Package: ChIPpeakAnno
Type: Package
Title: Batch annotation of the peaks identified from either ChIP-seq,
        ChIP-chip experiments, or any experiments that result in large
        number of genomic interval data
Version: 3.47.0
Encoding: UTF-8
Author: 
        Lihua Julie Zhu,
        Jianhong Ou, 
        Jun Yu, 
        Kai Hu, 
        Haibo Liu, 
        Junhui Li, 
        Hervé Pagès, 
        Claude Gazin,
        Nathan Lawson, 
        Ryan Thompson, 
        Simon Lin, 
        David Lapointe,
        Michael Green
Maintainer: Jianhong Ou <jou@morgridge.org>,
 Lihua Julie Zhu <julie.zhu@umassmed.edu>,
 Kai Hu <kai.hu@umassmed.edu>,
 Junhui Li <junhui.li@umassmed.edu>
Depends: R (>= 3.5), methods, IRanges (>= 2.13.12), GenomicRanges (>=
        1.31.8), S4Vectors (>= 0.17.25)
Imports: AnnotationDbi, BiocGenerics (>= 0.1.0), Biostrings (>=
        2.47.6), pwalign, DBI, dplyr, GenomeInfoDb, GenomicAlignments,
        GenomicFeatures, RBGL, Rsamtools, SummarizedExperiment,
        VennDiagram, biomaRt, ggplot2, grDevices, graph, graphics,
        grid, InteractionSet, KEGGREST, matrixStats, multtest,
        regioneR, rtracklayer, stats, utils, universalmotif, stringr,
        tibble, tidyr, data.table, scales, ensembldb
Suggests: AnnotationHub, BSgenome, limma, reactome.db, BiocManager,
        BiocStyle, BSgenome.Ecoli.NCBI.20080805,
        BSgenome.Hsapiens.UCSC.hg19, org.Ce.eg.db, org.Hs.eg.db,
        BSgenome.Celegans.UCSC.ce10, BSgenome.Drerio.UCSC.danRer7,
        BSgenome.Hsapiens.UCSC.hg38, DelayedArray, idr, seqinr,
        EnsDb.Hsapiens.v75, EnsDb.Hsapiens.v79, EnsDb.Hsapiens.v86,
        TxDb.Hsapiens.UCSC.hg18.knownGene,
        TxDb.Hsapiens.UCSC.hg19.knownGene,
        TxDb.Hsapiens.UCSC.hg38.knownGene, GO.db, gplots, UpSetR,
        knitr, rmarkdown, reshape2, testthat, trackViewer, motifStack,
        OrganismDbi, BiocFileCache
Description: 
        The package encompasses a range of functions for identifying the 
        closest gene, exon, miRNA, or custom features—such as highly conserved
        elements and user-supplied transcription factor binding sites. 
        Additionally, users can retrieve sequences around the peaks and obtain 
        enriched Gene Ontology (GO) or Pathway terms. In version 2.0.5 and beyond,
        new functionalities have been introduced. These include features for 
        identifying peaks associated with bi-directional promoters along with 
        summary statistics (peaksNearBDP), summarizing motif occurrences in 
        peaks (summarizePatternInPeaks), and associating additional identifiers 
        with annotated peaks or enrichedGO (addGeneIDs). The package integrates 
        with various other packages such as biomaRt, IRanges, Biostrings, BSgenome, 
        GO.db, multtest, and stat to enhance its analytical capabilities.
License: GPL (>= 2)
LazyLoad: yes
LazyData: true
LazyDataCompression: xz
biocViews: Annotation, ChIPSeq, ChIPchip
VignetteBuilder: knitr
RoxygenNote: 7.3.3
git_url: https://git.bioconductor.org/packages/ChIPpeakAnno
git_branch: devel
git_last_commit: 9964693
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:04:56 UTC; biocbuild

# ChIPpeakAnno

[![platforms](http://bioconductor.org/shields/availability/devel/ChIPpeakAnno.svg)](http://bioconductor.org/packages/devel/bioc/html/ChIPpeakAnno.html)
[![build](http://bioconductor.org/shields/build/devel/bioc/ChIPpeakAnno.svg)](http://bioconductor.org/packages/devel/bioc/html/ChIPpeakAnno.html)

Batch annotation and visualization of peaks from ChIP-seq, ATAC-seq, and NAD-seq experiments or any experiments resulted in large number of chromosome ranges

## Installation

To install this package, start R and enter:

```r
library(BiocManager)
BiocManager::install("ChIPpeakAnno")
```

## Documentation

To view documentation of ChIPpeakAnno, start R and enter:
```r
browseVignettes("ChIPpeakAnno")
```

#' plot distribution in given ranges
#' 
#' plot distribution in the given feature ranges
#' 
#' 
#' @param cvglists Output of \link{featureAlignedSignal} or a list of
#' \link[IRanges:AtomicList-class]{SimpleRleList} or
#' \link[IRanges:AtomicList-class]{RleList}
#' @param feature.gr An object of \link[GenomicRanges:GRanges-class]{GRanges}
#' with identical width.  If the width equal to 1, you can use upstream and
#' downstream to set the range for plot.  If the width not equal to 1, you can
#' use zeroAt to set the zero point of the heatmap.
#' @param upstream,downstream upstream or dwonstream from the feature.gr.
#' @param zeroAt zero point position of feature.gr
#' @param n.tile The number of tiles to generate for each element of
#' feature.gr, default is 100
#' @param ... any paramters could be used by \link[graphics]{matplot}
#' @return invisible matrix of the plot.
#' @author Jianhong Ou
#' @seealso See Also as \link{featureAlignedSignal},
#' \link{featureAlignedHeatmap}
#' @keywords misc
#' @export
#' @importFrom BiocGenerics start end width strand
#' @importFrom graphics matplot
#' @examples
#' 
#'   cvglists <- list(A=RleList(chr1=Rle(sample.int(5000, 100), 
#'                                       sample.int(300, 100))), 
#'                    B=RleList(chr1=Rle(sample.int(5000, 100), 
#'                                       sample.int(300, 100))))
#'   feature.gr <- GRanges("chr1", IRanges(seq(1, 4900, 100), width=100))
#'   featureAlignedDistribution(cvglists, feature.gr, zeroAt=50, type="l")
#' 
featureAlignedDistribution <- function(cvglists, feature.gr, 
                                       upstream, downstream, 
                                       n.tile=100, zeroAt, ...){
    stopifnot(is(feature.gr, "GRanges"))
    dots <- list(...)
    
    grWidr <- unique(width(feature.gr))
    if(missing(upstream) || missing(downstream)){
        if(length(grWidr)!=1){
            stop("The width of feature.gr is not identical.")
        }
        if(missing(zeroAt)) {
            zeroAt <- 0.5
            message("zero is set as the center of the feature.gr")
        }
    }else{
        if(!is.numeric(upstream) || !is.numeric(downstream)){
            stop("upstream and downstream must be integers")
        }
        if(upstream<0 || downstream<0){
            stop("upstream and downstream must be not less than 0")
        }
        upstream <- as.integer(upstream)
        downstream <- as.integer(downstream)
        if(length(grWidr)!=1 || any(grWidr!=1)){
            start(feature.gr) <- start(feature.gr)+floor(width(feature.gr)/2)
            width(feature.gr) <- 1
            warning("feature.gr is set to the center of feature.gr")
        }
        if(!missing(zeroAt)){
            warning("zeroAt will be ignored.")
        }
        zeroAt <- upstream/(upstream + downstream)
        end(feature.gr) <- start(feature.gr) + downstream
        start(feature.gr) <- start(feature.gr) - upstream
        grWidr <- unique(width(feature.gr))
    }
    stopifnot(is.numeric(zeroAt))
    stopifnot(zeroAt>=0)
    if(zeroAt<=1){
        zero <- round(grWidr*zeroAt)
    }else{
        zero <- round(zeroAt)
    }
    
    grWid <- c(0, grWidr) - zero
    grWidLab <- grid.pretty(grWid)
    grWidAt <- (grWidLab+zero)/grWidr*n.tile
    if(inherits(cvglists, c("SimpleRleList", "RleList", "CompressedRleList"))){
        cvglistsName <- substitute(deparse(cvglists))
        cvglists <- list(cvglists)
        names(cvglists) <- cvglistsName
    }
    if(!is(cvglists, "list")){
        stop("cvglists must be output of featureAlignedSignal or 
             a list of SimpleRleList or RleList")
    }
    
    cls <- sapply(cvglists, is, class2="matrix")
    if(all(cls)){
      cov <- cvglists
      if(ncol(cov[[1]])!=n.tile){
        stop("n.tile must keep same as featureAligendSignal.")
      }
    }else{
      cls <- sapply(cvglists, inherits, 
                    what = c("SimpleRleList", "RleList", "CompressedRleList"))
      if(any(!cls))
        stop("cvglists must be a list of SimpleRleList or RleList")
      cov <- featureAlignedSignal(cvglists, feature.gr, n.tile=n.tile)
    }
    
    ## normalized read density
    if(any(sapply(cov, function(.ele) any(is.na(.ele))))){
        warning("cvglists contain NA values. ", 
                "NA value will be omit.")
    }
    density <- sapply(cov, colMeans, na.rm=TRUE)
    try({
        matplot(density, ..., xaxt="n")
        axis(1, at = grWidAt, labels = grWidLab)
        lty <- if(!is.null(dots$lty)) dots$lty else 1:5
        lwd <- if(!is.null(dots$lwd)) dots$lwd else 1
        col <- if(!is.null(dots$col)) dots$col else 1:6
        legend("topright", legend=colnames(density), col=col,
               lty=lty, lwd=lwd)
    })
    
    return(invisible(density))
}

test_that("featureAligend works not correct", {
    ##featureAlignedSignal
    cvglists <- list(A=RleList(chr1=Rle(rep(c(1:5, 5:1), 100))), 
                     B=RleList(chr1=Rle(rep(c(5:1, 1:5), 100))))
    feature.gr <- GRanges("chr1", IRanges(seq(15, 985, length.out=98), width=1))
    #feature.gr.shift <- shift(feature.gr, shift = -5)
    sig <- featureAlignedSignal(cvglists, feature.gr, 
                         upstream=5, downstream=5, 
                         n.tile=11)
    sig.unique <- lapply(sig, unique)
    expect_true(all(sapply(sig.unique, nrow)==1))
    expect_equal(unname(sig.unique[["A"]][,1]), 1)
    expect_equal(unname(sig.unique[["B"]][,6]), 1)
    f1 <- featureAlignedDistribution(sig, feature.gr, 
                               upstream=5, downstream=5, 
                               n.tile=11, type="l")
    f2 <- featureAlignedDistribution(cvglists, feature.gr,
                                     upstream=5, downstream=5, 
                                     n.tile=11, type="l")
    expect_identical(f1, f2)
    h1 <- featureAlignedHeatmap(sig, feature.gr,
                          upstream=5, downstream=5, 
                          n.tile=11, type="l")
    h2 <- featureAlignedHeatmap(cvglists, feature.gr,
                                upstream=5, downstream=5, 
                                n.tile=11, type="l")
    expect_identical(h1, h2)
    
    cvglists <- list(A=RleList(chr1=Rle(rep(c(0, 0, 3, 0, 0), 20))), 
                     B=RleList(chr1=Rle(rep(c(1:5, 5:1), 10))))
    feature.gr <- GRanges("chr1", IRanges(seq(15, 85, length.out=8), width=1))
    sig <- featureAlignedSignal(cvglists, feature.gr, 
                                upstream=4, downstream=5, 
                                n.tile=10)
    f<- featureAlignedDistribution(cvglists, feature.gr,
                               upstream=4, downstream=5, 
                               n.tile=10, type="l")
    expect_equal(f[, "A"], c(0, 0, 3, 0, 0, 0, 0, 3, 0, 0))
    expect_equal(f[, "B"], c(1:5, 5:1))
})

#' plot enrichment results
#' 
#' Plot the GO/KEGG/reactome enrichment results
#' 
#' @param res output of \link{getEnrichedGO}, \link{getEnrichedPATH}.
#' @param n number of terms to be plot.
#' @param style plot vertically or horizontally
#' @param strlength shorten the description of term by the number of char.
#' @param orderBy order the data by pvalue, termId or none.
#' @param label_wrap soft wrap the labels (i.e. descriptions of the GO or PATHWAY terms), default to 40 characters.
#' @param label_substring_to_remove remove common substring from label, 
#' default to NULL. Special characters must be escaped. E.g. if you would like 
#' to remove "Homo sapiens (human)" from labels, you must use "Homo sapiens \\\(
#' human\\\)".
#' @author Jianhong Ou, Kai Hu
#' @return an object of ggplot
#' @importFrom ggplot2 ggplot aes geom_bar geom_point scale_x_discrete scale_y_continuous geom_text
#' xlab ylab theme_classic theme facet_grid expansion element_text
#' @importFrom stats as.formula reorder
#' @importFrom scales label_wrap
#' @export
#' @examples 
#' data(enrichedGO)
#' enrichmentPlot(enrichedGO)
#' if (interactive()||Sys.getenv("USER")=="jou") {
#'      
#'      library(org.Hs.eg.db)
#'      library(GO.db)
#'      bed <- system.file("extdata", "MACS_output.bed", package="ChIPpeakAnno")
#'      gr1 <- toGRanges(bed, format="BED", header=FALSE) 
#'      gff <- system.file("extdata", "GFF_peaks.gff", package="ChIPpeakAnno")
#'      gr2 <- toGRanges(gff, format="GFF", header=FALSE, skip=3)
#'      library(EnsDb.Hsapiens.v75) ##(hg19)
#'      annoData <- toGRanges(EnsDb.Hsapiens.v75)
#'      gr1.anno <- annoPeaks(gr1, annoData)
#'      gr2.anno <- annoPeaks(gr2, annoData)
#'      over <- lapply(GRangesList(gr1=gr1.anno, gr2=gr2.anno), 
#'                     getEnrichedGO, orgAnn="org.Hs.eg.db",
#'                     maxP=.05, minGOterm=10, condense=TRUE)
#'      enrichmentPlot(over$gr1)
#'      enrichmentPlot(over$gr2, style = "h")
#'  }
enrichmentPlot <- function(res, n=20, strlength=Inf,
                           style = c("v", "h"),
                           label_wrap = 40,
                           label_substring_to_remove = NULL,
                           orderBy=c("pvalue", "termId", "none")){
  if(is.data.frame(res)){## output of getEnrichedPATH
    res <- list(path=res)
  }
  stopifnot("n must be a numeric(1)"=is.numeric(n) && length(n)==1)
  orderBy <- match.arg(orderBy)
  style <- match.arg(style)
  stopifnot(is.integer(as.integer(label_wrap)))
  if(is.list(res[[1]])&&is.data.frame(res[[1]][[1]])){
    ## list of list, output of getEnrichedGO for multiple samples
    ## dot plot
    res <- swapList(res)
    res <- lapply(res, function(.ele){
      ## unlist and add source
      .e <- do.call(rbind, .ele)
      .e$source <- rep(names(.ele), vapply(.ele, nrow, FUN.VALUE = 0))
      .e
    })
  }
  p <- lapply(res, function(.ele){
    cn <- colnames(.ele)
    cn.id <- cn[grepl("\\.id$", cn)]
    cn.term <- cn[grepl("\\.term$", cn)]
    if(length(.ele$source)!=nrow(.ele)){
      .ele$source <- "undefined"
    }
    if(nrow(.ele)==0) return(data.frame())
    if(!all(c(cn.id, cn.term, "pvalue", "count.InDataset", 
             "count.InGenome", "source") %in% colnames(.ele))){
      return(data.frame())
    }
    plotdata <- .ele[!is.na(.ele$pvalue), 
                     c(cn.id, cn.term, "pvalue", "count.InDataset", 
                       "count.InGenome", "source")]
    plotdata <- as.data.frame(plotdata)
    plotdata <- unique(plotdata)
    plotdata$qvalue <- -1*log10(plotdata$pvalue)
    plotdata <- switch(orderBy,
                       "pvalue"=plotdata[order(plotdata$pvalue), ],
                       "termId"=plotdata[order(plotdata[, cn.term]), ],
                       plotdata)
    if(nrow(plotdata)>n) plotdata <- plotdata[seq.int(n), ]
    plotdata$Description <- shortStrs(plotdata[, cn.term], len=strlength)
    plotdata$Count <- plotdata$count.InDataset
    plotdata$GeneRatio <- plotdata$count.InDataset/plotdata$count.InGenome
    plotdata
  })
  plotdata <- do.call(rbind, p)
  plotdata$category <- rep(names(res), vapply(p, nrow, FUN.VALUE = 0))
  plotdata$Description <- removeLabelSubstring(plotdata, label_substring_to_remove)

  if(nrow(plotdata)<2){
    warning("two less data to plot")
    return(plotdata)
  }

  if(all(plotdata$source=="undefined")){
    if (style == "v") {
      p <- ggplot(plotdata, 
                  aes(x = switch(orderBy,
                                 "pvalue" = reorder(Description, pvalue),
                                 "termId" = reorder(Description, plotdata[, 2]),
                                 "Description"),
                      y = qvalue, fill = Count, label = Count))
    } else if (style == "h") {
      p <- ggplot(plotdata, 
                  aes(x = switch(orderBy,
                                 "pvalue" = reorder(Description, pvalue, decreasing = TRUE),
                                 "termId" = reorder(Description, plotdata[, 2]),
                                 "Description"),
                      y = qvalue, fill = Count, label = Count))
    }
    p <- p +
      geom_bar(stat="identity") +
      scale_x_discrete(label = label_wrap(as.integer(label_wrap))) +
      scale_y_continuous(expand = expansion(mult = c(0, .1))) +
      xlab("") + ylab("-log10(p-value)") +
      theme_classic() + 
      theme(axis.text.x = element_text(angle = 90, hjust = 1, vjust = .5)) + 
      facet_grid(~ category, scales = "free_x", space = "free_x")
    
    if (style == "v") {
      p <- p + 
            geom_text(vjust=-.1)
    } else if (style == "h") {
      p <- p + 
            geom_text(hjust=-.1) + 
            coord_flip()
    }
    p
  }else{
    ## multiple samples dot plot
    if (style == "v") {
      p <- ggplot(plotdata,
                  aes(y = switch(orderBy, 
                                 "pvalue" = reorder(Description, pvalue),
                                 "termId" = reorder(Description, plotdata[, 2]),
                                 Description),
                      x = source, color = qvalue, size = GeneRatio))
    } else if (style == "h") {
      p <- ggplot(plotdata, 
                  aes(y = switch(orderBy,
                                 "pvalue" = reorder(Description, pvalue, decreasing = TRUE),
                                 "termId" = reorder(Description, plotdata[, 2]),
                                 Description),
                      x = source, color = qvalue, size = GeneRatio))
    }
    p <- p +
      geom_point() + theme_classic() +
      facet_grid(~ category, scales = "free_x", space = "free_x")
  
    if (style == "v") {
      p
    } else if (style == "h") {
      p <- p + coord_flip()
      p
    }
  }
}

removeLabelSubstring <- function(plotdata, label_substring_to_remove = NULL) {
  if (!is.null(label_substring_to_remove)) {
    gsub(label_substring_to_remove, "", plotdata$Description)
  } else {
    plotdata$Description
  }
}

shortStrs <- function(strs, len=60){
  if(length(strs)==0) return(strs)
  strs <- as.character(strs)
  shortStr <- function(str, len=60){
    stopifnot(length(str)==1)
    stopifnot(is.character(str))
    if(nchar(str)<=len) return(str)
    strs <- strsplit(str, " ")[[1]]
    nc <- nchar(strs)
    nclast <- nc[length(nc)] + 3
    paste0(substring(str, first = 1, last = len-nclast), "...",
           strs[length(strs)])
  }
  strs <- sapply(strs, shortStr, len=len)
  make.unique(strs)
}

test_that("enrichmentPlot works not correct", {
    data(enrichedGO)
    ## test enrichmentPlot can handle empty elements.
    enrichedGO$cc <- enrichedGO$cc[enrichedGO$cc$go.id=="A", ]
    enrichmentPlot(enrichedGO)
})

#' Add common IDs to annotated peaks such as gene symbol, entrez ID, 
#' ensemble gene id and refseq id.
#' @description Add common IDs to annotated peaks such as gene symbol, 
#' entrez ID, ensemble gene id and refseq id leveraging organism annotation 
#' dataset. For example, org.Hs.eg.db is the dataset from orgs.Hs.eg.db 
#' package for human, while org.Mm.eg.db is the dataset from the org.Mm.eg.db
#' package for mouse.
#' @param annotatedPeak GRanges or a vector of feature IDs.
#' @param orgAnn organism annotation dataset such as org.Hs.eg.db.
#' @param IDs2Add a vector of annotation identifiers to be added
#' @param feature_id_type type of ID to be annotated, default is 
#' ensembl_gene_id
#' @param silence TRUE or FALSE. If TRUE, will not show unmapped entrez id
#' for feature ids.
#' @param mart mart object, see \link[biomaRt:useMart]{useMart} of biomaRt
#' package for details
#' @details One of orgAnn and mart should be assigned. 
#' \itemize{    
#'   \item If orgAnn is given, parameter feature_id_type should be 
#'   ensemble_gene_id, entrez_id, gene_symbol, gene_alias or refseq_id.
#'   And parameter IDs2Add can be set to any combination of identifiers 
#'   such as "accnum", "ensembl", "ensemblprot", "ensembltrans", "entrez_id",
#'   "enzyme", "genename", "pfam", "pmid", "prosite", "refseq", "symbol", 
#'   "unigene" and "uniprot". Some IDs are unique to an organism, 
#'   such as "omim" for org.Hs.eg.db and "mgi" for org.Mm.eg.db.
#'   
#'   Here is the definition of different IDs : 
#'     \itemize{
#'       \item accnum: GenBank accession numbers
#'       \item ensembl: Ensembl gene accession numbers
#'       \item ensemblprot: Ensembl protein accession numbers
#'       \item ensembltrans: Ensembl transcript accession numbers
#'       \item entrez_id: entrez gene identifiers
#'       \item enzyme: EC numbers
#'       \item genename: gene name
#'       \item pfam: Pfam identifiers
#'       \item pmid: PubMed identifiers
#'       \item prosite: PROSITE identifiers
#'       \item refseq: RefSeq identifiers
#'       \item symbol: gene abbreviations
#'       \item unigene: UniGene cluster identifiers
#'       \item uniprot: Uniprot accession numbers
#'       \item omim: OMIM(Mendelian Inheritance in Man) identifiers
#'       \item mgi: Jackson Laboratory MGI gene accession numbers
#'     }
#'   
#'   \item If mart is used instead of orgAnn, for valid parameter 
#'   feature_id_type and IDs2Add parameters, please refer to 
#'   \link[biomaRt:getBM]{getBM} in bioMart package. 
#'   Parameter feature_id_type should be one valid filter name listed by 
#'   \link[biomaRt:listFilters]{listFilters(mart)} such as ensemble_gene_id.
#'   And parameter IDs2Add should be one or more valid attributes name listed 
#'   by \link[biomaRt:listAttributes]{listAttributes(mart)} such as 
#'   external_gene_id, entrezgene, wikigene_name, or mirbase_transcript_name.
#'   
#' }
#' @return GRanges if the input is a GRanges or dataframe if input is a vector.
#' @references http://www.bioconductor.org/packages/release/data/annotation/
#' @author Jianhong Ou, Lihua Julie Zhu
#' @seealso \link[biomaRt:getBM]{getBM}, AnnotationDb
#' @export
#' @importFrom AnnotationDbi mget keytypes select
#' @importFrom biomaRt getBM
#' @importFrom utils installed.packages
#' @examples
#' data(annotatedPeak)
#' library(org.Hs.eg.db)
#' addGeneIDs(annotatedPeak[1:6,],orgAnn="org.Hs.eg.db",
#'            IDs2Add=c("symbol","omim"))
#' ##addGeneIDs(annotatedPeak$feature[1:6],orgAnn="org.Hs.eg.db",
#' ##           IDs2Add=c("symbol","genename"))
#' if(interactive()){
#'   mart <- useMart("ENSEMBL_MART_ENSEMBL",host="www.ensembl.org",
#'                   dataset="hsapiens_gene_ensembl")
#'   ##mart <- useMart(biomart="ensembl",dataset="hsapiens_gene_ensembl")
#'   addGeneIDs(annotatedPeak[1:6,], mart=mart,
#'              IDs2Add=c("hgnc_symbol","entrezgene"))
#' }
#' @keywords misc

addGeneIDs<-function(annotatedPeak, orgAnn, IDs2Add=c("symbol"), 
                     feature_id_type="ensembl_gene_id",
                     silence=TRUE, 
                     mart){
    if (missing(annotatedPeak))
    {
        stop("Missing required argument annotatedPeak!",
             call.=FALSE)
    }
    if(missing(orgAnn) & missing(mart)){
        stop('no annotation database selected',
             call.=FALSE)
    }
    
    if(is(annotatedPeak, "GRanges")){
      feature_ids <- unique(annotatedPeak$feature)
    }else{
      if(is.character(annotatedPeak)){
        feature_ids <- unique(annotatedPeak)
      }else{
        stop("annotatedPeak needs to be GRanges type with 
                                 feature variable holding the feature id or a 
             character vector holding the IDs of the features 
             used to annotate the peaks!",call.=FALSE)
      }
    }
  
    feature_ids <- feature_ids[!is.na(feature_ids)]
    feature_ids <- feature_ids[feature_ids!=""]
    if (length(feature_ids) == 0)
    {
        stop("There is no feature column in annotatedPeak or 
             annotatedPeak has size 0!",call.=FALSE)
        
    }
    if(!missing(orgAnn)){
      if(is(orgAnn, 'EnsDb')){
        keytype <- switch(feature_id_type,
                          ensembl_gene_id       = "GENEID",
                          ensembl_transcript_id = "TXID",
                          ensembl_exon_id  = "EXONID",
                          gene_id = "GENEID",
                          tx_id = "TXID",
                          exon_id = "EXONID",
                          "UNKNOWN"
        )
        if(keytype=="UNKNOWN"){
          if(feature_id_type %in% keytypes(orgAnn)){
            keytype <- feature_id_type
          }else{
            stop("Currently only the following type of feature_id_type are supported: 
               ensembl_gene_id, ensembl_transcript_id, ensembl_exon_id,
               gene_id, tx_id, exon_id,
               and keytypes(orgAnn)!",
                 call.=FALSE)
          }
        }
        m_ent <- ensembldb::select(orgAnn, keys=feature_ids,
                        columns = IDs2Add, keytype = keytype)
        colnames(m_ent) <- c(feature_id_type, IDs2Add)
      }else{
        if(is(orgAnn, 'TxDb')){
          keytype <- switch(feature_id_type,
                            ensembl_gene_id       = "GENEID",
                            ensembl_transcript_id = "TXNAME",
                            ensembl_exon_id  = "EXONNAME",
                            gene_id = "GENEID",
                            tx_id = "TXID",
                            exon_id = "EXONID",
                            "UNKNOWN"
          )
          if(keytype=="UNKNOWN"){
            if(feature_id_type %in% keytypes(orgAnn)){
              keytype <- feature_id_type
            }else{
              stop("Currently only the following type of feature_id_type are supported: 
               ensembl_gene_id, ensembl_transcript_id, ensembl_exon_id,
               gene_id, tx_id, exon_id,
               and keytypes(orgAnn)!",
                   call.=FALSE)
            }
          }
          m_ent <- AnnotationDbi::select(orgAnn, keys=feature_ids,
                        columns = IDs2Add, keytype = keytype)
          colnames(m_ent) <- c(feature_id_type, IDs2Add)
        }else{
        if(is(orgAnn, "OrgDb")){
            orgAnn <- deparse(substitute(orgAnn))
        }
        if(!is(orgAnn, "character")){
            stop("orgAnn must be a character.")
        }
        if(!grepl(".eg.db",orgAnn,ignore.case=TRUE)){
            stop('Annotation database must be *.eg.db',call.=FALSE)
        }
        is.installed <- function(orgpkg) 
            is.element(orgpkg, installed.packages()[,1])
        if(!is.installed(orgAnn)){
            BiocManager::install(pkgs=orgAnn, 
                     update=FALSE, 
                     ask=FALSE)
        }
        if(!library(orgAnn, 
                    character.only=TRUE, 
                    logical.return=TRUE)){
            if(!silence) 
                message("No valid gene mapping package as 
                        argument orgAnn is passed in!")
            stop("Please refer 
                 http://www.bioconductor.org/packages/release/data/annotation/ 
                 for available org.xx.eg.db packages")
        }
        #	require(orgAnn,character.only = TRUE)
        orgAnn<-sub("\\.db$","",orgAnn,ignore.case=TRUE)
        #get Entrez ID::entrezIDs
        if(feature_id_type=="entrez_id"){
            m_ent<-as.data.frame(feature_ids, stringsAsFactors=FALSE)
            colnames(m_ent)<-c("entrez_id")
        }else{
            prefix<-switch(feature_id_type,
                           gene_alias       = "ALIAS",
                           gene_symbol      = "SYMBOL",
                           ensembl_gene_id  = "ENSEMBL",
                           refseq_id        = "REFSEQ",
                           "UNKNOWN"
            )
            if(prefix=="UNKNOWN"){
                stop("Currently only the following type of IDs are supported: 
entrez_id, gene_alias, ensembl_gene_id, refseq_id and gene_symbol!",
                     call.=FALSE)
            }
            tryCatch(env<-get(paste(orgAnn,prefix,"2EG",sep="")),
                     error = function(e){
                         stop(paste("Annotation database ",
                                    orgAnn,
                                    "2EG does not exist!\n
                                    \tPlease try to load annotation 
                                    database by library(",
                                    orgAnn,".db)",sep=""),call.=FALSE)
            })
            entrez <- AnnotationDbi::mget(feature_ids,env,ifnotfound=NA)
            gene_ids <- names(entrez)
            m_ent <- do.call(rbind,lapply(gene_ids,function(.ele){
                r = entrez[[.ele]]
                if(!is.na(r[1])) cbind(rep(.ele,length(r)),r)
                else {
                    if(!silence) message(paste("entrez id for '", 
                                               .ele, "' not found\n", 
                                               sep = ""))
                    c(.ele, NA)
                }
            }))
            m_ent<-as.data.frame(m_ent, stringsAsFactors=FALSE)
            m_ent<-m_ent[!is.na(m_ent[,1]), , drop=FALSE]
            colnames(m_ent)<-c(feature_id_type, "entrez_id")
            }
        entrezIDs<-as.character(m_ent$entrez_id)
        entrezIDs<-unique(entrezIDs)
        entrezIDs<-entrezIDs[!is.na(entrezIDs)]
        if(length(entrezIDs)==0){
            stop("No entrez identifier can be mapped by input data based on 
                 the feature_id_type.\nPlease consider to use correct 
                 feature_id_type, orgAnn or annotatedPeak\n",
                 call.=FALSE);
        }
        IDs2Add <- unique(IDs2Add)
        IDs2Add <- IDs2Add[IDs2Add!=feature_id_type]
        IDs <- unique(entrezIDs[!is.na(entrezIDs)])
        for(IDtoAdd in IDs2Add){
            x<-NULL
            if(!silence) message(paste("Adding",IDtoAdd,"... "))
            if(IDtoAdd!="entrez_id"){
                orgDB<-NULL
                tryCatch(orgDB<-get(paste(orgAnn,toupper(IDtoAdd),sep="")),
                         error = function(e){
                             if(!silence){
                                 message(paste("The IDs2Add you input, \"", 
                                               IDtoAdd, 
                                               "\", is not supported!\n",
                                               sep=""))
                    }
                })
                if(is.null(orgDB)){
                    IDs2Add<-IDs2Add[IDs2Add!=IDtoAdd]
                    next
                }
                if(!is(orgDB, "AnnDbBimap") & !is(orgDB, "IpiAnnDbMap")){
                    if(!silence){
                        message(paste("The IDs2Add you input, \"", 
                                      IDtoAdd, 
                                      "\", is not supported!\n",
                                      sep=""))
                    }
                    IDs2Add<-IDs2Add[IDs2Add!=IDtoAdd]
                    next
                }
                x <- AnnotationDbi::mget(IDs, orgDB,ifnotfound=NA)
                x <- sapply(x,base::paste,collapse=";")
                x <- as.data.frame(x, stringsAsFactors=FALSE)
                m_ent <- merge(m_ent, x, 
                               by.x="entrez_id",
                               by.y="row.names",
                               all.x=TRUE)
                colnames(m_ent)[length(colnames(m_ent))]<-IDtoAdd
            }
            if(!silence) message("done\n")
        }
        m_ent<-m_ent[, c(feature_id_type,IDs2Add), drop=FALSE]
        }
      }
}else{
    if(missing(mart) || !is(mart, "Mart")){
        stop('No valid mart object is passed in!',call.=FALSE)
    }
    IDs2Add<-unique(IDs2Add)
    IDs2Add<-IDs2Add[IDs2Add!=feature_id_type]
    if(all(grepl('\\.\\d+$', feature_ids)) && feature_id_type %in% c(
      'ensembl_gene_id', 'ensemble_exon_id', 'ensembl_transcript_id'
    )){
      feature_ids_new <- sub('\\.\\d+$', '', feature_ids)
      has_version_num <- TRUE
    }else{
      feature_ids_new <- feature_ids
      has_version_num <- FALSE
    }
    tryCatch(m_ent<-
                 getBM(attributes=c(feature_id_type,IDs2Add),
                       filters = feature_id_type, 
                       values = feature_ids_new,
                       mart=mart),
             error = function(e){
        stop(paste("Get error when calling getBM:", e, sep="\n"),
             call.=FALSE)
    })
    if(any(colnames(m_ent)!=c(feature_id_type, IDs2Add))) 
        colnames(m_ent) <- c(feature_id_type, IDs2Add)
    if(has_version_num){
      m_ent[, feature_id_type] <- feature_ids[match(m_ent[, feature_id_type], feature_ids_new)]
    }
}
if(!silence) message("prepare output ... ")
#dealing with multiple entrez_id for single feature_id
if(ncol(m_ent)==1) stop("None of IDs could be appended. Please double check IDs2Add.")
duplicated_ids <-
    m_ent[duplicated(m_ent[,feature_id_type]), feature_id_type]
if(length(duplicated_ids)>0){
    m_ent.duplicated <- m_ent[m_ent[,feature_id_type] %in% duplicated_ids,]
    m_ent.duplicated <- condenseMatrixByColnames(as.matrix(m_ent.duplicated),
                                                 feature_id_type)
    m_ent<-m_ent[!(m_ent[,feature_id_type] %in% duplicated_ids),]
    m_ent<-rbind(m_ent,m_ent.duplicated)
}
if (is(annotatedPeak, "GRanges")){
    #rearrange m_ent by annotatedPeak$feature
    #data.frame is very important for order...
    orderlist <- data.frame(annotatedPeak$feature)
    orderlist <- cbind(1:nrow(orderlist),orderlist)
    colnames(orderlist) <- c("orderid___",feature_id_type)
    m_ent <- merge(orderlist, m_ent, by=feature_id_type, all.x=TRUE)
    m_ent <- m_ent[order(m_ent[,"orderid___"]), 
                   c(feature_id_type, IDs2Add)]
    for(IDtoAdd in IDs2Add){
        mcols(annotatedPeak)[,IDtoAdd] <- m_ent[,IDtoAdd]
    }
}else{
    annotatedPeak <- m_ent
}
if(!silence) message("done\n")
annotatedPeak
}

test_that("addGeneIDs works not correct", {
    data(annotatedPeak)
    x<-addGeneIDs(annotatedPeak[1:6],"org.Hs.eg.db",c("symbol","omim"))
    expect_is(x$symbol, "character")
    expect_is(x$omim, "character")
    expect_equal(x$feature[1:4], c("ENSG00000202254", "ENSG00000186086",
                              "ENSG00000065135", "ENSG00000197106"))
    expect_equal(unname(x$symbol[1:4]), c(NA, "NBPF6", "GNAI3", "SLC6A17"))
    x <- addGeneIDs(c("ENSG00000065135", "ENSG00000116396", 
                      "ENSG00000197106", "ENSG00000186086", 
                      "ENSG00000202254"), org.Hs.eg.db, c("symbol"))
    expect_equal(unname(x$symbol[match(c("ENSG00000065135", "ENSG00000116396", 
                                  "ENSG00000197106", "ENSG00000186086", 
                                  "ENSG00000202254"), x$ensembl_gene_id)]), 
                 c('GNAI3', 'KCNC4', 'SLC6A17', 'NBPF6', NA))
    expect_error(addGeneIDs("ENSG00000065135", orgAnn="generate.error"))
})

test_that("getEnrichedPath works not correct", {
  data(annotatedPeak)
  
  enriched.PATH <- getEnrichedPATH(annotatedPeak[1:500],
                                   orgAnn="org.Hs.eg.db", 
                                   feature_id_type="ensembl_gene_id",
                                   pathAnn="reactome.db", maxP=0.01,
                                   minPATHterm=10,
                                   multiAdjMethod=NULL)
  ann <- addGeneIDs(enriched.PATH[,2],
                    feature_id_type = "entrez_id",
                    orgAnn = org.Hs.eg.db,
                    IDs2Add = "symbol")
  enriched.PATH <- merge(ann, enriched.PATH)
  expect_true(nrow(enriched.PATH)>0)
})

#' Class \code{"bindist"}
#' 
#' An object of class \code{"bindist"} represents the relevant fixed-width
#' range of binding site from the feature and number of possible binding site
#' in each range.
#' 
#' 
#' @name bindist-class
#' @rdname bindist
#' @aliases bindist bindist-class bindist-method $,bindist-method
#' $<-,bindist-method
#' @docType class
#' @section Objects from the Class: Objects can be created by calls of the form
#' \code{new("bindist", counts="integer", mids="integer",
#' halfBinSize="integer", bindingType="character", featureType="character")}.
#' @seealso \link{preparePool}, \link{peakPermTest}
#' @exportClass bindist
#' @exportMethod "$" "$<-"
#' @keywords classes

setClass("bindist", representation(counts="integer",
                            mids="integer",
                            halfBinSize="integer",
                            bindingType="character",
                            featureType="character"),
         validity=function(object){
             re <- TRUE
             if(is.null(object@counts)) re <- "counts is empty"
             if(is.null(object@mids)) re <- "mids is empty"
             if(is.null(object@halfBinSize)) re <- "halfBinSize is empty"
             if(length(object@halfBinSize)>1) re <- "length of halfBinSize must be 1"
             if(length(object@counts)!=length(object@mids)) 
                 re <- "the length of mids and counts are not identical"
             if(!object@bindingType %in% c("TSS", "geneEnd"))
                 re <- "the bindingType must be TSS or geneEnd"
             if(!object@featureType %in% c("transcript", "exon"))
                 re <- "the featureType must be transcript or exon"
             re
         })

setMethod("$", "bindist", function(x, name) slot(x, name))
setReplaceMethod("$", "bindist",
                 function(x, name, value){
                     slot(x, name, check = TRUE) <- value
                     x
                 })

#' obtain the peaks near bi-directional promoters
#' 
#' Obtain the peaks near bi-directional promoters. Also output percent of peaks
#' near bi-directional promoters.
#' 
#' 
#' @param peaks peak list, \link[GenomicRanges:GRanges-class]{GRanges} object
#' @param annoData annotation data, \link{annoGR} object
#' @param maxgap maxgap between peak and TSS
#' @param ...  Not used.
#' @return Output is a list of GRanges object of the peaks near bi-directional
#' promoters.
#' @author Jianhong Ou
#' @seealso See Also as \code{\link{annoPeaks}}, \code{\link{annoGR}}
#' @keywords misc
#' @importFrom GenomeInfoDb seqlevelsStyle
#' @importFrom S4Vectors elementNROWS
#' @examples
#' 
#'   if(interactive() || Sys.getenv("USER")=="jou"){
#'     library(ensembldb)
#'     library(EnsDb.Hsapiens.v75)
#'     data("myPeakList")
#'     annoGR <- annoGR(EnsDb.Hsapiens.v75)
#'     seqlevelsStyle(myPeakList) <- seqlevelsStyle(annoGR)
#'     ChIPpeakAnno:::bdp(myPeakList, annoGR)
#'   }
#' 
bdp <- function(peaks, annoData, maxgap=2000L, ...){
    stopifnot(inherits(peaks, "GRanges"))
    stopifnot(inherits(annoData, c("annoGR", "GRanges")))
    stopifnot(length(intersect(seqlevelsStyle(peaks),seqlevelsStyle(annoData)))>0)
    stopifnot(is.numeric(maxgap))
    maxgap <- round(maxgap[1])
    peaks <- unique(peaks)
    peaks$bdp_idx <- 1:length(peaks)
    anno <- annoPeaks(peaks, annoData, 
                      bindingType = "nearestBiDirectionalPromoters",
                      bindingRegion = c(-1*maxgap, maxgap))
    if(length(anno)<1){
        return(NA)
    }
    anno.s <- split(anno, anno$bdp_idx)
    len <- elementNROWS(anno.s)
    anno.s <- anno.s[len>=2]
    len <- sapply(anno.s, function(.ele){
        std <- .ele$feature.strand
        all(c("+", "-") %in% as.character(.ele$feature.strand))
    })
    anno.s <- anno.s[len]
    anno.s
}

test_that("bdp works not correct", {
    ##GRanges
    ## myPeak
    ## 1 2 3 4 5 6 7 8 9 10
    ##   a a a a a b b   c
    ## A A B         D D    +
    ##     F F F   C C      -
    ##   E E E E E          +
    ## G G G G G            +
    ##     H H H H H        +
    ## I I I I I I I        -
    
    myPeak = GRanges("1", 
                     IRanges(start=c(2, 7, 10), 
                             end=c(6, 8, 10), 
                             names=letters[1:3]), 
                     strand="*")
    feature = GRanges("1", 
                      IRanges(start=c(1,3, 6, 8, 2, 3, 1, 3, 1), 
                              end=c(2, 3, 7, 9, 6, 5, 5, 7, 7), 
                              names=LETTERS[1:9]), 
                      strand=c("+","+", "-", "+", "+", "-", "+", "+", "-"))
    annotatedBDP <- bdp(myPeak, annoData=feature,
                       maxgap=2)
    expect_equal(length(annotatedBDP), 2)
    ##0 bdp
    strand(feature) <- "+"
    suppressWarnings(annotatedBDP <- 
                         bdp(myPeak, annoData=feature, maxgap=2))
    expect_equal(length(annotatedBDP), 0)
})

#' transcription factor binding site clusters (V3) from ENCODE
#' 
#' possible binding pool for human (hg19) from transcription factor binding
#' site clusters (V3) from ENCODE data and removed the HOT spots
#' 
#' How to generate the data:
#' 
#' temp <- tempfile()
#' 
#' download.file(file.path("http://hgdownload.cse.ucsc.edu", "goldenPath",
#' 
#' "hg19", "encodeDCC",
#' 
#' "wgEncodeRegTfbsClustered",
#' 
#' "wgEncodeRegTfbsClusteredV3.bed.gz"), temp)
#' 
#' data <- read.delim(gzfile(temp, "r"), header=FALSE)
#' 
#' unlink(temp)
#' 
#' colnames(data)[1:4] <- c("seqnames", "start", "end", "TF")
#' 
#' wgEncodeRegTfbsClusteredV3 <- GRanges(as.character(data$seqnames),
#' 
#' IRanges(data$start, data$end),
#' 
#' TF=data$TF)
#' 
#' data(HOT.spots)
#' 
#' hot <- reduce(unlist(HOT.spots))
#' 
#' ol <- findOverlaps(wgEncodeRegTfbsClusteredV3, hot)
#' 
#' wgEncodeTfbsV3 <- wgEncodeRegTfbsClusteredV3[-unique(queryHits(ol))]
#' 
#' wgEncodeTfbsV3 <- reduce(wgEncodeTfbsV3)
#' 
#' save(list="wgEncodeTfbsV3",
#' 
#' file="data/wgEncodeTfbsV3.rda",
#' 
#' compress="xz", compression_level=9)
#' 
#' @name wgEncodeTfbsV3
#' @docType data
#' @format An object of GRanges.
#' @source http://hgdownload.cse.ucsc.edu/goldenPath/hg19/encodeDCC/
#' wgEncodeRegTfbsClustered/wgEncodeRegTfbsClusteredV3.bed.gz
#' @keywords datasets
#' @examples
#' 
#' data(wgEncodeTfbsV3)
#' head(wgEncodeTfbsV3)
#' 
"wgEncodeTfbsV3"

#' translate pattern from IUPAC Extended Genetic Alphabet to regular expression
#' 
#' translate pattern containing the IUPAC nucleotide ambiguity codes to regular
#' expression.  For example,Y->[C|T], R-> [A|G], S-> [G|C], W-> [A|T], K->
#' [T|U|G], M-> [A|C], B-> [C|G|T], D-> [A|G|T], H-> [A|C|T], V-> [A|C|G] and
#' N-> [A|C|T|G].
#' 
#' 
#' @param pattern a character vector with the IUPAC nucleotide ambiguity codes
#' @return a character vector with the pattern represented as regular
#' expression
#' @author Lihua Julie Zhu
#' @seealso countPatternInSeqs, summarizePatternInPeaks
#' @keywords misc
#' @export
#' @examples
#' 
#'     pattern1 = "AACCNWMK"
#'     translatePattern(pattern1)
#' 
translatePattern <- function(pattern)
{
    pattern = toupper(pattern)
    pattern = gsub("Y","[C|T]", pattern)
    pattern = gsub("R", "[A|G]", pattern)
    pattern = gsub("S", "[G|C]", pattern)
    pattern = gsub("W", "[A|T]", pattern)
    pattern = gsub("K", "[T|U|G]", pattern)
    pattern = gsub("M", "[A|C]", pattern)
    pattern = gsub("B", "[C|G|T]", pattern)
    pattern = gsub("D", "[A|G|T]", pattern)
    pattern = gsub("H", "[A|C|T]", pattern)
    pattern = gsub("V", "[A|C|G]", pattern)
    pattern = gsub("N", "[A|C|T|G]", pattern)	
    pattern
}

#' Class \code{annoGR}
#' 
#' An object of class \code{annoGR} represents the annotation data could be
#' used by annotationPeakInBatch.
#' 
#' 
#' @name annoGR-class
#' @rdname annoGR
#' @aliases annoGR-class annoGR
#' @docType class
#' @param ranges an object of \link[GenomicRanges:GRanges-class]{GRanges},
#' \link[GenomicFeatures:TxDb-class]{TxDb} or \link[ensembldb]{EnsDb}
#' @param feature annotation type
#' @param date a \link{Date} object
#' @param ... could be following parameters
#' @param source character, where the annotation comes from
#' @param mdata data frame, metadata from annotation
#' @param OrganismDb an object of OrganismDb. It is used for extracting gene
#' symbol for geneModel group for \link[GenomicFeatures:TxDb-class]{TxDb}
#' @section Objects from the Class: Objects can be created by calls of the form
#' \code{new("annoGR", date, elementMetadata, feature, mdata, ranges, seqinfo,
#' seqnames, source, strand)}
#' @slot seqnames,ranges,strand,elementMetadata,seqinfo slots inherit from 
#' \link[GenomicRanges:GRanges-class]{GRanges}. 
#' The ranges must have unique names.
#' @slot source character, where the annotation comes from
#' @slot date a \link{Date} object
#' @slot feature annotation type, could be "gene", "exon", "transcript", "CDS",
#' "fiveUTR", "threeUTR", "microRNA", "tRNAs", "geneModel" for 
#' \link[GenomicFeatures:TxDb-class]{TxDb} object, or "gene", "exon",
#' "transcript" for \link[ensembldb]{EnsDb} object
#' @slot mdata data frame, metadata from annotation
#' @author Jianhong Ou
#' @keywords classes
#' @exportClass annoGR
#' @import methods
#' @importFrom ensembldb EnsDb
#' @examples
#' 
#'     if(interactive() || Sys.getenv("USER")=="jou"){
#'         library(EnsDb.Hsapiens.v79)
#'         anno <- annoGR(EnsDb.Hsapiens.v79)
#'     }
#' 
setClass("annoGR", 
         representation(source="character",
                        date="Date",
                        feature="character",
                        mdata="data.frame"),
         contains="GRanges",
         validity=function(object){
             re <- TRUE
             if(length(object@seqnames)<1) re <- "annotation is empty"
             if(is.null(names(object@ranges))) 
                 re <- "annotation must have names"
             if(any(duplicated(names(object@ranges))))
                 re <- "the names has duplicates"
             if(!is.null(object@mdata)){
                 if(!all(colnames(object@mdata)==c("name", "value"))){
                     re <- "colnames of mdata must be name and value"
                 }
             }
             re
         })

#' @importFrom S4Vectors Rle DataFrame 
#' @importFrom stats setNames
#' @importFrom GenomeInfoDb Seqinfo
newAnnoGR <- function (seqnames = Rle(), 
                       ranges = IRanges(), 
                       strand = Rle("*", length(seqnames)), 
                       mcols = DataFrame(), 
                       seqlengths = NULL, 
                       seqinfo = NULL,
                       ...) 
{
    if (!is(seqnames, "Rle")) 
        seqnames <- Rle(seqnames)
    if (!is.factor(runValue(seqnames))) 
        runValue(seqnames) <- factor(runValue(seqnames), 
                                     levels = unique(runValue(seqnames)))
    if (!is(ranges, "IRanges")) 
        ranges <- as(ranges, "IRanges")
    if (!is(strand, "Rle")) 
        strand <- Rle(strand)
    if (!is.factor(runValue(strand)) || !identical(levels(runValue(strand)), 
                                                   levels(strand()))) 
        runValue(strand) <- strand(runValue(strand))
    if (any(is.na(runValue(strand)))) {
        warning("missing values in strand converted to \"*\"")
        runValue(strand)[is.na(runValue(strand))] <- "*"
    }
    lx <- max(length(seqnames), length(ranges), length(strand))
    if (lx > 1) {
        if (length(seqnames) == 1) 
            seqnames <- rep(seqnames, lx)
        if (length(ranges) == 1) 
            ranges <- rep(ranges, lx)
        if (length(strand) == 1) 
            strand <- rep(strand, lx)
    }
    if (is.null(seqlengths)) 
        seqlengths <- setNames(rep(NA_integer_, length(levels(seqnames))), 
                               levels(seqnames)) ## stats
    if (is.null(seqinfo)) 
        seqinfo <- Seqinfo(names(seqlengths), seqlengths) ##GenomicInfoDb
    runValue(seqnames) <- factor(runValue(seqnames), seqnames(seqinfo))
    if (!is(mcols, "DataFrame")) 
        stop("'mcols' must be a DataFrame object")
    if (ncol(mcols) == 0L) {
        mcols <- mcols(ranges)
        if (is.null(mcols)){
            rn <- names(ranges)
            removenames <- FALSE
            if(length(rn)!=length(ranges)){
                removenames <- TRUE
                rn <- seq_along(ranges)
            }
            mcols <- DataFrame(row.names = rn)
            if(removenames){
                rownames(mcols) <- NULL
            }
        }
    }
    if (!is.null(mcols(ranges))) 
        mcols(ranges) <- NULL
    if (!is.null(rownames(mcols))) {
        if (is.null(names(ranges))) 
            names(ranges) <- rownames(mcols)
        rownames(mcols) <- NULL
    }
    new("annoGR", seqnames = seqnames, ranges = ranges, strand = strand, 
        seqinfo = seqinfo, elementMetadata = mcols, ...)
}


newAGR <- function(gr, ...){
    newAnnoGR(seqnames = seqnames(gr), 
              ranges = ranges(gr), 
              strand = strand(gr), 
              mcols = mcols(gr), 
              seqlengths = seqlengths(gr), 
              seqinfo = seqinfo(gr),
              ...)
}

setGeneric("annoGR", function(ranges, ...) standardGeneric("annoGR"))
setGeneric("info", function(object) standardGeneric("info"))

#' @name coerce
#' @import GenomicRanges
#' @rdname annoGR
#' @aliases coerce,GRanges,annoGR-method
#' coerce,annoGR,GRanges-method
#' @exportMethod coerce
setAs(from="annoGR", to="GRanges", function(from){
    do.call(GRanges, args=append(list(seqnames=seqnames(from), 
                                      ranges=ranges(from),
                                      strand=strand(from),
                                      seqlengths=seqlengths(from),
                                      seqinfo=seqinfo(from)),
                                 as.list(mcols(from))))
})

setAs(from="GRanges", to="annoGR", function(from){
    annoGR(from)
})

#' @rdname annoGR
#' @exportMethod info
#' @param object annoGR object.
#' @aliases info info,annoGR-method
setMethod("info", "annoGR", function(object){
    cat(class(object), "object;\n")
    cat("# source: ", object@source, "\n")
    cat("# create at: ", format(object@date, "%a %b %d %X %Y %Z"), "\n")
    cat("# feature: ", object@feature, "\n")
    mdata <- object@mdata
    for (i in seq_len(nrow(mdata))) {
        cat("# ", mdata[i, "name"], ": ", mdata[i, "value"],
            "\n", sep="")
    }
})

#' @rdname annoGR
#' @exportMethod annoGR
#' @aliases annoGR,GRanges-method
setMethod("annoGR", "GRanges", 
          function(ranges, feature="group", date, ...){
              if(missing("date")) date <- Sys.Date()
              if(is.null(names(ranges))){
                  names(ranges) <- make.names(
                      formatC(1:length(ranges),
                              width=nchar(length(ranges)),
                              flag="0"))
              }
              newAGR(gr=ranges,
                     date=date, feature=feature,
                     ...)
          })

#' @importFrom DBI dbGetQuery 
#' @importFrom BiocGenerics dbconn
#' @rdname annoGR
#' @exportMethod annoGR
#' @aliases annoGR,TxDb-method
setMethod("annoGR", "TxDb", 
          function(ranges, feature=c("gene", "transcript", "exon",
                                     "CDS", "fiveUTR", "threeUTR",
                                     "tRNAs", "geneModel"),
                   date, source, mdata, OrganismDb){
              feature <- match.arg(feature)
              if(missing(mdata)) {
                  mdata <- 
                      dbGetQuery(dbconn(ranges), "select * from metadata")
              }
              if(missing(source)) 
                  source <- deparse(substitute(ranges, env=parent.frame()))
              if(missing(date)) date <- Sys.Date()
              gr <- if(!missing(OrganismDb)) TxDb2GR(ranges, feature, OrganismDb) else TxDb2GR(ranges, feature)
              newAGR(gr=gr, source=source,
                     date=date, feature=feature, 
                     mdata=mdata)
          })

#' @importFrom DBI dbGetQuery 
#' @importFrom BiocGenerics dbconn
#' @rdname annoGR
#' @exportMethod annoGR
#' @aliases annoGR,EnsDb-method
setMethod("annoGR", "EnsDb",
          function(ranges, 
                   feature=c("gene", "transcript", "exon", "disjointExons"),
                   date, source, mdata){
              feature <- match.arg(feature)
              if(missing(mdata)) {
                  mdata <- 
                      dbGetQuery(dbconn(ranges), "select * from metadata")
              }
              if(missing(source)) 
                  source <- deparse(substitute(ranges, env=parent.frame()))
              if(missing(date)) date <- Sys.Date()
              gr <- EnsDb2GR(ranges, feature)
              newAGR(gr=gr, source=source,
                     date=date, feature=feature, 
                     mdata=mdata)
          })

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(message = FALSE, 
                      warning = FALSE,
          					  tidy = FALSE, 
          					  fig.width = 6, 
          					  fig.height = 6,
          					  fig.align = "center")
# Handle the biofilecache error
library(BiocFileCache)
bfc <- BiocFileCache()
res <- bfcquery(bfc, 
                "annotationhub.index.rds", 
                field = "rname", 
                exact = TRUE) 
bfcremove(bfc, rids = res$rid)

## ----fig.cap = "A workflow for ChIP-seq data analysis", echo = FALSE, out.width = "100%", out.height = "100%"----
png <- system.file("extdata", "dataFlow.png", package = "ChIPpeakAnno")

knitr::include_graphics(png)

## -----------------------------------------------------------------------------
library(ChIPpeakAnno)

macs_peak <- system.file("extdata", "MACS_peaks.xls", 
                         package = "ChIPpeakAnno")
macs_peak_gr <- toGRanges(macs_peak, format = "MACS")
head(macs_peak_gr, n = 2)

## -----------------------------------------------------------------------------
# Use Ensembl annotation package:
library(EnsDb.Hsapiens.v86)

ensembl.hs86.transcript <- transcripts(EnsDb.Hsapiens.v86)

## -----------------------------------------------------------------------------
# Use Ensembl annotation package:
macs_peak_ensembl <- annotatePeakInBatch(macs_peak_gr, 
										 AnnotationData = ensembl.hs86.transcript)
head(macs_peak_ensembl, n = 2)

## -----------------------------------------------------------------------------
# Use Ensembl annotation package:
macs_peak_ensembl <- addGeneIDs(annotatedPeak = macs_peak_ensembl, 
                                orgAnn = EnsDb.Hsapiens.v86,
                                feature_id_type = "ensembl_transcript_id",
                                IDs2Add = "SYMBOL")
head(macs_peak_ensembl, n = 2)

## -----------------------------------------------------------------------------
# Convert GFF to GRanges:
macs_peak_gff <- system.file("extdata", "GFF_peaks_hg38.gff", 
                             package = "ChIPpeakAnno")
macs_peak_gr1 <- toGRanges(macs_peak_gff, format = "GFF", header = FALSE)
head(macs_peak_gr1, n = 2)

# Convert BED to GRanges:
macs_peak_bed <- system.file("extdata", "MACS_output_hg38.bed", 
                             package = "ChIPpeakAnno")
macs_peak_gr2 <- toGRanges(macs_peak_bed, format = "BED", header = FALSE)
head(macs_peak_gr2, n = 2)

## -----------------------------------------------------------------------------
# For two samples:
data(peaks1)
data(peaks2)
head(peaks1, n = 2)
head(peaks2, n = 2)
ol <- findOverlapsOfPeaks(peaks1, peaks2)
names(ol)

# For three samples:
data(peaks3)
ol2 <- findOverlapsOfPeaks(peaks1, peaks2, peaks3,
                           connectedPeaks = "min")

# Find peaks with at least 90% overlap:
ol3 <- findOverlapsOfPeaks(peaks1, peaks2, minoverlap = 0.9)

## -----------------------------------------------------------------------------
# For peaks1:
length(ol$peaklist[["peaks1"]])

# For peaks2:
length(ol$peaklist[["peaks2"]])

## ----results = "hide", fig.cap = "Venn diagram showing the number of overlapping peaks for two samples", fig.small = TRUE----
# For two samples:
venn <- makeVennDiagram(ol, totalTest = 100,
                        fill = c("#009E73", "#F0E442"),
                        col = c("#D55E00", "#0072B2"),
                        cat.col = c("#D55E00", "#0072B2"))

# For three samples:
venn2 <- makeVennDiagram(ol2, totalTest = 100,
                         fill = c("#CC79A7", "#56B4E9", "#F0E442"),
                         col = c("#D55E00", "#0072B2", "#E69F00"),
                         cat.col = c("#D55E00", "#0072B2", "#E69F00"))

# For peaks overlap at least 90%:
venn3 <- makeVennDiagram(ol3, totalTest = 100,
                         fill = c("#009E73", "#F0E442"),
                         col = c("#D55E00", "#0072B2"),
                         cat.col = c("#D55E00", "#0072B2"))

## ----eval = FALSE-------------------------------------------------------------
# if (!library(Vennerable)) {
#   install.packages("Vennerable", repos="http://R-Forge.R-project.org")
#   library(Vennerable)
# }
# 
# n <- which(colnames(ol$vennCounts) == "Counts") - 1
# set_names <- colnames(ol$vennCounts)[1:n]
# weight <- ol$vennCounts[, "Counts"]
# names(weight) <- apply(ol$vennCounts[, 1:n], 1, base::paste, collapse = "")
# v <- Venn(SetNames = set_names, Weight = weight)
# plot(v)

## -----------------------------------------------------------------------------
names(ol$overlappingPeaks)
dim(ol$overlappingPeaks[["peaks1///peaks2"]])
ol$overlappingPeaks[["peaks1///peaks2"]][1:2, ]
unique(ol$overlappingPeaks[["peaks1///peaks2"]][["overlapFeature"]])
pie1(table(ol$overlappingPeaks[["peaks1///peaks2"]]$overlapFeature))

## ----echo = FALSE-------------------------------------------------------------
library(knitr)

Resource <- c("Ensembl", "NCBI RefSeq")
Generated_by <- c("EMBL-EBI", "NCBI")
Annotation_criteria <- c("Comprehensive (most transcripts)", "Conservative (fewer transcripts)")
Gene_id_name <- c("Ensembl gene ID", "NCBI Gene ID, or entrezGene ID, or entrez ID")
URL <- c("https://ftp.Ensembl.org/pub/", "https://ftp.ncbi.nlm.nih.gov/refseq/")
df <- data.frame(Resource, Generated_by, Annotation_criteria, URL)

kable(df, caption = 'Commonly used annotation resources')

## ----echo = FALSE-------------------------------------------------------------
library(knitr)

Human <- c("[hg38.refGene.gtf.gz](https://hgdownload.soe.ucsc.edu/goldenPath/hg38/bigZips/genes/hg38.refGene.gtf.gz)",
           "[hg38.ncbiRefSeq.gtf.gz](https://hgdownload.soe.ucsc.edu/goldenPath/hg38/bigZips/genes/hg38.ncbiRefSeq.gtf.gz)",
           "[hg38.knownGene.gtf.gz](https://hgdownload.soe.ucsc.edu/goldenPath/hg38/bigZips/genes/hg38.knownGene.gtf.gz)")
Mouse <- c("[mm10.refGene.gtf.gz](https://hgdownload.soe.ucsc.edu/goldenPath/mm10/bigZips/genes/mm10.refGene.gtf.gz)",
           "[mm10.ncbiRefSeq.gtf.gz](https://hgdownload.soe.ucsc.edu/goldenPath/mm10/bigZips/genes/mm10.ncbiRefSeq.gtf.gz)",
           "[mm10.knownGene.gtf.gz](https://hgdownload.soe.ucsc.edu/goldenPath/mm10/bigZips/genes/mm10.knownGene.gtf.gz)")
Remark <- c("Based on RefSeq transcripts aligned by UCSC followed by manual curation",
            "Based on RefSeq transcripts as aligned by NCBI",
            "Based on Ensembl gene models")
df <- data.frame(Human, Mouse, Remark)

kable(df, caption = "UCSC Genome Browser hosted annotation files")

## -----------------------------------------------------------------------------
library(AnnotationHub)

ah <- AnnotationHub()

# Obtain EnsDb:
EnsDb_Mmusculus_all <- query(ah, pattern = c("Mus musculus", "EnsDb"))
head(EnsDb_Mmusculus_all, n = 2)
EnsDb_Mmusculus <- EnsDb_Mmusculus_all[["AH53222"]]
class(EnsDb_Mmusculus)

# Obtain TxDb:
TxDb_Mmusculus_all <- query(ah, pattern = c("Mus musculus", "TxDb"))
head(TxDb_Mmusculus_all, n = 2)
TxDb_Mmusculus <- TxDb_Mmusculus_all[["AH52264"]]
class(TxDb_Mmusculus)

## ----eval = FALSE-------------------------------------------------------------
# library(biomaRt)
# 
# listMarts()
# head(listDatasets(useMart("ENSEMBL_MART_ENSEMBL")), n = 2)
# mart <- useMart(biomart = "ENSEMBL_MART_ENSEMBL",
#                 dataset = "mmusculus_gene_ensembl")
# anno_from_biomart <- getAnnotation(mart,
#                                    featureType = "transcript")
# head(anno_from_biomart, n = 2)

## -----------------------------------------------------------------------------
library(EnsDb.Hsapiens.v86)

anno_ensdb_transcript <- toGRanges(EnsDb.Hsapiens.v86, 
                                   feature = "transcript")
head(anno_ensdb_transcript, n = 2)

## -----------------------------------------------------------------------------
anno_ensdb_transcript <- transcripts(EnsDb.Hsapiens.v86)

head(anno_ensdb_transcript, n = 2)

## ----fig.cap = "Peak count distribution around TSSs", warning = FALSE---------
library(TxDb.Hsapiens.UCSC.hg38.knownGene)

annotation_data <- transcripts(TxDb.Hsapiens.UCSC.hg38.knownGene)
binOverFeature(macs_peak_gr2, 
               featureSite = "FeatureStart",
               nbins = 20,
               annotationData = annotation_data,
               xlab = "peak distance from TSS (bp)", 
               ylab = "peak count", 
               main = "Distribution of aggregated peak numbers around TSS")

## ----fig.cap = "Bar graph showing peak distributions over different genomic features"----
chromosome_region <- assignChromosomeRegion(macs_peak_gr2,
                                            TxDb = TxDb.Hsapiens.UCSC.hg38.knownGene,
                                            nucleotideLevel = FALSE,
                                            precedence=c("Promoters",
                                                         "immediateDownstream", 
                                                         "fiveUTRs", 
                                                         "threeUTRs",
                                                         "Exons", 
                                                         "Introns"))

# optional helper function to rotate x-axis labels for barplot(): 
# ref: https://stackoverflow.com/questions/10286473/rotating-x-axis-labels-in-r-for-barplot
rotate_x <- function(data, rot_angle) {
  plt <- barplot(data, xaxt = "n")
  text(plt, par("usr")[3], 
       labels = names(data), 
       srt = rot_angle, adj = c(1.1,1.1), 
       xpd = TRUE, cex = 0.6)
}

rotate_x(chromosome_region[["percentage"]], 45)

## ----fig.cap = "Pie graph showing peak distributions over features at different levels"----
genomicElementDistribution(macs_peak_gr1, 
                           TxDb = TxDb.Hsapiens.UCSC.hg38.knownGene)

## ----fig.cap = "Bar graph showing peak distributions over features at different levels"----
macs_peaks <- GRangesList(rep1 = macs_peak_gr1,
                          rep2 = macs_peak_gr2)
genomicElementDistribution(macs_peaks, 
                           TxDb = TxDb.Hsapiens.UCSC.hg38.knownGene)

## ----fig.cap = "UpSet plot showing the overlappings of peak distributions among different genomic features"----
library(UpSetR)

res <- genomicElementUpSetR(macs_peak_gr1,
                            TxDb.Hsapiens.UCSC.hg38.knownGene)
upset(res[["plotData"]], 
      nsets = length(colnames(res$plotData)), 
      nintersects = NA)

## ----fig.cap = "How does peak-centric annotation method work", echo = FALSE, out.width = "100%", out.height = "100%"----
png <- system.file("extdata", "annoPeakCentric.png", package = "ChIPpeakAnno")

knitr::include_graphics(png)

## ----fig.cap = "How does feature-centric annotation method work", echo = FALSE, out.width = "100%", out.height = "100%"----
png <- system.file("extdata", "annoFeatureCentric1.png", package = "ChIPpeakAnno")

knitr::include_graphics(png)

## ----fig.cap = "How to define target region with bindingRegion", echo = FALSE, out.width = "100%", out.height = "100%"----
png <- system.file("extdata", "annoFeatureCentric2.png", package = "ChIPpeakAnno")

knitr::include_graphics(png)

## -----------------------------------------------------------------------------
library(TxDb.Hsapiens.UCSC.hg18.knownGene)

data(myPeakList)
peak_to_anno <- myPeakList[1:100]
anno_data <- transcripts(TxDb.Hsapiens.UCSC.hg18.knownGene)

annotated_peak <- annotatePeakInBatch(peak_to_anno, 
                                      output = "nearestLocation",
                                      PeakLocForDistance = "start",
                                      FeatureLocForDistance = "TSS",
                                      AnnotationData = anno_data)
head(annotated_peak, n = 2)

## -----------------------------------------------------------------------------
annotated_peak <- annotatePeakInBatch(peak_to_anno, 
                                      AnnotationData = anno_data,
                                      output = "both",
                                      maxgap = 100)
head(annotated_peak, n = 4)

## ----fig.cap = "Peak distribution around features"----------------------------
pie1(table(annotated_peak$insideFeature))

## -----------------------------------------------------------------------------
TF_binding_sites <- GRanges(seqnames = c("1", "2", "3", "4", "5", "6", "1", 
                                         "2", "3", "4", "5", "6", "6", "6", 
                                         "6", "6", "5"),
                            ranges = IRanges(start = c(967659, 2010898, 2496700, 
                                                       3075866, 3123260, 3857500,
                                                       96765, 201089, 249670, 
                                                       307586, 312326, 385750, 
                                                       1549800, 1554400, 1565000, 
                                                       1569400, 167888600),
                                             end = c(967869, 2011108, 2496920, 
                                                     3076166,3123470, 3857780,
                                                     96985, 201299, 249890, 307796, 
                                                     312586, 385960, 1550599, 
                                                     1560799, 1565399, 1571199, 
                                                     167888999),
                                             names = paste("t", 1:17, sep = "")),
                            strand = c("*", "*", "*", "*", "*", "*", "*", "*", "*", 
                                       "*", "*", "*", "*", "*", "*", "*", "*"))

annotated_peak2 <- annotatePeakInBatch(peaks1, AnnotationData = TF_binding_sites)
head(annotated_peak2, n = 2)

## -----------------------------------------------------------------------------
promoter_regions <- promoters(TxDb.Hsapiens.UCSC.hg18.knownGene, 
                              upstream = 2000, downstream = 500)
head(promoter_regions, n = 2)

annotated_peak3 <- annotatePeakInBatch(peak_to_anno, 
                                       AnnotationData = promoter_regions)
head(annotated_peak3, n = 2)

## -----------------------------------------------------------------------------
anno_txdb <- genes(TxDb.Hsapiens.UCSC.hg38.knownGene)
head(anno_txdb$gene_id, n = 5)

anno_ensdb <- genes(EnsDb.Hsapiens.v86)
head(anno_ensdb$gene_id, n = 5)

## -----------------------------------------------------------------------------
library(org.Hs.eg.db)
library(TxDb.Hsapiens.UCSC.hg38.knownGene)

ucsc.hg38.knownGene <- genes(TxDb.Hsapiens.UCSC.hg38.knownGene)
entrez_ids <- head(ucsc.hg38.knownGene$gene_id, n = 10)
print(entrez_ids)

res <- addGeneIDs(entrez_ids, 
                  orgAnn = "org.Hs.eg.db", 
                  feature_id_type = "entrez_id",
                  IDs2Add = "symbol")
head(res, n = 3)

## -----------------------------------------------------------------------------
txdb.hg38.transcript <- transcripts(TxDb.Hsapiens.UCSC.hg38.knownGene)
head(txdb.hg38.transcript, n = 4)

## -----------------------------------------------------------------------------
names(txdb.hg38.transcript) <- txdb.hg38.transcript$tx_name

## -----------------------------------------------------------------------------
res <- annotatePeakInBatch(macs_peak_gr2, 
                           AnnotationData = txdb.hg38.transcript)
head(res, n = 2)

## -----------------------------------------------------------------------------
tryCatch({
  # we will first try biomaRt
  library(biomaRt)

  mart <- useMart(biomart = "ensembl",
                  dataset = "hsapiens_gene_ensembl")
  res <- addGeneIDs(res, 
                    mart = mart,
                    feature_id_type = "ensembl_transcript_id",
                    IDs2Add = "hgnc_symbol")
  head(res, n = 2)
}, error=function(e){
  message(e)
  library(org.Hs.eg.db)
  res <- addGeneIDs(res, 
                    orgAnn = TxDb.Hsapiens.UCSC.hg38.knownGene,
                    feature_id_type = "ensembl_transcript_id",
                    IDs2Add = "GENEID")
  res$symbol[!is.na(res$GENEID)] <- 
    xget(res$GENEID[!is.na(res$GENEID)], org.Hs.egSYMBOL, output = 'first')
  tail(res, n = 2)
})

## ----fig.cap = "Histogram showing enriched GO terms"--------------------------
anno_data <- genes(EnsDb.Hsapiens.v86)
annotated_peak4 <- annotatePeakInBatch(macs_peak_gr2,
                                       AnnotationData = anno_data,
                                       output = "both")

enriched_go <- getEnrichedGO(annotated_peak4, 
                             orgAnn = "org.Hs.eg.db", 
                             feature_id_type = "ensembl_gene_id")
enrichmentPlot(enriched_go, label_wrap = 60)

## -----------------------------------------------------------------------------
length(enriched_go[["bp"]][["go.id"]])
length(enriched_go[["cc"]][["go.id"]])
length(enriched_go[["mf"]][["go.id"]])

## -----------------------------------------------------------------------------
head(enriched_go[["mf"]], n = 2)

## ----fig.cap = "Bar graph showing enriched pathways"--------------------------
library(reactome.db)

data(annotatedPeak)
enriched_path <- getEnrichedPATH(annotatedPeak,
                                 orgAnn = "org.Hs.eg.db",
                                 feature_id_type = "ensembl_gene_id",
                                 pathAnn = "reactome.db")

## ----fig.cap = "Histogram showing enriched pathways"--------------------------
enrichmentPlot(enriched_path)

## -----------------------------------------------------------------------------
library(BSgenome.Hsapiens.UCSC.hg38)

sequence_around_peak <- getAllPeakSequence(macs_peak_gr2, 
                                           upstream = 20,
                                           downstream = 20, 
                                           genome = BSgenome.Hsapiens.UCSC.hg38)
head(sequence_around_peak, n = 2)

## ----eval = FALSE-------------------------------------------------------------
# library(biomaRt)
# 
# mart <- useMart(biomart="ENSEMBL_MART_ENSEMBL",
#                 dataset="hsapiens_gene_ensembl")
# 
# sequence_around_peak <- getAllPeakSequence(macs_peak_gr2[1],
#                                            upstream = 20,
#                                            downstream = 20,
#                                            genome = mart)

## ----eval = FALSE-------------------------------------------------------------
# write2FASTA(sequence_around_peak, file = "macs_peak_gr2.fa")

## -----------------------------------------------------------------------------
freqs <- oligoFrequency(BSgenome.Hsapiens.UCSC.hg38$chr1)
motif_summary <- oligoSummary(sequence_around_peak, 
                              oligoLength = 6,
                              MarkovOrder = 3,
                              freqs = freqs,
                              quickMotif = TRUE)

## ----fig.cap = "Histogram showing Z-score distribution"-----------------------
zscore <- sort(motif_summary$zscore)
h <- hist(zscore, breaks = 100, main = "Histogram of Z-score")
text(x = zscore[length(zscore)], 
     y = h$counts[length(h$counts)] + 1, 
     labels = names(zscore[length(zscore)]), 
     adj = 0, 
     srt = 90)

## ----fig.cap = "Histogram showing Z-score distribution for simulation data"----
set.seed(1)

# motifs to simulate
simulate_motif_1 <- "AATTTA"
simulate_motif_2 <- "TGCATG"

# sample 5000 sequences with lengths ranging from 100 to 2000 nucleotides
# randomly insert motif_1 to 10% of the sequences, and motif_2 to 15% of the sequences
simulation_seqs <- sapply(sample(c(1, 2, 0), 
                                 5000,
                                 prob = c(0.1, 0.15, 0.75),
                                 replace = TRUE), 
                           function(x) {
                             seq <- sample(c("A", "T", "C", "G"),
                                           sample.int(1900, 1) + 100, 
                                           replace = TRUE)
                             insert_pos <- sample.int(length(seq) - 6, 1)
                             if (x == 1) {
                               seq[insert_pos:(insert_pos + 5)] <- strsplit(simulate_motif_1, "")[[1]]
                             } else if (x == 2) {
                               seq[insert_pos:(insert_pos + 5)] <- strsplit(simulate_motif_2, "")[[1]]
                             }
                             paste(seq, collapse = "")
                           }
)

motif_summary_simu <- oligoSummary(simulation_seqs, 
                                   oligoLength = 6, 
                                   MarkovOrder = 3, 
                                   quickMotif = TRUE)
zscore_simu <- sort(motif_summary_simu$zscore, 
                    decreasing = TRUE)
h_simu <- hist(x = zscore_simu, 
               breaks = 100, 
               main = "Histogram of Z-score for simulation data")
text(x = zscore_simu[1:2],  
     y = rep(5, 2), 
     labels = names(zscore_simu[1:2]), 
     adj = 0, 
     srt = 90)

## ----fig.small = TRUE---------------------------------------------------------
library(motifStack)

pfm <- new("pfm", mat = motif_summary_simu$motifs[[1]],
           name = "sample motif 1")
motifStack(pfm)

## ----fig.cap = "Plot showing the first motif detected", fig.small = TRUE------
pfms <- mapply(function(motif, id) { new("pfm", mat = motif, name = as.character(id)) },
               motif_summary$motifs,
               seq_along(motif_summary$motifs))

motifStack(pfms[[1]])

## -----------------------------------------------------------------------------
example_pattern_file <- system.file("extdata/examplePattern.fa",
                                    package = "ChIPpeakAnno")
readLines(example_pattern_file)
pattern_in_peak <- summarizePatternInPeaks(patternFilePath = example_pattern_file,
                                           BSgenomeName = BSgenome.Hsapiens.UCSC.hg38,
                                           peaks = macs_peak_gr2[1:200],
                                           bgdForPerm = "chromosome",
                                           nperm = 100, 
                                           method = "permutation.test")

pattern_in_peak$motif_enrichment
head(pattern_in_peak$motif_occurrence, n = 2)

## -----------------------------------------------------------------------------
tf1 <- toGRanges(system.file("extdata/TAF.broadPeak", package = "ChIPpeakAnno"),
                 format = "broadPeak")
tf2 <- toGRanges(system.file("extdata/Tead4.broadPeak", package = "ChIPpeakAnno"),
                 format = "broadPeak")
tf3 <- toGRanges(system.file("extdata/YY1.broadPeak", package = "ChIPpeakAnno"),
                 format = "broadPeak")

## ----results = "hide", fig.cap = "Venn diagram1 showing overlapping peaks", fig.small = TRUE----
overlapping_peaks <- findOverlapsOfPeaks(tf1, 
                                         tf2, 
                                         tf3, 
                                         connectedPeaks = "keepAll")
mean_peak_width <- mean(width(unlist(GRangesList(overlapping_peaks[["all.peaks"]]))))

total_binding_sites <- length(BSgenome.Hsapiens.UCSC.hg38[["chr2"]]) * 0.03 / mean_peak_width
venn1 <- makeVennDiagram(overlapping_peaks, 
                         totalTest = total_binding_sites, 
                         connectedPeaks = "keepAll", 
                         fill = c("#CC79A7", "#56B4E9", "#F0E442"),
                         col = c("#D55E00", "#0072B2", "#E69F00"),
                         cat.col = c("#D55E00", "#0072B2", "#E69F00"))

## -----------------------------------------------------------------------------
venn1[["p.value"]]

## -----------------------------------------------------------------------------
venn1[["vennCounts"]]

## ----results = "hide", fig.cap = "Venn diagram2 showing overlapping peaks", fig.small = TRUE----
venn2 <- makeVennDiagram(overlapping_peaks, 
                         totalTest = total_binding_sites, 
                         connectedPeaks = "keepFirstListConsistent", 
                         fill = c("#CC79A7", "#56B4E9", "#F0E442"),
                         col = c("#D55E00", "#0072B2", "#E69F00"),
                         cat.col = c("#D55E00", "#0072B2", "#E69F00"))

## ----eval = FALSE-------------------------------------------------------------
# library(TxDb.Hsapiens.UCSC.hg38.knownGene)
# 
# txdb <- TxDb.Hsapiens.UCSC.hg38.knownGene
# set.seed(123)
# 
# # Example1: non-relevant peak sets
# utr5 <- unique(unlist(fiveUTRsByTranscript(txdb)))
# utr3 <- unique(unlist(threeUTRsByTranscript(txdb)))
# 
# utr5 <- utr5[sample.int(length(utr5), 1000)]
# utr3 <- utr3[sample.int(length(utr3), 1000)]
# 
# pt1 <- peakPermTest(peaks1 = utr3,
#                     peaks2 = utr5,
#                     TxDb = txdb,
#                     maxgap = 500,
#                     seed = 1)
# plot(pt1)

## ----fig.cap = "Permutation test for non-relevant peak sets", echo = FALSE, out.width = "100%", out.height = "100%"----
png <- system.file("extdata", "permTest1.png", package = "ChIPpeakAnno")

knitr::include_graphics(png)

## ----eval = FALSE-------------------------------------------------------------
# # Example2: highly relevant peak sets
# cds <- unique(unlist(cdsBy(txdb)))
# ol <- findOverlaps(cds, utr3, maxgap = 1)
# peaks2 <- c(cds[sample.int(length(cds), 500)],
#             cds[queryHits(ol)][sample.int(length(ol), 500)])
# pt2 <- peakPermTest(peaks1 = utr3,
#                     peaks2 = peaks2,
#                     TxDb = txdb,
#                     maxgap = 500,
#                     seed = 1)
# plot(pt2)

## ----fig.cap = "Permutation test for highly relevant peak sets", echo = FALSE, out.width = "100%", out.height = "100%"----
png <- system.file("extdata", "permTest2.png", package = "ChIPpeakAnno")

knitr::include_graphics(png)

## ----eval = FALSE-------------------------------------------------------------
# # Step1: download TF binding sites
# temp <- tempfile()
# download.file(file.path("https://hgdownload.cse.ucsc.edu/",
#                         "goldenpath/",
#                         "hg38/",
#                         "encRegTfbsClustered/",
#                         "encRegTfbsClusteredWithCells.hg38.bed.gz"),
#               temp)
# df_tfbs <- read.delim(gzfile(temp, "r"), header = FALSE)
# unlink(temp)
# 
# colnames(df_tfbs)[1:4] <- c("seqnames", "start", "end", "TF")
# tfbs_hg38 <- GRanges(as.character(df_tfbs$seqnames),
#                      IRanges(df_tfbs$start, df_tfbs$end),
#                      TF = df_tfbs$TF)
# 
# # Step2: download hot spots
# base_url <- "http://metatracks.encodenets.gersteinlab.org/metatracks/"
# 
# temp1 <- tempfile()
# temp2 <- tempfile()
# download.file(file.path(base_url,
#                         "HOT_All_merged.tar.gz"),
#               temp1)
# download.file(file.path(base_url,
#                         "HOT_intergenic_All_merged.tar.gz"),
#               temp2)
# untar(temp1, exdir = dirname(temp1))
# untar(temp2, exdir = dirname(temp1))
# bedfiles <- dir(dirname(temp1), "bed$")
# hot_spots_hg19 <- sapply(file.path(dirname(temp1), bedfiles), toGRanges, format = "BED")
# unlink(temp1)
# unlink(temp2)
# 
# names(hot_spots_hg19) <- gsub("_merged.bed", "", bedfiles)
# hot_spots_hg19 <- sapply(hot_spots_hg19, unname)
# hot_spots_hg19 <- GRangesList(hot_spots_hg19)
# 
# # Step3: liftover hot spots to hg38
# library(R.utils)
# 
# temp_chain_gz <- tempfile()
# temp_chain <- tempfile()
# base_url_chain <- "http://hgdownload.cse.ucsc.edu/goldenpath/"
# download.file(file.path(base_url_chain,
#                         "hg19/liftOver/",
#                         "hg19ToHg38.over.chain.gz"),
#               temp_chain_gz)
# gunzip(filename = temp_chain_gz, destname = temp_chain)
# chain_file <- import.chain(hg19_to_hg38)
# unlink(temp_chain_gz)
# unlink(temp_chain)
# 
# hot_spots_hg38 <- liftOver(hot_spots_hg19, chain_file)
# 
# # Step4: select peak sets to test
# tfbs_hg38_by_TF <- split(tfbs_hg38, tfbs_hg38$TF)
# TAF1 <- tfbs_hg38_by_TF[["TAF1"]]
# TEAD4 <- tfbs_hg38_by_TF[["TEAD4"]]
# 
# # Step5: remove hot spots from binding pool
# tfbs_hg38 <- subsetByOverlaps(tfbs_hg38, hot_spots_hg38, invert=TRUE)
# tfbs_hg38 <- reduce(tfbs_hg38)
# 
# # Step6: perform permutation test
# pool <- new("permPool",
#             grs = GRangesList(tfbs_hg38),
#             N = length(TAF1))
# pt3 <- peakPermTest(TAF1, TEAD4, pool = pool, ntimes = 500)
# plot(pt3)

## ----fig.cap = "Permutation test using custom peak pool", echo = FALSE, out.width = "100%", out.height = "100%"----
png <- system.file("extdata", "permTest3.png", package = "ChIPpeakAnno")

knitr::include_graphics(png)

## ----fig.cap = "Heatmap of coverage densities for selected TFs"---------------
# Step1: read in example peak files
extdata_path <- system.file("extdata", package = "ChIPpeakAnno")
broadPeaks <- dir(extdata_path, "broadPeak")
gr_TFs <- sapply(file.path(extdata_path, broadPeaks), toGRanges, format = "broadPeak")
names(gr_TFs) <- gsub(".broadPeak", "", broadPeaks)
names(gr_TFs)

## -----------------------------------------------------------------------------
# Step2: find peaks that are shared by all
ol <- findOverlapsOfPeaks(gr_TFs)
gr_TFs_ol <- ol$peaklist$`TAF///Tead4///YY1`

# Step3: read in example coverage files
# here we read in coverage data from -2000bp to -2000bp of each shared peak center
gr_TFs_ol_center <- reCenterPeaks(gr_TFs_ol, width = 4000) # use the center of the peaks and extend 2000bp upstream and downstream to obtain peaks with uniform length of 4000bp

bigWigs <- dir(extdata_path, "bigWig")
coverage_list <- sapply(file.path(extdata_path, bigWigs), 
                        import, # rtracklayer::import
                        format = "BigWig",
                        which = gr_TFs_ol_center,
                        as = "RleList")

names(coverage_list) <- gsub(".bigWig", "", bigWigs)
names(coverage_list)

## ----fig.cap = "Heatmap of coverages for selected TFs", fig.height = 6, message = FALSE----
# Step4: visualize binding patterns
sig <- featureAlignedSignal(coverage_list, gr_TFs_ol_center)

# since the bigWig files are only a subset of the original files,
# filter to keep peaks that are with coverage data for all peak sets
keep <- rowSums(sig[[1]]) > 0 & rowSums(sig[[2]]) > 0 & rowSums(sig[[3]]) > 0
sig <- sapply(sig, function(x) x[keep, ], simplify = FALSE)
gr_TFs_ol_center <- gr_TFs_ol_center[keep]

featureAlignedHeatmap(sig, gr_TFs_ol_center,
                      upper.extreme=c(3, 0.5, 4))

## ----fig.cap = "Heatmap of coverages for selected TFs sorted by hierarchical clustering", fig.height = 6, message = FALSE----
# perform hierarchical clustering on rows
sig_rowsums <- sapply(sig, rowSums, na.rm = TRUE)
row_distance <- dist(sig_rowsums)
hc <- hclust(row_distance)

# use hierarchical clustering order to sort
gr_TFs_ol_center$sort_by <- hc$order
featureAlignedHeatmap(sig, gr_TFs_ol_center, 
                      upper.extreme = c(3, 0.5, 4),
                      sortBy = "sort_by")

## ----fig.cap = "Distribution of coverage densities for selected TFs", message = FALSE----
featureAlignedDistribution(sig, gr_TFs_ol_center,
                           type = "l")

## ----message = FALSE, warning = FALSE-----------------------------------------
library(ChIPpeakAnno)

# Convert BED/GFF into GRanges
bed1 <- system.file("extdata", "MACS_output_hg38.bed", 
                    package = "ChIPpeakAnno")
gr1 <- toGRanges(bed1, format = "BED", header = FALSE)
gff1 <- system.file("extdata", "GFF_peaks_hg38.gff", 
                    package = "ChIPpeakAnno")
gr2 <- toGRanges(gff1, format = "GFF", header = FALSE)

# Find overlapping peaks
ol <- findOverlapsOfPeaks(gr1, gr2)

# Add "score" metadata column to overlapping peaks
ol <- addMetadata(ol, colNames = "score", FUN = mean) 
head(ol$mergedPeaks, n = 2)

## ----results = "hide", fig.cap = "Venn diagram showing the number of overlapping peaks for gr1 and gr2", fig.small = TRUE----
venn <- makeVennDiagram(ol,
                        fill = c("#009E73", "#F0E442"),
                        col = c("#D55E00", "#0072B2"),
                        cat.col = c("#D55E00", "#0072B2"))

## -----------------------------------------------------------------------------
venn[["p.value"]]

## -----------------------------------------------------------------------------
venn[["vennCounts"]]

## ----warning = FALSE----------------------------------------------------------
library(EnsDb.Hsapiens.v86)

ensembl.hs86.gene <- toGRanges(EnsDb.Hsapiens.v86, feature = "gene")
head(ensembl.hs86.gene, n = 2)

## ----fig.cap = "Peak count distribution around transcription start sites", warning = FALSE----
binOverFeature(ol$mergedPeaks, 
               nbins = 20,
               annotationData = ensembl.hs86.gene,
               xlab = "peak distance from TSSs (bp)", 
               ylab = "peak count", 
               main = "Distribution of aggregated peak numbers around TSS")

## ----fig.cap = "Pie graph showing peak distributions over different genomic features"----
library(TxDb.Hsapiens.UCSC.hg38.knownGene)

genomicElementDistribution(ol$mergedPeaks, 
                           TxDb = TxDb.Hsapiens.UCSC.hg38.knownGene)

## ----fig.cap = "Bar graph showing peak distributions over different genomic features for two replicates"----
macs_peaks <- GRangesList(rep1 = gr1,
                          rep2 = gr2)
genomicElementDistribution(macs_peaks, 
                           TxDb = TxDb.Hsapiens.UCSC.hg38.knownGene)

## ----fig.cap = "UpSet plot showing peak overlappings for multiple features"----
library(UpSetR)

res <- genomicElementUpSetR(ol$mergedPeak,
                            TxDb.Hsapiens.UCSC.hg38.knownGene)
upset(res[["plotData"]], 
      nsets = length(colnames(res$plotData)), 
      nintersects = NA)

## -----------------------------------------------------------------------------
ol_anno <- annotatePeakInBatch(ol$mergedPeak, 
                               AnnotationData = ensembl.hs86.gene, 
                               output = "nearestBiDirectionalPromoters",
                               bindingRegion = c(-2000, 500))
head(ol_anno, n = 2)

## ----eval = FALSE-------------------------------------------------------------
# ol_anno <- unname(ol_anno) # remove names to avoid duplicate row.names error
# ol_anno$peakNames <- NULL # remove peakNames to avoid unimplemented type 'list' error
# write.csv(as.data.frame(ol_anno), "ol_anno.csv")

## ----fig.cap = "Pie chart showing peak distribution around features"----------
pie1(table(ol_anno$insideFeature))

## -----------------------------------------------------------------------------
peaks_near_BDP <- peaksNearBDP(ol$mergedPeaks, 
                    AnnotationData = ensembl.hs86.gene, 
                    MaxDistance = 5000) 
# MaxDistance will be translated into "bindingRegion = 
# c(-MaxDistance, MaxDistance)" internally

peaks_near_BDP$n.peaks
peaks_near_BDP$n.peaksWithBDP
peaks_near_BDP$percentPeaksWithBDP

head(peaks_near_BDP$peaksWithBDP, n = 2)

## -----------------------------------------------------------------------------
library(EnsDb.Hsapiens.v75)

ensembl.hs75.gene <- toGRanges(EnsDb.Hsapiens.v75, feature = "gene")

DNA5C <- system.file("extdata", 
                     "wgEncodeUmassDekker5CGm12878PkV2.bed.gz",
                     package="ChIPpeakAnno")
DNAinteractiveData <- toGRanges(gzfile(DNA5C))
# the example bed.gz file can also be downloaded from:
# https://hgdownload.cse.ucsc.edu/goldenpath/hg19/encodeDCC/wgEncodeUmassDekker5C/wgEncodeUmassDekker5CGm12878PkV2.bed.gz

peaks_near_enhancer <-  findEnhancers(peaks = ol$mergedPeaks,
                                      annoData = ensembl.hs75.gene, 
                                      DNAinteractiveData = DNAinteractiveData)
head(peaks_near_enhancer, n = 2)

## ----fig.cap = "Histogram showing enriched GO terms"--------------------------
library(org.Hs.eg.db)

enriched_go <- getEnrichedGO(annotatedPeak = ol_anno, 
                             orgAnn = "org.Hs.eg.db", 
                             feature_id_type = "ensembl_gene_id",
                             condense = TRUE)
enrichmentPlot(enriched_go)

## ----fig.cap = "Histogram showing enriched pathways"--------------------------
library(reactome.db)

enriched_pathway <- getEnrichedPATH(annotatedPeak = ol_anno,
                                    orgAnn = "org.Hs.eg.db", 
                                    pathAnn = "KEGGREST",
                                    maxP = 0.05)
enrichmentPlot(enriched_pathway)

# To remove the common suffix " - Homo sapiens (human)":
enrichmentPlot(enriched_pathway, label_substring_to_remove = " - Homo sapiens \\(human\\)")

## -----------------------------------------------------------------------------
library(BSgenome.Hsapiens.UCSC.hg38)

seq_around_peak <- getAllPeakSequence(ol$mergedPeaks, 
                                      upstream = 20,
                                      downstream = 20, 
                                      genome = BSgenome.Hsapiens.UCSC.hg38)
head(seq_around_peak, n = 2)

## ----fig.cap = "Histogram showing Z-score distribution for oligos of length 6"----
freqs <- oligoFrequency(BSgenome.Hsapiens.UCSC.hg38$chr1)
motif_summary <- oligoSummary(seq_around_peak, 
                              oligoLength = 6,
                              MarkovOrder = 3,
                              freqs = freqs,
                              quickMotif = TRUE)
zscore <- sort(motif_summary$zscore)
h <- hist(zscore, 
          breaks = 100, 
          main = "Histogram of Z-score")
text(x = zscore[length(zscore)], 
     y = h$counts[length(h$counts)] + 1, 
     labels = names(zscore[length(zscore)]), 
     adj = 0, 
     srt = 90)

## ----fig.cap = "Sequence log of detected motif 1", fig.small = TRUE-----------
library(motifStack)

pfm <- new("pfm", mat = motif_summary$motifs[[1]],
           name = "sample motif 1")
motifStack(pfm)

## ----warning = FALSE----------------------------------------------------------
tf1 <- toGRanges(system.file("extdata/TAF.broadPeak", package = "ChIPpeakAnno"),
                 format = "broadPeak")
tf2 <- toGRanges(system.file("extdata/Tead4.broadPeak", package = "ChIPpeakAnno"),
                 format = "broadPeak")
tf3 <- toGRanges(system.file("extdata/YY1.broadPeak", package = "ChIPpeakAnno"),
                 format = "broadPeak")

## ----results = "hide", fig.cap = "Venn diagram showing overlapping peaks for three TFs", fig.small = TRUE----
library(BSgenome.Hsapiens.UCSC.hg38)

overlapping_peaks <- findOverlapsOfPeaks(tf1, 
                                         tf2, 
                                         tf3, 
                                         connectedPeaks = "keepAll")
mean_peak_width <- mean(width(unlist(GRangesList(overlapping_peaks[["all.peaks"]]))))

total_binding_sites <- length(BSgenome.Hsapiens.UCSC.hg38[["chr2"]]) * 0.03 / mean_peak_width
venn1 <- makeVennDiagram(overlapping_peaks, 
                         totalTest = total_binding_sites, 
                         connectedPeaks = "keepAll", 
                         fill = c("#CC79A7", "#56B4E9", "#F0E442"),
                         col = c("#D55E00", "#0072B2", "#E69F00"),
                         cat.col = c("#D55E00", "#0072B2", "#E69F00"))

## -----------------------------------------------------------------------------
venn1[["p.value"]]

## ----fig.cap = "Heatmap of coverages for selected TFs", fig.height = 6, message = FALSE----
ol_tfs <- findOverlapsOfPeaks(tf1, tf2, tf3, 
                              connectedPeaks = "keepAll")
gr_ol_tfs <- ol_tfs$peaklist$`tf1///tf2///tf3`

TF_width <- width(gr_ol_tfs)
gr_ol_tfs_center <- reCenterPeaks(gr_ol_tfs, width = 4000)

extdata_path <- system.file("extdata", package = "ChIPpeakAnno")
bigWigs <- dir(extdata_path, "bigWig")
coverage_list <- sapply(file.path(extdata_path, bigWigs), 
                        import, # rtracklayer::import
                        format = "BigWig",
                        which = gr_ol_tfs_center,
                        as = "RleList")

names(coverage_list) <- gsub(".bigWig", "", bigWigs)

sig <- featureAlignedSignal(coverage_list, gr_ol_tfs_center)
# since the bigWig files are only a subset of the original files,
# filter to keep peaks that are with coverage data for all peak sets
keep <- rowSums(sig[[1]]) > 0 & rowSums(sig[[2]]) > 0 & rowSums(sig[[3]]) > 0
sig <- sapply(sig, function(x) x[keep, ], simplify = FALSE)
gr_ol_tfs_center <- gr_ol_tfs_center[keep]

featureAlignedHeatmap(sig, gr_ol_tfs_center,
                      upper.extreme=c(3, 0.5, 4))

## ----fig.cap = "Heatmap of coverages for selected TFs sorted by YY1 sample", fig.height = 6, message = FALSE----
featureAlignedHeatmap(sig, gr_ol_tfs_center,
                      upper.extreme=c(3, 0.5, 4),
                      sortBy = "YY1")

## ----fig.cap = "Distribution of coverage densities for selected TFs", message = FALSE----
featureAlignedDistribution(sig, gr_ol_tfs_center, 
                           type="l")

## ----warning = FALSE----------------------------------------------------------
library(ensembldb)
library(EnsDb.Hsapiens.v75)
data(myPeakList)
annoData <- annoGR(EnsDb.Hsapiens.v75)

# Step1: annotate peaks to the overlapping features, if "select = 'all'", multiple features can be assigned to a single peak.
anno_overlapping <- annotatePeakInBatch(myPeakList, 
                                        AnnotationData = annoData, 
                                        output = "overlapping", 
                                        select = "first")
anno_overlapping_non_na <- anno_overlapping[!is.na(anno_overlapping$feature)]

# Step2: annotate peaks that are without overlapping features to nearest features
myPeakList_non_overlapping <- myPeakList[!(names(myPeakList) %in% anno_overlapping_non_na$peak)]  
anno_nearest <- annotatePeakInBatch(myPeakList_non_overlapping,
                                    AnnotationData = annoData, 
                                    output = "nearestLocation", 
                                    select = "first")

# Step3: concatenate the two
anno_final <- c(anno_overlapping_non_na, anno_nearest)

## ----warning = FALSE----------------------------------------------------------
library(ChIPpeakAnno)
library(reshape2)

# Step1: read in two peak files
bed <- system.file("extdata", 
                   "MACS_output.bed",
                   package = "ChIPpeakAnno")
gff <- system.file("extdata", 
                   "GFF_peaks.gff", 
                   package = "ChIPpeakAnno")
gr1 <- toGRanges(bed, format = "BED", 
                 header = FALSE)
gr2 <- toGRanges(gff, format = "GFF", 
                 header = FALSE, skip = 3)
names(gr2) <- seq(length(gr2)) # add names to gr2 for Step4

# Step2: find overlapping peaks
ol <- findOverlapsOfPeaks(gr1, gr2)
peakNames <- ol$peaklist[['gr1///gr2']]$peakNames

# Step3: extract original peak names
peakNames <- melt(peakNames, 
                  value.name = "merged_peak_id") # reshape df
head(peakNames, n = 2)

peakNames <- cbind(peakNames[, 1], 
                   do.call(rbind, 
                           strsplit(as.character(peakNames[, 3]), "__")))

colnames(peakNames) <- c("merged_peak_id", "group", "peakName")
head(peakNames, n = 2)

# Step4: split by peak group
gr1_subset <- gr1[peakNames[peakNames[, "group"] %in% "gr1", "peakName"]]
gr2_subset <- gr2[peakNames[peakNames[, "group"] %in% "gr2", "peakName"]]
head(gr1_subset, n = 2)
head(gr2_subset, n = 2)

## -----------------------------------------------------------------------------
gr1_renamed <- ol$all.peaks$gr1
gr2_renamed <- ol$all.peaks$gr2
head(gr1_renamed, n = 2)
head(gr2_renamed, n = 2)

peakNames <- melt(ol$peaklist[['gr1///gr2']]$peakNames, 
                  value.name = "merged_peak_id")
gr1_subset <- gr1_renamed[peakNames[grepl("^gr1", peakNames[, 3]), 3]]
gr2_subset <- gr2_renamed[peakNames[grepl("^gr2", peakNames[, 3]), 3]]
head(gr1_subset, n = 2)
head(gr2_subset, n = 2)

## ----citation, echo = FALSE---------------------------------------------------
citation(package = "ChIPpeakAnno")

## ----sessionInfo, echo = FALSE------------------------------------------------
sessionInfo()

#' Annotated Peaks
#' 
#' TSS annotated putative STAT1-binding regions that are identified in
#' un-stimulated cells using ChIP-seq technology (Robertson et al., 2007)
#' 
#' obtained by data(TSS.human.GRCh37)
#' 
#' data(myPeakList)
#' 
#' annotatePeakInBatch(myPeakList, AnnotationData = TSS.human.GRCh37,
#' output="b", multiple=F)
#' 
#' @name annotatedPeak
#' @docType data
#' @format GRanges with slot start holding the start position of the peak, slot
#' end holding the end position of the peak, slot names holding the id of the
#' peak, slot strand holding the strands and slot space holding the chromosome
#' location where the peak is located. In addition, the following variables are
#' included.  \describe{ \item{list("feature")}{id of the feature such as
#' ensembl gene ID} \item{list("insideFeature")}{upstream: peak resides
#' upstream of the feature; downstream: peak resides downstream of the feature;
#' inside: peak resides inside the feature; overlapStart: peak overlaps with
#' the start of the feature; overlapEnd: peak overlaps with the end of the
#' feature; includeFeature: peak include the feature entirely}
#' \item{list("distancetoFeature")}{distance to the nearest feature such as
#' transcription start site} \item{list("start_position")}{start position of
#' the feature such as gene} \item{list("end_position")}{end position of the
#' feature such as the gene} }
#' @keywords datasets
#' @examples
#' 
#' data(annotatedPeak)
#' head(annotatedPeak, 4)  # show first 4 ranges
#' if (interactive() || Sys.getenv("USER")=="jou") {
#' y = annotatedPeak$distancetoFeature[!is.na(annotatedPeak$distancetoFeature)]
#' hist(as.numeric(as.character(y)), 
#'      xlab="Distance To Nearest TSS", main="", breaks=1000, 
#' ylim=c(0, 50), xlim=c(min(as.numeric(as.character(y)))-100, 
#' max(as.numeric(as.character(y)))+100))
#' }
#' 
"annotatedPeak"

formatStrand <- function(strand){
  strand <- as.character(strand)
  strand.levels=levels(as.factor(strand))
  strand.allowed.characters=c("1","-1","+","-", "*")
  if(any(!strand.levels %in% strand.allowed.characters))
  {
    warning("All the characters for strand, 
            other than '1', '-1', '+', '-' and '*', 
            will be converted into '*'.")
  }
  strand[strand== "-1"] <- "-"
  strand[strand== "1"] <- "+"
  strand[!strand %in% strand.allowed.characters] <- "*"
  strand
}
###clear seqnames, the format should be chr+NUM
#' @importFrom GenomeInfoDb `seqlevels<-` `seqlevelsStyle` `seqlevelsStyle<-`
formatSeqnames <- function(from, to) {
  forceFormatSeqnames <- function(from, to){
    message("\n Try to keep the seqname style consistent.")
    seql <- seqlevels(to)
    getPrefix <- function(x, seql){
      seql <- table(c(grepl(x, seql), "TRUE", "FALSE"))
      if(seql['TRUE'] > seql['FALSE']){
        prefix <- x
      }else{
        prefix <- ""
      }
      prefix
    }
    
    prefix <- ""
    for(i in c("chr", "Chr")){
      if(prefix==""){
        prefix <- getPrefix(i, seql)
      }
    }
    if(prefix!=""){
      if(length(seqlevels(from)[grepl("^(\\d+|V?I{0,3}|IV|MT|M|X|Y)$",
                                      seqlevels(from))])>0){
        if(is(from, "GRanges")){
          seqlevels(from)[grepl("^(\\d+|V?I{0,3}|IV|MT|M|X|Y)$", seqlevels(from))] <-
            paste(prefix,
                  seqlevels(from)[grepl("^(\\d+|V?I{0,3}|IV|MT|M|X|Y)$",
                                        seqlevels(from))], sep="")
          #seqlevels(from)[seqlevels(from)=="chrMT"] <- "chrM"
        }else{
          seqnames(from)[grepl("^(\\d+|V?I{0,3}|IV|MT|M|X|Y)$", seqnames(from))] <-
            paste(prefix,
                  seqnames(from)[grepl("^(\\d+|V?I{0,3}|IV|MT|M|X|Y)$",
                                       seqnames(from))], sep="")
          #seqnames(from)[seqnames(from)=="chrMT"] <- "chrM"
        }
      }
      #if(seqlevelsStyle(from)!="UCSC") seqlevelsStyle(from) <- "UCSC"
      seqlevels(from) <- sub("^chr", prefix, seqlevels(from), 
                             ignore.case = TRUE)
    }else{
      ## remove chr
      seqlevels(from) <- sub("^chr", prefix, seqlevels(from), 
                             ignore.case = TRUE)
    }
    from
  }
  seql <- seqlevelsStyle(to)
  seqf <- seqlevelsStyle(from)
  if(!seql[1] %in% seqf){
    tried <- try({
      seqlevelsStyle(from) <- seql[1]
    })
    if(inherits(tried, "try-error")){
      from <- forceFormatSeqnames(from, to)
    }
  }
  
  seql <- seqlevelsStyle(to)
  seqf <- seqlevelsStyle(from)
  if(length(intersect(seql, seqf))==0){
    from <- forceFormatSeqnames(from, to)
  }
  from
}

getRelationship <- function(queryHits, subjectHits){
    if(!inherits(queryHits, "GRanges")) 
        stop("queryHits must be an object of GRanges")
    if(!inherits(subjectHits, "GRanges")) 
        stop("subjectHits must be an object of GRanges")
    strand <- strand(subjectHits)=="-"
    FeatureStart <- as.numeric(ifelse(strand, 
                                      end(subjectHits), 
                                      start(subjectHits)))
    FeatureEnd <- as.numeric(ifelse(strand, 
                                    start(subjectHits), 
                                    end(subjectHits)))
    PeakStart <- as.numeric(ifelse(strand, end(queryHits), 
                                   start(queryHits)))
    PeakEnd <- as.numeric(ifelse(strand, start(queryHits), end(queryHits)))
    ss <- PeakStart - FeatureStart
    ee <- PeakEnd - FeatureEnd
    se <- PeakStart - FeatureEnd
    es <- PeakEnd - FeatureStart
    upstream <- ifelse(strand, es>0, es<0)
    downstream <- ifelse(strand, se<0, se>0)
    includeFeature <- ifelse(strand, (ss>=0 & ee<=0), (ss<=0 & ee>=0))
    overlap <- ss==0 & ee==0
    inside <- ifelse(strand, (ss<=0 & ee>=0), (ss>=0 & ee<=0))
    overlapStart <- 
        ifelse(strand, (ss>0 & es<=0 & ee>=0), (ss<0 & es>=0 & ee<=0))
    overlapEnd <- 
        ifelse(strand, (ss<0 & se>=0 & ee<=0), (ss>0 & se<=0 & ee>=0))
    insideFeature <- rep(NA, length(queryHits))
    insideFeature[as.logical(includeFeature)] <- "includeFeature"
    insideFeature[as.logical(inside)] <- "inside"
    insideFeature[as.logical(overlap)] <- "overlap"
    insideFeature[as.logical(overlapEnd)] <- "overlapEnd"
    insideFeature[as.logical(downstream)] <- "downstream"
    insideFeature[as.logical(overlapStart)] <- "overlapStart"
    insideFeature[as.logical(upstream)] <- "upstream"
    shortestDistance <- apply(cbind(ss, ee, se, es), 1,
                              function(.ele) min(abs(.ele)))
    shortestDistanceToStart <- apply(cbind(ss, es), 1, 
                                     function(.ele) min(abs(.ele)))
    data.frame(insideFeature=insideFeature, 
               shortestDistance=shortestDistance, 
               ss=ss,
               distanceToStart=shortestDistanceToStart)
}
annoScore <- function(queryHits, subjectHits){
    if(!inherits(queryHits, "GRanges")) 
        stop("queryHits must be an object of GRanges")
    if(!inherits(subjectHits, "GRanges")) 
        stop("subjectHits must be an object of GRanges")
    stopifnot(length(queryHits)==length(subjectHits))
    ## jaccard index of two range
    intersection <- pintersect(queryHits, subjectHits)
    totalSize <- punion(queryHits, subjectHits, fill.gap=TRUE, ignore.strand=TRUE)
    JaccardIndex <- width(intersection)/width(totalSize)
    JaccardIndex
}
trimPeakList <- function(Peaks, ignore.strand, by, keepMetadata=FALSE){
    if (!inherits(Peaks, "GRanges")) {
        stop("No valid Peaks passed in. It needs to be GRanges object")
    }
    if(ignore.strand) {
        .gr <- paste(seqnames(Peaks), start(Peaks), end(Peaks))
    }else{
        .gr <- paste(seqnames(Peaks), start(Peaks), 
                     end(Peaks), strand(Peaks))
    }
    if(any(duplicated(.gr)))
        stop("Inputs contains duplicated ranges. 
             please recheck your inputs.")
    if(any(is.null(names(Peaks))) || 
       any(is.na(names(Peaks))) || 
       any(duplicated(names(Peaks)))) {
        message("duplicated or NA names found. 
                Rename all the names by numbers.")
        names(Peaks) <- formatC(1:length(Peaks), 
                                width=nchar(length(Peaks)), 
                                flag='0')
    }
    feature <- mcols(Peaks)$feature
    if(!keepMetadata) mcols(Peaks) <- NULL
    if(by=="feature") {
        if(is.null(feature)) 
            stop("Need feature metadata for each inputs")
        mcols(Peaks)$feature <- feature
    }
    Peaks
}

#' @importFrom S4Vectors queryHits subjectHits
vennCounts <- function(PeaksList, n, names,
                       maxgap=-1L, minoverlap=0L,
                       by=c("region", "feature", "base"), 
                       ignore.strand=TRUE, 
                       connectedPeaks=c("min", "merge", "keepAll")){
    NAME_conn_string <- "___conn___"
    PeaksList<-lapply(PeaksList, trimPeakList, by=by, 
                      ignore.strand=ignore.strand, keepMetadata=FALSE)
    if(by=="base"){
        # try coverage and then split
        # problem for coverage: can not seperate for different source
        for(i in 1:n){
            names(PeaksList[[i]]) <- 
                paste(names[i], names(PeaksList[[i]]), sep=NAME_conn_string)
        }
        names(PeaksList) <- NULL
        Peaks <- unlist(GRangesList(PeaksList))
        #if(ignore.strand) strand(Peaks) <- "*"
        #cov <- coverage(Peaks)
        disj <- disjoin(Peaks, ignore.strand=ignore.strand)
        ol <- findOverlaps(Peaks, disj, ignore.strand=ignore.strand)
        ol.query <- Peaks[queryHits(ol)]
        ol.subject <- disj[subjectHits(ol)]
        group <- gsub(paste(NAME_conn_string, ".*$", sep=""), 
                      "", 
                      names(ol.query))
        subject <- subjectHits(ol)
        ncontrasts <- n
        noutcomes <- 2^ncontrasts
        outcomes <- matrix(0,noutcomes,ncontrasts)
        colnames(outcomes) <- names
        for (j in 1:ncontrasts)
            outcomes[,j] <- rep(0:1,times=2^(j-1),each=2^(ncontrasts-j))
        gps <- split(group, subject)
        xlist <- list()
        for(i in 1:ncontrasts)
            xlist[[i]] <- 
            factor(as.numeric(sapply(gps, 
                                     function(.ele) 
                                         names[ncontrasts-i+1] %in% .ele)), 
                   levels=c(0,1))
        counts <- do.call(cbind, xlist)
        counts <- counts[, ncontrasts:1]
        counts <- counts - 1
        counts <- apply(counts, 1, base::paste, collapse="")
        idx <- apply(outcomes, 1, base::paste, collapse="")
        wids <- width(disj[as.numeric(names(gps))])
        wids <- split(wids, counts)
        wids <- wids[idx]
        names(wids) <- idx
        counts <- sapply(wids, sum)
        venn_cnt <- structure(cbind(outcomes, Counts=counts), 
                              class="VennCounts")
        return(list(venn_cnt=venn_cnt, xlist=NULL, 
                    PeaksList=PeaksList, all=all, Peaks=Peaks))
    }
    if(by=="feature"){
        features <- lapply(PeaksList, 
                           function(.ele) unique(as.character(.ele$feature)))
        all_features <- unique(unlist(features))
        all <- lapply(features, function(.f)  all_features %in% .f)
        all <- do.call(cbind, all)
        rownames(all) <- all_features
        for(j in 1:n){
            all[,j] <- ifelse(all[,j], names[j], NA)
        }
        all <- split(all, rownames(all))
        Peaks <- NULL
    }else{
        ##get all merged peaks
        for(i in 1:n){
            names(PeaksList[[i]]) <- 
                paste(names[i], names(PeaksList[[i]]), sep=NAME_conn_string)
        }
        names(PeaksList) <- NULL
        Peaks <- unlist(GRangesList(PeaksList))
        if(ignore.strand) {
            Peaks$old_strand_HH <- strand(Peaks)
            strand(Peaks) <- "*"
        }
        
        if(length(Peaks)<10000){
            ol <- as.data.frame(findOverlaps1(Peaks, maxgap=maxgap, 
                                             minoverlap=minoverlap, 
                                             select="all",
                                             drop.self=TRUE, 
                                             drop.redundant=TRUE))
            ##all connected peaks
            olm <- cbind(names(Peaks[ol[,1]]), names(Peaks[ol[,2]]))
            ## remove the overlaps from same list
            olm <- olm[sub(paste0(NAME_conn_string, ".*?$"), "", names(Peaks[ol[,1]]))!=
                         sub(paste0(NAME_conn_string, ".*?$"), "", names(Peaks[ol[,2]])), , drop=FALSE]
            edgeL <- c(split(olm[,2], olm[,1]), split(olm[,1], olm[,2]))
            nodes <- unique(as.character(olm))
            ##use graph to extract all the connected peaks
            gR <- new("graphNEL", nodes=nodes, edgeL=edgeL)
            Merged <- connectedComp(ugraph(gR))
        }else{
            Peaks.list <- split(Peaks, seqnames(Peaks))
            Merged <- lapply(Peaks.list, function(.peaks.list){
                .ol <- findOverlaps1(.peaks.list,
                                    maxgap=maxgap, minoverlap=minoverlap, 
                                    select="all",
                                    drop.self=TRUE, drop.redundant=TRUE)
                olm <- cbind(names(.peaks.list[queryHits(.ol)]), 
                             names(.peaks.list[subjectHits(.ol)]))
                ## remove the overlaps from same list
                olm <- olm[sub(paste0(NAME_conn_string, ".*?$"), "", names(.peaks.list[queryHits(.ol)]))!=
                             sub(paste0(NAME_conn_string, ".*?$"), "", names(.peaks.list[subjectHits(.ol)])), , drop=FALSE]
                edgeL <- c(split(olm[,2], olm[,1]), split(olm[,1], olm[,2]))
                nodes <- unique(as.character(olm))
                ##use graph to extract all the connected peaks
                gR <- new("graphNEL", nodes=nodes, edgeL=edgeL)
                connectedComp(ugraph(gR))
            })
            Merged <- unlist(Merged, recursive=FALSE)
            nodes <- unique(as.character(unlist(Merged)))
            rm(Peaks.list)
        }
        
        Left <- as.list(names(Peaks)[!names(Peaks) %in% nodes])
        all <- c(Merged, Left)
    }
    ##venn count
    ncontrasts <- n
    noutcomes <- 2^ncontrasts
    outcomes <- matrix(0,noutcomes,ncontrasts)
    colnames(outcomes) <- names
    for (j in 1:ncontrasts)
        outcomes[,j] <- rep(0:1,times=2^(j-1),each=2^(ncontrasts-j))
    
    xlist <- list()
    xlist1 <- list()
    ## time consuming step, FIXME!!
    ## Fixed by paste connection string before lapply 
    NAME_conn_string_wild <- paste(NAME_conn_string, ".*?$", sep="")
    all.df <- data.frame(rnames=unlist(all), 
                    groupID=rep(1:length(all), sapply(all, length)))
    all.df$tfname <- gsub(NAME_conn_string_wild, "", all.df$rnames)
    all.df.tbl <- table(all.df[, -1])
    for (i in 1:ncontrasts){
#         NAME_conn_string_contrasts_wild <- paste("^", 
#                                                  names[ncontrasts-i+1], 
#                                                  NAME_conn_string,
#                                                  sep="")
#         xlist[[i]] <- factor(as.numeric(unlist(lapply(all, function(.ele) 
#             any(grepl(NAME_conn_string_contrasts_wild, .ele))))),
#             levels=c(0,1))
        xlist[[i]] <- 
            factor(as.numeric(all.df.tbl[, names[ncontrasts-i+1]]>0), 
                   levels=c(0, 1))
        if(connectedPeaks=="merge"){
#             xlist1[[i]] <- factor(as.numeric(unlist(lapply(all, function(.ele) 
#                 any(grepl(NAME_conn_string_contrasts_wild, .ele))))),
#                 levels=c(0,1))
            xlist1[[i]] <- xlist[[i]]
        }else{ ## increase the efficency be change list to dataframe
#             xlist1[[i]] <- 
#                 factor(as.numeric(unlist(lapply(all, function(.ele) {
#                 ##count involved nodes in each group
#                 .ele <- gsub(NAME_conn_string_wild, "", .ele)
#                 .ele <- table(.ele)
#                 rep(names[ncontrasts-i+1] %in% names(.ele), min(.ele))
#             }))), levels=c(0,1))
            xlist1[[i]] <- 
                factor(as.numeric(rep(all.df.tbl[, names[ncontrasts-i+1]]>0, 
                                      apply(all.df.tbl, 1, function(.e) min(.e[.e>0])))), 
                       levels=c(0, 1))
        }
    }
    
    counts <- as.vector(table(xlist1))
    venn_cnt <- structure(cbind(outcomes, Counts=counts), class="VennCounts")
    
    if(connectedPeaks=="keepAll"){
        NAME_conn_string_wild <- paste(NAME_conn_string, ".*$", sep="")
        all.m <- lapply(all, 
                        function(.ele){gsub(NAME_conn_string_wild, "", .ele)})
        all.m <- all.m[sapply(all.m, function(.ele) length(unique(.ele))>1)]
        all.count <- ifelse(rowSums(outcomes)>1, NA, counts)
        all.count <- all.count * outcomes
        for(j in 1:ncol(all.count)){
            ylist <- list()
            for(i in 1:ncontrasts){
                ylist[[i]] <- 
                    factor(as.numeric(unlist(lapply(all.m, function(.ele){
                    .ele <- table(.ele)
                    times <- .ele[colnames(all.count)[j]]
                    if(is.na(times)) times <- 0
                    rep(names[ncontrasts-i+1] %in% names(.ele), times)
                }))), levels=c(0,1))
            }
            all.count[is.na(all.count[,j]),j] <- 
                as.vector(table(ylist))[is.na(all.count[,j])]
        }
        colnames(all.count) <- paste("count", colnames(all.count), sep=".")
        venn_cnt <- structure(cbind(outcomes, Counts=counts, all.count), 
                              class="VennCounts")
    }
    
    return(list(venn_cnt=venn_cnt, xlist=xlist, 
                PeaksList=PeaksList, all=all, 
                Peaks=Peaks))
}

findOverlaps1 <- function(query, subject, maxgap=-1L,
                          minoverlap=0L, ...){
  if(minoverlap[1]>0 && minoverlap[1]<1){
    if(missing(subject)){
      hits <- findOverlaps(query = query, 
                           minoverlap = 0L,
                           maxgap = -1L,
                           ...)
      overlaps <- pintersect(query[queryHits(hits)],
                             query[subjectHits(hits)],
                             ignore.strand = TRUE)
      percentOverlap0 <- width(overlaps)/width(query[queryHits(hits)])
      percentOverlap1 <- width(overlaps)/width(query[subjectHits(hits)])
      percentOverlap <- ifelse(
        percentOverlap0>percentOverlap1,
        percentOverlap0, percentOverlap1
      )
    }else{
      hits <- findOverlaps(query = query, 
                           subject = subject,
                           minoverlap = 0L,
                           maxgap = -1L,
                           ...)
      overlaps <- pintersect(query[queryHits(hits)],
                             subject[subjectHits(hits)],
                             ignore.strand = TRUE)
      percentOverlap0 <- width(overlaps)/width(query[queryHits(hits)])
      percentOverlap1 <- width(overlaps)/width(subject[subjectHits(hits)])
      percentOverlap <- ifelse(
        percentOverlap0>percentOverlap1,
        percentOverlap0, percentOverlap1
      )
    }
    hits[percentOverlap>=minoverlap]
  }else{
    if(missing(subject)){
      findOverlaps(query = query,
                   maxgap = maxgap,
                   minoverlap = minoverlap,
                   ...)
    }else{
      findOverlaps(query = query,
                   subject = subject,
                   maxgap = maxgap,
                   minoverlap = minoverlap,
                   ...)
    }
  }
}
#' TxDb object to GRanges
#' 
#' convert TxDb object to GRanges
#' @param ranges an Txdb object
#' @param feature feature type, could be geneModel, gene, exon, 
#' transcript, CDS, fiveUTR, threeUTR, microRNA, and tRNA
#' @param OrganismDb org db object
#' @importFrom GenomicFeatures exonsBy cdsBy fiveUTRsByTranscript 
#' threeUTRsByTranscript genes exons transcripts cds tRNAs
#' @importFrom AnnotationDbi select
TxDb2GR <- function(ranges, feature, OrganismDb){
    switch(feature,
           geneModel={
               exon <- exonsBy(ranges, "tx", use.names=TRUE)
               tids <- rep(names(exon), elementNROWS(exon))
               exon <- unlist(exon, use.names=FALSE)
               if(length(exon)){
                   exon$tx_name <- tids
                   exon$feature_type <- "ncRNA"
                   cds <- cdsBy(ranges, "tx", use.names=TRUE)
                   tids <- 
                       rep(names(cds), elementNROWS(cds))
                   cds <- unlist(cds)
                   if(length(cds)){
                       mcols(cds) <- NULL
                       cds$tx_name <- tids
                       cds$feature_type <- "CDS"
                   }
                   utr5 <- 
                       fiveUTRsByTranscript(ranges,
                                            use.names=TRUE)
                   tids <- rep(names(utr5), 
                               elementNROWS(utr5))
                   utr5 <- unlist(utr5)
                   if(length(utr5)){
                       mcols(utr5) <- NULL
                       utr5$tx_name <- tids
                       utr5$feature_type <- "5UTR"
                   }
                   utr3 <- 
                       threeUTRsByTranscript(ranges,
                                             use.names=TRUE)
                   tids <- rep(names(utr3), 
                               elementNROWS(utr3))
                   utr3 <- unlist(utr3)
                   if(length(utr3)){
                       mcols(utr3) <- NULL
                       utr3$tx_name <- tids
                       utr3$feature_type <- "3UTR"
                   }
                   anno <- c(cds, utr5, utr3)
                   left <- exon[!(exon$tx_name %in% anno$tx_name)]
                   ##check logical, anno covered all annotation
                   right <- exon[exon$tx_name %in% anno$tx_name]
                   rd1 <- reduce(anno)
                   rd2 <- reduce(right)
                   if(!identical(rd1, rd2)){
                       stop("some annotation is missing! bug!")
                   }
                   mcols(left) <- 
                       mcols(left)[, 
                                   c("tx_name", "feature_type")]
                   exon <- c(left, anno) ## merge ncRNA with anno
                   if(!missing(OrganismDb)){
                       if(inherits(OrganismDb, c("OrganismDb"))){
                         tried <- try({
                           symbol <- select(OrganismDb, 
                                            keys=unique(exon$tx_name),
                                            columns="SYMBOL",
                                            keytype="TXNAME")
                           })
                         if(inherits(tried, "try-error")){
                           symbol <- NULL
                         }
                         if(length(symbol)>0){
                           exon$symbol <- 
                             symbol[match(exon$tx_name, 
                                          symbol[, 1]),
                                    "SYMBOL"]
                         }
                       }else{
                           message("OrganismDb must be an object of OrganismDb")
                       }
                   }
                   ## sort exon
                   exon <- exon[order(exon$tx_name)]
                   ### get each tx_name first start pos
                   tids <- rle(exon$tx_name)
                   tids$values <- 
                       tapply(start(exon), exon$tx_name, min)
                   tids <- inverse.rle(tids)
                   exon <- 
                       exon[order(as.character(seqnames(exon)),
                                  tids, 
                                  start(exon))]
                   names(exon) <- formatC(1:length(exon), 
                                          width=nchar(as.character(length(exon))),
                                          flag="0")
               }
               exon
           },
           gene={
               g <- genes(ranges, columns="gene_id")
               names(g) <- g$gene_id
               g$gene_id <- NULL
               g
           },
           exon={
               e <- exons(ranges, 
                          columns=c("exon_id", 
                                    "tx_name", 
                                    "gene_id"))
               if(length(e)){
                   names(e) <- e$exon_id
                   e$exon_id <- NULL
               }
               e
           },
           transcript={
               t <- transcripts(ranges,
                                columns=c("tx_id",
                                          "tx_name",
                                          "gene_id"))
               if(length(t)){
                   names(t) <- t$tx_id
                   t$tx_id <- NULL
               }
               t
           },
           CDS={
               c <- cds(ranges, 
                        columns=c("cds_id",
                                  "tx_name",
                                  "gene_id"))
               if(length(c)){
                   names(c) <- c$cds_id
                   c$cds_id <- NULL
               }
               c
           },
           fiveUTR={
               u <- fiveUTRsByTranscript(ranges,
                                         use.name=TRUE)
               tids <- rep(names(u), elementNROWS(u))
               u <- unlist(u)
               if(length(u)){
                   u$tx_name <- tids
                   names(u) <- make.names(names(u), 
                                          unique=TRUE)
               }
               u
           },
           threeUTR={
               u <- threeUTRsByTranscript(ranges,
                                          use.name=TRUE)
               tids <- rep(names(u), elementNROWS(u))
               u <- unlist(u)
               if(length(u)){
                   u$tx_name <- tids
                   names(u) <- make.names(names(u), 
                                          unique=TRUE)
               }
               u
           },
           tRNA=tRNAs(ranges)
    )
}

#' EnsDb object to GRanges
#' 
#' convert EnsDb object to GRanges
#' @param ranges an EnsDb object
#' @param feature feature type, could be disjointExons, gene, exon and 
#' transcript
#' @importFrom GenomicFeatures exonicParts
#' @importFrom GenomeInfoDb `seqlevelsStyle<-`
EnsDb2GR <- function(ranges, feature){
    gr <- 
        switch(feature,
               disjointExons={
                   e <- exonicParts(ranges, linked.to.single.gene.only=TRUE)
                   l <- length(e)
                   names(e) <- make.names(
                       formatC(seq_len(l), 
                               width=nchar(as.character(l)),
                               flag="0"))
                   e
               },
               gene={
                   g <- genes(ranges, columns=c("gene_id",
                                                "gene_name"))
                   names(g) <- g$gene_id
                   g$gene_id <- NULL
                   g
               },
               exon={
                   e <- exons(ranges, 
                              columns=c("exon_id", 
                                        "tx_id", 
                                        "gene_id",
                                        "gene_name"))
                   if(length(e)){
                       names(e) <- make.names(names(e), 
                                              unique=TRUE,
                                              allow_=TRUE)
                   }
                   e
               },
               transcript={
                   t <- transcripts(ranges,
                                    columns=c("tx_id",
                                              "gene_id",
                                              "gene_name"))
                   if(length(t)){
                       names(t) <- make.names(names(t), 
                                              unique=TRUE,
                                              allow_=TRUE)
                   }
                   t
               }
        )
    #seqlevelsStyle(gr) <- "UCSC"
    gr <- formatSeqnames(gr, GRanges("chr1", IRanges(1, 2)))
    return(gr)
}


#' @importFrom stats fisher.test
removeAncestor <- function(goenrichments, onto, cutoffPvalue){
  stopifnot(colnames(goenrichments)[1] %in% c("go.id")) ## confirm the result is from getEnrichedGO
  stopifnot(onto %in% c("BP", "MF", "CC"))
  if(nrow(goenrichments)<2){
    return(goenrichments)
  }
  offsprings <- mget(as.character(goenrichments$go.id), 
                     get(paste0("GO", onto, "CHILDREN")),
                     ifnotfound = NA)
  offsprings <- lapply(offsprings, function(.ele){
    .ele <- .ele[!is.na(.ele)]
    .ele[.ele %in% as.character(goenrichments$go.id)]
  })
  keep <- mapply(function(.ele, offspring){
    if(length(offspring)<1){
      return(TRUE)
    }
    all(sapply(offspring, function(.e){
      cnt <- goenrichments[goenrichments$go.id %in% c(.ele, .e), 
                           c("count.InDataset", "count.InGenome")]
      cnt[, 2] <- cnt[, 2] - cnt[, 1]
      fisher.test(cnt, alternative = "less")$p.value < cutoffPvalue
    }))
  }, names(offsprings), offsprings)
  goenrichments[keep, , drop=FALSE]
}

getGOLevel <- function(goid, onto, level=0){
  if(any(goid=="all")){
    return(level)
  }
  parent <- mget(goid, get(paste0("GO", onto, "PARENTS")))
  parent <- unique(unlist(parent))
  level <- level + 1
  if(any(parent=="all")){
    return(level)
  }else{
    return(getGOLevel(parent, onto, level))
  }
}

filterByLevel <- function(goenrichments, onto, level=4){
  if(level<2){
    warning("keepByLevel must be a number lager than 1.
            Not used parameter keepByLevel")
    return(goenrichments)
  }
  stopifnot(colnames(goenrichments)[1] %in% c("go.id")) ## confirm the result is from getEnrichedGO
  stopifnot(onto %in% c("BP", "MF", "CC"))
  levels <- sapply(as.character(goenrichments$go.id), getGOLevel, onto=onto)
  goenrichments[levels <= level, , drop=FALSE]
}

swapList <- function(x){
  stopifnot(is.list(x))
  null <- sapply(x, function(.ele){
    stopifnot(is.list(.ele))
  })
  levelsA <- names(x)
  levelsB <- unique(unlist(sapply(x, names, simplify = FALSE)))
  y <- as.list(levelsB)
  names(y) <- levelsB
  for(.lB in levelsB){
    y[[.lB]] <- list()
  }
  for(.lA in levelsA){
    for(.lB in names(x[[.lA]])){
      y[[.lB]][[.lA]] <- x[[.lA]][[.lB]]
    }
  }
  y
}


filterByOverlaps <- function(x, ranges, ignore.strand=FALSE, 
                             minoverlap=1L, ...){
  y <- disjoin(c(x, ranges), ignore.strand=ignore.strand)
  ranges <- subsetByOverlaps(y, ranges, ignore.strand=ignore.strand)
  x <- subsetByOverlaps(y, x, ignore.strand=ignore.strand)
  subsetByOverlaps(x, ranges = ranges, invert = TRUE, 
                   ignore.strand=ignore.strand,
                   minoverlap = minoverlap,
                   ...)
}

#' Obtain the distance to the nearest TSS, miRNA, and/or exon for a list of 
#' peaks
#' 
#' Obtain the distance to the nearest TSS, miRNA, exon et al for a list of peak 
#' locations leveraging IRanges and biomaRt package
#' 
#' 
#' @param myPeakList A \link[GenomicRanges:GRanges-class]{GRanges} object
#' @param mart A mart object, used if AnnotationData is not supplied, see
#' useMart of bioMaRt package for details
#' @param featureType A charcter vector used with mart argument if
#' AnnotationData is not supplied; choose from "TSS", "miRNA" or "Exon"
#' @param AnnotationData A \link[GenomicRanges:GRanges-class]{GRanges} or
#' \link{annoGR} object. It can be obtained from the function getAnnotation or
#' customized annotation of class GRanges containing additional variable:
#' strand (1 or + for plus strand and -1 or - for minus strand). Pre-compliled
#' annotations, such as TSS.human.NCBI36, TSS.mouse.NCBIM37, TSS.rat.RGSC3.4
#' and TSS.zebrafish.Zv8, are provided by this package (attach them with data()
#' function). Another method to provide annotation data is to obtain through
#' biomaRt in real time by using the mart and featureType option
#' @param output \describe{ 
#' \item{nearestLocation (default)}{will output the nearest features calculated 
#' as PeakLoc - FeatureLocForDistance; when selected, the output can consist of 
#' both "strictly nearest features (non-overlapping)" and "overlapping features"
#' as long as they are the nearest}
#' \item{overlapping}{will output overlapping features with maximum gap
#' specified as maxgap between peak range and feature range; it is possible for 
#' a peak to be annotated with zero ("NA" will be returned) or multiple 
#' overlapping features if exist}
#' \item{both}{will output all the nearest features as well as any features
#' that overlap with the peak that is not the nearest}
#' \item{shortestDistance}{will output the features with the shortest distance;
#' the "shortest distance" is determined from either ends of the feature to 
#' either ends of the peak} 
#' \item{upstream&inside}{will output all upstream and overlapping features with 
#' maximum gap} 
#' \item{inside&downstream}{will output all downstream and overlapping features 
#' with maximum gap}
#' \item{upstream}{will output all upstream features with maximum gap} 
#' \item{downstream}{will output all downstream features with maximum gap} 
#' \item{upstreamORdownstream}{will output all upstream features with maximum 
#' gap or downstream with maximum gap} 
#' \item{nearestBiDirectionalPromoters}{will use \link{annoPeaks} to
#' annotate peaks. Nearest promoters from both direction of the peaks (strand
#' is considered). It will report bidirectional promoters if there are
#' promoters in both directions in the given region (defined by bindingRegion).
#' Otherwise, it will report the closest promoter in one direction.} }
#' @param multiple Not applicable when output is nearest. TRUE: output multiple
#' overlapping features for each peak. FALSE: output at most one overlapping
#' feature for each peak. This parameter is kept for backward compatibility,
#' please use select.
#' @param maxgap The maximum \emph{gap} that is allowed between 2 ranges for
#' the ranges to be considered as overlapping. The \emph{gap} between 2 ranges
#' is the number of positions that separate them. The \emph{gap} between 2
#' adjacent ranges is 0. By convention when one range has its start or end
#' strictly inside the other (i.e. non-disjoint ranges), the \emph{gap} is
#' considered to be -1.
#' @param PeakLocForDistance Specify the location of peak for calculating
#' distance,i.e., middle means using middle of the peak to calculate distance
#' to feature, start means using start of the peak to calculate the distance to
#' feature, endMinusStart means using the end of the peak to calculate the 
#' distance to features on plus strand and the start of the peak to calculate 
#' the distance to features on minus strand. To be compatible with previous 
#' version, by default using start
#' @param FeatureLocForDistance Specify the location of feature for calculating
#' distance,i.e., middle means using middle of the feature to calculate
#' distance of peak to feature, start means using start of the feature to
#' calculate the distance to feature, TSS means using start of feature when
#' feature is on plus strand and using end of feature when feature is on minus
#' strand, geneEnd means using end of feature when feature is on plus strand
#' and using start of feature when feature is on minus strand. To be compatible
#' with previous version, by default using TSS
#' @param select "all" may return multiple overlapping peaks, "first" will
#' return the first overlapping peak, "last" will return the last overlapping
#' peak and "arbitrary" will return one of the overlapping peaks.
#' @param ignore.strand When set to TRUE, the strand information is ignored in
#' the annotation. Unless you have stranded peaks and you are interested in 
#' annotating peaks to the features in the same strand only, you should just 
#' use the default setting ignore.strand = TRUE.
#' @param bindingRegion Annotation range used for \link{annoPeaks}, which is a
#' vector with two integer values, default to c (-5000, 5000). The first one
#' must be no bigger than 0. And the sec ond one must be no less than 1. Once
#' bindingRegion is defined, annotation will based on \link{annoPeaks}. Here is
#' how to use it together with the parameter output and FeatureLocForDistance.
#' \itemize{ \item To obtain peaks with nearest bi-directional promoters within
#' 5kb upstream and 3kb downstream of TSS, set output =
#' "nearestBiDirectionalPromoters" and bindingRegion = c(-5000, 3000) \item To
#' obtain peaks within 5kb upstream and up to 3kb downstream of TSS within the
#' gene body, set output="overlapping", FeatureLocForDistance="TSS" and
#' bindingRegion = c(-5000, 3000) \item To obtain peaks up to 5kb upstream
#' within the gene body and 3kb downstream of gene/Exon End, set
#' output="overlapping", FeatureLocForDistance="geneEnd" and bindingRegion =
#' c(-5000, 3000) \item To obtain peaks from 5kb upstream to 3kb downstream of
#' genes/Exons, set output="overlapping", bindingType = "fullRange" and
#' bindingRegion = c(-5000, 3000) } For details, see \link{annoPeaks}.
#' @param ... Parameters could be passed to \link{annoPeaks}
#' @return An object of \link[GenomicRanges:GRanges-class]{GRanges} with slot
#' start holding the start position of the peak, slot end holding the end
#' position of the peak, slot space holding the chromosome location where the
#' peak is located, slot rownames holding the id of the peak. In addition, the
#' following variables are included.  \item{list("feature")}{id of the feature
#' such as ensembl gene ID} \item{list("insideFeature")}{upstream: peak resides
#' upstream of the feature; downstream: peak resides downstream of the feature;
#' inside: peak resides inside the feature; overlapStart: peak overlaps with
#' the start of the feature; overlapEnd: peak overlaps with the end of the
#' feature; includeFeature: peak include the feature entirely}
#' \item{list("distancetoFeature")}{distance to the nearest feature such as
#' transcription start site.  By default, the distance is calculated as the
#' distance between the start of the binding site and the TSS that is the gene
#' start for genes located on the forward strand and the gene end for genes
#' located on the reverse strand. The user can specify the location of peak and
#' location of feature for calculating this}
#' \item{list("start_position")}{start position of the feature such as gene}
#' \item{list("end_position")}{end position of the feature such as the gene}
#' \item{list("strand")}{1 or + for positive strand and -1 or - for negative
#' strand where the feature is located} \item{list("shortestDistance")}{The
#' shortest distance from either end of peak to either end the feature.  }
#' \item{list("fromOverlappingOrNearest")}{Relevant only when output is set to 
#' "both". If "nearestLocation": indicates this feature's start (feature's end 
#' for features from minus strand) is the closest to the peak start ("strictly 
#' nearest" or "nearest overlapping"); if "Overlapping": indicates this feature 
#' overlaps with this peak although it is not the nearest (non-nearest 
#' overlapping) }
#' @author Lihua Julie Zhu, Jianhong Ou
#' @seealso \link{getAnnotation}, \link{findOverlappingPeaks},
#' \link{makeVennDiagram}, \link{addGeneIDs}, \link{peaksNearBDP},
#' \link{summarizePatternInPeaks}, \link{annoGR}, \link{annoPeaks}
#' @references 1. Zhu L.J. et al. (2010) ChIPpeakAnno: a Bioconductor package
#' to annotate ChIP-seq and ChIP-chip data. BMC Bioinformatics 2010,
#' 11:237doi:10.1186/1471-2105-11-237
#' 
#' 2. Zhu L (2013). "Integrative analysis of ChIP-chip and ChIP-seq dataset."
#' In Lee T and Luk ACS (eds.), Tilling Arrays, volume 1067, chapter 4, pp.
#' -19.  Humana Press. http://dx.doi.org/10.1007/978-1-62703-607-8_8
#' @keywords misc
#' @export
#' @import IRanges
#' @import GenomicRanges
#' @importFrom GenomeInfoDb seqlevels
#' @importFrom BiocGenerics start end width strand
#' @importFrom S4Vectors mcols
#' @importFrom dplyr %>% filter group_by top_n
#' @examples
#' 
#' 
#'     ## example 1: annotate myPeakList by TxDb or EnsDb.
#'     data(myPeakList)
#'     library(ensembldb)
#'     library(EnsDb.Hsapiens.v75)
#'     annoData <- annoGR(EnsDb.Hsapiens.v75)
#'     annotatePeak = annotatePeakInBatch(myPeakList[1:6], AnnotationData=annoData)
#'     annotatePeak
#'     
#'     ## example 2: annotate myPeakList (GRanges) 
#'     ## with TSS.human.NCBI36 (Granges)
#'     data(TSS.human.NCBI36)
#'     annotatedPeak = annotatePeakInBatch(myPeakList[1:6], 
#'                                         AnnotationData=TSS.human.NCBI36)
#'     annotatedPeak
#'     
#'     ## example 3: you have a list of transcription factor biding sites from 
#'     ## literature and are interested in determining the extent of the overlap 
#'     ## to the list of peaks from your experiment. Prior calling the function 
#'     ## annotatePeakInBatch, need to represent both dataset as GRanges 
#'     ## where start is the start of the binding site, end is the end of the 
#'     ## binding site, names is the name of the binding site, space and strand 
#'     ## are the chromosome name and strand where the binding site is located.
#'     
#'     myexp <- GRanges(seqnames=c(6,6,6,6,5,4,4), 
#'                      IRanges(start=c(1543200,1557200,1563000,1569800,
#'                                      167889600,100,1000),
#'                              end=c(1555199,1560599,1565199,1573799,
#'                                    167893599,200,1200),
#'                              names=c("p1","p2","p3","p4","p5","p6", "p7")), 
#'                      strand="+")
#'     literature <- GRanges(seqnames=c(6,6,6,6,5,4,4), 
#'                           IRanges(start=c(1549800,1554400,1565000,1569400,
#'                                           167888600,120,800),
#'                                   end=c(1550599,1560799,1565399,1571199,
#'                                         167888999,140,1400),
#'                                   names=c("f1","f2","f3","f4","f5","f6","f7")),
#'                           strand=rep(c("+", "-"), c(5, 2)))
#'     annotatedPeak1 <- annotatePeakInBatch(myexp, 
#'                                           AnnotationData=literature)
#'     pie(table(annotatedPeak1$insideFeature))
#'     annotatedPeak1
#'     ### use toGRanges or rtracklayer::import to convert BED or GFF format
#'     ###  to GRanges before calling annotatePeakInBatch
#'     test.bed <- data.frame(space=c("4", "6"), 
#'                            start=c("100", "1000"),
#'                            end=c("200", "1100"), 
#'                            name=c("peak1", "peak2"))
#'     test.GR = toGRanges(test.bed)
#'     annotatePeakInBatch(test.GR, AnnotationData = literature)
#'  
#'  library(testthat)
#'   peak <- GRanges(seqnames = "chr1", 
#'                   IRanges(start = 24736757, end=24737528,
#'                           names = "testPeak"))
#'   data(TSS.human.GRCh37)
#'   TSS.human.GRCh37[names(TSS.human.GRCh37)== "ENSG00000001461"]
#'   # GRanges object with 1 range and 1 metadata column:
#'   # seqnames            ranges strand |            description
#'   #<Rle>         <IRanges>  <Rle> |            <character>
#'   # ENSG00000001461        1 24742285-24799466      + | NIPA-like domain con..
#'   peak
#'   #GRanges object with 1 range and 0 metadata columns:
#'   #   seqnames            ranges strand
#'   #<Rle>         <IRanges>  <Rle>
#'   #  testPeak     chr1 24736757-24737528      *
#'   TSS.human.GRCh37[names(TSS.human.GRCh37)== "ENSG00000001460"]
#'   #GRanges object with 1 range and 1 metadata column:
#'   #   seqnames            ranges strand |            description
#'   #<Rle>         <IRanges>  <Rle> |            <character>
#'   #   ENSG00000001460        1 24683490-24743424      - | UPF0490 protein C1or..
#'   ap <- annotatePeakInBatch(peak, Annotation=TSS.human.GRCh37, 
#'                             PeakLocForDistance = "start")
#'   stopifnot(ap$feature=="ENSG00000001461")
#'   ap <- annotatePeakInBatch(peak, Annotation=TSS.human.GRCh37,
#'                             PeakLocForDistance = "end")
#'   stopifnot(ap$feature=="ENSG00000001461")
#'   ap <- annotatePeakInBatch(peak, Annotation=TSS.human.GRCh37,
#'                             PeakLocForDistance = "middle")
#'   stopifnot(ap$feature=="ENSG00000001461")
#'   ap <- annotatePeakInBatch(peak, Annotation=TSS.human.GRCh37,
#'                             PeakLocForDistance = "endMinusStart")
#'   stopifnot(ap$feature=="ENSG00000001461")
#'   ## Let's calculate the distances between the peak and the TSS of the genes
#'   ## in the annotation file used for annotating the peaks.
#'   ## Please note that we need to compute the distance using the annotation
#'   ## file TSS.human.GRCh37.
#'   ## If you would like to use  TxDb.Hsapiens.UCSC.hg19.knownGene, 
#'   ## then you will need to annotate the peaks
#'   ## using TxDb.Hsapiens.UCSC.hg19.knownGene as well.
#'   ### using start
#'   start(peak) -start(TSS.human.GRCh37[names(TSS.human.GRCh37)== 
#'                                       "ENSG00000001461"]) #picked
#'   #[1] -5528
#'   start(peak) -end(TSS.human.GRCh37[names(TSS.human.GRCh37)==
#'                                    "ENSG00000001460"])
#'   #[1] -6667
#'   #### using middle
#'   (start(peak) + end(peak))/2 -
#'       start(TSS.human.GRCh37[names(TSS.human.GRCh37)== "ENSG00000001461"])
#'   #[1] -5142.5
#'   (start(peak) + end(peak))/2 -
#'       end(TSS.human.GRCh37[names(TSS.human.GRCh37)== "ENSG00000001460"])
#'   # [1] 49480566
#'   end(peak) -start(TSS.human.GRCh37[names(TSS.human.GRCh37)==
#'                                    "ENSG00000001461"]) #picked
#'   # [1] -4757
#'   end(peak) -end(TSS.human.GRCh37[names(TSS.human.GRCh37)==
#'                                  "ENSG00000001460"])
#'   # [1] -5896
#'   #### using endMinusStart
#'   end(peak) - start(TSS.human.GRCh37[names(TSS.human.GRCh37)==
#'                                     "ENSG00000001461"]) ## picked
#'   # [1] -4575
#'   start(peak) -end(TSS.human.GRCh37[names(TSS.human.GRCh37)==
#'                                     "ENSG00000001460"])
#'   #[1] -6667
#'   ###### using txdb object to annotate the peaks
#'   library(org.Hs.eg.db)
#'   select(org.Hs.eg.db, key="STPG1", keytype="SYMBOL",
#'          columns=c("ENSEMBL", "ENTREZID", "SYMBOL"))
#'   #  SYMBOL         ENSEMBL ENTREZID
#'   #  STPG1 ENSG00000001460    90529
#'   select(org.Hs.eg.db, key= "ENSG00000001461", keytype="ENSEMBL",
#'          columns=c("ENSEMBL", "ENTREZID", "SYMBOL"))
#'   #ENSEMBL ENTREZID SYMBOL
#'   # ENSG00000001461    57185 NIPAL3
#'   require(TxDb.Hsapiens.UCSC.hg19.knownGene)
#'   txdb.ann.current <- genes(TxDb.Hsapiens.UCSC.hg19.knownGene)
#'   # note: the annotation of STPG1 shifted from old version
#'   # here we set the old one for the test
#'   txdb.ann <- GRanges('chr1', IRanges(start=c(24683489, 24742245),
#'                       end=c(24741587, 24799473)), 
#'                       strand=c('-', '+'), gene_id=c('90529', '57185'))
#'   names(txdb.ann) <- txdb.ann$gene_id
#'   STPG1 <- select(org.Hs.eg.db, key="STPG1", keytype="SYMBOL",
#'                   columns=c( "SYMBOL", "ENSEMBL", "ENTREZID"))[1,3]
#'   NIPAL3 <- select(org.Hs.eg.db, key="NIPAL3", keytype="SYMBOL",
#'                    columns=c( "SYMBOL", "ENSEMBL", "ENTREZID"))[1,3]
#'   ap <- annotatePeakInBatch(peak, Annotation=txdb.ann,
#'                             PeakLocForDistance = "start")
#'   expect_equal(ap$feature, STPG1)
#'   ap <- annotatePeakInBatch(peak, Annotation=txdb.ann,
#'                             PeakLocForDistance = "end")
#'   expect_equal(ap$feature, STPG1)
#'   ap <- annotatePeakInBatch(peak, Annotation=txdb.ann,
#'                             PeakLocForDistance = "middle")
#'   expect_equal(ap$feature, STPG1)
#'   ap <- annotatePeakInBatch(peak, Annotation=txdb.ann,
#'                             PeakLocForDistance = "endMinusStart")
#'   expect_equal(ap$feature, NIPAL3)
#'   txdb.ann.current[NIPAL3]
#'   txdb.ann[txdb.ann$gene_id == NIPAL3]
#'   #  GRanges object with 1 range and 1 metadata column:
#'   #    seqnames            ranges strand |     gene_id
#'   #  <Rle>         <IRanges>  <Rle> | <character>
#'   #   57185     chr1 24742245-24799473      + |       57185
#'   #-------
#'   txdb.ann.current[STPG1]
#'   txdb.ann[txdb.ann$gene_id == STPG1]
#'   #   GRanges object with 1 range and 1 metadata column:
#'   #     seqnames            ranges strand |     gene_id
#'   #  <Rle>         <IRanges>  <Rle> | <character>
#'   #     90529     chr1 24683489-24741587      - |       90529
#' 
annotatePeakInBatch <-
    function (myPeakList, mart, featureType = c("TSS", "miRNA", "Exon"),
              AnnotationData, 
              output = c("nearestLocation", "overlapping", "both", 
                         "shortestDistance", "inside",
                         "upstream&inside", "inside&downstream",
                         "upstream", "downstream", 
                         "upstreamORdownstream", 
                         "nearestBiDirectionalPromoters"),
              multiple = c(TRUE,FALSE), maxgap = -1L,
              PeakLocForDistance=c("start","middle","end", "endMinusStart"),
              FeatureLocForDistance=c("TSS","middle","start","end", "geneEnd"),
              select=c("all", "first", "last", "arbitrary"),
              ignore.strand=TRUE, bindingRegion=NULL, ...)
    {
        if(output[1]=="nearestStart") output <- "nearestLocation"
        featureType = match.arg(featureType)
        PeakLocForDistance = match.arg(PeakLocForDistance)
        FeatureLocForDistance = match.arg(FeatureLocForDistance)
        output = match.arg(output)
        select = match.arg(select)
        multiple = multiple[1]
        if (PeakLocForDistance == "endMinusStart")
        {
            if (missing(AnnotationData) || length(AnnotationData) == 0)
             {
              if (missing(mart)) {
                stop("Error in querying biomart database.
                     No valid mart object is passed in!
                     Suggest call getAnnotation before calling
                     annotatePeakInBatch")
              }
              else if(!is(mart, "Mart")){
                if(is(mart, "GRanges")){
                    warning("AnnotationData is missing, and a GRanges is passed
                            to mart parameter. Trying to annotate peaks by
                            the GRanges you input.")
                    AnnotationData <- mart
                    mart <- NULL
                } else {
                    stop("Error in querying biomart database.
                     No valid mart object is passed in!
                     Suggest call getAnnotation before calling
                     annotatePeakInBatch")
                }
            }
            else {
                AnnotationData <- getAnnotation(mart, featureType = featureType)
            }
          } 
          if (!length(names(AnnotationData)) || any(is.na(names(AnnotationData))))
          {
             names(AnnotationData) <- paste0("ann", seq_along(AnnotationData))
          }
          plusAnno = AnnotationData[strand(AnnotationData) == "+"]
          minusAnno = AnnotationData[strand(AnnotationData) == "-"]
          if (length(plusAnno) > 0) 
             r.plus <- annotatePeakInBatch(myPeakList, 
                    AnnotationData =  plusAnno,
                    featureType = featureType,
                    PeakLocForDistance = "end",
                    output = output,
                    multiple = multiple,
                    select = select,
                    maxgap = maxgap,
                    FeatureLocForDistance = FeatureLocForDistance,
                    ignore.strand = TRUE,
                    bindingRegion = bindingRegion, ...)
          if (length(minusAnno) > 0)  
              r.minus <- annotatePeakInBatch(myPeakList, 
                    AnnotationData =  minusAnno,
                    featureType = featureType,
                    PeakLocForDistance = "start",
                    output = output,
                    multiple = multiple,
                    select = select,
                    maxgap = maxgap,
                    FeatureLocForDistance = FeatureLocForDistance,
                    ignore.strand = TRUE,
                    bindingRegion = bindingRegion, ...)
         if (length(plusAnno) > 0 & length(minusAnno) == 0) {
             return(r.plus)
         }
         else if (length(plusAnno) == 0 & length(minusAnno) > 0) {
	     return(r.minus)
         }
         else if (length(plusAnno) > 0 & length(minusAnno) > 0) {
             r.both  <- c(r.plus, r.minus) 
             r.both <- r.both[!is.na(r.both$fromOverlappingOrNearest)]
             r.both.df <- cbind(uid = names(r.both), as.data.frame(r.both))
             r.both.df %>%
                filter(fromOverlappingOrNearest == "NearestLocation") %>%        
    		group_by(peak) %>%
                top_n(-1, abs(distancetoFeature)) -> r.n.df
	     if (nrow(r.n.df) == 0)
		return(r.both)
             else if (length(r.both[r.both$fromOverlappingOrNearest != "NearestLocation"]) == 0)
		return(r.both[names(r.both) %in% r.n.df$uid & !is.na(r.both$feature)]) 
             else
         	return(r.both[(names(r.both) %in% r.n.df$uid |
		    r.both$fromOverlappingOrNearest != "NearestLocation") & !is.na(r.both$feature)])
          }
       } ### end of if endMinusStart
       if(output[1]=="nearestStart") output <- "nearestLocation"
           featureType = match.arg(featureType)
           PeakLocForDistance = match.arg(PeakLocForDistance)
           FeatureLocForDistance = match.arg(FeatureLocForDistance)
           output = match.arg(output)
           select = match.arg(select)
           multiple = multiple[1]

      if ((output == "overlapping" || output == "both")
            && select =="all" && multiple==FALSE) {
            warning("Please use select instead of multiple!")
            select = "first"
      }
      if(output=="upstream&inside"){
            if(FeatureLocForDistance!="TSS") {
                FeatureLocForDistance <- "TSS"
                warning("FeatureLocForDistance is set to TSS")
            }
            select <- "all"
        }
      if(output=="inside&downstream"){
            if(FeatureLocForDistance!="geneEnd"){
                FeatureLocForDistance <- "geneEnd"
                warning("FeatureLocForDistance is set to geneEnd")
            }
            select <- "all"
      }
      if (missing(myPeakList)) stop("Missing required argument myPeakList!")
        if (!is(myPeakList, "GRanges")) {
            stop("No valid myPeakList passed in. It needs to be GRanges object")
        }
        if (missing(AnnotationData)) {
            message("No AnnotationData as GRanges is passed in, 
                    so now querying biomart database for AnnotationData ....")
            if (missing(mart)) {
                stop("Error in querying biomart database. 
                     No valid mart object is passed in! 
                     Suggest call getAnnotation before calling 
                     annotatePeakInBatch")
            }
            if(!is(mart, "Mart")){
                if(is(mart, "GRanges")){
                    warning("AnnotationData is missing, and a GRanges is passed
                            to mart parameter. Trying to annotate peaks by 
                            the GRanges you input.")
                    AnnotationData <- mart
                    mart <- NULL
                }else{
                    stop("Error in querying biomart database. 
                     No valid mart object is passed in! 
                     Suggest call getAnnotation before calling 
                     annotatePeakInBatch")
                }
            }else{
                AnnotationData <- getAnnotation(mart, featureType = featureType)
                message("Done querying biomart database, start annotating ....
                        Better way would be calling getAnnotation before 
                        calling annotatePeakInBatch")
            }
       }
      if (!inherits(AnnotationData, 
                      c("GRanges", "annoGR"))) {
            stop("AnnotationData needs to be GRanges or annoGR object")
       }
       if (!length(names(AnnotationData)) || any(is.na(names(AnnotationData))))
       {
             names(AnnotationData) <- paste0("ann", seq_along(AnnotationData))
       }
       if(inherits(AnnotationData, "annoGR")){
            TSS.ordered <- as(AnnotationData, "GRanges")
       }else{
            TSS.ordered <- AnnotationData
       }
        nAnno <- length(TSS.ordered)
        
        rm(AnnotationData)
        rm(nAnno)
        
      if(length(bindingRegion)>1){
            message("Annotate peaks by annoPeaks, see ?annoPeaks for details.")
            ## FeatureLocForDistance=c("TSS","middle","start","end", "geneEnd")
            ##"startSite", "endSite", "fullRange"
            dots <- list(...)
            if(!"bindingType" %in% names(dots)){
                if(output %in% 
                   c("overlapping", 
                     "nearestBiDirectionalPromoters")){
                    bindingType <- switch(
                        output,
                        nearestBiDirectionalPromoters="nearestBiDirectionalPromoters",
                        overlapping=switch(FeatureLocForDistance,
                                           TSS="startSite",
                                           geneEnd="endSite",
                                           NA),
                        NA
                    )
                }
            }else{
              bindingType <- dots$bindingType
            }
            if(exists("bindingType") && !is.na(bindingType)){
                message("maxgap will be ignored.")
                dots$peak <- myPeakList
                dots$annoData <- TSS.ordered
                dots$bindingType <- bindingType
                dots$bindingRegion <- bindingRegion
                return(do.call(annoPeaks, dots))
            }else{
                message("bindingRegion will be ignored.")
            }
      }
        
      if (is.null(names(TSS.ordered))){
            names(TSS.ordered) <- formatC(seq_along(TSS.ordered),
                                          width=nchar(length(TSS.ordered)),
                                          flag="0")
        }
      if (is.null(names(myPeakList))) {
            names(myPeakList) <- formatC(seq_along(myPeakList),
                                         width = nchar(length(myPeakList)),
                                         flag = "0")
        }
      if(any(duplicated(names(myPeakList)))){
            warning("Found duplicated names in myPeakList. 
                    Changing the peak names ...")
            names(myPeakList) <- formatC(seq_along(myPeakList),
                                         width = nchar(length(myPeakList)),
                                         flag = "0")
       }
        savedNames <- names(myPeakList)
        
        ##clear seqnames, the format should be chr+NUM
        ##TODO, how about the seqname not start with chr?
        ## fix by seqlevelsStyle
        TSS.ordered <- formatSeqnames(TSS.ordered, myPeakList)
        #myPeakList <- formatSeqnames(myPeakList)
      if(!all(seqlevels(myPeakList) %in% seqlevels(TSS.ordered))){
            warning("not all the seqnames of myPeakList is 
                    in the AnnotationData.")
      }
        
      if(length(myPeakList)>10000){
            ##huge dataset
            myPeakList <- split(myPeakList, 
                                cut(seq_along(myPeakList),
                                    ceiling(length(myPeakList)/5000)))
            myPeakList <- lapply(myPeakList, annotatePeakInBatch, 
                                 AnnotationData=TSS.ordered, 
                                 output = output, maxgap = maxgap,
                                 PeakLocForDistance=PeakLocForDistance,
                                 FeatureLocForDistance=FeatureLocForDistance,
                                 select=select,
                                 ignore.strand=ignore.strand)
            names(myPeakList) <- NULL
            myPeakList <- unlist(GRangesList(myPeakList))
            names(myPeakList) <- make.names(paste(myPeakList$peak, 
                                                  myPeakList$feature))
            ##myPeakList
            return(myPeakList)
      }
        ###STEP1 get nearst annotation for each peak, 
        ###use distanceToNearest(query, subject, ignore.strand=T/F, select)
        ## the distance got here is the shortestDistance
        ## select could only be arbitrary or all, 
        ## if it is "first" or "last", use "all" instead.
        ## if output=="nearest", annotation should only consider the start point
        ##         ignore.strand <- all(strand(myPeakList)=="*") || 
        ##             all(strand(TSS.ordered)=="*") || 
        ##             all(strand(myPeakList)=="+")
        nsel <- ifelse(select %in% c("all", "first", "last"), 
                       "all", "arbitrary")
        featureGR <- TSS.ordered
        end(featureGR) <- 
            start(featureGR) <- 
            switch(FeatureLocForDistance,
                   TSS=ifelse(strand(featureGR)=="-", 
                              end(featureGR), 
                              start(featureGR)), 
                   geneEnd=ifelse(strand(featureGR)=="-", 
                                  start(featureGR), 
                                  end(featureGR)),
                   middle=round(rowMeans(cbind(start(featureGR), 
                                               end(featureGR)))),
                   start=start(featureGR),
                   end=end(featureGR) 
            )
        myPeaksGR <- myPeakList
        end(myPeaksGR) <-
            start(myPeaksGR) <-
            switch(PeakLocForDistance,
                   middle=round(rowMeans(cbind(start(myPeaksGR),
                                               end(myPeaksGR)))),
                   start=start(myPeaksGR),
                   end=end(myPeaksGR)
            )
        if(output=="nearestLocation"){
            dist <- as.data.frame(nearest(myPeaksGR, featureGR, 
                                          ignore.strand=ignore.strand, 
                                          select=nsel))            
            if(nrow(dist)==0) dist[1,] <- NA ##in case no match at all
            if(nsel=="arbitrary") {
                dist <- cbind(queryHits=seq_along(myPeakList), 
                              subjectHits=dist)
                colnames(dist) <- c("queryHits", "subjectHits")
            }
            dist$output <- rep("NearestLocation", nrow(dist))
        }
        if(output=="both"){
            distN <- as.data.frame(nearest(myPeaksGR, featureGR,
                                           ignore.strand=ignore.strand,
                                           select=nsel))
            if(nrow(distN)==0) distN[1,]<-NA
            if(nsel=="arbitrary") {
                distN <- cbind(queryHits=seq_along(myPeakList), 
                               subjectHits=distN)
                colnames(distN) <- c("queryHits", "subjectHits")
            }
            distO <- as.data.frame(findOverlaps(myPeakList, TSS.ordered,
                                                maxgap=maxgap,
                                                ignore.strand=ignore.strand,
                                                select=select))
            if(nrow(distO)==0) distO[1,]<-NA
            if(ncol(distO)==1){
                distO <- cbind(queryHits=seq_along(myPeakList), 
                               subjectHits=distO)
                colnames(distO) <- c("queryHits", "subjectHits")
            }
            distN$output <- rep("NearestLocation", nrow(distN))
            distN <- distN[!is.na(distN$subjectHits),]
            distO$output <- rep("Overlapping", nrow(distO))
            distO <- distO[!is.na(distO$subjectHits),]
            dist <- rbind(distN, distO)
            dist <- dist[!duplicated(dist[,c("queryHits", "subjectHits")]),
                         ,drop=FALSE]
            dist <- dist[order(dist$queryHits, dist$subjectHits),,drop=FALSE]
        }
        if(output=="overlapping"){
            dist <- as.data.frame(findOverlaps(myPeakList, TSS.ordered,
                                               maxgap=maxgap,
                                               ignore.strand=ignore.strand,
                                               select=select))
            if(nrow(dist)==0) dist[1,] <- NA
            if(ncol(dist)==1){
                dist <- cbind(queryHits=seq_along(myPeakList), subjectHits=dist)
                colnames(dist) <- c("queryHits", "subjectHits")
            }
            dist$output <- rep("Overlapping", nrow(dist))
        }
        if(output=="shortestDistance"){
            dist <- as.data.frame(nearest(myPeakList, TSS.ordered,
                                          ignore.strand=ignore.strand,
                                          select=nsel))
            if(nrow(dist)==0) dist[1,] <- NA ##in case no match at all
            if(nsel=="arbitrary") {
                dist <- cbind(queryHits=seq_along(myPeakList), subjectHits=dist)
                colnames(dist) <- c("queryHits", "subjectHits")
            }
            dist$output <- rep("shortestDistance", nrow(dist))
        }
        if(output=="upstream&inside"){
            #upstream
            featureGR <- TSS.ordered
            start <- ifelse(strand(featureGR)=="-", 
                            start(featureGR), 
                            start(featureGR)-max(maxgap, 1))
            width <- width(featureGR) + max(maxgap, 1)
            start(featureGR) <- start
            width(featureGR) <- width
            dist <- as.data.frame(findOverlaps(myPeakList, featureGR,
                                                ignore.strand=ignore.strand,
                                                select=select,
                                                type="any"))
            dist$output <- rep("Upstream&Inside", nrow(dist))
        }
        if(output=="upstream"){
            #upstream
            featureGR <- TSS.ordered
            start <- ifelse(strand(featureGR)=="-", 
                            end(featureGR)+1, 
                            start(featureGR)-max(maxgap, 1))
            width <- max(maxgap, 1)
            start(featureGR) <- start
            width(featureGR) <- width
            dist <- as.data.frame(findOverlaps(myPeakList, featureGR,
                                               ignore.strand=ignore.strand,
                                               select=select,
                                               type="any"))
            dist$output <- rep("Upstream", nrow(dist))
        }
        if(output=="inside&downstream"){
            #downstream
            featureGR <- TSS.ordered
            start <- ifelse(strand(featureGR)=="-", 
                            start(featureGR)-max(maxgap, 1), 
                            start(featureGR))
            width <- width(featureGR) + max(maxgap, 1)
            start(featureGR) <- start
            width(featureGR) <- width
            dist <- as.data.frame(findOverlaps(myPeakList, featureGR,
                                                ignore.strand=ignore.strand,
                                                select=select,
                                                type="any"))
            dist$output <- rep("Inside&Downstream", nrow(dist))
        }
        if(output=="downstream"){
            #downstream
            featureGR <- TSS.ordered
            start <- ifelse(strand(featureGR)=="-", 
                            start(featureGR)-max(maxgap, 1), 
                            end(featureGR)+1)
            width <- max(maxgap, 1)
            start(featureGR) <- start
            width(featureGR) <- width
            dist <- as.data.frame(findOverlaps(myPeakList, featureGR,
                                               ignore.strand=ignore.strand,
                                               select=select,
                                               type="any"))
            dist$output <- rep("Downstream", nrow(dist))
        }
        if(output=="upstreamORdownstream"){
            featureGR <- TSS.ordered
            start <- ifelse(strand(featureGR)=="-", 
                            end(featureGR)+1, 
                            start(featureGR)-max(maxgap, 1))
            width <- max(maxgap, 1)
            start(featureGR) <- start
            width(featureGR) <- width
            dist1 <- as.data.frame(findOverlaps(myPeakList, featureGR,
                                               ignore.strand=ignore.strand,
                                               select=select,
                                               type="any"))
            dist1$output <- rep("Upstream", nrow(dist1))
            featureGR <- TSS.ordered
            start <- ifelse(strand(featureGR)=="-", 
                            start(featureGR)-max(maxgap, 1), 
                            end(featureGR)+1)
            width <- max(maxgap, 1)
            start(featureGR) <- start
            width(featureGR) <- width
            dist2 <- as.data.frame(findOverlaps(myPeakList, featureGR,
                                               ignore.strand=ignore.strand,
                                               select=select,
                                               type="any"))
            dist2$output <- rep("Downstream", nrow(dist2))
            dist <- rbind(dist1, dist2)
        }
        if(output=="inside"){
            dist <- as.data.frame(findOverlaps(myPeakList, TSS.ordered,
                                               ignore.strand=ignore.strand,
                                               select=select,
                                               type="within"))
            dist$output <- rep("inside", nrow(dist))
        }
        if(output=="upstream2downstream"){
            featureGR <- TSS.ordered
            start(featureGR) <- 
                apply(cbind(start(featureGR) - maxgap, 1), 1, max)
            end(featureGR) <- end(featureGR) + maxgap
            dist <- as.data.frame(findOverlaps(myPeakList, featureGR,
                                               ignore.strand=ignore.strand,
                                               select=select,
                                               type="any"))
            dist$output <- rep("upstream2downstream", nrow(dist))
        }
        ##  nearest is NOT filtered by maxgap, is this should be changed?
        ##        dist <- dist[!is.na(dist$subjectHits), ]
        ##        distance <- distance(myPeakList[dist$queryHits],
        ##                             TSS.ordered[dist$subjectHits],
        ##                             ignore.strand=ignore.strand)
        ##        dist <- dist[abs(distance) <= maxgap, ]
        if(output=="nearestBiDirectionalPromoters" && length(bindingRegion)<=1){
          stop("If output is nearestBiDirectionalPromoters,",
               "please set bindingRegion. See ?annoPeaks for details.")
        }
        myPeakList.Hit <- 
            myPeakList[dist$queryHits[!is.na(dist$subjectHits)]]
        myPeakList.NA <- 
            myPeakList[!names(myPeakList) %in% names(myPeakList.Hit)]
        subjectHits <- 
            TSS.ordered[dist$subjectHits[!is.na(dist$subjectHits)]]
        mcols(subjectHits)$output <- 
            dist[!is.na(dist$subjectHits),"output"]
        #    myPeakList.Hit$distanceToNearest <- 
        #    dist$distance[!is.na(dist$subjectHits)]
        
        ###STEP2 get distance for each peak and nearest annotation by 
        ## distance(x, y). the distance is calculated by
        ##        PeakLocForDistance=c("start","middle","end"),
        ##        FeatureLocForDistance=c("TSS","middle","start",
        ##                              "end", "geneEnd")
        FeatureLoc <-
            switch(FeatureLocForDistance,
                   middle=as.integer(round(rowMeans(cbind(start(subjectHits), 
                                                          end(subjectHits))))),
                   start=start(subjectHits),
                   end=end(subjectHits),
                   geneEnd=as.integer(ifelse(strand(subjectHits)=="-", 
                                             start(subjectHits), 
                                             end(subjectHits))),
                   TSS=as.integer(ifelse(strand(subjectHits)=="-", 
                                         end(subjectHits), 
                                         start(subjectHits))))
        
        PeakLoc <- 
            switch(PeakLocForDistance,
                   start=start(myPeakList.Hit),
                   end=end(myPeakList.Hit),
                   middle=as.integer(round(rowMeans(
                       cbind(start(myPeakList.Hit), end(myPeakList.Hit))))))
        
        distancetoFeature <- as.numeric(ifelse(strand(subjectHits)=="-", 
                                               FeatureLoc - PeakLoc, 
                                               PeakLoc - FeatureLoc))
        
        ###STEP3 relationship between query and subject:
        ###   "inside", "overlapEnd", "overlapStart", 
        ###    "includeFeature", "upstream", "downstream"
        insideFeature <- getRelationship(myPeakList.Hit, subjectHits)
        myPeakList.Hit$peak <- names(myPeakList.Hit)
        myPeakList.Hit$feature <- names(subjectHits)
        myPeakList.Hit$start_position <- start(subjectHits)
        myPeakList.Hit$end_position <- end(subjectHits)
        myPeakList.Hit$feature_strand <- as.character(strand(subjectHits))
        
        myPeakList.Hit$insideFeature <- insideFeature[, "insideFeature"]
        myPeakList.Hit$distancetoFeature <- distancetoFeature
        
        myPeakList.Hit$shortestDistance <- 
            as.integer(insideFeature[,"shortestDistance"])
        
        myPeakList.Hit$fromOverlappingOrNearest <- subjectHits$output
        ##save oid for select == "first" or "last" filter
        myPeakList.Hit$oid <- insideFeature[, "ss"]
        ###combind data of NA with Hits
        if(length(myPeakList.NA)>0){
            myPeakList.NA$peak <- names(myPeakList.NA)
            for(ncol in c("feature",
                          "start_position",
                          "end_position",
                          "feature_strand",
                          "insideFeature",
                          "distancetoFeature",
                          "shortestDistance",
                          "fromOverlappingOrNearest",
                          "oid")){
                mcols(myPeakList.NA)[, ncol] <- NA
            }
            ## in case duplicated colnames
            colnames(mcols(myPeakList.NA)) <- colnames(mcols(myPeakList.Hit))
            myPeakList <- c(myPeakList.Hit, myPeakList.NA)
        }else{
            myPeakList <- myPeakList.Hit
        }
        ###output the results
        ##select=c("all", "first", "last", "arbitrary"))
        ##output = c("nearest", "overlapping", "both")
        ##if select %in% first or last, must filter the duplicate annotation
        ##if output="both", must filter the duplicate annotation
        ##if input is GRanges, output is GRanges
        ###the order of output should be same as input
        if(select=="first"){
            myPeakList <- 
                myPeakList[order(names(myPeakList), abs(myPeakList$oid))]
            myPeakList <- 
                myPeakList[!duplicated(names(myPeakList))]
        }
        if(select=="last"){
            myPeakList <- 
                myPeakList[order(names(myPeakList), -abs(myPeakList$oid))]
            myPeakList <- 
                myPeakList[!duplicated(names(myPeakList))]
        }
        ##remove column oid
        myPeakList$oid <- NULL
        ##re-order myPeakList as the original order
        oid <- seq_along(savedNames)
        names(oid) <- savedNames
        oid <- oid[names(myPeakList)]
        if(!any(is.na(oid))){
            myPeakList <- myPeakList[order(oid)]
        }
        

        if(output=="nearestLocation"){
            ## remove duplicate annotation, just keep the nearest one
            removeDuplicates <- function(gr){
                dup <- duplicated(gr$peak)
                if(any(dup)){
                    gr$oid <- seq_along(gr)
                    dup <- gr[dup]
                    gr.dup <- gr[gr$peak %in% dup$peak] 
                    ## bugs peak name must be different.
                    gr.NOTdup <- gr[!gr$peak %in% dup$peak]
                    gr.dup <- split(gr.dup, gr.dup$peak)
                    gr.dup <- lapply(gr.dup, function(.ele){
                        .ele[.ele$shortestDistance == 
                                 min(.ele$shortestDistance)]
                    })
                    gr.dup <- unlist(GRangesList(gr.dup))
                    gr <- c(gr.dup, gr.NOTdup)
                    gr <- gr[order(gr$oid)]
                    gr$oid <- NULL  
                }
                gr
            }
            myPeakList <- removeDuplicates(myPeakList)
        }

        
        names(myPeakList) <- 
            make.names(paste(myPeakList$peak, myPeakList$feature))

        ##myPeakList
        return(myPeakList)
    }

globalVariables(c("fromOverlappingOrNearest", "peak"))

test_that("filterByOverlaps works not correct", {
    ##GRanges
    ## myPeak
    ## 1 2 3 4 5 6 7 8 9 10
    ##       a a a a         +
    ##           b b b       -
    
    myPeak = GRanges("1", 
                     IRanges(start=c(4, 6), 
                             end=c(7, 8), 
                             names=letters[1:2]), 
                     strand=c("+", "-"))
    o <- filterByOverlaps(myPeak[1], myPeak[2], ignore.strand=FALSE)
    expect_identical(o, unname(myPeak[1]))
    o <- filterByOverlaps(myPeak[1], myPeak[2], ignore.strand=TRUE)
    expect_equal(end(o), 5)
})

#' get the oligonucleotide frequency
#' 
#' Prepare the oligonucleotide frequency for given Markov order.
#' 
#' 
#' @param sequence The sequences packaged in DNAStringSet, DNAString object or
#' output of function \link{getAllPeakSequence}.
#' @param MarkovOrder Markov order.
#' @return A numeric vector.
#' @author Jianhong Ou
#' @seealso See Also as \code{\link{oligoSummary}}
#' @keywords misc
#' @importFrom Biostrings oligonucleotideFrequency
#' @export
#' @examples
#'     library(seqinr)
#'     library(Biostrings)
#'     oligoFrequency(DNAString("AATTCGACGTACAGATGACTAGACT"))
#' 
oligoFrequency <- function(sequence, MarkovOrder=3L){
    stopifnot(is.numeric(MarkovOrder))
    stopifnot(MarkovOrder>0)
    stopifnot("The seqinr package is required." = 
                  requireNamespace("seqinr", quietly = TRUE))
    if(is(sequence, "GRanges")){
        sequence <- sequence$sequence
    }
    if(is.character(sequence)){
      sequence <- DNAStringSet(sequence)
    }
    if(!inherits(sequence, c("DNAStringSet", "DNAString"))){
      stop("sequence must be an object of DNAStringSet or DNAString",
           "or output of getAllPeakSequence")
    }
    MarkovOrder <- as.integer(MarkovOrder)
    total <- sum(nchar(sequence))
    freqs <- lapply(unique(c(1, MarkovOrder, MarkovOrder+1)), function(m){
        of <- oligonucleotideFrequency(sequence,
                                       width = m,
                                       as.prob = FALSE)
        if(length(dim(of))==2) of <- colSums(of)
        of/total
    })
    unlist(freqs, recursive = FALSE)
}




#' Output a summary of consensus in the peaks
#' 
#' Calculate the z-scores of all combinations of oligonucleotide in a given
#' length by Markove chain.
#' 
#' 
#' @param sequence The sequences packaged in DNAStringSet, DNAString object or
#' output of function \link{getAllPeakSequence}.
#' @param oligoLength The length of oligonucleotide.
#' @param freqs Output of function \link{frequency}.
#' @param MarkovOrder The order of Markov chain.
#' @param quickMotif Generate the motif by z-score of not.
#' @param revcomp Consider both the given strand and the reverse complement
#' strand when searching for motifs in a complementable alphabet (ie DNA).
#' Default, FALSE.
#' @param maxsize Maximum allowed dataset size (in length of sequences).
#' @return A list is returned. \item{zscore}{A numeric vector. The z-scores of
#' each oligonucleotide.} \item{counts}{A numeric vector. The counts number of
#' each oligonucleotide.} \item{motifs}{a list of motif matrix.}
#' @author Jianhong Ou
#' @seealso See Also as \code{\link{frequency}}
#' @references van Helden, Jacques, Marcel li del Olmo, and Jose E.
#' Perez-Ortin. "Statistical analysis of yeast genomic downstream sequences
#' reveals putative polyadenylation signals." Nucleic Acids Research 28.4
#' (2000): 1000-1010.
#' @keywords misc
#' @export
#' @importFrom Biostrings DNAStringSet PDict vcountPDict DNAString 
#' @importFrom pwalign pairwiseAlignment aligned
#' @importFrom utils adist combn
#' @importFrom stats hclust kmeans as.dendrogram nobs
#' @examples
#' 
#'     if(interactive() || Sys.getenv("USER")=="jou"){
#'         data(annotatedPeak)
#'         library(BSgenome.Hsapiens.UCSC.hg19)
#'         library(seqinr)
#'         seq <- getAllPeakSequence(annotatedPeak[1:100], 
#'                      upstream=20, 
#'                      downstream=20, 
#'                      genome=Hsapiens)
#'         oligoSummary(seq)
#'     }
#' 
oligoSummary <- function(sequence, oligoLength=6L, 
                         freqs=NULL, MarkovOrder=3L, 
                         quickMotif=FALSE, revcomp=FALSE,
                         maxsize=100000){
    oligoLength <- as.integer(oligoLength)
    stopifnot(oligoLength>3&oligoLength<13)
    MarkovOrder <- as.integer(MarkovOrder)
    stopifnot(MarkovOrder>0&MarkovOrder<6)
    stopifnot(MarkovOrder < oligoLength-2)
    stopifnot("The seqinr package is required." = 
                  requireNamespace("seqinr", quietly = TRUE))
    if(is(sequence, "GRanges")){
        sequence <- sequence$sequence
    }else{
        if(is(sequence, "DNAStringSet")){
            sequence <- as.character(sequence)
        }else{
            if(!is.character(sequence)){
                stop("sequence must be an object of DNAStringSet or DNAString",
                     "or output of getAllPeakSequence")
            }
        }
    }
    
    sequence <- tolower(sequence)
    oligoWords <- seqinr::words(oligoLength)
    dict <- PDict(DNAStringSet(oligoWords))
    len <- length(sequence)
    sequence.tbl <- 1
    if(len > maxsize){
        sequence.tbl <- table(sequence)
        if(length(sequence.tbl)>maxsize){
            stop("oligoSummary can not handle such hugue dataset.")
        }
        cnt <- vcountPDict(dict, subject=DNAStringSet(names(sequence.tbl)), 
                           max.mismatch=0, min.mismatch=0, 
                           with.indels=FALSE, fixed=TRUE)
    }else{
        cnt <- vcountPDict(dict, subject=DNAStringSet(sequence), 
                           max.mismatch=0, min.mismatch=0, 
                           with.indels=FALSE, fixed=TRUE)
    }
    rownames(cnt) <- oligoWords
    cnt <- t(cnt)
    mergeRevcomp <- function(mat){
        coln <- colnames(mat)
        map <- c(a="t", c="g", g="c", t="a")
        revComp <- function(.ele){
            paste(map[rev(seqinr::s2c(.ele))], collapse="")
        }
        coln.rev <- sapply(coln, revComp)
        coln.id <- 1:length(coln)
        coln.rev.id <- match(coln.rev, coln)
        coln.ids <- apply(cbind(coln.id, coln.rev.id), 1, sort)
        coln.ids <- unique(t(coln.ids))
        mat1 <- mat[, coln.ids[, 1]] > 0
        mat2 <- mat[, coln.ids[, 2]] > 0
        mat1 <- colSums(mat1)
        mat2 <- colSums(mat2)
        coln <- ifelse(mat1>mat2, names(mat1), names(mat2))
        mat <- mat[, coln.ids[, 1]] + mat[, coln.ids[, 2]]
        colnames(mat) <- coln
        mat
    }
    if(revcomp) cnt <- mergeRevcomp(cnt)
    #cnt <- cnt>0
    mode(cnt) <- "logical"
    mode(cnt) <- "numeric"
    if(len > maxsize) cnt <- cnt * as.numeric(sequence.tbl)
    cntSum <- colSums(cnt)
    ## calculate Z score
    ## shuffle sequence based on 1 level markovmodel
    if(is.null(freqs)){
        freqs <- oligoFrequency(sequence, 
                                MarkovOrder=MarkovOrder)
    }
    namesFreqs <- unique(c("a", "c", "g", "t", 
                           seqinr::words(MarkovOrder),
                           seqinr::words(MarkovOrder+1)))
    names(freqs) <- tolower(names(freqs))
    stopifnot(all(namesFreqs %in% names(freqs)))
    f <- sapply(names(cntSum), function(.ele) {
        m1 <- substring(.ele, 1:(oligoLength-MarkovOrder),
                        (MarkovOrder+1):oligoLength)
        m0 <- substring(.ele, 2:(oligoLength-MarkovOrder),
                        (MarkovOrder+1):(oligoLength-1))
        prod(freqs[m1])/prod(freqs[m0])
    })
    if(len > maxsize){
        seqLen <- sapply(names(sequence.tbl), nchar, USE.NAMES=FALSE) - 
            oligoLength + 1
    }else{
        seqLen <- sapply(sequence, nchar, USE.NAMES=FALSE) - oligoLength + 1
    }
    seqLen[seqLen<0] <- 0
    f.m <- seqLen %*% t(f)
    f.m[f.m>1] <- 1
    if(len > maxsize){
        f.m <- f.m * as.numeric(sequence.tbl)
    }
    mu <- colSums(f.m)
    names(mu) <- names(cntSum)
    #     Kov <- sapply(names(cntSum), function(.ele){
    #         arr <- seqinr::s2c(.ele)
    #         k <- lapply(seq_len(length(arr)), function(.e){
    #             if(.e==1) return(TRUE)
    #             if(.e %% 2) 
    #                 return(all(arr[1:ceiling(.e/2)]==arr[ceiling(.e/2):.e]))
    #             return(all(arr[1:(.e/2)]==arr[(.e/2+1):.e]))
    #         })
    #         k <- as.numeric(k)
    #         j <- sapply(seq_len(length(arr)), function(.e){
    #             (1/freqs[arr[.e]])^.e
    #         })
    #         sum(k*j)
    #     })
    #std <- sqrt(mu * (2*Kov - 1 - (2*oligoLength - 1) * mu/length(sequence)))
    #std <- sqrt(length(sequence) * 
    #            (Kov/2-1+(2*oligoLength-1)/4^oligoLength) / 4^oligoLength)
    N <- len #length(sequence)
    std <- sqrt(mu/N * (1-mu/N) / N)
    zscore <- (cntSum - mu)/N/std
    #zscore <- (cntSum - mu)/std
    zscore[std==0] <- NA
    
    if(!quickMotif){
        return(list(zscore=zscore, counts=cntSum, expCnt=mu,
                    motifs=NA))
    }
    ## motif search
    seeds <- zscore[!is.na(zscore)]
    seeds <- sort(seeds, decreasing=TRUE)
    seeds <- seeds[1:min(50, length(seeds))]
    zscore.max <- max(zscore)
    seeds <- seeds[zscore.max - seeds <= zscore.max/2]
    zscore.cutoff <- c(NA, NA, 2.155, 2.66, 3.095, 3.49, 3.83, 4.1, 5, 5, 5, 5)
    seeds <- names(seeds)[seeds>zscore.cutoff[oligoLength]] #top50 only
    
    str2motif <- function(s){
        tmp <- matrix(c(1, 0, 0, 0,
                        0, 1, 0, 0,
                        0, 0, 1, 0,
                        0, 0, 0, 1), ncol=4, nrow=4, 
                      dimnames=list(c("A", "C", "G", "T"), 
                                    c("a", "c", "g", "t")))
        if(length(s)==1){
            return(tmp[, seqinr::s2c(s)])
        }
        ss <- table(s)
        if(length(ss)==1){
            return(tmp[, seqinr::s2c(names(ss))])
        }
        sss <- lapply(names(ss), function(.ele) 
            as.numeric(tmp[, seqinr::s2c(.ele)]))
        sss <- mapply(function(mat, times, coln) mat*times, 
                      sss, ss, SIMPLIFY = FALSE)
        consensusStr <- DNAString(names(ss)[1])
        for(i in 2:length(ss)){
            tempStr <- DNAString(names(ss)[i])
            consensusStr <- aligned(
                    pairwiseAlignment(consensusStr, tempStr, 
                                      type="local"),
                    degap=TRUE)
        }
        consensusStr <- tolower(as.character(consensusStr))
        idx <- regexpr(consensusStr, names(ss))
        tl <- max(idx)
        nc <- nchar(names(ss)[1])
        tmp0 <- rep(0, 4*(tl+nc-1))
        pcm <- mapply(function(.ele, .idx){
            left <- max(idx) - .idx
            this.tmp <- tmp0
            this.tmp[left*4+1:length(.ele)] <- .ele
            this.tmp
        }, sss, idx, SIMPLIFY=FALSE)
        pcm <- do.call(rbind, pcm)
        pcm <- colSums(pcm)
        pcm <- matrix(pcm, nrow=4, 
                      dimnames=list(c("A", "C", "G", "T")))
        pcm.colsums <- colSums(pcm)
        pcm.colsums.max <- max(pcm.colsums)
        pcm <- t(t(pcm)+(pcm.colsums.max - pcm.colsums)/4)
        pcm/colSums(pcm)
    }
    subgroupMotif <- function(.ele){
        .ele <- .ele[!is.na(.ele)]
        if(length(.ele)==0){
            return(NA)
        }
        if(length(.ele)==1){
            return(str2motif(.ele))
        }
        .cnt <- cnt[, .ele]
        .ord <- colSums(.cnt)
        .cnt <- .cnt[, order(-.ord)]
        if(length(.ele)==2){
            .ele <- colnames(.cnt)
            .ele <- c(rep(.ele[1], sum(.cnt[, 1])), 
                      rep(.ele[2], sum(.cnt[.cnt[, 2]>0 &
                                                (!(.cnt[, 1]>0 & 
                                                       .cnt[, 2]>0)), 2])))
            return(str2motif(.ele))
        }
        ## get max hits of any combinations
        ad <- adist(.ele, partial=TRUE)
        rownames(ad) <- colnames(ad) <- .ele
        all.comb <- sapply(1:min(length(.ele), 5), function(m){ 
            .comb <- combn(.ele, m, simplify=FALSE)
            .comb.ad <- sapply(.comb, function(.cmb){
                if(length(.cmb)>1){
                    .cmb <- combn(.cmb, 2)
                    all(ad[.cmb[1, ], .cmb[2, ]]<=2)
                }else{
                    TRUE
                }
            })
            .comb[.comb.ad]
        })
        all.comb <- unlist(all.comb, recursive=FALSE, use.names=FALSE)
        prob.mul.evt <- function(x){
            if(length(x)==1) return(x)
            p <- x[1] + x[2] - x[1]*x[2]
            Recall(c(p, x[-(1:2)]))
        }
        comb.f <- sapply(all.comb, function(.e) prob.mul.evt(f[.e]), 
                         simplify = TRUE,
                         USE.NAMES = FALSE)
        comb.f.m <- seqLen %*% t(comb.f)
        comb.f.m[comb.f.m>1] <- 1
        if(len > maxsize){
            comb.f.m <- comb.f.m * as.numeric(sequence.tbl)
        }
        comb.mu <- colSums(comb.f.m)
        rm(comb.f.m); gc(reset=TRUE)
        comb.std <- sqrt(comb.mu/N * (1-comb.mu/N)/N)
        comb.score <- sapply(all.comb, function(.e) sum(.cnt[, .e]),
                             simplify = TRUE,
                             USE.NAMES = FALSE)
        score <- (comb.score - comb.mu)/N/comb.std
        best.combs <- all.comb[score==max(score)]
        best.combs.score <- sapply(best.combs, function(.ele) sum(.ord[.ele]))
        best.comb <- best.combs[best.combs.score==max(best.combs.score)][[1]]
        .cnt <- .cnt[, colnames(.cnt) %in% best.comb, drop=FALSE]
        ## resort the column order
        .cnt <- .cnt[, order(.ord[colnames(.cnt)], decreasing=TRUE), drop=FALSE]
        .cnt.gt0 <- .cnt > 0
        .ele <- rep(colnames(.cnt)[1], sum(.cnt[, 1]))
        if(ncol(.cnt)>1){
            for(i in 2:ncol(.cnt)){
                .cnt.gt0[, i] <- .cnt.gt0[, i] & 
                    !(apply(.cnt.gt0[, 1:(i-1), drop=FALSE], 1, any) &
                          .cnt.gt0[, i])
                .ele <- c(.ele, rep(colnames(.cnt)[i], 
                                    sum(.cnt[.cnt.gt0[, i] , i])))
            }
        }
        str2motif(.ele)
    }
    if(length(seeds)>2){
        ### split the seeds by distance
        dist <- adist(seeds, partial=TRUE)
        hc <- hclust(dist(dist), method="average")
        len <- length(hc$height)
        if(len>2){
            hc.height.diff <- diff(hc$height)
            km <- kmeans(hc.height.diff, centers=2)
            idx <- km$cluster==km$cluster[length(km$cluster)]
            idx <- (length(idx):1)[which(rev(!idx))[1]]+1
            d <- cut(as.dendrogram(hc), hc$height[idx])
            lowers <- d$lower[sapply(d$lower, nobs)>=1]
            if(length(lowers)>0){
                subgroup <- lapply(lowers, function(.ele) 
                    seeds[as.numeric(labels(.ele))])
                subgroup <- subgroup[order(sapply(subgroup, function(.ele) 
                    max(zscore[.ele])), decreasing=TRUE)]
                motifs <- lapply(subgroup, subgroupMotif)
            }else{
                motifs <- NA ## this is impossible
            }
        }else{
            d <- as.dendrogram(hc)
            subgroup <- list()
            subgroup[[1]] <- seeds[as.numeric(labels(d[[1]]))]
            subgroup[[2]] <- seeds[as.numeric(labels(d[[2]]))]
            motifs <- lapply(subgroup, subgroupMotif)
        }
    }else{
        if(length(seeds)==2){
            consensus <- tolower(as.character(aligned(
                pairwiseAlignment(DNAString(seeds[1]), 
                                  DNAString(seeds[2]),
                                  type="local"),
                degap=TRUE)))
            if(nchar(consensus)>=oligoLength-2){
                motifs <- list(subgroupMotif(seeds))
            }else{
                motifs <- lapply(seeds[order(-zscore[seeds])], str2motif)
            }
        }else{
            motifs <- lapply(seeds[order(-zscore[seeds])], str2motif)
        }
    }
    
    return(list(zscore=zscore, counts=cntSum,
                motifs=motifs))
}

#' Output total number of patterns found in the input sequences
#' 
#' Output total number of patterns found in the input sequences
#' 
#' 
#' @param pattern DNAstringSet object
#' @param sequences a vector of sequences
#' @return Total number of occurrence of the pattern in the sequences
#' @author Lihua Julie Zhu
#' @seealso summarizePatternInPeaks, translatePattern
#' @keywords misc
#' @export
#' @importFrom Biostrings reverseComplement
#' @examples
#'   library(Biostrings)
#'   filepath = 
#'     system.file("extdata", "examplePattern.fa", package="ChIPpeakAnno")
#'   dict = readDNAStringSet(filepath = filepath, format="fasta", 
#'                           use.names=TRUE)
#'   sequences = c("ACTGGGGGGGGCCTGGGCCCCCAAAT", 
#'                 "AAAAAACCCCTTTTGGCCATCCCGGGACGGGCCCAT", 
#'                 "ATCGAAAATTTCC")
#'   countPatternInSeqs(pattern=dict[1], sequences=sequences)
#'   countPatternInSeqs(pattern=dict[2], sequences=sequences)
#'   pattern = DNAStringSet("ATNGMAA")
#'   countPatternInSeqs(pattern=pattern, sequences=sequences)
#' 
countPatternInSeqs <- function(pattern, sequences){     
    if(missing(pattern) || !is(pattern, "DNAStringSet" ))
    {
        stop("pattern is required as a DNAStringSet object!")
        
    }
    if (missing(sequences)) {
        stop("No valid sequences passed in!")
    }
    revcomp.pattern = reverseComplement(pattern)
    pattern = as.character(pattern)[[1]]
    pattern = translatePattern(pattern)
    revcomp.pattern = as.character(revcomp.pattern)[[1]]
    revcomp.pattern = translatePattern(revcomp.pattern)
    
    total =0 
    lapply(1:length(sequences), function(i){
        pos.plus = regexpr(pattern, sequences[i], perl=TRUE)[1]
        pos.minus = regexpr(revcomp.pattern, sequences[i], perl=TRUE)[1]
        if (pos.plus >0 || pos.minus >0)
        {
            total <<- total + 1;
        }
    })
    total
}

#' Genomic Element distribution
#' 
#' Plot pie chart for genomic element distribution
#' 
#' @details The distribution will be calculated by geneLevel,
#' ExonIntron, and Exons The geneLevel will be categorized as
#' promoter region, gene body, gene downstream and distal intergenic region.
#' The ExonIntron will be categorized as exon, intron and intergenic.
#' The Exons will be categorized as 5' UTR, 3'UTR and CDS.
#' The precedence will follow the order of labels defination.
#' For example, for ExonIntron, if a peak overlap with both exon and intron, 
#' and exon is specified before intron, then only exon will
#' be incremented for the same example.
#' @param peaks peak list, \link[GenomicRanges:GRanges-class]{GRanges} object or
#' a \link[GenomicRanges:GRangesList-class]{GRangesList}.
#' @param TxDb an object of \code{\link[GenomicFeatures:TxDb-class]{TxDb}}
#' @param seqlev sequence level should be involved. 
#' Default is all the sequence levels in intersect of peaks and TxDb.
#' @param nucleotideLevel Logical. Choose between peak centric and nucleotide
#' centric view. Default=FALSE
#' @param ignore.strand logical. Whether the strand of the input ranges
#' should be ignored or not. Default=TRUE
#' @param promoterRegion numeric. The upstream and downstream of genes to define
#' promoter region.
#' @param promoterLevel list. The breaks, labels, and colors for divided range 
#' of promoters. The breaks must be from 5' -> 3' and the percentage will use
#' the fixed precedence 3' -> 5' 
#' @param geneDownstream numeric. The upstream and downstream of genes to define
#' gene downstream region.
#' @param labels list. A list for labels for the genomic elements.
#' @param labelColors named character vector. The colors for each labels.
#' @param plot logic. Plot the pie chart for the genomic elements or not.
#' @param keepExonsInGenesOnly logic. Keep the exons within annotated gene only.
#' @export
#' @importFrom ggplot2 ggplot geom_rect xlim coord_polar aes_string geom_bar
#' coord_flip scale_fill_manual theme_void theme_bw facet_wrap geom_col 
#' geom_text guide_legend
#' @importFrom GenomicFeatures intronsByTranscript exons fiveUTRsByTranscript 
#' threeUTRsByTranscript genes
#' @importFrom stats as.formula
#' @return Invisible list of data for plot.
#' @examples 
#' if (interactive() || Sys.getenv("USER")=="jou"){
#'   data(myPeakList)
#'   if(require(TxDb.Hsapiens.UCSC.hg19.knownGene)){
#'   seqinfo(myPeakList) <- 
#'   seqinfo(TxDb.Hsapiens.UCSC.hg19.knownGene)[seqlevels(myPeakList)]
#'   myPeakList <- GenomicRanges::trim(myPeakList)
#'   myPeakList <- myPeakList[width(myPeakList)>0]
#'     genomicElementDistribution(myPeakList, 
#'         TxDb.Hsapiens.UCSC.hg19.knownGene)
#'     genomicElementDistribution(myPeakList, 
#'         TxDb.Hsapiens.UCSC.hg19.knownGene,
#'         nucleotideLevel = TRUE)
#'     genomicElementDistribution(myPeakList, 
#'         TxDb.Hsapiens.UCSC.hg19.knownGene,
#'         promoterLevel=list(
#'         #from 5' -> 3', fixed precedence 3' -> 5'
#'         breaks = c(-2000, -1000, -500, 0, 100),
#'         labels = c("upstream 1-2Kb", "upstream 0.5-1Kb", 
#'                    "upstream <500b", "TSS - 100b"),
#'         colors = c("#FFE5CC", "#FFCA99", 
#'                    "#FFAD65", "#FF8E32")))
#'   }
#' }
genomicElementDistribution <- 
  function(peaks, TxDb, seqlev, nucleotideLevel=FALSE, ignore.strand=TRUE,
           promoterRegion=c(upstream=2000, downstream=100),
           geneDownstream=c(upstream=0, downstream=1000),
           labels=list(geneLevel=c(promoter="Promoter",
                                   geneDownstream="Downstream",
                                   geneBody="Gene body",
                                   distalIntergenic="Distal Intergenic"),
                       ExonIntron=c(exon="Exon",
                                    intron="Intron",
                                    intergenic="Intergenic"),
                       Exons=c(utr5="5' UTR",
                               utr3="3' UTR",
                               CDS="CDS",
                               otherExon="Other exon"),
                       group=c(geneLevel="Transcript Level",
                               promoterLevel="Promoter Level",
                               Exons="Exon level",
                               ExonIntron="Exon/Intron/Intergenic")),
           labelColors = c(promoter="#E1F114",
                           geneBody="#9EFF00",
                           geneDownstream="#57CB1B",
                           distalIntergenic="#066A4B",
                           exon="#6600FF",
                           intron="#8F00FF",
                           intergenic="#DA00FF",
                           utr5="#00FFDB",
                           utr3="#00DFFF",
                           CDS="#00A0FF",
                           otherExon="#006FFF"),
           plot = TRUE,
           keepExonsInGenesOnly = TRUE,
           promoterLevel){
    stopifnot("peaks must be an object of GRanges or GRangesList"=
                inherits(peaks, c("GRanges", "GRangesList")))
    if(is(peaks, "GRanges")){
      n <- deparse(substitute(peaks))
      peaks <- GRangesList(peaks)
      names(peaks) <- n
      isGRanges <- TRUE
    }else{
      isGRanges <- FALSE
    }
    stopifnot("TxDb must be an object of TxDb"=is(TxDb, "TxDb"))
    stopifnot("nuleotideLevel is not logical"=is.logical(nucleotideLevel))
    stopifnot("promoterRegion should contain element upstream and downstream"=
                all(c("upstream", "downstream") %in% names(promoterRegion)))
    stopifnot("geneDownstream should contain element upstream and downstream"=
                all(c("upstream", "downstream") %in% names(geneDownstream)))
    stopifnot("Elements in promoterRegion should be numeric"=
                is.numeric(promoterRegion))
    stopifnot("Elements in geneDownstream should be numeric"=
                is.numeric(geneDownstream))
    labs <- list(geneLevel=c(promoter="Promoter",
                             geneDownstream="Downstream",
                             geneBody="Gene body",
                             distalIntergenic="Distal Intergenic"),
                 ExonIntron=c(exon="Exon",
                              intron="Intron",
                              intergenic="Intergenic"),
                 Exons=c(utr5="5' UTR",
                         utr3="3' UTR",
                         CDS="CDS",
                         otherExon="Other exon"))
    groupLabels <- c(geneLevel="Gene Level",
                     promoterLevel="Promoter Level",
                     Exons="Exon level",
                     ExonIntron="Exon/Intron/Intergenic")
    labelCols = c(promoter="#D55E00",
                  geneDownstream="#E69F00",
                  geneBody="#51C6E6",
                  distalIntergenic="#AAAAAA",
                  exon="#009DDA",
                  intron="#666666",
                  intergenic="#DDDDDD",
                  utr5="#0072B2",
                  utr3="#56B4E9",
                  CDS="#0033BF",
                  otherExon="#009E73",
                  undefined="#FFFFFF")
    labelCols[names(labelColors)] <- labelColors
    for(i in names(labs)){
      if(i %in% names(labels)){
        ## keep the orders in labels
        n <- intersect(names(labs[[i]]), names(labels[[i]]))
        labs[[i]] <- c(labels[[i]][n], labs[[i]][!names(labs[[i]]) %in% n])
      }
    }
    
    for(i in names(groupLabels)){
      if("group" %in% names(labels)){
        groupLabels[names(labels[["group"]])] <- labels[["group"]]
      }
    }
    if(!missing(promoterLevel)){
      # stopifnot("promoterLevel must be within promoterRegion"=
      #             all(abs(promoterLevel$breaks[promoterLevel$breaks<0])<=
      #                   promoterRegion["upstream"]) && 
      #             all(abs(promoterLevel$breaks[promoterLevel$breaks>0])<=
      #                   promoterRegion["downstream"]))
      promoterLevel$breaks <- sort(promoterLevel$breaks)
      stopifnot("breaks, labels and colors of promoterLevel are not paired"=
                  length(promoterLevel$breaks)==
                  length(promoterLevel$labels)+1 &&
                  length(promoterLevel$labels)==
                  length(promoterLevel$colors))
      proK <- paste0("promoter", seq_along(promoterLevel$labels))
      promoterLevel$upstream <- ifelse(promoterLevel$breaks<0,
                                       abs(promoterLevel$breaks),
                                       0)
      promoterLevel$upstream <- 
        promoterLevel$upstream[-length(promoterLevel$upstream)]
      promoterLevel$downstream <- ifelse(promoterLevel$breaks>0,
                                         promoterLevel$breaks,
                                         0)
      promoterLevel$downstream <- promoterLevel$downstream[-1]
      proV <- promoterLevel$labels
      names(proV) <- proK
      labs <- c(list("promoterLevel"=proV), 
                labs)
      proV <- promoterLevel$colors
      names(proV) <- proK
      labelCols <- c(proV, labelCols)
    }else{
      promoterLevel <- NULL
    }
    
    defaultW <- getOption("warn")
    options(warn = -1)
    on.exit({warn = defaultW})
    
    seql <- seqlevelsStyle(peaks)
    
    ## set annotation
    anno <- GRangesList()
    for(i in names(labs)){
      anno[[i]] <- switch (i,
        "promoterLevel" = {
          suppressMessages(g <- transcripts(TxDb))
          pro <- mapply(FUN=function(upstream, downstream){
            unique(promoters(g, upstream = upstream, downstream = downstream))
          }, promoterLevel$upstream, 
          promoterLevel$downstream,
          SIMPLIFY = FALSE)
          names(pro) <- names(labs[["promoterLevel"]])
          pro <- rev(pro)
          current_anno <- GRanges()
          for(j in seq_along(pro)){
            ca <- filterByOverlaps(pro[[j]], current_anno,
                                   ignore.strand = ignore.strand)
            mcols(ca) <- DataFrame(type=rep(names(pro)[j], length(ca)))
            current_anno <- c(current_anno, ca)
          }
          current_anno <- formatSeqnames(current_anno, peaks)
          current_anno
        },
        "geneLevel" = {
          suppressMessages(g <- transcripts(TxDb))
          pro <- unique(promoters(g, 
                           upstream = promoterRegion["upstream"],
                           downstream = promoterRegion["downstream"]))
          dws <- downstreams(g,
                             upstream = geneDownstream["upstream"],
                             downstream = geneDownstream["downstream"])
          pro <- GenomicRanges::trim(pro)
          dws <- GenomicRanges::trim(dws)
          intergenic <- gaps(reduce(c(pro, g, dws), ignore.strand=FALSE))
          intergenic <- intergenic[!strand(intergenic) %in% "*"]
          current_anno <- GRanges()
          ## set precedence
          for(j in names(labs[["geneLevel"]])){
            s <- 
              switch(j,
                     "promoter" =pro,
                     "geneDownstream" =dws,
                     "geneBody" =g,
                     "distalIntergenic" =intergenic)
            ca <- 
              filterByOverlaps(s, current_anno,
                               ignore.strand = ignore.strand)
            mcols(ca) <- DataFrame(type=rep(j, length(ca)))
            current_anno <- c(current_anno, ca)
          }
          current_anno <- formatSeqnames(current_anno, peaks)
          current_anno
        },
        "ExonIntron" = {
          exon <- exons(TxDb)
          intron <- unlist(intronsByTranscript(TxDb))
          if(keepExonsInGenesOnly){
            suppressMessages(g <- transcripts(TxDb))
            ole <- findOverlaps(exon, g, type = "within")
            oli <- findOverlaps(intron, g, type = "within")
            ole <- !seq_along(exon) %in% queryHits(ole)
            oli <- !seq_along(intron) %in% queryHits(oli)
            if(sum(ole)>0 || sum(oli)>0){
              warning(paste(sum(ole), "exons were dropped because there is no",
                            "relative gene level annotations.",
                            sum(oli), "introns were dropped because there is no",
                            "relative gene level annotations."))
              exon <- exon[!ole]
              intron <- intron[!oli]
            }
          }
          intergenic <- gaps(reduce(c(exon, intron), ignore.strand=FALSE))
          intergenic <- intergenic[!strand(intergenic) %in% "*"] 
          current_anno <- GRanges()
          ## set precedence
          for(j in names(labs[["ExonIntron"]])){
            s <- 
              switch(j,
                     "exon" =exon,
                     "intron" =intron,
                     "intergenic" =intergenic)
            ca <- 
              filterByOverlaps(s, current_anno,
                               ignore.strand = ignore.strand)
            mcols(ca) <- DataFrame(type=rep(j, length(ca)))
            current_anno <- c(current_anno, ca)
          }
          current_anno <- formatSeqnames(current_anno, peaks)
          current_anno
        },
        "Exons" = {
          utr5 <- unlist(fiveUTRsByTranscript(TxDb))
          utr3 <- unlist(threeUTRsByTranscript(TxDb))
          CDS <- cds(TxDb)
          exon <- exons(TxDb)
          if(keepExonsInGenesOnly){
            suppressMessages(g <- transcripts(TxDb))
            ole <- findOverlaps(exon, g, type = "within")
            olc <- findOverlaps(CDS, g, type = "within")
            ol5 <- findOverlaps(utr5, g, type = "within")
            ol3 <- findOverlaps(utr3, g, type = "within")
            ole <- !seq_along(exon) %in% queryHits(ole)
            olc <- !seq_along(CDS) %in% queryHits(olc)
            ol5 <- !seq_along(utr5) %in% queryHits(ol5)
            ol3 <- !seq_along(utr3) %in% queryHits(ol3)
            if(sum(ole)>0 || sum(olc)>0 || sum(ol5)>0 || sum(ol3)){
              warning(paste(sum(ole), "exons were dropped because there is no",
                            "relative gene level annotations.",
                            sum(olc), "CDS were dropped because there is no",
                            "relative gene level annotations.",
                            sum(ol5), "utr5 were dropped because there is no",
                            "relative gene level annotations.",
                            sum(ol3), "utr3 were dropped because there is no",
                            "relative gene level annotations."))
              exon <- exon[!ole]
              CDS <- CDS[!olc]
              utr5 <- utr5[!ol5]
              utr3 <- utr3[!ol3]
            }
          }
          current_anno <- GRanges()
          ## set precedence
          for(j in names(labs[["Exons"]])){
            s <- 
              switch(j,
                     "utr5" =utr5,
                     "utr3" =utr3,
                     "CDS" =CDS,
                     "otherExon"=exon)
            ca <- 
              filterByOverlaps(s, current_anno,
                               ignore.strand = ignore.strand)
            mcols(ca) <- DataFrame(type=rep(j, length(ca)))
            current_anno <- c(current_anno, ca)
          }
          current_anno <- formatSeqnames(current_anno, peaks)
          current_anno
        }
      )
    }
    groupLabels <- groupLabels[names(anno)]
    groupLabels[is.na(groupLabels)] <- names(anno)[is.na(groupLabels)]
    
    ## filter peaks by seqlev
    if(!missing(seqlev)){
      if(length(seqlev)>0){
        peaks <- lapply(peaks, 
                        function(.ele) .ele[seqnames(.ele) %in% seqlev])
      }
    }
    
    if(nucleotideLevel){
      peaks <- lapply(peaks, function(.ele){
        y <- disjoin(c(.ele, unlist(anno)), ignore.strand=ignore.strand)
        subsetByOverlaps(y, .ele, ignore.strand=ignore.strand)
      })
    }
    
    peaks <- lapply(peaks, FUN = function(.peaks){
      pct <- lapply(anno, FUN = function(.ele){
        y <- .peaks
        ol <- findOverlaps(y, .ele, ignore.strand=ignore.strand)
        ol <- as.data.frame(ol)
        ol <- ol[order(ol$queryHits, ol$subjectHits), ]
        ol <- ol[!duplicated((ol$queryHits)), ]
        mcols(y)[, 'anno'] <- rep("undefined", length(y))
        y$anno[ol$queryHits] <- .ele$type[ol$subjectHits]
        y$anno
      })
      
      pct <- do.call(cbind, pct)
      if( ncol(mcols(.peaks)) ){
        mcols(.peaks) <- cbind(mcols(.peaks), pct)
      }else{
        mcols(.peaks) <- pct
      }
      
      .peaks
    })
    if(isGRanges){
      peaks <- peaks[[1]]
    }
    
    melt <- function(m){
      if(nucleotideLevel){
        m <- m[rep(seq_along(m), width(m))]
      }
      m <- mcols(m)[, names(anno)]
      p <- lapply(names(anno), function(.ele){
        tt <- table(m[, .ele])
        data.frame(category=factor(rep(groupLabels[.ele],
                                       length(tt)), 
                                   levels = groupLabels),
                   type=factor(names(tt), levels = rev(names(labelCols))), 
                   percentage=as.numeric(tt)/sum(tt))
      })
      do.call(rbind, p)
    }
    
    if(isGRanges){## donut-plot
      #dat <- reshape2::melt()
      dat <- melt(peaks)
      l <- unlist(unname(labs))
      l1 <- paste0(l, " (", 
                   round(dat$percentage[match(names(l), dat$type)]*100,
                         digits = 1), "%)")
      names(l1) <- names(l)
      l1 <- c(l1, undefined="")
      p <- ggplot(dat, 
                  aes_string(x="category", y="percentage", 
                             fill="type"))+
        geom_col() +
        coord_polar("y") + 
        geom_text(data = subset(dat, !duplicated(dat$category)),
                  aes_string(x="category", label="category"),
                  y=1) +
        theme_void()

    }else{## bar-plot
      dat <- lapply(peaks, melt)
      dat1 <- do.call(rbind, dat)
      dat1$source <- rep(names(peaks), vapply(dat, nrow, FUN.VALUE = 0))
      l1 <- c(unlist(unname(labs)), undefined="")
      p <- ggplot(dat1, 
                  aes_string(x="source", y="percentage", fill="type")) +
        geom_bar(stat="identity") + coord_flip() +
        facet_wrap(as.formula("~ category"), ncol = 1) + 
        theme_bw()
    }
    p <- p + 
      scale_fill_manual(values = labelCols, labels=l1, name=NULL,
                        guide = guide_legend(reverse=TRUE))
    
    if(plot){
      print(p)
    }
    return(invisible(list(peaks=peaks, plot=p)))
  }

test_that("assignChromosomeRegion works not correct", {
    ##algorithm
    txdb_file <- system.file("extdata", "Biomart_Ensembl_sample.sqlite",
                             package="GenomicFeatures")
    TxDb <- loadDb(txdb_file)
    exons <- exons(TxDb, columns=NULL)
    fiveUTRs <- unique(unlist(fiveUTRsByTranscript(TxDb)))
    Feature.distribution <- 
        genomicElementDistribution(exons, nucleotideLevel=TRUE, TxDb=TxDb)
    expect_true(all(Feature.distribution$peaks$ExonIntron=='exon'))
    Feature.distribution <- 
      genomicElementDistribution(exons, TxDb=TxDb)
    Feature.distribution <- 
      genomicElementDistribution(fiveUTRs, TxDb=TxDb)
    expect_true(all(Feature.distribution$peaks$Exons=='utr5'))
    seqlevelsStyle(fiveUTRs) <- 'UCSC'
    Feature.distribution <- 
      genomicElementDistribution(fiveUTRs, TxDb=TxDb)
    expect_equal(seqlevelsStyle(Feature.distribution$peaks), 'UCSC')
    expect_true(all(Feature.distribution$peaks$Exons=='utr5'))
})

#' coverage of chromosome regions
#' 
#' calculate the coverage of 5'UTR, CDS and 3'UTR per transcript per bin.
#' 
#' 
#' @param cvglists A list of \link[IRanges:AtomicList-class]{SimpleRleList} or
#' \link[IRanges:AtomicList-class]{RleList}. It represents the coverage for
#' samples.
#' @param TxDb An object of \code{\link[GenomicFeatures:TxDb-class]{TxDb}}.  It
#' is used for extracting the annotations.
#' @param upstream.cutoff,downstream.cutoff cutoff length for upstream or
#' downstream of transcript.
#' @param nbinsCDS,nbinsUTR,nbinsUpstream,nbinsDownstream The number of bins
#' for CDS, UTR, upstream and downstream.
#' @param includeIntron A logical value which indicates including intron or
#' not.
#' @param minCDSLen,minUTRLen minimal length of CDS or UTR of transcript.
#' @param maxCDSLen,maxUTRLen maximal length of CDS or UTR of transctipt.
#' @author Jianhong Ou
#' @seealso \link{binOverGene}, \link{plotBinOverRegions}
#' @export
#' @import IRanges
#' @import GenomicRanges
#' @importFrom GenomicFeatures transcripts
#' @importFrom S4Vectors mcols elementMetadata
#' @importFrom BiocGenerics strand start
#' @importFrom GenomeInfoDb seqinfo seqlevels seqnames
#' @examples
#' 
#' if(Sys.getenv("USER")=="jou"){
#' path <- system.file("extdata", package="ChIPpeakAnno")
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' library(rtracklayer)
#' files <- dir(path, "bigWig")
#' if(.Platform$OS.type != "windows"){
#' cvglists <- lapply(file.path(path, files), import,
#'                    format="BigWig", as="RleList")
#' names(cvglists) <- sub(".bigWig", "", files)
#' d <- binOverRegions(cvglists, TxDb.Hsapiens.UCSC.hg19.knownGene)
#' plotBinOverRegions(d)
#' }
#' }
#' 
binOverRegions <- function(cvglists, TxDb, 
                           upstream.cutoff=1000L, 
                           downstream.cutoff=upstream.cutoff, 
                           nbinsCDS=100L, nbinsUTR=20L, 
                           nbinsUpstream=20L,
                           nbinsDownstream=nbinsUpstream,
                           includeIntron=FALSE,
                           minCDSLen=nbinsCDS,
                           minUTRLen=nbinsUTR,
                           maxCDSLen=Inf,
                           maxUTRLen=Inf){
    if(inherits(cvglists, c("SimpleRleList", "RleList", "CompressedRleList"))){
        cvglistsName <- substitute(deparse(cvglists))
        cvglists <- list(cvglists)
        names(cvglists) <- cvglistsName
    }
    if(!is(cvglists, "list")){
        stop("cvglists must be a list of SimpleRleList or RleList")
    }
    cls <- sapply(cvglists, inherits, 
                  what = c("SimpleRleList", "RleList", "CompressedRleList"))
    if(any(!cls))
      stop("cvglists must be a list of SimpleRleList or RleList")
    stopifnot(is(TxDb, "TxDb"))
    stopifnot(maxCDSLen>minCDSLen)
    stopifnot(minCDSLen>=nbinsCDS)
    stopifnot(maxUTRLen>minUTRLen)
    stopifnot(minUTRLen>=nbinsUTR)
    features <- toGRanges(TxDb, feature="geneModel")
    features.reduced <- reduce(features)
    feature_type <- c("upstream", "5UTR", "CDS", "3UTR", "downstream")
    features <- features[features$feature_type %in% c("5UTR", "CDS", "3UTR")]
    transcripts <- transcripts(TxDb, columns=c("tx_name", "gene_id"))
    trx <- unique(mcols(transcripts))
    features$gene_id <- trx[match(features$tx_name, trx$tx_name), "gene_id"]
    features <- features[lengths(features$gene_id)>0]
    features$tx_name <- sapply(features$gene_id, function(.ele) .ele[1])
    features$gene_id <- NULL
    
    features.disjoin <- disjoin(features, with.revmap=TRUE)
    features.disjoin.1 <- 
      features.disjoin[rep(seq_along(features.disjoin),
                           lengths(features.disjoin$revmap))]
    features.disjoin.1$revmap <- unlist(features.disjoin$revmap)
    features.disjoin.1$feature_type <- 
      features$feature_type[features.disjoin.1$revmap]
    features.disjoin.1$tx_name <- features$tx_name[features.disjoin.1$revmap]
    features.disjoin.1$revmap2 <- 
      rep(seq_along(features.disjoin), lengths(features.disjoin$revmap))
    feature_type2 <- 
      split(features.disjoin.1$feature_type, features.disjoin.1$revmap2)
    feature_type2 <- lapply(feature_type2, unique)
    feature_type2 <- feature_type2[lengths(feature_type2)==1]
    features.disjoin.1 <- 
      features.disjoin.1[match(as.numeric(names(feature_type2)),
                               features.disjoin.1$revmap2)]
    features.disjoin.1$seqn <- paste(features.disjoin.1$tx_name, 
                                     features.disjoin.1$feature_type, 
                                     as.character(seqnames(features.disjoin.1)))
    features1 <- GRanges(seqnames = features.disjoin.1$seqn, 
                         ranges = ranges(features.disjoin.1),
                         strand = strand(features.disjoin.1))
    features1 <- reduce(features1)
    mcols(features1) <- 
      data.frame(do.call(rbind, 
                         strsplit(as.character(seqnames(features1)), " ")), 
                 stringsAsFactors=FALSE)
    colnames(mcols(features1)) <- c("tx_name", "feature_type", "seqn")
    features1 <- GRanges(seqnames = features1$seqn, 
                         ranges = ranges(features1),
                         strand = strand(features1),
                         tx_name = features1$tx_name,
                         feature_type = features1$feature_type)
    seqinfo(features1) <- seqinfo(features)[seqlevels(features1)]
    features <- features1
    rm(list=c("features.disjoin", "features.disjoin.1", 
              "feature_type2", "features1"))
    
    txs <- unique(features$tx_name)
    txs <- txs[!is.na(txs)]
    if(includeIntron){
        cds <- features[features$feature_type=="CDS"]
        cds <- GRanges(seqnames = paste(as.character(seqnames(cds)), 
                                        cds$tx_name),
                       ranges = ranges(cds), strand = strand(cds))
        cds <- reduce(cds, min.gapwidth=1e9)
        mcols(cds) <- 
          data.frame(do.call(rbind, 
                             strsplit(as.character(seqnames(cds)), " ")), 
                     stringsAsFactors = FALSE)
        colnames(mcols(cds)) <- c("seqn", "tx_name")
        cds <- GRanges(seqnames = cds$seqn, 
                       ranges = ranges(cds), strand = strand(cds),
                       tx_name = cds$tx_name, feature_type = "CDS")
        seqinfo(cds) <- seqinfo(features)[seqlevels(cds)]
        features <- features[features$feature_type %in% c("5UTR", "3UTR")]
        features <- c(features, cds)
    }
    ## resort by txs
    features <- features[order(as.numeric(factor(features$tx_name, 
                                                 levels = txs)))]
    ## features must contain 5UTR, CDS and 3UTR
    txs <- split(features$feature_type, features$tx_name)
    txs <- lapply(txs, unique)
    txs <- names(txs)[lengths(txs)==3]
    features <- features[features$tx_name %in% txs]
    ## add upstream and downstream
    if(upstream.cutoff>0 && downstream.cutoff>0){
        genes <- GRanges(seqnames = paste(as.character(seqnames(features)), 
                                          features$tx_name),
                         ranges = ranges(features), strand = strand(features))
        genes <- reduce(genes, min.gapwidth=1e9)
        mcols(genes) <- 
          data.frame(do.call(rbind, 
                             strsplit(as.character(seqnames(genes)), " ")),
                     stringsAsFactors = FALSE)
        colnames(mcols(genes)) <- c("seqn", "tx_name")
        genes <- 
          GRanges(seqnames = genes$seqn, 
                  ranges = ranges(genes), strand = strand(genes),
                  tx_name = genes$tx_name)
        seqinfo(genes) <- seqinfo(features)[seqlevels(genes)]
        suppressWarnings({
            upstream <- promoters(genes,
                                  upstream = upstream.cutoff,
                                  downstream = 0)})
        upstream <- trim(upstream)
        upstream <- upstream[width(upstream)>=nbinsUpstream]
        revert.strand <- function(gr){
            l <- as.character(strand(gr))
            l.plus <- which(l=="+")
            l.minus <- which(l=="-")
            if(length(l.plus)>=1){
                l[l.plus] <- "-"
            }
            if(length(l.minus)>=1){
                l[l.minus] <- "+"
            }
            strand(gr) <- l
            gr
        }
        genes.rev.strand <- revert.strand(genes)
        suppressWarnings({downstream <- 
            promoters(genes.rev.strand,
                      upstream = downstream.cutoff,
                      downstream = 0)})
        downstream <- revert.strand(downstream)
        downstream <- trim(downstream)
        downstream <- downstream[width(downstream)>=nbinsDownstream]
        upstream$feature_type <- "upstream"
        downstream$feature_type <- "downstream"
        #remove the overlapping parts
        rmOverlaps <- function(gr, tobeRemoved=features.reduced){
          gr.intersect <- intersect(gr, tobeRemoved, ignore.strand=TRUE)
          gr.intersect$tx_name <- NA
          gr.intersect$feature_type <- NA
          gr.disjoin <- disjoin(c(gr, gr.intersect), 
                                with.revmap=TRUE, ignore.strand=TRUE)
          gr.disjoin <- gr.disjoin[lengths(gr.disjoin$revmap)==1]
          gr.disjoin$revmap <- unlist(gr.disjoin$revmap)
          strand(gr.disjoin) <- strand(gr[gr.disjoin$revmap])
          mcols(gr.disjoin) <- mcols(gr[gr.disjoin$revmap])
          gr.disjoin
        }
        upstream <- rmOverlaps(upstream)
        downstream <- rmOverlaps(downstream)
        features <- c(features, upstream, downstream)
    }
    ## split the features by seqnames and generate Views for cvglist
    seqn <- Reduce(intersect, lapply(cvglists, names))
    seqn <- intersect(seqn, seqlevels(features))
    if(length(seqn)<1){
        stop("Please check the names of cvglist. ",
             "None of them in the seqlevels of TxDb.")
    }
    features <- features[seqnames(features) %in% seqn]
    
    ## make sure no overlaps in all the region 
    features.disjoin <- disjoin(features, with.revmap=TRUE)
    features.disjoin <- features.disjoin[lengths(features.disjoin$revmap)==1]
    features.disjoin$revmap <- unlist(features.disjoin$revmap)
    features.disjoin$feature_type <- 
      features$feature_type[features.disjoin$revmap]
    features.disjoin$tx_name <- features$tx_name[features.disjoin$revmap]
    features.disjoin$revmap <- NULL
    features.disjoin.tx_name <- 
      split(features.disjoin$feature_type, features.disjoin$tx_name)
    features.disjoin.tx_name <- lapply(features.disjoin.tx_name, unique)
    features.disjoin.tx_name <- 
      names(features.disjoin.tx_name)[lengths(features.disjoin.tx_name) ==
                                        max(lengths(features.disjoin.tx_name))]
    features.disjoin <- features.disjoin[features.disjoin$tx_name %in% 
                                           features.disjoin.tx_name]
    seqinfo(features.disjoin) <- seqinfo(features)[seqlevels(features.disjoin)]
    features <- features.disjoin
    rm(features.disjoin)
    ## make sure features are sorted by pos
    features <- 
      features[order(
        as.numeric(factor(features$tx_name, 
                          levels = txs)),
        as.numeric(factor(features$feature_type,
                          levels = 
                            feature_type[feature_type %in% 
                                           unique(
                                             features$feature_type)])),
                     start(features))]
    
    ## filter by minCDSLen, min5UTR, min3UTR
    filterByLen <- function(type, minlen, maxLen){
        x <- features[features$feature_type %in% type]
        if(length(x)<1) return(x)
        x.width <- rowsum(width(x), x$tx_name, reorder = FALSE)
        rownames(x.width)[x.width[, 1] >= minlen & x.width[, 1] < maxLen]
    }
    txs <- Reduce(intersect, mapply(filterByLen, 
                                    c("CDS", "5UTR", "3UTR", 
                                      "upstream", "downstream"), 
                                    c(minCDSLen, minUTRLen, minUTRLen, 
                                      nbinsUpstream, nbinsDownstream),
                                    c(maxCDSLen, maxUTRLen, maxUTRLen,
                                      Inf, Inf)))
    if(length(txs)<2){
        stop("less than 2 CDS left.")
    }
    features <- features[features$tx_name %in% txs]
    ## features must contain 5UTR, CDS, 3UTR, and/or upstream, downstream.
    txs <- split(features$feature_type, features$tx_name)
    txs <- lapply(txs, unique)
    txs <- names(txs)[lengths(txs)==length(unique(features$feature_type))]
    if(length(txs)<2){
      stop("less than 2 CDS left.")
    }
    features <- features[features$tx_name %in% txs]
    ## calculate fators to balance the region be count multiple times
    len <- length(unique(features$tx_name))
    features.s <- split(features, seqnames(features))
    features.s <- features.s[seqn]
    cvglists <- lapply(cvglists, function(.ele) .ele[seqn])
    features.l <- as(features.s, "IntegerRangesList")
    
    bins=c("upstream"=nbinsUpstream,
           "5UTR"=nbinsUTR,
           "CDS" =nbinsCDS,
           "3UTR"=nbinsUTR,
           "downstream"=nbinsDownstream)
    
    features.view <- lapply(cvglists, function(.ele) {
      vw <- Views(.ele, features.l)
      cntByChr <- lapply(vw, function(.vw){
        .df <- elementMetadata(.vw)
        .gr <- GRanges(paste(.df$feature_type, .df$tx_name), ranges(.vw), 
                       feature_type=.df$feature_type, tx_name=.df$tx_name)
        .gr.s <- split(.gr, seqnames(.gr))
        .cvg <- subject(.vw)
        .cvgs <- rep(list(.cvg), length(.gr.s))
        .gr.l <- as(.gr.s, "IntegerRangesList")
        names(.cvgs) <- names(.gr.l)
        .cvgs <- as(.cvgs, "SimpleRleList")
        .cvg.sub <- .cvgs[.gr.l]
        ### split the RleList into bins
        .ir <- IRanges(rep(1, length(.cvg.sub)), lengths(.cvg.sub))
        .ir <- IRanges::tile(.ir, n=bins[sub("^(.*?) .*$", "\\1", 
                                             names(.cvg.sub))])
        names(.ir) <- names(.cvg.sub)
        .cnt <- viewMeans(Views(.cvg.sub, .ir))
        .cnt <- split(.cnt, sub("^(.*?) .*$", "\\1", names(.cnt)))
        ## make sure 5'->3'
        .cnt <- lapply(.cnt, function(x){
          strd <- 
            as.character(strand(features))[match(sub("^(.*?) (.*$)", "\\2", 
                                                     names(x)), 
                                                 features$tx_name)]
          x <- split(x, strd)
          x <- lapply(x, do.call, what=rbind)
          if("-" %in% names(x)){
            x[["-"]] <- x[["-"]][, ncol(x[["-"]]):1, drop=FALSE]
          }
          do.call(rbind, x)
        })
        lapply(.cnt, colSums)
      })
      cntByFeature <- swapList(cntByChr)
      cntByFeature <- lapply(cntByFeature, function(.ele){
        colSums(do.call(rbind, .ele))/len
      })
    })
    d <- swapList(features.view)
    d <- d[feature_type[feature_type %in% names(d)]]
    d <- lapply(d, do.call, what=cbind)
    return(d)
}




#' plot the coverage of regions
#' 
#' plot the output of \link{binOverRegions} or \link{binOverGene}
#' 
#' 
#' @param dat A list of matrix which indicate the coverage of regions per bin
#' @param ... Parameters could be used by \link[graphics]{matplot}
#' @author Jianhong Ou
#' @seealso \link{binOverRegions}, \link{binOverGene}
#' @export
#' @importFrom S4Vectors elementNROWS
#' @importFrom graphics abline axis legend matplot
#' @examples
#' 
#' if(interactive()){
#' path <- system.file("extdata", package="ChIPpeakAnno")
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' library(rtracklayer)
#' files <- dir(path, "bigWig")
#' if(.Platform$OS.type != "windows"){
#' cvglists <- lapply(file.path(path, files), import,
#'                    format="BigWig", as="RleList")
#' names(cvglists) <- sub(".bigWig", "", files)
#' d <- binOverGene(cvglists, TxDb.Hsapiens.UCSC.hg19.knownGene)
#' plotBinOverRegions(d)
#' }
#' }
#' 
plotBinOverRegions <- function(dat, ...){
    feature_type <- c("upstream", "5UTR", "CDS", "gene", "3UTR", "downstream")
    if(!all(names(dat) %in% feature_type)){
        stop("names of dat must be upstream, 5UTR, CDS, 3UTR or downstream")
    }
    feature_type <- feature_type[feature_type %in% names(dat)]
    dat <- dat[feature_type]
    bins <- elementNROWS(dat)
    dat <- do.call(rbind, dat)
    matplot(dat, type = "l", xaxt="n", ...)
    bins.sum <- cumsum(bins) + .5
    bins.sum <- bins.sum[-length(bins.sum)]
    abline(v = bins.sum, lty=2, col="gray")
    axis(side = 1, at = bins.sum, 
         labels = rep("", length(bins.sum)), 
         tick = TRUE, lwd=-1, lwd.ticks=1, ...)
    bins.sum2 <- c(0, bins.sum) + bins/2
    axis(side = 1, at = bins.sum2, 
         labels = feature_type, lwd=-1, ...)
    legend.arg <- formals("legend")
    legend.arg.names <- names(legend.arg)
    legend.arg$x <- "topright"
    legend.arg$box.col <- NA
    legend.arg$merge <- FALSE
    legend.arg$legend <- colnames(dat)
    matplot.arg <- formals("matplot")
    for(arg in c("col", "lty", "lwd", "bg")){
        legend.arg[[arg]] <- matplot.arg[[arg]]
    }
    legend.arg <- c(list(...), legend.arg)
    legend.arg <- legend.arg[!duplicated(names(legend.arg))]
    legend.arg <- legend.arg[legend.arg.names]
    legend.arg <- legend.arg[lengths(legend.arg)>0]
    cex <- 1
    text.col <- par("col")
    text.font <- NULL
    if(is.null(legend.arg[["cex"]])){
      legend.arg[["cex"]] <- cex
    }
    do.call(legend, legend.arg)
}

test_that("binOverRegions or binOverGene works not correct", {
    ##algorithm
    library(TxDb.Hsapiens.UCSC.hg38.knownGene)
    if(Sys.getenv("USER")[1]=="jianhongou"){
        TxDb <- TxDb.Hsapiens.UCSC.hg38.knownGene
        x <- isActiveSeq(TxDb)
        x[seq_along(x)] <- FALSE
        x["chrX"] <- TRUE
        isActiveSeq(TxDb) <- x
        utr5 <- fiveUTRsByTranscript(TxDb)
        utr3 <- threeUTRsByTranscript(TxDb)
        CDS <- cds(TxDb)
        gene <- genes(TxDb)
        exon <- exons(TxDb)
        txs <- transcripts(TxDb)
        utr5 <- unlist(utr5)
        utr3 <- unlist(utr3)
        prom <- promoters(gene, upstream=1000, downstream=0)
        anno <- list("5UTR"=utr5,
                     "3UTR"=utr3,
                     "CDS" =CDS,
                     "gene"=gene,
                     "exon"=exon,
                     "txs" =txs,
                     "prom"=prom)
        anno.rd <- lapply(anno, reduce)
        cvglists.rd <- lapply(anno.rd, coverage)
        d1 <- binOverRegions(cvglists.rd, TxDb)
        d2 <- binOverGene(cvglists.rd, TxDb)
        plotBinOverRegions(d1, main="binOverRegions.reduced")
        plotBinOverRegions(d2, main="binOverGene.reduced")
    }
})

#' Condense matrix by colnames
#' 
#' Condense matrix by colnames
#' 
#' 
#' @param mx a matrix to be condensed
#' @param iname the name of the column to be condensed
#' @param sep separator for condensed values,default ;
#' @param cnt TRUE/FALSE specifying whether adding count column or not?
#' @return dataframe of condensed matrix
#' @author Jianhong Ou, Lihua Julie Zhu
#' @keywords misc
#' @export
#' @examples
#' 
#' a<-matrix(c(rep(rep(1:5,2),2),rep(1:10,2)),ncol=4)
#' colnames(a)<-c("con.1","con.2","index.1","index.2")
#' condenseMatrixByColnames(a,"con.1")
#' condenseMatrixByColnames(a,2)
#' 
condenseMatrixByColnames <- function(mx,iname,sep=";",cnt=FALSE){
    if(!is(mx, "matrix")) stop("mx must be matrix\n")
    if(length(iname)!=1) stop("iname must be single colname\n")
    m_cname<-colnames(mx)
    if(is(iname, "numeric") &iname<=length(m_cname)) iname<-m_cname[iname]
    cnames<-m_cname[which(m_cname!=iname)]
    if(length(m_cname)==length(cnames)) 
        stop("the colum name specified for condense does not exist")
    m_split<-split(mx[,cnames],mx[,iname])
    colN<-length(cnames)
    m_list<-lapply(m_split,function(.ele){
        x<-apply(matrix(.ele,nrow=colN,byrow=TRUE),1,base::paste,collapse=sep)
        if(cnt) {
            unlist(lapply(x, function(w){
                tmp<-unique(as.character(unlist(strsplit(w,sep))))
                c(paste(tmp,collapse=sep),length(tmp))
            }))
        }else{
            unlist(lapply(x, function(w){
                tmp<-unique(as.character(unlist(strsplit(w,sep))))
                paste(tmp,collapse=sep)}))
        }
    })
    m_dat<-as.data.frame(do.call(rbind,m_list))
    m_dat$index<-rownames(m_dat)
    cnames.cnt<-c()
    for(i in cnames){
        if(cnt) cnames.cnt<-c(cnames.cnt,i,paste(i,"count",sep="."))
        else cnames.cnt<-c(cnames.cnt,i)
    }
    colnames(m_dat)<-c(cnames.cnt,iname)
    m_dat<-m_dat[,c(iname,cnames.cnt)]
    m_dat
}

#' Make Venn Diagram from a list of peaks
#' @description Make Venn Diagram from two or more peak ranges, 
#' Also calculate p-value to  determine whether those peaks 
#' overlap significantly.
#' @param Peaks A list of peaks in \link[GenomicRanges:GRanges-class]{GRanges}
#'  format: See example below.
#' @param NameOfPeaks Character vector to specify the name of Peaks, 
#' e.g., c("TF1", "TF2"). This will be used as label in the Venn Diagram.
#' @param maxgap,minoverlap Used in the internal call to 
#' \code{findOverlaps()} to detect overlaps.
#' See \code{?\link[IRanges:findOverlaps-methods]{findOverlaps}} 
#' in the \pkg{IRanges} package for a description of these arguments.
#' @param totalTest Numeric value to specify the total number of tests 
#' performed to obtain the list of peaks. It should be much larger than 
#' the number of peaks in the largest peak set.
#' @param by "region", "feature" or "base", default = "region". 
#' "feature" means using feature field in the GRanges for calculating overlap, 
#' "region" means using chromosome range for calculating overlap, 
#' and "base" means calculating overlap in nucleotide level.
#' @param ignore.strand Logical: when set to TRUE, the strand information is
#' ignored in the overlap calculations.
#' @param connectedPeaks If multiple peaks involved in overlapping in 
#' several groups, set it to "merge" will count it as only 1, 
#' while set it to "min" will count it as the minimal involved peaks in 
#' any connected peak group. "keepAll" will show all the orginal counts 
#' for each list while the final counts will be same as "min". 
#' "keepFirstListConsistent" will keep the counts consistent with first list.
#' @param method method to be used for p value calculation. 
#' hyperG means hypergeometric test and permutation means \link{peakPermTest}.
#' @param TxDb An object of \link[GenomicFeatures:TxDb-class]{TxDb}.
#' @param plot logical. If TRUE (default), a venn diagram is plotted. 
#' @param \dots Additional arguments to be passed to 
#' \link[VennDiagram:venn.diagram]{venn.diagram}.
#' @details For customized graph options, 
#' please see venn.diagram in VennDiagram package.
#' @return A p.value is calculated by
#' hypergeometric test or permutation test to determine whether the overlaps of 
#' peaks or features are significant.
#' @importFrom VennDiagram venn.diagram
#' @importFrom grid textGrob gList grid.newpage
#' @export
#' @author Lihua Julie Zhu, Jianhong Ou
#' @seealso \link{findOverlapsOfPeaks}, 
#' \link[VennDiagram:venn.diagram]{venn.diagram}, \link{peakPermTest}
#' @examples 
#' if (interactive()){
#' peaks1 <- GRanges(seqnames=c("1", "2", "3"),
#'                   IRanges(start=c(967654, 2010897, 2496704),
#'                           end=c(967754, 2010997, 2496804), 
#'                           names=c("Site1", "Site2", "Site3")),
#'                   strand="+",
#'                   feature=c("a","b","f"))
#' peaks2 = GRanges(seqnames=c("1", "2", "3", "1", "2"), 
#'                  IRanges(start = c(967659, 2010898,2496700,
#'                                    3075866,3123260),
#'                          end = c(967869, 2011108, 2496920, 
#'                                  3076166, 3123470),
#'                          names = c("t1", "t2", "t3", "t4", "t5")), 
#'                  strand = c("+", "+", "-", "-", "+"), 
#'                  feature=c("a","b","c","d","a"))
#' makeVennDiagram(list(peaks1, peaks2), NameOfPeaks=c("TF1", "TF2"),
#'                 totalTest=100,scaled=FALSE, euler.d=FALSE, 
#'                 fill=c("#009E73", "#F0E442"), # circle fill color
#'                 col=c("#D55E00", "#0072B2"), #circle border color
#'                 cat.col=c("#D55E00", "#0072B2"))
#' 
#' makeVennDiagram(list(peaks1, peaks2), NameOfPeaks=c("TF1", "TF2"),
#'                 totalTest=100, 
#'                 fill=c("#009E73", "#F0E442"), # circle fill color
#'                 col=c("#D55E00", "#0072B2"), #circle border color
#'                 cat.col=c("#D55E00", "#0072B2"))
#' 
#' ###### 4-way diagram using annotated feature instead of chromosome ranges
#' 
#' makeVennDiagram(list(peaks1, peaks2, peaks1, peaks2), 
#'                 NameOfPeaks=c("TF1", "TF2","TF3", "TF4"), 
#'                 totalTest=100, by="feature",
#'                 main = "Venn Diagram for 4 peak lists",
#'                 fill=c(1,2,3,4))
#' }
#' @keywords graph
#' 

makeVennDiagram <- function(Peaks, NameOfPeaks, maxgap=-1L, minoverlap=0L,
                            totalTest, by=c("region", "feature", "base"), 
                            ignore.strand=TRUE, 
                            connectedPeaks=c("min", "merge", "keepAll", 
                                             "keepFirstListConsistent"), 
                            method=c("hyperG", "permutation"), 
                            TxDb, plot=TRUE,
                            ...){
  ###Functions to be used
  getCountsList<-function(counts){
    CountsList <- list()
    cnt <- 1
    for(i in 1:length(counts)){
      CountsList[[i]] <- seq(cnt, length.out=counts[i])
      cnt <- cnt+counts[i]
    }
    CountsList
  }
  getVennList<-function(a, NameOfPeaks, CountsList){
    .x<-lapply(NameOfPeaks, function(.ele, cl, a){
      .y<-c()
      for(i in 1:nrow(a)){
        if(a[i,.ele]!=0) .y <- c(.y, cl[[i]])
      }
      .y
    }, CountsList, a)
    names(.x)<-NameOfPeaks
    .x
  }
  plotVenn<-function(venn_cnt, vennx, otherCounts=NULL, ...){
    dots <- list(...)
    if(is.null(dots$cat.cex)) dots$cat.cex = 1
    if(is.null(dots$cat.col)) dots$cat.col = "black"
    if(is.null(dots$cat.fontface)) dots$cat.fontface = "plain"
    if(is.null(dots$cat.fontfamily)) dots$cat.fontfamily = "serif"
    
    op=par(mar=c(0,0,0,0))
    on.exit(par(op))
    grid.newpage()
    dots$x <- vennx
    if(!'disable.logging' %in% names(dots)){
      dots <- c(dots, disable.logging = TRUE)
    }
    ## must returns the grid object itself
    if('filename' %in% names(dots)){
      dots$filename <- NULL
    }
    dots <- c(dots, filename=list(NULL))
    suppressMessages(venngrid <- do.call(venn.diagram, dots))
    #unlink(dir(pattern="^VennDiagram[0-9_\\-]+.log$")) ## delete the log file
    if(grepl("^count\\.", colnames(venn_cnt)[ncol(venn_cnt)]) && 
           connectedPeaks=="keepAll"){
        n <- which(colnames(venn_cnt)=="Counts")-1
        venn_cnt.Counts.gt.1 <- rowSums(venn_cnt[ ,1:n]) > 1
        counts <- venn_cnt[-1,"Counts"]
        counts <- counts[counts!=0]
        if(!any(duplicated(counts))){## there is no duplicated counts number
            w <- 1
            for(i in 1:length(venngrid)){
                if(inherits(venngrid[[i]], what="text") && w<nrow(venn_cnt)){
                    w <- w+1
                    cnt <- as.numeric(venngrid[[i]]$label)
                    if(!is.na(cnt) && cnt!=0){
                        j <- which(venn_cnt[,n+1]==cnt)
                        if(venn_cnt.Counts.gt.1[j]){
                            labels <- venn_cnt[j, -(1:(n+1))]
                            if(nrow(venn_cnt)==4 && sum(venn_cnt[,4]) < 
                                   sum(venn_cnt[,5])){
                                labels <- rev(labels)
                            }
                            labels <- paste(as.character(labels[labels>0]),
                                            collapse="/", sep="")
                            if(labels!="") venngrid[[i]]$label <- 
                                paste(venngrid[[i]]$label, "(", 
                                      labels, ")", sep="")
                        }
                    }
                }
            }
        }else{##otherwise guess the order of the number, 
              ##Bugs, the map order maybe wrong
            j <- 1
            map <- switch(as.character(nrow(venn_cnt)),
                          '4'=c(3, 4, 2),
                          '8'=c(5, 7, 3, 6, 8, 4, 2),
                          '16'=c(3, 4, 2, 11, 12, 16, 8, 6, 9, 10, 
                                 14, 15, 7, 5, 13),
                          '32'=c(17, 9, 5, 3, 2, 6, 18, 19, 25, 10, 13, 21, 7, 
                                 11, 4, 8, 22, 20, 27, 26, 30, 29, 23, 
                                 15, 12, 16, 24, 28, 30, 31, 32))
            for(i in 1:length(venngrid)){
                if(inherits(venngrid[[i]], what="text") && j<length(map)){
                    while(j < length(map) && as.numeric(venngrid[[i]]$label) != 
                              venn_cnt[map[j],n+1]) j <- j+1
                    if(as.numeric(venngrid[[i]]$label) == venn_cnt[map[j],
                                                                   n+1] && 
                           j <= length(map)){
                        if(venn_cnt.Counts.gt.1[map[j]]){
                            labels <- venn_cnt[map[j], -(1:(n+1))]
                            labels <- paste(as.character(labels[labels>0]), 
                                            collapse="/", sep="")
                            if(labels!="") 
                                venngrid[[i]]$label <- 
                                paste(venngrid[[i]]$label, "(", 
                                      labels, ")", sep="")
                        }
                        j <- j+1
                    }
                }
            }
        }
    }
    if(!is.null(otherCounts)){
      tmp <- textGrob(label=paste("others:", otherCounts), x=0.9, y=0.1, 
                      gp=gpar(col = "black", cex = dots$cat.cex, 
                              fontface = dots$cat.fontface, 
                              fontfamily = dots$cat.fontfamily))
      venngrid <- gList(venngrid, tmp)
    }
    grid.draw(venngrid)
  }
  getPval<-function(venn_cnt, totalTest){
    n <- which(colnames(venn_cnt)=="Counts") - 1 ##ncol(venn_cnt)-1
    s <- apply(venn_cnt[,1:n], 1, sum)
    venn_cnt_s <- venn_cnt[s==2, , drop=FALSE]
	  for(i in 1:nrow(venn_cnt_s)){
		  venn_cnt_s[i,n+1] <- 
              sum(venn_cnt[as.numeric(venn_cnt[,1:n]%*%venn_cnt_s[i,1:n])==2,
                           n+1,drop=TRUE])
	  }
    cnt <- venn_cnt[,n+1]
    cnt_s <- apply(venn_cnt[,1:n], 2, function(.ele){
      sum(cnt[as.logical(.ele)])
    })
    p.value <- apply(venn_cnt_s, 1, function(.ele){
      ab <- cnt_s[as.logical(.ele[1:n])]
      a <- ab[1]
      b <- ab[2]
      a.and.b <- .ele[(n+1)]
      phyper <- phyper(a.and.b-1, b, totalTest-b, a, 
                       lower.tail=FALSE, log.p=FALSE)
    })
    cbind(venn_cnt_s[, 1:n, drop=FALSE], pval=p.value)
  }
  ###check inputs
  method <- match.arg(method)
  if (missing(totalTest) && method=="hyperG")
  {
    message("Missing totalTest! totalTest is required for HyperG test. 
If totalTest is missing, pvalue will be calculated by estimating 
the total binding sites of encoding region of human.
totalTest = humanGenomeSize * (2%(codingDNA) + 
             1%(regulationRegion)) / ( 2 * averagePeakWidth )
          = 3.3e+9 * 0.03 / ( 2 * averagePeakWidth)
          = 5e+7 /averagePeakWidth")
  }
  if (missing(Peaks))
  {
    stop("Missing Peaks which is a list of peaks in GRanges!")
  }
  connectedPeaks <- match.arg(connectedPeaks)
  stopifnot(is.logical(plot))
  by <- match.arg(by)
  n1 = length(Peaks)
  olout_flag <- FALSE
  if(is(Peaks, "overlappingPeaks")){
    if(!is.null(Peaks$venn_cnt) && is(Peaks$venn_cnt, "VennCounts")){
        venn_cnt <- Peaks$venn_cnt
        n1 <- which(colnames(venn_cnt)=="Counts") - 1 ##ncol(venn_cnt)-1
        if(missing(NameOfPeaks)){
            NameOfPeaks <- colnames(venn_cnt)[1:n1]
        }
        olout_flag <- TRUE
    }else{
        stop("Input is object of overlappingPeaks. 
             But it does not have venn counts data.")
    }
  }
  if (missing(NameOfPeaks) ||  mode(NameOfPeaks) != "character")
  {
    warning("Missing required character vector NameOfPeaks. 
            NameOfPeaks will be extract from the names of input Peaks.")
    NameOfPeaks <- names(Peaks)
    if(is.null(NameOfPeaks)){
      NameOfPeaks <- paste("peaks", 1:length(Peaks), sep="")
    }
  }
  n2 = length(NameOfPeaks)
  if (n1 <2)
  {
    stop("The number of element in Peaks is less than 1, 
         need at least 2 peak ranges!")
  }
  if (n1 > 5) stop("The length of input peaks list should no more than 5")
  if (n1 > n2)
  {
     stop("The number of element in NameOfPeaks is less 
          than the number of elements in Peaks, need to be equal!")
  }
  if (n1 < n2)
  {
    warning("The number of element in NameOfPeaks is larger than 
            the number of elements in Peaks! 
            NameOfPeaks will be cut by the length of Peaks")
    NameOfPeaks <- NameOfPeaks[1:n1]
  }
  NameOfPeaks <- make.names(NameOfPeaks, unique=TRUE, allow_=TRUE)
  if(!olout_flag){
      for(i in seq_len(n1)){
        if (!inherits(Peaks[[i]], c("GRanges")))
        {
          err.msg = paste("Element", i, 
                          "in Peaks is not a valid GRanges object", sep=" ")
          stop(err.msg)
        }
        if (is.null(names(Peaks[[i]]))) names(Peaks[[i]]) <-  
            formatC(1:length(Peaks[[i]]), 
                    width=nchar(length(Peaks[[i]])), 
                    flag="0")
      }
      if(!missing(totalTest)){
          if(totalTest < max(sapply(Peaks, length))){
              stop("totaltest specifies the total number of possible peaks 
                   in the testing space. It should be larger than the largest
                   peak numbers in the input sets. Please see more details 
                   at http://pgfe.umassmed.edu/ChIPpeakAnno/FAQ.html")
          }
      }
      names(Peaks) <- NameOfPeaks
      venn_cnt <- 
        getVennCounts(Peaks, maxgap=maxgap, 
                      minoverlap=minoverlap, 
                      by=by, ignore.strand=ignore.strand, 
                      connectedPeaks=
                        ifelse(connectedPeaks=="keepFirstListConsistent", 
                               "keepAll", connectedPeaks))
  }
  colnames(venn_cnt)[1:n1] <- NameOfPeaks
  venn_cnt1 <- venn_cnt
  if(connectedPeaks=="keepFirstListConsistent"){ ## keepAll to getVennCounts
    if(!grepl("^count\\.", colnames(venn_cnt)[ncol(venn_cnt)])){
      warning("If connectedPeaks set to keepFirstListConsistent,",
              "connectedPeaks of findOverlapsOfPeaks must be keepAll.",
              "Setting connectedPeaks to default.")
    }else{
      venn_cnt1[venn_cnt[, 1]==1, "Counts"] <- venn_cnt[venn_cnt[, 1]==1, n1+2]
    }
    connectedPeaks <- "min"
  }
  Counts <- getCountsList(venn_cnt1[,"Counts"])
  vennx <- getVennList(venn_cnt1, NameOfPeaks, Counts)
  if(method=="hyperG"){
      if(!missing(totalTest)){
          otherCount <- totalTest - sum(venn_cnt[, "Counts"])
          venn_cnt[1, "Counts"] <- otherCount
          p.value <- getPval(venn_cnt, totalTest)
      }else{
          otherCount <- venn_cnt[1, "Counts"]
          if(is(Peaks, "overlappingPeaks")){
              averagePeakWidth = median(unlist(lapply(Peaks$peaklist, width)))
          }else{
              averagePeakWidth = median(unlist(lapply(Peaks, width))) 
          }
          
          p.value <- getPval(venn_cnt, round(5e+7/averagePeakWidth))
      }
  }else{
      ##method=="permutation"
      p.value <- NA
      if(olout_flag){
          warning("Input is an object of overlappingPeaks.
                  Can not do permutation test. Please try ?peakPermTest")
      }else{
          if(missing(TxDb)){
              warning("TxDb is missing. Please try ?peakPermTest later.")
          }else{
              n <- which(colnames(venn_cnt)=="Counts") - 1 ##ncol(venn_cnt)-1
              s <- apply(venn_cnt[,1:n], 1, sum)
              venn_cnt_s <- venn_cnt[s==2, , drop=FALSE]
              p.value <- apply(venn_cnt_s, 1, function(.ele){
                  AB <- Peaks[as.logical(.ele)]
                  pt <- peakPermTest(AB[[1]], AB[[2]], TxDb=TxDb, ...)
                  pt$pval
              })
              p.value <- cbind(venn_cnt_s[, 1:n, drop=FALSE], pval=p.value)
          }
      }
      if(!missing(totalTest)){
          otherCount <- totalTest - sum(venn_cnt[, "Counts"])
          venn_cnt[1, "Counts"] <- otherCount
      }else{
          otherCount <- venn_cnt[1, "Counts"]
      }
  }
  if(otherCount==0) otherCount <- NULL
  if(plot) {
    plotVenn(venn_cnt1, vennx, otherCounts=otherCount, ...)
  }
  return(list(p.value=p.value, vennCounts=venn_cnt))
}

test_that("makeVennDiagram works not correct", {
    peaks1 = GRanges(seqnames = c("1", "2", "3"), 
                     IRanges(start = c(967654, 2010897, 2496704),
                             end = c(967754, 2010997, 2496804), 
                             names = c("Site1", "Site2", "Site3")),
                     strand="+",
                     feature=c("a","b","f"))
    peaks2 = GRanges(seqnames = c("1", "2", "3", "1", "2"), 
                     IRanges(start = c(967659, 2010898, 2496700,
                                       3075866, 3123260),
                             end = c(967869, 2011108, 2496920, 
                                     3076166, 3123470),
                             names = c("t1", "t2", "t3", "t4", "t5")), 
                     strand = c("+", "+", "+","-", "+"), 
                     feature=c("a","b","c","d","a"))
    x<-makeVennDiagram(GRangesList(peaks1, peaks2), 
                       NameOfPeaks=c("TF1", "TF2"),
                       totalTest=100)
    expect_true(x$p.value[1,"pval"] - 6.184292e-05 < 1e-05)
    expect_equal(x$vennCounts[,"Counts"], c(95, 2, 0, 3))
    
    y<-makeVennDiagram(GRangesList(peaks1, peaks2, peaks1, peaks2), 
                       NameOfPeaks=c("TF1", "TF2","TF3", "TF4"),
                       totalTest=100, by="feature")
    expect_true(y$p.value[y$p.value[, "TF1"]==1 & 
                                     y$p.value[, "TF2"]==1,"pval"] - 
                       0.003586889 < 0.001)
    expect_true(y$p.value[y$p.value[, "TF1"]==1 & 
                                     y$p.value[, "TF3"]==1,"pval"] - 
                       6.184292e-06 < 1e-06)
    expect_true(y$p.value[y$p.value[, "TF2"]==1 & 
                                     y$p.value[, "TF3"]==1,"pval"] -
                       0.003586889 < 0.001)
    expect_true(y$p.value[y$p.value[, "TF1"]==1 & 
                                     y$p.value[, "TF4"]==1,"pval"] - 
                       0.003586889 < 0.001)
    expect_true(y$p.value[y$p.value[, "TF3"]==1 & 
                                     y$p.value[, "TF4"]==1,"pval"] -
                       0.003586889 < 0.001)
    expect_equal(y$vennCounts[,"Counts"], 
                       c(95, 0, 0, 0, 0, 2, 0, 0, 0, 0, 1, 0, 0, 0, 0, 2))
    ##test 0 overlaps
    peaks1 = GRanges(seqnames = c("1", "1", "1"), 
                     IRanges(start = c(1, 100, 200),
                             end = c(2, 101, 201), 
                             names = c("Site1", "Site2", "Site3")),
                     strand="+",
                     feature=c("a","b","f"))
    peaks2 = GRanges(seqnames = c("1", "1", "1"), 
                     IRanges(start = c(1, 100, 200),
                             end = c(2, 101, 201), 
                             names = c("Site1", "Site2", "Site3")),
                     strand="+",
                     feature=c("a","b","f"))
    suppressWarnings(makeVennDiagram(GRangesList(peaks1,peaks2), 
                                     NameOfPeaks=c("TF1", "TF2"),
                                     totalTest=100,scaled=F, euler.d=F))
    
    peaks1 = GRanges(seqnames = c("1", "1", "1"), 
                     IRanges(start = c(1, 100, 200),
                             end = c(2, 101, 201), 
                             names = c("Site1", "Site2", "Site3")),
                     strand="+",
                     feature=c("a","b","f"))
    peaks2 = GRanges(seqnames = c("2", "2", "2"), 
                     IRanges(start = c(1, 100, 200),
                             end = c(2, 101, 201), 
                             names = c("Site1", "Site2", "Site3")),
                     strand="+",
                     feature=c("a","b","f"))
    suppressWarnings(makeVennDiagram(GRangesList(peaks1,peaks2), 
                                     NameOfPeaks=c("TF1", "TF2"),
                                     totalTest=100,scaled=F, euler.d=F))
    
    peaks1 = GRanges(seqnames = c("1", "1", "1"), 
                     IRanges(start = c(1, 100, 200),
                             end = c(2, 101, 201), 
                             names = c("Site1", "Site2", "Site3")),
                     strand="+",
                     feature=c("a","b","f"))
    peaks2 = GRanges(seqnames = c("1", "1", "1"),
                     IRanges(start = c(5, 105, 205),
                             end = c(6, 106, 206), 
                             names = c("Site1", "Site2", "Site3")), 
                     strand="+",
                     feature=c("a","b","f"))
    suppressWarnings(makeVennDiagram(GRangesList(peaks1,peaks2), 
                                     NameOfPeaks=c("TF1", "TF2"),
                                     totalTest=100,scaled=F, euler.d=F))
    
    peaks1 = GRanges(seqnames = c("1", "1", "1"),
                     IRanges(start = c(1, 100, 200),
                             end = c(2, 101, 201), 
                             names = c("Site1", "Site2", "Site3")),
                     strand="+",
                     feature=c("a","b","f"))
    peaks2 = GRanges(IRanges(start = c(1, 100, 200),
                             end = c(1, 101, 201), 
                             names = c("Site1", "Site2", "Site3")),
                     seqnames = c("2", "2", "2"),
                     strand="+",feature=c("a","b","f"))
    peaks3 = GRanges(seqnames = c("1", "2", "2"),
                     IRanges(start = c(1, 100, 200),
                             end = c(3, 103, 203), 
                             names = c("Site1", "Site2", "Site3")),
                     strand="+",feature=c("a","b","f"))
    peaks4 = GRanges(seqnames = c("1", "2", "2"),
                     IRanges(start = c(1, 100, 200),
                             end = c(2, 101, 201), 
                             names = c("Site1", "Site2", "Site3")),
                     strand="+",
                     feature=c("a","b","f"))
    suppressWarnings(makeVennDiagram(GRangesList(peaks1,peaks2,peaks3),
                                     NameOfPeaks=c("TF1", "TF2","TF3"),
                                     totalTest=100,scaled=F, euler.d=F))
    #data same as above except first chrom of first range in peaks2
    peaks1 = GRanges(seqnames = c("1", "1", "1"),
                     IRanges(start = c(1, 100, 200),
                             end = c(2, 101, 201), 
                             names = c("Site1", "Site2", "Site3")),
                     strand="+",feature=c("a","b","f"))
    peaks2 = GRanges(seqnames = c("1", "2", "2"),
                     IRanges(start = c(1, 100, 200),
                             end = c(1, 101, 201), 
                             names = c("Site1", "Site2", "Site3")),
                     strand="+",feature=c("a","b","f")) #note first
    #chrom diff from above!
    peaks3 = GRanges(seqnames = c("1", "2", "2"),
                     IRanges(start = c(1, 100, 200),
                             end = c(3, 103, 203), 
                             names = c("Site1", "Site2", "Site3")),
                     strand="+",feature=c("a","b","f"))
    peaks4 = GRanges(seqnames = c("1", "2", "2"),
                     IRanges(start = c(1, 100, 200),
                             end = c(2, 101, 201), 
                             names = c("Site1", "Site2", "Site3")),
                     strand="+",feature=c("a","b","f"))
    suppressWarnings(makeVennDiagram(GRangesList(peaks1,peaks2,peaks3),
                                     NameOfPeaks=c("TF1", "TF2","TF3"),
                                     totalTest=100,scaled=F, euler.d=F))
    #is fine, as is below
    suppressWarnings(makeVennDiagram(GRangesList(peaks1,peaks2,peaks3,peaks4),
                                     NameOfPeaks=c("TF1", "TF2","TF3","TF4"),
                                     totalTest=100,scaled=F, euler.d=F))
})

#' estimate the fragment length
#' 
#' estimate the fragment length for bam files
#' 
#' 
#' @param bamfiles The file names of the 'BAM' ('SAM' for asBam) files to be
#' processed.
#' @param index The names of the index file of the 'BAM' file being processed;
#' this is given without the '.bai' extension.
#' @param plot logical. If TRUE (the default) the acf is plotted.
#' @param lag.max maximum lag at which to calculate the acf. See
#' \code{\link[stats]{acf}}
#' @param minFragmentSize minimal fragment size to avoid the phantom peak.
#' @param \dots Not used.
#' @return numberic vector
#' @author Jianhong Ou
#' @keywords misc
#' @export
#' @importFrom Rsamtools testPairedEndBam scanBam ScanBamParam scanBamFlag
#' scanBamHeader countBam 
#' @importFrom GenomicAlignments readGAlignments
#' @importFrom stats loess.smooth ts
#' @examples
#' 
#'     if(interactive() || Sys.getenv("USER")=="jou"){
#'         path <- system.file("extdata", "reads", package="MMDiffBamSubset")
#'         if(file.exists(path)){
#'             WT.AB2 <- file.path(path, "WT_2.bam")
#'             Null.AB2 <- file.path(path, "Null_2.bam")
#'             Resc.AB2 <- file.path(path, "Resc_2.bam")
#'             estFragmentLength(c(WT.AB2, Null.AB2, Resc.AB2))
#'         }
#'     }
#'     
#' 
estFragmentLength <- function(bamfiles, index=bamfiles, plot=TRUE,
                              lag.max=1000, minFragmentSize=100, ...){
    #message("The fragment size is being calculated for DNA-seq.")
    res <- mapply(function(f, i) {
        if(suppressMessages(testPairedEndBam(f, index=i))){
            isize <- 
                sort(
                    abs(scanBam(f, index=i, 
                                param=
                                    ScanBamParam(
                                        flag=
                                            scanBamFlag(
                                                isPaired = TRUE, 
                                                isProperPair = TRUE,
                                                isSecondaryAlignment = FALSE,
                                                isFirstMateRead = TRUE,
                                                isNotPassingQualityControls = 
                                                    FALSE),
                                        what="isize"))[[1]]$isize))
            isize <- table(isize)
            isize.x <- as.numeric(names(isize))
            isize.y <- isize
            ## do smooth and select the max point
            isize.smooth <- loess.smooth(isize.x, isize.y, span=1/3,
                                         evaluation = length(isize.x))
            isize.smooth$y[seq.int(minFragmentSize)] <- 0
            pos <- round(isize.smooth$x[which.max(isize.smooth$y)],
                         digits = 0)
            if(plot){
                try({
                    plot(isize.x, isize.y,
                         xlab="Lag", ylab="ACF",
                         main=f, type="l")
                    abline(v=pos, col="red")
                })
            }
            pos
        }else{
            ## count reads for all chromosomes
            seqinfo <- lapply(scanBamHeader(f, index=i), 
                              function(.ele) .ele$targets)
            seqn <- sort(table(unlist(lapply(seqinfo, names))))
            seqn <- names(seqn[which(seqn==max(seqn))])
            seqinfo <- unique(do.call(rbind, lapply(seqinfo, `[`, seqn)))[1, ]
            seqinfo.gr <- GRangesList(lapply(1:length(seqinfo), function(.ele){
                GRanges(names(seqinfo)[.ele], IRanges(1, seqinfo[.ele]))
            }))
            names(seqinfo.gr) <- names(seqinfo)
            cnts <- countBam(f, index=i, 
                             param=ScanBamParam(
                                 flag=scanBamFlag(isPaired = FALSE, 
                                                  isUnmappedQuery = FALSE,
                                                  isSecondaryAlignment = FALSE,
                                                  isNotPassingQualityControls =
                                                      FALSE),
                                                which=seqinfo.gr))
            cnts <- cnts[cnts$nucleotides>0, , drop=FALSE]
            if(nrow(cnts)<1){
                stop("no reads detected.")
            }
            depth <- cnts$nucleotides/cnts$width
            ## select middle one
            select.chr <- 
                as.character(cnts$space[which.min(abs(depth-median(depth)))])
            #read reads
            reads <- 
                readGAlignments(f, index=i, 
                                param=ScanBamParam(
                                    flag=scanBamFlag(
                                        isPaired = FALSE, 
                                        isUnmappedQuery = FALSE,
                                        isSecondaryAlignment = FALSE,
                                        isNotPassingQualityControls = FALSE),
                                    which=seqinfo.gr[[select.chr]],
                                    what=scanBamWhat()))
            #convert to GRanges
            reads.gr <- as(reads, "GRanges")
            mcols(reads.gr) <- NULL
            reads.gr <- split(reads.gr, strand(reads.gr))
            reads.gr <- sapply(reads.gr, coverage)
            reads.gr.pos <- as.integer(reads.gr[["+"]][[select.chr]])
            reads.gr.neg <- as.integer(reads.gr[["-"]][[select.chr]])
            ## remove 0 from both end
            pos0 <- max(which(reads.gr.pos!=0)[1], which(reads.gr.neg!=0)[1])
            pos1 <- length(reads.gr.pos) - 
                max(which(rev(reads.gr.pos)!=0)[1], 
                    which(rev(reads.gr.neg)!=0)[1])
            if(pos1>pos0+5000){
                reads.gr.pos <- reads.gr.pos[pos0:pos1]
                reads.gr.neg <- reads.gr.neg[pos0:pos1]
            }
            if(length(reads.gr.pos)>100000){
                block <- 50000
                len <- ceiling(length(reads.gr.pos)/block)
                signal <- 
                    split(reads.gr.pos, 
                          rep(formatC(1:len, width = 
                                          nchar(as.character(len)), 
                                      flag="0"), 
                              each=block)[1:length(reads.gr.pos)])
                signal <- sapply(signal, mean)
                signal <- signal[-len]
                sid <- which.max(signal)
                pos0 <- (sid - 1) * block + 1
                pos1 <- min(sid * block, length(reads.gr.pos))
                reads.gr.pos <- reads.gr.pos[pos0:pos1]
                reads.gr.neg <- reads.gr.neg[pos0:pos1]
            }
            ## cross-correlation 
            reads.gr.pos.ts <- ts(reads.gr.pos)
            reads.gr.neg.ts <- ts(reads.gr.neg)
            ccf <- ccf(reads.gr.neg.ts, reads.gr.pos.ts, 
                       type = "correlation", plot=FALSE, lag.max=lag.max)
            keep <- ccf$lag>=0
            lag <- ccf$lag[keep]
            acf1 <- acf <- ccf$acf[keep]
            acf[seq.int(minFragmentSize)] <- 0
            pos <- lag[which.max(acf)]
            if(plot){
                try({
                    plot(lag, acf1, xlab="Lag", ylab="ACF",
                         main=
                           paste(f, 
                                 "insertion size (not including reads length)"), 
                         type="l")
                    abline(v=pos, col="red")
                })
            }
            pos + mean(width(reads))
        }
    }, bamfiles, index, SIMPLIFY = TRUE)
    res
}

#' Merge peaks from plus strand and minus strand
#' 
#' Merge peaks from plus strand and minus strand within certain distance apart,
#' and output merged peaks as bed format.
#' 
#' 
#' @param peaks.file Specify the peak file. The peak file should contain peaks
#' from both plus and minus strand
#' @param columns Specify the column names in the peak file
#' @param sep Specify column delimiter, default tab-delimited
#' @param header Specify whether the file has a header row, default TRUE
#' @param distance.threshold Specify the maximum gap allowed between the plus
#' stranded and the nagative stranded peak
#' @param plus.strand.start.gt.minus.strand.end Specify whether plus strand
#' peak start greater than the paired negative strand peak end. Default to TRUE
#' @param output.bedfile Specify the bed output file name
#' @return output the merged peaks in bed file and a data frame of the bed
#' format
#' @author Lihua Julie Zhu
#' @seealso annotatePeakInBatch, findOverlappingPeaks, makeVennDiagram
#' @references Zhu L.J. et al. (2010) ChIPpeakAnno: a Bioconductor package to
#' annotate ChIP-seq and ChIP-chip data. BMC Bioinformatics 2010,
#' 11:237doi:10.1186/1471-2105-11-237
#' @keywords misc
#' @export
#' @importFrom matrixStats rowMins rowMaxs
#' @importFrom utils read.table write.table
#' @examples
#' 
#' 
#' if (interactive())
#' {
#'     data(myPeakList)
#'     data(TSS.human.NCBI36)
#'     library(matrixStats)
#'         peaks <- system.file("extdata", "guide-seq-peaks.txt", 
#'                               package = "ChIPpeakAnno")
#'         merged.bed <- mergePlusMinusPeaks(peaks.file = peaks, 
#'                                           columns=c("name", "chromosome", 
#'                                                     "start", "end", "strand", 
#'                                                     "count", "count"), 
#'                                           sep = "\t", header = TRUE,  
#'                                           distance.threshold = 100,  
#'                                 plus.strand.start.gt.minus.strand.end = TRUE, 
#'                                           output.bedfile = "T2test100bp.bed")
#' }
#' 
mergePlusMinusPeaks <- function(peaks.file, 
                                columns=c("name", "chromosome", "start", 
                                          "end", "strand", "count", 
                                          "count", "count", "count"), 
                                sep = "\t", header = TRUE,  
                                distance.threshold = 100,  
                                plus.strand.start.gt.minus.strand.end = TRUE, 
                                output.bedfile)
{
    peaks<- read.table (peaks.file, sep = sep, header = header)
    if (dim(peaks)[2] != length(columns))
        stop("Number of columns specified differs from the number of columns 
             in the input peak file, please modify the column specification 
             in parameter columns accordingly!")
    if (length(intersect(columns, "strand")) != 1)
        stop("Please include one strand column in columns and 
             corresponding peaks.file")
    colnames(peaks) <- columns
    pos.peaks <- subset(peaks, peaks[, which(columns == "strand")] == "+")
    neg.peaks <- subset(peaks, peaks[, which(columns == "strand")] == "-")
    if (dim(pos.peaks)[1] == 0 || dim(neg.peaks)[1] == 0)
        stop("Need peaks from both + and - strand to merge")
    pos.gr <- makeGRangesFromDataFrame(pos.peaks)
    neg.gr <- makeGRangesFromDataFrame(neg.peaks)
    names(pos.gr) <- paste(paste(seqnames(pos.gr), strand(pos.gr), sep=""),
                           start(pos.gr),end(pos.gr), sep=":")
    names(neg.gr) <- paste(paste(seqnames(neg.gr), strand(neg.gr), sep=""),
                           start(neg.gr),end(neg.gr), sep=":")
    if (plus.strand.start.gt.minus.strand.end)
        gr <- annotatePeakInBatch(pos.gr, featureType = "TSS",
                                  AnnotationData = neg.gr, 
                                  output="nearestStart", 
                                  PeakLocForDistance = "TSS")
    else
        gr <- annotatePeakInBatch(neg.gr, featureType = "TSS", 
                                  AnnotationData = pos.gr, 
                                  output="nearestStart",
                                  PeakLocForDistance = "end")
    pos.peaks <- 
        cbind(peak = paste(paste(pos.peaks[,which(columns == "chromosome")], 
                                 "+", sep = ""), 
                           pos.peaks[,which(columns == "start")], 
                           pos.peaks[,which(columns == "end")], sep=":"), 
              pos.peaks)
    neg.peaks <- 
        cbind(feature = paste(paste(neg.peaks[,which(columns == "chromosome")],
                                    "-", sep = ""), 
                              neg.peaks[,which(columns == "start")], 
                              neg.peaks[,which(columns == "end")], sep=":"), 
              neg.peaks)
    if (!plus.strand.start.gt.minus.strand.end)
    {
        colnames(pos.peaks)[1] <-  "feature"
        colnames(neg.peaks)[1] <-  "peak"
    }
    new.count.columns <- which(columns == "count") + 1
    colnames(neg.peaks)[new.count.columns] <- 
        paste("minus", colnames(neg.peaks)[new.count.columns], sep=":")
    colnames(pos.peaks)[new.count.columns] <- 
        paste("plus", colnames(pos.peaks)[new.count.columns], sep=":")
    pos.peaks <- pos.peaks[, c(1, new.count.columns)]
    neg.peaks <- neg.peaks[, c(1, new.count.columns)]
    ann.peaks <- as.data.frame(gr[abs(gr$distancetoFeature) <= 
                                      distance.threshold & 
                                      gr$distancetoFeature < 0,])
    temp <- merge(pos.peaks, ann.peaks)
    temp1 <- merge(neg.peaks, temp)
    temp1 <- cbind(temp1, 
                   totalCount = rowSums(temp1[,grep("count", 
                                                    colnames(temp1))]))
    temp1$names = paste(temp1$peak, temp1$feature, sep=":")
    temp1$minStart <- rowMins(as.matrix(temp1[, c("start_position", "start")]))
    temp1$maxEnd <- rowMaxs(as.matrix(temp1[, c("end_position", "end")]))
    bed.temp <- 
        temp1[, c("seqnames", "minStart", "maxEnd", "names", "totalCount")]
    bed.temp <- cbind(bed.temp, strand = "+")
    write.table(bed.temp, file = output.bedfile, sep = "\t", col.names = FALSE,
                row.names=FALSE, quote=FALSE)
    bed.temp
}

#' @importFrom stats rexp
randPeaks <- function(A, grs, N, ...){
    len <- lengths(grs)
    if(any(len<1)){
        stop("All length of grs must be greater than 0")
    }
    if(length(N)!=length(grs)){
        stop("length of N and grs are not identical")
    }
    
    s <- mapply(runifGR, grs, N)
    s <- unlist(GRangesList(s))
    
    wid <- width(A)
    ## how to avoid warning?
    wid <- rexp(length(s),1/(mean(wid)-min(wid))) + min(wid)
    halfwid <- floor(wid/2)
    suppressWarnings(start(s) <- start(s)-halfwid)
    suppressWarnings(width(s) <- 2*halfwid)
    s <- trim(s)
    s
}

runifGR <- function(grNoN, n){
    grNoN <- grNoN[sample.int(length(grNoN))]
    wid <- width(grNoN)
    totL <- sum(as.numeric(wid))
    ends <- cumsum(as.numeric(wid))
    starts <- c(1, ends[-length(ends)] + 1)
    idx <- sample.int(n=totL, size=n, replace=TRUE)
    pos <- cut(idx, breaks=c(0, ends), labels=1:length(grNoN))
    pos <- as.integer(as.character(pos))
    off <- idx - starts[pos] - 1
    gr <- grNoN[pos]
    suppressWarnings(gr <- shift(gr, shift=off))
    gr <- trim(gr)
    width(gr) <- 1
    gr
}

#' Output a summary of the occurrence and enrichment of each pattern in the 
#' sequences.
#' 
#' Output a summary of the occurrence and enrichment of each pattern in the 
#' sequences.
#'
#' @param patternFilePath Character value. The path to the file that contains 
#' the pattern. 
#' 
#' @param format Character value. The format of file containing the 
#' oligonucleotide pattern, either "fasta" (default) or "fastq".
#' 
#' @param BSgenomeName Character value. BSgenome object. Please refer to 
#' available.genomes in BSgenome package for details.
#' 
#' @param peaks Character value. \link[GenomicRanges:GRanges-class]{GRanges} 
#' containing the peaks.
#' 
#' @param revcomp Boolean value, if TURE, also search the reverse compliment of 
#' pattern. Default is TRUE.
#' 
#' @param method Character value. Method for pattern enrichment test, 
#' 'binom.test' (default) or 'permutation.test'.
#' 
#' @param expectFrequencyMethod Character value. Method for calculating the 
#' expected probability of pattern occurrence, 'Markov' (default) or 'Naive'.
#' 
#' @param MarkovOrder Integer value. The order of Markov chain. Default is 3.
#' 
#' @param bgdForPerm Character value. The method for obtaining the background 
#' sequence. 'chromosome' (default) selects background chromosome 
#' from chromosomes, refer to 'chromosome' parameter; 'shuffle' will obtain the
#' backgroud sequence by shufflubg any k-mers in peak sequences, refer to '...'.
#'
#' @param chromosome Character value. Relevant if "bgdForPerm='chromosome'".
#' 'asPeak' means to use the same chromosomes in peaks; 'random' means to use 
#' all chromosomes randomly. Default is 'asPeak'. 
#' 
#' @param nperm Integer value. The number of permutation test, default is 1000.
#'
#' @param alpha Numeric value. The significant level for permutation test, 
#' default is 0.05.
#'
#' @param ... Aditional parameter passed to function
#'  \link[universalmotif]{shuffle_sequences}
#'
#' @return A list including two data frames named 'motif_enrichment' and 
#' 'motif_occurrence'. The 'motif_enrichment' has four columns: 
#' \itemize{
#'  \item "patternNum": number of matched pattern
#'  \item "totalNumPatternWithSameLen":  total number of pattern with the 
#'  same length
#'  \item "expectedRate":  expected rate of pattern for 'binom.test' method
#'  \item "patternRate":  real rate of pattern for 'permutation.test' method
#'  \item "pValueBinomTest":  p value of bimom test for 'binom.test' method
#'  \item "cutOffPermutationTest":  cut off of permutation test for 
#'  'permutation.test' method
#' }
#' 
#'The 'motif_occurrence' has 14 columns:
#'
#' \itemize{
#'  \item "motifChr":    Chromosome of motif
#'  \item "motifStartInChr":    motif start position in chromosome
#'  \item "motifEndInChr":    motif end position in chromosome
#'  \item "motifName":    motif name
#'  \item "motifPattern":    motif pattern
#'  \item "motifStartInPeak":    motif start position in peak
#'  \item "motifEndInPeak":    motif end position in peak
#'  \item "motifFound":    specific motif Found in peak
#'  \item "motifFoundStrand":    strand of specific motif Found in peak, "-" 
#'  means reverse complement of motif found in peaks
#'  \item "peakChr":    Chromosome of peak
#'  \item "peakStart":    peak start position
#'  \item "peakEnd":    peak end position
#'  \item "peakWidth":    peak width
#'  \item "peakStrand":    peak strand
#' }
#' 
#' @details Please see \link[universalmotif]{shuffle_sequences} for the more 
#' information bout 'shuffle' method.
#' 
#' @author Lihua Julie Zhu, Junhui Li, Kai Hu
#' 
#' @export
#' 
#' @importFrom Biostrings readDNAStringSet reverseComplement
#' 
#' @importFrom Biostrings oligonucleotideFrequency
#' 
#' @importFrom stats binom.test
#' 
#' @importFrom universalmotif shuffle_sequences
#' 
#' @importFrom data.table data.table
#' 
#' @importFrom stringr str_split
#' 
#' @importFrom dplyr %>% pull left_join
#' 
#' @importFrom tidyr separate_rows
#' 
#' @importFrom tibble tibble
#' 
#' @keywords misc
#' 
#' @examples
#'                             
#' library(BSgenome.Hsapiens.UCSC.hg19)
#' filepath <- system.file("extdata", "examplePattern.fa", 
#'                         package = "ChIPpeakAnno")
#' peaks <- GRanges(seqnames = c("chr17", "chr3", "chr12", "chr8"),
#'                  IRanges(start = c(41275784, 10076141, 4654135, 31024288),
#'                          end = c(41276382, 10076732, 4654728, 31024996),
#'                          names = paste0("peak", 1:4)))
#' result <- summarizePatternInPeaks(patternFilePath = filepath, peaks = peaks,
#'                                   BSgenomeName = Hsapiens)
#' 
summarizePatternInPeaks <- function(patternFilePath, 
                                    format = "fasta", 
                                    BSgenomeName,
                                    peaks,
                                    revcomp = TRUE,
                                    method = c("binom.test","permutation.test"),
                                    expectFrequencyMethod = c("Markov","Naive"),
                                    MarkovOrder = 3L,
                                    bgdForPerm = c("shuffle","chromosome"),
                                    chromosome = c("asPeak","random"),
                                    nperm = 1000,
                                    alpha = 0.05,
                                    ...) {
  method <- match.arg(method)
  expectFrequencyMethod <- match.arg(expectFrequencyMethod)
  bgdForPerm <- match.arg(bgdForPerm)
  chromosome <- match.arg(chromosome)
  
  if (missing(patternFilePath)) {
    stop("missing required parameter patternFilePath!")
  }
  if (!file.exists(patternFilePath)) {
    stop("patternFilePath specified as ", patternFilePath,
         " does not exsist!")
  }
  if (format != "fasta" && format != "fastq") {
    stop("format needs to be either fasta or fastq!")
  }
  if (missing(BSgenomeName) || !is(BSgenomeName, "BSgenome")) {
    stop("BSgenomeName is required as BSgenome object!")
  }
  if (missing(peaks) || (!is(peaks, "RangedData") && !is(peaks,
                                                         "GRanges"))) {
    stop("No valid peaks passed in. 
         It needs to be RangedData or GRanges object.")
  }
  if (is(peaks, "RangedData"))
    peaks <- toGRanges(peaks, format = "RangedData")

  seqs <- getAllPeakSequence(peaks, upstream = 0, downstream = 0, 
                             genome = BSgenomeName)
  
  # seqs <- getAllPeakSequence(peaks, BSgenome.Hsapiens.UCSC.hg19, upstream = 0, downstream = 0)
  # patternVec <- DNAStringSet("AACCCA")
  # names(patternVec) <- "testRun"
  # revcomp <- FALSE
  
  patternVec <- readDNAStringSet(patternFilePath, format, use.names = TRUE)
  patternName <- names(patternVec)
  temp <- do.call(rbind, lapply(seq_along(patternVec), function(i) {
    getPosInSeqs(thispattern = patternVec[i], seq = seqs, revcomp = revcomp)
  }))
  temp2 <- patternEnrichmentInPeak(patternVec,
                                   revcomp = revcomp,
                                   BSgenomeName = BSgenomeName,
                                   seqs = seqs, 
                                   method = method, 
                                   expectFrequencyMethod = expectFrequencyMethod,
                                   bgdForPerm = bgdForPerm,
                                   chromosome = chromosome,
                                   MarkovOrder = MarkovOrder,
                                   nperm = nperm,
                                   alpha = alpha,
                                   ...)
  
  output <- list()
  output["motif_enrichment"] <- list(temp2)
  output["motif_occurrence"] <- list(temp)
  return(output)
}

patternEnrichmentInPeak <- function(patternVec,
                                    revcomp = TRUE,
                                    seqs,
                                    method = c("binom.test", "permutation.test"),
                                    expectFrequencyMethod = c("Markov", "Naive"),
                                    bgdForPerm = c("chromosome", "shuffle"),
                                    chromosome = c("asPeak","random"),
                                    BSgenomeName,
                                    MarkovOrder = 3L,
                                    nperm = 1000,
                                    alpha = 0.05,
                                    ...) {
  method <- match.arg(method)
  expectFrequencyMethod <- match.arg(expectFrequencyMethod)
  bgdForPerm <- match.arg(bgdForPerm)
  stopifnot("The 'nperm' or 'alpha' parameter should be increased to a 
            sufficient extent."=round(nperm*alpha,0) != 0)
  
  pattern <- as.character(patternVec)
  if(method == "binom.test"){
    peakPvalue <- binomEnrichment(pattern, 
                                  expectFrequencyMethod = expectFrequencyMethod,
                                  revcomp = revcomp, 
                                  seqs = seqs, 
                                  MarkovOrder = MarkovOrder)
  }else if(method == "permutation.test"){
    peakPvalue <- permutationEnrichment(pattern, 
                                        revcomp = revcomp, 
                                        seqs = seqs, 
                                        BSgenomeName = BSgenomeName, 
                                        bgdForPerm = bgdForPerm,
                                        chromosome = chromosome,
                                        nperm = nperm, 
                                        alpha = alpha,
                                        ...)
  }
  return(peakPvalue)
}

binomEnrichment <- function(pattern, 
                            expectFrequencyMethod = c("Naive","Markov"), 
                            revcomp = TRUE, 
                            seqs, 
                            MarkovOrder = 3L) {
  ## get frequency of single nucleotide in seqs
  expFreqSet <- expectMotifFrequency(pattern, 
                                     revcomp = revcomp, 
                                     seqs = seqs, 
                                     expectFrequencyMethod = expectFrequencyMethod,
                                     MarkovOrder = MarkovOrder)
  ## get real frequency of input seq in peak region
  peakFreq <- matrix(0,length(pattern),3)
  rownames(peakFreq) <- pattern
  colnames(peakFreq) <- c("patternNum","totalNumPatternWithSameLen",
                          "expectedRate")
  peakFreq[,3] <- expFreqSet[,1]
  
  ## get expected frequency of fasta
  pattern.t <- translatePattern(pattern)
  backwardpattern.t <- NULL
  backwardpattern <- NULL
  if(revcomp == TRUE){
    backwardpattern <- reverseComplement(DNAStringSet(pattern))
    backwardpattern <- as.character(backwardpattern)
    backwardpattern.t <- translatePattern(backwardpattern)
  }
  peakFreq[,1:2] <- t(sapply(seq.int(pattern),function(i){
    oligoNVec <- colSums(oligonucleotideFrequency(DNAStringSet(seqs$sequence),
                                                  width=nchar(pattern[i])))
    posPlus = gregexpr(pattern.t[i], names(oligoNVec), perl = TRUE)
    posPlusFreq <- sum(oligoNVec[which(sapply(posPlus, "[[", 1) > 0)])
    posMinusFreq <- 0
    if(revcomp == TRUE){
      posMinus = gregexpr(backwardpattern.t[i], names(oligoNVec), perl = TRUE)
      posMinusFreq <- sum(oligoNVec[which(sapply(posMinus, "[[", 1) > 0)])
    }
    c(posPlusFreq + posMinusFreq, sum(oligoNVec))
  }))
  
  pValueBinomTest <- sapply(seq.int(nrow(peakFreq)),function(i){
    stats::binom.test(peakFreq[i,1],peakFreq[i,2],peakFreq[i,3],
                      alternative="greater")$p.value
  })
  peakFreq <- data.frame(peakFreq,pValueBinomTest)
  return(peakFreq)
}

expectMotifFrequency <- function(pattern, 
                                 revcomp = TRUE, 
                                 seqs,
                                 expectFrequencyMethod = c("Naive","Markov"),
                                 MarkovOrder = 3L) {
  
  if(expectFrequencyMethod == "Naive"){
    ACGTcount <- colSums(oligonucleotideFrequency(DNAStringSet(seqs$sequence),
                                                  width=1))
    ACGTfreq <- ACGTcount/sum(ACGTcount)
    iuapc <- data.table(code = c("A", "C", "G", "T", "R", "Y", "S", "W", "K", 
                                 "M", "B", "D", "H", "V", "N"),
                        base = c("A", "C", "G", "T", "AG", "CT", "GC", "AT", 
                                "GT", "AC", "CGT", "AGT", "ACT", "ACG", "ACGT"))
    allBaseFreq <- sapply(1:nrow(iuapc),function(i){
      sum(ACGTfreq[seqinr::s2c(as.character(iuapc[i,2]))])
    })
    names(allBaseFreq) <- as.matrix(iuapc)[,1]
    
    ## get expected frequency of forward and backward fasta 
    pattern.t <- translatePattern(pattern)
    backwardpattern.t <- NULL
    backwardpattern <- NULL
    if(revcomp == TRUE){
      backwardpattern <- reverseComplement(DNAStringSet(pattern))
      backwardpattern <- as.character(backwardpattern)
      backwardpattern.t <- translatePattern(backwardpattern)
    }
    expFreqSet <- sapply(c(pattern,backwardpattern),function(i){
      patternTab <- table(strsplit(i,"")[[1]])
      expFre <- prod(allBaseFreq[names(patternTab)]^patternTab)
      expFre
    })
    expFreqSet <- colSums(matrix(expFreqSet,ncol=length(pattern),byrow = TRUE))
    names(expFreqSet) <- pattern
    expectedFreq <- data.frame(expFreqSet)
    colnames(expectedFreq) <- "expected_frequency"
  }else if(expectFrequencyMethod == "Markov"){
    
    oligoLength <- nchar(pattern)
    stopifnot("motif length should > 3 and < 13 with Markov method"=
                all(oligoLength>3&oligoLength<13))
    MarkovOrder <- as.integer(MarkovOrder)
    stopifnot("MarkovOrder should > 0 and < 6" = MarkovOrder > 0 & MarkovOrder < 6)
    stopifnot("MarkovOrder should be less than motif length - 2"=
                all(MarkovOrder < oligoLength - 2))
    # stopifnot("The seqinr package is required." = 
    #             requireNamespace("seqinr", quietly = TRUE))
    if(is(seqs, "GRanges")){
      seqs_content <- seqs$sequence
    }else{
      if(is(seqs, "DNAStringSet")){
        seqs_content <- as.character(seqs)
      }else{
        if(!is.character(seqs)){
          stop("seqs must be an object of DNAStringSet or DNAString",
               "or output of getAllPeakSequence")
        }
      }
    }
    sequence <- tolower(seqs_content)
    len <- length(sequence)
    #i=6
    expectedFreq <- sapply(unique(oligoLength),function(i){
      oligoWords <- seqinr::words(i)
      dict <- PDict(DNAStringSet(oligoWords))
      sequence.tbl <- 1
      maxsize <- 100000
      if(len > maxsize){
        sequence.tbl <- table(sequence)
        if(length(sequence.tbl)>maxsize){
          stop("Can not handle such huge dataset.")
        }
        cnt <- vcountPDict(dict, subject=DNAStringSet(names(sequence.tbl)), 
                           max.mismatch=0, min.mismatch=0, 
                           with.indels=FALSE, fixed=TRUE)
      }else{
        cnt <- vcountPDict(dict, subject=DNAStringSet(sequence), 
                           max.mismatch=0, min.mismatch=0, 
                           with.indels=FALSE, fixed=TRUE)
      }
      
      rownames(cnt) <- oligoWords
      cnt <- t(cnt)
      mergeRevcomp <- function(mat){
        coln <- colnames(mat)
        index <- nrow(mat)
        map <- c(a="t", c="g", g="c", t="a")
        revComp <- function(.ele){
          paste(map[rev(seqinr::s2c(.ele))], collapse="")
        }
        coln.rev <- sapply(coln, revComp)
        coln.id <- 1:length(coln)
        coln.rev.id <- match(coln.rev, coln)
        coln.ids <- apply(cbind(coln.id, coln.rev.id), 1, sort)
        coln.ids <- unique(t(coln.ids))
        mat1 <- mat[, coln.ids[, 1]] > 0
        mat2 <- mat[, coln.ids[, 2]] > 0
        if (index == 1) {
          mat1 <- t(as.data.frame(mat1))
          mat2 <- t(as.data.frame(mat2))
        }
        mat1 <- colSums(mat1)
        mat2 <- colSums(mat2)
        coln <- ifelse(mat1>mat2, names(mat1), names(mat2))
        mat <- mat[, coln.ids[, 1]] + mat[, coln.ids[, 2]]
        if (index == 1) {
          mat <- t(as.data.frame(mat))
        }
        colnames(mat) <- coln
        mat
      }
      
      if(revcomp) cnt <- mergeRevcomp(cnt)
      
      #cnt <- cnt>0
      mode(cnt) <- "logical"
      mode(cnt) <- "numeric"
      if(len > maxsize) cnt <- cnt * as.numeric(sequence.tbl)
      cntSum <- colSums(cnt)
      freqs <- oligoFrequency(sequence, MarkovOrder=MarkovOrder)
      namesFreqs <- unique(c(seqinr::words(1), 
                             seqinr::words(MarkovOrder),
                             seqinr::words(MarkovOrder+1)))
      
      names(freqs) <- tolower(names(freqs))
      stopifnot(all(namesFreqs %in% names(freqs)))
      f <- sapply(names(cntSum), function(.ele) {
        m1 <- substring(.ele, 1:(i-MarkovOrder),
                        (MarkovOrder+1):i)
        m0 <- substring(.ele, 2:(i-MarkovOrder),
                        (MarkovOrder+1):(i-1))
        prod(freqs[m1])/prod(freqs[m0])
      })
      #i=6
      allPatternList <- expandPattern(pattern[oligoLength %in% i])
      
      expFreqSubset <- sapply(allPatternList,function(seq){
        sum(f[names(f) %in% tolower(seq)])
      })
      expFreqSubset
    })
    expectedFreq <- as.data.frame(expectedFreq)
    colnames(expectedFreq) <- "expected_frequency"
  }
  return(expectedFreq)
}


expandPattern <- function(pattern){
  pattern = toupper(pattern)
  iuapc <- data.table(code = c("A", "C", "G", "T", "R", "Y", "S", "W", "K", "M",
                               "B", "D", "H", "V", "N"),
                      base = c("A", "C", "G", "T", "AG", "CT", "GC", "AT", "GT",
                               "AC", "CGT", "AGT", "ACT", "ACG", "ACGT"))
  
  allExpPattern <- lapply(pattern,function(seq){
    allSeqMat <- tibble(seq) %>%
      separate_rows(seq, sep = '(?<=.)(?=.)') %>%
      left_join(iuapc, by = c("seq" = "code")) %>%
      pull(base) %>%
      str_split("") %>%
      expand.grid(stringsAsFactors = FALSE)
    apply(allSeqMat,1,seqinr::c2s)
  })
  names(allExpPattern) <- pattern
  allExpPattern
}

permutationEnrichment <- function(pattern, 
                                  revcomp = TRUE, 
                                  seqs, 
                                  BSgenomeName, 
                                  bgdForPerm = c("chromosome","shuffle"), 
                                  chromosome = c("asPeak","random"),
                                  nperm = 1000, 
                                  alpha = 0.05,
                                  ...) {
  pattern.t <- translatePattern(pattern)
  backwardpattern.t <- NULL
  backwardpattern <- NULL
  if (revcomp == TRUE) {
    backwardpattern <- reverseComplement(DNAStringSet(pattern))
    backwardpattern <- as.character(backwardpattern)
    backwardpattern.t <- translatePattern(backwardpattern)
  }
  allseqLen <- seqlengths(BSgenomeName)
  seqWidth <- width(seqs)
  nPeak <- length(seqs)
  colnames(mcols(seqs))[4] <- "orig.sequence"
  names(seqs$orig.sequence) <- do.call(paste, c(as.data.frame(seqs)[, 1:3], 
                                                sep = "_"))
  inputSeq <- DNAStringSet(seqs$orig.sequence)
  candiChrom <- names(allseqLen >= max(seqWidth))
  stopifnot("The length of peak sequence should be less than the length of 
  chromosomes"=all(seqWidth < allseqLen[as.character(seqnames(seqs)@values)]))
  
  peakFreq <- matrix(0,length(pattern),4)
  rownames(peakFreq) <- pattern
  colnames(peakFreq) <- c("patternNum","totalNumPatternWithSameLen",
                          "patternRate","cutOffPermutationTest")
  peakFreq[,1:2] <- t(sapply(seq.int(pattern),function(i){
    oligoNVec <- colSums(oligonucleotideFrequency(
      DNAStringSet(seqs$orig.sequence),width=nchar(pattern[i])))
    posPlus = gregexpr(pattern.t[i], names(oligoNVec), perl = TRUE)
    posPlusFreq <- sum(oligoNVec[which(sapply(posPlus, "[[", 1) > 0)])
    posMinusFreq <- 0
    if(revcomp == TRUE){
      posMinus = gregexpr(backwardpattern.t[i], names(oligoNVec), perl = TRUE)
      posMinusFreq <- sum(oligoNVec[which(sapply(posMinus, "[[", 1) > 0)])
    }
    c(posPlusFreq + posMinusFreq, sum(oligoNVec))
  }))
  peakFreq[,3] <- peakFreq[,1]/peakFreq[,2]
  
  ep <- list(...)
  permutationFreq <- do.call(rbind, lapply(seq.int(nperm), 
                                           function(n, ep) {
                                             if (bgdForPerm == "chromosome") {
      if (chromosome=="random"){
        chrs <- sample(candiChrom, nPeak, replace = TRUE)
        givenSeqLen <- allseqLen[chrs]
      } else if(chromosome=="asPeak"){
        chrs <- as.character(seqnames(seqs))
        givenSeqLen <- allseqLen[chrs]
      }
      startPos <- vapply(givenSeqLen-seqWidth,function(x){sample(seq.int(x),1)},
                         numeric(1))
      endPos <- startPos + seqWidth - 1
      backgroudPeak <- GRanges(seqnames = chrs,
                               IRanges(start = startPos,
                                       end = endPos,
                                       names = paste0("peak",seq.int(nPeak))))
      backgroudPeakseq <- getAllPeakSequence(backgroudPeak, upstream = 0,
                                             downstream = 0, 
                                             genome = BSgenomeName)
    
      } 
                                             else if (bgdForPerm == "shuffle") {
      sequences.shuffled <- do.call(universalmotif::shuffle_sequences, c(list(inputSeq), ep))
      seqs$sequence <- as.vector(sequences.shuffled)
      backgroudPeakseq <- seqs
    }
  ## get frequency from permutation
  sapply(seq.int(pattern),function(i){
  oligoNVec <- colSums(oligonucleotideFrequency(DNAStringSet(
    backgroudPeakseq$sequence),width=nchar(pattern[i])))
  posPlus <- gregexpr(pattern.t[i], names(oligoNVec), perl = TRUE)
  expFre <- sum(oligoNVec[which(sapply(posPlus, "[[", 1) > 0)])
  if(revcomp == TRUE){
    posMinus <- gregexpr(backwardpattern.t[i], names(oligoNVec), perl = TRUE)
    expFreMinus <- sum(oligoNVec[which(sapply(posMinus, "[[", 1) > 0)])
    expFre <- expFre + expFreMinus
  }
  c(expFre/sum(oligoNVec))
})
                                             }, ep = ep))
  colnames(permutationFreq) <- names(pattern)
  permutationFreqSorted <- apply(permutationFreq, 2, sort, decreasing=TRUE)
  peakFreq[,4] <- as.vector(permutationFreqSorted[round(nperm*alpha,0),])
  return(peakFreq)
}

getPosInSeqs <- function(thispattern, seq, revcomp = TRUE){
  if (missing(thispattern) || !is(thispattern, "DNAStringSet")) {
    stop("thispattern is required as a DNAStringSet object!")
  }
  if (missing(seq)) {
    stop("No valid sequences passed in!")
  }
  patternName <- names(thispattern)
  thispattern.t = as.character(thispattern)[[1]]
  thispattern.t = translatePattern(thispattern.t)
  if(revcomp == TRUE){
    revcomp.pattern = reverseComplement(thispattern)
    revcomp.pattern.t = as.character(revcomp.pattern)[[1]]
    revcomp.pattern.t = translatePattern(revcomp.pattern.t)
  }
  sequences <- seq$sequence
  #seqInfo <- as.data.frame(seqGRanges)
  seqInfo <- as.data.frame(seq)[,1:5]
  
  total <- do.call(rbind, lapply(seq_along(sequences), function(i) {
    pos.plus = gregexpr(thispattern.t, sequences[i], perl = TRUE)[[1]]
    if (pos.plus[1] > 0) {
      pattern.start <- as.numeric(pos.plus)
      pattern.end <- pattern.start + attr(pos.plus, "match.length") - 1
      patternSeq.found.plus <- 
        do.call(rbind, lapply(1:length(pattern.start), function(j){
          c(patternName, as.character(thispattern), 
            pattern.start[j], pattern.end[j], 
            substr(sequences[i], pattern.start[j], 
                   pattern.end[j]),"+", seqInfo[i,])
        }))
    }
    if(revcomp == TRUE){
      pos.minus = gregexpr(revcomp.pattern.t, sequences[i], perl = TRUE)[[1]]
      if(pos.minus[1] > 0) {
        pattern.start <- as.numeric(pos.minus)
        pattern.end <- pattern.start + attr(pos.minus, "match.length") - 1
        patternSeq.found.minus <- 
          do.call(rbind, lapply(1:length(pattern.start), function(j){
            c(patternName, as.character(thispattern), 
              pattern.start[j], pattern.end[j], 
              substr(sequences[i], pattern.start[j],
                     pattern.end[j]), "-",  seqInfo[i,])
          }))
        if(pos.plus[1] > 0){
          rbind(patternSeq.found.plus, patternSeq.found.minus)
        }else{
          patternSeq.found.minus
        }
      }else{
        if(pos.plus[1] > 0){
          patternSeq.found.plus
        }
      }
    }else{
      if(pos.plus[1] > 0){
        patternSeq.found.plus
      }
    }
  }))
  if (length(total) == 0){
    cat( c(patternName, as.character(thispattern), 
           "not found in the input sequences!\n\n"))
  }else{
    total <- as.data.frame(total,stringsAsFactors = FALSE)
    colnames(total)[1:6] <- c("motifName", "motifPattern", "motifStartInPeak",
                              "motifEndInPeak", "motifFound", 
                              "motifFoundStrand")
    motifstartInChromosome <- as.numeric(total$start) + as.numeric(total[,3]) -1
    motifendInChromosome <- as.numeric(total$start) + as.numeric(total[,4]) -1
    total <- cbind(motifChr = motifstartInChromosome,
                   motifStartInChr = motifstartInChromosome, 
                   motifEndInChr = motifendInChromosome, 
                   total)
    colnames(total)[(ncol(total)-4):ncol(total)] <- c("peakChr",
                                                      "peakStart",
                                                      "peakEnd",
                                                      "peakWidth",
                                                      "peakStrand")
    for (i in 1:dim(total)[2]) total[,i] <- unlist(total[,i])
    total$motifChr <- total$peakChr
  }
  total
}

test_that("summarizePatternInPeaks does not work correctly", {
filepath <- system.file("extdata", "examplePattern.fa", package = "ChIPpeakAnno")

# Check the motif occurrences in one example peak
# Skip checking for p-value calculation
peaks <- GRanges(seqnames = c("chr17"),
                 IRanges(start = c(41275784),
                         end = c(41296382),
                         names = paste0("peak", 1)))
peaks_seq <- getAllPeakSequence(peaks, genome = BSgenome.Hsapiens.UCSC.hg19, 
                                upstream = 0, downstream = 0)$sequence

# Test for each motif separately
patternVec <- readDNAStringSet(filepath, "fasta", use.names = TRUE)

for (i in 1:length(patternVec)) {
  pattern <- patternVec[i]
  temfile <- tempfile()
  writeXStringSet(pattern, temfile)
  
  # Without reverse complement:
  result <- summarizePatternInPeaks(patternFilePath = temfile,
                                    peaks = peaks, 
                                    BSgenomeName = BSgenome.Hsapiens.UCSC.hg19,
                                    revcomp = FALSE)
  
  if (pattern == "AACCNM") {
    res <- gregexec("AACC[A|T|C|G][A|C]", peaks_seq, perl = TRUE)
    expect_equal(length(res[[1]]), nrow(result$motif_occurrence))
  } else if (pattern == "GGNCCK") {
    res <- gregexec("GG[A|T|C|G]CC[G|T]", peaks_seq, perl = TRUE)
    expect_equal(length(res[[1]]), nrow(result$motif_occurrence))
  }
  
  # With reverse complement:
  result <- summarizePatternInPeaks(patternFilePath = temfile,
                                    peaks = peaks, 
                                    BSgenomeName = BSgenome.Hsapiens.UCSC.hg19,
                                    revcomp = TRUE)
  
  if (pattern == "AACCNM") {
    res1 <- gregexec("AACC[A|T|C|G][A|C]", peaks_seq, perl = TRUE)
    res2 <- gregexec("[T|G][G|C|A|T]GGTT", peaks_seq, perl = TRUE)
    expect_equal(length(res1[[1]]) + length(res2[[1]]), nrow(result$motif_occurrence))
  } else if (pattern == "GGNCCK") {
    res1 <- gregexec("GG[A|T|C|G]CC[G|T]", peaks_seq, perl = TRUE)
    res2 <- gregexec("[C|A]GG[C|G|A|T]CC", peaks_seq, perl = TRUE)
    expect_equal(length(res1[[1]]) + length(res2[[1]]), nrow(result$motif_occurrence))
  }
}

})

ratio.zScore <- function(A, B, background=1){
    stopifnot(length(A)==length(B))
    r <- log2(A+background) - log2(B+background)
    ## check distribution?
    ## normal distribution
    pop_sd <- sd(r) * sqrt((length(r)-1)/length(r))
    pop_mean <- mean(r)
    z <- (r - pop_mean)/pop_sd
    z
}

#' Class \code{"permPool"}
#' 
#' An object of class \code{"permPool"} represents the possible locations to do
#' permutation test.
#' 
#' 
#' @name permPool-class
#' @rdname permPool
#' @aliases permPool permPool-class permPool-method $,permPool-method
#' $<-,permPool-method
#' @docType class
#' @section Objects from the Class: Objects can be created by calls of the form
#' \code{new("permPool", grs="GRangesList", N="integer")}.
#' @slot grs object of \code{"GRangesList"} The list of binding ranges
#' @slot N vector of \code{"integer"}, permutation number for each ranges
#' @seealso \link{preparePool}, \link{peakPermTest}
#' @exportClass permPool
#' @exportMethod "$" "$<-"
#' @keywords classes

setClass("permPool", representation(grs="GRangesList",
                                    N="integer"),
         validity=function(object){
             re <- TRUE
             if(length(object@grs)!=length(object@N)) 
                 re <- "the length of grs and N are not identical"
             re
         })

setMethod("$", "permPool", function(x, name) slot(x, name))
setReplaceMethod("$", "permPool",
                 function(x, name, value){
                     slot(x, name, check = TRUE) <- value
                     x
                 })

#' prepare data for permutation test
#' 
#' prepare data for permutation test \link{peakPermTest}
#' 
#' 
#' @param TxDb an object of \link[GenomicFeatures:TxDb-class]{TxDb}
#' @param template an object of \link[GenomicRanges:GRanges-class]{GRanges}
#' @param bindingDistribution an object of \link{bindist}
#' @param bindingType the relevant position to features
#' @param featureType feature type, transcript or exon.
#' @param seqn seqnames. If given, the pool for permutation will be restrict in
#' the given chromosomes.
#' @return a list with two elements, grs, a list of
#' \link[GenomicRanges:GRanges-class]{GRanges}.  N, the numbers of elements
#' should be drawn from in each GRanges.
#' @author Jianhong Ou
#' @seealso \link{peakPermTest}, \link{bindist}
#' @keywords misc
#' @export
#' @importFrom S4Vectors queryHits subjectHits
#' @examples
#' 
#'     if(interactive() || Sys.getenv("USER")=="jou"){
#'         path <- system.file("extdata", package="ChIPpeakAnno")
#'         peaksA <- toGRanges(file.path(path, "peaks.narrowPeak"), 
#'                             format="narrowPeak")
#'         peaksB <- toGRanges(file.path(path, "MACS2_peaks.xls"), format="MACS2")
#'         library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#'         ppp <- preparePool(TxDb.Hsapiens.UCSC.hg19.knownGene, 
#'                            peaksA, bindingType="TSS",
#'                            featureType="transcript")
#'     }
#' 
preparePool <- function(TxDb, template, bindingDistribution,
                        bindingType=c("TSS", "geneEnd"), 
                        featureType=c("transcript", "exon"), seqn=NA){
    if(missing(TxDb)){
        stop("TxDb is requried!")
    }
    if(!is(TxDb, "TxDb")){
        stop("TxDb must be an object of TxDb")
    }
    if(!missing(bindingDistribution)){
        if(!is(bindingDistribution, "bindist")){
            stop("bindingDistribution must be an object of bindist")
        }
    }
    bindingType <- match.arg(bindingType)
    featureType <- match.arg(featureType)
    if(featureType=="transcript"){
        tx <- transcripts(x=TxDb)
        tx <- unique(tx)
        names(tx) <- seq_along(tx)
    }else{
        tx <- exons(x=TxDb)
        tx <- unique(tx)
        names(tx) <- seq_along(tx)
    }
    
    tx <- unique(tx)
    
    if(missing(bindingDistribution)){
        bindingDistribution <- 
            buildBindingDistribution(template, AnnotationData=tx,
                                     bindingType=bindingType,
                                     featureType=featureType)
    }
    offset <- bindingDistribution$mids
    diff <- bindingDistribution$halfBinSize
    N <- bindingDistribution$counts
    
    if(!is.na(seqn[1])) tx <- tx[as.character(seqnames(tx)) %in% seqn]
    
    grs <- lapply(offset, function(.off){
        x <- NULL
        suppressWarnings({
            x <- shift(tx, .off)
            start(x) <- start(x) - diff
            width(x) <- 2*diff
            x <- trim(x)
            x <- x[width(x) > 1]
        })
        ol <- findOverlaps(x, tx)
        if(length(ol)>0){
            if(.off+diff<0){
                x <- x[-(unique(queryHits(ol)))]
            }else{
                x <- x[-(unique(queryHits(ol)[
                    names(x)[queryHits(ol)]!=names(tx)[subjectHits(ol)]]))]
            }
        }
    })
    
    list(grs=GRangesList(grs), N=as.integer(N))
}

##require library graph, RBGL

#' Obtain Venn Counts for Venn Diagram, internal function for makeVennDigram
#' 
#' Obtain Venn Counts for peak ranges using chromosome ranges or feature field,
#' internal function for makeVennDigram
#' 
#' 
#' @param \dots Objects of \link[GenomicRanges:GRanges-class]{GRanges}. See
#' example below.
#' @param maxgap,minoverlap Used in the internal call to \code{findOverlaps()}
#' to detect overlaps. See
#' \code{?\link[IRanges:findOverlaps-methods]{findOverlaps}} in the
#' \pkg{IRanges} package for a description of these arguments.
#' @param by region, feature or base, default region. feature means using
#' feature field in the GRanges for calculating overlap, region means using
#' chromosome range for calculating overlap, and base means using calculating
#' overlap in nucleotide level.
#' @param ignore.strand When set to TRUE, the strand information is ignored in
#' the overlap calculations.
#' @param connectedPeaks If multiple peaks involved in overlapping in several
#' groups, set it to "merge" will count it as only 1, while set it to "min"
#' will count it as the minimal involved peaks in any concered groups
#' @return \item{vennCounts}{vennCounts objects containing counts for Venn
#' Diagram generation, see details in limma package vennCounts}
#' @author Jianhong Ou
#' @seealso \link{makeVennDiagram}, \link{findOverlappingPeaks}
#' @keywords misc
#' @export
#' @examples
#' 
#' if(interactive() || Sys.getenv("USER")=="jou"){
#' peaks1 = GRanges(seqnames=c("1", "2", "3"), 
#'                  IRanges(start = c(967654, 2010897, 2496704), 
#'                             end = c(967754, 2010997, 2496804), 
#'                             names = c("Site1", "Site2", "Site3")),  
#'                    strand=as.integer(1), 
#'                    feature=c("a","b", "c"))
#'   peaks2 = 
#'       GRanges(seqnames= c("1", "2", "3", "1", "2"), 
#'                     IRanges(start=c(967659, 2010898, 2496700, 3075866, 3123260), 
#'                          end=c(967869, 2011108, 2496920, 3076166, 3123470), 
#'                          names = c("t1", "t2", "t3", "t4", "t5")), 
#'                     strand = c(1L, 1L, -1L,-1L,1L), 
#'                     feature=c("a","c","d","e", "a"))
#'     getVennCounts(peaks1,peaks2)
#'     getVennCounts(peaks1,peaks2, by="feature")
#'     getVennCounts(peaks1, peaks2, by="base")
#' }
#' 
getVennCounts <- function(..., maxgap = -1L, minoverlap=0L,
                          by=c("region", "feature", "base"), 
                          ignore.strand=TRUE, 
                          connectedPeaks=c("min", "merge", "keepAll")){
  ###check inputs
  PeaksList <- list(...)
  n <- length(PeaksList)
  if(n==1){
    PeaksList <- PeaksList[[1]]
    n <- length(PeaksList)
    names <- names(PeaksList)
    if(is.null(names)) names <- paste("peaks", 1:n, sep="")
  }else{
    ##save dots arguments names
    dots <- substitute(list(...))[-1]
    names <- unlist(sapply(dots, deparse))
  }
  if(n<2){
    stop("Missing required argument Peaks!")
  }
  if(n>5){
    stop("The length of input peaks list should no more than 5")
  }
  connectedPeaks <- match.arg(connectedPeaks)
  by <- match.arg(by)
  if(any(duplicated(names)))
    stop("Same input Peaks detected!")
  venn_cnt <- vennCounts(PeaksList, n=n, names=names, 
                         maxgap=maxgap, minoverlap=minoverlap, by=by,
                         ignore.strand=ignore.strand, 
                         connectedPeaks=connectedPeaks)
  venn_cnt$venn_cnt
}

test_that("getVennCounts works not correct", {
    ##2 way
    p1 <- GRanges("1", 
                  IRanges(start=c(1, 3, 5, 8, 10), 
                          end=c(2, 4, 6, 9, 11), 
                          names=letters[1:5]), 
                  strand="*", 
                  feature=c("a","c","d","e", "a"))
    p2 <- GRanges("1", 
                  IRanges(start=c(2, 4, 9), 
                          end=c(3, 5, 10), 
                          names=letters[1:3]), 
                  strand="*", 
                  feature=c("a","b", "c"))
    venn_cnt <- getVennCounts(p1, p2, by="region")
    expect_equal(venn_cnt[,"Counts"], c(0,0,0,3))
    venn_cnt <- getVennCounts(p1, p2, by="feature")
    venn_cnt <- getVennCounts(p1, p2, by="base")
    ##3 way
    p3 <- GRanges("1", 
                  IRanges(start=c(3), end=c(4), names=letters[1]), 
                  strand="*", 
                  feature=c("a"))
    venn_cnt <- getVennCounts(p1, p2, p3, by="region")
    expect_equal(venn_cnt[,"Counts"], c(0,0,0,0,0,0,1,1))
    venn_cnt <- getVennCounts(p1, p2, p3, by="feature")
    ##4 way
    p4 <- GRanges("1", 
                  IRanges(start=c(13), end=c(14), names=letters[1]), 
                  strand="*", 
                  feature=c("a"))
    venn_cnt <- getVennCounts(p1, p2, p3, p4, by="region")
    expect_equal(venn_cnt[,"Counts"], 
                c(0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0))
    venn_cnt <- getVennCounts(p1, p2, p3, p4, by="feature")
})

#' Enriched Gene Ontology terms used as example
#' 
#' Enriched Gene Ontology terms used as example
#' 
#' 
#' @name enrichedGO
#' @docType data
#' @format A list of 3 dataframes. \describe{ \item{list("bp")}{ dataframe
#' described the enriched biological process with 9 columns
#' 
#' go.id:GO biological process id
#' 
#' go.term:GO biological process term
#' 
#' go.Definition:GO biological process description
#' 
#' Ontology: Ontology branch, i.e. BP for biological process
#' 
#' count.InDataset: count of this GO term in this dataset
#' 
#' count.InGenome: count of this GO term in the genome
#' 
#' pvalue: pvalue from the hypergeometric test
#' 
#' totaltermInDataset: count of all GO terms in this dataset
#' 
#' totaltermInGenome: count of all GO terms in the genome
#' 
#' } \item{list("mf")}{ dataframe described the enriched molecular function
#' with the following 9 columns
#' 
#' go.id:GO molecular function id
#' 
#' go.term:GO molecular function term
#' 
#' go.Definition:GO molecular function description
#' 
#' Ontology: Ontology branch, i.e. MF for molecular function
#' 
#' count.InDataset: count of this GO term in this dataset
#' 
#' count.InGenome: count of this GO term in the genome
#' 
#' pvalue: pvalue from the hypergeometric test
#' 
#' totaltermInDataset: count of all GO terms in this dataset
#' 
#' totaltermInGenome: count of all GO terms in the genome
#' 
#' } \item{list("cc")}{ dataframe described the enriched cellular component the
#' following 9 columns
#' 
#' go.id:GO cellular component id
#' 
#' go.term:GO cellular component term
#' 
#' go.Definition:GO cellular component description
#' 
#' Ontology: Ontology type, i.e. CC for cellular component
#' 
#' count.InDataset: count of this GO term in this dataset
#' 
#' count.InGenome: count of this GO term in the genome
#' 
#' pvalue: pvalue from the hypergeometric test
#' 
#' totaltermInDataset: count of all GO terms in this dataset
#' 
#' totaltermInGenome: count of all GO terms in the genome
#' 
#' } }
#' @author Lihua Julie Zhu
#' @keywords datasets
#' @examples
#' 
#' data(enrichedGO)
#' dim(enrichedGO$mf)
#' dim(enrichedGO$cc)
#' dim(enrichedGO$bp)
#' 
"enrichedGO"

#' @importFrom graphics hist
#' @import methods
#' @importFrom grDevices boxplot.stats
buildBindingDistribution <- function(x, AnnotationData,
                                     bindingType=c("TSS", "geneEnd"), 
                                     featureType=c("transcript", "exon")){
    if(missing(AnnotationData) || missing(x)){
        stop("x and AnnotationData is required.")
    }
    if(!is(x, "GRanges")){
        stop("x must be an object of GRanges")
    }
    if(is(AnnotationData, "annoGR")){
        AnnotationData <- as(AnnotationData, "GRanges")
    }
    if(!is(AnnotationData, "GRanges")){
        stop("AnnotationData must be an object of GRanges")
    }
    bindingType <- match.arg(bindingType)
    featureType <- match.arg(featureType)
    AnnotationData <- unique(AnnotationData)
    suppressWarnings({
        anno <- annotatePeakInBatch(x, AnnotationData=AnnotationData, 
                                    output="shortestDistance",
                                    FeatureLocForDistance=bindingType, 
                                    PeakLocForDistance="middle")
    })
    
    anno <- unique(anno)
    if(length(anno)<1){
        stop("Can not annotate input x with the AnnotationData.")
    }
    distancetoFeature <- anno$distancetoFeature
    ## calculate the breaks
    ## previous just use ceiling(length(x)/100)
    ## now use boxplot.stats to remove the out
    box.stats <- boxplot.stats(distancetoFeature, coef=1.5, 
                               do.conf=FALSE, do.out=FALSE)
    whiskers <- box.stats$stats[5] - box.stats$stats[1]
    minWid <- 100
    if(whiskers>100*minWid){
        breaks <- seq(box.stats$stats[1], box.stats$stats[5],
                      length.out=100)
        minWid <- diff(breaks)[1]
    }else{
        if(whiskers>minWid){
            breaks <- seq(floor(box.stats$stats[1]/minWid), 
                          ceiling(box.stats$stats[5]/minWid),
                          by=1)*minWid
        }else{
            breaks <- mean(box.stats$stats[c(1,5)])
            breaks <- c(breaks-minWid/2, breaks+minWid/2)
        }
    }
    if(min(distancetoFeature)<min(breaks)) 
        breaks <- c(min(distancetoFeature), breaks)
    if(max(distancetoFeature)>max(breaks))
        breaks <- c(breaks, max(distancetoFeature))
    h <- hist(distancetoFeature, breaks=breaks, 
              plot=FALSE)
    N <- as.integer(h$counts)
    diff <- as.integer(floor(minWid/2))
    offset <- as.integer(floor(h$mids))
    offset <- offset[N>0]
    N <- N[N>0]
    new("bindist", counts=N,
        mids=offset,
        halfBinSize=diff,
        bindingType=bindingType,
        featureType=featureType)
}

#' Perform overlap queries between reads and genome by windows
#' 
#' tileCount extends
#' \link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps} by
#' providing fixed window size and step to split whole genome into windows and
#' then do queries. It will return counts in each windows.
#' 
#' 
#' @param reads A \link[GenomicRanges:GRanges-class]{GRanges},
#' \link[GenomicRanges:GRangesList-class]{GRangesList}
#' \link[GenomicAlignments:GAlignments-class]{GAlignments},
#' \link[GenomicAlignments:GAlignmentsList-class]{GAlignmentsList},
#' \link[GenomicAlignments:GAlignmentPairs-class]{GAlignmentPairs} or
#' \link[Rsamtools:BamFile-class]{BamFileList} object that represents the data
#' to be counted by
#' \code{\link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps}}.
#' @param genome The object from/on which to get/set the sequence information.
#' @param windowSize Size of windows
#' @param step Step of windows
#' @param keepPartialWindow Keep last partial window or not.
#' @param mode mode can be one of the pre-defined count methods. see
#' \link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps}.
#' default is countByOverlaps, alia of countOverlaps(features, reads,
#' ignore.strand=ignore.strand)
#' @param ...  Additional arguments passed to
#' \code{\link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps}}.
#' @return A
#' \link[SummarizedExperiment:RangedSummarizedExperiment-class]{RangedSummarizedExperiment}
#' object. The assays slot holds the counts, rowRanges holds the annotation
#' from genome.
#' @author Jianhong Ou
#' @keywords misc
#' @export
#' @import IRanges
#' @import GenomicRanges
#' @importFrom GenomicAlignments summarizeOverlaps
#' @examples
#' 
#'     fls <- list.files(system.file("extdata", package="GenomicAlignments"),
#'                   recursive=TRUE, pattern="*bam$", full=TRUE)
#'     names(fls) <- basename(fls)
#'     genes <- GRanges(seqlengths = c(chr2L=7000, chr2R=10000))
#'     se <- tileCount(fls, genes, windowSize=1000, step=500)
#' 
tileCount <- function(reads, genome, windowSize=1e6, step=1e6, 
                      keepPartialWindow=FALSE,
                      mode=countByOverlaps, ...){
    targetRegions <- seqlengths(genome)
    if(any(is.na(targetRegions))) stop("Can not get seq lengths from genome.")
    targetRegions <- GRanges(names(targetRegions), 
                             IRanges(1, width=targetRegions))
    tileTargetRegions <- tileGRanges(targetRegions, windowSize, 
                                     step, keepPartialWindow)
    se <- summarizeOverlaps(features=tileTargetRegions, reads=reads, 
                            mode=mode, ...)
    return(se)
}

#' Get gene sequence using the biomaRt package
#' 
#' Get gene sequence using the biomaRt package
#' 
#' 
#' @param LocationParameters c(ensembl_gene_id, distance from the peak to the
#' transcription start site of the gene with the above ensemblID, upstream
#' offset from the peak, downstream offset from the peak, Gene Start, Gene End)
#' @param mart see useMart of bioMaRt package for details
#' @return a list with the following items \item{feature_id}{ensemble gene ID}
#' \item{distancetoFeature}{distance from the peak to the transcriptionstart
#' site of the gene with the above ensembl gene ID} \item{upstream}{upstream
#' offset from the peakStart} \item{downstream}{downstream offset from the
#' peakEnd} \item{seq}{sequence obtained around the peak with above upstream
#' and downstream offset}
#' @note internal function not intended to be called directly by users
#' @author Lihua Julie Zhu
#' @keywords internal misc
#' @importFrom biomaRt getSequence
#' @examples
#' 
#' 
#' 
#' if (interactive())
#' {
#' mart <- useMart(biomart="ensembl", dataset="drerio_gene_ensembl")
#' LocationParameters =c("ENSDARG00000054562",400, 750, 750,40454140,40454935)
#' getGeneSeq(LocationParameters, mart)
#' 
#' LocationParameters =c("ENSDARG00000054562",752, 750, 750,40454140,40454935)
#' getGeneSeq(LocationParameters, mart)
#'  
#' LocationParameters =c("ENSDARG00000054562",750, 750, 750,40454140,40454935)
#' getGeneSeq(LocationParameters, mart)
#'  
#'  LocationParameters =c("ENSDARG00000054562",-2, 750, 750,40454140,40454935)
#'  getGeneSeq(LocationParameters, mart)
#' 
#'  LocationParameters =c("ENSDARG00000054562",0, 750, 750,40454140,40454935)
#'  getGeneSeq(LocationParameters, mart)
#'  
#'  LocationParameters =c("ENSDARG00000054562",2, 750, 750,40454140,40454935)
#'  getGeneSeq(LocationParameters, mart) 
#'  
#'  LocationParameters =c("ENSDARG00000054562",1000, 750, 750,40454140,40454935)
#'  getGeneSeq(LocationParameters, mart)
#' }
#' 
#' 
getGeneSeq <- function(LocationParameters, mart){
    ### ensembl_gene_id, distanceToNearestTSS, upstream, downstream, 
    ### TSSStart, TSSEnd, mart
    if (missing(LocationParameters) || length(LocationParameters) <6)
    {
        stop("No valid LocationParameters passed in. 
             It should contain six fields as c(distanceToNearestTSS, 
             upstream, downstream, GeneStart, GeneEnd)!")
    }
    if (missing(mart) || !is(mart, "Mart"))
    {
        stop("No valid mart object is passed in!")
    }
    distanceToNearestTSS = as.numeric(LocationParameters[2])
    downstream = as.numeric(LocationParameters[4])
    upstream = as.numeric(LocationParameters[3])
    TSSStart = as.numeric(LocationParameters[5])
    TSSEnd = as.numeric(LocationParameters[6])
    
    TSSLen = TSSEnd - TSSStart
    seqLen = downstream + upstream
    
    seq = getSequence(id=as.character(LocationParameters[1]), 
                      type="ensembl_gene_id",
                      seqType="gene_exon_intron",
                      mart=mart)
    if (nchar(seq[1]) < TSSLen)
    {
        upstream = upstream + TSSLen - nchar(seq[1])
    }
    if (distanceToNearestTSS <= upstream & 
            TSSLen - distanceToNearestTSS > downstream)
    {
        upstreamOffset = upstream - distanceToNearestTSS 
        seq = getSequence(id=as.character(LocationParameters[1]),
                          type="ensembl_gene_id",
                          seqType="gene_exon_intron",
                          upstream=upstreamOffset,
                          mart=mart)
        start = 1
        end = seqLen + 1
        seq1 = substr(seq[1], start, end)
    }
    else if (TSSLen - distanceToNearestTSS < downstream & 
                 distanceToNearestTSS > upstream)
    {
        downstreamOffset = downstream - TSSLen + distanceToNearestTSS
        seq = getSequence(id=as.character(LocationParameters[1]), 
                          type="ensembl_gene_id",
                          seqType="gene_exon_intron",
                          downstream=downstreamOffset,
                          mart=mart)
        start = distanceToNearestTSS - upstream
        end = distanceToNearestTSS + downstream + 1
        seq1 = substr(seq[1], start, end)
    }    
    else if ( distanceToNearestTSS > upstream & 
                  TSSLen - distanceToNearestTSS >= downstream)
    {
        seq = getSequence(id=as.character(LocationParameters[1]), 
                          type="ensembl_gene_id",
                          seqType="gene_exon_intron",
                          mart=mart)
        start = distanceToNearestTSS - upstream
        end = distanceToNearestTSS + downstream + 1
        seq1 = substr(seq[1], start, end)
    }
    else if (TSSLen - distanceToNearestTSS <= downstream & 
                 distanceToNearestTSS <= upstream)
    {
        downstreamOffset = downstream - TSSLen + distanceToNearestTSS
        upstreamOffset = upstream - distanceToNearestTSS
        seq1 = getSequence(id=as.character(LocationParameters[1]), 
                           type="ensembl_gene_id",
                           seqType="gene_exon_intron",
                           upstream=upstreamOffset,
                           mart=mart)
        seq2 = getSequence(id=as.character(LocationParameters[1]), 
                           type="ensembl_gene_id",
                           seqType="gene_exon_intron",
                           downstream=downstreamOffset,
                           mart=mart)
        seq3 = substr(seq1[1], 1, upstreamOffset)
        seq = paste(seq3, seq2[1], sep="")
        start = 1
        end = seqLen + 1
        seq1 = substr(seq, start, end)
    }
    
    if (is.na(seq1))
    {
        seq1 ="No Sequence Found"
    }
    temp = c(LocationParameters[1:4], seq1)
    dim(temp) =c(1,5)
    
    colnames(temp) = c("feature_id", "distancetoFeature", 
                       "upstream", "downstream", "seq")
    list(feature_id=temp[1],
         distancetoFeature=temp[2],
         upstream=temp[3],
         downstream=temp[4],
         seq=temp[5])
}

#' Obtain gene ontology (GO) terms for given genes
#' 
#' Obtain gene ontology (GO) terms useing GO gene mapping package such as
#' org.Hs.db.eg to obtain the GO annotation.
#' 
#' 
#' @param all.genes A character vector of feature IDs
#' @param orgAnn Organism annotation package such as org.Hs.eg.db for human and
#' org.Mm.eg.db for mouse, org.Dm.eg.db for fly, org.Rn.eg.db for rat,
#' org.Sc.eg.db for yeast and org.Dr.eg.db for zebrafish
#' @param ID_type The feature type in annotatedPeak such as ensembl_gene_id,
#' refseq_id, gene_symbol
#' @param writeTo File path for output table
#' @return An invisible table with genes and GO terms.
#' @author Lihua Julie Zhu
#' @seealso getEnrichedGO
#' @keywords misc
#' @export
#' @importFrom AnnotationDbi mappedkeys Definition Ontology Term
#' @importFrom utils write.table
#' @examples
#' 
#'   if (interactive()) {
#'      data(annotatedPeak)
#'      library(org.Hs.eg.db)
#'      getGO(annotatedPeak[1:6]$feature, 
#'           orgAnn="org.Hs.eg.db", 
#'           ID_type="ensembl_gene_id")
#' }
#' 
getGO <- function(all.genes, orgAnn = "org.Hs.eg.db", 
                  writeTo, ID_type="gene_symbol"){

  GOgenome = sub(".db", "", orgAnn)
  
  cov2EntrezID <- function(IDs, orgAnn, ID_type = "ensembl_gene_id") {
    
    GOgenome = sub(".db", "", orgAnn)
    
    orgAnn <- switch(ID_type, ensembl_gene_id = "ENSEMBL2EG", 
                     
                     gene_symbol = "SYMBOL2EG", refseq_id = "REFSEQ2EG", 
                     
                     "BAD_NAME")
    
    if (orgAnn == "BAD_NAME") 
      
      stop("Currently only the following type of IDs are supported:\n 
           ensembl_gene_id, refseq_id  and gene_symbol!")
    
    orgAnn <- get(paste(GOgenome, orgAnn, sep = ""))
    
    if (!is(orgAnn, "AnnDbBimap")) {
      
      stop("orgAnn is not a valid annotation dataset! \n 
           For example, orgs.Hs.eg.db package for human and \n 
           the org.Mm.eg.db package for mouse.")
      
    }
    
    IDs <- unique(IDs[!is.na(IDs)])
    
    ids <- mget(IDs, orgAnn, ifnotfound = NA)
    
    ids <- lapply(ids, `[`, 1)
    
    ids <- unlist(ids)
    
    ids <- unique(ids[!is.na(ids)])
    
    
    
    ids
    
  }
  
  
  
  entrezIDs <- cov2EntrezID(as.character(all.genes), orgAnn, ID_type)
  
  
  
  if (length(entrezIDs) < 2) {
    
    stop("The number of gene is less than 2. 
         Please double check your feature_id_type.")
    
  }
  
  goAnn <- get(paste(GOgenome, "GO", sep = ""))
  
  mapped_genes <- mappedkeys(goAnn)
  
  totalN.genes = length(unique(mapped_genes))
  
  thisN.genes = length(unique(entrezIDs))
  
  xx <- mget(mapped_genes, goAnn, ifnotfound = NA)
  
  all.GO <- cbind(matrix(unlist(unlist(xx)), ncol = 3, byrow = TRUE), 
                  
                  rep(names(xx), elementNROWS(xx)))
  
  all.GO <- unique(all.GO)
  
  this.GO <- all.GO[all.GO[, 4] %in% entrezIDs, , drop = FALSE]
  
  
  
  annoTerms <- function(goids) {
    
    if (length(goids) < 1) {
      
      goterm <- matrix(ncol = 4)
      
    }
    
    else {
      
      goids <- as.character(goids)
      
      terms <- Term(goids)
      
      definition <- Definition(goids)
      
      ontology <- Ontology(goids)
      
      goterm <- cbind(goids, terms[match(goids, names(terms))], 
                      
                      definition[match(goids, names(definition))]) 
      
      #, ontology[match(goids, names(ontology))])
      
    }
    
    colnames(goterm) <- c("go.id", "go.term", "Definition" 
                          
    )
    
    rownames(goterm) <- NULL
    
    goterm
    
  }
  
  
  
  this.GO.withTerms <- unique(annoTerms(this.GO[,1]))
  
  colnames(this.GO) = c("go.id", "Evidence", "Ontology", "EntrezID")
  
  
  
  IDs <- as.character(all.genes)
  
  GOgenome = sub(".db", "", orgAnn)
  
  orgAnn2 <- switch(ID_type, ensembl_gene_id = "ENSEMBL2EG", 
                    
                    gene_symbol = "SYMBOL2EG", refseq_id = "REFSEQ2EG", 
                    
                    "BAD_NAME")
  
  if (orgAnn2 == "BAD_NAME") 
    
    stop("Currently only the following type of IDs are supported:\n 
         ensembl_gene_id, refseq_id and gene_symbol!")
  
  orgAnn2 <- get(paste(GOgenome, orgAnn2, sep = ""))
  
  if (!is(orgAnn2, "AnnDbBimap")) {
    
    stop("orgAnn is not a valid annotation dataset! \n 
         For example, orgs.Hs.eg.db package for human and \n 
         the org.Mm.eg.db package for mouse.")
    
  }
  
  
  
  ids <- mget(IDs, orgAnn2, ifnotfound = NA)
  
  ids.withInputIDs <- cbind(names(unlist(ids)), unlist(ids))
  
  ids.withInputIDs <- subset(ids.withInputIDs, !is.na(ids.withInputIDs[,2]))
  
  
  
  this.GO.withTermsEntrezIDs <- merge(this.GO, this.GO.withTerms)
  
  #dim(this.GO.withTermsEntrezIDs)
  
  
  
  this.GO.withTermsEntrezIDs <- 
    cbind(ids.withInputIDs[match(this.GO.withTermsEntrezIDs[, 4], 
                                 ids.withInputIDs[,2]), 1],
          this.GO.withTermsEntrezIDs)
  
  colnames(this.GO.withTermsEntrezIDs)[1] = "Alternate.ID"
  
  
  
  
  
  if(!missing(writeTo)) write.table(this.GO.withTermsEntrezIDs,
                                    file =writeTo, sep="\t",
                                    row.names = FALSE)
  
  return(invisible(this.GO.withTermsEntrezIDs))
}

#' Convert between the name of the organism annotation package ("OrgDb") and
#' the name of the organism.
#' 
#' Give a species name and return the organism annotation package name or give
#' an organism annotation package name then return the species name.
#' 
#' 
#' @param name The name of the organism annotation package or the species.
#' @return A object of character
#' @author Jianhong Ou
#' @keywords misc
#' @export
#' @importFrom utils adist
#' @examples
#' 
#'   egOrgMap("org.Hs.eg.db")
#'   egOrgMap("Mus musculus")
#' 
egOrgMap <- function(name){
    if(!is(name, "character"))
        stop("class of input organism should be character")
    organism <- c(
        "org.Ag.eg.db"="Anopheles gambiae",
        "org.At.eg.db"="Arabidopsis thaliana",
        "org.Bt.eg.db"="Bos taurus",
        "org.Ce.eg.db"="Caenorhabditis elegans",
        "org.Cf.eg.db"="Canis lupus familiaris",
        "org.Dm.eg.db"="Drosophila melanogaster",
        "org.Dr.eg.db"="Danio rerio",
        "org.EcK12.eg.db"="Escherichia coli str. K12a",
        "org.EcSakai.eg.db"="Escherichia coli O157:H7 str. Sakai",
        "org.Gg.eg.db"="Gallus gallus",
        "org.Hs.eg.db"="Homo sapiens",
        "org.Mm.eg.db"="Mus musculus",
        "org.Mmu.eg.db"="Macaca mulatta",
        "org.Pf.plasmo.db"="Plasmodium falciparum",
        "org.Pt.eg.db"="Pan troglodytes",
        "org.Rn.eg.db"="Rattus norvegicus",
        "org.Sc.sgd.db"="Saccharomyces cerevisiae",
        "org.Sco.eg.db"="Streptomyces coelicolor",
        "org.Ss.eg.db"="Sus scrofa",
        "org.Tgondii.eg.db"="Toxoplasma gondii",
        "org.Xl.eg.db"="Xenopus laevis")
    if(name %in% names(organism)){
        return(organism[name])
    }else{
        if(name %in% organism)
            return(names(organism)[organism==name])
    }
    ##claculate the string distance, need utils package
    org <- as.character(c(names(organism), organism))
    dis <- adist(name, org)
    org <- org[dis==min(dis)]
    stop(paste("You input \"", name, "\". Do you mean \"", org, "\"?", sep=""))
}

#' Add GO IDs of the ancestors for a given vector of GO ids
#' @description Add GO IDs of the ancestors for a given vector of GO IDs 
#' leveraging GO.db 
#' @param go.ids A matrix with 4 columns: first column is GO IDs and 4th 
#' column is entrez IDs.
#' @param ontology bp for biological process, cc for cellular component and 
#' mf for molecular function.
#' @return A vector of GO IDs containing the input GO IDs with the GO IDs of 
#' their ancestors added.
#' @export
#' @author Lihua Julie Zhu
#' @examples 
#' go.ids = cbind(c("GO:0008150", "GO:0005576", "GO:0003674"),
#'                c("ND", "IDA", "ND"), 
#'                c("BP", "BP", "BP"), 
#'                c("1", "1", "1"))
#' library(GO.db)
#' addAncestors(go.ids, ontology="bp")
#' @keywords misc
#' 

addAncestors <- function(go.ids, ontology=c("bp","cc", "mf"))
{
    stopifnot("The 'GO.db' package is required"=
                  requireNamespace("GO.db", quietly = TRUE))
    ontology = match.arg(ontology)
    if (missing(go.ids))
    {
        stop("missing required parameter go.ids!")
    }
    if (!is(go.ids, "matrix") | dim(go.ids)[2] <4)
    {
        stop("go.ids need to be a matrix with at least 4 columns, 
            the first column is go id and the second column is the entrez ID!")
    }
    if (ontology =="bp")
    {
        xx <- as.list(GO.db::GOBPANCESTOR)
    }
    else if (ontology =="cc")
    {
        xx <- as.list(GO.db::GOCCANCESTOR)
    }
    else if (ontology =="mf")
    {
        xx <- as.list(GO.db::GOMFANCESTOR)
    }
    xx <- xx[!is.na(xx)]
    
    if (length(xx) <=0)
    {
        stop("No GO Ancestors! Should not have happened!")
    }
    go.ids.withAncestor = intersect(as.character(go.ids[,1]), names(xx))
    if (length(go.ids.withAncestor) >0)
    {
        Ancestors =	do.call(rbind, lapply(go.ids.withAncestor,function(x1)
        {
            r= xx[names(xx)==x1]
            if (length(r) > 0 )
            {
                cbind(rep(x1, length(r[[1]])), r[[1]])
            }
        }))
        Ancestors = Ancestors[Ancestors[,2] !="all",]
        colnames(Ancestors) = c("child", "ancestor")
        children = cbind(go.ids[,1],go.ids[,4])
        colnames(children) = c("child", "entrezID")
        go.all = merge(children, Ancestors, by="child", all.x=TRUE)
        temp = cbind(c(as.character(go.all$child),
                       as.character(go.all$ancestor)), 
                     c(as.character(go.all$entrezID), 
                       as.character(go.all$entrezID)))
        temp = unique(temp)
        if (length(temp) <3)
        {
            unique(children)
        }
        else
        {
            temp[!is.na(temp[,1]) & temp[,1] != "",]
        }
    }
    else
    {
        unique(cbind(as.character(go.ids[,1]), go.ids[,4]))
    }
}

#' Obtain enriched PATH that near the peaks
#'
#' Obtain enriched PATH that are near the peaks using path package such as
#' reactome.db and path mapping package such as org.Hs.db.eg to obtain the path
#' annotation and using hypergeometric test (phyper) and multtest package for
#' adjusting p-values
#'
#'
#' @param annotatedPeak GRanges such as data(annotatedPeak) or a vector of
#' feature IDs
#' @param orgAnn organism annotation package such as org.Hs.eg.db for human and
#' org.Mm.eg.db for mouse, org.Dm.eg.db for fly, org.Rn.eg.db for rat,
#' org.Sc.eg.db for yeast and org.Dr.eg.db for zebrafish
#' @param pathAnn pathway annotation package such as KEGG.db (deprecated), reactome.db, KEGGREST
#' @param feature_id_type the feature type in annotatedPeakRanges such as
#' ensembl_gene_id, refseq_id, gene_symbol or entrez_id
#' @param maxP maximum p-value to be considered to be significant
#' @param minPATHterm minimum count in a genome for a path to be included
#' @param multiAdjMethod multiple testing procedures, for details, see
#' mt.rawp2adjp in multtest package
#' @param subGroupComparison A logical vector to split the peaks into two
#' groups. The enrichment analysis will compare the over-present GO terms
#' in TRUE group and FALSE group separately. The analysis will split into
#' two steps: 1. enrichment analysis for TRUE group by hypergeometric
#' test; 2. enrichment analysis for TRUE over FALSE group
#' by Fisher's Exact test for the enriched GO terms.
#' To keep the output same format, if you want to compare FALSE vs TRUE,
#' please repeat the analysis by inverting the parameter.
#' Default is NULL.
#' @return A dataframe of enriched path with the following variables.
#' \item{path.id}{KEGG PATH ID} \item{EntrezID}{Entrez ID}
#' \item{count.InDataset}{count of this PATH in this dataset}
#' \item{count.InGenome}{count of this PATH in the genome} \item{pvalue}{pvalue
#' from the hypergeometric test} \item{totaltermInDataset}{count of all PATH in
#' this dataset} \item{totaltermInGenome}{count of all PATH in the genome}
#' \item{PATH}{PATH name}
#' @author Jianhong Ou, Kai Hu
#' @seealso phyper, hyperGtest
#' @references Johnson, N. L., Kotz, S., and Kemp, A. W. (1992) Univariate
#' Discrete Distributions, Second Edition. New York: Wiley
#' @keywords misc
#' @export
#' @importFrom AnnotationDbi mappedkeys
#' @importFrom multtest mt.rawp2adjp
#' @importFrom KEGGREST keggGet keggLink
#' @examples
#'
#' if (interactive()||Sys.getenv("USER")=="jou") {
#' data(annotatedPeak)
#' library(org.Hs.eg.db)
#' library(reactome.db)
#' enriched.PATH = getEnrichedPATH(annotatedPeak, orgAnn="org.Hs.eg.db",
#'                  feature_id_type="ensembl_gene_id",
#'                  pathAnn="reactome.db", maxP=0.01,
#'                  minPATHterm=10, multiAdjMethod=NULL)
#'  head(enriched.PATH)
#'  enrichedKEGG = getEnrichedPATH(annotatedPeak, orgAnn="org.Hs.eg.db",
#'                  feature_id_type="ensembl_gene_id",
#'                  pathAnn="KEGGREST", maxP=0.01,
#'                  minPATHterm=10, multiAdjMethod=NULL)
#'  enrichmentPlot(enrichedKEGG)
#' }
#'
getEnrichedPATH <- function(annotatedPeak, orgAnn, pathAnn,
                            feature_id_type="ensembl_gene_id",
                            maxP=0.01, minPATHterm=10, multiAdjMethod=NULL,
                            subGroupComparison=NULL)
{
    if (missing(annotatedPeak)){
        stop("Missing required argument annotatedPeak!")
    }
    # if (missing(feature_id_type)) {
    #     stop("Missing required argument feature_id_type!")
    # }
    if(length(multiAdjMethod)>0){
        multiAdjMethod <- match.arg(multiAdjMethod,
                                    c("Bonferroni", "Holm", "Hochberg",
                                      "SidakSS", "SidakSD", "BH", "BY",
                                      "ABH","TSBH"))
    }
    if (!grepl("^org\\...\\.eg\\.db",orgAnn)){
        message("No valid organism specific PATH gene mapping package as
                parameter orgAnn is passed in!")
        stop("Please refer
             http://www.bioconductor.org/packages/release/data/annotation/
             for available org.xx.eg.db packages")
    }
    if(!isNamespaceLoaded(orgAnn)){
        stop(paste("Need to load", orgAnn,
                   "before using getEnrichedPATH. Try \n\"library(",
                   orgAnn,")\""))
    }
    if (missing(pathAnn)){
        stop("Missing required argument pathAnn. \n
             pathAnn is the database with annotation object that maps
Entrez Gene to pathway identifies named as xxxxxEXTID2PATHID
             and pathway identifies to pathway names named as
             xxxxxPATHID2NAME.")
    }
    if(!isNamespaceLoaded(pathAnn)){
        stop(paste("Need to load",pathAnn,
                   "before using getEnrichedPATH. Try \n\"library(",
                   pathAnn,")\""))
    }

    groupFALSE <- NULL
    feature_ids_FALSE <- NULL
    entrezIDs_FALSE <- NULL
    if(length(subGroupComparison)){
        if(length(subGroupComparison)!=length(annotatedPeak)){
            stop("Length of subGroupComparison should keep same as",
                 "length of annotatedPeak or check your input annotatedPeak type.")
        }
        stopifnot(is(subGroupComparison, "logical"))
        groupFALSE <- annotatedPeak[!subGroupComparison]
        annotatedPeak <- annotatedPeak[subGroupComparison]
    }
    if (inherits(annotatedPeak, what=c("GRanges"))){
        feature_ids = unique(as.character(annotatedPeak$feature))
        if(length(groupFALSE)){
            feature_ids_FALSE = unique(as.character(groupFALSE$feature))
        }
    }else if (is.character(annotatedPeak)){
        feature_ids = unique(annotatedPeak)
        if(length(groupFALSE)){
            feature_ids_FALSE = unique(groupFALSE)
        }
    }else{
        stop("annotatedPeak needs to be GRanges with feature variable
             holding the feature id or a character vector holding the IDs of
             the features used to annotate the peaks!")
    }
    if (feature_id_type == "entrez_id"){
        entrezIDs <- feature_ids
        if(length(groupFALSE)){
            entrezIDs_FALSE <- feature_ids_FALSE
        }
    }else{
        entrezIDs <- convert2EntrezID(feature_ids, orgAnn, feature_id_type)
        if(length(groupFALSE)){
            entrezIDs_FALSE <- convert2EntrezID(feature_ids_FALSE,
                                            orgAnn, feature_id_type)
        }
    }
    if(length(entrezIDs)<2){
        stop('The number of gene is less than 2. Please double check your feature_id_type. If using "ensembl_gene_id", do not include the version number. E.g. "ENSG00000139618" is okay while "ENSG00000139618.2" is not compatible. Use `ensembl_gene_id <- sub("\\.[^.]+$", "", ensembl_gene_id)` to batch remove the version number if needed.')
    }
    if (pathAnn %in% c("KEGG.db")) {
      stop('`pathAnn = "KEGG.db"` has been deprecated, use `pathAnn = "KEGGREST"` instead.')
    }
    if (pathAnn %in% c("reactome.db", "KEGG.db")) {
        extid2path<- paste(gsub(".db$","",pathAnn),"EXTID2PATHID", sep="")
        path2name<- paste(gsub(".db$","",pathAnn),"PATHID2NAME", sep="")
        if(length(objects(paste("package",pathAnn,sep=":"),
                          pattern=extid2path))!=1 &
           length(objects(paste("package",pathAnn,sep=":"),
                          pattern=path2name))!=1 ){
            stop("argument pathAnn is not the annotation data with objects named
             as xxxxxEXTID2PATHID and/or xxxxxPATHID2NAME")
        }
        extid2path <- get(extid2path)
        mapped_genes <- mappedkeys(extid2path)
        #get all the entrez_ids in the species
        mapped_genes <-
            mapped_genes[mapped_genes %in%
                             mappedkeys(get(paste(gsub(".db","",orgAnn),
                                                  "SYMBOL",sep="")))]
        totalN.genes=length(unique(mapped_genes))
        thisN.genes = length(unique(entrezIDs))
        xx <- as.list(extid2path[mapped_genes])
    } else if (pathAnn == "KEGGREST") {
    # for KEGGREST db
        organismKEGGREST <- .findKEGGRESTOrganismName(orgAnn)
        EGID2PATHID <- keggLink("pathway", organismKEGGREST)
        # get rid of the leading organismKEGGREST in front of the EntrezID and the "path" in front of the PATHID
        names(EGID2PATHID) <- unlist(lapply(strsplit(names(EGID2PATHID), ":"), "[", 2))
        EGID2PATHID <- unlist(lapply(strsplit(EGID2PATHID, ":"), "[", 2))

        mapped_genes2 <- names(keggLink("pathway", organismKEGGREST))
        mapped_genes2 <- unique(unlist(lapply(strsplit(mapped_genes2, ":"), "[", 2)))

        mapped_genes <- mapped_genes2[mapped_genes2 %in%
                            mappedkeys(get(paste(gsub(".db","",orgAnn), "SYMBOL", sep="")))]

        totalN.genes=length(unique(mapped_genes))
        thisN.genes = length(unique(entrezIDs))

        xx <- with(stack(as.list(EGID2PATHID)), split(values, ind))
    }

    all.PATH <- do.call(rbind, lapply(mapped_genes,function(x1)
    {
        temp = unlist(xx[names(xx) ==x1])
        if (length(temp) >0)
        {
            temp1 =matrix(temp,ncol=1,byrow=TRUE)
            cbind(temp1,rep(x1,dim(temp1)[1]))
        }
    }))
    this.PATH <- do.call(rbind, lapply(entrezIDs,function(x1)
    {
        temp = unlist(xx[names(xx) ==x1])
        if (length(temp) >0)
        {
            temp1 =matrix(temp,ncol=1,byrow=TRUE)
            cbind(temp1,rep(x1,dim(temp1)[1]))
        }
    }))


    all.PATH <- unique(all.PATH)## in case the database is not unique
    this.PATH <- unique(this.PATH)
    if (is.null(all.PATH) | is.null(this.PATH)) {
    	return(data.frame(log = "No enriched pathway found!"))
    }
    colnames(all.PATH)<-c("path.id","entrez_id")
    colnames(this.PATH)<-c("path.id","entrez_id")
    path.all<-as.character(all.PATH[,"path.id"])
    path.this<-as.character(this.PATH[,"path.id"])

    total = length(path.all)
    this = length(path.this)

    all.count = getUniqueGOidCount(as.character(path.all[path.all!=""]))
    this.count = getUniqueGOidCount(as.character(path.this[path.this!=""]))

    if(length(groupFALSE)){
        FALSE.PATH <- do.call(rbind, lapply(entrezIDs_FALSE,function(x1)
        {
            temp = unlist(xx[names(xx) ==x1])
            if (length(temp) >0)
            {
                temp1 =matrix(temp,ncol=1,byrow=TRUE)
                cbind(temp1,rep(x1,dim(temp1)[1]))
            }
        }))
        FALSE.PATH <- unique(FALSE.PATH)
        colnames(FALSE.PATH)<-c("path.id","entrez_id")
        path.FALSE<-as.character(FALSE.PATH[,"path.id"])
        FALSE.count = getUniqueGOidCount(as.character(path.FALSE[path.FALSE!=""]))
        names(FALSE.count[[2]]) <- FALSE.count[[1]]
        FALSE.count <- FALSE.count[[2]]
    }

    selected = hyperGtest(all.count,this.count, total, this)

    selected = data.frame(selected)

    colnames(selected) = c("path.id", "count.InDataset", "count.InGenome",
                           "pvalue", "totaltermInDataset", "totaltermInGenome")
		
    annoTerms <- function(termids){
        if(length(termids)<1){
            goterm <- matrix(ncol=2)
        }else{
            if (pathAnn %in% c("reactome.db")) {
                termids <- as.character(termids)
                terms <- xget(termids, get(sub(".db", "PATHID2NAME", pathAnn)))
                goterm <- cbind(termids,
                                terms[match(termids, names(terms))])
            } else if (pathAnn %in% c("KEGG.db", "KEGGREST")) {
                # Must get rid of the leading organismKEGGREST of path.id
                # if using KEGG.db or KEGGREST
                organismKEGGREST <- .findKEGGRESTOrganismName(orgAnn)
                termidsPreRemoved <- sub(organismKEGGREST, "", termids)

                if (pathAnn == "KEGG.db") {
                    terms <- xget(termidsPreRemoved, get(sub(".db", "PATHID2NAME", pathAnn)))
                    goterm <- cbind(termids,
                                    terms[match(termidsPreRemoved, names(terms))])
                } else if (pathAnn  == "KEGGREST") {
                    getPathName <- function(pathid) {
                        namePath <- tryCatch(
                            res <- keggGet(pathid)[[1]]$NAME,
                            error = function(c) res <- "NA"
                        )
                        names(namePath) <- pathid
                        namePath
                    }
                    terms <- unlist(lapply(termids, getPathName))
                    goterm <- cbind(termids,
                                    terms[match(termids, names(terms))])
                }
            }
        }
        colnames(goterm) <- c("path.id", "path.term")
        rownames(goterm) <- NULL
        goterm
    }
    annoterm <- annoTerms(selected$path.id)
    selected <- merge(annoterm, selected, by="path.id")

    if (is.null(multiAdjMethod)){
        s = selected[as.numeric(as.character(selected[,"pvalue"]))<maxP &
                         as.numeric(as.character(selected[, "count.InGenome"]))>=minPATHterm,]
    }else{
        procs = c(multiAdjMethod)
        res <- mt.rawp2adjp(as.numeric(as.character(selected[,"pvalue"])), procs)
        adjp = unique(res$adjp)
        colnames(adjp)[1] = "pvalue"
        colnames(adjp)[2] = paste(multiAdjMethod, "adjusted.p.value", sep=".")
        selected[,"pvalue"] = as.numeric(as.character(selected[,"pvalue"]))
        bp1 = merge(selected, adjp, all.x=TRUE)

        s = bp1[as.numeric(as.character(bp1[,dim(bp1)[2]]))<maxP &
                    !is.na(bp1[,dim(bp1)[2]]) &
                    as.numeric(as.character(bp1[,"count.InGenome"]))>=minPATHterm,]
    }

    selected = merge(this.PATH, s)

    if(length(groupFALSE)){ ## add counts for FALSE group and do Fisher's exact test
        selected$count.InBackgroundDataset = FALSE.count[selected$path.id]

        multiFisher <- function(.data){
            rowFisher <- function(x, ...){
                return(fisher.test(matrix(x, nrow = 2, byrow = TRUE), ...)$p.value)
            }
            .data0 <- .data[, c("count.InDataset", "count.InBackgroundDataset")]
            .data0 <- as.matrix(.data0)
            .data0[is.na(.data0)] <- 0
            .data0 <- cbind(.data0, .data[, "count.InGenome"] - .data0)
            apply(.data0, 1, rowFisher, alternative = "greater")
        }
        selected$dataset.vs.background.pval <- multiFisher(selected)

        selected <-
            selected[selected$dataset.vs.background.pval<maxP, , drop=FALSE]
    }


    selected
    }


.findKEGGRESTOrganismName <- function(name) {
    # Find the organism names used in the KEGGREST db, tested for Hs, Mm, Dm, Rn, Sc, and Dr
    #acroName <- egOrgMap(orgName)
    #KEGGOrganismList <- keggList("organism")
    #ad <- adist(acroName, KEGGOrganismList[, "species"])[1, ]
    #KEGGOrganism <- KEGGOrganismList[which.min(ad), "organism"][[1]]
    if(!is(name, "character"))
        stop("class of input organism should be character")
    organism <- c(
        "org.Ag.eg.db"="aga",
        "org.At.eg.db"="ath",
        "org.Bt.eg.db"="bta",
        "org.Ce.eg.db"="cel",
        "org.Cf.eg.db"="cfa",
        "org.Dm.eg.db"="dme",
        "org.Dr.eg.db"="dre",
        "org.EcK12.eg.db"="eco",
        "org.EcSakai.eg.db"="ecs",
        "org.Gg.eg.db"="gga",
        "org.Hs.eg.db"="hsa",
        "org.Mm.eg.db"="mmu",
        "org.Mmu.eg.db"="mcc",
        "org.Pf.plasmo.db"="pfa",
        "org.Pt.eg.db"="ptr",
        "org.Rn.eg.db"="rno",
        "org.Sc.sgd.db"="sce",
        "org.Sco.eg.db"="sco",
        "org.Ss.eg.db"="ssc",
        "org.Tgondii.eg.db"="tgo",
        "org.Xl.eg.db"="xla")
    if(name %in% names(organism)){
        return(organism[name])
    }else{
        if(name %in% organism)
            return(names(organism)[organism==name])
    }
    ##claculate the string distance, need utils package
    org <- as.character(c(names(organism), organism))
    dis <- adist(name, org)
    org <- org[dis==min(dis)]
    stop(paste("You input \"", name, "\". Do you mean \"", org, "\"?", sep=""))
}

#' Get downstream coordinates
#' 
#' Returns an object of the same type and length as x containing downstream 
#' ranges. The output range is defined as
#' 
#' (end(x) - upstream) to (end(x) + downstream -1) 
#' 
#' for ranges on the + and * 
#' strand, and as 
#' 
#' (start(x) - downstream + 1) to (start(x) + downstream)
#' 
#' for ranges on the - strand.
#' 
#' Note that the returned object might contain out-of-bound ranges.
#' 
#' @param gr A GenomicRanges object
#' @param upstream,downstream non-negative interges.
#' @return A GenomicRanges object
#' @export
#' @import GenomicRanges
#' @examples 
#' gr <- GRanges("chr1", IRanges(rep(10, 3), width=6), c("+", "-", "*"))
#' downstreams(gr, 2, 2)
#'
downstreams <- function(gr, upstream, downstream){
  stopifnot(is(gr, "GRanges"))
  stopifnot(identical(levels(strand(gr)), c("+", "-", "*")))
  gr.rev <- gr
  levels(strand(gr.rev)) <- c("-", "+", "*")
  out <- promoters(gr.rev, upstream = downstream, downstream = upstream)
  levels(strand(out)) <- c("-", "+", "*")
  stopifnot(identical(levels(strand(out)), c("+", "-", "*")))##will auto Correct
  out
}

test_that("downstreams works not correct", {
    ##GRanges
    ## myPeak
    ## 1 2 3 4 5 6 7 8 9 10
    ##       a a a b b       + -
    
    myPeak = GRanges("1", 
                     IRanges(start=c(4, 7), 
                             end=c(6, 8), 
                             names=letters[1:2]), 
                     strand=c("+", "-"))
    dws <- downstreams(myPeak, upstream = 0, downstream = 2)
    expect_equal(width(dws), c(2, 2))
    expect_equal(start(dws), c(7, 5))
    expect_equal(strand(dws), strand(myPeak))
    ##0 bdp
    dws <- downstreams(myPeak, upstream = 0, downstream = 0)
    expect_equal(width(dws), c(0, 0))
    ##up
    dws <- downstreams(myPeak, upstream = 2, downstream = 0)
    expect_equal(width(dws), c(2, 2))
    expect_equal(start(dws), c(5, 7))
    expect_equal(end(dws), end(myPeak))
    expect_equal(strand(dws), strand(myPeak))
    ##up & down
    dws <- downstreams(myPeak, upstream = 2, downstream = 2)
    expect_equal(width(dws), c(4, 4))
    expect_equal(start(dws), c(5, 5))
    expect_equal(end(dws), c(8, 8))
    expect_equal(strand(dws), strand(myPeak))
})

#' Plot the cumulative percentage tag allocation in sample
#' 
#' Plot the difference between the cumulative percentage tag allocation in
#' paired samples.
#' 
#' 
#' @param bamfiles Bam file names.
#' @param gr An object of \link[GenomicRanges:GRanges-class]{GRanges}
#' @param input Which file name is input. default 1.
#' @param binWidth The width of each bin.
#' @param ... parameter for
#' \link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps}.
#' @return A list of data.frame with the cumulative percentages.
#' @author Jianhong Ou
#' @references Normalization, bias correction, and peak calling for ChIP-seq
#' Aaron Diaz, Kiyoub Park, Daniel A. Lim, Jun S. Song Stat Appl Genet Mol
#' Biol. Author manuscript; available in PMC 2012 May 3.Published in final
#' edited form as: Stat Appl Genet Mol Biol. 2012 Mar 31; 11(3):
#' 10.1515/1544-6115.1750
#' /j/sagmb.2012.11.issue-3/1544-6115.1750/1544-6115.1750.xml.  Published
#' online 2012 Mar 31.  doi: 10.1515/1544-6115.1750 PMCID: PMC3342857
#' @importFrom SummarizedExperiment assays
#' @importFrom GenomicAlignments summarizeOverlaps
#' @importFrom graphics abline axis legend matlines par plot
#' @export
#' @examples
#' 
#' \dontrun{
#' path <- system.file("extdata", "reads", package="MMDiffBamSubset")
#' files <- dir(path, "bam$", full.names = TRUE)
#' library(BSgenome.Hsapiens.UCSC.hg19)
#' gr <- as(seqinfo(Hsapiens)["chr1"], "GRanges")
#' cumulativePercentage(files, gr)
#' } 
#'  
#' 
cumulativePercentage <- function(bamfiles, gr, input=1, binWidth=1e3,
                                 ...){
  stopifnot(is(gr, "GRanges"))
  tileTargetRegions <- tileGRanges(gr, windowSize = binWidth, step = binWidth)
  se <- summarizeOverlaps(features=tileTargetRegions, reads=bamfiles, ...)
  ## resample
  sampleName <- colnames(assays(se)[[1]])[-1*input]
  input <- colnames(assays(se)[[1]])[input]
  sigBin <- lapply(sampleName, function(.n){
    sig <- assays(se)[[1]][, c(input, .n)]
    sig[order(sig[, .n], sig[, input]), ]
  })
  sigCumsum <- lapply(sigBin, function(.ele){
    .ele <- apply(.ele, 2, cumsum)
    .ele <- cbind(Rank=seq.int(nrow(.ele)), .ele)
    sweep(.ele, MARGIN = 2, STATS = .ele[nrow(.ele),], FUN = `/`)
  })
  pin <- par("pin")
  if(pin[2]>0){
    ratio <- 2^round(diff(log2(pin)))
    n <- length(sampleName)
    ncol <- ceiling(sqrt(n/ratio))
    nrow <- ceiling(n/ncol)
    op <- par(mfrow=c(nrow, ncol), pty="s")
    on.exit(par(op))
    for(i in 1:n){
      ## plot
      plot(c(0, 1), c(0, 1), type="n", 
           xlab="% of bins", ylab="% of tags", 
           main=sampleName[i])
      matlines(x=sigCumsum[[i]][, 1], 
               y=sigCumsum[[i]][, -1],
               lty = 1)
      zero <- which(sigCumsum[[i]][, 2]>1/binWidth)
      maxDist <- which.max(abs(sigCumsum[[i]][, 2] - sigCumsum[[i]][, 3]))
      if(length(zero)>0 | length(maxDist)>0){
        x <- numeric(0)
        if(length(zero)>0) x <- c(x, zero[1])
        if(length(maxDist)>0) x <- c(x, maxDist[1])
        x.tick <- sigCumsum[[i]][x, 1]
        abline(v=x.tick, col="yellowgreen", lty=3)
        axis(3, at=x.tick, labels = formatC(x.tick, digits=2), 
             lwd = 0, lwd.ticks = 1)
      }
      legend("topleft", legend = colnames(sigCumsum[[i]])[-1], 
             col=1:6, lty = 1, pch = NA, box.col = NA)
    }
  }
  return(invisible(sigCumsum))
}

## help function df2GRanges
df2GRanges <- function(data, colNames=NULL, format="", ...){
    if (missing(data)){
        stop("data is required!")
    }
    if ((!is(data, "data.frame")) || dim(data)[2] <3)
    {
        stop("No valid data passed in. For example a data frame as BED format
             file with at least 3 fields in the order of: chromosome, start and end.
             Optional fields are name, score and strand etc.
             Please refer to http://genome.ucsc.edu/FAQ/FAQformat#format1 for details.")
    }
    if(is.null(colNames)) colNames <- colnames(data)
    colNames_space <-
        tolower(colNames) %in% c("space", "seqnames", "chr", "chrom",
                                 "chromosome", "chromosomes")
    if(length(sum(colNames_space))==1){
        colNames[colNames_space] <- "space"
    }
    colNames <- gsub("^start$", "start", colNames, ignore.case=TRUE)
    colNames <- gsub("^end$", "end", colNames, ignore.case=TRUE)
    if(!all(c("space","start","end") %in% colNames)){
        stop("colname must contain space/seqnames, start and end.")
    }
    if(length(colNames)<ncol(data))
        stop("the length of colNames is less than number of columns of data")
    colnames(data) <- colNames[1:ncol(data)]

    getCol <- function(pattern, words, default){
        ss <- grep(pattern, colnames(data), ignore.case=TRUE)
        if(length(ss)>1)
            stop(paste("input data has multiple columns for",words,"information"))
        if(length(ss)==1){
            re <- data[,ss]
            data[, ss] <<- NULL
        }else{
            re <- default
        }
        re
    }
    ##prepare strand
    strand <- getCol("^strand$", "strand", "*")
    strand <- formatStrand(strand)

    ##prepare name, memory comsume step. TODO, change it.
    names <- getCol("^name(s)?$", "names", NA)
    if(any(is.na(names)) || any(duplicated(names))) {
        message("duplicated or NA names found. Rename all the names by numbers.")
        ## formatC has memory leak
        n <- nrow(data)
        names <- sprintf(paste("X%0",nchar(as.character(n)),"d", sep=""), 1:n)
    }
    names <- make.names(names)

    ##prepare score
    #   score <- getCol("^score$", "score", 1L)
    #   if(length(score)==1) score <- rep(1, nrow(data))
    #   if(all(is.na(score))) score <- rep(1, nrow(data))
    #   score <- as.numeric(as.character(score))

    ##prepare start, end, seqnames
    start <- data$start
    end <- data$end
    seqnames <- data$space
    if(!is.numeric(start[1])) start <- as.numeric(as.character(start))
    if(!is.numeric(end[1])) end <- as.numeric(as.character(end))
    if(!is.character(seqnames[1])) seqnames <- as.character(data$space)
    ## trim seqnames
    seqnames <- gsub("^\\s+|\\s+$", "", seqnames)

    gr <- GRanges(seqnames=seqnames,
                  ranges=IRanges(start=start,
                                 end=end,
                                 names = names),
                  strand=strand)
    rm(list=c("start", "end", "names", "strand", "seqnames"))
    metadata <- colnames(data)
    metadata <- metadata[!metadata %in% c("seqnames", "space", "ranges",
                                          "strand", "seqlevels",
                                          "seqlengths", "isCircular",
                                          "genome", "start",
                                          "end", "width", "element")]
    for(col in metadata){
        mcols(gr)[,col]<-data[,col]
    }
    rm(data)
    #  gc(verbose=FALSE, reset=TRUE)
    if(format=="BED"){
        start(gr) <- start(gr) + 1 ## bed file is (start, end]
        if(length(gr$thickStart)>0 &
           length(gr$thickEnd)>0){
            if(!(all(gr$thickStart==round(gr$thickStart)) &&
               all(gr$thickEnd==round(gr$thickEnd)))){
              stop("This is not a standard BED file. ",
                   "Maybe it is narrowPeak or broadPeak")
            }
            gr$thick <- IRanges(gr$thickStart+1, gr$thickEnd)
            gr$thickStart <- NULL
            gr$thickEnd <- NULL
        }
        if(length(gr$itemRgb)>0) {## itemRgb, 255,0,0
            itemRgb <- do.call(rbind, strsplit(as.character(gr$itemRgb), ","))
            gr$itemRgb <- NULL
            if(ncol(itemRgb)==3){
                itemRgb <- apply(itemRgb, 1, function(.ele){
                    .ele <- as.numeric(.ele)
                    rgb(.ele[1], .ele[2], .ele[3], maxColorValue = 255)
                })
                gr$itemRgb <- itemRgb
            }else{
                gr$itemRgb <- NA
            }
        }
        if(length(gr$blockCount)>0 &
           length(gr$blockSizes)>0 &
           length(gr$blockStarts)>0){
            blocksizes <- strsplit(as.character(gr$blockSizes), ",")
            blockstarts <- strsplit(as.character(gr$blockStarts), ",")
            blocks <- mapply(function(num, sizes, starts){
                sizes <- as.integer(sizes)[1:num]
                starts <- as.integer(starts)[1:num]
                ir <- IRanges(starts+1, width=sizes)
                return(ir)
            }, gr$blockCount, blocksizes, blockstarts, SIMPLIFY=FALSE)
            gr$blocks <- IRangesList(blocks)
            gr$blockCount <- NULL
            gr$blockSizes <- NULL
            gr$blockStarts <- NULL
        }
    }
    return(gr)
}

switchColNames <- function(format=c("BED", "GFF",
                                    "MACS", "MACS2", "MACS2.broad",
                                    "narrowPeak", "broadPeak", "CSV",
                                    "others"), colNames=NULL){
    format <- match.arg(format)
    switch(format,
           BED=c("space", "start", "end", "names",
                 "score", "strand", "thickStart",
                 "thickEnd", "itemRgb", "blockCount",
                 "blockSizes", "blockStarts"),
           GFF=c("space", "source", "names", "start",
                 "end", "score", "strand", "frame", "group"),
           MACS=c("space", "start", "end", "length",
                  "summit", "tags", "-10*log10(pvalue)",
                  "fold_enrichment", "FDR"),
           MACS2=c("space", "start", "end", "length",
                   "abs_summit", "pileup", "-log10(pvalue)",
                   "fold_enrichment", "-log10(qvalue)", "names"),
           MACS2.broad=c("space", "start", "end", "length",
                         "pileup", "-log10(pvalue)",
                         "fold_enrichment", "-log10(qvalue)", "names"),
           narrowPeak=c("space", "start", "end", "names",
                        "score", "strand", "signalValue",
                        "pValue", "qValue", "peak"),
           broadPeak=c("space", "start", "end", "names",
                       "score", "strand", "signalValue",
                       "pValue", "qValue"),
           others=colNames,
           colNames)
}

#' Convert dataset to GRanges
#'
#' Convert UCSC BED format and its variants, such as GFF, or any user defined
#' dataset such as MACS output file to GRanges
#'
#' @rdname toGRanges
#' @aliases toGRanges toGRanges,data.frame-method
#' @param data an object of data.frame, \link[GenomicFeatures:TxDb-class]{TxDb}
#' or \link[ensembldb]{EnsDb}, or the file name of data to be imported.
#' Alternatively, data can be a readable txt-mode connection (See ?read.table).
#' @param format data format.  If the data format is set to BED, GFF,
#' narrowPeak or broadPeak, please refer to
#' http://genome.ucsc.edu/FAQ/FAQformat#format1 for column order. "MACS" is for
#' converting the excel output file from MACS1. "MACS2" is for converting the
#' output file from MACS2. If set to CSV, must have columns: seqnames, start, end, strand.
#' @param feature annotation type
#' @param header A logical value indicating whether the file contains the names
#' of the variables as its first line. If missing, the value is determined from
#' the file format: header is set to TRUE if the first row contains
#' one fewer field than the number of columns or the format is set to 'CSV'.
#' @param comment.char character: a character vector of length one containing a
#' single character or an empty string. Use "" to turn off the interpretation
#' of comments altogether.
#' @param colNames If the data format is set to "others", colname must be
#' defined. And the colname must contain space, start and end. The column name
#' for the chromosome # should be named as space.
#' @param \dots parameters passed to \link{read.table}
#' @param OrganismDb an object of \link[OrganismDbi]{OrganismDb}. It is used
#' for extracting gene symbol for geneModel group for
#' \link[GenomicFeatures:TxDb-class]{TxDb}
#' @return An object of \link[GenomicRanges:GRanges-class]{GRanges}
#' @author Jianhong Ou
#' @keywords misc
#' @exportMethod toGRanges
#' @export toGRanges
#' @importFrom utils read.csv
#' @examples
#'
#'   macs <- system.file("extdata", "MACS_peaks.xls", package="ChIPpeakAnno")
#'   macsOutput <- toGRanges(macs, format="MACS")
#'   if(interactive() || Sys.getenv("USER")=="jou"){
#'     ## MACS connection
#'     macs <- readLines(macs)
#'     macs <- textConnection(macs)
#'     macsOutput <- toGRanges(macs, format="MACS")
#'     close(macs)
#'     ## bed
#'     toGRanges(system.file("extdata", "MACS_output.bed", package="ChIPpeakAnno"),
#'                 format="BED")
#'     ## narrowPeak
#'     toGRanges(system.file("extdata", "peaks.narrowPeak", package="ChIPpeakAnno"),
#'                 format="narrowPeak")
#'     ## broadPeak
#'     toGRanges(system.file("extdata", "TAF.broadPeak", package="ChIPpeakAnno"),
#'                 format="broadPeak")
#'     ## CSV
#'     toGRanges(system.file("extdata", "peaks.csv", package="ChIPpeakAnno"),
#'                 format="CSV")
#'     ## MACS2
#'     toGRanges(system.file("extdata", "MACS2_peaks.xls", package="ChIPpeakAnno"),
#'                 format="MACS2")
#'     ## GFF
#'     toGRanges(system.file("extdata", "GFF_peaks.gff", package="ChIPpeakAnno"),
#'                 format="GFF")
#'     ## EnsDb
#'     library(EnsDb.Hsapiens.v75)
#'     toGRanges(EnsDb.Hsapiens.v75, feature="gene")
#'     ## TxDb
#'     library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#'     toGRanges(TxDb.Hsapiens.UCSC.hg19.knownGene, feature="gene")
#'     ## data.frame
#'     macs <- system.file("extdata", "MACS_peaks.xls", package="ChIPpeakAnno")
#'     macs <- read.delim(macs, comment.char="#")
#'     toGRanges(macs)
#'   }
#'
#' @importFrom grDevices rgb
#'
setGeneric("toGRanges", function(data, ...) standardGeneric("toGRanges"))
setMethod("toGRanges", "data.frame",
          function(data, colNames=NULL, ...){
              this.call <- match.call(expand.dots=TRUE)
              this.call[[1]] <- df2GRanges
              if(length(this.call$format)==0) this.call$format <- "data.frame"
              gr <- eval(this.call, parent.frame())
              return(gr)
})


message4GTF <- function(con){
  message("If you are importing files downloaded from ensembl,
          it will be better to import the files into a TxDb object,
          and then convert to GRanges by toGRanges. Here is the sample code:
          library(GenomicFeatures)
          txdb <- makeTxDbFromGFF('", con ,"')
          anno <- toGRanges(txdb, format='gene')")
}

#' @importFrom rtracklayer import
#' @importFrom utils read.table
#' @rdname toGRanges
#' @aliases toGRanges,connection-method
setMethod("toGRanges", "connection",
          function(data, format=c("BED", "GFF", "GTF",
                                  "MACS", "MACS2", "MACS2.broad",
                                  "narrowPeak", "broadPeak", "CSV",
                                  "others"),
                   header=FALSE, comment.char="#", colNames=NULL, ...){
              format <- match.arg(format)
              if(format %in% c("GFF", "GTF")){
                message4GTF("path/to/your/GFF")
                gr <- import(data, format=format)
                return(gr)
              }
              if(format %in% c("narrowPeak", "broadPeak")){
                  data <- read.table(data, header=FALSE,
                                     fill=TRUE, stringsAsFactors=FALSE)
                  data <- data[!grepl("track|browser", data[, 1]), 1:ncol(data)]
                  classes <- c("character", "integer", "integer", "character",
                               "integer", "character", "numeric", "numeric",
                               "numeric", "integer")[1:ncol(data)]
                  for(i in 1:ncol(data)){
                      class(data[, i]) <- mode(data[, i]) <- classes[i]
                  }
              } else if (format %in% c("CSV")) {
                data <- read.csv(data, header=TRUE)
                if(any(colnames(data)=="X") &
                   all(!colnames(data) %in% c("names", "name"))){
                  colnames(data)[colnames(data)=="X"] <- "names"
                }
                colNames <- colnames(data)
              }else{
                  if(format %in% c("MACS", "MACS2", "MACS2.broad")){
                      header <- TRUE
                      comment.char <- "#"
                  }
                  data <- read.table(data, header=header,
                                     comment.char=comment.char,
                                     ...)
              }
              colNames <- switchColNames(format, colNames)
              if(is.null(colNames))
                stop("colNames is required for unkown format.")
              gr <- df2GRanges(data, colNames, format, ...)
              return(gr)
          })

#' @rdname toGRanges
#' @aliases toGRanges,TxDb-method
setMethod("toGRanges", "TxDb",
          function(data, feature=c("gene", "transcript", "exon",
                                   "CDS", "fiveUTR", "threeUTR",
                                   "tRNAs", "geneModel"),
                   OrganismDb, ...){
              feature <- match.arg(feature)
              if(!missing(OrganismDb)) {
                  return(TxDb2GR(data, feature, OrganismDb))
              }else{
                  return(TxDb2GR(data, feature))
              }
          })

#' @rdname toGRanges
#' @aliases toGRanges,EnsDb-method
setMethod("toGRanges", "EnsDb",
          function(data,
                   feature=c("gene", "transcript", "exon", "disjointExons"),
                   ...){
              feature <- match.arg(feature)
              return(EnsDb2GR(data, feature))
          })

#' @rdname toGRanges
#' @aliases toGRanges,character-method
setMethod("toGRanges", "character",
          function(data, format=c("BED", "GFF", "GTF",
                                  "MACS", "MACS2", "MACS2.broad",
                                  "narrowPeak", "broadPeak", "CSV",
                                  "others"),
                   header=FALSE, comment.char="#", colNames=NULL, ...){
              format <- match.arg(format)
              if(format %in% c("GFF", "GTF")){
                message4GTF(data)
                gr <- import(data, format=format)
                return(gr)
              } else if (format %in% c("narrowPeak", "broadPeak")){
                  data <- read.table(data, header=FALSE,
                                     fill=TRUE, stringsAsFactors=FALSE)
                  data <- data[!grepl("track|browser", data[, 1]), 1:ncol(data)]
                  classes <- c("character", "integer", "integer", "character",
                               "integer", "character", "numeric", "numeric",
                               "numeric", "integer")[1:ncol(data)]
                  for(i in 1:ncol(data)){
                      class(data[, i]) <- mode(data[, i]) <- classes[i]
                  }
              } else if (format %in% c("CSV")) {
                  data <- read.csv(data, header=TRUE)
                  if(any(colnames(data)=="X") &
                     all(!colnames(data) %in% c("names", "name"))){
                    colnames(data)[colnames(data)=="X"] <- "names"
                  }
                  colNames <- colnames(data)
              } else {
                  if(format %in% c("MACS", "MACS2", "MACS2.broad")){
                      header <- TRUE
                      comment.char <- "#"
                  }
                  tab5rows <- read.table(data, header=header,
                                         comment.char=comment.char, ...,
                                         nrows=5)
                  classes <- sapply(tab5rows, class)
                  if(format=="BED"){##check class of column 2 and 3
                      if(classes[2]!="integer"||classes[3]!="integer")
                          stop("No valid data passed in. For example a data frame as
                               BED format file with at least 3 fields in the order of:
                               chromosome, start and end. Optional fields are name, score and strand etc.
                               Column 2 and 3 must be integer.
                               Please refer to http://genome.ucsc.edu/FAQ/FAQformat#format1 for details.")
                      if(!is.na(classes[5])) classes[5] <- "numeric"
                      classes[1] <- "character"
                  }else{
                      if(format=="GFF"){##check class of column 4 and 5
                          if(classes[4]!="integer"||classes[5]!="integer")
                              stop("No valid data passed in.
                                   For example a data frame as
                                   GFF format file with 9 fields in the order of:
                                   seqname, source, feature, start, end, score, strand, frame and group.
                                   Column 4 and 5 must be integer.
                                   Please refer to http://genome.ucsc.edu/FAQ/FAQformat#format1 for details.")
                        classes[1] <- "character"
                      }else{
                          if(format %in% c("MACS", "MACS2", "MACS2.broad")){
                              ## do nothing
                          }else{
                              if(header && is.null(colNames)){ ## format=="others"
                                  colNames <- colnames(tab5rows)
                              }
                          }
                      }
                  }
                  if(format=="BED" && length(classes)>12)
                      classes[13:length(classes)] <- rep("NULL", length(classes)-12)

                  data <- read.table(data, header=header,
                                     comment.char=comment.char, ...,
                                     colClasses=classes)
                  rm(list=c("tab5rows", "classes"))
              }
              colNames <- switchColNames(format, colNames)
              gr <- df2GRanges(data, colNames, format, ...)
              return(gr)
          })

#' TSS annotation for human sapiens (NCBI36) obtained from biomaRt
#' 
#' TSS annotation for human sapiens (NCBI36) obtained from biomaRt
#' 
#' used in the examples Annotation data obtained by:
#' 
#' mart = useMart(biomart = "ensembl_mart_47", dataset =
#' "hsapiens_gene_ensembl", archive=TRUE)
#' 
#' getAnnotation(mart, featureType = "TSS")
#' 
#' @name TSS.human.NCBI36
#' @docType data
#' @format GRanges with slot start holding the start position of the gene, slot
#' end holding the end position of the gene, slot names holding ensembl gene
#' id, slot seqnames holding the chromosome location where the gene is located
#' and slot strand holding the strinad information. In addition, the following
#' variables are included.  \describe{ \item{list("description")}{description
#' of the gene}}
#' @keywords datasets
#' @examples
#' 
#' data(TSS.human.NCBI36)
#' slotNames(TSS.human.NCBI36)
#' 
"TSS.human.NCBI36"

#' re-center the peaks
#' 
#' Create a new list of peaks based on the peak centers of given list.
#' 
#' 
#' @param peaks An object of \link[GenomicRanges:GRanges-class]{GRanges} or
#' \link{annoGR}.
#' @param width The width of new peaks
#' @param ... Not used.
#' @return An object of GRanges.
#' @author Jianhong Ou
#' @keywords misc
#' @export
#' @examples
#' 
#'     reCenterPeaks(GRanges("chr1", IRanges(1, 10)), width=2)
#' 
reCenterPeaks <- function(peaks, width=2000L, ...){
    stopifnot(inherits(peaks, c("annoGR", "GRanges")))
    peaks.center <- start(peaks) + floor(width(peaks)/2)
    peaks.recentered <- peaks
    start(peaks.recentered) <- peaks.center - floor(width/2)
    width(peaks.recentered) <- width
    if(any(start(peaks.recentered)<1)){
      warning("Some start position of the peaks are less than 1!")
    }
    seqLen <- seqlengths(peaks)
    seqLen <- seqLen[!is.na(seqLen)]
    if(length(seqLen)>0){
      peaks.subset <- 
        peaks.recentered[seqnames(peaks.recentered) %in% names(seqLen)]
      if(any(end(peaks.subset)>seqLen[as.character(seqnames(peaks.subset))])){
        warning("Some end position of the peaks are out of bound!")
      }
    }
    peaks.recentered
}

#' extract signals in given ranges
#' 
#' extract signals in the given feature ranges
#' 
#' 
#' @param cvglists List of \link[IRanges:AtomicList-class]{SimpleRleList} or
#' \link[IRanges:AtomicList-class]{RleList}
#' @param feature.gr An object of \link[GenomicRanges:GRanges-class]{GRanges}
#' with identical width.
#' @param upstream,downstream Set the feature.gr to upstream and dwonstream
#' from the center of the feature.gr if they are set.
#' @param n.tile The number of tiles to generate for each element of
#' feature.gr, default is 100
#' @param ... Not used.
#' @return A list of matrix. In each matrix, each row record the signals for
#' corresponding feature. rownames of the matrix show the seqnames and
#' coordinates.
#' @author Jianhong Ou
#' @seealso See Also as \link{featureAlignedHeatmap},
#' \link{featureAlignedDistribution}
#' @keywords misc
#' @export
#' @import GenomicRanges
#' @importFrom BiocGenerics width start end strand `%in%`
#' @importFrom S4Vectors runLength runValue Rle
#' @importFrom GenomeInfoDb seqnames seqlengths 
#' @examples
#' 
#'   cvglists <- list(A=RleList(chr1=Rle(sample.int(5000, 100), 
#'                                       sample.int(300, 100))), 
#'                    B=RleList(chr1=Rle(sample.int(5000, 100), 
#'                                       sample.int(300, 100))))
#'   feature.gr <- GRanges("chr1", IRanges(seq(1, 4900, 100), width=100))
#'   featureAlignedSignal(cvglists, feature.gr)
#' 
featureAlignedSignal <- function(cvglists, feature.gr, 
                                 upstream, downstream, 
                                 n.tile=100, ...){
  stopifnot(is(feature.gr, "GRanges"))
  
  grWidr <- unique(width(feature.gr))
  if(missing(upstream) || missing(downstream)){
    if(length(grWidr)!=1){
      stop("The width of feature.gr is not identical.")
    }
  }else{
    if(!is.numeric(upstream) || !is.numeric(downstream)){
      stop("upstream and downstream must be integers")
    }
    if(upstream<0 || downstream<0){
      stop("upstream and downstream must be not less than 0")
    }
    upstream <- as.integer(upstream)
    downstream <- as.integer(downstream)
    if(length(grWidr)!=1 || any(grWidr!=1)){
      start(feature.gr) <- start(feature.gr)+floor(width(feature.gr)/2)
      width(feature.gr) <- 1
      warning("feature.gr is set to the center of feature.gr")
    }
    feature.gr <- promoters(feature.gr, upstream = upstream,
                            downstream = downstream + 1)
    grWidr <- unique(width(feature.gr))
  }
  if(any(start(feature.gr)<1)){
    warning("Some start position of the peaks are less than 1!",
            "They will be filtered.")
    feature.gr <- feature.gr[start(feature.gr)>0]
  }
  if(length(feature.gr)<2){
    stop("Length of feature.gr less than 2.")
  }
  if(inherits(cvglists, c("SimpleRleList", "RleList", "CompressedRleList"))){
    cvglistsName <- substitute(deparse(cvglists))
    cvglists <- list(cvglists)
    names(cvglists) <- cvglistsName
  }
  if(!is(cvglists, "list")){
    stop("cvglists must be a list of SimpleRleList or RleList")
  }
  cls <- sapply(cvglists, inherits, 
                what = c("SimpleRleList", "RleList", "CompressedRleList"))
  if(any(!cls))
    stop("cvglists must be a list of SimpleRleList or RleList")
  seqLen <-  lapply(cvglists, function(.ele) 
    sapply(.ele, function(.e) sum(runLength(.e))))
  seqLen.keep <- table(unlist(sapply(seqLen, names)))==length(cvglists)
  seqLen <- seqLen[[1]][seqLen.keep]
  seqLen <- seqLen[!is.na(seqLen)]
  if(length(seqLen)>0){
    feature.gr.subset <- 
      feature.gr[seqnames(feature.gr) %in% names(seqLen)]
    if(any(end(feature.gr.subset)>
           seqLen[as.character(seqnames(feature.gr.subset))])){
      warning("Some end position of the peaks are out of bound!",
              "They will be filtered.")
      feature.gr <- 
        feature.gr.subset[end(feature.gr.subset) <=
                            seqLen[as.character(seqnames(feature.gr.subset))]]
    }
  }
  #feature.gr.bck <- feature.gr
  stopifnot(is.numeric(n.tile))
  n.tile <- round(n.tile)
  grL <- tile(feature.gr, n=n.tile)
  idx <- as.character(strand(feature.gr))=="-"
  if(sum(idx)>0) {
    grL.rev <- grL[idx]
    grL.rev.len <- lengths(grL.rev)
    grL.rev <- unlist(grL.rev, use.names = FALSE)
    grL.rev$oid <- rep(seq.int(length(grL[idx])), grL.rev.len)
    grL.rev <- rev(grL.rev)
    grL.rev.oid <- grL.rev$oid
    grL.rev$oid <- NULL
    grL.rev <- split(grL.rev, grL.rev.oid)
    grL[idx] <- as(grL.rev, "CompressedGRangesList")
    rm(grL.rev, grL.rev.len, grL.rev.oid)
  }
  grL.len <- lengths(grL)
  grL <- unlist(grL)
  grL$oid <- rep(seq_along(feature.gr), grL.len)
  grL$nid <- unlist(lapply(grL.len, seq.int))
  grL.len <- length(grL)
  grL.s <- split(grL, as.character(seqnames(grL)))
  grL <- unlist(grL.s) ## make sure grL and grL.s keep the same order
  seqn <- names(grL.s)
  seql <- seqlengths(feature.gr)
  seql <- seql[seqn]
  seql.f <- range(feature.gr)
  seql.f <- seql.f[match(seqn, seqnames(seql.f))]
  seql[is.na(seql)] <- width(seql.f)[is.na(seql)] + 1
  trimChar <- function(x, width){
      len <- nchar(x)
      if(len <= width) return(x)
      return(paste0(strtrim(x, width=width), "..."))
  }
  rowname.feature.gr <- paste0(as.character(seqnames(feature.gr)), ":",
                               start(feature.gr), "-",
                               end(feature.gr))
  cov <- lapply(cvglists, function(.dat){
      .dat <- .dat[seqn[seqn %in% names(.dat)]]
      if(length(.dat)!=length(seqn)){
          warning(paste(seqn[!seqn %in% names(.dat)], collapse=", "), 
                  ifelse(length(seqn[!seqn %in% names(.dat)])>1, " are", " is"), 
                  " not in cvglists. seqlevels of cvglist are ", 
                  trimChar(paste(names(.dat), collapse=", "), width=60))
          for(i in seqn[!seqn %in% names(.dat)]){
              .dat[[i]] <- Rle(0, seql[i])
          }
      }
      warn <- sapply(.dat, function(.ele){
          any(is.na(runValue(.ele)))
      })
      if(any(warn)){
          warning("cvglists contain NA values.")
      }
      .dat <- sapply(.dat, function(.ele){
          if(any(is.infinite(runValue(.ele)))){
              warning("cvglists contain infinite values. ", 
                      "infinite value will be converted to NA.")
              runValue(.ele)[is.infinite(runValue(.ele))] <- NA
          }
          .ele
      })
      .dat <- .dat[seqn]
      vw <- Views(as(.dat, "RleList"), grL.s)
      vm <- viewMeans(vw)
      vm <- unlist(vm)
      stopifnot(length(vm)==grL.len)
      mm <- matrix(0, nrow=length(feature.gr), ncol=n.tile)
      mm[grL$oid+length(feature.gr)*(grL$nid-1)] <- vm
      rownames(mm) <- rowname.feature.gr
      mm
  })
  
  cov
}

#' TSS annotation data for zebrafish (Zv8) obtained from biomaRt
#' 
#' A GRanges object to annotate TSS for zebrafish (Zv8) obtained from biomaRt
#' 
#' Annotation data obtained by: mart <- useMart(biomart="ENSEMBL_MART_ENSEMBL",
#' host="may2009.archive.ensembl.org", path="/biomart/martservice",
#' dataset="drerio_gene_ensembl")
#' 
#' getAnnotation(mart, featureType = "TSS")
#' 
#' @name TSS.zebrafish.Zv8
#' @docType data
#' @format GRanges with slot start holding the start position of the gene, slot
#' end holding the end position of the gene, slot names holding ensembl gene
#' id, slot seqnames holding the chromosome location where the gene is located
#' and slot strand holding the strinad information. In addition, the following
#' variables are included.  \describe{ \item{list("description")}{description
#' of the gene}}
#' @keywords datasets
#' @examples
#' 
#' data(TSS.zebrafish.Zv8)
#' slotNames(TSS.zebrafish.Zv8)
#' 
"TSS.zebrafish.Zv8"

#' Gene model with exon, 5' UTR and 3' UTR information for human sapiens
#' (GRCh37) obtained from biomaRt
#' 
#' Gene model with exon, 5' UTR and 3' UTR information for human sapiens
#' (GRCh37) obtained from biomaRt
#' 
#' used in the examples Annotation data obtained by: mart = useMart(biomart =
#' "ensembl", dataset = "hsapiens_gene_ensembl") ExonPlusUtr.human.GRCh37 =
#' getAnnotation(mart=human, featureType="ExonPlusUtr")
#' 
#' @name ExonPlusUtr.human.GRCh37
#' @docType data
#' @format GRanges with slot start holding the start position of the exon, slot
#' end holding the end position of the exon, slot rownames holding ensembl
#' transcript id and slot space holding the chromosome location where the gene
#' is located. In addition, the following variables are included.  \describe{
#' \item{list("strand")}{1 for positive strand and -1 for negative strand}
#' \item{list("description")}{description of the transcript}
#' \item{list("ensembl_gene_id")}{gene id} \item{list("utr5start")}{5' UTR
#' start} \item{list("utr5end")}{5' UTR end} \item{list("utr3start")}{3' UTR
#' start} \item{list("utr3end")}{3' UTR end}}
#' @keywords datasets
#' @examples
#' 
#' data(ExonPlusUtr.human.GRCh37)
#' slotNames(ExonPlusUtr.human.GRCh37)
#' 
"ExonPlusUtr.human.GRCh37"

#' Heatmap representing signals in given ranges
#' 
#' plot heatmap in the given feature ranges
#' 
#' 
#' @param cvglists Output of \link{featureAlignedSignal} or a list of
#' \link[IRanges:AtomicList-class]{SimpleRleList} or
#' \link[IRanges:AtomicList-class]{RleList}
#' @param feature.gr An object of \link[GenomicRanges:GRanges-class]{GRanges}
#' with identical width.  If the width equal to 1, you can use upstream and
#' downstream to set the range for plot.  If the width not equal to 1, you can
#' use zeroAt to set the zero point of the heatmap.
#' @param upstream,downstream upstream or dwonstream from the feature.gr.  It
#' must keep same as \link{featureAlignedSignal}. It is used for x-axis label.
#' @param zeroAt zero point position of feature.gr
#' @param n.tile The number of tiles to generate for each element of
#' feature.gr, default is 100
#' @param annoMcols The columns of metadata of feature.gr that specifies the
#' annotations shown of the right side of the heatmap.
#' @param sortBy Sort the feature.gr by columns by annoMcols and then the
#' signals of the given samples. Default is the first sample. Set to NULL to
#' disable sort.
#' @param color vector of colors used in heatmap
#' @param lower.extreme,upper.extreme The lower and upper boundary value of
#' each samples
#' @param margin Margin for of the plot region.
#' @param gap Gap between each heatmap columns.
#' @param newpage Call grid.newpage or not. Default, TRUE
#' @param gp A gpar object can be used for text.
#' @param ... Not used.
#' @return invisible gList object.
#' @author Jianhong Ou
#' @seealso See Also as \link{featureAlignedSignal},
#' \link{featureAlignedDistribution}
#' @keywords misc
#' @export
#' @import IRanges
#' @import GenomicRanges
#' @importFrom BiocGenerics start end width strand
#' @importFrom S4Vectors mcols
#' @importFrom grid grid.newpage viewport legendGrob gpar gList gEdit rasterGrob
#' gTree rasterGrob grid.pretty yaxisGrob grid.draw xaxisGrob
#' @importFrom grDevices colorRampPalette col2rgb rgb
#' @examples
#' 
#'   cvglists <- list(A=RleList(chr1=Rle(sample.int(5000, 100), 
#'                                       sample.int(300, 100))), 
#'                    B=RleList(chr1=Rle(sample.int(5000, 100), 
#'                                       sample.int(300, 100))))
#'   feature.gr <- GRanges("chr1", IRanges(seq(1, 4900, 100), width=100))
#'   feature.gr$anno <- rep(c("type1", "type2"), c(25, 24))
#'   featureAlignedHeatmap(cvglists, feature.gr, zeroAt=50, annoMcols="anno")
#' 
featureAlignedHeatmap <- 
    function(cvglists, feature.gr, upstream, downstream, 
             zeroAt, n.tile=100,
             annoMcols=c(), sortBy=names(cvglists)[1],
             color=colorRampPalette(c("yellow", "red"))(50),
             lower.extreme, upper.extreme,
             margin=c(0.1, 0.01, 0.15, 0.1), gap=0.01, 
             newpage=TRUE, gp=gpar(fontsize=10),
             ...){
    if(!missing(lower.extreme)){
        stopifnot(is.numeric(lower.extreme))
    }
    if(!missing(upper.extreme)){
        stopifnot(is.numeric(upper.extreme))
    }
    stopifnot(is(gp, "gpar"))
    stopifnot(is.logical(newpage))
    stopifnot(is(feature.gr, "GRanges"))
    
    grWidr <- unique(width(feature.gr))
    if(missing(upstream) || missing(downstream)){
        if(length(grWidr)!=1){
            stop("The width of feature.gr is not identical.")
        }
        if(missing(zeroAt)) {
            zeroAt <- 0.5
            message("zero is set as the center of the feature.gr")
        }
    }else{
        if(!is.numeric(upstream) || !is.numeric(downstream)){
            stop("upstream and downstream must be integers")
        }
        if(upstream<0 || downstream<0){
            stop("upstream and downstream must be not less than 0")
        }
        upstream <- as.integer(upstream)
        downstream <- as.integer(downstream)
        if(length(grWidr)!=1){
            start(feature.gr) <- start(feature.gr)+floor(grWidr/2)
            width(feature.gr) <- 1
            warning("feature.gr is set to the center of feature.gr")
        }
        zeroAt <- upstream/(upstream + downstream)
        feature.gr <- promoters(feature.gr, upstream = upstream,
                                downstream = downstream + 1)
        grWidr <- unique(width(feature.gr))
    }
    stopifnot(is.numeric(zeroAt))
    stopifnot(zeroAt>=0)
    if(zeroAt<=1){
        zero <- round(grWidr*zeroAt)
    }else{
        zero <- round(zeroAt)
    }
    
    grWid <- c(0, grWidr) - zero
    grWidLab <- grid.pretty(grWid)
    grWidAt <- (grWidLab+zero)/grWidr
    if(inherits(cvglists, c("SimpleRleList", "RleList", "CompressedRleList"))){
        cvglistsName <- substitute(deparse(cvglists))
        cvglists <- list(cvglists)
        names(cvglists) <- cvglistsName
    }
    if(!is(cvglists, "list")){
        stop("cvglists must be output of featureAlignedSignal or 
             a list of SimpleRleList or RleList")
    }
    
    
    cls <- sapply(cvglists, is, class2="matrix")
    if(all(cls)){
        cov <- cvglists
        if(ncol(cov[[1]])!=n.tile){
            stop("n.tile must keep same as featureAligendSignal.")
        }
    }else{
      cls <- sapply(cvglists, inherits, 
                    what = c("SimpleRleList", "RleList", "CompressedRleList"))
      if(any(!cls))
        stop("cvglists must be a list of SimpleRleList or RleList")
      cov <- featureAlignedSignal(cvglists, feature.gr, n.tile=n.tile)
    }
    
    annoMcols <- annoMcols[annoMcols %in% colnames(mcols(feature.gr))]
    if(length(sortBy)>0){
        covTotalCoverage <- 
            do.call(cbind, lapply(cov, rowSums, na.rm=TRUE))
        colnames(covTotalCoverage) <- names(cvglists)
        if(length(annoMcols)>0){
            sortMatrix <- mcols(feature.gr)[, annoMcols, drop=FALSE]
            for(i in seq.int(ncol(sortMatrix))){
                if(!is.numeric(sortMatrix[,i])){
                    sortMatrix[,i] <- 
                        factor(as.character(sortMatrix[,i]), 
                               levels=
                                 rev(unique(as.character(sortMatrix[, i]))))
                }
            }
            if(all(sortBy %in% colnames(mcols(feature.gr)))){
                sortMatrix <- 
                    cbind(sortMatrix, 
                          as.data.frame(mcols(feature.gr)[, sortBy, 
                                                          drop=FALSE]))
            }else{
                if(all(sortBy %in% colnames(covTotalCoverage))){
                    sortMatrix <- 
                        cbind(sortMatrix,
                              data.frame(covTotalCoverage[, sortBy,
                                                          drop=FALSE]))
                }else{
                    stop("sortBy is incorrect.")
                }
            }
        }else{
            if(all(sortBy %in% colnames(mcols(feature.gr)))){
                sortMatrix <- 
                    as.data.frame(mcols(feature.gr)[, sortBy, drop=FALSE])
            }else{
                if(all(sortBy %in% colnames(covTotalCoverage))){
                    sortMatrix <- data.frame(covTotalCoverage[, sortBy,
                                                              drop=FALSE])
                }else{
                    stop("sortBy is incorrect.")
                }
            }
        }
        names(sortMatrix) <- paste("V", 1:ncol(sortMatrix))
        soid <- do.call(order, c(as.list(sortMatrix), decreasing = TRUE))
        cov <- lapply(cov, function(.ele) .ele[soid, ])
        feature.gr <- feature.gr[soid]
    }
    
    #covert to color
    if(missing(lower.extreme)){
        lower.extreme <- rep(0, length(cvglists))
    }
    if(missing(upper.extreme)){
        lim=list()
    }else{
        upper.extreme <- 
            rep(upper.extreme, length(cvglists))[1:length(cvglists)]
        lim=as.list(data.frame(rbind(lower.extreme, upper.extreme)))
        names(lim) <- NULL
    }
    
    if(length(lim)==0){
        lim <- sapply(cov, range, na.rm=TRUE, simplify=FALSE)
    }
    if(length(lim)==1){
        lim <- rep(lim, length(cov))
        legend <- 1
    }else{
        legend <- length(cov)
    }
    if(any(sapply(lim, length)<2)){
        stop("each limit should be a numeric vector with length 2")
    }
    cov <- mapply(function(.ele, .lim){
        if(min(.lim)==max(.lim)){
            .lim <- seq(min(.lim), max(.lim)+1, length.out=length(color)+1)
        }else{
            .lim <- seq(min(.lim), max(.lim), length.out=length(color)+1)
        }
        .lim[1] <- min(.lim[1], 0)
        .lim[length(.lim)] <- max(max(.lim), .Machine$integer.max)
        t(apply(.ele, 1, 
                cut, breaks=.lim, labels=color, include.lowest=TRUE))
    }, cov, lim, SIMPLIFY=FALSE)
    # library(grid)
    # grid.raster
    if(newpage) grid.newpage()
    allGrob <- NULL
    height=1-margin[3]-margin[1]
    width=1-margin[4]-margin[2]
    ## draw y labels
    isFloat <- function(x){
        if(is.numeric(x)){
            return(x!=floor(x))
        }
        return(FALSE)
    }
    areColors <- function(x) {
        sapply(x, function(X) {
            if(isFloat(X)) return(FALSE)
            if(is.numeric(X)){
                if(X<9 && X>0){
                    return(TRUE)
                }else{
                    return(FALSE)
                }
            }
            tryCatch(is.matrix(col2rgb(X)), 
                     error = function(e) FALSE)
        })
    }
    colorGroup <- 
        list(c("#295AA5", "#52BDBD", "#FFAD6B", "#F784A5", "#CEB55A", 
               "#31B5D6", "#BD2119", "#F79463", "#FFE608", "#D69419", 
               "#29B5CE", "#737BB5"), 
             c("#4A4221", "#A5BD42", "#8CC584", "#CEE6D6", "#C5D64A", 
               "#FFF79C", "#84AD31", "#DBDECE", "#D6AD4A", "#4A4229", 
               "#637B7B", "#525229", "#F7F7AD", "#EFAD63"), 
             c("#6B5252", "#DE6B73", "#000000", "#4A4221", "#3AA55A", 
               "#DEE6C5", "#102119", "#DEE6CE", "#738CC5", "#31317B", 
               "#F7F7AD", "#8C9CA5", "#732163", "#001000"), 
             c("#192919", "#8C946B", "#6B1921", "#F7F7AD", "#4A4229", 
               "#CEA54A", "#000000", "#6B736B", "#524A29", "#423119", 
               "#213129", "#7B4229", "#7B2121", "#C57B4A"), 
             c("#9D2932", "#EFDEB0", "#789262", "#494166", "#A88462", 
               "#D9B612", "#177CB0", "#F3F8F1", "#424B50", "#B36D61", 
               "#C3272B", "#A98175", "#D4F2E8", "#FF3300", "#76664D", 
               "#ED5736", "#A3E2C5", "#415065", "#D7ECF1"), 
             c("#009C8C", "#0094AD", "#BDDEC5", "#00ADCE", "#DEFF19", 
               "#D6EFB5", "#EFF7E6", "#42CE73", "#42A5CE", "#BDFFF7", 
               "#DEFFDE", "#4A6BCE"), 
             c("#D6B5BD", "#EFD6BD", "#FFE6D6", "#DEE6CE", "#F7F7C5", 
               "#D6E6B5", "#73BD8C", "#BDDEDE", "#DEBD8C", "#E6A5BD", 
               "#F7ADAD", "#FFE6D6", "#F7F7D6", "#E6BDBD"), 
             c("#E6E6BD", "#637342", "#425A52", "#298473", "#BDDEC5", 
               "#527384", "#73847B", "#CED6AD", "#94D6CE", "#527384", 
               "#4A6B5A", "#318442", "#C5DEDE"), 
             c("#F7846B", "#F79C9C", "#CEE6E6", "#FFEFBD", "#EFEFBD", 
               "#FFE6DE", "#FFBDA5", "#FFEF00", "#63BD84", "#D6E6AD", 
               "#FFF7D6", "#FFFFEF", "#FFE6DE", "#FFBD9C", "#EF9C94"), 
             c("#4A4229", "#212108", "#6B8484", "#EFE6BD", "#E68C3A", 
               "#A56352", "#6B2921", "#525229", "#844229", "#8C524A", 
               "#E68C3A", "#D6AD4A", "#212108", "#524A3A"), 
             c("#312184", "#AD2919", "#EF3129", "#D69C4A", "#FF6B00", 
               "#6B4A31", "#CE3121", "#AD2919", "#5A3A5A", "#292931", 
               "#3A3184", "#9C5229", "#EFCE19"), 
             c("#6373B5", "#FF5200", "#4AF54A", "#FFCE10", "#EF3A21", 
               "#EF4A94", "#5A63AD", "#FFEDA5", "#EF3121", "#FFC510", 
               "#FF5200"), 
             c("#FFB6C1", "#DC143C", "#DB7093", "#FF69B4", "#FF1493", 
               "#C71585", "#DA70D6", "#FF00FF", "#8B008B", "#9400D3", 
               "#4B0082", "#FFA07A", "#FF7F50", "#FF4500", "#E9967A", 
               "#FF6347", "#F08080", "#CD5C5C", "#FF0000", "#A52A2A", 
               "#B22222", "#8B0000"), 
             c("#7B68EE", "#6A5ACD", "#483D8B", "#E6E6FA", "#0000FF", 
               "#191970", "#4169E1", "#6495ED", "#B0C4DE", "#1E90FF", 
               "#87CEFA", "#00BFFF", "#00FFFF"), 
             c("#008B8B", "#48D1CC", "#7FFFD4", "#66CDAA", "#00FA9A", 
               "#00FF7F", "#3CB371", "#2E8B57", "#90EE90", "#32CD32", 
               "#00FF00", "#008000", "#006400", "#ADFF2F", "#556B2F", 
               "#9ACD32", "#6B8E23"), 
             c("#FAFAD2", "#FFFF00", "#808000", "#BDB76B", "#FFFACD", 
               "#EEE8AA", "#F0E68C", "#FFD700", "#DAA520", "#B8860B", 
               "#F5DEB3", "#FFA500", "#FFEBCD", "#FFDEAD", "#D2B48C", 
               "#FF8C00", "#CD853F", "#8B4513"),
             c("#F5F5F5", "#DCDCDC", "#D3D3D3", "#C0C0C0", "#A9A9A9", 
               "#808080", "#696969", "#5C5C5C", "#4D4D4D", "#333333", 
               "#1A1A1A", "#000000"))
    if(length(annoMcols)>0){
        ci <- 1
        ytop <- 0.75-margin[3]
        mcols <- mcols(feature.gr)
        vp.annoMcols <- viewport(x=.5, y=height/2+margin[1], 
                                 width=1, height=height,
                                 name="vp.annoMcols")
        for(i in annoMcols){
            mc <- as.character(mcols[, i])
            mc.name <- ifelse(is.numeric(i), colnames(mcols)[i], i)
            if(!all(areColors(mcols[, i]))){
                if(is.numeric(mcols[, i])){
                    mc.range <- range(mcols[, i])
                    mc.color <- range(colorGroup[[ci]])
                    mc.color <- colorRampPalette(mc.color)(100)
                    mc <- cut(mcols[, i], breaks = 100, labels = mc.color)
                    mc <- as.character(mc)
                    mc.label <- sort(grid.pretty(mc.range), decreasing = TRUE)
                    mc.label.color <-
                        mc.color[round(100*(mc.label-min(mc.range))/
                                     diff(mc.range))]
                    mc.label <- mc.label[!is.na(mc.label.color)]
                    mc.label.color <- mc.label.color[!is.na(mc.label.color)]
                }else{
                    mc.label <- unique(mc)
                    mc <- factor(mc, levels=mc.label)
                    mc.label.color <- rep(colorGroup[[ci]], 
                                          length(mc.label))[1:length(mc.label)]
                    levels(mc) <- mc.label.color
                    mc <- as.character(mc)
                }
                
                ci <- ci+1
            }else{
                mc.label <- unique(mcols[, i])
                if(is.numeric(mcols[, i])){
                    mc <- col2rgb(mc);
                    mc <- rgb(red=mc[1, ],
                              green=mc[2, ],
                              blue=mc[3, ], maxColorValue = 255)
                }
                mc.label.color <- unique(mc)
            }
            ## mc is color
            ## mc.label is legends
            ## plot legned
            ht.annoMcols.legend <- length(mc.label) * 0.03
            wd.annoMcols.legend <- margin[4]
            vp.annoMcols.legend <- 
                viewport(x=1-wd.annoMcols.legend+gap, 
                         y=ytop-ht.annoMcols.legend/2, 
                         width=wd.annoMcols.legend, 
                         height=ht.annoMcols.legend,
                         just=0,
                         name="vp.annoMcols.legend")
            annoMcols.legend <- legendGrob(labels=mc.label, 
                                           ncol=1,
                                           pch=15,
                                           gp=gpar(col=mc.label.color))
            allGrob <- gList(allGrob, 
                             gTree(children=gList(annoMcols.legend),
                                   vp=vp.annoMcols.legend,
                                   name=paste("gTree.annoMcols.legend",
                                              mc.name,
                                              sep=".")))
            ytop <- ytop-ht.annoMcols.legend-gap
            
            ## add annoMcols
            vp.annoMcols.sub <- viewport(x=width - .0075,
                                         y=.5, 
                                         width=.015,
                                         height=1,
                                         name=paste("vp.annoMcols",
                                                    mc.name,
                                                    sep="."))
            raster.annoMcols.sub <- 
                rasterGrob(mc,
                           width=1, height=1,
                           interpolate=FALSE,
                           name=paste("raster.annoMcols",
                                      mc.name,
                                      sep="."),
                           vp=vp.annoMcols.sub)
            xaxis.annoMcols.sub <- 
                xaxisGrob(at=.5,
                          label=mc.name,
                          gp=gp,
                          edits=gEdit("labels", rot=90),
                          name=paste("xaxis.annoMcols",
                                     mc.name,
                                     sep="."),
                          vp=vp.annoMcols.sub)
            allGrob <- gList(allGrob, 
                             gTree(children=gList(raster.annoMcols.sub,
                                                  xaxis.annoMcols.sub),
                                   vp=vp.annoMcols,
                                   name=paste("gTree.annoMcols",
                                              mc.name,
                                              sep=".")))
            width <- width - .015
        }
        width <- width - gap
    }
    
    vp.heatmap <- viewport(x=width/2+margin[2], y=height/2+margin[1], 
                           width=width, height=height,
                           name="vp.heatmap")
    l <- length(cov)
    wid <- 1/l
    x <- -wid/2
    y <- 1
    for(i in 1:l){
        x <- x+wid
        x.name <- names(cvglists)[i]
        vp.heatmap.sub <- viewport(x=x, width=wid-gap, height=y,
                                   name=paste("vp.heatmap",
                                              x.name,
                                              sep="."))
        raster.heatmap.sub <- rasterGrob(cov[[i]], 
                                         width=1, height=1, 
                                         interpolate=FALSE,
                                         name=paste("raster.heatmap",
                                                    x.name,
                                                    sep="."),
                                         vp=vp.heatmap.sub)
        
        grWidLab.this <- grWidLab
        if(i==1){
            if(i!=l){
                if(length(grWidAt)>1){
                    grWidLab.this[length(grWidLab)] <- " "
                }
            }
        }else{
            if(i==l){##i!=1
                if(length(grWidAt)>1){
                    grWidLab.this[1] <- " "
                }
            }else{## middle
                if(length(grWidAt)>2){
                    grWidLab.this[1] <- " "
                    grWidLab.this[length(grWidLab)] <- " "
                }
            }
        }
        xaxis.heatmap.sub <- xaxisGrob(at=grWidAt,
                                       label=grWidLab.this,
                                       gp=gp,
                                       edits=gEdit("labels", rot=90),
                                       name=paste("xaxis.heatmap",
                                                  x.name,
                                                  sep="."),
                                       vp=vp.heatmap.sub)
        allGrob <- gList(allGrob, 
                         gTree(children=gList(raster.heatmap.sub,
                                              xaxis.heatmap.sub),
                               vp=vp.heatmap,
                               name=paste("gTree.heatmap",
                                          x.name,
                                          sep=".")))
    }
    
    ## add heatmap legend
    if(legend==1){
        vp.legend <- viewport(x=1.01-margin[4]+gap, y=.875-margin[3], 
                              width=.02, height=.25,
                              name="vp.legend")
        raster.legend <- rasterGrob(matrix(rev(color), ncol=1), 
                                    width=1, height=1,
                                    name="raster.legend")
        .lim <- lim[[1]]
        label <- grid.pretty(.lim)
        ll <- length(label)
        if(ll>=2){
            if(ll%%2==0){
                label <- label[c(1, ll)]
            }else{
                label <- label[c(1, ceiling(ll/2), ll)]
            }
            at <- (label-min(.lim))/abs(diff(.lim))
            yaxis.legend <- yaxisGrob(at=at,
                                      label=label,
                                      main=FALSE,
                                      gp=gp,
                                      name="yaxis.legend")
        }
        allGrob <- gList(allGrob, 
                         gTree(children=gList(raster.legend,
                                              yaxis.legend),
                               vp=vp.legend,
                               name="gTree.legend"))
        
        ## draw x labels
        vp.xlabels <- viewport(x=width/2+margin[2], 
                               y=1-margin[3]/2+gap, 
                               width=width, height=margin[3]-gap,
                               name="vp.xlabels")
        x <- -wid/2
        h <- .5
        for(i in 1:l){
            x <- x+wid
            x.name <- names(cvglists)[i]
            text.xlabels.sub <- 
                textGrob(label = x.name,
                         gp=gp,
                         just=1, hjust=0,
                         vp=viewport(x=x, y=.5, width=wid, height=1, 
                                     name=paste("vp.xlabels", x.name, sep=".")),
                         name=paste("text.xlabels", x.name, sep="."))
            allGrob <- gList(allGrob, 
                             gTree(children=gList(text.xlabels.sub),
                                   vp=vp.xlabels,
                                   name=paste("gTree.xlabels",
                                              x.name,
                                              sep=".")))
        }
    }else{
        vp.legend <- viewport(x=width/2+margin[2], 
                              y=1-margin[3]/3+gap, 
                              width=width, height=margin[3]*2/3-gap,
                              name="vp.legend")
        
        vp.xlabels <- viewport(x=width/2+margin[2], 
                               y=1-margin[3]*5/6+gap, 
                               width=width, height=margin[3]/3-gap,
                               name="vp.xlabels")
        
        x <- -wid/2
        h <- .5
        for(i in 1:l){
            x <- x+wid
            x.name=names(cvglists)[i]
            vp.legend.sub <- 
                viewport(x=x, y=0.25, width=wid/2, height=0.2,
                         name=paste("vp.legend",
                                    x.name,
                                    sep="."))
            raster.legend.sub <- 
                rasterGrob(matrix(color, nrow=1), 
                           width=1, height=1,
                           name=paste("raster.legend", x.name, sep="."),
                           vp=vp.legend.sub)
            .lim <- lim[[i]]
            label <- grid.pretty(.lim)
            ll <- length(label)
            xaxis.legned.sub <- NULL
            if(ll>=2){
                if(ll%%2==0){
                    label <- label[c(1, ll)]
                }else{
                    label <- label[c(1, ceiling(ll/2), ll)]
                }
                at <- (label-min(.lim))/abs(diff(.lim))
                xaxis.legned.sub <- xaxisGrob(at=at,
                                              label=label,
                                              main=FALSE,
                                              gp=gp,
                                              name=paste("xaxis.legend",
                                                         x.name,
                                                         sep="."),
                                              vp=vp.legend.sub)
            }
            allGrob <- gList(allGrob, 
                             gTree(children=gList(raster.legend.sub,
                                                  xaxis.legned.sub),
                                   vp=vp.legend,
                                   name=paste("gTree.legend",
                                              x.name,
                                              sep=".")))
            
            ## draw x labels
            text.xlabels.sub <- 
                textGrob(label = x.name,
                         gp=gp,
                         vp=viewport(x=x, y=.5, width=wid, height=1, 
                                     name=paste("vp.xlabels", x.name, sep=".")),
                         name=paste("text.xlabels", x.name, sep="."))
            allGrob <- gList(allGrob, 
                             gTree(children=gList(text.xlabels.sub),
                                   vp=vp.xlabels,
                                   name=paste("gTree.xlabels",
                                              x.name,
                                              sep=".")))
            
        }
    }    
    
    ## consider how to return all and could be redraw by grid.draw.
    grid.draw(allGrob)
    return(invisible(allGrob))
}

#' Find occurence of input motifs in the promoter regions of the input gene
#' list
#' 
#' Find occurence of input motifs in the promoter regions of the input gene
#' list
#' 
#' This function outputs the motif occuring locations in the promoter regions
#' of input gene list and input motifs. It also can find paired motifs within
#' specificed gap threshold
#' 
#' @param patternFilePath1 File path containing a list of known motifs.
#' Required
#' @param patternFilePath2 File path containing a motif requried to be in the
#' flanking regions of the motif(s) in the first file, i.e, patternFilePath1.
#' Requried if findPairedMotif is set to TRUE
#' @param BSgenomeName A BSgenome object. For a list of existing Bsgenomes,
#' please refer use the function available.genomes in BSgenome package. For
#' example,BSgenome.Hsapiens.UCSC.hg38 is for hg38, BSgenome.Hsapiens.UCSC.hg19
#' is for hg19, BSgenome.Mmusculus.UCSC.mm10 is for mm10,
#' BSgenome.Celegans.UCSC.ce6 is for ce6 BSgenome.Rnorvegicus.UCSC.rn5 is for
#' rn5, BSgenome.Drerio.UCSC.danRer7 is for Zv9, and
#' BSgenome.Dmelanogaster.UCSC.dm3 is for dm3. Required
#' @param findPairedMotif Find motifs in paired configuration only or not.
#' Default FALSE
#' @param txdb A TxDb object. For creating and using TxDb object, please refer
#' to GenomicFeatures package. For a list of existing TxDb object, please
#' search for annotation package starting with Txdb at
#' http://www.bioconductor.org/packages/release/BiocViews.html#___AnnotationData,
#' such as TxDb.Rnorvegicus.UCSC.rn5.refGene for rat,
#' TxDb.Mmusculus.UCSC.mm10.knownGene for mouse,
#' TxDb.Hsapiens.UCSC.hg19.knownGene and TxDb.Hsapiens.UCSC.hg38.knownGene for
#' human, TxDb.Dmelanogaster.UCSC.dm3.ensGene for Drosophila and
#' TxDb.Celegans.UCSC.ce6.ensGene for C.elegans
#' @param geneIDs One or more gene entrez IDs. For example the entrez ID for
#' EWSIR is 2130 https://www.genecards.org/cgi-bin/carddisp.pl?gene=EWSR1 You
#' can use the addGeneIDs function in ChIPpeakAnno to convert other types of
#' Gene IDs to entrez ID
#' @param upstream Number of bases upstream of the TSS to search for the
#' motifs. Default 5000L
#' @param downstream Number of bases downstream of the TSS to search for the
#' motifs. Default 5000L
#' @param name.motif1 Name of the motif in inputfilePath2 for labeling the
#' output file column. Default motif1. used only when searching for motifs in
#' paired configuration
#' @param name.motif2 Name of the motif in inputfilePath2 for labeling the
#' output file column. Default motif2 used only when searching for motifs in
#' paired configuration
#' @param max.distance maximum required gap between a paired motifs to be
#' included in the output file. Default 100L
#' @param min.distance Minimum required gap between a paired motifs to be
#' included in the output file. Default 1L
#' @param motif.orientation Required relative oriention between paired motifs:
#' both means any orientation, motif1UpstreamOfMotif2 means motif1 needs to be
#' located on the upstream of motif2, and motif2UpstreamOfMoif1 means motif2
#' needs to be located on the upstream of motif1. Default both
#' @param ignore.strand Specify whether paired motifs should be located on the
#' same strand. Default FALSE
#' @param format The format of the files specified in inputFilePath1 and
#' inputFilePath2. Default fasta
#' @param skip Specify number of lines to skip at the beginning of the input
#' file. Default 0L
#' @param motif1LocForDistance Specify whether to use the start or end of the
#' motif1 location to calculate distance between paired motifs. Only applicable
#' when findPairedMotif is set to TRUE. Default end
#' @param motif2LocForDistance Specify whether to use the start or end of the
#' motif2 location to calculate distance between paired motifs. Only applicable
#' when findPairedMotif is set to TRUE. Default start
#' @param outfile File path to save the search results
#' @param append Specify whether to append the results to the specified output
#' file, i.e., outfile. Default FALSE
#' @return A vector of numeric. It is the background corrected log2-transformed
#' ratios, CPMRatios or OddRatios.
#' 
#' An object of GRanges with metadata "tx_start", "tx_end tx_strand", "tx_id",
#' "tx_name", "Gene ID", and motif specific information such as motif name,
#' motif found, motif strand etc.
#' @author Lihua Julie Zhu, Kai Hu
#' @export
#' @importFrom GenomicFeatures transcriptsBy 
#' @importFrom S4Vectors mcols
#' @importFrom utils write.table
#' @examples
#' 
#' 
#' library("BSgenome.Hsapiens.UCSC.hg38")
#' library("TxDb.Hsapiens.UCSC.hg38.knownGene")
#' 
#' patternFilePath1 =system.file("extdata", "motifIRF4.fa", package="ChIPpeakAnno")
#' patternFilePath2 =system.file("extdata", "motifAP1.fa", package="ChIPpeakAnno")
#' pairedMotifs <- findMotifsInPromoterSeqs(patternFilePath1 = patternFilePath1,
#'    patternFilePath2 = patternFilePath2,
#'    findPairedMotif = TRUE,
#'    name.motif1 = "IRF4", name.motif2 = "AP1",
#'    BSgenomeName = BSgenome.Hsapiens.UCSC.hg38,
#'    geneIDs = 7486, txdb = TxDb.Hsapiens.UCSC.hg38.knownGene,
#'    outfile = "testPaired.xls")
#' 
#' unPairedMotifs <- findMotifsInPromoterSeqs(patternFilePath1 = patternFilePath1,
#'     BSgenomeName = BSgenome.Hsapiens.UCSC.hg38,
#'    geneIDs = 7486, txdb = TxDb.Hsapiens.UCSC.hg38.knownGene,
#'    outfile = "testUnPaired.xls")
#' 
findMotifsInPromoterSeqs <-
  function(patternFilePath1,
           patternFilePath2,
           findPairedMotif = FALSE,
           BSgenomeName,
           txdb,
           geneIDs,
           upstream = 5000L,
           downstream = 5000L,
           name.motif1 = "motif1",
           name.motif2 = "motif2",
           max.distance = 100L, min.distance = 1L,
           motif.orientation = c("both", "motif1UpstreamOfMotif2", 
                                 "motif2UpstreamOfMoif1"),
           ignore.strand = FALSE,
           format = "fasta",
           skip = 0L,
           motif1LocForDistance = "end",
           motif2LocForDistance = "start",
           outfile, append = FALSE)
  {
    if (missing(patternFilePath1))
      stop("missing required parameter patternFilePath1!")
    if (missing(txdb) || !is(txdb, "TxDb"))
      stop("txdb is required as Txdb object!")
    if (missing(geneIDs))
      stop("geneIDs is required as Entrez IDs")
    motif.orientation <- match.arg(motif.orientation)
    tx <- transcriptsBy(txdb, by = "gene")
    tx <- tx[names(tx) %in% geneIDs]
    
    peaks <- promoters(tx, upstream = upstream, downstream = downstream)
    
    x1 <- do.call(rbind, 
                  lapply(seq_along(peaks),
                         function(i) {
                           thisPeak <- peaks[[i]]
                           mcols(thisPeak)$gene_id = names(peaks)[i]
                           x <- summarizePatternInPeaks(patternFilePath = patternFilePath1, 
                                                        format = format,
                                                        skip = skip, 
                                                        BSgenomeName = BSgenomeName, 
                                                        peaks = thisPeak,
                                                        expectFrequencyMethod = "Naive")
                           x$motif_occurrence
                           }
                         )
                  )
    
    # original colnames(x1):
      # 1: motifChr
      # 2: motifStartInChr
      # 3: motifEndInChr
      # 4: motifName
      # 5: motifPattern
      # 6: motifStartInPeak
      # 7: motifEndInPeak
      # 8: motifFound
      # 9: motifFoundStrand
      # 10: peakChr
      # 11: peakStart
      # 12: peakEnd
      # 13: peakWidth
      # 14: peakStrand
    colnames(x1)[1] <- "seqnames"
    colnames(x1)[2] <- "start"
    colnames(x1)[3] <- "end"
    colnames(x1)[9] <- "strand"
    colnames(x1)[11] <- "tx_start"
    colnames(x1)[12] <- "tx_end"
    colnames(x1)[14] <- "tx_strand"

    if (!findPairedMotif) {
      if (!missing(outfile))
        write.table(x1, file = outfile, sep ="\t", row.names = FALSE)
      toGRanges(x1)
    }
    else if(missing(patternFilePath2)) {
      stop("missing required parameter patternFilePath2!")
    }
    else {
      x2 <- do.call(rbind, 
                    lapply(seq_along(peaks), 
                           function(i) {
                             thisPeak <- peaks[[i]]
                             mcols(thisPeak)$gene_id = names(peaks)[i]
                             x <- summarizePatternInPeaks(patternFilePath = patternFilePath2,
                                                          format = format,
                                                          skip = skip, 
                                                          BSgenomeName = BSgenomeName, 
                                                          peaks = thisPeak,
                                                          expectFrequencyMethod = "Naive")
                             x <- x$motif_occurrence
                            }
                           )
                    )
  
      # original colnames(x2):
        # 1: motifChr
        # 2: motifStartInChr
        # 3: motifEndInChr
        # 4: motifName
        # 5: motifPattern
        # 6: motifStartInPeak
        # 7: motifEndInPeak
        # 8: motifFound
        # 9: motifFoundStrand
        # 10: peakChr
        # 11: peakStart
        # 12: peakEnd
        # 13: peakWidth
        # 14: peakStrand
      
      colnames(x2)[1] <- "seqnames"
      colnames(x2)[2] <- "start"
      colnames(x2)[3] <- "end"
      colnames(x2)[9] <- "strand"
      colnames(x2)[11] <- "tx_start"
      colnames(x2)[12] <- "tx_end"
      colnames(x2)[14] <- "tx_strand"

      x1.gr <- toGRanges(x1)
      x2.gr <- toGRanges(x2)
      
      res <- annotatePeakInBatch(x1.gr, AnnotationData=x2.gr,
                                 PeakLocForDistance = motif1LocForDistance,
                                 FeatureLocForDistance = motif2LocForDistance,
                                 ignore.strand = ignore.strand)
      
      temp <- res[res$shortestDistance <= max.distance & 
                    res$shortestDistance >= min.distance,]
      
      if (motif.orientation == "motif1UpstreamMotif2" )
        temp <- temp[temp$insideFeature == "upstream",]
      if (motif.orientation == "motif1UpstreamMotif2" )
        temp <- temp[temp$insideFeature == "downstream",]
      
      temp <- as.data.frame(temp)
      
      m2 <- cbind(names(x2.gr), as.data.frame(x2.gr))
      colnames(m2)[1] <- "feature"
      m2 <- m2[, c(1:2, 7:8, 11)]
      colnames(m2)[3:5] <- paste(name.motif2, colnames(m2)[3:5])
      
      #m2$seqnames <- paste("chr", m2$seqnames, sep = "" )
      
      res <- merge(m2, temp, by = c("feature", "seqnames"))
      colnames(res)[6:14] <- paste(name.motif1, colnames(res)[6:14])
      # colnames(res):
        # 1: feature                  
        # 2: seqnames                 
        # 3: motif2_motifName           
        # 4: motif2_motifPattern         
        # 5: motif2_motifFound           
        # 6: motif1_start                   
        # 7: motif1_end                      
        # 8: motif1_width                    
        # 9: motif1_strand                  
        # 10: motif1_motifName                
        # 11: motif1_motifPattern             
        # 12: motif1_motifStartInPeak        
        # 13: motif1_motifEndInPeak           
        # 14: motif1_motifFound               
        # 15: peakChr                 
        # 16: tx_start                 
        # 17: tx_end                   
        # 18: peakWidth               
        # 19: tx_strand                
        # 20: peak                     
        # 21: start_position          
        # 22: end_position             
        # 23: feature_strand           
        # 24: insideFeature           
        # 25: distancetoFeature        
        # 26: shortestDistance         
        # 27: fromOverlappingOrNearest
      res <- res[, -c(1, 20)]
      
      colnames(res)[grep("insideFeature", colnames(res))] <- 
        paste(name.motif1, name.motif2, sep  =   "relatviePositionTo")
      
      colnames(res)[19:20] <- paste(name.motif2, colnames(res)[19:20])
      colnames(res)[21] <- paste(name.motif2, "strand", sep ="_")
      
      
      tem <- cbind(as.numeric(res[,5]), as.numeric(res[,6]), 
                   as.numeric(res[,19]), as.numeric(res[,20]))
      res2 <- cbind(seqnames = res[,1], compositMotifStart= rowMins(tem),
                    compositMotifEnd = rowMaxs(tem), res[, -1])
      
      res2 <- res2[, -grep("InPeak", colnames(res2))]
      
      d.ind <- grep("distancetoFeature", colnames(res2))
      res2 <- cbind(res2[c(1:6, d.ind, 7:dim(res2)[2])])
      res2 <- res2[, -(d.ind +1)]
      colnames(res2)[grep("distancetoFeature", colnames(res2))] <- 
        paste(name.motif1, name.motif2, sep="distanceto")
      colnames(res2)[grep("feature_strand", colnames(res2))] <- 
        paste(name.motif2, "strand")
      
      strand.ind <- grep("strand", colnames(res2))[1:3]
      strand <- res2[, strand.ind[1]]
      strand2 <- res2[, strand.ind[3]]
      strand <- ifelse(strand == strand2, as.character(strand), "*")
      res2 <- cbind(res2[,1:3], strand = strand, res2[,4:dim(res2)[2]])
      if (!missing(outfile)) {
        write.table(res2, file = outfile, sep ="\t", row.names = FALSE)
      }
      colnames(res2)[2:3] <- c("start", "end")
      toGRanges(res2)
    }
  }

#' High Occupancy of Transcription Related Factors regions
#' 
#' High Occupancy of Transcription Related Factors regions of human (hg19)
#' 
#' How to generated the data:
#' 
#' temp <- tempfile()
#' 
#' url <- "http://metatracks.encodenets.gersteinlab.org"
#' 
#' download.file(file.path(url, "HOT_All_merged.tar.gz"), temp)
#' 
#' temp2 <- tempfile()
#' 
#' download.file(file.path(url, "HOT_intergenic_All_merged.tar.gz"), temp2)
#' 
#' untar(temp, exdir=dirname(temp))
#' 
#' untar(temp2, exdir=dirname(temp))
#' 
#' f <- dir(dirname(temp), "bed$")
#' 
#' HOT.spots <- sapply(file.path(dirname(temp), f), toGRanges, format="BED")
#' 
#' names(HOT.spots) <- gsub("_merged.bed", "", f)
#' 
#' HOT.spots <- sapply(HOT.spots, unname)
#' 
#' HOT.spots <- GRangesList(HOT.spots)
#' 
#' save(list="HOT.spots",
#' 
#' file="data/HOT.spots.rda",
#' 
#' compress="xz", compression_level=9)
#' 
#' @name HOT.spots
#' @docType data
#' @format An object of GRangesList
#' @references Yip KY, Cheng C, Bhardwaj N, Brown JB, Leng J, Kundaje A,
#' Rozowsky J, Birney E, Bickel P, Snyder M, Gerstein M. Classification of
#' human genomic regions based on experimentally determined binding sites of
#' more than 100 transcription-related factors. Genome Biol. 2012 Sep
#' 26;13(9):R48.  doi: 10.1186/gb-2012-13-9-r48. PubMed PMID: 22950945; PubMed
#' Central PMCID: PMC3491392.
#' @source http://metatracks.encodenets.gersteinlab.org/
#' @keywords datasets
#' @examples
#' 
#'  data(HOT.spots)
#'  elementNROWS(HOT.spots)
#' 
"HOT.spots"

require("ChIPpeakAnno") || stop("unable to load Package:ChIPpeakAnno")
require("BSgenome.Drerio.UCSC.danRer7") || stop("unable to load Package:BSgenome.Drerio.UCSC.danRer7")
require("BSgenome.Hsapiens.UCSC.hg19") || stop("unable to load Package:BSgenome.Hsapiens.UCSC.hg19")
require("org.Hs.eg.db") || stop("unable to load Package:org.Hs.eg.db")
require("org.Ce.eg.db") || stop("unable to load Package:org.Ce.eg.db")
require("BSgenome.Celegans.UCSC.ce10") || stop("unable to load Package:BSgenome.Celegans.UCSC.ce10")
require("EnsDb.Hsapiens.v79") || stop("unable to load Package:EnsDb.Hsapiens.v79")
require("TxDb.Hsapiens.UCSC.hg38.knownGene") || stop("unable to load TxDb.Hsapiens.UCSC.hg38.knownGene")
require("biomaRt") || stop("unable to load biomaRt")
require("reactome.db") || stop("unable to load reactome.db")
require("testthat") || stop("unable to load testthat")
test_check("ChIPpeakAnno")

#' An example GRanges object representing a ChIP-seq peak dataset
#' 
#' @name peaks2
#' @docType data
#' @format GRanges
#' @keywords datasets
#' @examples
#' 
#' data(peaks2)
#' head(peaks2, n = 2)
"peaks2"

countByOverlaps <- function(features, reads,  ignore.strand, inter.feature) {
    ## NOT work for parallel 
    countOverlaps(features, reads, ignore.strand=ignore.strand)
}



#' Perform overlap queries between reads and genomic features by bins
#' 
#' summarizeOverlapsByBins extends
#' \link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps} by
#' providing fixed window size and step to split each feature into bins and
#' then do queries. It will return counts by signalSummaryFUN, which applied to
#' bins in one feature, for each feature.
#' 
#' 
#' @param targetRegions A \link[GenomicRanges:GRanges-class]{GRanges} object of
#' genomic regions of interest.
#' @param reads A \link[GenomicRanges:GRanges-class]{GRanges},
#' \link[GenomicRanges:GRangesList-class]{GRangesList}
#' \link[GenomicAlignments:GAlignments-class]{GAlignments},
#' \link[GenomicAlignments:GAlignmentsList-class]{GAlignmentsList},
#' \link[GenomicAlignments:GAlignmentPairs-class]{GAlignmentPairs} or
#' \link[Rsamtools:BamFile-class]{BamFileList} object that represents the data
#' to be counted by
#' \code{\link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps}}.
#' @param windowSize Size of windows
#' @param step Step of windows
#' @param signalSummaryFUN function, which will be applied to the bins in each
#' feature.
#' @param mode mode can be one of the pre-defined count methods. see
#' \link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps}.
#' default is countByOverlaps, alia of countOverlaps(features, reads,
#' ignore.strand=ignore.strand)
#' @param ...  Additional arguments passed to
#' \code{\link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps}}.
#' @return A
#' \link[SummarizedExperiment:RangedSummarizedExperiment-class]{RangedSummarizedExperiment}
#' object. The assays slot holds the counts, rowRanges holds the annotation
#' from features.
#' @author Jianhong Ou
#' @keywords misc
#' @export
#' @importFrom GenomicAlignments summarizeOverlaps
#' @importFrom SummarizedExperiment colData SummarizedExperiment
#' @importFrom S4Vectors SimpleList aggregate
#' @examples
#' 
#'     fls <- list.files(system.file("extdata", package="GenomicAlignments"),
#'                   recursive=TRUE, pattern="*bam$", full=TRUE)
#'     names(fls) <- basename(fls)
#'     genes <- GRanges(
#'         seqnames = c(rep("chr2L", 4), rep("chr2R", 5), rep("chr3L", 2)),
#'         ranges = IRanges(c(1000, 3000, 4000, 7000, 2000, 3000, 3600, 
#'                            4000, 7500, 5000, 5400), 
#'                          width=c(rep(500, 3), 600, 900, 500, 300, 900, 
#'                                  300, 500, 500),
#'                          names=letters[1:11])) 
#'     se <- summarizeOverlapsByBins(genes, fls, windowSize=50, step=10)
#' 
summarizeOverlapsByBins <- function(targetRegions, reads, 
                                    windowSize=50, step=10, 
                                    signalSummaryFUN=max, 
                                    mode=countByOverlaps, ...){
    stopifnot(is(targetRegions, "GRanges"))
    stopifnot(is.function(signalSummaryFUN))
    stopifnot(length(reads)>1)
    if(length(names(targetRegions))==0 ||
       any(duplicated(names(targetRegions)))){
        stop("duplicated or null targetRegions names.")
    }
    checkFun <- signalSummaryFUN(1:10)
    if(length(checkFun)!=1){
        stop("the output of signalSummaryFUN must be a vector with length 1")
    }
    if(!inherits(checkFun, c("numeric", "integer"))){
        stop("the output of signalSummaryFUN must be a numeric.")
    }
    ## change the targetRegions by windowSize, step
#     if(any(width(targetRegions)<windowSize) | any(width(targetRegions)<step)){
#         warning("Some of targetRegions are smaller than windowSize or step.",
#                 "They will be removed.")
#     }
#     targetRegions <- targetRegions[width(targetRegions)>=windowSize]
#     targetRegions <- targetRegions[width(targetRegions)>=step]
#     tileTargetRanges <- tile(x=ranges(targetRegions), width=step)
#     nt <- elementNROWS(tileTargetRanges)
#     tileTargetRanges.end <- rep(end(targetRegions), nt)
#     tileTargetRanges <- unlist(tileTargetRanges)
#     width(tileTargetRanges) <- windowSize
#     tileTargetRegions <- GRanges(rep(seqnames(targetRegions), nt), 
#                                  tileTargetRanges,
#                                  rep(strand(targetRegions), nt),
#                                  oid=rep(1:length(targetRegions), nt))
#     tileTargetRegions <- tileTargetRegions[end(tileTargetRanges) <= 
#                                            tileTargetRanges.end]
    tileTargetRegions <- tileGRanges(targetRegions, windowSize, 
                                     step, keepPartialWindow=FALSE)
    se <- summarizeOverlaps(features=tileTargetRegions, reads=reads, 
                            mode=mode, ...)
    cnts <- aggregate(x=assay(se), 
                      by=list(oid_USED_BY_SE_OU=tileTargetRegions$oid), 
                      FUN=signalSummaryFUN, drop=FALSE)
    se.rowRanges <- targetRegions[cnts$oid_USED_BY_SE_OU]
    rownames(cnts) <- names(se.rowRanges)
    cnts$oid_USED_BY_SE_OU <- NULL
    cnts <- as.matrix(cnts)
    SummarizedExperiment(assays=SimpleList(counts=cnts), 
                         rowRanges=se.rowRanges,
                         colData=colData(se))
}

#' TSS annotation for human sapiens (GRCh37) obtained from biomaRt
#' 
#' TSS annotation for human sapiens (GRCh37) obtained from biomaRt
#' 
#' The dataset TSS.human.GRCh37 was obtained by:
#' 
#' mart = useMart(biomart = "ENSEMBL_MART_ENSEMBL", host="grch37.ensembl.org",
#' path="/biomart/martservice", dataset = "hsapiens_gene_ensembl")
#' 
#' getAnnotation(mart, featureType = "TSS")
#' 
#' @name TSS.human.GRCh37
#' @docType data
#' @format A GRanges object with slot start holding the start position of the
#' gene, slot end holding the end position of the gene, slot names holding
#' ensembl gene id, slot seqnames holding the chromosome location where the
#' gene is located and slot strand holding the strinad information. In
#' addition, the following variables are included.  \describe{
#' \item{list("description")}{description of the gene}}
#' @keywords datasets
#' @examples
#' 
#' data(TSS.human.GRCh37)
#' slotNames(TSS.human.GRCh37)
#' 
"TSS.human.GRCh37"

#' TSS annotation data for Rattus norvegicus (Rnor_5.0) obtained from biomaRt
#' 
#' TSS annotation data for Rattus norvegicus (Rnor_5.0) obtained from biomaRt
#' 
#' Annotation data obtained by:
#' 
#' mart = useMart(biomart = "ensembl", dataset = "rnorvegicus_gene_ensembl")
#' 
#' getAnnotation(mart, featureType = "TSS")
#' 
#' @name TSS.rat.Rnor_5.0
#' @docType data
#' @format GRanges with slot start holding the start position of the gene, slot
#' end holding the end position of the gene, slot names holding ensembl gene
#' id, slot seqnames holding the chromosome location where the gene is located
#' and slot strand holding the strinad information. In addition, the following
#' variables are included.  \describe{ \item{list("description")}{description
#' of the gene}}
#' @keywords datasets
#' @examples
#' 
#' data(TSS.rat.Rnor_5.0)
#' slotNames(TSS.rat.Rnor_5.0)
#' 
"TSS.rat.Rnor_5.0"

#' Aggregate peaks over bins from the TSS
#' 
#' Aggregate peaks over bins from the feature sites.
#' 
#' 
#' @param \dots Objects of GRanges to be analyzed
#' @param annotationData An object of
#' \link[GenomicRanges:GRanges-class]{GRanges} or \link{annoGR} for annotation
#' @param select Logical: annotate the peaks to all features or the nearest one
#' @param radius The radius of the longest distance to feature site
#' @param nbins The number of bins
#' @param minGeneLen The minimal gene length
#' @param aroundGene Logical: count peaks around features or a given site of
#' the features.  Default = FALSE
#' @param mbins if aroundGene set as TRUE, the number of bins intra-feature.
#' The value will be normalized by value * (radius/genelen) * (mbins/nbins)
#' @param featureSite which site of features should be used for distance
#' calculation
#' @param PeakLocForDistance which site of peaks should be used for distance
#' calculation
#' @param FUN the function to be used for score calculation
#' @param errFun the function to be used for errorbar calculation or values for
#' the errorbar.
#' @param xlab titles for each x axis
#' @param ylab titles for each y axis
#' @param main overall titles for each plot
#' @return A data.frame with bin values.
#' @author Jianhong Ou
#' @keywords misc
#' @export
#' @import GenomicRanges
#' @importFrom BiocGenerics strand start end width score
#' @importFrom graphics segments axis abline
#' @examples
#' 
#' bed <- system.file("extdata", "MACS_output.bed", package="ChIPpeakAnno")
#' gr1 <- toGRanges(bed, format="BED", header=FALSE)
#' data(TSS.human.GRCh37)
#' binOverFeature(gr1, annotationData=TSS.human.GRCh37,
#'                radius=5000, nbins=10, FUN=length, errFun=0)
#' 
binOverFeature <- function(..., annotationData=GRanges(),
                           select=c("all", "nearest"),
                           radius=5000L, nbins=50L,
                           minGeneLen=1L, aroundGene=FALSE, mbins=nbins, 
                           featureSite=c("FeatureStart", "FeatureEnd", 
                                         "bothEnd"),
                           PeakLocForDistance=c("all", "end", 
                                                "start", "middle"), 
                           FUN=sum, errFun=sd, xlab, ylab, main)
{
    ###check inputs
    PeaksList <- list(...)
    isGRangesList <- FALSE
    if(length(PeaksList)==1){
        if(is(PeaksList[[1]], "GRangesList")){
            PeaksList <- PeaksList[[1]]
            names <- names(PeaksList)
            isGRangesList <- TRUE
        }
    }
    ##save dots arguments names
    if(!isGRangesList){
        dots <- substitute(list(...))[-1]
        names <- unlist(sapply(dots, deparse))
    }
    
    n <- length(PeaksList)
    if(!n){
        stop("Missing required argument Peaks!")
    }else{
        nr <- ceiling(sqrt(n))
        nc <- ceiling(n/nr)
        op <- par(mfrow=c(nr, nc))
        on.exit(par(op))
    }
    if (missing(annotationData)) {
        stop("No AnnotationData as GRanges or annoGR is passed in.")
    }
    if(!inherits(annotationData, c("GRanges", "annoGR")) || 
           length(annotationData)<1){
        stop("No AnnotationData as GRanges or annoGR is passed in.")
    }
    if(is(annotationData, "annoGR"))
        annotationData <- as(annotationData, "GRanges")
    annotationData <- unique(annotationData)
    if (!all(as.character(strand(annotationData)) %in% c("+", "-", "*")))
        stop("strands of annotationData must be +, - or *")
    select <- match.arg(select)
    featureSite <- match.arg(featureSite)
    PeakLocForDistance <- match.arg(PeakLocForDistance)
    if(!is.list(FUN)) FUN <- list(FUN)
    if(!is.list(errFun)) errFun <- list(errFun)
    lapply(FUN, function(fun){
        if(mode(fun)!="function")
            stop("The mode of FUN must be function. 
                 The FUN could be any function such as 
                 median, mean, sum, length, ...")
    })
    lapply(errFun, function(fun){
        if(mode(fun)!="function" & !is.numeric(fun))
            stop("The mode of errFun must be function. 
                 The errFun could be any function such as sd")
    })
    
    annotatedPeaksList<-lapply(PeaksList, function(Peaks){
        if (!inherits(Peaks, "GRanges")) {
            stop("No valid Peaks passed in. It needs to be GRanges object")
        }
        if(is.null(score(Peaks))){
            message("score of GRanges object is required for calculation. 
                    It will be the input of FUN. Setting score as 1.")
            Peaks$score <- 1
        }
        ## annotate the peaks
        if(select=="all"){
            annotatedPeaks <- 
                annotatePeakInBatch(Peaks, AnnotationData=annotationData,
                                    output="overlapping", maxgap = radius, 
                                    select="all") 
        }else{
            annotatedPeaks <- 
                annotatePeakInBatch(Peaks, AnnotationData=annotationData,
                                    output="nearestLocation", select="all")
        }
        ## filter the annotation
        annotatedPeaks <- annotatedPeaks[!is.na(annotatedPeaks$feature_strand)]
        annotatedPeaks <- 
            annotatedPeaks[
                as.numeric(as.character(annotatedPeaks$end_position))-
                    as.numeric(as.character(annotatedPeaks$start_position))+1>=
                    minGeneLen]
        
        ###if insideFeature==inside or includeFeature, 
        ###featureSite=="bothEnd.intergenic", the annotation should be removed
        #    if(featureSite=="bothEnd.intergenic") 
        #      annotatedPeaks <- 
        #        annotatedPeaks[!annotatedPeaks$insideFeature %in% 
        #                c("inside", "includeFeature"),]
        annotatedPeaks
    })
    
    plotErrBar <- function(x, y, err){
        yplus <- y+err
        yminus <- y-err
        segments(x, yminus, x, yplus)
        xcoord <- par()$usr[1:2]
        smidge <- 0.015*(xcoord[2]-xcoord[1])/2
        segments(x-smidge, yminus, x+smidge, yminus)
        segments(x-smidge, yplus, x+smidge, yplus)
    }
    
    if(missing(xlab)) {
        xlab <- if(aroundGene){
            paste("Bins from", featureSite)
        }else{
            paste("distance from", featureSite)
        }
    }
    if(missing(ylab)) ylab <- "Score" 
    if(missing(main)) main <- paste(names, "binding over", featureSite)
    
    binValue <- mapply(function(annotatedPeaks, fun, errfun,
                                xlab.ele, ylab.ele, main.ele){
        ##genelength
        genelen <- 
            annotatedPeaks$end_position - annotatedPeaks$start_position + 1
        ## change the function if it is length
        if(identical(fun, length)){
            fun <- sum
            annotatedPeaks$score <- 1
        }
        ###step 1 calculate the distance,
        strand <- annotatedPeaks$feature_strand=="-"
        if(PeakLocForDistance=="all"){
            ##dist, the start distance to feature loc, dist2, 
            ##the end distance to feature loc
            PeakLoc.start <- start(annotatedPeaks)
            PeakLoc.end <- end(annotatedPeaks)
            if(featureSite=="bothEnd"){
                ##bothEnd, TODO
                stop("Sorry, can not handle the combination of 
                     PeakLocForDistance=='all' AND featureSite=='bothEnd'")
            }else{
                FeatureLoc<-
                    switch(featureSite,
                           FeatureStart=ifelse(strand, 
                                               annotatedPeaks$end_position, 
                                               annotatedPeaks$start_position),
                           FeatureEnd=ifelse(strand, 
                                             annotatedPeaks$start_position, 
                                             annotatedPeaks$end_position),
                           0)
                dist1 <- ifelse(strand, 
                                FeatureLoc-PeakLoc.end, 
                                PeakLoc.start-FeatureLoc)
                dist2 <- ifelse(strand, 
                                FeatureLoc-PeakLoc.start, 
                                PeakLoc.end-FeatureLoc)
                score <- score(annotatedPeaks)
                weight <- (radius * mbins)/(genelen * nbins)
                if(aroundGene){
                    if(featureSite=="FeatureStart"){
                        ibin1 <- 
                            ifelse(dist1<0, 
                                   nbins+floor(dist1*nbins/radius),
                                   ifelse(dist1<genelen, 
                                          nbins+floor(dist1*mbins/genelen), 
                                          nbins+mbins+
                                              floor((dist1-genelen)*
                                                        nbins/radius)))
                        ibin2 <- 
                            ifelse(dist2<0, 
                                   nbins+floor(dist2*nbins/radius),
                                   ifelse(dist2<genelen, 
                                          nbins+floor(dist2*mbins/genelen), 
                                          nbins+mbins+
                                              floor((dist2-genelen)*
                                                        nbins/radius)))
                        b <- c(-1*c(nbins:1),0:(mbins+nbins-1))
                        distance2 <- -1*radius
                        distance1 <- genelen+radius
                    }else{##featureSite=="FeatureEnd"
                        ibin1 <- 
                            ifelse(dist1>=0, 
                                   nbins+mbins+floor(dist1*nbins/radius),
                                   ifelse(dist1>-1*genelen, 
                                          nbins+mbins+
                                              floor(dist1*mbins/genelen), 
                                          nbins+
                                              floor((dist1+genelen)*
                                                        nbins/radius)))
                        ibin2 <- 
                            ifelse(dist2>=0, 
                                   nbins+mbins+floor(dist2*nbins/radius),
                                   ifelse(dist2>-1*genelen, 
                                          nbins+mbins+
                                              floor(dist2*mbins/genelen), 
                                          nbins+
                                              floor((dist2+genelen)*
                                                        nbins/radius)))
                        b <- c(-1*c((mbins+nbins):1), 0:(nbins-1))
                        distance2 <- -1*(radius+genelen)
                        distance1 <- radius
                    }
                    numbins <- 2*nbins + mbins
                    b.type <- c(rep(FALSE, nbins), 
                                rep(TRUE, mbins), 
                                rep(FALSE, nbins))
                }else{
                    ibin1 <- round(nbins+floor(dist1*nbins/radius))
                    ibin2 <- round(nbins+floor(dist2*nbins/radius))
                    b <- c(-1*c(nbins:1), 0:(nbins-1))
                    numbins <- 2*nbins
                    distance2 <- -1*radius
                    distance1 <- radius
                    genelen <- 0
                    minGeneLen <- -1
                    b.type <- rep(FALSE, 2*nbins)
                }
                ids <- dist2>=distance2 & 
                    dist1<distance1 & 
                    genelen > minGeneLen
                score <- score[ids]
                weight <- weight[ids]
                ibin1 <- ibin1[ids]
                ibin2 <- ibin2[ids]
                ibin1[ibin1<0] <- 0
                ibin2[ibin2>numbins] <- numbins
                gps <- lapply(0:(numbins-1), function(.id){
                    ##split the scores
                    .idx <- ibin1<=.id & ibin2>=.id
                    if(b.type[.id+1]){
                        score[.idx] * weight[.idx]
                    }else{
                        score[.idx]
                    }
                })
                names(gps) <- formatC(1:numbins, 
                                      width=nchar(numbins), 
                                      flag="0")
            }
        }else{##PeakLocForDistance %in% start, middle, end
            PeakLoc <- 
                switch(PeakLocForDistance,
                       middle=round(rowMeans(cbind(start(annotatedPeaks), 
                                                   end(annotatedPeaks)))),
                       start=start(annotatedPeaks),
                       end=end(annotatedPeaks),
                       0)
            if(featureSite=="bothEnd"){##only consider outside of bothEnd
                FeatureStart=ifelse(strand, 
                                    annotatedPeaks$end_position, 
                                    annotatedPeaks$start_position)
                FeatureEnd=ifelse(strand, 
                                  annotatedPeaks$start_position, 
                                  annotatedPeaks$end_position)
                dist1 <- ifelse(strand, 
                                FeatureStart-PeakLoc, 
                                PeakLoc-FeatureStart) ##frome feature start
                dist2 <- ifelse(strand, 
                                FeatureEnd-PeakLoc, 
                                PeakLoc-FeatureEnd) ##from feature end
                score <- score(annotatedPeaks)
                if(aroundGene){
                    stop("Sorry, can not handle the combination of 
                         aroundGene==TRUE AND featureSite=='bothEnd'")
                }else{
                    ibin1 <- round(nbins+floor(dist1*nbins/radius))
                    ibin2 <- round(nbins+floor(dist2*nbins/radius))
                    score1 <- score[ibin1<nbins & ibin1>=0]
                    ibin1 <- ibin1[ibin1<nbins & ibin1>=0]
                    score2 <- score[ibin2>=nbins & ibin2<2*nbins]
                    ibin2 <- ibin2[ibin2>=nbins & ibin2<2*nbins]
                    numbins <- 2*nbins
                    b <- c(-1*c(nbins:1), 0:(nbins-1))
                    b.type <- rep(FALSE, length(b))
                    ##insert the empty bins
                    ibin1 <- formatC(ibin1, width=nchar(numbins), flag="0")
                    ibin2 <- formatC(ibin2, width=nchar(numbins), flag="0")
                    gps1 <- split(score1, ibin1)
                    gps2 <- split(score2, ibin2)
                    gps1 <- gps1[formatC(0:numbins, 
                                         width=nchar(numbins), 
                                         flag="0")]
                    gps2 <- gps2[formatC(0:numbins, 
                                         width=nchar(numbins), 
                                         flag="0")]
                    names(gps1) <- formatC(0:numbins, 
                                           width=nchar(numbins), 
                                           flag="0")
                    names(gps2) <- formatC(0:numbins, 
                                           width=nchar(numbins), 
                                           flag="0")
                    gps <- c(gps1[1:nbins], gps2[(nbins+1):(2*nbins)])
                }
            }else{##featureSite %in% FeatureStart, FeatureEnd
                FeatureLoc <-
                    switch(featureSite,
                           FeatureStart=ifelse(strand, 
                                               annotatedPeaks$end_position, 
                                               annotatedPeaks$start_position),
                           FeatureEnd=ifelse(strand, 
                                             annotatedPeaks$start_position, 
                                             annotatedPeaks$end_position),
                           0)
                dist1 <- ifelse(strand, 
                                FeatureLoc - PeakLoc, 
                                PeakLoc - FeatureLoc)
                weight <- (radius * mbins)/(genelen * nbins)
                if(aroundGene){
                    if(featureSite=="FeatureStart"){
                        ibin1 <- 
                            ifelse(dist1<0, 
                                   nbins+floor(dist1*nbins/radius),
                                   ifelse(dist1<genelen, 
                                          nbins+floor(dist1*mbins/genelen), 
                                          nbins+mbins+
                                              floor((dist1-genelen)*
                                                        nbins/radius)))
                        b <- c(-1*c(nbins:1),0:(mbins+nbins-1))
                        distance1 <- radius+genelen
                        distance2 <- -1*radius
                    }else{##featureSite=="FeatureEnd"
                        ibin1 <- 
                            ifelse(dist1>=0, 
                                   nbins+mbins+floor(dist1*nbins/radius),
                                   ifelse(dist1>-1*genelen, 
                                          nbins+mbins+
                                              floor(dist1*mbins/genelen), 
                                          nbins+
                                              floor((dist1+genelen)*
                                                        nbins/radius)))
                        b <- c(-1*c((mbins+nbins):1), 0:(nbins-1))
                        distance1 <- radius
                        distance2 <- -1*(radius+genelen)
                    }
                    numbins <- 2*nbins + mbins
                    b.type <- c(rep(FALSE, nbins), 
                                rep(TRUE, mbins), 
                                rep(FALSE, nbins))
                }else{
                    ibin1 <- round(nbins+floor(dist1*nbins/radius))
                    numbins <- 2*nbins
                    b <- c(-1*c(nbins:1), 0:(nbins-1))
                    genelen <- 0
                    minGeneLen <- -1
                    distance1 <- radius
                    distance2 <- -1*radius
                    b.type <- rep(FALSE, 2 * nbins)
                }
                ids <- dist1>=distance2 & 
                    dist1<distance1 & 
                    genelen > minGeneLen
                score <- score(annotatedPeaks)[ids]
                weight <- weight[ids]
                ibin1 <- ibin1[ids]
                ibin1[ibin1<0] <- 0
                ibin1[ibin1>numbins] <- numbins
                score[b.type[ibin1+1]] <- 
                    score[b.type[ibin1+1]] * weight[b.type[ibin1+1]]
                ibin1 <- formatC(ibin1, 
                                 width=nchar(numbins), 
                                 flag="0")
                gps <- split(score, ibin1)
                gps <- gps[formatC(0:numbins, 
                                   width=nchar(numbins),
                                   flag="0")]
                names(gps) <- formatC(0:numbins, 
                                      width=nchar(numbins), 
                                      flag="0")
                ##insert the empty bins
                gps <- gps[1:numbins]
            }
        }
        gps <- lapply(gps, function(.ele){
            if(is.null(.ele[1])){
                    0
                }else{
                    .ele
                }
            })
        value <- unlist(lapply(gps, fun))
        std <- if(mode(errfun)=="function") unlist(lapply(gps, errfun)) else 
            rep(errfun, length(gps))
        std[is.na(std)] <- 0
        ##plot the figure
        ylim.min <- min(value[!is.na(value)] - std[!is.na(value)])
        ylim.max <- max(value[!is.na(value)] + std[!is.na(value)])
        ylim.dis <- (ylim.max - ylim.min)/20
        blabel <- if(aroundGene){
            c(seq.int(-radius, -radius/nbins, length.out=nbins)+radius/nbins/2,
              1:mbins,
              seq.int(0, radius-radius/nbins, length.out=nbins)+radius/nbins/2)
        }else{
            seq.int(-radius, radius-radius/nbins, length.out=2*nbins) +
                radius/nbins/2
        }
        if(aroundGene){
            plot(b, value, 
                 ylim=c(ylim.min-ylim.dis, ylim.max+ylim.dis),
                 xlab=xlab.ele, 
                 ylab=ylab.ele, 
                 main=main.ele,
                 xaxt="n")
            b.type.at <- b[which(b.type)]
            b.type.at <- 
                b.type.at[c(1, length(b.type.at))] + c(-.5, .5)
            abline(v=b.type.at, lty=2)
            b.at <- c(b[1]-.5, b[nbins]+.5, b[nbins+mbins]+.5, b[length(b)]+.5)
            b.label <- c(-1 * radius, "Feature Start", "Feature End", radius)
            axis(1, at=b.at, labels=b.label)
            if(!all(std==0)) plotErrBar(b, value, std)
        }else{
            plot(blabel, value, 
                 ylim=c(ylim.min-ylim.dis, ylim.max+ylim.dis),
                 xlab=xlab.ele, 
                 ylab=ylab.ele, 
                 main=main.ele)
            if(!all(std==0)) plotErrBar(blabel, value, std)
        }
        
        names(value) <- blabel
        value
    }, annotatedPeaksList, FUN, errFun, xlab, ylab, main)
    
    colnames(binValue) <- names
    ###output statistics
    return(invisible(binValue))
}

test_that("binOverFeature works not correct", {
    ##algorithm
    annotationData <- GRanges("X", IRanges(50, 50, name="X"), 
                              strand="+")
    peaks <- GRanges("X", IRanges(1:100, width=1), strand="+", 
                     score=rep(1, 100))
    bin <- binOverFeature(peaks, annotationData=annotationData, 
                          radius=50L, nbins=50L, minGeneLen=1L)
    expect_true(bin[1,1]==0)
    expect_equal(sum(bin[,1]), 99)
    
    peaks <- GRanges("X", IRanges(1:100, width=2), strand="+", 
                     score=rep(1, 100))
    bin <- binOverFeature(peaks, annotationData=annotationData, 
                          radius=50L, nbins=50L, minGeneLen=1L)
    expect_true(bin[1,1]==0)
    expect_true(bin[2,1]==1)
    expect_equal(sum(bin[,1]), 197)
    
    peaks <- GRanges("X", IRanges(1:50, 99:50), strand="+", score=rep(1, 50))
    bin <- binOverFeature(peaks, annotationData=annotationData, 
                          radius=50L, nbins=50L, minGeneLen=1L)
    expect_equal(sum(bin[,1]), sum(1:49)+sum(1:50))
    
    ## by simulation data
    annoGR <- annoGR(EnsDb.Hsapiens.v79)
    peaks <- as(annoGR, "GRanges")
    st <- as.character(strand(peaks))=="+"
    start(peaks)[st] <- start(peaks)[st]-100
    end(peaks)[st] <- start(peaks)[st]
    end(peaks)[!st] <- end(peaks)[!st]+100
    start(peaks)[!st] <- end(peaks)[!st]
    peaks$score <- 1
    bin <- binOverFeature(peaks, annotationData=annoGR, 
                          radius=500L, nbins=50L, minGeneLen=1L)
    expect_true(rownames(bin)[which(bin[,1]==max(bin[,1]))]=="-95")
})

#' Obtain enriched gene ontology (GO) terms that near the peaks
#' 
#' Obtain enriched gene ontology (GO) terms based on the features near the
#' enriched peaks using GO.db package and GO gene mapping package such as
#' org.Hs.db.eg to obtain the GO annotation and using hypergeometric test
#' (phyper) and multtest package for adjusting p-values
#' 
#' 
#' @param annotatedPeak A GRanges object or a vector of feature IDs
#' @param orgAnn Organism annotation package such as org.Hs.eg.db for human and
#' org.Mm.eg.db for mouse, org.Dm.eg.db for fly, org.Rn.eg.db for rat,
#' org.Sc.eg.db for yeast and org.Dr.eg.db for zebrafish
#' @param feature_id_type The feature type in annotatedPeak such as
#' ensembl_gene_id, refseq_id, gene_symbol or entrez_id
#' @param maxP The maximum p-value to be considered to be significant
#' @param minGOterm The minimum count in a genome for a GO term to be included
#' @param multiAdjMethod The multiple testing procedures, for details, see
#' mt.rawp2adjp in multtest package
#' @param condense Condense the results or not.
#' @param removeAncestorByPval Remove ancestor by p-value. P-value is
#' calculated by fisher exact test. If gene number in all of the children is
#' significant greater than it in parent term, the parent term will be removed
#' from the list.
#' @param keepByLevel If the shortest path from the go term to 'all' is greater
#' than the given level, the term will be removed.
#' @param subGroupComparison A logical vector to split the peaks into two 
#' groups. The enrichment analysis will compare the over-present GO terms
#' in TRUE group and FALSE group separately. The analysis will split into 
#' two steps: 1. enrichment analysis for TRUE group by hypergeometric
#' test; 2. enrichment analysis for TRUE over FALSE group
#' by Fisher's Exact test for the enriched GO terms.
#' To keep the output same format, if you want to compare FALSE vs TRUE,
#' please repeat the analysis by inverting the parameter.
#' Default is NULL.
#' @return A list with 3 elements \item{list("bp")}{ enriched biological
#' process with the following 9 variables
#' 
#' go.id:GO biological process id
#' 
#' go.term:GO biological process term
#' 
#' go.Definition:GO biological process description
#' 
#' Ontology: Ontology branch, i.e. BP for biological process
#' 
#' count.InDataset: count of this GO term in this dataset
#' 
#' count.InGenome: count of this GO term in the genome
#' 
#' pvalue: pvalue from the hypergeometric test
#' 
#' totaltermInDataset: count of all GO terms in this dataset
#' 
#' totaltermInGenome: count of all GO terms in the genome
#' 
#' } \item{list("mf")}{enriched molecular function with the following 9
#' variables
#' 
#' go.id:GO molecular function id
#' 
#' go.term:GO molecular function term
#' 
#' go.Definition:GO molecular function description
#' 
#' Ontology: Ontology branch, i.e. MF for molecular function
#' 
#' count.InDataset: count of this GO term in this dataset
#' 
#' count.InGenome: count of this GO term in the genome
#' 
#' pvalue: pvalue from the hypergeometric test
#' 
#' totaltermInDataset: count of all GO terms in this dataset
#' 
#' totaltermInGenome: count of all GO terms in the genome
#' 
#' } \item{list("cc")}{enriched cellular component the following 9 variables
#' 
#' go.id:GO cellular component id
#' 
#' go.term:GO cellular component term
#' 
#' go.Definition:GO cellular component description
#' 
#' Ontology: Ontology type, i.e. CC for cellular component
#' 
#' count.InDataset: count of this GO term in this dataset
#' 
#' count.InGenome: count of this GO term in the genome
#' 
#' pvalue: pvalue from the hypergeometric test
#' 
#' totaltermInDataset: count of all GO terms in this dataset
#' 
#' totaltermInGenome: count of all GO terms in the genome
#' 
#' }
#' @author Lihua Julie Zhu. Jianhong Ou for subGroupComparison
#' @seealso phyper, hyperGtest
#' @references Johnson, N. L., Kotz, S., and Kemp, A. W. (1992) Univariate
#' Discrete Distributions, Second Edition. New York: Wiley
#' @keywords misc
#' @export
#' @importFrom AnnotationDbi mappedkeys
#' @importFrom multtest mt.rawp2adjp
#' @importFrom AnnotationDbi Definition Ontology Term
#' @importFrom stats phyper fisher.test
#' @examples
#' 
#'   data(enrichedGO)
#'   enrichedGO$mf[1:10,]
#'   enrichedGO$bp[1:10,]
#'   enrichedGO$cc
#'   if (interactive()) {
#'      data(annotatedPeak)
#'      library(org.Hs.eg.db)
#'      library(GO.db)
#'      enriched.GO = getEnrichedGO(annotatedPeak[1:6,], 
#'                                  orgAnn="org.Hs.eg.db", 
#'                                  maxP=0.01,
#'                                  minGOterm=10,
#'                                  multiAdjMethod= NULL)
#'      dim(enriched.GO$mf)
#'      colnames(enriched.GO$mf)
#'      dim(enriched.GO$bp)
#'      enriched.GO$cc
#' }
#' 
getEnrichedGO <- function(annotatedPeak, orgAnn, 
                          feature_id_type="ensembl_gene_id", 
                          maxP=0.01,
                          minGOterm=10, multiAdjMethod=NULL,
                          condense=FALSE,
                          removeAncestorByPval=NULL,
                          keepByLevel=NULL,
                          subGroupComparison=NULL){
  if(is(annotatedPeak, "GRangesList")){
    if(length(subGroupComparison)){
      stop("subGroupComparison parameter is not supported for list of peaks.")
    }
    args <- as.list(match.call())
    res <- lapply(annotatedPeak, function(.ele){
      args$annotatedPeak <- .ele
      do.call(getEnrichedGO, args = args)
    })
  }
  stopifnot("The 'GO.db' package is required"=
              requireNamespace("GO.db", quietly = TRUE)) 
    if (missing(annotatedPeak))
    {
        stop("Missing required argument annotatedPeak!")    
    }
    if(length(multiAdjMethod)>0){
        multiAdjMethod <- match.arg(multiAdjMethod, 
                                    c("Bonferroni", "Holm", "Hochberg", 
                                      "SidakSS", "SidakSD", "BH", "BY",
                                      "ABH","TSBH"))
    }
    if (missing(orgAnn))
    {
        message("No valid organism specific GO gene mapping package 
                as argument orgAnn is passed in!")
        stop("Please refer 
             http://www.bioconductor.org/packages/release/data/annotation/ 
             for available org.xx.eg.db packages")
    }
    GOgenome = sub(".db","",orgAnn)
    if (nchar(GOgenome) <1)
    {
        message("No valid organism specific GO gene mapping package as 
                parameter orgAnn is passed in!")
        stop("Please refer 
             http://www.bioconductor.org/packages/release/data/annotation/ 
             for available org.xx.eg.db packages")
    }
    groupFALSE <- NULL
    feature_ids_FALSE <- NULL
    entrezIDs_FALSE <- NULL
    if(length(subGroupComparison)){
      if(length(subGroupComparison)!=length(annotatedPeak)){
        stop("Length of subGroupComparison should keep same as ",
             "length of annotatedPeak or check your input annotatedPeak type.")
      }
      stopifnot(is(subGroupComparison, "logical"))
      groupFALSE <- annotatedPeak[!subGroupComparison]
      annotatedPeak <- annotatedPeak[subGroupComparison]
    }
    if (inherits(annotatedPeak, what=c("GRanges")))
    {
        feature_ids = unique(as.character(annotatedPeak$feature))
        if(length(groupFALSE)){
          feature_ids_FALSE = unique(as.character(groupFALSE$feature))
        }
    }else if(is.character(annotatedPeak))
    {
        feature_ids = unique(annotatedPeak)
        if(length(groupFALSE)){
          feature_ids_FALSE = unique(groupFALSE)
        }
    }else{
        stop("annotatedPeak needs to be GRanges type with feature 
             variable holding the feature id or a character vector 
             holding the IDs of the features used to annotate the peaks!")
    }
    if (feature_id_type == "entrez_id"){
        entrezIDs <- feature_ids
        if(length(groupFALSE)){
          entrezIDs_FALSE <- feature_ids_FALSE
        }
    }else{
        cov2EntrezID <- function(IDs, orgAnn, ID_type="ensembl_gene_id"){
            GOgenome = sub(".db","",orgAnn)
            orgAnn <- switch(ID_type,
                             ensembl_gene_id="ENSEMBL2EG",
                             gene_symbol="SYMBOL2EG",
                             refseq_id="REFSEQ2EG",
                             "BAD_NAME")
            if(orgAnn=="BAD_NAME")
                stop("Currently only the following type of IDs are supported:
                     ensembl_gene_id, refseq_id and gene_symbol!")
            orgAnn <- get(paste(GOgenome, orgAnn, sep=""))
            if(!is(orgAnn, "AnnDbBimap")){
                stop("orgAnn is not a valid annotation dataset! 
                     For example, orgs.Hs.eg.db package for human and 
                     the org.Mm.eg.db package for mouse.")
            }
            IDs <- unique(IDs[!is.na(IDs)])
            ids <- mget(IDs, orgAnn, ifnotfound=NA)
            ids <- lapply(ids, `[`, 1)
            ids <- unlist(ids)
            ids <- unique(ids[!is.na(ids)])
            ids
        }
        entrezIDs <- cov2EntrezID(feature_ids, orgAnn, feature_id_type)
        if(length(groupFALSE)){
          entrezIDs_FALSE <- cov2EntrezID(feature_ids_FALSE,
                                          orgAnn, feature_id_type)
        }
    }
    if(length(entrezIDs)<2){
        stop("The number of gene is less than 2. 
             Please double check your feature_id_type.")
    }
    goAnn <- get(paste(GOgenome,"GO", sep=""))
    mapped_genes <- mappedkeys(goAnn)
    totalN.genes=length(unique(mapped_genes))
    thisN.genes = length(unique(entrezIDs))
    #xx <- as.list(goAnn[mapped_genes])
    
    xx <- mget(mapped_genes, goAnn, ifnotfound=NA)
    all.GO <- cbind(matrix(unlist(unlist(xx)),ncol=3,byrow=TRUE),
                    rep(names(xx), elementNROWS(xx)))
    all.GO <- unique(all.GO)## incalse the database is not unique
    this.GO <- all.GO[all.GO[, 4] %in% entrezIDs, , drop=FALSE]
    FALSE.GO <- all.GO[all.GO[, 4] %in% entrezIDs_FALSE, , drop=FALSE]
    
    addAnc <- function(go.ids,
                       onto=c("bp", "cc", "mf")){
        ##replace the function addAncestors
        GOIDs <- unique(as.character(go.ids[, 1]))
        empty <- matrix(nrow=0, ncol=2)
        colnames(empty) <- c("go.id", "EntrezID")
        if(length(GOIDs)<1){
            return(empty)
        }
        onto <- match.arg(onto)
        Ancestors <- switch(onto, 
                            bp=mget(GOIDs, GO.db::GOBPANCESTOR, ifnotfound = NA),
                            cc=mget(GOIDs, GO.db::GOCCANCESTOR, ifnotfound = NA),
                            mf=mget(GOIDs, GO.db::GOMFANCESTOR, ifnotfound = NA))
        Ancestors <- unique(unlist(Ancestors))
        Ancestors <- Ancestors[Ancestors!="all" & !is.na(Ancestors)]
        if(length(Ancestors)>0){
            children <- go.ids[,c(1, 4), drop=FALSE]
            children <- unique(children)
            children.s <- split(children[, 2], children[, 1])
            Ancestors <- switch(onto,
                               bp=mget(Ancestors, 
                                       GO.db::GOBPOFFSPRING, 
                                       ifnotfound = NA),
                               cc=mget(Ancestors, 
                                       GO.db::GOCCOFFSPRING, 
                                       ifnotfound = NA),
                               mf=mget(Ancestors, 
                                       GO.db::GOMFOFFSPRING, 
                                       ifnotfound = NA))
            Ancestors <- cbind(Ancestor=rep(names(Ancestors),
                                           elementNROWS(Ancestors)),
                              child=unlist(Ancestors))
            Ancestors <- 
                Ancestors[Ancestors[, "child"] %in% names(children.s), 
                          , drop=FALSE]
            temp <- cbind(Ancestor=children[, 1], child=children[, 1])
            Ancestors <- rbind(Ancestors, temp)
            Ancestors <- unique(Ancestors)
            Ancestors.ezid <- children.s[Ancestors[, "child"]]
            temp <- cbind(rep(Ancestors[, "Ancestor"], 
                                    elementNROWS(Ancestors.ezid)),
                          unlist(Ancestors.ezid))
            temp <- unique(temp) #time....
            if (length(temp) <3){
                re <- unique(children)
            }else{
                re <- temp[!is.na(temp[,1]) & temp[,1] != "",]
            }
        }else{
            re <- unique(cbind(as.character(go.ids[,1]), go.ids[,4]))
        }
        colnames(re) <- c("go.id", "EntrezID")
        re
    }
    
    bp.go.this.withEntrez = addAnc(this.GO[this.GO[,3]=="BP",],"bp")
    cc.go.this.withEntrez = addAnc(this.GO[this.GO[,3]=="CC",], "cc")
    mf.go.this.withEntrez = addAnc(this.GO[this.GO[,3]=="MF",],"mf")
    
    bp.go.all.withEntrez  = addAnc(all.GO[all.GO[,3]=="BP",], "bp")
    cc.go.all.withEntrez = addAnc(all.GO[all.GO[,3]=="CC",], "cc")
    mf.go.all.withEntrez = addAnc(all.GO[all.GO[,3]=="MF",], "mf")
    
    bp.go.this  = bp.go.this.withEntrez[,1]
    cc.go.this = cc.go.this.withEntrez[,1]
    mf.go.this = mf.go.this.withEntrez[,1]
    
    bp.go.all  = bp.go.all.withEntrez[,1]
    cc.go.all = cc.go.all.withEntrez[,1]
    mf.go.all = mf.go.all.withEntrez[,1]
    
    total.mf = length(mf.go.all)
    total.cc = length(cc.go.all)
    total.bp = length(bp.go.all)
    this.mf = length(mf.go.this)
    this.cc = length(cc.go.this)
    this.bp = length(bp.go.this)
    
    this.bp.count <- table(as.character(bp.go.this[bp.go.this!=""]))
    this.mf.count <- table(as.character(mf.go.this[mf.go.this!=""]))
    this.cc.count <- table(as.character(cc.go.this[cc.go.this!=""]))
    
    all.bp.count <- table(as.character(bp.go.all[bp.go.all!=""]))
    all.mf.count <- table(as.character(mf.go.all[mf.go.all!=""]))
    all.cc.count <- table(as.character(cc.go.all[cc.go.all!=""]))
    
    if(length(groupFALSE)){
      bp.go.FALSE.withEntrez = addAnc(FALSE.GO[FALSE.GO[,3]=="BP",],"bp")
      cc.go.FALSE.withEntrez = addAnc(FALSE.GO[FALSE.GO[,3]=="CC",], "cc")
      mf.go.FALSE.withEntrez = addAnc(FALSE.GO[FALSE.GO[,3]=="MF",],"mf")
      
      bp.go.FALSE  = bp.go.FALSE.withEntrez[,1]
      cc.go.FALSE = cc.go.FALSE.withEntrez[,1]
      mf.go.FALSE = mf.go.FALSE.withEntrez[,1]
      
      FALSE.mf = length(mf.go.FALSE)
      FALSE.cc = length(cc.go.FALSE)
      FALSE.bp = length(bp.go.FALSE)
      
      FALSE.bp.count <- table(as.character(bp.go.FALSE[bp.go.FALSE!=""]))
      FALSE.mf.count <- table(as.character(mf.go.FALSE[mf.go.FALSE!=""]))
      FALSE.cc.count <- table(as.character(cc.go.FALSE[cc.go.FALSE!=""]))
    }
    
    hyperGT <- function(alltermcount, thistermcount, 
                        totaltermInGenome, totaltermInPeakList){
        m <- as.numeric(alltermcount[names(thistermcount)])
        q <- as.numeric(thistermcount)
        n <- as.numeric(totaltermInGenome)
        k <- as.numeric(totaltermInPeakList)
        pvalue <- phyper(q-1, m, n-m, k, lower.tail = FALSE, log.p = FALSE)
        data.frame(go.id=names(thistermcount), 
                   count.InDataset=q,
                   count.InGenome=m, 
                   pvalue=pvalue,
                   totaltermInDataset=k, 
                   totaltermInGenome=n)
    }
    
    bp.selected = hyperGT(all.bp.count,
                             this.bp.count, 
                             total.bp, 
                             this.bp)
    mf.selected = hyperGT(all.mf.count,
                             this.mf.count, 
                             total.mf, 
                             this.mf)
    cc.selected = hyperGT(all.cc.count,
                             this.cc.count, 
                             total.cc, 
                             this.cc)
    
    if (length(multiAdjMethod)<1){
        bp.s = 
            bp.selected[
                as.numeric(as.character(bp.selected[,4]))<maxP & 
                    as.numeric(as.character(bp.selected[,3]))>=minGOterm,]
        mf.s = 
            mf.selected[
                as.numeric(as.character(mf.selected[,4]))<maxP & 
                    as.numeric(as.character(mf.selected[,3]))>=minGOterm,]
        cc.s = 
            cc.selected[
                as.numeric(as.character(cc.selected[,4]))<maxP & 
                    as.numeric(as.character(cc.selected[,3]))>=minGOterm,]
    }else{
        procs = c(multiAdjMethod)
        res <- mt.rawp2adjp(as.numeric(as.character(bp.selected[,4])), procs)
        adjp = unique(res$adjp)
        colnames(adjp)[1] = colnames(bp.selected)[4]
        colnames(adjp)[2] = paste(multiAdjMethod, "adjusted.p.value", sep=".")
        bp.selected[,4] = as.numeric(as.character(bp.selected[,4]))
        bp1 = merge(bp.selected, adjp, all.x=TRUE)
        
        res <- mt.rawp2adjp(as.numeric(as.character(mf.selected[,4])), procs)
        adjp = unique(res$adjp)
        colnames(adjp)[1] = colnames(mf.selected)[4]
        colnames(adjp)[2] = paste(multiAdjMethod, "adjusted.p.value", sep=".")
        mf.selected[,4] = as.numeric(as.character(mf.selected[,4]))
        mf1 = merge(mf.selected, adjp, all.x=TRUE)
        
        res <- mt.rawp2adjp(as.numeric(as.character(cc.selected[,4])), procs)
        adjp = unique(res$adjp)
        colnames(adjp)[1] = colnames(cc.selected)[4]
        colnames(adjp)[2] = paste(multiAdjMethod, "adjusted.p.value", sep=".")
        cc.selected[,4] = as.numeric(as.character(cc.selected[,4]))
        cc1 = merge(cc.selected, adjp, all.x=TRUE)
        
        bp.s = bp1[as.numeric(as.character(bp1[,dim(bp1)[2]]))<maxP &  
                       !is.na(bp1[,dim(bp1)[2]]) & 
                       as.numeric(as.character(bp1[,4]))>=minGOterm,]
        mf.s = mf1[as.numeric(as.character(mf1[,dim(mf1)[2]]))<maxP & 
                       !is.na(mf1[,dim(mf1)[2]]) & 
                       as.numeric(as.character(mf1[,4]))>=minGOterm,]
        cc.s = cc1[as.numeric(as.character(cc1[,dim(cc1)[2]]))<maxP & 
                       !is.na(cc1[,dim(cc1)[2]]) & 
                       as.numeric(as.character(cc1[,4]))>=minGOterm,]
    }
    
    annoTerms <- function(goids){
        if(length(goids)<1){
            goterm <- matrix(ncol=4)
        }else{
            goids <- as.character(goids)
            terms <- Term(goids)
            definition <- Definition(goids)
            ontology <- Ontology(goids)
            goterm <- cbind(goids, 
                            terms[match(goids, names(terms))],
                            definition[match(goids, names(definition))],
                            ontology[match(goids, names(ontology))])
        }
        colnames(goterm) <- c("go.id", "go.term", "Definition", "Ontology")
        rownames(goterm) <- NULL
        goterm
    }
    goterm.bp <- annoTerms(bp.s$go.id)
    goterm.mf <- annoTerms(mf.s$go.id)
    goterm.cc <- annoTerms(cc.s$go.id)
    
    bp.selected1 = merge(goterm.bp, bp.s,by="go.id")
    mf.selected1 = merge(goterm.mf, mf.s,by="go.id")
    cc.selected1 = merge(goterm.cc, cc.s,by="go.id")
    
    if(length(groupFALSE)){ ## add counts for FALSE group and do Fisher's exact test
      bp.selected1$count.InBackgroundDataset = FALSE.bp.count[bp.selected1$go.id]
      mf.selected1$count.InBackgroundDataset = FALSE.mf.count[mf.selected1$go.id]
      cc.selected1$count.InBackgroundDataset = FALSE.cc.count[cc.selected1$go.id]
      
      multiFisher <- function(.data){
        rowFisher <- function(x, ...){
          return(fisher.test(matrix(x, nrow = 2, byrow = TRUE), ...)$p.value)
        }
        .data0 <- .data[, c("count.InDataset", "count.InBackgroundDataset")]
        .data0 <- as.matrix(.data0)
        .data0[is.na(.data0)] <- 0
        .data0 <- cbind(.data0, .data[, "count.InGenome"] - .data0)
        apply(.data0, 1, rowFisher, alternative = "greater")
      }
      bp.selected1$dataset.vs.background.pval <- multiFisher(bp.selected1)
      mf.selected1$dataset.vs.background.pval <- multiFisher(mf.selected1)
      cc.selected1$dataset.vs.background.pval <- multiFisher(cc.selected1)
      
      bp.selected1 <-
        bp.selected1[bp.selected1$dataset.vs.background.pval<maxP, , drop=FALSE]
      mf.selected1 <-
        mf.selected1[mf.selected1$dataset.vs.background.pval<maxP, , drop=FALSE]
      cc.selected1 <-
        cc.selected1[cc.selected1$dataset.vs.background.pval<maxP, , drop=FALSE]
    }
    
    if(condense){
        bp.go.this.withEntrez <- 
            condenseMatrixByColnames(bp.go.this.withEntrez, iname="go.id")
        mf.go.this.withEntrez <- 
            condenseMatrixByColnames(mf.go.this.withEntrez, iname="go.id")
        cc.go.this.withEntrez <- 
            condenseMatrixByColnames(cc.go.this.withEntrez, iname="go.id")
    }
    
    bp.selected = merge(bp.selected1, bp.go.this.withEntrez)
    mf.selected = merge(mf.selected1, mf.go.this.withEntrez)
    cc.selected = merge(cc.selected1, cc.go.this.withEntrez)
    
    if(length(removeAncestorByPval)>0){
      if(is.numeric(removeAncestorByPval[1]) || 
         is.integer(removeAncestorByPval[1])){
        bp.selected <- removeAncestor(bp.selected, onto="BP", 
                                      cutoffPvalue=removeAncestorByPval)
        mf.selected <- removeAncestor(mf.selected, onto="MF", 
                                      cutoffPvalue=removeAncestorByPval)
        cc.selected <- removeAncestor(cc.selected, onto="CC", 
                                      cutoffPvalue=removeAncestorByPval)
      }
    }
    
    if(length(keepByLevel)>0){
      if(is.numeric(keepByLevel[1]) || is.integer(keepByLevel[1])){
        bp.selected <- filterByLevel(bp.selected, onto="BP", level=keepByLevel)
        mf.selected <- filterByLevel(mf.selected, onto="MF", level=keepByLevel)
        cc.selected <- filterByLevel(cc.selected, onto="CC", level=keepByLevel)
      }
    }
    list(bp=bp.selected, mf=mf.selected, cc=cc.selected)
}

#' Pie Charts
#' 
#' Draw a pie chart with percentage
#' 
#' 
#' @param x a vector of non-negative numerical quantities.  The values in x are
#' displayed as the areas of pie slices.
#' @param labels one or more expressions or character strings giving names for
#' the slices.  Other objects are coerced by as.graphicsAnnot. For empty or NA
#' (after coercion to character) labels, no label nor pointing line is drawn.
#' @param edges the circular outline of the pie is approximated by a polygon
#' with this many edges.
#' @param radius the pie is drawn centered in a square box whose sides range
#' from -1 to 1.  If the character strings labeling the slices are long it may
#' be necessary to use a smaller radius.
#' @param clockwise logical indicating if slices are drawn clockwise or counter
#' clockwise (i.e., mathematically positive direction), the latter is default.
#' @param init.angle number specifying the starting angle (in degrees) for the
#' slices. Defaults to 0 (i.e., "3 o'clock") unless clockwise is true where
#' init.angle defaults to 90 (degrees), (i.e., "12 o'clock").
#' @param density the density of shading lines, in lines per inch. The default
#' value of NULL means that no shading lines are drawn. Non-positive values of
#' density also inhibit the drawing of shading lines.
#' @param angle the slope of shading lines, given as an angle in degrees
#' (counter-clockwise).
#' @param col a vector of colors to be used in filling or shading the slices.
#' If missing a set of 6 pastel colours is used, unless density is specified
#' when par("fg") is used.
#' @param border,lty (possibly vectors) arguments passed to polygon which draws
#' each slice.
#' @param main an overall title for the plot.
#' @param percentage logical. Add percentage in the figure or not. default
#' TRUE.
#' @param rawNumber logical. Instead percentage, add raw number in the figure
#' or not. default FALSE.
#' @param digits When set percentage as TRUE, how many significant digits are
#' to be used for percentage. see \link[base]{format}. default 3.
#' @param cutoff When percentage is TRUE, if the percentage is lower than
#' cutoff, it will NOT be shown. default 0.01.
#' @param legend logical. Instead of lable, draw legend for the pie. default,
#' FALSE.
#' @param legendpos,legendcol legend position and legend columns. see
#' \link[graphics]{legend}
#' @param radius.innerlabel position of percentage or raw number label relative
#' to the circle.
#' @param ...  graphical parameters can be given as arguments to pie. They will
#' affect the main title and labels only.
#' @author Jianhong Ou
#' @seealso \code{\link[graphics]{pie}}
#' @keywords misc
#' @export
#' @importFrom grDevices as.graphicsAnnot dev.hold dev.flush 
#' @importFrom graphics plot.new plot.window polygon lines text title
#' @examples
#' 
#' pie1(1:5)
#' 
pie1 <- function (x, labels = names(x), edges = 200, 
                  radius = 0.8, clockwise = FALSE, 
                  init.angle = if (clockwise) 90 else 0, 
                  density = NULL, angle = 45, 
                  col = NULL, border = NULL, lty = NULL, 
                  main = NULL, percentage=TRUE, rawNumber=FALSE, 
                  digits=3, cutoff=0.01, 
                  legend=FALSE, legendpos="topright", legendcol=2, 
                  radius.innerlabel = radius, ...) 
{
    if (!is.numeric(x) || any(is.na(x) | x < 0)) 
        stop("'x' values must be positive.")
    if (is.null(labels)) 
        labels <- as.character(seq_along(x))
    else labels <- as.graphicsAnnot(labels)
    rawX <- x
    x <- c(0, cumsum(x)/sum(x))
    dx <- diff(x)
    nx <- length(dx)
    plot.new()
    pin <- par("pin")
    xlim <- ylim <- c(-1, 1)
    if (pin[1L] > pin[2L]) 
        xlim <- (pin[1L]/pin[2L]) * xlim
    else ylim <- (pin[2L]/pin[1L]) * ylim
    dev.hold()
    on.exit(dev.flush())
    plot.window(xlim, ylim, "", asp = 1)
    if (is.null(col)) 
        col <- if (is.null(density)) 
            c("white", "lightblue", "mistyrose", "lightcyan", 
              "lavender", "cornsilk", "pink")
    else par("fg")
    if (!is.null(col)) 
        col <- rep_len(col, nx)
    if (!is.null(border)) 
        border <- rep_len(border, nx)
    if (!is.null(lty)) 
        lty <- rep_len(lty, nx)
    angle <- rep(angle, nx)
    if (!is.null(density)) 
        density <- rep_len(density, nx)
    twopi <- if (clockwise) 
        -2 * pi
    else 2 * pi
    t2xy <- function(t) {
        t2p <- twopi * t + init.angle * pi/180
        list(x = radius * cos(t2p), y = radius * sin(t2p))
    }
    for (i in 1L:nx) {
        n <- max(2, floor(edges * dx[i]))
        P <- t2xy(seq.int(x[i], x[i + 1], length.out = n))
        polygon(c(P$x, 0), c(P$y, 0), density = density[i], angle = angle[i], 
                border = border[i], col = col[i], lty = lty[i])
        if(!legend){
            P <- t2xy(mean(x[i + 0:1]))
            lab <- as.character(labels[i])
            if (!is.na(lab) && nzchar(lab)) {
                lines(c(1, 1.05) * P$x, c(1, 1.05) * P$y)
                text(1.1 * P$x, 1.1 * P$y, labels[i], xpd = TRUE, 
                     adj = ifelse(P$x < 0, 1, 0), ...)
            }
        }
    }
    if (percentage) {
        for (i in 1L:nx){
            if(dx[i]>cutoff){
                P <- t2xy(mean(x[i + 0:1]))
                text(radius.innerlabel * P$x, radius.innerlabel * P$y, 
                     paste(formatC(dx[i]*100, digits=digits), "%", sep=""), 
                     xpd = TRUE, 
                     adj = .5, ...)
            }
        }
    }else{
        if(rawNumber){
            for (i in 1L:nx){
                if(dx[i]>cutoff){
                    P <- t2xy(mean(x[i + 0:1]))
                    text(radius.innerlabel * P$x, radius.innerlabel * P$y, 
                         rawX[i], xpd = TRUE, 
                         adj = .5, ...)
                }
            }
        }
    }
    if(legend) legend(legendpos, legend=labels, fill=col, 
                      border="black", bty="n", ncol = legendcol)
    title(main = main, ...)
    invisible(NULL)
}

#' An example GRanges object representing a ChIP-seq peak dataset
#' 
#' the putative STAT1-binding regions identified in un-stimulated cells using
#' ChIP-seq technology (Robertson et al., 2007)
#' 
#' 
#' @name myPeakList
#' @docType data
#' @format GRanges with slot rownames containing the ID of peak as character,
#' slot start containing the start position of the peak, slot end containing
#' the end position of the peak and seqnames containing the chromosome where
#' the peak is located.
#' @source Robertson G, Hirst M, Bainbridge M, Bilenky M, Zhao Y, et al. (2007)
#' Genome-wide profiles of STAT1 DNA association using chromatin
#' immunoprecipitation and massively parallel sequencing. Nat Methods 4:651-7
#' @keywords datasets
#' @examples
#' 
#' data(myPeakList)
#' slotNames(myPeakList)
"myPeakList"

#' extract signals in given ranges from bam files
#' 
#' extract signals in the given feature ranges from bam files (DNAseq only).
#' The reads will be extended to estimated fragement length.
#' 
#' 
#' @param bamfiles The file names of the 'BAM' ('SAM' for asBam) files to be
#' processed.
#' @param index The names of the index file of the 'BAM' file being processed;
#' this is given without the '.bai' extension.
#' @param feature.gr An object of \link[GenomicRanges:GRanges-class]{GRanges}
#' with identical width.
#' @param upstream,downstream upstream or dwonstream from the feature.gr.
#' @param n.tile The number of tiles to generate for each element of
#' feature.gr, default is 100
#' @param fragmentLength Estimated fragment length.
#' @param librarySize Estimated library size.
#' @param pe Pair-end or not. Default auto.
#' @param adjustFragmentLength A numberic vector with length 1. Adjust the
#' fragments/reads length to.
#' @param gal A GAlignmentsList object or a list of GAlignmentPairs. If
#' bamfiles is missing, gal is required.
#' @param \dots Not used.
#' @return A list of matrix. In each matrix, each row record the signals for
#' corresponding feature.
#' @author Jianhong Ou
#' @seealso See Also as \code{\link{featureAlignedSignal}},
#' \code{\link{estLibSize}}, \code{\link{estFragmentLength}}
#' @keywords misc
#' @export
#' @import IRanges
#' @import GenomicRanges
#' @importFrom S4Vectors elementNROWS mcols
#' @importFrom GenomicAlignments readGAlignments readGAlignmentPairs
#' @importFrom Rsamtools testPairedEndBam ScanBamParam scanBamWhat scanBamFlag
#' @examples
#' 
#'  if(interactive() || Sys.getenv("USER")=="jou"){
#'     path <- system.file("extdata", package="MMDiffBamSubset")
#'     if(file.exists(path)){
#'         WT.AB2 <- file.path(path, "reads", "WT_2.bam")
#'         Null.AB2 <- file.path(path, "reads", "Null_2.bam")
#'         Resc.AB2 <- file.path(path, "reads", "Resc_2.bam")
#'         peaks <- file.path(path, "peaks", "WT_2_Macs_peaks.xls")
#'         estLibSize(c(WT.AB2, Null.AB2, Resc.AB2))
#'         feature.gr <- toGRanges(peaks, format="MACS")
#'         feature.gr <- feature.gr[seqnames(feature.gr)=="chr1" & 
#'                              start(feature.gr)>3000000 & 
#'                              end(feature.gr)<75000000]
#'         sig <- featureAlignedExtendSignal(c(WT.AB2, Null.AB2, Resc.AB2), 
#'                                feature.gr=reCenterPeaks(feature.gr, width=1), 
#'                                upstream = 505,
#'                                downstream = 505,
#'                                n.tile=101, 
#'                                fragmentLength=250,
#'                                librarySize=1e9)
#'         featureAlignedHeatmap(sig, reCenterPeaks(feature.gr, width=1010), 
#'                           zeroAt=.5, n.tile=101)
#'     }
#'  }
#' 
featureAlignedExtendSignal <- function(bamfiles, index=bamfiles, 
                                       feature.gr, 
                                       upstream, downstream, 
                                       n.tile=100, 
                                       fragmentLength,
                                       librarySize,
                                       pe=c("auto", "PE", "SE"),
                                       adjustFragmentLength,
                                       gal, ...){
    #message("The signal is being calculated for DNA-seq.")
    if(missing(fragmentLength)){
        stop("fragmentLength is missing")
    }
    if(!missing(adjustFragmentLength)){
      stopifnot(inherits(adjustFragmentLength, c("numeric", "integer")))
      stopifnot(length(adjustFragmentLength)==1)
    }
    if(!missing(bamfiles)){
      stopifnot(is(bamfiles, "character"))
      stopifnot(length(bamfiles)==length(index))
      galInput <- FALSE
    }else{
      if(missing(gal)){
        stop("gal is required if missing bamfiles")
      }else{
        if(!is(gal, "GAlignmentsList")){
          galInput <- sapply(gal, function(.ele){
            inherits(.ele, c("GAlignments", "GAlignmentPairs"))
          })
          if(any(!galInput)){
            stop("gal must be a GAlignmentsList object or ", 
                 "a list of GAlignmentPairs.")
          }
        }
      }
      galInput <- TRUE
    }
    stopifnot(is(feature.gr, "GRanges"))
    if(missing(upstream) | missing(downstream)){
        stop("upstream and downstream is missing")
    }
    stopifnot(inherits(upstream, c("numeric", "integer")))
    stopifnot(inherits(downstream, c("numeric", "integer")))
    stopifnot(inherits(n.tile, c("numeric", "integer")))
    stopifnot(inherits(fragmentLength, c("numeric", "integer")))
    stopifnot(inherits(librarySize, c("numeric", "integer")))
    pe <- match.arg(pe)
    upstream <- as.integer(upstream)
    downstream <- as.integer(downstream)
    n.tile <- as.integer(n.tile)
    fragmentLength <- as.integer(fragmentLength)
    librarySize <- as.integer(librarySize)
    stopifnot(all(width(feature.gr)==1))
    
    totalBPinBin <- floor((upstream + downstream)/n.tile)# * length(feature.gr)
    feature.gr$oid <- 1:length(feature.gr)
    feature.gr.expand <- 
        suppressWarnings(promoters(feature.gr, 
                                   upstream=upstream+max(fragmentLength), 
                                   downstream=downstream+max(fragmentLength)))
    strand(feature.gr.expand) <- "*"
    feature.gr <- suppressWarnings(promoters(feature.gr,
                                             upstream=upstream, 
                                             downstream=downstream))
    
    grL <- tile(feature.gr, n=n.tile)
    ## reorder the tiles for negative strand and set group id for them.
    idx <- as.character(strand(feature.gr))=="-"
    if(sum(idx)>0) {
        grL.rev <- grL[idx]
        grL.rev.len <- lengths(grL.rev)
        grL.rev <- unlist(grL.rev, use.names = FALSE)
        grL.rev$oid <- rep(seq.int(length(grL[idx])), grL.rev.len)
        grL.rev <- rev(grL.rev)
        grL.rev.oid <- grL.rev$oid
        grL.rev$oid <- NULL
        grL.rev <- split(grL.rev, grL.rev.oid)
        grL[idx] <- as(grL.rev, "CompressedGRangesList")
        rm(grL.rev, grL.rev.len, grL.rev.oid)
    }
    grL.eleLen <- elementNROWS(grL)
    grs <- unlist(grL)
    grs$gpid <- unlist(lapply(grL.eleLen, seq_len)) 
    grs$oid <- rep(feature.gr$oid, grL.eleLen)
    if(galInput){
      bams.gr <- mapply(function(ga, .fLen){
        if(is(ga, "GAlignmentPairs")){
          granges(.ele)
        }else{
          qname <- mcols(ga)$qname
          if(pe=="auto"){
            ## check qname
            if(length(qname)==0){
              pe <- FALSE
            }else{
              ## check duplicated qname
              if(all(table(qname)==1)){
                pe <- FALSE
              }else{
                if(all(table(qname)<3)){
                  pe <- TRUE
                }else{
                  pe <- FALSE
                }
              }
            }
          }else{
            pe <- pe=="PE"
          }
          
          if(pe){
            .ele <- split(ga, qname)
            .ele <- granges(.ele, ignore.strand=TRUE)
            .ele
          }else{
            .ele <- granges(ga)
            start(.ele[strand(.ele)=="-"]) <- 
              end(.ele[strand(.ele)=="-"]) - .fLen + 1
            width(.ele) <- .fLen
            .ele
          }
        }
      }, gal, fragmentLength, SIMPLIFY=FALSE)
    }else{
      if(pe=="auto") {
        pe <- mapply(function(file, id) 
          suppressMessages(testPairedEndBam(file, index=id)), 
          bamfiles, index)
      }else{
        pe <- pe=="PE"
      }
      param <- ScanBamParam(which=reduce(feature.gr.expand), 
                            flag=scanBamFlag(isSecondaryAlignment=FALSE,
                                             isNotPassingQualityControls=FALSE),
                            what=scanBamWhat())
      paramp <- ScanBamParam(which=reduce(feature.gr.expand), 
                             flag=scanBamFlag(
                               isProperPair=TRUE,
                               isSecondaryAlignment=FALSE,
                               isNotPassingQualityControls=FALSE),
                             what=scanBamWhat())
      bams.gr <- mapply(function(f, i, p, .fLen) {
        if(!p){
          .ele <- granges(readGAlignments(f, index=i, param=param))
          start(.ele[strand(.ele)=="-"]) <- 
            end(.ele[strand(.ele)=="-"]) - .fLen + 1
          width(.ele) <- .fLen
          .ele
        }else{
          .ele <- readGAlignmentPairs(f, index=i, param=paramp)
          .ele <- granges(.ele)
          .ele
        }
      }, bamfiles, index, pe, fragmentLength, SIMPLIFY=FALSE)
    }
    
    if(!missing(adjustFragmentLength)){
      bams.gr <- lapply(bams.gr, reCenterPeaks, 
                        width=adjustFragmentLength)
      fragmentLength <- adjustFragmentLength
    }
    ## count overlaps
    co <- lapply(bams.gr, countOverlaps, 
                 query=grs, ignore.strand=TRUE)
    
    countTable <- do.call(cbind, co)
    colnames(countTable) <- names(bams.gr)
    stopifnot(nrow(countTable)==length(grs))
#    sumByGpid <- rowsum(countTable, grs$gpid, reorder = FALSE)
#    signal <- t(t(sumByGpid)*1e8/librarySize*100/fragmentLength)/totalBPinBin
    countTable.list <- as.list(as.data.frame(countTable))
    signal <- mapply(function(.ele, .libsize, .fLen){
        tbl <- matrix(nrow=n.tile, ncol=length(feature.gr))
        tbl[(grs$oid-1)*n.tile + grs$gpid] <- .ele
        t(tbl)*1e8/.libsize*100/.fLen/totalBPinBin
    }, countTable.list, librarySize, fragmentLength, SIMPLIFY = FALSE)
    return(signal)
}

#' Convert other common IDs to entrez gene ID.
#' 
#' Convert other common IDs such as ensemble gene id, gene symbol, refseq id to
#' entrez gene ID leveraging organism annotation dataset.  For example,
#' org.Hs.eg.db is the dataset from orgs.Hs.eg.db package for human, while
#' org.Mm.eg.db is the dataset from the org.Mm.eg.db package for mouse.
#' 
#' 
#' @param IDs a vector of IDs such as ensembl gene ids
#' @param orgAnn organism annotation dataset such as org.Hs.eg.db
#' @param ID_type type of ID: can be ensemble_gene_id, gene_symbol or refseq_id
#' @return vector of entrez ids
#' @author Lihua Julie Zhu
#' @keywords misc
#' @export
#' @examples
#' 
#' ensemblIDs = c("ENSG00000115956", "ENSG00000071082", "ENSG00000071054",
#'  "ENSG00000115594", "ENSG00000115594", "ENSG00000115598", "ENSG00000170417")
#' library(org.Hs.eg.db)
#' entrezIDs = convert2EntrezID(IDs=ensemblIDs, orgAnn="org.Hs.eg.db",
#'  ID_type="ensembl_gene_id")
#' 
convert2EntrezID <- function(IDs, orgAnn, ID_type="ensembl_gene_id")
{
    GOgenome = sub(".db","",orgAnn)
    if (ID_type == "ensembl_gene_id")
    {
        orgAnn <- get(paste(GOgenome,"ENSEMBL2EG", sep=""))
    }
    else if (ID_type == "gene_symbol")
    {
        orgAnn <- get(paste(GOgenome,"SYMBOL2EG", sep=""))
    }
    else if (ID_type == "refseq_id")
    {
        orgAnn <- get(paste(GOgenome,"REFSEQ2EG", sep=""))
    }
    else
    {
        stop("Currently only the following type of IDs are supported:",
             "ensembl_gene_id, refseq_id and gene_symbol!")
    }
    
    if(!is(orgAnn, "AnnDbBimap"))
    {
        stop("orgAnn is not a valid annotation dataset! ",
             "For example, orgs.Hs.eg.db package for human",
			 "and the org.Mm.eg.db package for mouse.")
    }
    xx <- as.list(orgAnn)
    IDs = unique(IDs[!is.na(IDs)])
    x = do.call(rbind, lapply(IDs,function(x1)
    {
        r= xx[names(xx)==x1]
        if (length(r) >0)
        {
            r[[1]][1]
        }
    }))
    unique(x)
}

#' TSS annotation for human sapiens (GRCh38) obtained from biomaRt
#' 
#' TSS annotation for human sapiens (GRCh38) obtained from biomaRt
#' 
#' used in the examples Annotation data obtained by:
#' 
#' mart = useMart(biomart = "ensembl", dataset = "hsapiens_gene_ensembl")
#' 
#' getAnnotation(mart, featureType = "TSS")
#' 
#' @name TSS.human.GRCh38
#' @docType data
#' @format A 'GRanges' [package "GenomicRanges"] object with ensembl id as
#' names.
#' @keywords datasets
#' @examples
#' 
#' data(TSS.human.GRCh38)
#' slotNames(TSS.human.GRCh38)
#' 
"TSS.human.GRCh38"

#' count overlaps
#' 
#' Count overlaps with max gap.
#' 
#' @param A,B A GRanges object.
#' @param maxgap A single integer >= 0.
#' @param ... parameters passed to \link[regioneR]{numOverlaps}#' 
#' @importFrom regioneR numOverlaps
cntOverlaps <- function(A, B, maxgap=0L, ...){
    if(maxgap>0) {
        A <- expandGR(A, maxgap)
    }
    
    numOverlaps(A, B, ...)
}

#' peak distance to features
#' 
#' Bar plot for distance to features
#' 
#' @details the bar heatmap is indicates the peaks around features. 
#' @param peaks peak list, \link[GenomicRanges:GRanges-class]{GRanges} object or
#' a \link[GenomicRanges:GRangesList-class]{GRangesList}.
#' @param AnnotationData A \link[GenomicRanges:GRanges-class]{GRanges} object 
#' or a \link[GenomicFeatures:TxDb-class]{TxDb} object.
#' @param PeakLocForDistance Specify the location of peak for calculating
#' distance,i.e., middle means using middle of the peak to calculate distance
#' to feature, start means using start of the peak to calculate the distance to
#' feature. To be compatible with previous version, by default using start
#' @param FeatureLocForDistance Specify the location of feature for calculating
#' distance,i.e., middle means using middle of the feature to calculate
#' distance of peak to feature, TSS means using start of feature when
#' feature is on plus strand and using end of feature when feature is on minus
#' strand, geneEnd means using end of feature when feature is on plus strand
#' and using start of feature when feature is on minus strand. 
#' @param upstream,downstream numeric(1). Upstream or downstream region of
#' features to plot.
#' @export
#' @importFrom ggplot2 geom_bin2d ggplot theme_bw aes_string
#' @examples 
#' path <- system.file("extdata", package="ChIPpeakAnno")
#' files <- dir(path, "broadPeak")
#' peaks <- sapply(file.path(path, files), toGRanges, format="broadPeak")
#' peaks <- GRangesList(peaks)
#' names(peaks) <- sub(".broadPeak", "", basename(names(peaks)))
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' metagenePlot(peaks, TxDb.Hsapiens.UCSC.hg19.knownGene)
metagenePlot <- function(peaks, AnnotationData, 
                     PeakLocForDistance = c("middle", "start", "end"),
                     FeatureLocForDistance = c("TSS", "middle", "geneEnd"),
                     upstream=100000, 
                     downstream=100000){
  stopifnot("peaks must be an object of GRanges or GRangesList"=
              inherits(peaks, c("GRanges", "GRangesList")))
  FeatureLocForDistance <- match.arg(FeatureLocForDistance)
  PeakLocForDistance <- match.arg(PeakLocForDistance)
  if(is(peaks, "GRanges")){
    n <- deparse(substitute(peaks))
    peaks <- GRangesList(peaks)
    names(peaks) <- n
    isGRanges <- TRUE
  }else{
    isGRanges <- FALSE
  }
  stopifnot("AnnotationData must be an object of TxDb"=
              inherits(AnnotationData, c("TxDb", "GRanges")))
  if(is(AnnotationData, "TxDb")){
    suppressMessages(g <- genes(AnnotationData))
  }else{
    g <- AnnotationData
    if(length(names(g))!=length(g)){
      names(g) <- paste0("ann", 
                         formatC(seq_along(g), 
                                 width = nchar(as.character(length(g))),
                                 flag = 0))
    }
  }
  seql <- seqlevelsStyle(g)
  seqn <- seqlevels(g)
  peaks <- lapply(peaks, function(.ele){
    seqlevelsStyle(.ele) <- seql[1]
    .ele <- .ele[seqnames(.ele) %in% seqn]
    seqlevels(.ele) <- seqn
    .ele
  })
  features <- switch(FeatureLocForDistance,
                     "TSS"=promoters(g, upstream=0, downstream=1),
                     "geneEnd"=downstreams(g, upstream=1, downstream=0),
                     "middle"=reCenterPeaks(g, width=1))
  suppressWarnings({
    features.ext <- switch(FeatureLocForDistance,
                         "TSS"=promoters(g, upstream=upstream, 
                                         downstream=downstream),
                         "geneEnd"=downstreams(g, upstream=upstream, 
                                           downstream=downstream),
                         "middle"=reCenterPeaks(g, width=upstream+downstream))})
  features.ext <- GenomicRanges::trim(features.ext)
  ol <- lapply(peaks, function(.peaks){
    findOverlaps(.peaks, features.ext)
  })
  pp <- mapply(ol, peaks, FUN=function(.ol, .peaks){
    a <- .peaks[queryHits(.ol)]
    a <- switch(PeakLocForDistance,
                "start"=promoters(a, upstream=0, downstream=1),
                "end"=downstreams(a, upstream=1, downstream=0),
                "middle"=reCenterPeaks(a, width=1))
    b <- features[subjectHits(.ol)]
    d <- distance(a, b)
    s <- pcompare(ranges(a), ranges(b))
    s <- ifelse(as.character(strand(b)) == "-", -1*s, s)
    d <- data.frame(id=names(b), distance=d*sign(s))
  }, SIMPLIFY = FALSE)
  dat <- do.call(rbind, pp)
  dat$peaks <- rep(names(peaks), vapply(pp, nrow, FUN.VALUE = 0))
  ggplot(dat, aes_string(x="distance", y="peaks")) + 
    geom_bin2d()+theme_bw()
}

#' An example GRanges object representing a ChIP-seq peak dataset
#' 
#' @name peaks3
#' @docType data
#' @format GRanges
#' @keywords datasets
#' @examples
#' 
#' data(peaks3)
#' head(peaks3, n = 2)
"peaks3"

#' Return the value from a Bimap objects
#' 
#' Search by name for an Bimap object.
#' 
#' 
#' @param x,envir,mode,ifnotfound,inherits see
#' \link[AnnotationDbi:Bimap-envirAPI]{mget}
#' @param output return the all or first item for each query
#' @return a character vector
#' @author Jianhong Ou
#' @seealso See Also as \code{\link[base:get]{mget}},
#' \code{\link[AnnotationDbi:Bimap-envirAPI]{mget}}
#' @keywords misc
#' @export
#' @examples
#' 
#'     library(org.Hs.eg.db)
#'     xget(as.character(1:10), org.Hs.egSYMBOL)
#' 
xget <- function(x, envir, mode, ifnotfound=NA, inherits, 
                 output=c("all", "first", "last")){
    output <- match.arg(output)
    y <- mget(x=x, envir=envir, mode=mode, 
              ifnotfound=ifnotfound, inherits=inherits)
    switch(output, 
           all=sapply(y, base::paste, collapse=";"),
           first=sapply(y, `[`, 1),
           last=sapply(y, function(.ele) .ele[length(.ele)])
    )
}

#' Write sequences to a file in fasta format
#' 
#' Write the sequences obtained from getAllPeakSequence to a file in fasta
#' format leveraging writeFASTA in Biostrings package. FASTA is a simple file
#' format for biological sequence data. A FASTA format file contains one or
#' more sequences and there is a header line which begins with a > proceeding
#' each sequence.
#' 
#' 
#' @param mySeq GRanges with varibles name and sequence ,e.g., results obtained
#' from getAllPeakSequence
#' @param file Either a character string naming a file or a connection open for
#' reading or writing. If "" (the default for write2FASTA), then the function
#' writes to the standard output connection (the console) unless redirected by
#' sink
#' @param width The maximum number of letters per line of sequence
#' @return Output as FASTA file format to the naming file or the console.
#' @author Lihua Julie Zhu
#' @keywords misc
#' @export
#' @importFrom Biostrings writeXStringSet
#' @examples
#' 
#' peaksWithSequences = GRanges(seqnames=c("1", "2"),
#' IRanges(start=c(1000, 2000), 
#' end=c(1010, 2010), 
#' names=c("id1", "id2")), 
#' sequence= c("CCCCCCCCGGGGG", "TTTTTTTAAAAAA"))
#' 
#' write2FASTA(peaksWithSequences, file="testseq.fasta", width=50)
#' 
write2FASTA <- function(mySeq, file="", width=80){
    if(!inherits(mySeq, c("GRanges"))){
        stop("mySeq must be an object of GRanges")
    }
    if(is.null(mySeq$sequence)){
        stop("metadata must contain sequence")
    }
    if(!is.null(names(mySeq))){
        descriptions <- names(mySeq)
    }else{
        descriptions <- 
            paste("X", 
                  formatC(1:length(mySeq), 
                          width=nchar(as.character(length(mySeq))),
                          flag="0"), 
                  as.character(seqnames(mySeq)), ":", 
                  start(mySeq), "-",
                  end(mySeq), ":",
                  as.character(strand(mySeq)))
    }
    
    sequences <- mySeq$sequence
    names(sequences) <- descriptions
    writeXStringSet(as(sequences,"XStringSet"), file, width=width)
}

test_that("write2FASTA works not correct", {
    ##GRanges
    peaksWithSequences = GRanges("chr1", 
                                 IRanges(start=c(1000, 2000), 
                                         end=c(1010, 2010), 
                                         names=c("id1", "id2")), 
                                 sequence= c("CCCCCCCCGGGGG", 
                                             "TTTTTTTAAAAAA"))
    write2FASTA(peaksWithSequences, tempfile(fileext = "testWrite2FASTA.fa"))
})

#' Obtain genomic sequences around the peaks
#' 
#' Obtain genomic sequences around the peaks leveraging the BSgenome and
#' biomaRt package
#' 
#' 
#' @param myPeakList An object of \link[GenomicRanges:GRanges-class]{GRanges}:
#' See example below
#' @param upstream upstream offset from the peak start, e.g., 200
#' @param downstream downstream offset from the peak end, e.g., 200
#' @param genome BSgenome object or mart object. Please refer to
#' available.genomes in BSgenome package and useMart in bioMaRt package for
#' details
#' @param AnnotationData GRanges object with annotation information.
#' @return \link[GenomicRanges:GRanges-class]{GRanges} with slot start holding
#' the start position of the peak, slot end holding the end position of the
#' peak, slot rownames holding the id of the peak and slot seqnames holding the
#' chromosome where the peak is located. In addition, the following variables
#' are included: \item{upstream}{upstream offset from the peak start}
#' \item{downstream}{downstream offset from the peak end} \item{sequence}{the
#' sequence obtained}
#' @author Lihua Julie Zhu, Jianhong Ou
#' @references Durinck S. et al. (2005) BioMart and Bioconductor: a powerful
#' link between biological biomarts and microarray data analysis.
#' Bioinformatics, 21, 3439-3440.
#' @keywords misc
#' @export
#' @importFrom BiocGenerics start end width strand
#' @importFrom GenomeInfoDb seqlengths seqlevels seqnames `seqlengths<-`
#' @importFrom Biostrings getSeq
#' @examples
#' 
#' #### use Annotation data from BSgenome
#' peaks <- GRanges(seqnames=c("NC_008253", "NC_010468"),
#'                  IRanges(start=c(100, 500), end=c(300, 600), 
#'                          names=c("peak1", "peak2")))
#' library(BSgenome.Ecoli.NCBI.20080805)
#' seq <- getAllPeakSequence(peaks, upstream=20, downstream=20, genome=Ecoli)
#' write2FASTA(seq, file="test.fa")
#' 
getAllPeakSequence <- function(myPeakList, 
                               upstream=200L, downstream=upstream, 
                               genome, AnnotationData)
{
    if (!inherits(myPeakList, c("GRanges"))) {
        stop("No valid myPeakList passed in. It needs to be GRanges object")
    }
    if (missing(genome))
    {
        stop("genome is required parameter, 
             please pass in either a BSgenome object or a Mart object!")
    }
  old_name <- names(myPeakList)
    if(length(old_name)!=length(myPeakList)){
      names(myPeakList) <- paste0("peak_", seq_along(myPeakList))
    }
    myPeakList.bk <- myPeakList
    if (is(genome, "BSgenome"))
    {
        strand <- strand(myPeakList)
        width <- width(myPeakList)
        ##  start(myPeakList)
        start(myPeakList) <- ifelse(strand=="-", 
                                    start(myPeakList) - as.numeric(downstream),
                                    start(myPeakList) - as.numeric(upstream))
        lt0 <- start(myPeakList)<=0
        start <- start(myPeakList)-1
        start[!lt0] <- 0
        start(myPeakList)[lt0] <- 1
        width(myPeakList) <- width + as.numeric(upstream) + 
            as.numeric(downstream) + start
        strand[strand!="-"] <- "+"
        strand(myPeakList) <- strand
        ##how to make the seqname be same is a question.
        if(!all(seqlevels(myPeakList) %in% seqnames(genome))){
            #myPeakList <- formatSeqnames(myPeakList)
            genome <- formatSeqnames(genome, myPeakList)
        }
        ends <- unlist(
            apply(
                cbind(end(myPeakList), 
                      seqlengths(genome)[as.character(seqnames(myPeakList))]), 
                1,
                min))
        ends <- unname(ifelse(is.na(ends), end(myPeakList), ends))
        keep <- start(myPeakList) <= ends
        end(myPeakList)[keep] <- ends[keep]
        myPeakList <- myPeakList[keep]
        seq <- getSeq(genome, myPeakList, as.character=TRUE)
        
        myPeakList <- myPeakList.bk
        myPeakList$upstream <- rep(upstream,length(myPeakList.bk))
        myPeakList$downstream <- rep(downstream,length(myPeakList.bk))
        myPeakList$sequence <- NA
        if(!all(names(myPeakList) %in% names(seq))){
          warning("The genome assembly are not identical to your peaks!")
        }
        myPeakList[names(seq)]$sequence <- seq
        if(all(seqlevels(myPeakList) %in% seqlevels(genome))){
            seqlengths(myPeakList) <- seqlengths(genome)[seqlevels(myPeakList)]
        }   
        names(myPeakList) <- old_name
        myPeakList
    }else if (is(genome, "Mart")){
        if (missing(AnnotationData)) {
            message("No AnnotationData as GRanges is passed in, 
                    so now querying biomart database for AnnotationData ....")
            AnnotationData <- getAnnotation(genome)
            message("Done querying biomart database, start annotating ....
                    Better way would be calling getAnnotation before 
                    querying for sequence")
        }
        if (!inherits(AnnotationData, c("GRanges"))) {
            stop("AnnotationData needs to be GRanges object. 
                 Better way would be calling getAnnotation.")
        }
        
        downstream.bk = downstream
        plusAnno = AnnotationData[strand(AnnotationData)=="+"]
        temp = annotatePeakInBatch(myPeakList, AnnotationData=plusAnno)
        TSSlength =temp$end_position - temp$start_position
        downstream = end(temp) - start(temp) + downstream
        temp$downstream=  downstream
        temp$TSSlength = TSSlength
        
        myList3 = as.data.frame(temp)
        rm(temp)
        
        if (dim(myList3)[1] != 0)
        {
            l3 =  cbind(as.character(myList3$feature), 
                        as.numeric(as.character(myList3$distancetoFeature)), 
                        as.numeric(rep(upstream, dim(myList3)[1])), 
                        as.numeric(as.character(myList3$downstream)), 
                        as.numeric(as.character(myList3$start_position)), 
                        as.numeric(as.character(myList3$end_position)))
            r3 = apply(l3, 1, getGeneSeq, genome)
        }
        else
        {
            r3 = 0
        }
        
        if (is.list(r3))
        {
            r = as.data.frame(do.call("rbind",r3))
        }
        else
        {
            stop("No sequence found error!")
        }
        colnames(r)= c("feature", "distancetoFeature", "upstream", 
                       "downstream", "seq")
        r4 = merge(r, myList3)
        GRanges(seqnames=as.character(r4$space),
                ranges=IRanges(start=r4$start, 
                               end  =r4$end, 
                               names=as.character(r4$name)),
                strand="+",
                upstream=rep(upstream, dim(r4)[1]), 
                downstream= rep(downstream.bk, dim(r4)[1]),
                sequence=unlist(r4$seq))
    }else{
        stop("genome needs to be either a BSgenome object or Mart object!")
    }
}

test_that("getAllPeakSequence works not correct", {
    #Fixme, Zv9_scaffold.
    peaks <- GRanges(c("Zv9_scaffold3564","MT","1", "1"),
                     IRanges(start=c(10,300,60348387, 60348490),
                             end=c(50,330,60348389, 60348498), 
                             names=c("p1","p2","p0", "p3")))
    suppressWarnings(seq <- 
                         getAllPeakSequence(peaks, 
                                            upstream = 20, 
                                            downstream = 20, 
                                            genome = Drerio))
    expect_equal(as.character(seq["p0",]$sequence),
                getSeq(Drerio, 
                       GRanges("chr1",
                               IRanges(60348367, 60348388)),
                       as.character=TRUE))
    expect_equal(as.character(seq["p1",]$sequence),
                suppressWarnings(getSeq(Drerio, 
                                        GRanges("Zv9_scaffold3564",
                                                IRanges(1, 70)),
                                        as.character=TRUE)))
    expect_equal(as.character(seq["p2",]$sequence),
                getSeq(Drerio, GRanges("chrM",
                                       IRanges(280, 350)),
                       as.character=TRUE))
    expect_true(is.na(seq["p3"]$sequence))
})

#' estimate the library size
#' 
#' estimate the library size of bam files
#' 
#' 
#' @param bamfiles The file names of the 'BAM' ('SAM' for asBam) files to be
#' processed.
#' @param index The names of the index file of the 'BAM' file being processed;
#' this is given without the '.bai' extension.
#' @param \dots Not used.
#' @return numberic vector
#' @author Jianhong Ou
#' @keywords misc
#' @export
#' @importFrom Rsamtools testPairedEndBam countBam ScanBamParam scanBamFlag
#' @examples
#' 
#'     if(interactive() || Sys.getenv("USER")=="jou"){
#'         path <- system.file("extdata", "reads", package="MMDiffBamSubset")
#'         if(file.exists(path)){
#'             WT.AB2 <- file.path(path, "WT_2.bam")
#'             Null.AB2 <- file.path(path, "Null_2.bam")
#'             Resc.AB2 <- file.path(path, "Resc_2.bam")
#'             estLibSize(c(WT.AB2, Null.AB2, Resc.AB2))
#'         }
#'     }
#' 
estLibSize <- function(bamfiles, index=bamfiles, ...){
    if(length(index)==0){
        index <- rep(list(character(0)), length(bamfiles))
    }
    res <- mapply(function(f, i){
        if(suppressMessages(testPairedEndBam(f, index=i))){
            countBam(f, index=i, 
                     param=ScanBamParam(
                         flag=scanBamFlag(
                             isPaired = TRUE, 
                             isProperPair = TRUE,
                             isSecondaryAlignment = FALSE,
                             isNotPassingQualityControls = FALSE)))[, 
                                                                    "records"]/2
        }else{
            countBam(f, index=i, 
                     param=ScanBamParam(
                         flag=scanBamFlag(isPaired = FALSE, 
                                          isUnmappedQuery = FALSE,
                                          isSecondaryAlignment = FALSE,
                                          isNotPassingQualityControls = 
                                              FALSE)))[, "records"]
        }
    }, bamfiles, index, SIMPLIFY = TRUE)
    
    res
}

#' Batch annotation of the peaks identified from either ChIP-seq or ChIP-chip
#' experiments.
#' 
#' The package includes functions to retrieve the sequences around the peak,
#' obtain enriched Gene Ontology (GO) terms, find the nearest gene, exon, miRNA
#' or custom features such as most conserved elements and other transcription
#' factor binding sites leveraging biomaRt, IRanges, Biostrings, BSgenome,
#' GO.db, hypergeometric test phyper and multtest package.
#' 
#' \tabular{ll}{ Package: \tab ChIPpeakAnno\cr Type: \tab Package\cr Version:
#' \tab 3.0.0\cr Date: \tab 2014-10-24\cr License: \tab LGPL\cr LazyLoad: \tab
#' yes\cr }
#' 
#' @name ChIPpeakAnno-package
#' @aliases ChIPpeakAnno-package ChIPpeakAnno
#' @docType package
#' @author Lihua Julie Zhu, Jianhong Ou, Hervé Pagès, Claude Gazin, Nathan
#' Lawson, Simon Lin, David Lapointe and Michael Green
#' 
#' Maintainer: Jianhong Ou <jianhong.ou@@umassmed.edu>, Lihua Julie Zhu
#' <julie.zhu@@umassmed.edu>
#' @references 1. Y. Benjamini and Y. Hochberg (1995). Controlling the false
#' discovery rate: a practical and powerful approach to multiple testing. J. R.
#' Statist. Soc. B. Vol. 57: 289-300. \cr 2. Y. Benjamini and D. Yekutieli
#' (2001). The control of the false discovery rate in multiple hypothesis
#' testing under dependency. Annals of Statistics. Accepted. \cr 3.  S. Durinck
#' et al. (2005) BioMart and Bioconductor: a powerful link between biological
#' biomarts and microarray data analysis. Bioinformatics, 21, 3439-3440. \cr 4.
#' S. Dudoit, J. P. Shaffer, and J. C. Boldrick (Submitted). Multiple
#' hypothesis testing in microarray experiments. \cr 5. Y. Ge, S. Dudoit, and
#' T. P. Speed. Resampling-based multiple testing for microarray data
#' hypothesis, Technical Report #633 of UCB Stat.
#' http://www.stat.berkeley.edu/~gyc \cr 6. Y. Hochberg (1988). A sharper
#' Bonferroni procedure for multiple tests of significance, Biometrika. Vol.
#' 75: 800-802. \cr 7. S. Holm (1979). A simple sequentially rejective multiple
#' test procedure. Scand. J. Statist.. Vol. 6: 65-70. \cr 8. N. L. Johnson,S.
#' Kotz and A. W. Kemp (1992) Univariate Discrete Distributions, Second
#' Edition. New York: Wiley \cr 9. Zhu L.J. et al. (2010) ChIPpeakAnno: a
#' Bioconductor package to annotate ChIP-seq and ChIP-chip data. BMC
#' Bioinformatics 2010, 11:237doi:10.1186/1471-2105-11-237.\cr
#' @keywords package
#' @examples
#' 
#'  if(interactive()){
#'   data(myPeakList)
#'   library(ensembldb)
#'   library(EnsDb.Hsapiens.v75)
#'   anno <- annoGR(EnsDb.Hsapiens.v75)
#'   annotatedPeak <-
#'     annotatePeakInBatch(myPeakList[1:6], AnnotationData=anno)
#'  }
#' 
"_PACKAGE"

#' get the count for each unique GO ID
#' 
#' get the count for each unique GO ID
#' 
#' 
#' @param goList a set of GO terms as character vector
#' @return a list with 2 variables \item{GOterm}{a vector of GO terms as
#' character vector} \item{GOcount}{counts corresponding to the above GOterm as
#' numeric vector}
#' @note internal function not intended to be called directly by users
#' @author Lihua Julie Zhu
#' @seealso getEnrichedGO
#' @keywords internal
#' @export
#' @examples
#' 
#' goList= c("GO:0000075", "GO:0000082","GO:0000082","GO:0000122","GO:0000122",
#'            "GO:0000075","GO:0000082","GO:0000082","GO:0000122","GO:0000122",
#'            "GO:0000122","GO:0000122","GO:0000075", "GO:0000082","GO:000012")
#'  
#' getUniqueGOidCount(goList)
#' 
getUniqueGOidCount <-
    function(goList)
    {
        x = goList[order(goList)]
        duplicated.go<-duplicated(x)
        unique.go <- unique(x)
        go.count<- numeric()
        
        count <- 1
        j <- 1
        
        for (i in 2:length(duplicated.go))
        {
            
            if (duplicated.go[i] == FALSE)
            {
                go.count[j] <- count # previous GO
                j <- j + 1
                count <- 1
            }
            else
            {
                count <- count + 1
            }
        }
        go.count[j] <- count #last GO
        list(GOterm=unique.go, GOcount=go.count)
    }

#' Ste12-binding sites from biological replicate 1 in yeast (see reference)
#' 
#' Ste12-binding sites from biological replicate 1 in yeast (see reference)
#' 
#' 
#' @name Peaks.Ste12.Replicate1
#' @docType data
#' @format GRanges with slot names containing the ID of peak as character, slot
#' start containing the start position of the peak, slot end containing the end
#' position of the peak and space containing the chromosome where the peak is
#' located.
#' @references Philippe Lefranois, Ghia M Euskirchen, Raymond K Auerbach, Joel
#' Rozowsky, Theodore Gibson, Christopher M Yellman, Mark Gerstein and Michael
#' Snyder (2009) Efficient yeast ChIP-Seq using multiplex short-read DNA
#' sequencing BMC Genomics 10:37
#' @keywords datasets
#' @examples
#' 
#' data(Peaks.Ste12.Replicate1)
#' Peaks.Ste12.Replicate1
#' 
"Peaks.Ste12.Replicate1"

#' Ste12-binding sites from biological replicate 2 in yeast (see reference)
#' 
#' Ste12-binding sites from biological replicate 2 in yeast (see reference)
#' 
#' 
#' @name Peaks.Ste12.Replicate2
#' @docType data
#' @format GRanges with slot names containing the ID of peak as character, slot
#' start containing the start position of the peak, slot end containing the end
#' position of the peak and space containing the chromosome where the peak is
#' located.
#' @references Philippe Lefranois, Ghia M Euskirchen, Raymond K Auerbach, Joel
#' Rozowsky, Theodore Gibson, Christopher M Yellman, Mark Gerstein and Michael
#' Snyder (2009) Efficient yeast ChIP-Seq using multiplex short-read DNA
#' sequencing BMC Genomics 10:37doi:10.1186/1471-2164-10-37
#' @source http://www.biomedcentral.com/1471-2164/10/37
#' @keywords datasets
#' @examples
#' 
#' data(Peaks.Ste12.Replicate2)
#' Peaks.Ste12.Replicate2
"Peaks.Ste12.Replicate2"

#' Ste12-binding sites from biological replicate 3 in yeast (see reference)
#' 
#' Ste12-binding sites from biological replicate 3 in yeast (see reference)
#' 
#' 
#' @name Peaks.Ste12.Replicate3
#' @docType data
#' @format GRanges with slot names containing the ID of peak as character, slot
#' start containing the start position of the peak, slot end containing the end
#' position of the peak and space containing the chromosome where the peak is
#' located.
#' @references Philippe Lefranois, Ghia M Euskirchen, Raymond K Auerbach, Joel
#' Rozowsky, Theodore Gibson, Christopher M Yellman, Mark Gerstein and Michael
#' Snyder (2009) Efficient yeast ChIP-Seq using multiplex short-read DNA
#' sequencing BMC Genomics 10:37doi:10.1186/1471-2164-10-37
#' @source http://www.biomedcentral.com/1471-2164/10/37
#' @keywords datasets
#' @examples
#' 
#' data(Peaks.Ste12.Replicate3)
#' Peaks.Ste12.Replicate3
#' 
"Peaks.Ste12.Replicate3"

#' Find possible enhancers depend on DNA interaction data
#' 
#' Find possible enhancers by data from chromosome conformation capture
#' techniques such as 3C, 5C or HiC.
#' 
#' 
#' @param peaks peak list, \link[GenomicRanges:GRanges-class]{GRanges} object
#' @param annoData annotation data, \link[GenomicRanges:GRanges-class]{GRanges}
#' object
#' @param DNAinteractiveData DNA interaction data,
#' \link[GenomicRanges:GRanges-class]{GRanges} object with interaction blocks
#' informations, \link[InteractionSet:InteractionSet]{GInteractions} object, 
#' or BEDPE file which could be imported by 
#' \link[trackViewer:importGInteractions]{importGInteractions} or 
#' BiocIO::\link[BiocIO:export]{import} or assembly in following list:
#' hg38, hg19, mm10, danRer10, danRer11.
#' @param bindingType Specifying the criteria to associate peaks with
#' annotation. Here is how to use it together with the parameter bindingRegion.
#' The annotation will be shift to a new position depend on the DNA interaction
#' region.  \itemize{ \item To obtain peaks within 5kb upstream and up to 3kb
#' downstream of shift TSS within the gene body, set bindingType = "startSite"
#' and bindingRegion = c(-5000, 3000) \item To obtain peaks up to 5kb upstream
#' within the gene body and 3kb downstream of shift gene/Exon End, set
#' bindingType = "endSite" and bindingRegion = c(-5000, 3000) \item To obtain
#' peaks with nearest bi-directional enhancer regions within 5kb upstream and
#' 3kb downstream of shift TSS, set bindingType =
#' "nearestBiDirectionalPromoters" and bindingRegion = c(-5000, 3000) }
#' \describe{ \item{startSite}{start position of the feature (strand is
#' considered)} \item{endSite}{end position of the feature (strand is
#' considered)} \item{nearestBiDirectionalPromoters}{nearest enhancer regions
#' from both direction of the peaks (strand is considered). It will report
#' bidirectional enhancer regions if there are enhancer regions in both
#' directions in the given region (defined by bindingRegion). Otherwise, it
#' will report the closest enhancer regions in one direction.} }
#' @param bindingRegion Annotation range used together with bindingType, which
#' is a vector with two integer values, default to c (-5000, 5000). The first
#' one must be no bigger than 0. And the sec ond one must be no less than 1.
#' For details, see bindingType.
#' @param ignore.peak.strand ignore the peaks strand or not.
#' @param ...  Not used.
#' @return Output is a GRanges object of the annotated peaks.
#' @author Jianhong Ou
#' @seealso See Also as \code{\link{annotatePeakInBatch}}
#' @keywords misc
#' @export
#' @import IRanges
#' @import GenomicRanges
#' @importFrom InteractionSet GInteractions
#' @importMethodsFrom S4Vectors first second
#' @importFrom GenomeInfoDb seqlevelsStyle
#' @importFrom BiocGenerics start end width strand
#' @importFrom S4Vectors elementNROWS mcols queryHits subjectHits
#' @examples
#' 
#'   bed <- system.file("extdata", 
#'                      "wgEncodeUmassDekker5CGm12878PkV2.bed.gz",
#'                      package="ChIPpeakAnno")
#'   DNAinteractiveData <- toGRanges(gzfile(bed))
#'   library(EnsDb.Hsapiens.v75)
#'   annoData <- toGRanges(EnsDb.Hsapiens.v75, feature="gene")
#'   data("myPeakList")
#'   findEnhancers(myPeakList[500:1000], annoData, DNAinteractiveData)
#'   
findEnhancers <- function(peaks, annoData, DNAinteractiveData, 
                    bindingType=c("nearestBiDirectionalPromoters",
                                  "startSite", "endSite"), 
                    bindingRegion=c(-5000, 5000), 
                    ignore.peak.strand=TRUE, ...){
    stopifnot(inherits(peaks, "GRanges"))
    stopifnot(inherits(annoData, c("annoGR", "GRanges")))
    stopifnot(length(intersect(seqlevelsStyle(peaks),
                               seqlevelsStyle(annoData)))>0)
    bindingType <- match.arg(bindingType)
    stopifnot(length(bindingRegion)==2)
    stopifnot(bindingRegion[1]<=0 && bindingRegion[2]>=1)
    
    if(inherits(annoData, "annoGR")){
        annoData <- as(annoData, "GRanges")
    }
    
    peaks$peak.oid.to.be.deleted <- 1:length(peaks)
    
    if(inherits(DNAinteractiveData, "GRanges")){
        stopifnot(length(DNAinteractiveData$blocks)>0)
        stopifnot(all(elementNROWS(DNAinteractiveData$blocks)==2))
        stopifnot(length(intersect(seqlevelsStyle(peaks),
                                   seqlevelsStyle(DNAinteractiveData)))>0)
        HiC_FIRST <- lapply(DNAinteractiveData$blocks, `[`, 1)
        HiC_SECOND <- lapply(DNAinteractiveData$blocks, `[`, 2)
        HiC_FIRST <- unlist(IRangesList(HiC_FIRST))
        HiC_SECOND <- unlist(IRangesList(HiC_SECOND))
        ## BED file blocks are half open half close.
        HiC_FIRST <- shift(HiC_FIRST, start(DNAinteractiveData)-1)
        HiC_SECOND <- shift(HiC_SECOND, start(DNAinteractiveData)-1)
        HiC_FIRST_GR <- HiC_SECOND_GR <- DNAinteractiveData
        ranges(HiC_FIRST_GR) <- HiC_FIRST
        ranges(HiC_SECOND_GR) <- HiC_SECOND
    }
    ## TODO
    # if(is.character(DNAinteractiveData)){ 
    #     if(DNAinteractiveData %in% c("hg38", "hg19", "mm10", 
    #                                  "danRer10", "danRer11")){
    #         DNAinteractiveData <- 
    #             readRDS(system.file("extdata", 
    #                                 paste0(DNAinteractiveData, 
    #                                        "interactions.rds"),
    #                                 package = "ChIPpeakAnno",
    #                                 mustWork = TRUE))
    #     }else{
    #         DNAinteractiveData <- toGInteractions(DNAinteractiveData)
    #     }
    # }
    if(inherits(DNAinteractiveData, c("GInteractions", "Pairs"))){
        HiC_FIRST_GR <- first(DNAinteractiveData)
        HiC_SECOND_GR <- second(DNAinteractiveData)
        stopifnot("seqlevels style of peaks and interaction data are different"=
                      length(intersect(seqlevelsStyle(peaks),
                                   seqlevelsStyle(HiC_FIRST_GR)))>0)
        stopifnot("seqlevels style of peaks and interaction data are different"=
                      length(intersect(seqlevelsStyle(peaks),
                                       seqlevelsStyle(HiC_SECOND_GR)))>0)
    }
    # peaks overlap with interaction region A_B, C_D
    # in upstream A, A_B, B_C, C_D, downstream D.
    HiC.A.ups <- shift(HiC_FIRST_GR, -max(abs(bindingRegion)))
    width(HiC.A.ups) <- max(abs(bindingRegion))
    HiC.D.dws <- shift(HiC_SECOND_GR, max(abs(bindingRegion)))
    start(HiC.D.dws) <- end(HiC_SECOND_GR) + 1
    HiC.BC <- HiC_SECOND_GR
    start(HiC.BC) <- end(HiC_FIRST_GR) + 1
    end(HiC.BC) <- start(HiC_SECOND_GR) - 1
    HiC.groups <- list(A.ups=HiC.A.ups,
                       AB=HiC_FIRST_GR,
                       BC=HiC.BC,
                       CD=HiC_SECOND_GR,
                       D.dws=HiC.D.dws)
    peaks.ol.HiCdata <- lapply(HiC.groups, function(hic){
        ol <- findOverlaps(peaks, hic)
        this.peaks <- peaks[queryHits(ol)]
        this.peaks$HiC.idx <- subjectHits(ol)
        this.peaks
    })
    if(all(elementNROWS(peaks.ol.HiCdata)==0)){## not in interaction region
        return(GRanges())
    }
    ## refine annoData by HiCdata
    anno.ol.HiCdata <- lapply(HiC.groups, function(hic){
        ol <- findOverlaps(annoData, hic)
        annoData.ol.HiC <- annoData[queryHits(ol)]
        annoData.ol.HiC.pos <- 
            switch(bindingType,
                   nearestBiDirectionalPromoters={
                       promoters(annoData.ol.HiC, upstream=0, downstream=1)
                   },
                   startSite={
                       promoters(annoData.ol.HiC, upstream=0, downstream=1)
                   }, 
                   endSite={
                       tmp <- annoData.ol.HiC
                       strand(tmp) <- ifelse(strand(tmp)=="-", "+", "-")
                       promoters(tmp, upstream=0, downstream=1)
                   },
                   stop("Not supported binding type", bindingType))
        HiC_FIRST_GR.anno <- HiC_FIRST_GR[subjectHits(ol)]
        HiC_SECOND_GR.anno <- HiC_SECOND_GR[subjectHits(ol)]
        annoData.ol.HiC$point_A <- start(HiC_FIRST_GR.anno)
        annoData.ol.HiC$point_B <- end(HiC_FIRST_GR.anno)
        annoData.ol.HiC$point_C <- start(HiC_SECOND_GR.anno)
        annoData.ol.HiC$point_D <- end(HiC_SECOND_GR.anno)
        annoData.ol.HiC$point_X <- start(annoData.ol.HiC.pos)
        annoData.ol.HiC$HiC.idx <- subjectHits(ol)
        annoData.ol.HiC
    })
    if(all(elementNROWS(anno.ol.HiCdata)==0)){
        return(GRanges())
    }
    HiC.idx.peaks <- unique(unlist(lapply(peaks.ol.HiCdata, 
                                          function(.ele) .ele$HiC.idx), 
                                   use.names = FALSE))
    HiC.idx.anno <- unique(unlist(lapply(anno.ol.HiCdata, 
                                         function(.ele) .ele$HiC.idx),
                                  use.names = FALSE))
    HiC.idx <- intersect(HiC.idx.peaks, HiC.idx.anno)
    if(length(HiC.idx)==0){
        return(GRanges())
    }
    anno.refined <- list()
    rotate.gr <- function(gr, anchor){
        strand(gr) <- ifelse(strand(gr)=="-", "+", "-")
        off.pos <- end(gr) > anchor
        start(gr[off.pos]) <- anchor[off.pos] - width(gr[off.pos])
        end(gr[off.pos]) <- anchor[off.pos]
        end(gr[!off.pos]) <- anchor[!off.pos] + width(gr[!off.pos])
        start(gr[!off.pos]) <- anchor[!off.pos]
        gr
    }
    rev.gr <- function(gr, p1, p2, px){
        tmp.shift <- p1 + p2 - 2*px
        tmp <- shift(gr, shift=tmp.shift)
        rotate.gr(tmp, px + tmp.shift)
    }
    addListInfo <- function(l, info, infoname){
        lapply(l, function(.ele){
            if(length(.ele)>0)
                mcols(.ele)[, infoname] <- rep(info, length(.ele))
            .ele
        })
    }
    unList1level <- function(l){
        l.offs <- unique(unlist(lapply(l, names)))
        sapply(l.offs, function(.ele){
            .ele <- lapply(l, `[[`, .ele)
            .ele <- .ele[sapply(.ele, length)>0]
            if(length(.ele)>0) unlist(GRangesList(.ele), use.names = FALSE)
            else NULL
        }, simplify = FALSE)
    }
    
    for(i in seq_along(anno.ol.HiCdata)){
        this.name <- names(anno.ol.HiCdata)[i]
        this.data <- anno.ol.HiCdata[[i]]
        this.data <- this.data[this.data$HiC.idx %in% HiC.idx]
        if(length(this.data)>0){
            AC.rev <- rev.gr(this.data, this.data$point_C,
                             this.data$point_A, this.data$point_X)
            AC <- shift(this.data, shift=this.data$point_C - this.data$point_A)
            CA <- shift(this.data, shift=this.data$point_A - this.data$point_C)
            AD.rev <- rev.gr(this.data, this.data$point_D,
                             this.data$point_A, this.data$point_X)
            AD <- shift(this.data, shift=this.data$point_D - this.data$point_A)
            DA <- shift(this.data, shift=this.data$point_A - this.data$point_D)
            BC.rev <- rev.gr(this.data, this.data$point_C,
                             this.data$point_B, this.data$point_X)
            BC <- shift(this.data, shift=this.data$point_C - this.data$point_B)
            CB <- shift(this.data, shift=this.data$point_B - this.data$point_C)
            BD.rev <- rev.gr(this.data, this.data$point_D,
                             this.data$point_B, this.data$point_X)
            BD <- shift(this.data, shift=this.data$point_D - this.data$point_B)
            DB <- shift(this.data, shift=this.data$point_B - this.data$point_D)
            shiftAnn <- 
                switch(this.name,
                       A.ups=list(AC=list(A.ups=NULL, 
                                          AB=AC.rev, 
                                          BC=AC.rev,
                                          CD=AC, 
                                          D.dws=AC),
                                  AD=list(A.ups=NULL, 
                                          AB=AD.rev,
                                          BC=AD.rev,
                                          CD=AD.rev,
                                          D.dws=AD),
                                  BC=list(A.ups=NULL, 
                                          AB=NULL,
                                          BC=BC.rev,
                                          CD=BC,
                                          D.dws=BC),
                                  BD=list(A.ups=NULL, 
                                          AB=NULL,
                                          BC=BD.rev,
                                          CD=BD.rev,
                                          D.dws=BD)),
                       AB=list(AC=list(A.ups=AC.rev, 
                                       AB=c(AC, CA), 
                                       BC=AC,
                                       CD=AC.rev, 
                                       D.dws=AC.rev),
                               AD=list(A.ups=AD.rev, 
                                       AB=c(AD, DA),
                                       BC=AD,
                                       CD=AD,
                                       D.dws=AD.rev),
                               BC=list(A.ups=NULL, 
                                       AB=NULL,
                                       BC=BC.rev,
                                       CD=BC,
                                       D.dws=BC),
                               BD=list(A.ups=NULL, 
                                       AB=NULL,
                                       BC=BD.rev,
                                       CD=BD.rev,
                                       D.dws=BD)),
                       BC=list(AC=list(A.ups=AC.rev, 
                                       AB=CA, 
                                       BC=c(AC, CA),
                                       CD=AC.rev, 
                                       D.dws=AC.rev),
                               AD=list(A.ups=AD.rev, 
                                       AB=DA,
                                       BC=c(AD, DA),
                                       CD=AD,
                                       D.dws=AD.rev),
                               BC=list(A.ups=BC.rev, 
                                       AB=BC.rev,
                                       BC=c(BC, CB),
                                       CD=BC.rev,
                                       D.dws=BC.rev),
                               BD=list(A.ups=BD.rev, 
                                       AB=BD.rev,
                                       BC=c(BD, DB),
                                       CD=BD,
                                       D.dws=BD.rev)),
                       CD=list(AC=list(A.ups=CA,
                                       AB=AC.rev,
                                       BC=AC.rev,
                                       CD=NULL,
                                       D.dws=NULL),
                               AD=list(A.ups=AD.rev,
                                       AB=DA,
                                       BC=DA,
                                       CD=c(AD, DA),
                                       D.dws=AD.rev),
                               BC=list(A.ups=CB,
                                       AB=CB,
                                       BC=BC.rev,
                                       CD=NULL, 
                                       D.dws=NULL),
                               BD=list(A.ups=BD.rev,
                                       AB=BD.rev,
                                       BC=DB,
                                       CD=c(BD, DB), 
                                       D.dws=BD.rev)),
                       D.dws=list(AC=list(A.ups=CA,
                                          AB=AC.rev,
                                          BC=AC.rev,
                                          CD=NULL,
                                          D.dws=NULL),
                                  AD=list(A.ups=DA,
                                          AB=AD.rev,
                                          BC=AD.rev,
                                          CD=AD.rev,
                                          D.dws=NULL),
                                  BC=list(A.ups=CB,
                                          AB=CB,
                                          BC=BC.rev,
                                          CD=NULL, 
                                          D.dws=NULL),
                                  BD=list(A.ups=DB,
                                          AB=DB,
                                          BC=BD.rev,
                                          CD=BD.rev, 
                                          D.dws=NULL)))
            shiftAnn <- 
                mapply(addListInfo, 
                       shiftAnn, names(shiftAnn), 
                       infoname="cross.link.region",
                       SIMPLIFY = FALSE)
            anno.refined[[this.name]] <- unList1level(shiftAnn)
        }
    }
    anno.refined <- 
        mapply(addListInfo, 
               anno.refined, names(anno.refined), 
               infoname="raw.annotation.region",
               SIMPLIFY = FALSE)
    anno.refined <- unList1level(anno.refined)
    anno.refined <- anno.refined[names(peaks.ol.HiCdata)]
    enhancer <- mapply(function(.anno, .peaks){
        ol.HiC.idx <- intersect(.peaks$HiC.idx, .anno$HiC.idx)
        if(length(ol.HiC.idx)==0) return(NULL)
        annot <- lapply(ol.HiC.idx, function(.HiC.id){
            .a <- .anno[.anno$HiC.idx == .HiC.id]
            .p <- .peaks[.peaks$HiC.idx == .HiC.id]
            annoPeaks(.p, .a, bindingType = bindingType,
                      bindingRegion = bindingRegion,
                      ignore.peak.strand = ignore.peak.strand)
        })
        annot <- annot[sapply(annot, length)>0]
        if(length(annot)==0) return(NULL)
        annot <- unlist(GRangesList(annot))
        colnames(mcols(annot)) <- 
            gsub("feature\\.", "feature.shift.", colnames(mcols(annot)))
        annot
    }, anno.refined, peaks.ol.HiCdata, SIMPLIFY = FALSE)
    enhancer <- enhancer[sapply(enhancer, length)>0]
    if(length(enhancer)==0) return(GRanges())
    enhancer <- mapply(function(.a, .n){
        mcols(.a)[, "peak.annotation.region"] <- .n
        .a
    }, enhancer, names(enhancer), SIMPLIFY = FALSE)
    enhancer <- unlist(GRangesList(enhancer), use.names = FALSE)
    enhancer$feature.ranges <- ranges(annoData[enhancer$feature])
    enhancer$feature.strand <- strand(annoData[enhancer$feature])
    ncols <- ncol(mcols(enhancer))
    feature.col.id <- which(colnames(mcols(enhancer))=="feature")
    mcols(enhancer) <- mcols(enhancer)[, c(1:(feature.col.id-2), feature.col.id,
                                           ncols-1, ncols, 
                                           (feature.col.id+1):(ncols-2), 
                                           feature.col.id-1)]
    enhancer$point_X <- NULL
    enhancer$HiC.idx.1 <- NULL
    colnames(mcols(enhancer)) <- 
        gsub("point_", "DNAinteractive_point_", colnames(mcols(enhancer)))
    colnames(mcols(enhancer)) <- 
        gsub("HiC", "DNAinteractive", colnames(mcols(enhancer)))
    peak.gpid <- rle(enhancer$peak.oid.to.be.deleted)
    peak.gpid$values <- seq_along(peak.gpid$values)
    peak.gpid <- inverse.rle(peak.gpid)
    enhancer <- enhancer[order(peak.gpid, enhancer$distance)]
    enhancer <- enhancer[!duplicated(paste(enhancer$feature, enhancer$peak))]
    enhancer$peak.oid.to.be.deleted <- NULL
    enhancer$DNAinteractive.ranges <- 
        ranges(DNAinteractiveData[enhancer$DNAinteractive.idx])
    enhancer$DNAinteractive.blocks <- 
        DNAinteractiveData[enhancer$DNAinteractive.idx]$blocks
    enhancer$DNAinteractive_point_A <- NULL
    enhancer$DNAinteractive_point_B <- NULL
    enhancer$DNAinteractive_point_C <- NULL
    enhancer$DNAinteractive_point_D <- NULL
    enhancer$cross.link.region <- NULL
    enhancer$raw.annotation.region <- NULL
    enhancer$peak.annotation.region <- NULL
    enhancer$DNAinteractive.idx <- NULL
    enhancer
}

test_that("findEnhancers works not correct", {
    ## expect GRanges()
    DNAinteractiveData <- GRanges("chr1", IRanges(100, 1500), 
                                  blocks=IRangesList(IRanges(c(1, 901), 
                                                             c(101, 1401))))
    peaks <- GRanges("chr1", IRanges(c(50, 150, 250, 950, 1050, 1450, 1550), 
                                    width=10, names=letters[1:7]))
    anno <- GRanges("chr1", IRanges(c(40, 1560), width=10, names=LETTERS[1:2]),
                    strand=c("-", "+"))
    enhancers <- findEnhancers(peaks, anno, DNAinteractiveData,
                                bindingType="nearestBiDirectionalPromoters",
                                bindingRegion=c(-120, 120),
                                ignore.peak.strand = TRUE)
    expect_equal(letters[1:7], enhancers$peak)
    expect_equal(c(100, 100, 109, 91, 100, 91, 100), enhancers$distance)
})

#' hypergeometric test
#' 
#' hypergeometric test with lower.tail = FALSE used by getEnrichedGO
#' 
#' see phyper for details
#' 
#' @param alltermcount a list with two variables: GOterm and GOcount which is
#' GO terms and corresponding counts in the whole genome
#' @param thistermcount a list with two variables: GOterm and GOcount which is
#' GO terms and corresponding counts in the peak list
#' @param totaltermInGenome number of total GO terms in the whole genome
#' @param totaltermInPeakList number of total GO terms in the peak list
#' @return a list with 6 variables \item{thisterm}{GO term}
#' \item{thistermcount}{count of this GO term in the peak list}
#' \item{thistermtotal}{count of this GO term in the whole genome}
#' \item{pvalue}{pvalue of the hypergeometric test}
#' \item{totaltermInPeakList}{number of total GO terms in the peak list}
#' \item{totaltermInGenome}{number of total GO terms in the whole genome}
#' @note internal function not intended to be used directly by users
#' @author Lihua Julie ZHu
#' @seealso phyper, getEnrichedGO
#' @references Johnson, N. L., Kotz, S., and Kemp, A. W. (1992) Univariate
#' Discrete Distributions, Second Edition. New York: Wiley
#' @keywords internal
#' @export
#' @importFrom stats phyper
#' @examples
#' 
#' goList= c("GO:0000075", "GO:0000082","GO:0000082","GO:0000122",
#'           "GO:0000122","GO:0000075","GO:0000082","GO:0000082",
#'           "GO:0000122","GO:0000122","GO:0000122","GO:0000122",
#'           "GO:0000075", "GO:0000082","GO:000012")
#'   
#' alltermcount = list(GOterm=c("GO:0000075", "GO:0000082", "GO:000012", 
#'                              "GO:0000122"), 
#'                     GOcount=c(100, 200, 10, 10))
#' thistermcount = getUniqueGOidCount(goList)
#' totaltermInPeakList = 15
#' totaltermInGenome = 1000
#' hyperGtest(alltermcount,thistermcount, totaltermInGenome, totaltermInPeakList)
#' 
hyperGtest <- function(alltermcount,thistermcount, 
                       totaltermInGenome, totaltermInPeakList){
    pvalue = as.numeric()
    thistermtotal = as.numeric()
    for (i in 1:length(thistermcount$GOterm))
    {
        m = 
            as.numeric(alltermcount$GOcount[alltermcount$GOterm==
                                                thistermcount$GOterm[i]])
        q = as.numeric(thistermcount$GOcount[i])
        n = as.numeric(totaltermInGenome)
        k = as.numeric(totaltermInPeakList)
        ####### k - number of total GO terms in the peak list
        ####### n - number of GO terms total
        ####### q - number of this GO terms in the peak list
        ####### m - number of this GO terms total
        pvalue[i] = phyper(q-1, m, n-m, k, lower.tail = FALSE, log.p = FALSE)
        thistermtotal[i] = m
    }
    list(thisterm=thistermcount$GOterm, 
         thistermcount=thistermcount$GOcount,
         thistermtotal=thistermtotal, 
         pvalue=pvalue, 
         totaltermInPeakList=k, 
         totaltermInGenome=n)
}

#' Permutation Test for two given peak lists
#' 
#' Performs a permutation test to seee if there is an association between two
#' given peak lists.
#' 
#' 
#' @param peaks1,peaks2 an object of
#' \link[GenomicRanges:GRanges-class]{GRanges}
#' @param ntimes number of permutations
#' @param seed random seed
#' @param mc.cores The number of cores to use. see mclapply.
#' @param maxgap See \link[IRanges:findOverlaps-methods]{findOverlaps} in the
#' IRanges package for a description of these arguments.
#' @param pool an object of \link{permPool}
#' @param TxDb an object of \link[GenomicFeatures:TxDb-class]{TxDb}
#' @param bindingDistribution an object of \link{bindist}
#' @param bindingType where the peaks should bind, TSS or geneEnd
#' @param featureType what annotation type should be used for detecting the
#' binding distribution.
#' @param seqn default is NA, which means not filter the universe pool for
#' sampling.  Otherwise the universe pool will be filtered by the seqnames in
#' seqn.
#' @param \dots further arguments to be passed to \link[regioneR]{numOverlaps}.
#' @return A list of class permTestResults. See \link[regioneR]{permTest}
#' @author Jianhong Ou
#' @seealso \link{preparePool}, \link{bindist}
#' @references Davison, A. C. and Hinkley, D. V. (1997) Bootstrap methods and
#' their application, Cambridge University Press, United Kingdom, 156-160
#' @keywords misc
#' @export
#' @importFrom regioneR permTest numOverlaps
#' @examples
#' 
#'     path <- system.file("extdata", package="ChIPpeakAnno")
#'     #files <- dir(path, pattern="[12]_WS170.bed", full.names=TRUE)
#'     #peaks1 <- toGRanges(files[1], skip=5)
#'     #peaks2 <- toGRanges(files[2], skip=5)
#'     #peakPermTest(peaks1, peaks2, TxDb=TxDb.Celegans.UCSC.ce6.ensGene)
#'     if(interactive()){
#'         peaks1 <- toGRanges(file.path(path, "MACS2_peaks.xls"), 
#'                             format="MACS2")
#'         peaks2 <- toGRanges(file.path(path, "peaks.narrowPeak"), 
#'                             format="narrowPeak")
#'         library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#'         peakPermTest(peaks1, peaks2, 
#'                TxDb=TxDb.Hsapiens.UCSC.hg19.knownGene, min.pctA=10)
#'     }
#' 
peakPermTest <- function(peaks1, peaks2, ntimes=100, 
                         seed=as.integer(Sys.time()),
                         mc.cores=getOption("mc.cores", 2L),
                         maxgap=-1L, pool,
                         TxDb, bindingDistribution,
                         bindingType=c("TSS", "geneEnd"), 
                         featureType=c("transcript", "exon"),
                         seqn=NA, ...){
    if(!is(peaks1, "GRanges") || !is(peaks2, "GRanges")){
        stop("peaks1 and peaks2 must be GRanges objects.")
    }
    if(!missing(bindingDistribution)){
        if(!is(bindingDistribution, "bindist")){
            stop("bindingDistribution must be an object of bindist")
        }
    }
    bindingType <- match.arg(bindingType)
    featureType <- match.arg(featureType)
    if(missing(pool)){
        pool <- preparePool(TxDb, template=peaks1, 
                            bindingDistribution=bindingDistribution, 
                            bindingType=bindingType, 
                            featureType=featureType, seqn=seqn)
    }else{
        if(!is(pool, "permPool")){
            stop("pool must be a permPool object")
        }
    }
    set.seed(seed)
    pt <- permTest(A=peaks1, ntimes=ntimes,
                   randomize.function=randPeaks, 
                   grs=pool$grs, N=pool$N, 
                   maxgap=maxgap,
                   evaluate.function=cntOverlaps, 
                   B=peaks2, verbose=FALSE, alternative="greater", 
                   mc.set.seed=FALSE, mc.cores=mc.cores,
                   ...)
    return(pt)
}

#' Obtain the TSS, exon or miRNA annotation for the specified species
#' 
#' Obtain the TSS, exon or miRNA annotation for the specified species using the
#' biomaRt package
#' 
#' 
#' @param mart A mart object, see useMart of biomaRt package for details.
#' @param featureType TSS, miRNA, Exon, 5'UTR, 3'UTR, transcript or Exon plus
#' UTR. The default is TSS.
#' @return \link[GenomicRanges:GRanges-class]{GRanges} with slot start holding
#' the start position of the feature, slot end holding the end position of the
#' feature, slot names holding the id of the feature, slot space holding the
#' chromosome location where the feature is located. In addition, the following
#' variables are included.  \item{list("strand")}{1 for positive strand and -1
#' for negative strand where the feature is located}
#' \item{list("description")}{description of the feeature such as gene}
#' @note For featureType of TSS, start is the transcription start site if
#' strand is 1 (plus strand), otherwise, end is the transcription start site.
#' \cr\cr
#' Note that the version of the annotation db must match with the genome used
#' for mapping because the coordinates may differ for different genome releases.
#'  For example, if you are using Mus_musculus.v103 for mapping, 
#'  you'd best also use EnsDb.Mmusculus.v103 for annotation. 
#'  See Examples for more info.
#' @author Lihua Julie Zhu, Jianhong Ou, Kai Hu
#' @references Durinck S. et al. (2005) BioMart and Bioconductor: a powerful
#' link between biological biomarts and microarray data analysis.
#' Bioinformatics, 21, 3439-3440.
#' @keywords misc
#' @export
#' @import GenomicRanges
#' @importFrom biomaRt getBM
#' @examples
#' 
#' if (interactive() || Sys.getenv("USER")=="jou" )
#' {
#'   library(biomaRt)
#'   mart <- useMart(biomart="ensembl", dataset="hsapiens_gene_ensembl")
#'   Annotation <- getAnnotation(mart, featureType="TSS")
#' }
#' 
#' ##########################################################
#' #  Below are 3 options to fetch the annotation file.     #
#' ##########################################################
#' if (interactive() || Sys.getenv("USER")=="jou" ){
#' ## Option1: with the AnnotationHub package
#' library(AnnotationHub)
#' ah <- AnnotationHub()
#' EnsDb.Mmusculus <- query(ah, pattern = c("Mus musculus", "EnsDb"))
#' EnsDb.Mmusculus.v101 <- EnsDb.Mmusculus[[length(EnsDb.Mmusculus)]]
#' class(EnsDb.Mmusculus.v101)
#' 
#' ## Option2: with the getAnnotation() function
#' library(ChIPpeakAnno)
#' library(biomaRt)
#' listMarts()
#' mart <- useMart(biomart="ENSEMBL_MART_ENSEMBL", 
#'                 dataset="mmusculus_gene_ensembl")
#' Annotation <- getAnnotation(mart)
#' # Note that getAnnotation() queries biomart, which is always up-to-date.
#' 
#' ## Option3: build your own EnsDb package
#' ## This may need extra effort, and the ?makeEnsembldbPackage 
#' ## is a good starting point.
#' }


getAnnotation <- function(mart, 
                          featureType=c("TSS","miRNA", "Exon", 
                                        "5utr", "3utr", 
                                        "ExonPlusUtr", "transcript")){
    featureType = match.arg(featureType)
    if (missing(mart) || !is(mart, "Mart"))
    {
        stop("No valid mart object is passed in!")
    }
    if(featureType=="miRNA"){
        TSS = getBM(c("ensembl_gene_id","chromosome_name", "start_position", 
                      "end_position",  "strand", "description", "gene_biotype"), 
                    filters=c("biotype"),values="miRNA", mart = mart)
    }else{
        seqnames <- getBM(c("chromosome_name"), mart = mart)
        seqnames <- as.character(seqnames[, "chromosome_name"])
        TSS <- lapply(seqnames, function(.ele){
            attr <- switch(featureType, 
                           TSS=c("ensembl_gene_id", "chromosome_name", 
                                 "start_position", "end_position", 
                                 "strand", "description"),
                           Exon=c("ensembl_exon_id","chromosome_name", 
                                  "exon_chrom_start", "exon_chrom_end", 
                                  "strand", "description"),
                           "5utr"=c("ensembl_transcript_id", "chromosome_name", 
                                    "5_utr_start", "5_utr_end", "strand", 
                                    "description"),
                           "3utr"=c("ensembl_transcript_id", "chromosome_name", 
                                    "3_utr_start", "3_utr_end", "strand", 
                                    "description"),
                           ExonPlusUtr=c('ensembl_exon_id','chromosome_name', 
                                         'exon_chrom_start','exon_chrom_end', 
                                         'strand', 'ensembl_gene_id', 
                                         '5_utr_start', '5_utr_end',
                                         '3_utr_start','3_utr_end', 
                                         'description'),
                           transcript=c("ensembl_transcript_id", 
                                        "chromosome_name", 
                                        "transcript_start", "transcript_end", 
                                        'strand', 'description', 
                                        'ensembl_gene_id')
            )
            getBM(attributes=attr, filters="chromosome_name",
                  values=.ele, mart=mart)
        })
        TSS <- do.call(rbind, TSS)
    }
    
    TSS <- TSS[!is.na(TSS[, 3]), ]
    TSS = unique(TSS)
    TSS = TSS[order(TSS[,3]),]        
    duplicatedID = TSS[duplicated(TSS[,1]),1]
    TSS = TSS[!duplicated(TSS[,1]),]
    if (length(duplicatedID) >0 && 
        featureType != "3utr" && 
        featureType != "5utr" && 
        featureType != "ExonPlusUtr")
    {
        warning("Following duplicated IDs found, 
                only one of entries of the duplicated id will be returned!")
        warning(duplicatedID)
    }
    if (featureType == "ExonPlusUtr")
    {
        re <- GRanges(seqnames = as.character(TSS[,2]),
                      IRanges(start=as.numeric(as.character(TSS[,3])),
                              end = as.numeric(as.character(TSS[,4])),
                              names= make.names(as.character(TSS[,1]), 
                                                unique = TRUE)),
                      ensembl_exon_id = as.character(TSS[,1]),
                      ensembl_gene_id = as.character(TSS[,6]),
                      utr5start =  as.numeric(as.character(TSS[,7])),
                      utr5end =  as.numeric(as.character(TSS[,8])),
                      utr3start =  as.numeric(as.character(TSS[,9])),
                      utr3end =  as.numeric(as.character(TSS[,10])),
                      strand = TSS[,5],
                      description=as.character(TSS[,11]))
    }
    else if (featureType == "transcript")
    {
        re <- GRanges(seqnames = as.character(TSS[,2]),
                      IRanges(start=as.numeric(TSS[,3]), 
                              end=as.numeric(TSS[,4]), 
                              names= as.character(TSS[,1])), 
                      strand = TSS[,5],   
                      description=as.character(TSS[,6]), 
                      ensembl_gene_id=as.character(TSS[,7]))
    }
    else if (featureType == "5utr" || featureType == "3utr")
    {
        re <- GRanges(seqnames = as.character(TSS[,2]),
                      IRanges(start=as.numeric(TSS[,3]), 
                              end=as.numeric(TSS[,4]), 
                              names=make.names(as.character(TSS[,1]),
                                               unique = TRUE)), 
                      strand = TSS[,5],   
                      description=as.character(TSS[,6]), 
                      ensembl_transcript_id = as.character(TSS[,1]))
    }
    else
    {
        re <- GRanges(seqnames = as.character(TSS[,2]),
                      IRanges(start=as.numeric(TSS[,3]),
                              end=as.numeric(TSS[,4]), 
                              names= as.character(TSS[,1])), 
                      strand = TSS[,5],   
                      description=as.character(TSS[,6]))
    }
    re
}

test_that("getAnnotation works not correct", {
    #GRanges
    if(interactive()){
        mart<-useMart(biomart="ensembl",dataset="hsapiens_gene_ensembl")
        Annotation = getAnnotation(mart, featureType="TSS")
    }
})

#' Add metadata of the GRanges objects used for findOverlapsOfPeaks
#' 
#' Add metadata to to overlapping peaks after calling findOverlapsOfPeaks.
#' 
#' 
#' @param ol An object of overlappingPeaks, which is output of
#' \link{findOverlapsOfPeaks}.
#' @param colNames Names of metadata column to be added. If it is NULL,
#' addMetadata will guess what to add.
#' @param FUN A function to be called
#' @param ...  Arguments to the function call.
#' @return return value is An object of \link{overlappingPeaks}.
#' @export
#' @importFrom S4Vectors mcols aggregate
#' @author Jianhong Ou
#' @seealso See Also as \code{\link{findOverlapsOfPeaks}}
#' @keywords misc
#' @examples
#' 
#' peaks1 <- GRanges(seqnames=c(6,6,6,6,5),
#'                  IRanges(start=c(1543200,1557200,1563000,1569800,167889600),
#'                          end=c(1555199,1560599,1565199,1573799,167893599),
#'                          names=c("p1","p2","p3","p4","p5")),
#'                  strand="+",
#'                  score=1:5, id=letters[1:5])
#' peaks2 <- GRanges(seqnames=c(6,6,6,6,5),
#'                   IRanges(start=c(1549800,1554400,1565000,1569400,167888600),
#'                           end=c(1550599,1560799,1565399,1571199,167888999),
#'                           names=c("f1","f2","f3","f4","f5")),
#'                   strand="+",
#'                   score=6:10, id=LETTERS[1:5])
#' ol <- findOverlapsOfPeaks(peaks1, peaks2)
#' addMetadata(ol)
#' 
addMetadata <- function(ol, colNames=NULL, FUN=c, ...){
    stopifnot(class(ol)=="overlappingPeaks")
    stopifnot(length(ol$all.peaks)>0)
    PeaksList <- ol$all.peaks
    if(length(colNames)==0){
        colNames <- lapply(PeaksList, function(.ele) colnames(mcols(.ele)))
        colNames <- table(unlist(colNames))
        colNames <- names(colNames)[colNames==length(PeaksList)]
    }
    stopifnot(is.character(colNames))
    stopifnot(length(colNames)>0)
    stopifnot(is.function(FUN))
    for(i in 1:length(PeaksList)){
        if(!all(colNames %in% colnames(mcols(PeaksList[[i]])))){
            stop(paste("colNames: ", 
                       paste(colNames[!colNames %in% 
                                          colnames(mcols(PeaksList[[i]]))], 
                             collapse=", "),
                       "does not exist in the metadata of all the list."))
        }
    }
    PeaksList <- lapply(PeaksList, function(.ele) .ele[, colNames])
    cl <- lapply(PeaksList, function(.ele) sapply(mcols(.ele), class))
    for(i in 2:length(cl)){
        if(!identical(cl[[1]], cl[[i]])){
            stop("class of metadata are not identical.")
        }
    }
    Peaks <- unlist(GRangesList(PeaksList), use.names = FALSE)
    ol$peaklist <- lapply(ol$peaklist, function(.ele){
        .mcols <- aggregate(mcols(Peaks[unlist(.ele$peakNames)]), 
                            by=list(
                                addMetatdata_group=
                                    rep(seq_along(.ele), 
                                        lengths(.ele$peakNames))), 
                            FUN=FUN, ...)
        .mcols <- .mcols[order(.mcols$addMetatdata_group), ]
        .n <- ncol(mcols(.ele))
        mcols(.ele) <- cbind(mcols(.ele), .mcols[, colNames])
        if(.n>0){
          colnames(mcols(.ele))[-seq.int(.n)] <- colNames
        }else{
          colnames(mcols(.ele)) <- colNames
        }
        .ele
    })
    ol
}

#' Find the overlapped peaks among two or more set of peaks.
#' 
#' Find the overlapping peaks for two or more (less than five) set of peak
#' ranges.
#' 
#' Efficiently perform overlap queries with an interval tree implemented with
#' GRanges.
#' 
#' @aliases findOverlapsOfPeaks overlappingPeaks overlappingPeaks-class
#' @param \dots Objects of \link[GenomicRanges:GRanges-class]{GRanges}: See
#' example below.
#' @param maxgap,minoverlap Used in the internal call to \code{findOverlaps()}
#' to detect overlaps. See
#' \code{?\link[IRanges:findOverlaps-methods]{findOverlaps}} in the
#' \pkg{IRanges} package for a description of these arguments. 
#' If 0 < minoverlap < 1, the function will find overlaps by percentage
#' covered of interval and the filter condition will be set to max covered 
#' percentage of overlapping peaks.
#' @param ignore.strand When set to TRUE, the strand information is ignored in
#' the overlap calculations.
#' @param connectedPeaks If multiple peaks are involved in any group of 
#' connected/overlapping peaks in any input peak list, set it to "merge" will
#' add 1 to the overlapping counts, while set it to "min" will add the minimal 
#' involved peaks in each group of connected/overlapped peaks to the 
#' overlapping counts. Set it to "keepAll" will add the number of involved 
#' peaks for each peak list to the corresponding overlapping counts. 
#' In addition, it will output counts as if connectedPeaks were set to "min".
#' For examples (https://support.bioconductor.org/p/133486/#133603), 
#' if 5 peaks in group1 overlap with 2 peaks in group 2, setting connectedPeaks
#'  to "merge" will add 1 to the overlapping counts; setting it to "keepAll" 
#'  will add 5 peaks to count.group1, 2 to count.group2, and 2 to counts; 
#'  setting it to “min” will add 2 to the overlapping counts.
#' @return return value is An object of overlappingPeaks.  \item{venn_cnt}{an
#' object of VennCounts} \item{peaklist}{a list consists of all overlapping
#' peaks or unique peaks} \item{uniquePeaks}{an object of
#' \link[GenomicRanges:GRanges-class]{GRanges} consists of all unique peaks}
#' \item{mergedPeaks}{an object of \link[GenomicRanges:GRanges-class]{GRanges}
#' consists of all merged overlapping peaks} \item{peaksInMergedPeaks}{an
#' object of \link[GenomicRanges:GRanges-class]{GRanges} consists of all peaks
#' in each samples involved in the overlapping peaks} \item{overlappingPeaks}{a
#' list of data frame consists of the annotation of all the overlapped peaks}
#' \item{all.peaks}{a list of GRanges object which contain the input peaks with
#' formated rownames.}
#' @author Jianhong Ou
#' @seealso \link{annotatePeakInBatch}, \link{makeVennDiagram},
#' \link{getVennCounts}, \link{findOverlappingPeaks}
#' @references 1.Interval tree algorithm from: Cormen, Thomas H.; Leiserson,
#' Charles E.; Rivest, Ronald L.; Stein, Clifford. Introduction to Algorithms,
#' second edition, MIT Press and McGraw-Hill. ISBN 0-262-53196-8
#' 
#' 2.Zhu L.J. et al. (2010) ChIPpeakAnno: a Bioconductor package to annotate
#' ChIP-seq and ChIP-chip data. BMC Bioinformatics 2010,
#' 11:237doi:10.1186/1471-2105-11-237
#' 
#' 3. Zhu L (2013). "Integrative analysis of ChIP-chip and ChIP-seq dataset."
#' In Lee T and Luk ACS (eds.), Tilling Arrays, volume 1067, chapter 4, pp.
#' -19. Humana Press. http://dx.doi.org/10.1007/978-1-62703-607-8_8,
#' http://link.springer.com/protocol/10.1007\%2F978-1-62703-607-8_8
#' @keywords misc
#' @export
#' @import IRanges
#' @import GenomicRanges
#' @importFrom S4Vectors queryHits subjectHits
#' @examples
#' 
#' peaks1 <- GRanges(seqnames=c(6,6,6,6,5),
#'                  IRanges(start=c(1543200,1557200,1563000,1569800,167889600),
#'                          end=c(1555199,1560599,1565199,1573799,167893599),
#'                          names=c("p1","p2","p3","p4","p5")),
#'                  strand="+")
#' peaks2 <- GRanges(seqnames=c(6,6,6,6,5),
#'                   IRanges(start=c(1549800,1554400,1565000,1569400,167888600),
#'                           end=c(1550599,1560799,1565399,1571199,167888999),
#'                           names=c("f1","f2","f3","f4","f5")),
#'                   strand="+")
#' t1 <- findOverlapsOfPeaks(peaks1, peaks2, maxgap=1000)
#' makeVennDiagram(t1)
#' t1$venn_cnt
#' t1$peaklist
#' t2 <- findOverlapsOfPeaks(peaks1, peaks2, minoverlap = .5)
#' makeVennDiagram(t2)
#' 
#' t3 <- findOverlapsOfPeaks(peaks1, peaks2, minoverlap = .90)
#' makeVennDiagram(t3)
#' 
findOverlapsOfPeaks <- function(..., maxgap=-1L, minoverlap=0L,
                                ignore.strand=TRUE, connectedPeaks=c("keepAll", "min", "merge")){
  ###check inputs
  NAME_conn_string <- "___conn___"
  NAME_short_string <- "__"
  NAME_long_string <- "///"
  PeaksList <- list(...)
  n <- length(PeaksList)
  if(n==1){
    PeaksList <- PeaksList[[1]]
    n <- length(PeaksList)
    names <- names(PeaksList)
    if(is.null(names)) names <- paste("peaks", 1:n, sep="")
  }else{
    ##save dots arguments names
    dots <- substitute(list(...))[-1]
    names <- make.names(unlist(sapply(dots, deparse)))
    names(PeaksList) <- names
  }
  if(any(grepl(NAME_short_string, names))){
    stop(paste("The name of peaks could not contain", NAME_short_string))
  }
  if(n<2){
    stop("Missing required argument Peaks!")
  }
  if(n>5){
    stop("The length of input peaks list should no more than 5")
  }
  connectedPeaks <- match.arg(connectedPeaks)
  if(any(duplicated(names)))
    stop("Same input Peaks detected!")
  PeaksList<-lapply(PeaksList, trimPeakList, by="region", 
                    ignore.strand=ignore.strand, keepMetadata=TRUE)
  venn_cnt <- 
    vennCounts(PeaksList, n=n, names=names, 
               maxgap=maxgap, minoverlap=minoverlap, by="region",
               ignore.strand=ignore.strand, connectedPeaks=connectedPeaks)
  
  outcomes <- venn_cnt$venn_cnt[, 1:n]
  xlist <- do.call(rbind, venn_cnt$xlist)
  xlist <- xlist - 1
  xlist <- xlist[nrow(xlist):1,,drop=FALSE] 
  ## reverse xlist to match the order of names
  xlist <- apply(xlist, 2, base::paste, collapse="")
  if(length(venn_cnt$all)!=length(xlist)) 
    stop("length of 'xlist' and 'all' should be identical.")
  #     all <- do.call(rbind,
  #                    mapply(function(.ele, .id, .gp) cbind(.id, .ele, .gp), 
  #                           venn_cnt$all, 1:length(venn_cnt$all), 
  #                           xlist, SIMPLIFY=FALSE))
  all <- cbind(.id=rep(1:length(venn_cnt$all), sapply(venn_cnt$all, length)), 
               .ele=unlist(venn_cnt$all), 
               .gp=rep(xlist, sapply(venn_cnt$all, length)))
  all.peaks <- venn_cnt$Peaks[all[,2]]
  names(all.peaks) <- gsub(NAME_conn_string,
                           NAME_short_string,
                           names(all.peaks))
  if(!is.null(all.peaks$old_strand_HH)){
    strand(all.peaks) <- all.peaks$old_strand_HH
    all.peaks$old_strand_HH <- NULL
  }
  all.peaks$gpForFindOverlapsOfPeaks <- all[, 1]
  all.peaks$gpType <- all[, 3]
  all.peaks.split <- split(all.peaks, all.peaks$gpType)
  listname <- apply(outcomes, 1, 
                    function(id) 
                      paste(names[as.logical(id)], 
                            collapse=NAME_long_string))
  listcode <- apply(outcomes, 1, base::paste, collapse="")
  listname <- listname[-1]
  listcode <- listcode[-1]
  names(listname) <- listcode
  names(all.peaks.split) <- listname[names(all.peaks.split)]
  peaklist <- lapply(all.peaks.split, reduce, 
                     min.gapwidth=maxgap+1L, with.revmap=TRUE, 
                     ignore.strand=ignore.strand)
  peaklist <- mapply(function(peaks, info){
    revmap <- peaks$revmap
    #         peakNames <- do.call(rbind, 
    #                              mapply(function(id, gp) cbind(id, gp), 
    #                                     revmap, 1:length(revmap), 
    #                                     SIMPLIFY=FALSE))
    peakNames <- cbind(id=unlist(revmap),
                       gp=rep(1:length(revmap), sapply(revmap, length)))
    peaks$peakNames <- CharacterList(split(names(info)[peakNames[, 1]], 
                                           peakNames[, 2]), 
                                     compress=TRUE)
    if(ignore.strand){
      strand <- split(as.character(strand(info))[peakNames[, 1]], 
                      peakNames[, 2])
      strand <- lapply(strand, unique)
      l <- sapply(strand, length)
      strand[l>=2] <- "*"
      strand(peaks) <- unlist(strand)
    }
    peaks$revmap <- NULL
    peaks
  }, peaklist, all.peaks.split, SIMPLIFY=FALSE)
  
  listcode <- strsplit(listcode, "")
  names(listcode) <- listname
  listcode <- sapply(listcode, function(.ele) sum(as.numeric(.ele))==2)
  overlappingPeaks <- sapply(names(listcode)[listcode], function(.ele){
    peakListName <- strsplit(.ele, NAME_long_string, fixed = TRUE)[[1]]
    ps <- PeaksList[peakListName]
    ol <- findOverlaps(query=ps[[1]], subject=ps[[2]], 
                       maxgap=maxgap, minoverlap=minoverlap, 
                       ignore.strand=ignore.strand)
    q <- ps[[1]][queryHits(ol)]
    s <- ps[[2]][subjectHits(ol)]
    cl <- getRelationship(q, s)[,c("insideFeature", "shortestDistance")]
    colnames(cl)[grepl("insideFeature", colnames(cl))] <- "overlapFeature"
    correlation <- cbind(peaks1=names(q), as.data.frame(unname(q)), 
                         peaks2=names(s), as.data.frame(unname(s)), 
                         cl)
    rownames(correlation) <- make.names(paste(names(q), names(s), sep="_"))
    correlation <- correlation[correlation[,"shortestDistance"]<maxgap | 
                                 correlation[,"overlapFeature"] %in% 
                                 c("includeFeature", "inside",
                                   "overlapEnd", "overlapStart",
                                   "overlap"),]
  }, simplify = FALSE)
  PeaksList <- sapply(PeaksList, trimPeakList, by="region",
                      ignore.strand=ignore.strand,
                      keepMetadata=TRUE)
  for(i in 1:n){
    names(PeaksList[[i]]) <- 
      paste(names[i], names(PeaksList[[i]]), sep=NAME_short_string)
  }
  sharedColnames <- Reduce(function(a, b){
    shared <- intersect(colnames(mcols(a)), colnames(mcols(b)))
    if(length(shared)>0){
      shared <- shared[sapply(shared, function(.ele){
        class(mcols(a)[, .ele])==class(mcols(b)[, .ele])
      })]
    }
    if(length(shared)>0) {
      mcols(a) <- mcols(a)[, shared, drop=FALSE]
    }else{
      mcols(a) <- NULL
    }
    a
  }, PeaksList)
  sharedColnames <- colnames(mcols(sharedColnames))
  uniquePeaks <- peaklist[names(peaklist) %in% 
                            listname[!grepl(NAME_long_string, 
                                            listname, fixed = TRUE)]]
  uniquePeaks <- mapply(function(a, b){
    b <- b[unlist(a$peakNames)]
    if(length(sharedColnames)>0){
      mcols(b) <- mcols(b)[, sharedColnames, drop=FALSE]
    }else{
      mcols(b) <- NULL
    }
    b
  }, uniquePeaks, PeaksList[names(uniquePeaks)])
  if(!is(uniquePeaks, "GRangesList"))
    uniquePeaks <- GRangesList(uniquePeaks)
  uniquePeaks <- unlist(uniquePeaks, use.names = FALSE)
  mergedPeaks <- peaklist[names(peaklist) %in% 
                            listname[grepl(NAME_long_string,
                                           listname, fixed = TRUE)]]
  if(!is(mergedPeaks, "GRangesList"))
    mergedPeaks <- GRangesList(mergedPeaks)
  mergedPeaks <- unlist(mergedPeaks, use.names = FALSE)
  peaksInMergedPeaks <- lapply(PeaksList, function(.ele){
    if(length(sharedColnames)>0){
      mcols(.ele) <- mcols(.ele)[, sharedColnames, drop=FALSE]
    }else{
      mcols(.ele) <- NULL
    }
    .ele
  })
  peaksInMergedPeaks <- unlist(GRangesList(peaksInMergedPeaks), 
                               use.names = FALSE)
  peaksInMergedPeaks <- peaksInMergedPeaks[unlist(mergedPeaks$peakNames)]
  structure(list(venn_cnt=venn_cnt$venn_cnt, 
                 peaklist=peaklist, 
                 uniquePeaks=uniquePeaks,
                 mergedPeaks=mergedPeaks,
                 peaksInMergedPeaks=peaksInMergedPeaks,
                 overlappingPeaks=overlappingPeaks,
                 all.peaks=PeaksList), 
            class="overlappingPeaks")
}

test_that("findOverlapsOfPeaks works not correct", {
  ##2 way
  p1 <- GRanges("1", 
                IRanges(start=c(1, 3, 5, 8, 10), 
                        end=c(2, 4, 6, 9, 11), 
                        names=letters[1:5]), 
                strand="*")
  p2 <- GRanges("1", 
                IRanges(start=c(2, 4, 9), 
                        end=c(3, 5, 10), 
                        names=letters[1:3]), 
                strand="*")
  ol <- findOverlapsOfPeaks(p1, p2)
  expect_equal(ol$venn_cnt[,"Counts"], c(0,0,0,3))
  ##3 way
  p3 <- GRanges("1", 
                IRanges(start=c(3), end=c(4), names=letters[1]), 
                strand="*")
  ol <- findOverlapsOfPeaks(p1, p2, p3)
  expect_equal(ol$venn_cnt[,"Counts"], c(0,0,0,0,0,0,1,1))
  ##4 way
  p4 <- GRanges("1", 
                IRanges(start=c(13), end=c(14), names=letters[1]), 
                strand="*")
  ol <- findOverlapsOfPeaks(p1, p2, p3, p4)
  expect_equal(ol$venn_cnt[,"Counts"], 
               c(0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0))
  ##5 way
  p5 <- GRanges("1", 
                IRanges(start=c(14), end=c(15), names=letters[1]), 
                strand="*")
  ol <- findOverlapsOfPeaks(p1, p2, p3, p4, p5)
  ## minoverlap > 2
  p1 <- GRanges(rep(1:8, each=3), 
                IRanges(start=rep(c(1, 5, 8), 8), end=rep(c(4, 7, 11), 8), 
                        names=letters[1:24]), 
                strand="*", id=LETTERS[1:24])
  p2 <- GRanges(rep(1:8, each=2), 
                IRanges(start=rep(c(2, 6), 8), end=rep(c(5, 10), 8), 
                        names=letters[1:16]), 
                strand="*", id=LETTERS[1:16])
  ol <- findOverlapsOfPeaks(p1, p2, minoverlap=3)
  expect_equal(p1[gsub("p1__", "", 
                       unlist(ol$peaklist$p1$peakNames))]$id, 
               LETTERS[1:8*3-1])
  d <- ol$peaklist$`p1///p2`$peakNames
  d <- do.call(rbind, lapply(d, function(.ele) .ele[order(.ele)]))
  d <- cbind(p1[gsub("p1__", "", d[,1])]$id, p2[gsub("p2__", "", d[,2])]$id)
  d <- apply(d, 1, sort)
  expect_equal(paste(d[1,], d[2,]), 
               paste(LETTERS[1:16], LETTERS[1:24][-(1:8*3-1)]))
  ## check the output
  peaks1 <- GRanges(seqnames=c(6,6,6,6,5),
                    IRanges(start=c(15432,15572,1563000,1569800,167889600),
                            end=c(15551,15605,1565199,1573799,167893599),
                            names=c("p1","p2","p3","p4","p5")),
                    strand="+", a=1, b=2, c="x", d=Rle(1, 5))
  peaks2 <- GRanges(seqnames=c(6,6,6,6,5),
                    IRanges(start=c(1549800,1554400,1565000,1569400,167888600),
                            end=c(1550599,1560799,1565399,1571199,167888999),
                            names=c("f1","f2","f3","f4","f5")),
                    strand="+", a=1, b="w", c="x", d=1:5)
  
  peaks3 <- GRanges(seqnames=c(6,6,6,6,5),
                    IRanges(start=c(154,155,1565000,1569400,167888600),
                            end=c(155,156,1565399,1571199,167888999),
                            names=c("f1","f2","f3","f4","f5")),
                    strand="+", a=1, b=2, c=Rle(1:5))
  
  peaks4 <- peaks3
  t1 <- findOverlapsOfPeaks(peaks1, peaks2, peaks3,peaks4, maxgap=1000)
  expect_equal(length(t1$peaksInMergedPeaks)+length(t1$uniquePeaks), 20)
  expect_equal(colnames(mcols(t1$uniquePeaks)), "a")
  ## check by percentage
  # GRanges with fixed width 100, set overlaps for 100 regions from 
  # 1 to 100
  p1 <- GRanges(seqnames = "chr1",
                IRanges(start = seq.int(100)*1000, width = 100,
                        names = paste0("p1_", seq.int(100))))
  p2 <- GRanges(seqnames = "chr1",
                IRanges(start = seq.int(100)*1001, width = 100,
                        names = paste0("p2_", seq.int(100))))
  for(i in seq.int(99)){
    ol <- findOverlapsOfPeaks(p1, p2, minoverlap = i/100)
    expect_equal(as.numeric(ol$venn_cnt[4,"Counts"]), 100-i)
  }
})

#' obtain the peaks near bi-directional promoters
#' 
#' Obtain the peaks near bi-directional promoters. Also output percent of peaks
#' near bi-directional promoters.
#' 
#' 
#' @param myPeakList \link[GenomicRanges:GRanges-class]{GRanges}: See example
#' below
#' @param AnnotationData annotation data obtained from getAnnotation or
#' customized annotation of class \link[GenomicRanges:GRanges-class]{GRanges}
#' containing additional variable: strand (1 or + for plus strand and -1 or -
#' for minus strand). For example, data(TSS.human.NCBI36),
#' data(TSS.mouse.NCBIM37), data(TSS.rat.RGSC3.4) and data(TSS.zebrafish.Zv8).
#' @param MaxDistance Specify the maximum gap allowed between the peak and
#' nearest gene
#' @param ... Not used
#' @return A list of 4 \item{list("peaksWithBDP")}{annotated Peaks containing
#' bi-directional promoters.
#' 
#' GRangesList with slot start holding the start position of the peak, slot end
#' holding the end position of the peak, slot space holding the chromosome
#' location where the peak is located, slot rownames holding the id of the
#' peak.  In addition, the following variables are included.
#' 
#' feature: id of the feature such as ensembl gene ID
#' 
#' insideFeature: upstream: peak resides upstream of the feature; downstream:
#' peak resides downstream of the feature; inside: peak resides inside the
#' feature; overlapStart: peak overlaps with the start of the feature;
#' overlapEnd: peak overlaps with the end of the feature; includeFeature: peak
#' include the feature entirely.
#' 
#' distancetoFeature: distance to the nearest feature such as transcription
#' start site.  By default, the distance is calculated as the distance between
#' the start of the binding site and the TSS that is the gene start for genes
#' located on the forward strand and the gene end for genes located on the
#' reverse strand. The user can specify the location of peak and location of
#' feature for calculating this
#' 
#' feature_range: start and end position of the feature such as gene
#' 
#' feature_strand: 1 or + for positive strand and -1 or - for negative strand
#' where the feature is located } \item{list("percentPeaksWithBDP")}{The
#' percent of input peaks containing bi-directional promoters}
#' \item{list("n.peaks")}{The total number of input peaks}
#' \item{list("n.peaksWithBDP")}{The # of input peaks containing bi-directional
#' promoters}
#' @author Lihua Julie Zhu, Jianhong Ou
#' @seealso annotatePeakInBatch, findOverlappingPeaks, makeVennDiagram
#' @references Zhu L.J. et al. (2010) ChIPpeakAnno: a Bioconductor package to
#' annotate ChIP-seq and ChIP-chip data. BMC Bioinformatics 2010,
#' 11:237doi:10.1186/1471-2105-11-237
#' @keywords misc
#' @export
#' @examples
#' 
#' 
#' if (interactive() || Sys.getenv("USER")=="jou")
#' {
#'     library(GenomeInfoDb)
#'     data(myPeakList)
#'     data(TSS.human.NCBI36)
#'     seqlevelsStyle(TSS.human.NCBI36) <- seqlevelsStyle(myPeakList)
#'     annotatedBDP = peaksNearBDP(myPeakList[1:6,], 
#'                                 AnnotationData=TSS.human.NCBI36,
#'                                 MaxDistance=5000,
#'                                 PeakLocForDistance =  "middle", 
#'                                 FeatureLocForDistance = "TSS")
#'     c(annotatedBDP$percentPeaksWithBDP, annotatedBDP$n.peaks, 
#'       annotatedBDP$n.peaksWithBDP)
#' }
#' 
peaksNearBDP <- function(myPeakList, AnnotationData,
                         MaxDistance=5000L, ...){
    if (missing(myPeakList)) {
        stop("Missing required argument myPeakList!")
    }
    if (!inherits(myPeakList, c("GRanges"))) {
        stop("myPeakList needs to be GRanges object")
    }
    if (!missing(AnnotationData)){        
        if (!inherits(AnnotationData, c("GRanges", "annoGR"))) {
            stop("AnnotationData needs to be GRanges or annoGR object")
        }
        if(is(AnnotationData, "annoGR"))
            AnnotationData <- AnnotationData@gr
    }else{
        stop("Missing required argument AnnotationData!")
    }
    stopifnot(length(intersect(seqlevelsStyle(myPeakList),
                               seqlevelsStyle(AnnotationData)))>0)
    stopifnot(is.numeric(MaxDistance))
    
    MaxDistance <- round(MaxDistance[1])
    myPeakList <- unique(myPeakList)
    myPeakList$bdp_idx <- seq_along(myPeakList)
    anno <- annoPeaks(myPeakList, AnnotationData, 
                      bindingType = "nearestBiDirectionalPromoters",
                      bindingRegion = c(-1*MaxDistance, MaxDistance))
    if(length(anno)<1){
        return(list(peaksWithBDP=anno,
                    percentPeaksWithBDP=0,
                    n.peaks=length(myPeakList),
                    n.peaksWithBDP=0))
    }
    anno.s <- split(anno, anno$bdp_idx)
    len <- elementNROWS(anno.s)
    anno.s <- anno.s[len>=2]
    len <- sapply(anno.s, function(.ele){
        std <- .ele$feature.strand
        all(c("+", "-") %in% as.character(.ele$feature.strand))
    })
    anno.s <- anno.s[len]
    list(peaksWithBDP=anno.s,
         percentPeaksWithBDP = length(anno.s)/length(myPeakList),
         n.peaks=length(myPeakList),
         n.peaksWithBDP=length(anno.s))
}

#' Annotate peaks
#' 
#' Annotate peaks by annoGR object in the given range.
#' 
#' 
#' @param peaks peak list, \link[GenomicRanges:GRanges-class]{GRanges} object
#' @param annoData annotation data, \link[GenomicRanges:GRanges-class]{GRanges}
#' object
#' @param bindingType Specifying the criteria to associate peaks with
#' annotation. Here is how to use it together with the parameter bindingRegion
#' \itemize{ \item To obtain peaks within 5kb upstream and up to 3kb downstream
#' of TSS within the gene body, set bindingType = "startSite" and bindingRegion
#' = c(-5000, 3000) \item To obtain peaks up to 5kb upstream within the gene
#' body and 3kb downstream of gene/Exon End, set bindingType = "endSite" and
#' bindingRegion = c(-5000, 3000) \item To obtain peaks from 5kb upstream to
#' 3kb downstream of genes/Exons , set bindingType = "fullRange" and
#' bindingRegion = c(-5000, 3000) \item To obtain peaks with nearest
#' bi-directional promoters within 5kb upstream and 3kb downstream of TSS, set
#' bindingType = "nearestBiDirectionalPromoters" and bindingRegion = c(-5000,
#' 3000) } \describe{ \item{startSite}{start position of the feature (strand is
#' considered)} \item{endSite}{end position of the feature (strand is
#' considered)} \item{fullRange}{whole range of the feature}
#' \item{nearestBiDirectionalPromoters}{nearest promoters from both direction
#' of the peaks (strand is considered). It will report bidirectional promoters
#' if there are promoters in both directions in the given region (defined by
#' bindingRegion). Otherwise, it will report the closest promoter in one
#' direction.} }
#' @param bindingRegion Annotation range used together with bindingType, which
#' is a vector with two integer values, default to c (-5000, 5000). The first
#' one must be no bigger than 0, which means upstream. And the sec ond one must
#' be no less than 1, which means downstream (1 is the site position, 2 is the
#' next base of the site position). For details, see bindingType.
#' @param ignore.peak.strand ignore the peaks strand or not.
#' @param select "all" or "bestOne". Return the annotation containing all or
#' the best one.  The "bestOne" is selected by the shortest distance to the
#' sites and then similarity between peak and annotations.  Ignored if
#' bindingType is nearestBiDirectionalPromoters.
#' @param ...  Not used.
#' @return Output is a GRanges object of the annotated peaks.
#' @export
#' @importFrom GenomeInfoDb seqlevelsStyle seqlengths
#' @importFrom BiocGenerics strand start end width pos
#' @importFrom S4Vectors queryHits subjectHits
#' @author Jianhong Ou
#' @seealso See Also as \code{\link{annotatePeakInBatch}}
#' @keywords misc
#' @examples
#'     library(ensembldb)
#'     library(EnsDb.Hsapiens.v75)
#'     data("myPeakList")
#'     annoGR <- toGRanges(EnsDb.Hsapiens.v75)
#'     seqlevelsStyle(myPeakList) <- seqlevelsStyle(annoGR)
#'     annoPeaks(myPeakList, annoGR)
#' 
annoPeaks <- function(peaks, annoData, 
                      bindingType=c("nearestBiDirectionalPromoters",
                                    "startSite", "endSite", "fullRange"), 
                      bindingRegion=c(-5000, 5000), 
                      ignore.peak.strand=TRUE,
                      select=c("all", "bestOne"), # bestOne will output the one with best score
                      ...){
    select <- match.arg(select)
    if(bindingType[1] %in% 
       c("bothSidesNearest", "nearestBiDirectionalPromoters", "bothSidesNSS")){
        bindingType <- bindingType[1]
        if(bindingType=="bothSidesNSS"){
            bindingType <- "nearestBiDirectionalPromoters"
        }
        if(select!="all"){
            select <- "all"
            message("nearestbiDirectionalPromoters do not support select=bestOne")
        }
    }else{
        bindingType <- match.arg(bindingType)
    }
    stopifnot(inherits(peaks, "GRanges"))
    stopifnot(inherits(annoData, c("annoGR", "GRanges")))
    check_seqlevel <- tryCatch({
    	seqlevelsStyle(peaks)
    	seqlevelsStyle(annoData)
    }, error = function(w) {
    	message("Warning: seqlevel style not recognized, you are probably using custom GRange objects: ", w$message)
    	return(NA)
    })
    if (!any(is.na(check_seqlevel))) {
    	stopifnot(length(intersect(seqlevelsStyle(peaks),seqlevelsStyle(annoData)))>0)
    }
    # stopifnot(length(intersect(seqlevelsStyle(peaks),seqlevelsStyle(annoData)))>0)
    stopifnot(length(bindingRegion)==2)
    stopifnot(bindingRegion[1]<=0 && bindingRegion[2]>=1)
    if(ignore.peak.strand){
        peaks$peakstrand <- strand(peaks)
        strand(peaks) <- "*"
    }
    if(is.null(names(peaks))){
        names(peaks) <- paste0("X", 1:length(peaks))
    }
    tmp <- annoData
    annotation <- switch(bindingType,
                         startSite={
                             idx <- as.character(strand(tmp))=="-"
                             start(tmp)[idx] <- end(tmp)[idx]
                             width(tmp) <- 1
                             tmp
                         },
                         endSite={
                             idx <- as.character(strand(tmp))!="-"
                             start(tmp)[idx] <- end(tmp)[idx]
                             width(tmp) <- 1
                             tmp
                         },
                         fullRange=annoData,
                         bothSidesNearest=annoData,
                         nearestBiDirectionalPromoters=annoData,
                         annoData)
    annotation.bck <- annotation
    rm(tmp)
    if(bindingType %in% c("bothSidesNearest", "nearestBiDirectionalPromoters")){
        if(bindingType=="bothSidesNearest"){
            extGR <- function(a, b){
                str_a <- as.character(strand(a))!="-"
                s1 <- ifelse(str_a, start(a)+b[1], start(a)-b[2])
                s1[s1<1] <- 1
                start(a) <- s1
                s2 <- ifelse(str_a, end(a)+b[2], end(a)-b[1])
                s2.idx <- which(s2 > seqlengths(a)[as.character(seqnames(a))])
                if(length(s2.idx)>0){
                    s2[s2.idx] <- seqlengths(a)[as.character(seqnames(a[s2.idx]))]
                }
                end(a) <- s2
                a
            }
            peaks.tmp <- extGR(peaks, bindingRegion)
            ol <- findOverlaps(query=peaks.tmp, subject=annotation,
                               type="any", select="all",
                               ignore.strand=FALSE)
        }else{
            ##bindingType=="nearestBiDirectionalPromoters"
            annotation <- promoters(annotation, 
                                    upstream=-1*bindingRegion[1],
                                    downstream=bindingRegion[2])
            ol <- findOverlaps(query=peaks, subject=annotation,
                               type="any", select="all",
                               ignore.strand=FALSE)
        }
    }else{
        idx <- as.character(strand(annotation))!="-"
        s1 <- ifelse(idx, start(annotation)+bindingRegion[1], 
                                    start(annotation)+1-bindingRegion[2])
        s1[s1<1] <- 1
        start(annotation) <- s1
        e1 <- ifelse(idx, end(annotation)-1+bindingRegion[2],
                                  end(annotation)-bindingRegion[1])
        seql <- seqlengths(annotation)
        if(length(seql)>0){
            e1_seql <- seql[as.character(seqnames(annotation))]
            id <- e1_seql<e1
            id <- id[!is.na(id)]
            if(length(id)>0) e1[id] <- e1_seql[id]
        }
        end(annotation) <- e1
        if(bindingType=="startSite"){##make sure the downstream is inside gene
            start(annotation)[!idx] <- 
                ifelse(start(annotation)[!idx]>start(annoData)[!idx], 
                       start(annotation)[!idx], 
                       start(annoData)[!idx])
            end(annotation)[idx] <- 
                ifelse(end(annotation)[idx]<end(annoData)[idx], 
                       end(annotation)[idx], 
                       end(annoData)[idx])
        }else{
            if(bindingType=="endSite"){
                start(annotation)[idx] <- 
                    ifelse(start(annotation)[idx]>start(annoData)[idx], 
                           start(annotation)[idx], 
                           start(annoData)[idx])
                end(annotation)[!idx] <- 
                    ifelse(end(annotation)[!idx]<end(annoData)[!idx], 
                           end(annotation)[!idx], 
                           end(annoData)[!idx])
            }
        }
        
        ol <- findOverlaps(query=peaks, subject=annotation,
                           type="any", select="all",
                           ignore.strand=FALSE)
    }
    if(length(ol)<1){
        return(GRanges())
    }
    peaks <- peaks[queryHits(ol)]
    anno <- annoData[subjectHits(ol)]
    annotation.bck.hits <- annotation.bck[subjectHits(ol)]
    if(bindingType %in% c("bothSidesNearest", "nearestBiDirectionalPromoters")){
        relations <- if(bindingType=="bothSidesNearest") getRelationship(peaks, anno) else getRelationship(peaks, promoters(unname(as(anno, "GRanges")), upstream=0, downstream=1))
        ##filter resutls and save the nearest
        keep <- rep(FALSE, length(peaks))
        anno.strand <- as.character(strand(anno))!="-"
        if(bindingType=="nearestBiDirectionalPromoters"){
            keep[relations$insideFeature %in% 
                     c("includeFeature", "overlap")] <- TRUE
            keep.left <- (relations$insideFeature %in% 
                c("upstream", "overlapStart") & !anno.strand) |
                (relations$insideFeature %in% "inside") | 
                ((relations$insideFeature %in% "overlapEnd") & anno.strand)
            keep.right <- (relations$insideFeature %in% 
                c("upstream", "overlapStart") & anno.strand) |
                (relations$insideFeature %in% "inside") |
                ((relations$insideFeature %in% "overlapEnd") & !anno.strand)
            shortestDist <- relations$distanceToStart
        }else{
            keep[relations$insideFeature %in% 
                     c("includeFeature", "inside", "overlap",
                       "overlapEnd", "overlapStart")] <- TRUE
            keep.left <- (relations$insideFeature=="downstream" & anno.strand) |
                (relations$insideFeature=="upstream" & !anno.strand)
            keep.right <- (relations$insideFeature=="upstream" & anno.strand) |
                (relations$insideFeature=="downstream" & !anno.strand)
            shortestDist <- relations$shortestDistance
        }
        names(shortestDist) <- 1:length(peaks)
        whichismin <- function(.ele){
            as.numeric(names(.ele)[.ele==min(.ele)])
        }
        if(sum(keep.left)>=1){
            nearest.left <- tapply(shortestDist[keep.left], 
                                       queryHits(ol)[keep.left],
                                       whichismin, simplify=FALSE)
            keep[unlist(nearest.left)] <- TRUE
        }
        if(sum(keep.right)>=1){
            nearest.right <- 
                tapply(shortestDist[keep.right], 
                       queryHits(ol)[keep.right],
                       whichismin, simplify=FALSE)
            keep[unlist(nearest.right)] <- TRUE
        }
        peaks <- peaks[keep]
        anno <- anno[keep]
        annotation.bck.hits <- annotation.bck.hits[keep]
    }
    peaks$peak <- names(peaks)
    if(!is.null(names(anno))){
        peaks$feature <- names(anno)
    }
    peaks$feature.ranges <- unname(ranges(anno))
    peaks$feature.strand <- strand(anno)
    peaks$distance <- distance(peaks, anno, ignore.strand=FALSE)
    relations <- getRelationship(peaks, anno)
    #peaks$binding.site <- relations$insideFeature
    peaks$insideFeature <- relations$insideFeature
    peaks$distanceToSite <- distance(peaks, annotation.bck.hits, 
                                     ignore.strand=ignore.peak.strand)
    if(ignore.peak.strand){
        strand(peaks) <- peaks$peakstrand
        peaks$peakstrand <- NULL
    }
    mcols(peaks) <- cbind(mcols(peaks), mcols(anno))
    if(select=="bestOne"){
        if(length(peaks)==0) return(peaks)
        annoscore <- -1 * annoScore(peaks, anno)
        peaks$ANNOPEAKS__peak.oid <- 1:length(peaks)
        peaks <- peaks[order(peaks$peak, peaks$distanceToSite, annoscore)]
        peaks <- peaks[!duplicated(peaks$peak)]
        peaks <- peaks[order(peaks$ANNOPEAKS__peak.oid)]
        peaks$ANNOPEAKS__peak.oid <- NULL
    }
    peaks
}

test_that("annoPeaks works not correct", {
    #check start
    #               a
    #      12345678901234567890
    #            -AA -BB
    #            +CC +DD
    #           +EE   +FF
    #           -GG   -HH
    #          +II     +JJ
    #          -KK     -LL
    #           +MMMMMMM
    #           -NNNNNNN
    myPeak = GRanges("chr1", 
                     IRanges(start=10, 
                             end=10, 
                             names="a"), 
                     strand="*")
    feature = GRanges("chr1", 
                      IRanges(start=c(8, 12, 8, 12, 7, 13, 7, 
                                      13, 6, 14, 6, 14, 7, 7),
                              end=c(9, 13, 9, 13, 8, 14, 8, 
                                    14, 7, 15, 7, 15, 13, 13),
                              names=LETTERS[1:14]), 
                      strand=c("-", "-", "+", "+", "+", "+", "-", 
                               "-", "+", "+", "-", "-", "+", "-"))
    expect_error(annoPeaks(myPeak, feature, bindingRegion=c(10, 10)))
    feature <- annoGR(feature)
    anno <- lapply(list(c(-1,1), c(-2,1), c(-2,3), c(-3,3), c(-4,4)), 
                   annoPeaks, peaks=myPeak, annoData=feature, 
                   bindingType="startSite", ignore.peak.strand=TRUE)
    anno.name <- sapply(anno, function(.ele) 
        paste0(names(.ele), .ele$feature))
    expect_equal(anno.name[[1]], "aA")
    expect_equal(anno.name[[2]], c("aA", "aD", "aG"))
    expect_equal(anno.name[[3]], c("aA", "aD", "aG"))
    expect_equal(anno.name[[4]], c("aA", "aD", "aF", "aG", "aK"))
    expect_equal(anno.name[[5]], 
                c("aA", "aD", "aF", "aG", 'aJ', "aK", "aM", "aN"))
    anno <- lapply(c("startSite", "endSite", "fullRange", "bothSidesNearest"),
                    annoPeaks, peaks=myPeak, annoData=feature, 
                    bindingRegion=c(-3, 3), ignore.peak.strand=TRUE)
    anno.name <- sapply(anno, function(.ele) 
        paste0(names(.ele), .ele$feature))
    expect_equal(anno.name[[1]], c("aA", "aD", "aF", "aG", "aK"))
    expect_equal(anno.name[[2]], c("aB", "aC", "aE", "aM", "aN"))
    expect_equal(anno.name[[3]], c("aA", "aB", "aC", "aD", "aE", 
                                  "aF", "aG", "aK", "aM", "aN"))
    expect_equal(anno.name[[4]], c("aA", "aB", "aC", "aD", "aM", "aN"))
    
    #             AA
    #      12345678901234567890
    #     -aaaa      +cccc
    #       +bbbb
    annoData<- GRanges(seqnames = "chr1", 
                       ranges=IRanges(start=c(1,3,12), 
                                      end=c(4,6,15),
                                      names=letters[1:3]), 
                       strand = c("-", "+", "+"))
    peak<- GRanges(seqnames = "chr1", 
                   ranges=IRanges(start=8, width=2), 
                   strand = "+")
    peak.anno <- annoPeaks(peak, annoData)
    expect_equal(peak.anno$feature, c("a", "c"))
    peak.anno <- annoPeaks(peak, annoData, 
                           bindingType="nearestBiDirectionalPromoters",
                           bindingRegion=c(-2, 1), 
                           ignore.peak.strand=TRUE)
    expect_true(length(peak.anno)==0)
    peak.anno <- annoPeaks(peak, annoData, 
                           bindingType="nearestBiDirectionalPromoters",
                           bindingRegion=c(-3, 1), 
                           ignore.peak.strand=TRUE)
    expect_equal(peak.anno$feature, "c")
    #             AA
    #      12345678901234567890
    #     -aaaa      +cccc
    #       +bbbbbb
    #       +ddd
    annoData<- GRanges(seqnames = "chr1", 
                       ranges=IRanges(start=c(1,3,12,3), 
                                      end=c(4,8,15,5),
                                      names=letters[1:4]), 
                       strand = c("-", "+", "+", "+"))
    peak.anno <- annoPeaks(peak, annoData, 
                           bindingType="nearestBiDirectionalPromoters",
                           bindingRegion=c(-3, 1), 
                           ignore.peak.strand=TRUE)
    expect_equal(peak.anno$feature, "c")
    peak.anno <- annoPeaks(peak, annoData, 
                           bindingType="nearestBiDirectionalPromoters",
                           bindingRegion=c(-4, 1), 
                           ignore.peak.strand=TRUE)
    expect_equal(peak.anno$feature, c("a", "c"))
    peak.anno <- annoPeaks(peak, annoData, 
                           bindingType="nearestBiDirectionalPromoters",
                           bindingRegion=c(-4, 6), 
                           ignore.peak.strand=TRUE)
    expect_equal(peak.anno$feature, c("a", "c"))
    peak.anno <- annoPeaks(peak, annoData, 
                           bindingType="nearestBiDirectionalPromoters",
                           bindingRegion=c(-3, 6), 
                           ignore.peak.strand=TRUE)
    expect_equal(peak.anno$feature, "c")
    ## check bestOne
    #               a
    #      12345678901234567890
    #            -AABB
    #              +CC
    #             +DD
    #              +E
    myPeak = GRanges("chr1", 
                     IRanges(start=10, 
                             end=10, 
                             names="a"), 
                     strand="*")
    feature = GRanges("chr1", 
                      IRanges(start=c(8, 10, 10, 9, 10),
                              end=c(9, 11, 11, 10, 10),
                              names=LETTERS[1:5]), 
                      strand=c("-", "-", "+", "+", "+"))
    peak.anno <- annoPeaks(myPeak, feature,
                           bindingType="fullRange",
                           bindingRegion=c(0, 1),
                           ignore.peak.strand=TRUE)
    expect_equal(length(peak.anno), 4)
    peak.anno <- annoPeaks(myPeak, feature,
                           bindingType="fullRange",
                           bindingRegion=c(0, 1),
                           select="bestOne",
                           ignore.peak.strand=TRUE)
    expect_equal(peak.anno$feature, "E")
    feature1 <- feature[1:4]
    peak.anno <- annoPeaks(myPeak, feature1,
                           bindingType="endSite",
                           bindingRegion=c(0, 1),
                           select="all",
                           ignore.peak.strand=TRUE)
    expect_equal(length(peak.anno), 2)
    peak.anno <- annoPeaks(myPeak, feature1,
                           bindingType="endSite",
                           bindingRegion=c(0, 1),
                           select="bestOne",
                           ignore.peak.strand=TRUE)
    expect_equal(peak.anno$feature, "B")
})

##require library graph, RBGL


#' Find the overlapping peaks for two peak ranges.
#' 
#' Find the overlapping peaks for two input peak ranges.
#' 
#' The new function findOverlapsOfPeaks is recommended.
#' 
#' Efficiently perform overlap queries with an interval tree implemented in
#' IRanges.
#' 
#' @aliases findOverlappingPeaks findOverlappingPeaks-deprecated
#' @param Peaks1 GRanges: See example below.
#' @param Peaks2 GRanges: See example below.
#' @param maxgap,minoverlap Used in the internal call to \code{findOverlaps()}
#' to detect overlaps. See
#' \code{?\link[IRanges:findOverlaps-methods]{findOverlaps}} in the
#' \pkg{IRanges} package for a description of these arguments.
#' @param multiple TRUE or FALSE: TRUE may return multiple overlapping peaks in
#' Peaks2 for one peak in Peaks1; FALSE will return at most one overlapping
#' peaks in Peaks2 for one peak in Peaks1. This parameter is kept for backward
#' compatibility, please use select.
#' @param NameOfPeaks1 Name of the Peaks1, used for generating column name.
#' @param NameOfPeaks2 Name of the Peaks2, used for generating column name.
#' @param select all may return multiple overlapping peaks, first will return
#' the first overlapping peak, last will return the last overlapping peak and
#' arbitrary will return one of the overlapping peaks.
#' @param annotate Include overlapFeature and shortestDistance in the
#' OverlappingPeaks or not.  1 means yes and 0 means no. Default to 0.
#' @param ignore.strand When set to TRUE, the strand information is ignored in
#' the overlap calculations.
#' @param connectedPeaks If multiple peaks involved in overlapping in several
#' groups, set it to "merge" will count it as only 1, while set it to "min"
#' will count it as the minimal involved peaks in any concered groups
#' @param \dots Objects of \link[GenomicRanges:GRanges-class]{GRanges}: See
#' also \code{\link{findOverlapsOfPeaks}}.
#' @return \item{OverlappingPeaks}{a data frame consists of input peaks
#' information with added information: overlapFeature (upstream: peak1 resides
#' upstream of the peak2; downstream: peak1 resides downstream of the peak2;
#' inside: peak1 resides inside the peak2 entirely; overlapStart: peak1
#' overlaps with the start of the peak2; overlapEnd: peak1 overlaps with the
#' end of the peak2; includeFeature: peak1 include the peak2 entirely) and
#' shortestDistance (shortest distance between the overlapping peaks)}
#' \item{MergedPeaks}{GRanges contains merged overlapping peaks}
#' @author Lihua Julie Zhu
#' @seealso findOverlapsOfPeaks, annotatePeakInBatch, makeVennDiagram
#' @references 1.Interval tree algorithm from: Cormen, Thomas H.; Leiserson,
#' Charles E.; Rivest, Ronald L.; Stein, Clifford. Introduction to Algorithms,
#' second edition, MIT Press and McGraw-Hill. ISBN 0-262-53196-8
#' 
#' 2.Zhu L.J. et al. (2010) ChIPpeakAnno: a Bioconductor package to annotate
#' ChIP-seq and ChIP-chip data. BMC Bioinformatics 2010, 11:237
#' doi:10.1186/1471-2105-11-237
#' 
#' 3. Zhu L (2013). Integrative analysis of ChIP-chip and ChIP-seq dataset.  In
#' Lee T and Luk ACS (eds.), Tilling Arrays, volume 1067, chapter 4, pp. -19.
#' Humana Press. http://dx.doi.org/10.1007/978-1-62703-607-8_8
#' @keywords misc
#' @export
#' @import IRanges
#' @import GenomicRanges
#' @importFrom S4Vectors mcols DataFrame
#' @importClassesFrom graph graphNEL
#' @importFrom graph ugraph
#' @importFrom RBGL connectedComp
#' @importFrom utils data
#' @examples
#' 
#'     if (interactive())
#'     {    
#'     peaks1 = 
#'         GRanges(seqnames=c(6,6,6,6,5), 
#'                 IRanges(start=c(1543200,1557200,1563000,1569800,167889600),
#'                         end=c(1555199,1560599,1565199,1573799,167893599),
#'                         names=c("p1","p2","p3","p4","p5")),
#'                 strand=as.integer(1))
#'     peaks2 = 
#'         GRanges(seqnames=c(6,6,6,6,5), 
#'                 IRanges(start=c(1549800,1554400,1565000,1569400,167888600),
#'                         end=c(1550599,1560799,1565399,1571199,167888999),
#'                         names=c("f1","f2","f3","f4","f5")),
#'                 strand=as.integer(1))
#'     t1 =findOverlappingPeaks(peaks1, peaks2, maxgap=1000, 
#'           NameOfPeaks1="TF1", NameOfPeaks2="TF2", select="all", annotate=1) 
#'     r = t1$OverlappingPeaks
#'     pie(table(r$overlapFeature))
#'     as.data.frame(t1$MergedPeaks)
#'     }
#' 
findOverlappingPeaks <- function(Peaks1, Peaks2, maxgap = -1L,minoverlap=0L,
                                 multiple = c(TRUE, FALSE),
                                 NameOfPeaks1 = "TF1", NameOfPeaks2 = "TF2", 
                                 select=c("all", "first", "last", "arbitrary"), 
                                 annotate =0, ignore.strand=TRUE, 
                                 connectedPeaks=c("min", "merge"), ...){
        .Deprecated("findOverlapsOfPeaks")
        ###check inputs
        NAME_conn_string <- "___conn___"
        NAME_short_string <- "__"
        NAME_long_string <- "///"
        PeaksList <- list(...)
        PeaksList<-lapply(PeaksList, function(Peaks){
            if (!inherits(Peaks, "GRanges")) {
                stop("No valid Peaks passed in. It needs to be GRanges object")
            }
            if(any(is.na(names(Peaks))) || any(duplicated(names(Peaks)))) {
                message("duplicated or NA names found. 
                        Rename all the names by numbers.")
                names(Peaks) <- formatC(1:nrow(data), 
                                        width=nchar(nrow(data)), 
                                        flag='0')
            }
            Peaks
        })
        n <- length(PeaksList)
        if(n>0){
            if(n==1){
                PeaksList <- PeaksList[[1]]
                n <- length(PeaksList)
                names <- names(PeaksList)
                if(is.null(names)) names <- paste("peaks", seq.int(n), sep="")
            }else{
                ##save dots arguments names
                dots <- substitute(list(...))[-1]
                names <- unlist(sapply(dots, deparse))
            }
        }else{
            names <- NULL
        }
        if((!missing(Peaks1)) || (!missing(Peaks2))){
            if(!missing(Peaks2)){##
                if (!inherits(Peaks2, "GRanges")) {
                    stop("No valid Peaks passed in. 
                         It needs to be GRanges object")
                }
                if(n!=0) PeaksList <- c(list(Peaks2), PeaksList)
                else PeaksList <- list(Peaks2)
                n <- n+1
                if(missing(NameOfPeaks2)) NameOfPeaks2 <- "Peaks2"
                names <- c(NameOfPeaks2, names)
            }
            if(!missing(Peaks1)){
                if (!inherits(Peaks1, "GRanges")) {
                    stop("No valid Peaks passed in. 
                         It needs to be GRanges object")
                }
                if(n!=0) PeaksList <- c(list(Peaks1), PeaksList)
                else PeaksList <- list(Peaks1)
                n <- n+1
                if(missing(NameOfPeaks1)) NameOfPeaks1 <- "Peaks1"
                names <- c(NameOfPeaks1, names)
            }
        }
        if(n<2){
            stop("Missing required argument Peaks!")
        }
        if(n>5){
            stop("The length of input peaks list should no more than 5")
        }
        connectedPeaks <- match.arg(connectedPeaks)
        if(any(duplicated(names)))
            stop("Same input Peaks detected!")
        ##handle colnames of metadata
        metacolnames <- lapply(PeaksList, function(Peaks)
            colnames(mcols(Peaks)))
        metacolnames <- Reduce(intersect, metacolnames)
        metacolclass <- do.call(rbind, lapply(PeaksList, function(Peaks)
            sapply(mcols(Peaks)[, metacolnames, drop=FALSE], 
                   function(.ele) class(.ele)[1])))
        metacolclass <- apply(metacolclass, 2, 
                              function(.ele) length(unique(.ele))==1)
        metacolnames <- metacolnames[metacolclass]
        PeaksList <- lapply(PeaksList, function(Peaks){
            mcols(Peaks) <- mcols(Peaks)[, metacolnames]
            Peaks
        })
        ##get all merged peaks
        for(i in 1:n){
            names(PeaksList[[i]]) <- 
                paste(names[i], names(PeaksList[[i]]), 
                      sep=NAME_conn_string)
        }
        Peaks <- unlist(GRangesList(PeaksList))
        if(ignore.strand) strand(Peaks) <- "*"
        
        ol <- as.data.frame(findOverlaps(Peaks, maxgap=maxgap, 
                                         minoverlap=minoverlap, 
                                         select="all",
                                         drop.self=TRUE, 
                                         drop.redundant=TRUE))
        olm <- cbind(names(Peaks[ol[,1]]), names(Peaks[ol[,2]]))
        edgeL <- c(split(olm[,2], olm[,1]), split(olm[,1], olm[,2]))
        nodes <- unique(as.character(olm))
        ##use graph to extract all the connected peaks
        gR <- new("graphNEL", nodes=nodes, edgeL=edgeL)
        Merged <- connectedComp(ugraph(gR))        
        Left <- as.list(names(Peaks)[!names(Peaks) %in% nodes])
        all <- c(Merged, Left)
        
        ##venn count
        ncontrasts <- n
        noutcomes <- 2^ncontrasts
        outcomes <- matrix(0,noutcomes,ncontrasts)
        colnames(outcomes) <- names
        for (j in 1:ncontrasts)
            outcomes[,j] <- rep(0:1,times=2^(j-1), 
                                each=2^(ncontrasts-j))
        xlist <- list()
        xlist1 <- list()
        for (i in 1:ncontrasts){
            xlist[[i]] <- factor(as.numeric(unlist(lapply(all, function(.ele) 
                any(grepl(paste("^",
                                names[ncontrasts-i+1], 
                                NAME_conn_string, sep=""), .ele))))),
                                 levels=c(0,1))
            if(connectedPeaks=="merge"){
                xlist1[[i]] <- xlist[[i]]
            }else{
                xlist1[[i]] <- 
                    factor(as.numeric(unlist(lapply(all, function(.ele) {
                    ##count involved nodes in each group
                    if(length(.ele)>2){
                        .ele <- gsub(paste(NAME_conn_string, ".*?$", sep=""), 
                                     "", .ele)
                        .ele <- table(.ele)
                        rep(names[ncontrasts-i+1] %in% names(.ele), 
                            min(.ele))
                    }else{
                        any(grepl(paste("^",names[ncontrasts-i+1], 
                                        NAME_conn_string, sep=""), 
                                  .ele))
                    }
                }))), levels=c(0,1))
            }
        }
        counts <- as.vector(table(xlist1))
        venn_cnt <- structure(cbind(outcomes, Counts=counts), 
                              class="VennCounts")
        xlist <- do.call(rbind, xlist)
        xlist <- xlist - 1
        xlist <- xlist[nrow(xlist):1,,drop=FALSE] 
        ## reverse xlist to match the order of names
        xlist <- apply(xlist, 2, base::paste, collapse="")
        all <- do.call(rbind, mapply(function(.ele, .id) cbind(.id, .ele), 
                                     all, 1:length(all), SIMPLIFY=FALSE))
        all.peaks <- Peaks[all[,2]]
        all.peaks$gpForFindOverlapsOfPeaks <- all[, 1]
        all.peaks.rd <- reduce(all.peaks, min.gapwidth=maxgap+1L,
                               with.revmap=TRUE)
        mapping <- all.peaks.rd$revmap
        m <- sapply(mapping, length)
        mIndex <- rep(1:length(mapping), m)
        mLists <- unlist(mapping)
        mcols <- mcols(all.peaks[mLists])
        mcols$peakNames <- gsub(NAME_conn_string, 
                                NAME_short_string, 
                                names(all.peaks[mLists]))
        mcolsn <- sapply(mcols[1, ], function(.ele) class(.ele)[1])
        mapping <- DataFrame(HHH_row___H=1:length(all.peaks.rd))
        for(.name in names(mcolsn)){
            .dat <- split(mcols[, .name], mIndex)
            mapping[, .name] <- switch(mcolsn[.name],
                                       logical=LogicalList(.dat),
                                       integer=IntegerList(.dat),
                                       numeric=NumericList(.dat),
                                       character=CharacterList(.dat),
                                       rle=RleList(.dat),
                                       ComplexList(.dat))
        }
        mapping$HHH_row___H <- NULL
        mcols(all.peaks.rd) <- mapping
        names(all.peaks.rd) <- sapply(all.peaks.rd$peakNames, 
                                      base::paste,
                                      collapse=NAME_short_string)
        all.peaks.rd$gpForFindOverlapsOfPeaks <- 
            unlist(lapply(all.peaks.rd$gpForFindOverlapsOfPeaks, unique)) 
        all <- split(all.peaks.rd, all.peaks.rd$gpForFindOverlapsOfPeaks)
        all <- all[order(as.numeric(names(all)))] 
        ##important, and length(all)==length(xlist)
        if(length(all)!=length(xlist)) 
            stop("length of all should be equal to length of xlist. 
                 Please report the bug. Thanks.")
        listname <- apply(outcomes, 1, 
                          function(id) paste(names[as.logical(id)], 
                                             collapse=NAME_long_string))
        listcode <- apply(outcomes, 1, base::paste, collapse="")
        listname <- listname[-1]
        listcode <- listcode[-1]
        peaklist <- list()
        for(i in 1:length(listcode)){
            sublist <- all[xlist==listcode[i]]
            if(length(sublist)>0) 
                peaklist[[listname[i]]]<-unlist(sublist, use.names=FALSE)
        }
        correlation <- list()
        names(Peaks) <- gsub(NAME_conn_string, NAME_short_string, names(Peaks))
        npl <- names(peaklist)
        for(i in seq_along(npl))
        {
            npln <- unlist(strsplit(npl[i], NAME_long_string))
            if(length(npln)==2){
                pl <- peaklist[[i]]$peakNames
                pl <- pl[sapply(pl, length)>1]
                pl1 <- lapply(pl, 
                              function(.ele) 
                                  .ele[grepl(paste("^", npln[1], 
                                                   NAME_short_string, 
                                                   sep=""), 
                                             .ele)][1])
                pl2 <- lapply(pl, 
                              function(.ele) 
                                  .ele[grepl(paste("^", npln[2], 
                                                   NAME_short_string, 
                                                   sep=""), .ele)][1])
                idsel <- mapply(function(.p1, .p2) is.na(.p1)+is.na(.p2)==0, 
                                pl1, pl2)
                pl1 <- Peaks[unlist(pl1[idsel])]
                pl2 <- Peaks[unlist(pl2[idsel])]
                cl <- 
                    getRelationship(pl1, pl2)[,c("insideFeature", 
                                                 "shortestDistance")]
                colnames(cl)[grepl("insideFeature", colnames(cl))] <- 
                    "overlapFeature"
                correlation[[npl[i]]] <- 
                    cbind(peaks1=names(pl1), as.data.frame(pl1), 
                          peaks2=names(pl2), as.data.frame(pl2), 
                          cl)
                rownames(correlation[[npl[i]]]) <- 
                    paste(names(pl1), names(pl2), sep="_")
            }
        }
        for(i in 1:length(peaklist)){
            peaklist[[i]]$gpForFindOverlapsOfPeaks <- NULL
        }
        
        if((!missing(Peaks1)) && (!missing(Peaks2))){
            sampleName <- 
                npl==paste(NameOfPeaks1, 
                           NAME_long_string, 
                           NameOfPeaks2, sep="")
            if(!any(sampleName)) 
                sampleName <- npl==paste(NameOfPeaks2, 
                                         NAME_long_string, 
                                         NameOfPeaks1, sep="")
            sampleName <- npl[sampleName]
            Peaks1withOverlaps <- 
                Peaks[names(Peaks) %in% correlation[[sampleName]]$peaks1]
            names(Peaks1withOverlaps) <- 
                gsub(paste(NameOfPeaks1, NAME_short_string, sep=""), 
                     "", 
                     names(Peaks1withOverlaps))
            Peaks2withOverlaps <- 
                Peaks[names(Peaks) %in% correlation[[sampleName]]$peaks2]
            names(Peaks2withOverlaps) <- 
                gsub(paste(NameOfPeaks2, NAME_short_string, sep=""), 
                     "", 
                     names(Peaks2withOverlaps))
            mergedPeaks <- peaklist[[sampleName]]##To fit old version
            mergedPeaks$peakNames <- NULL
            structure(list(venn_cnt=venn_cnt, 
                           peaklist=peaklist, 
                           overlappingPeaks=correlation,
                           OverlappingPeaks=correlation[[sampleName]],
                           MergedPeaks=mergedPeaks,##
                           Peaks1withOverlaps=Peaks1withOverlaps,
                           Peaks2withOverlaps=Peaks2withOverlaps), 
                      class="overlappingPeaks")
        }else{
            structure(list(venn_cnt=venn_cnt, 
                           peaklist=peaklist, 
                           overlappingPeaks=correlation), 
                      class="overlappingPeaks")
        }
    }

#' Deprecated Functions in Package ChIPpeakAnno
#' 
#' These functions are provided for compatibility with older versions of R
#' only, and may be defunct as soon as the next release.
#' 
#' findOverlappingPeaks is now deprecated wrappers for
#' \code{\link{findOverlapsOfPeaks}}
#' @rdname ChIPpeakAnno-deprecated
#' @param Peaks1 GRanges: See example below.
#' @param Peaks2 GRanges: See example below.
#' @param maxgap,minoverlap Used in the internal call to \code{findOverlaps()}
#' to detect overlaps. See
#' \code{?\link[IRanges:findOverlaps-methods]{findOverlaps}} in the
#' \pkg{IRanges} package for a description of these arguments.
#' @param multiple TRUE or FALSE: TRUE may return multiple overlapping peaks in
#' Peaks2 for one peak in Peaks1; FALSE will return at most one overlapping
#' peaks in Peaks2 for one peak in Peaks1. This parameter is kept for backward
#' compatibility, please use select.
#' @param NameOfPeaks1 Name of the Peaks1, used for generating column name.
#' @param NameOfPeaks2 Name of the Peaks2, used for generating column name.
#' @param select all may return multiple overlapping peaks, first will return
#' the first overlapping peak, last will return the last overlapping peak and
#' arbitrary will return one of the overlapping peaks.
#' @param annotate Include overlapFeature and shortestDistance in the
#' OverlappingPeaks or not.  1 means yes and 0 means no. Default to 0.
#' @param ignore.strand When set to TRUE, the strand information is ignored in
#' the overlap calculations.
#' @param connectedPeaks If multiple peaks involved in overlapping in several
#' groups, set it to "merge" will count it as only 1, while set it to "min"
#' will count it as the minimal involved peaks in any concered groups
#' @param \dots Objects of \link[GenomicRanges:GRanges-class]{GRanges}: See
#' also \code{\link{findOverlapsOfPeaks}}.
#' @seealso \code{\link{Deprecated}}, \link{findOverlapsOfPeaks},
#' \link{toGRanges}
#' @name ChIPpeakAnno-deprecated
NULL

#' Genomic Element data for upset plot
#' 
#' Prepare data for upset plot for genomic element distribution
#' 
#' @details The data will be calculated by for each breaks. 
#' No precedence will be considered. 
#' @param peaks peak list, \link[GenomicRanges:GRanges-class]{GRanges} object or
#' a \link[GenomicRanges:GRangesList-class]{GRangesList}.
#' @param TxDb an object of \code{\link[GenomicFeatures:TxDb-class]{TxDb}}
#' @param seqlev sequence level should be involved. 
#' Default is all the sequence levels in intersect of peaks and TxDb.
#' @param ignore.strand logical. Whether the strand of the input ranges
#' should be ignored or not. Default=TRUE
#' @param breaks list. A list for labels and sets for the genomic elements.
#' The element could be an S4 method for signature 'TxDb' or a numeric vector
#' with length of 4. The three numbers are 
#' c(upstream point, downstream point, promoter (-1) or downstream (1),
#'  remove gene body or not (1: remove, 0: keep)).
#' @export
#' @importFrom GenomicFeatures intronsByTranscript exons fiveUTRsByTranscript 
#' threeUTRsByTranscript genes cds promoters
#' @return list of data for plot.
#' @examples 
#' if (interactive() || Sys.getenv("USER")=="jou"){
#'   data(myPeakList)
#'   if(require(TxDb.Hsapiens.UCSC.hg19.knownGene)){
#'   seqinfo(myPeakList) <- 
#'   seqinfo(TxDb.Hsapiens.UCSC.hg19.knownGene)[seqlevels(myPeakList)]
#'   myPeakList <- GenomicRanges::trim(myPeakList)
#'   myPeakList <- myPeakList[width(myPeakList)>0]
#'   x <- genomicElementUpSetR(myPeakList, 
#'     TxDb.Hsapiens.UCSC.hg19.knownGene)
#'   library(UpSetR)
#'   upset(x$plotData, nsets=13, nintersects=NA)
#'   }
#' }
genomicElementUpSetR <- 
  function(peaks, TxDb, seqlev, ignore.strand=TRUE,
           breaks = 
             list("distal_upstream"=c(-100000, -10000, -1, 1), 
                  "proximal_upstream"=c(-10000,-5000, -1, 1),
                  "distal_promoter"=c(-5000, -2000, -1, 1),
                  "proximal_promoter"=c(-2000, 200, -1, 0),
                  "5'UTR"=fiveUTRsByTranscript,
                  "3'UTR"=threeUTRsByTranscript,
                  "CDS"=cds,
                  "exon"=exons,
                  "intron"=intronsByTranscript,
                  "gene_body"=genes,
                  "immediate_downstream"=c(0, 2000, 1, 1),
                  "proximal_downstream"=c(2000, 5000, 1, 1),
                  "distal_downstream"=c(5000, 100000, 1, 1))){
    stopifnot("peaks must be an object of GRanges or GRangesList"=
                inherits(peaks, c("GRanges", "GRangesList")))
    if(is(peaks, "GRanges")){
      n <- deparse(substitute(peaks))
      peaks <- GRangesList(peaks)
      names(peaks) <- n
      isGRanges <- TRUE
    }else{
      isGRanges <- FALSE
    }
    stopifnot("TxDb must be an object of TxDb"=is(TxDb, "TxDb"))
    
    defaultW <- getOption("warn")
    options(warn = -1)
    on.exit({warn = defaultW})
    
    seql <- seqlevelsStyle(peaks)
    
    ## set annotation
    suppressMessages(g <- genes(TxDb, single.strand.genes.only=TRUE))
    
    anno <- lapply(breaks, function(.ele){
      stopifnot("Elements of breaks must be function or numeric(4)"=
                  is.function(.ele)||is.numeric(.ele))
      if(is.numeric(.ele)){
        stopifnot("Elements of breaks must be function or numeric(4)"=
                    length(.ele)==4)
        ## upstream or downstream
        ups_dws <- function(n){
          ifelse(n[3]==-1,
                 ifelse(all(n[1:2]<0), "uu", 
                        ifelse(all(n[1:2]>0), "pp", "ups")),
                 ifelse(all(n[1:2]>0), "dd", 
                        ifelse(all(n[1:2]<0), "ww", "dws")))
        }
        x <- ups_dws(.ele)
        fil <- .ele[4]
        .ele <- .ele[1:2]
        .ele <- switch(x,
                      "uu"={
                        a <- promoters(g, upstream = abs(min(.ele)), 
                                       downstream = 0)
                        b <- promoters(g, upstream = abs(max(.ele)),
                                       downstream = 0)
                        filterByOverlaps(a, b,
                                         ignore.strand = ignore.strand)
                      },
                      "ups"={
                        promoters(g, upstream = abs(min(.ele)), 
                                  downstream = abs(max(.ele)))
                      },
                      "pp"={
                        a <- promoters(g, upstream = 0, 
                                       downstream = max(.ele))
                        b <- promoters(g, upstream = 0,
                                       downstream = min(.ele))
                        filterByOverlaps(a, b,
                                         ignore.strand = ignore.strand)
                      },
                      "dd"={
                        a <- downstreams(g, upstream = 0, 
                                       downstream = max(.ele))
                        b <- downstreams(g, upstream = 0,
                                       downstream = min(.ele))
                        filterByOverlaps(a, b,
                                         ignore.strand = ignore.strand)
                      },
                      "dws"={
                        downstreams(g, upstream = abs(min(.ele)),
                                    downstream = abs(max(.ele)))
                      },
                      "ww"={
                        a <- downstreams(g, upstream = abs(min(.ele)), 
                                         downstream = 0)
                        b <- downstreams(g, upstream = abs(max(.ele)),
                                         downstream = 0)
                        filterByOverlaps(a, b,
                                         ignore.strand = ignore.strand)
                      })
        if(fil==1){
          .ele <- filterByOverlaps(.ele, g, ignore.strand = ignore.strand)
        }
        seqlevelsStyle(.ele) <- seql[1]
        return(.ele)
      }
      if(is.function(.ele)){
        .ele <- .ele(TxDb)
        if(is(.ele, 'GRangesList')) .ele <- unlist(.ele)
        seqlevelsStyle(.ele) <- seql[1]
        return(.ele)
      }
    })
    l <- lengths(anno)
    n <- names(anno)
    anno <- unlist(GRangesList(anno))
    mcols(anno) <- DataFrame(type=rep(n, l))
    
    ## filter peaks by seqlev
    if(!missing(seqlev)){
      if(length(seqlev)>0){
        peaks <- lapply(peaks, 
                        function(.ele) .ele[seqnames(.ele) %in% seqlev])
      }
    }
    
    peaks <- lapply(peaks, FUN = function(.peaks){
      .peaks$id <- seq_along(.peaks)
      ol <- findOverlaps(.peaks, anno, ignore.strand=ignore.strand)
      .peaks$annoType <- "undefined"
      .p1 <- .peaks[-unique(queryHits(ol))]
      .p2 <- .peaks[queryHits(ol)]
      .p2$annoType <- anno$type[subjectHits(ol)]
      .peaks <- c(.p1, .p2)
      .peaks[order(.peaks$id)]
    })
    if(isGRanges){
      peaks <- peaks[[1]]
    }
    melt <- function(.ele){
      .i <- unique(.ele$id)
      .j <- c(names(breaks), "undefined")
      x <- matrix(0, nrow = length(.i), ncol = length(.j))
      colnames(x) <- .j
      rownames(x) <- .i
      .ele <- split(.ele$id, .ele$annoType)
      for(i in seq_along(.ele)){
        x[.ele[[i]], names(.ele)[i]] <- 1
      }
      as.data.frame(x)
    }
    if(isGRanges){## for upset
      dat <- melt(peaks)
    }else{## bar-plot
      dat <- lapply(peaks, melt)
    }
    
    return(list(peaks=peaks, plotData=dat))
  }

#' Filter peaks by IDR (irreproducible discovery rate)
#' 
#' Using IDR to assess the consistency of replicate experiments and obtain a
#' high-confidence single set of peaks
#' 
#' 
#' @param peaksA,peaksB peaklist, \link[GenomicRanges:GRanges-class]{GRanges}
#' object.
#' @param bamfileA,bamfileB file path of bam files.
#' @param maxgap,minoverlap Used in the internal call to \code{findOverlaps()}
#' to detect overlaps. See
#' \code{?\link[IRanges:findOverlaps-methods]{findOverlaps}} in the
#' \pkg{IRanges} package for a description of these arguments.
#' @param singleEnd (Default TRUE) A logical indicating if reads are single or
#' paired-end.
#' @param IDRcutoff If the IDR no less than IDRcutoff, the peak will be
#' removed.
#' @param ...  Not used.
#' @return An object GRanges
#' @author Jianhong Ou
#' @references Li, Qunhua, et al. "Measuring reproducibility of high-throughput
#' experiments." The annals of applied statistics (2011): 1752-1779.
#' @keywords misc
#' @export
#' @importFrom GenomicAlignments summarizeOverlaps Union
#' @importFrom SummarizedExperiment assay
#' @examples
#' 
#'   if(interactive()){
#'     path <- system.file("extdata", "reads", package="MMDiffBamSubset")
#'     if(file.exists(path)){
#'             bamfileA <- file.path(path, "reads", "WT_2.bam")
#'             bamfileB <- file.path(path, "reads", "Resc_2.bam")
#'             WT.AB2.Peaks <- file.path(path, "peaks", "WT_2_Macs_peaks.xls")
#'             Resc.AB2.Peaks <- file.path(path, "peaks",
#'                                        "Resc_2_Macs_peaks.xls")
#'             peaksA=toGRanges(WT.AB2.Peaks, format="MACS")
#'             peaksB=toGRanges(Resc.AB2.Peaks, format="MACS")
#'             library(idr)
#'             library(DelayedArray)
#'             IDRfilter(peaksA, peaksB,
#'                         bamfileA, bamfileB)
#'     }
#'   }
#' 
IDRfilter <- function(peaksA, peaksB, bamfileA, bamfileB, 
                      maxgap=-1L, minoverlap=0L, singleEnd=TRUE,
                      IDRcutoff=0.01, ...){
    if(!requireNamespace("idr", quietly = TRUE)){
        stop("The 'idr' package is required.")
    }
    if(!requireNamespace("DelayedArray", quietly = TRUE)){
        stop("The 'DelayedArray' package is required.")
    }
    stopifnot(is(peaksA,"GRanges"))
    stopifnot(is(peaksB,"GRanges"))
    stopifnot(file.exists(bamfileA))
    stopifnot(file.exists(bamfileB))
    ol <- findOverlapsOfPeaks(peaksA, peaksB, 
                              maxgap=maxgap, 
                              minoverlap=minoverlap)
    ol <- ol$peaklist[grepl("\\/\\/\\/", names(ol$peaklist))][[1]]
    if(length(ol)<1) return(GRanges())
    names(ol) <- paste0("olp", 
                        formatC(1:length(ol), 
                                width=nchar(as.character(length(ol))),
                                flag="0"))
    coverage <- summarizeOverlaps(features = ol, 
                                  reads = c(bamfileA, bamfileB),
                                  mode=Union, 
                                  ignore.strand = FALSE, 
                                  singleEnd=singleEnd)
    idr <- idr::est.IDR(assay(coverage)/width(
        DelayedArray::rowRanges(coverage)),
                   mu=2.07, sigma=1.34, rho=0.89, p=0.84)
    ol[idr$IDR<IDRcutoff]
}

#' Slide windows on a given \link[GenomicRanges:GRanges-class]{GRanges} object
#' 
#' tileGRanges returns a set of genomic regions by sliding the windows in a
#' given step. Each window is called a "tile".
#' 
#' 
#' @param targetRegions A \link[GenomicRanges:GRanges-class]{GRanges} object of
#' genomic regions of interest.
#' @param windowSize Size of windows
#' @param step Step of windows
#' @param keepPartialWindow Keep last partial window or not.
#' @param ...  Not used.
#' @return A \link[GenomicRanges:GRanges-class]{GRanges} object.
#' @author Jianhong Ou
#' @keywords misc
#' @export
#' @examples
#' 
#'     genes <- GRanges(
#'         seqnames = c(rep("chr2L", 4), rep("chr2R", 5), rep("chr3L", 2)),
#'         ranges = IRanges(c(1000, 3000, 4000, 7000, 2000, 3000, 3600, 
#'                            4000, 7500, 5000, 5400), 
#'                          width=c(rep(500, 3), 600, 900, 500, 300, 900, 
#'                                  300, 500, 500),
#'                          names=letters[1:11])) 
#'     se <- tileGRanges(genes, windowSize=50, step=10)
#' 
tileGRanges <- function(targetRegions, windowSize, 
                        step, keepPartialWindow=FALSE, ...){
    if(any(width(targetRegions)<windowSize) | any(width(targetRegions)<step)){
        warning("Some of chromosomes are smaller than windowSize or step.",
                "They will be removed.")
    }
    targetRegions <- targetRegions[width(targetRegions)>=windowSize]
    targetRegions <- targetRegions[width(targetRegions)>=step]
    tileTargetRanges <- tile(x=ranges(targetRegions), width=step)
    nt <- elementNROWS(tileTargetRanges)
    tileTargetRanges.end <- rep(end(targetRegions), nt)
    tileTargetRanges <- unlist(tileTargetRanges)
    width(tileTargetRanges) <- windowSize
    tileTargetRegions <- GRanges(rep(seqnames(targetRegions), nt), 
                                 tileTargetRanges,
                                 rep(strand(targetRegions), nt),
                                 oid=rep(1:length(targetRegions), nt))
    id <- end(tileTargetRanges) > tileTargetRanges.end
    if(keepPartialWindow){
        end(tileTargetRegions[id]) <- tileTargetRanges.end[id]
    }else{
        tileTargetRegions <- 
            tileTargetRegions[!id]
    }
    return(tileTargetRegions)
}

expandGR <- function(gr, size){
    if(size == 0){
        return(gr)
    }
    if(!is(gr, "GRanges")){
        stop("gr must be an object of GRanges")
    }
    if(size < 0){
        gr <- gr[width(gr)>2*abs(size)]
    }
    
    suppressWarnings({
        start(gr) <- start(gr) - size
        end(gr) <- end(gr) + size
    })
    
    gr <- trim(gr)
    gr
}

#import GenomicFeatures
## Jianhong Ou @ Mar.20, 2013


#' Summarize peak distribution over exon, intron, enhancer, proximal promoter,
#' 5 prime UTR and 3 prime UTR
#' 
#' Summarize peak distribution over exon, intron, enhancer, proximal promoter,
#' 5 prime UTR and 3 prime UTR
#' 
#' 
#' @param peaks.RD peaks in GRanges: See example below
#' @param exon exon data obtained from getAnnotation or customized annotation
#' of class GRanges containing additional variable: strand (1 or + for plus
#' strand and -1 or - for minus strand). This parameter is for backward
#' compatibility only.  \code{\link[GenomicFeatures:TxDb-class]{TxDb}} should
#' be used instead.
#' @param TSS TSS data obtained from getAnnotation or customized annotation of
#' class GRanges containing additional variable: strand (1 or + for plus strand
#' and -1 or - for minus strand). For example,
#' data(TSS.human.NCBI36),data(TSS.mouse.NCBIM37), data(TSS.rat.RGSC3.4) and
#' data(TSS.zebrafish.Zv8). This parameter is for backward compatibility only.
#' \code{\link[GenomicFeatures:TxDb-class]{TxDb}} should be used instead.
#' @param utr5 5 prime UTR data obtained from getAnnotation or customized
#' annotation of class GRanges containing additional variable: strand (1 or +
#' for plus strand and -1 or - for minus strand). This parameter is for
#' backward compatibility only.  \code{\link[GenomicFeatures:TxDb-class]{TxDb}}
#' should be used instead.
#' @param utr3 3 prime UTR data obtained from getAnnotation or customized
#' annotation of class GRanges containing additional variable: strand (1 or +
#' for plus strand and -1 or - for minus strand). This parameter is for
#' backward compatibility only.  \code{\link[GenomicFeatures:TxDb-class]{TxDb}}
#' should be used instead.
#' @param proximal.promoter.cutoff Specify the cutoff in bases to classify
#' proximal promoter or enhencer. Peaks that reside within
#' proximal.promoter.cutoff upstream from or overlap with transcription start
#' site are classified as proximal promoters. Peaks that reside upstream of the
#' proximal.promoter.cutoff from gene start are classified as enhancers. The
#' default is upstream 2000 bases and downstream 100 bases.
#' @param immediate.downstream.cutoff Specify the cutoff in bases to classify
#' immediate downstream region or enhancer region. Peaks that reside within
#' immediate.downstream.cutoff downstream of gene end but not overlap 3 prime
#' UTR are classified as immediate downstream.  Peaks that reside downstream
#' over immediate.downstreatm.cutoff from gene end are classified as enhancers.
#' The default is upstream 0 bases and downstream 1000 bases.
#' @param nucleotideLevel Logical. Choose between peak centric and nucleotide
#' centric view. Default=FALSE
#' @param precedence If no precedence specified, double count will be enabled,
#' which means that if a peak overlap with both promoter and 5'UTR, both
#' promoter and 5'UTR will be incremented. If a precedence order is specified,
#' for example, if promoter is specified before 5'UTR, then only promoter will
#' be incremented for the same example.  The values could be any conbinations
#' of "Promoters", "immediateDownstream", "fiveUTRs", "threeUTRs", "Exons" and
#' "Introns", Default=NULL
#' @param TxDb an object of \code{\link[GenomicFeatures:TxDb-class]{TxDb}} or
#' similar including \code{\link[ensembldb:EnsDb-class]{EnsDb}}
#' @return A list of two named vectors: percentage and jaccard (Jaccard Index).
#' The information in the vectors: \item{list("Exons")}{Percent or the picard
#' index of the peaks resided in exon regions.} \item{list("Introns")}{Percent
#' or the picard index of the peaks resided in intron regions.}
#' \item{list("fiveUTRs")}{Percent or the picard index of the peaks resided in
#' 5 prime UTR regions.} \item{list("threeUTRs")}{Percent or the picard index
#' of the peaks resided in 3 prime UTR regions.}
#' \item{list("Promoter")}{Percent or the picard index of the peaks resided in
#' proximal promoter regions.} \item{list("ImmediateDownstream")}{Percent or
#' the picard index of the peaks resided in immediate downstream regions.}
#' \item{list("Intergenic.Region")}{Percent or the picard index of the peaks
#' resided in intergenic regions.}
#' 
#' The Jaccard index, also known as Intersection over Union.  The Jaccard index
#' is between 0 and 1. The higher the index, the more significant the overlap
#' between the peak region and the genomic features in consideration.
#' @author Jianhong Ou, Lihua Julie Zhu
#' @seealso \link{genomicElementDistribution}, \link{genomicElementUpSetR},
#' \link{binOverFeature}, \link{binOverGene}, \link{binOverRegions}
#' @references 1. Zhu L.J. et al. (2010) ChIPpeakAnno: a Bioconductor package
#' to annotate ChIP-seq and ChIP-chip data. BMC Bioinformatics 2010,
#' 11:237doi:10.1186/1471-2105-11-237
#' 
#' 2. Zhu L.J. (2013) Integrative analysis of ChIP-chip and ChIP-seq dataset.
#' Methods Mol Biol. 2013;1067:105-24. doi: 10.1007/978-1-62703-607-8_8.
#' @keywords misc
#' @export
#' @import IRanges
#' @import GenomicRanges
#' @importFrom GenomeInfoDb keepSeqlevels seqlevels
#' @importFrom BiocGenerics start end width strand
#' @importFrom GenomicFeatures exons intronsByTranscript fiveUTRsByTranscript 
#' threeUTRsByTranscript transcripts tRNAs
#' @examples
#' 
#' if (interactive() || Sys.getenv("USER")=="jou"){
#'     ##Display the list of genomes available at UCSC:
#'     #library(rtracklayer)
#'     #ucscGenomes()[, "db"]
#'     ## Display the list of Tracks supported by makeTxDbFromUCSC()
#'     #supportedUCSCtables()
#'     ##Retrieving a full transcript dataset for Human from UCSC
#'     ##TranscriptDb <- 
#'     ##     makeTxDbFromUCSC(genome="hg19", tablename="ensGene")
#'     if(require(TxDb.Hsapiens.UCSC.hg19.knownGene)){
#'       TxDb <- TxDb.Hsapiens.UCSC.hg19.knownGene
#'       exons <- exons(TxDb, columns=NULL)
#'       fiveUTRs <- unique(unlist(fiveUTRsByTranscript(TxDb)))
#'       Feature.distribution <- 
#'           assignChromosomeRegion(exons, nucleotideLevel=TRUE, TxDb=TxDb)
#'       barplot(Feature.distribution$percentage)
#'       assignChromosomeRegion(fiveUTRs, nucleotideLevel=FALSE, TxDb=TxDb)
#'       data(myPeakList)
#'       assignChromosomeRegion(myPeakList, nucleotideLevel=TRUE, 
#'                              precedence=c("Promoters", "immediateDownstream", 
#'                                           "fiveUTRs", "threeUTRs", 
#'                                           "Exons", "Introns"), 
#'                              TxDb=TxDb)
#'     }
#' }
#' 
assignChromosomeRegion <-
    function(peaks.RD, exon, TSS, utr5, utr3, 
             proximal.promoter.cutoff=c(upstream=2000, downstream=100), 
             immediate.downstream.cutoff=c(upstream=0, downstream=1000), 
             nucleotideLevel=FALSE, 
             precedence=NULL, TxDb=NULL)
    {
        ##check inputs
        if(!is.null(TxDb)){
            if(!inherits(TxDb, c("TxDb", "EnsDb"))) 
                stop("TxDb must be an object of TxDb or similar such as EnsDb, 
                     try\n?TxDb\tto see more info.")
            if(!inherits(peaks.RD, c("GRanges"))) 
                stop("peaks.RD must be a GRanges object.")
            if(!all(c("upstream", "downstream") %in%
                    names(proximal.promoter.cutoff))){
                stop("proximal.promoter.cutoff must contain elements upstream and downstream")
            }
            if(!all(c("upstream", "downstream") %in%
                    names(immediate.downstream.cutoff))){
              stop("immediate.downstream.cutoff must contain elements upstream and downstream")
            }
            if(!is.null(precedence)) {
                if(!all(precedence %in% c("Exons", "Introns", "fiveUTRs", 
                                          "threeUTRs", "Promoters", 
                                          "immediateDownstream"))) 
                    stop("precedence must be a combination of 
                         Exons, Introns, fiveUTRs, threeUTRs, 
                         Promoters, immediateDownstream")
            }
            ignore.strand <- all(as.character(strand(peaks.RD))=="*")
            exons <- exons(TxDb, columns=NULL)
            introns <- unique(unlist(intronsByTranscript(TxDb)))
            fiveUTRs <- unique(unlist(fiveUTRsByTranscript(TxDb)))
            threeUTRs <- unique(unlist(threeUTRsByTranscript(TxDb)))
            transcripts <- unique(transcripts(TxDb, columns=NULL))
            options(warn = -1)
            try({
                promoters <- 
                    unique(promoters(TxDb, upstream=proximal.promoter.cutoff["upstream"], 
                                     downstream=proximal.promoter.cutoff["downstream"]))
                immediateDownstream <- 
                    unique(downstreams(transcripts, 
                                 upstream=immediate.downstream.cutoff["upstream"], 
                                 downstream=immediate.downstream.cutoff["downstream"]))
                promoters <- GenomicRanges::trim(promoters)
                immediateDownstream <- GenomicRanges::trim(immediateDownstream)
            })
            # microRNAs <- tryCatch(microRNAs(TxDb), 
            #                       error=function(e) return(NULL))
            tRNAs <- tryCatch(tRNAs(TxDb), error=function(e) return(NULL))
            options(warn = 0)
            annotation <- list(exons, introns, fiveUTRs, threeUTRs, 
                               promoters, immediateDownstream)
            # if(!is.null(microRNAs)) 
            #     annotation <- c(annotation, "microRNAs"=microRNAs)
            if(!is.null(tRNAs)) 
                annotation <- c(annotation, "tRNAs"=tRNAs)
            annotation <- 
                lapply(annotation, function(.anno){mcols(.anno)<-NULL; .anno})
            names(annotation)[1:6] <- 
                c("Exons", "Introns", "fiveUTRs", "threeUTRs", 
                  "Promoters", "immediateDownstream")
            ###clear seqnames, the format should be chr+NUM
            peaks.RD <- formatSeqnames(peaks.RD, exons)
            peaks.RD <- unique(peaks.RD)
            annotation <- GRangesList(annotation)
            newAnno <- c(unlist(annotation))
            if(ignore.strand){
              newAnno.rd <- newAnno
              strand(newAnno.rd) <- "*"
              newAnno.rd <- reduce(trim(newAnno.rd))
              Intergenic.Region <- gaps(newAnno.rd, end=seqlengths(TxDb))
              Intergenic.Region <- 
                Intergenic.Region[strand(Intergenic.Region)=="*"]
            }else{
              newAnno.rd <- reduce(trim(newAnno))
              Intergenic.Region <- gaps(newAnno.rd, end=seqlengths(TxDb))
              Intergenic.Region <- 
                Intergenic.Region[strand(Intergenic.Region)!="*"]
            }
            if(!all(seqlevels(peaks.RD) %in% seqlevels(newAnno))){
                warning("peaks.RD has sequence levels not in TxDb.")
                sharedlevels <- 
                    intersect(seqlevels(newAnno), seqlevels(peaks.RD))
                peaks.RD <- keepSeqlevels(peaks.RD, sharedlevels, 
                                          pruning.mode="coarse")
            }
            mcols(peaks.RD) <- NULL
            if(!is.null(precedence)){
                annotation <- 
                    annotation[unique(c(precedence,names(annotation)))]
            }
            ##    annotation$Intergenic.Region <- peaks.RD
            names(Intergenic.Region) <- NULL
            annotation$Intergenic.Region <- Intergenic.Region
            anno.names <- names(annotation)
            ol.anno <- findOverlaps(peaks.RD, annotation,
                                    ignore.strand=ignore.strand)
            if(nucleotideLevel){
              ## calculate Jaccard index
              jaccardIndex <- unlist(lapply(annotation, function(.ele){
                intersection <- intersect(.ele, peaks.RD, 
                                          ignore.strand=ignore.strand)
                union <- union(.ele, peaks.RD, ignore.strand=ignore.strand)
                sum(as.numeric(width(intersection)))/
                    sum(as.numeric(width(union)))
              }))
              jaccardIndex <- jaccardIndex[anno.names]
              names(jaccardIndex) <- anno.names
              jaccardIndex[is.na(jaccardIndex)] <- 0
              
              ## create a new annotations
              newAnno <- unlist(annotation)
              newAnno$source <- rep(names(annotation), lengths(annotation))
              newAnno.disjoin <- disjoin(newAnno, with.revmap=TRUE, 
                                         ignore.strand=ignore.strand)
              if(!is.null(precedence)){
                revmap <- cbind(from=unlist(newAnno.disjoin$revmap), 
                                to=rep(seq_along(newAnno.disjoin), 
                                       lengths(newAnno.disjoin$revmap)))
                revmap <- revmap[order(revmap[, "to"], revmap[, "from"]), , drop=FALSE]
                revmap <- revmap[!duplicated(revmap[, "to"]), , drop=FALSE]
                newAnno.disjoin$source <- newAnno[revmap[, "from"]]$source
              }else{
                revmap <- unlist(newAnno.disjoin$revmap)
                newAnno.disjoin <- rep(newAnno.disjoin, lengths(newAnno.disjoin$revmap))
                newAnno.disjoin$source <- newAnno[revmap]$source
              }
              newAnno.disjoin$revmap <- NULL
              ol.anno <- findOverlaps(peaks.RD, newAnno.disjoin, ignore.strand=ignore.strand)
              queryHits <- peaks.RD[queryHits(ol.anno)]
              subjectHits <- newAnno.disjoin[subjectHits(ol.anno)]
              totalLen <- sum(as.numeric(width(peaks.RD)))
              queryHits.list <- split(queryHits, subjectHits$source)
              lens <- unlist(lapply(queryHits.list, function(.ele) 
                sum(as.numeric(width(unique(.ele))))))
              percentage <- 100 * lens/totalLen
            }else{
                ##calculate Jaccard index
                ol.anno.splited <- split(queryHits(ol.anno),
                                         anno.names[subjectHits(ol.anno)])
                jaccardIndex <- unlist(lapply(anno.names, function(.name){
                    union <- length(annotation[[.name]]) + 
                        length(peaks.RD) - 
                        length(unique(subjectHits(findOverlaps(peaks.RD, 
                                                               annotation[[.name]], 
                                                               ignore.strand=ignore.strand))))
                    intersection <- length(ol.anno.splited[[.name]])
                    intersection/union
                }))
                names(jaccardIndex) <- anno.names
                ol.anno <- as.data.frame(ol.anno)
                ####keep the part only annotated in peaks.RD for peaks.RD
                ol.anno.splited <- split(ol.anno, ol.anno[,2])
                hasAnnoHits <- 
                  do.call(rbind, 
                          ol.anno.splited[names(ol.anno.splited)!=
                                            as.character(length(annotation))])
                hasAnnoHits <- unique(hasAnnoHits[,1])
                ol.anno <- 
                  ol.anno[!(ol.anno[,2]==length(annotation) & 
                              (ol.anno[,1] %in% hasAnnoHits)), ]    
                if(!is.null(precedence)){
                  ol.anno <- ol.anno[!duplicated(ol.anno[,1]), ]
                }
                ##calculate percentage
                subjectHits <-anno.names[ol.anno[,2]]
                counts <- table(subjectHits)
                percentage <- 100 * counts / length(peaks.RD)
            }
            len <- length(anno.names) - length(percentage)
            if(len>0) {
                tobeadd <- rep(0, len)
                names(tobeadd) <- anno.names[!anno.names %in% 
                                                 names(percentage)]
                percentage <- c(percentage, tobeadd)
            }
            percentage <- percentage[anno.names]
            return(list(percentage=percentage, jaccard=jaccardIndex))
        }else{
            message("Please try to use TxDb next time. Try\n
                    ?TxDb\tto see more info.")
            annotationList <- list(exon, TSS, utr5, utr3)
            names(annotationList) <- c("Exon", "TSS", "UTR5", "UTR3")
            status <- lapply(annotationList, function(.ele) {
                if(!inherits(.ele, "GRanges")){
                    stop("Annotation of exon, TSS, utr5, utr3 must 
                         be objects of GRanges.")
                }
            })
            if(!inherits(peaks.RD, "GRanges")) 
                stop("peaks.RD must be a GRanges object.") 
            ann.peaks <- annotatePeakInBatch(peaks.RD, AnnotationData = TSS)
            ann.peaks <- ann.peaks[!is.na(ann.peaks$distancetoFeature)]
            upstream <- 
                ann.peaks[ ann.peaks$insideFeature=="upstream" | 
                               (ann.peaks$distancetoFeature<0 & 
                                    ann.peaks$insideFeature == "overlapStart" & 
                                    abs(ann.peaks$distancetoFeature) >
                                    ann.peaks$shortestDistance ) | 
                               ann.peaks$insideFeature=="includeFeature" | 
                               (ann.peaks$distancetoFeature>=0 & 
                                    ann.peaks$insideFeature =="overlapStart" & 
                                    ann.peaks$distancetoFeature ==
                                    ann.peaks$shortestDistance)]
            
            proximal.promoter.n <- 
                length(upstream[upstream$distancetoFeature >= 
                                    -proximal.promoter.cutoff | 
                                    upstream$shortestDistance <= 
                                    proximal.promoter.cutoff])
            enhancer.n <- length(upstream) - proximal.promoter.n
            
            downstream <- ann.peaks[ann.peaks$insideFeature =="downstream"]
            immediateDownstream.n <- 
                length(downstream[downstream$distancetoFeature <= 
                                      immediate.downstream.cutoff,])
            enhancer.n <- enhancer.n + 
                dim(downstream[downstream$distancetoFeature > 
                                   immediate.downstream.cutoff,])
            
            inside.peaks <- 
                ann.peaks[ann.peaks$insideFeature =="inside" | 
                              ann.peaks$insideFeature ==
                              "overlapEnd" |  
                              (ann.peaks$insideFeature == "overlapStart" & 
                                   ann.peaks$distancetoFeature >=0 & 
                                   ann.peaks$distancetoFeature != 
                                   ann.peaks$shortestDistance) | 
                              (ann.peaks$insideFeature =="overlapStart" & 
                                   ann.peaks$distancetoFeature <0 & 
                                   abs(ann.peaks$distancetoFeature) ==
                                   ann.peaks$shortestDistance)]
            
            ann.utr5.peaks <- annotatePeakInBatch(inside.peaks, 
                                                  AnnotationData = utr5)
            
            proximal.promoter.n <- proximal.promoter.n + 
                length(ann.utr5.peaks[ann.utr5.peaks$insideFeature==
                                          "upstream"])
            
            utr5.n <- length(
                ann.utr5.peaks[ann.utr5.peaks$insideFeature %in% 
                                   c("includeFeature" , "inside") | 
                               (ann.utr5.peaks$insideFeature =="overlapStart" & 
                                    ann.utr5.peaks$distancetoFeature >=0 & 
                                    ann.utr5.peaks$distancetoFeature != 
                                    ann.utr5.peaks$shortestDistance)  | 
                                (ann.utr5.peaks$insideFeature =="overlapStart" & 
                                     ann.utr5.peaks$distancetoFeature <0 & 
                                     abs(ann.utr5.peaks$distancetoFeature)==
                                     ann.utr5.peaks$shortestDistance) | 
                                (ann.utr5.peaks$insideFeature =="overlapEnd" & 
                                     ann.utr5.peaks$strand=="+" & 
                                     abs(start(ann.utr5.peaks)-
                                             ann.utr5.peaks$end_position) >= 
                                     (end(ann.utr5.peaks)-
                                          ann.utr5.peaks$end_position)) | 
                                (ann.utr5.peaks$insideFeature =="overlapEnd" & 
                                     ann.utr5.peaks$strand=="-" & 
                                     abs(end(ann.utr5.peaks)-
                                             ann.utr5.peaks$start_position) >= 
                                     abs(start(ann.utr5.peaks)-
                                             ann.utr5.peaks$start_position ))])
            
            proximal.promoter.n <- 
                proximal.promoter.n +  
                length(
                    ann.utr5.peaks[
                        (ann.utr5.peaks$insideFeature =="overlapStart" & 
                             ann.utr5.peaks$distancetoFeature >=0 & 
                             ann.utr5.peaks$distancetoFeature == 
                             ann.utr5.peaks$shortestDistance)  | 
                            (ann.utr5.peaks$insideFeature =="overlapStart" & 
                                 ann.utr5.peaks$distancetoFeature <0 & 
                                 abs(ann.utr5.peaks$distancetoFeature) !=
                                 ann.utr5.peaks$shortestDistance)])
            
            downstream.utr5 <-
                ann.utr5.peaks[
                    ann.utr5.peaks$insideFeature =="downstream" |
                        (ann.utr5.peaks$insideFeature =="overlapEnd" & 
                             ann.utr5.peaks$strand=="+" & 
                             abs(start(ann.utr5.peaks)-
                                     ann.utr5.peaks$end_position) < 
                             (end(ann.utr5.peaks)-
                                  ann.utr5.peaks$end_position)) | 
                        (ann.utr5.peaks$insideFeature =="overlapEnd" & 
                             ann.utr5.peaks$strand=="-" & 
                             abs(end(ann.utr5.peaks)-
                                     ann.utr5.peaks$start_position) < 
                             abs(start(ann.utr5.peaks)-
                                     ann.utr5.peaks$start_position ))] 
            
            ann.utr3.peaks <- annotatePeakInBatch(downstream.utr5, 
                                                  AnnotationData = utr3)
            
            utr3.n <- 
                length(ann.utr3.peaks[ann.utr3.peaks$insideFeature %in% 
                                          c("includeFeature" , "overlapStart", 
                                            "overlapEnd", "inside")])
            
            rest.peaks <- ann.utr3.peaks[ann.utr3.peaks$insideFeature %in% 
                                             c("downstream", "upstream")]
            
            ann.rest.peaks <- annotatePeakInBatch(rest.peaks, 
                                                 AnnotationData = exon)
            
            intron.n <- length(ann.rest.peaks[ann.rest.peaks$insideFeature %in%
                                                  c("downstream", "upstream")])
            exon.n <- length(ann.rest.peaks) - intron.n
            
            total = length(peaks.RD)/100
            
            list( "Exons" =exon.n/total, 
                  "Introns"=intron.n/total, 
                  "fiveUTRs" = utr5.n/total, 
                  "threeUTRs" = utr3.n/total, 
                  "Promoters"= proximal.promoter.n/total, 
                  "immediate.Downstream" = immediateDownstream.n/total, 
                  "Intergenic.Region" = enhancer.n/total)
        }
    }

test_that("assignChromosomeRegion works not correct", {
    ##algorithm
    txdb_file <- system.file("extdata", "Biomart_Ensembl_sample.sqlite",
                             package="GenomicFeatures")
    TxDb <- loadDb(txdb_file)
    exons <- exons(TxDb, columns=NULL)
    fiveUTRs <- unique(unlist(fiveUTRsByTranscript(TxDb)))
    Feature.distribution <- 
        assignChromosomeRegion(exons, nucleotideLevel=TRUE, TxDb=TxDb)
    expect_equal(as.integer(Feature.distribution$percentage["Exons"]), 100)
    Feature.distribution <- 
        assignChromosomeRegion(fiveUTRs, nucleotideLevel=FALSE, TxDb=TxDb)
    expect_equal(as.integer(Feature.distribution$percentage["Exons"]), 100)
    expect_equal(as.integer(Feature.distribution$percentage["fiveUTRs"]), 100)
    Feature.distribution <- 
        assignChromosomeRegion(fiveUTRs, precedence="fiveUTRs", TxDb=TxDb)
    expect_equal(as.integer(Feature.distribution$percentage["Exons"]), 0)
    expect_equal(as.integer(Feature.distribution$percentage["fiveUTRs"]), 100)
    expect_error(assignChromosomeRegion(fiveUTRs,
                                        proximal.promoter.cutoff=1000,
                                        TxDb=TxDb))
    expect_error(assignChromosomeRegion(fiveUTRs,
                                        immediate.downstream.cutoff=1000,
                                        TxDb=TxDb))
})

#' coverage of gene body
#' 
#' calculate the coverage of gene body per gene per bin.
#' 
#' 
#' @param cvglists A list of \link[IRanges:AtomicList-class]{SimpleRleList} or
#' \link[IRanges:AtomicList-class]{RleList}. It represents the coverage for
#' samples.
#' @param TxDb An object of \code{\link[GenomicFeatures:TxDb-class]{TxDb}}.  It
#' is used for extracting the annotations.
#' @param upstream.cutoff,downstream.cutoff cutoff length for upstream or
#' downstream of transcript.
#' @param nbinsGene,nbinsUpstream,nbinsDownstream The number of bins for gene,
#' upstream and downstream.
#' @param includeIntron A logical value which indicates including intron or
#' not.
#' @param minGeneLen,maxGeneLen minimal or maximal length of gene.
#' @author Jianhong Ou
#' @seealso \link{binOverRegions}, \link{plotBinOverRegions}
#' @export
#' @import IRanges
#' @import GenomicRanges
#' @importFrom S4Vectors mcols
#' @importFrom BiocGenerics start end width strand do.call
#' @importFrom GenomeInfoDb seqinfo seqnames
#' @examples
#' 
#' if(Sys.getenv("USER")=="jou"){
#' path <- system.file("extdata", package="ChIPpeakAnno")
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' library(rtracklayer)
#' files <- dir(path, "bigWig")
#' if(.Platform$OS.type != "windows"){
#' cvglists <- lapply(file.path(path, files), import,
#'                    format="BigWig", as="RleList")
#' names(cvglists) <- sub(".bigWig", "", files)
#' d <- binOverGene(cvglists, TxDb.Hsapiens.UCSC.hg19.knownGene)
#' plotBinOverRegions(d)
#' }
#' }
#' 
binOverGene <- function(cvglists, TxDb, 
                        upstream.cutoff=0L, 
                        downstream.cutoff=upstream.cutoff, 
                        nbinsGene=100L,
                        nbinsUpstream=20L,
                        nbinsDownstream=nbinsUpstream,
                        includeIntron=FALSE,
                        minGeneLen=nbinsGene,
                        maxGeneLen=Inf){
  if(inherits(cvglists, c("SimpleRleList", "RleList", "CompressedRleList"))){
    cvglistsName <- substitute(deparse(cvglists))
    cvglists <- list(cvglists)
    names(cvglists) <- cvglistsName
  }
  if(!is(cvglists, "list")){
    stop("cvglists must be a list of SimpleRleList or RleList")
  }
  cls <- sapply(cvglists, inherits, 
                what = c("SimpleRleList", "RleList", "CompressedRleList"))
  if(any(!cls))
    stop("cvglists must be a list of SimpleRleList or RleList")
  stopifnot(is(TxDb, "TxDb"))
  stopifnot(maxGeneLen>minGeneLen)
  stopifnot(minGeneLen>=nbinsGene)
  if(includeIntron){
    features <- toGRanges(TxDb, feature="transcript")
  }else{
    features <- toGRanges(TxDb, feature="exon")
  }
  ## reduce by gene
  GRapply <- function(X, FUN, by, ...){
    stopifnot(by!="by_id")
    stopifnot(is(X, "GRanges"))
    x <- GRanges(seqnames = mcols(X)[, by], 
                 ranges = ranges(X),
                 strand = strand(X))
    x <- FUN(x, ...)
    x$by_id <- as.character(seqnames(x))
    x <- 
      GRanges(seqnames = 
                as.character(seqnames(X[match(x$by_id, 
                                              mcols(X)[, by])])),
              ranges = ranges(x),
              strand = strand(x),
              by_id = x$by_id)
    colnames(mcols(x)) <- by
    seqinfo(x) <- seqinfo(X)[seqlevels(x)]
    x
  }
  features <- features[lengths(features$gene_id)>0]
  features$gene_id <- sapply(features$gene_id, `[`, 1)
  features <- GRapply(features, reduce, "gene_id")
  
  ## filter by minGeneLen, maxGeneLen
  features <- trim(features)
  f.width <- rowsum(width(features), features$gene_id, reorder = FALSE)
  features <- features[features$gene_id %in% 
                         rownames(f.width)[f.width[, 1]>=minGeneLen & 
                                             f.width[, 1]<maxGeneLen]]
  
  if(length(features)<2){
    stop("less than 2 gene left.")
  }
  ## add upstream and downstream
  if(upstream.cutoff>0 && downstream.cutoff>0){
    genes <- GRapply(features, range, "gene_id")
    suppressWarnings({
      upstream <- promoters(genes,
                            upstream = upstream.cutoff,
                            downstream = 0)})
    upstream <- trim(upstream)
    upstream <- upstream[width(upstream)>=nbinsUpstream]
    revert.strand <- function(gr){
      l <- levels(strand(gr))
      l.plus <- which(l=="+")
      l.minus <- which(l=="-")
      if(length(l.plus)==1){
        l[l.plus] <- "-"
      }
      if(length(l.minus)==1){
        l[l.minus] <- "+"
      }
      levels(strand(gr)) <- l
      gr
    }
    genes.rev.strand <- revert.strand(genes)
    suppressWarnings({downstream <- 
      promoters(genes.rev.strand,
                upstream = downstream.cutoff,
                downstream = 0)})
    downstream <- revert.strand(downstream)
    downstream <- trim(downstream)
    downstream <- downstream[width(downstream)>=nbinsDownstream]
    upstream$feature_type <- "upstream"
    downstream$feature_type <- "downstream"
    features$feature_type <- "gene"
    gene_id <- unique(features$gene_id)
    features <- c(features, upstream, downstream)
    features <- 
      features[order(as.numeric(factor(features$gene_id, 
                                       levels = gene_id)),
                     as.numeric(factor(features$feature_type,
                                       levels = c("upstream", 
                                                  "gene", 
                                                  "downstream"))),
                     start(features))]
  }else{
    ## make sure features are sorted by position
    gene_id <- unique(features$gene_id)
    features$feature_type <- "gene"
    features <- 
      features[order(as.numeric(factor(features$gene_id, 
                                       levels = gene_id)),
                     start(features))]
  }
  ## split the features by seqnames and generate Views for cvglist
  seqn <- Reduce(intersect, lapply(cvglists, names))
  seqn <- intersect(seqn, seqlevels(features))
  if(length(seqn)<1){
    stop("Please check the names of cvglist. ",
         "None of them in the seqlevels of TxDb.")
  }
  features <- features[seqnames(features) %in% seqn]
  features <- 
    features[!features$gene_id %in% 
               features$gene_id[start(features)<1]] ## remove the start < 1
  len <- length(unique(features$gene_id))
  features.s <- split(features, seqnames(features))
  features.s <- features.s[seqn]
  cvglists <- lapply(cvglists, function(.ele) .ele[seqn])
  features.l <- as(features.s, "IntegerRangesList")
  
  bins=c("upstream"=nbinsUpstream,
         "gene"=nbinsGene,
         "downstream"=nbinsDownstream)
  
  features.view <- lapply(cvglists, function(.ele) {
    vw <- Views(.ele, features.l)
    cntByChr <- lapply(vw, function(.vw){
      .df <- elementMetadata(.vw)
      if(length(.df$feature_type) == 0) .df$feature_type <- "gene"
      .gr <- GRanges(paste(.df$feature_type, .df$gene_id), ranges(.vw), 
                     feature_type=.df$feature_type, gene_id=.df$gene_id)
      .gr.s <- split(.gr, seqnames(.gr))
      .cvg <- subject(.vw)
      .cvgs <- rep(list(.cvg), length(.gr.s))
      .gr.l <- as(.gr.s, "IntegerRangesList")
      names(.cvgs) <- names(.gr.l)
      .cvgs <- as(.cvgs, "SimpleRleList")
      .cvg.sub <- .cvgs[.gr.l]
      ### split the RleList into bins
      .ir <- IRanges(1, lengths(.cvg.sub))
      .ir <- 
        IRanges::tile(.ir, n=bins[sub("^(.*?) .*$", "\\1", names(.cvg.sub))])
      names(.ir) <- names(.cvg.sub)
      .cnt <- viewMeans(Views(.cvg.sub, .ir))
      .cnt <- split(.cnt, sub("^(.*?) .*$", "\\1", names(.cnt)))
      ## make sure 5'->3'
      .cnt <- lapply(.cnt, function(x){
        strd <- 
          as.character(strand(features))[match(sub("^(.*?) (.*$)", 
                                                   "\\2", names(x)), 
                                               features$gene_id)]
        x <- split(x, strd)
        x <- lapply(x, BiocGenerics::do.call, what=rbind)
        if("-" %in% names(x)){
          x[["-"]] <- x[["-"]][, ncol(x[["-"]]):1, drop=FALSE]
        }
        do.call(rbind, x)
      })
      lapply(.cnt, colSums)
    })
    cntByFeature <- swapList(cntByChr)
    cntByFeature <- lapply(cntByFeature, function(.ele){
      colSums(do.call(rbind, .ele))/len
    })
  })
  d <- swapList(features.view)
  feature_type <- c("upstream", "gene", "downstream")
  d <- d[feature_type[feature_type %in% names(d)]]
  d <- lapply(d, do.call, what=cbind)
  return(d)
}

test_that("binOverGene works not correct", {
  ## by simulation data
  if(Sys.getenv("USER")[1]=="jianhongou"){
  peaks <- toGRanges(TxDb.Hsapiens.UCSC.hg38.knownGene)
  peaks1 <- peaks <- peaks[seqnames(peaks)=="chr1"]
  st <- as.character(strand(peaks))=="+"
  start(peaks)[st] <- start(peaks)[st]-500
  end(peaks)[st] <- start(peaks)[st]
  end(peaks)[!st] <- end(peaks)[!st]+100
  start(peaks)[!st] <- end(peaks)[!st]
  peaks$score <- 1
  start(peaks1)[!st] <- start(peaks1)[!st]-500
  end(peaks1)[!st] <- start(peaks1)[!st]
  end(peaks1)[st] <- end(peaks1)[st]+100
  start(peaks1)[st] <- end(peaks1)[st]
  peaks1$score <- 1
  cvglists <- list(x=coverage(peaks), y=coverage(peaks1))
  bin <- binOverGene(cvglists, TxDb=TxDb.Hsapiens.UCSC.hg38.knownGene, 
                     upstream.cutoff = 1000)
  expect_true(all(c(11, 19) %in% order(bin$upstream[, "x"], decreasing = TRUE)[1:2]))
  expect_true(all(c(2, 10) %in% order(bin$downstream[, "y"], decreasing = TRUE)[1:2]))
  }
})

test_that("annotatePeakInBatch works not correct", {
    load(system.file("extdata", "annotatedPeaks.2.10.0.rds", 
                     ## this file should be rewrote for fix the new format
                     package="ChIPpeakAnno"))
    checkRes <- function(step, s){
        s <- s[!is.na(s$feature)]
        if(length(s$feature)>0){
            s <- as.data.frame(s)
            step <- step[rownames(s), ]
            step <- as.data.frame(step)
            for(i in c("peak", "feature", "start_position", 
                       "end_position", "distancetoFeature", 
                       "shortestDistance")){
                #if(any(step[,i]!=s[,i])) stop(paste(i, "is not identical!"))
                expect_equal(step[, i], s[, i], info=paste(i, "is not identical!"))
            }
        }
    }
    ## check 0 row
    myPeak = GRanges("chr1", 
                     IRanges(start = c(17208381), 
                             end = c(17208381), 
                             names=c("Site1")), 
                     strand = c('+'))
    feature = GRanges("chr1", 
                      IRanges(start = c(17066767, 17180899), 
                              end = c(17267729, 17180971), 
                              names =c("Site1", "Site2")),
                      strand = c('-'))
    for(output in c("nearestLocation", "overlapping", "both", 
                    "shortestDistance", "inside",
                    "upstream&inside", "inside&downstream",
                    "upstream", "downstream", 
                    "upstreamORdownstream")){
      suppressWarnings(annotation.step1 <- 
                         annotatePeakInBatch(myPeak, AnnotationData=feature, 
                                             output=output,
                                             ignore.strand = FALSE))
    }
    
    ##check one row
    myPeak = GRanges("chr1", 
                     IRanges(start = c(17208381), 
                             end = c(17208381), 
                             names=c("Site1")), 
                     strand = c('+'))
    feature = GRanges("chr1", 
                      IRanges(start = c(17066767, 17180899), 
                              end = c(17267729, 17180971), 
                              names =c("Site1", "Site2")),
                      strand = c('+'))
    suppressWarnings(annotation.step1 <- 
                         annotatePeakInBatch(myPeak, AnnotationData=feature, 
                                             output="overlapping",
                                             multiple=FALSE))
    checkRes(annotation.step1,annotation.s1)
    ##check one
    suppressWarnings(annotation.step2 <- 
                         annotatePeakInBatch(myPeak, 
                                             AnnotationData=feature[1,], 
                                             output="overlapping",
                                             multiple=FALSE))
    checkRes(annotation.step2,annotation.s2)
    suppressWarnings(annotation.step3 <- 
                         annotatePeakInBatch(myPeak, 
                                             AnnotationData=feature[2,], 
                                             output="overlapping"))
    #checkRes(annotation.step3,annotation.s3)
    suppressWarnings(annotation.step4 <- 
                         annotatePeakInBatch(myPeak, 
                                             AnnotationData=feature[2,], 
                                             output="both"))
    checkRes(annotation.step4,annotation.s4)
    suppressWarnings(annotation.step5 <- 
                         annotatePeakInBatch(myPeak, 
                                             AnnotationData=feature[2,]))
    checkRes(annotation.step5,annotation.s5)
    ##check select first
    suppressWarnings(annotation.step6 <- 
                         annotatePeakInBatch(myPeak, 
                                             AnnotationData=feature, 
                                             output="overlapping",
                                             select="first"))
    checkRes(annotation.step6,annotation.s6)
    suppressWarnings(annotation.step7 <- 
                         annotatePeakInBatch(myPeak, AnnotationData=feature, 
                                             output="overlapping",
                                             select="last"))
    checkRes(annotation.step7,annotation.s7)
    ## algorithm
    ##
    #       aaaaabb c
    #      1234567890
    #      AABB CCDD 
    #       EEEEE
    #        FFF
    #      GGGGG
    #        HHHHH
    #      IIIIIII
    #ignore strand
    myPeak = GRanges("1", IRanges(start=c(2, 7, 10), end=c(6, 8, 10), 
                                  names=letters[1:3]), 
                     strand="*")
    feature = GRanges("1", IRanges(start=c(1,3, 6, 8, 2, 3, 1, 3, 1), 
                                   end=c(2, 3, 7, 9, 6, 5, 5, 7, 7), 
                                   names=LETTERS[1:9]), 
                      strand="+")
    suppressWarnings(annotation.step8 <- 
                         annotatePeakInBatch(myPeak, AnnotationData=feature))
    checkRes(annotation.step8,annotation.s8)
    
    suppressWarnings(annotation.step9 <- 
                         annotatePeakInBatch(myPeak, AnnotationData=feature, 
                                             output="overlapping"))
    checkRes(annotation.step9,annotation.s9)
    
    suppressWarnings(annotation.step10 <- 
                         annotatePeakInBatch(myPeak, AnnotationData=feature, 
                                             output="both"))
    checkRes(annotation.step10,annotation.s10)
    
    #contain negative strand
    feature = GRanges("1", 
                      IRanges(start=c(1,3, 6, 8, 2, 3, 1, 3, 1), 
                              end=c(2, 3, 7, 9, 6, 5, 5, 7, 7), 
                              names=LETTERS[1:9]), 
                      strand=c("-", rep("+", 5), "-", "+", "+"))
    suppressWarnings(annotation.step11 <- 
                         annotatePeakInBatch(myPeak, AnnotationData=feature))
    checkRes(annotation.step11,annotation.s11)
    
    #consider strand
    myPeak = GRanges("1", 
                     IRanges(start=c(2, 7, 10), 
                             end=c(6, 8, 10), 
                             names=letters[1:3]), 
                     strand=c("-","+","+"))
    suppressWarnings(annotation.step12 <- 
                         annotatePeakInBatch(myPeak, AnnotationData=feature))
    checkRes(annotation.step12,annotation.s12)
    
    #check upsteam&inside and inside&downstream
    #       aaaaabb ccc    d
    #      12345678901234567890
    #     -AA    -DD
    #       +BB+CC  +JJJ
    #      +EEEEE     -KKK
    #       +FFF            +LL
    #     -GGGGG           +MMM
    #       +HHHHH
    #     +IIIIIII
    myPeak = GRanges("1", 
                     IRanges(start=c(2, 7, 10, 17), 
                             end=c(6, 8, 12, 17), 
                             names=letters[1:4]), 
                     strand="*")
    feature = GRanges("1", 
                      IRanges(start=c(1, 3, 6, 8, 2, 3, 1, 
                                      3, 1, 11, 13, 19, 18),
                              end=c(2, 3, 7, 9, 6, 5, 5, 
                                    7, 7, 13, 15, 20, 20),
                              names=LETTERS[1:13]), 
                      strand=c("-", "+", "+", "-", "+", "+", "-", 
                               "+", "+", "+", "-", "+", "+"))
    suppressWarnings(annotation <- 
                         annotatePeakInBatch(myPeak, 
                                             AnnotationData=feature, 
                                             maxgap=1,
                                             output="upstream&inside"))
    expect_equal(sum(annotation$peak=="a"& !is.na(annotation$feature)), 8)
    expect_equal(sum(annotation$peak=="b"& !is.na(annotation$feature)), 4)
    expect_equal(sum(annotation$peak=="c"& !is.na(annotation$feature)), 2)
    expect_equal(sum(annotation$peak=="d"& !is.na(annotation$feature)), 1)
    suppressWarnings(annotation <- 
                         annotatePeakInBatch(myPeak, 
                                             AnnotationData=feature, 
                                             maxgap=2,
                                             output="upstream&inside"))
    expect_equal(sum(annotation$peak=="a"& !is.na(annotation$feature)), 8)
    expect_equal(sum(annotation$peak=="b"& !is.na(annotation$feature)), 5)
    expect_equal(sum(annotation$peak=="c"& !is.na(annotation$feature)), 2)
    expect_equal(sum(annotation$peak=="d"& !is.na(annotation$feature)), 3)
    suppressWarnings(annotation <- 
                         annotatePeakInBatch(myPeak, 
                                             AnnotationData=feature, 
                                             maxgap=1,
                                             output="upstream"))
    expect_equal(sum(annotation$peak=="a"& !is.na(annotation$feature)), 6)
    expect_equal(sum(annotation$peak=="b"& !is.na(annotation$feature)), 0)
    expect_equal(sum(annotation$peak=="c"& !is.na(annotation$feature)), 2)
    expect_equal(sum(annotation$peak=="d"& !is.na(annotation$feature)), 1)
    suppressWarnings(annotation <- 
                         annotatePeakInBatch(myPeak, 
                                             AnnotationData=feature, 
                                             maxgap=2,
                                             output="upstream"))
    expect_equal(sum(annotation$peak=="a"& !is.na(annotation$feature)), 6)
    expect_equal(sum(annotation$peak=="b"& !is.na(annotation$feature)), 1)
    expect_equal(sum(annotation$peak=="c"& !is.na(annotation$feature)), 2)
    expect_equal(sum(annotation$peak=="d"& !is.na(annotation$feature)), 3)
    #check upsteam&inside and inside&downstream
    #       aaaaabb ccc    d
    #      12345678901234567890
    #     -AA    -DD
    #       +BB+CC  +JJJ
    #      +EEEEE     -KKK
    #       +FFF            +LL
    #     -GGGGG           +MMM
    #       +HHHHH
    #     +IIIIIII
    suppressWarnings(annotation <- 
                         annotatePeakInBatch(myPeak, 
                                             AnnotationData=feature, 
                                             maxgap=1,
                                             output="inside&downstream"))
    expect_equal(sum(annotation$peak=="a"& !is.na(annotation$feature)), 8)
    expect_equal(sum(annotation$peak=="b"& !is.na(annotation$feature)), 5)
    expect_equal(sum(annotation$peak=="c"& !is.na(annotation$feature)), 2)
    expect_equal(sum(annotation$peak=="d"& !is.na(annotation$feature)), 0)
    suppressWarnings(annotation <- 
                         annotatePeakInBatch(myPeak, 
                                             AnnotationData=feature, 
                                             maxgap=2,
                                             output="inside&downstream"))
    expect_equal(sum(annotation$peak=="a"& !is.na(annotation$feature)), 9)
    expect_equal(sum(annotation$peak=="b"& !is.na(annotation$feature)), 6)
    expect_equal(sum(annotation$peak=="c"& !is.na(annotation$feature)), 2)
    expect_equal(sum(annotation$peak=="d"& !is.na(annotation$feature)), 0)
    suppressWarnings(annotation <- 
                         annotatePeakInBatch(myPeak, 
                                             AnnotationData=feature, 
                                             maxgap=1,
                                             output="downstream"))
    expect_equal(sum(annotation$peak=="a"& !is.na(annotation$feature)), 2)
    expect_equal(sum(annotation$peak=="b"& !is.na(annotation$feature)), 5)
    expect_equal(sum(annotation$peak=="c"& !is.na(annotation$feature)), 1)
    expect_equal(sum(annotation$peak=="d"& !is.na(annotation$feature)), 0)
    suppressWarnings(annotation <- 
                         annotatePeakInBatch(myPeak, 
                                             AnnotationData=feature, 
                                             maxgap=2,
                                             output="downstream"))
    expect_equal(sum(annotation$peak=="a"& !is.na(annotation$feature)), 3)
    expect_equal(sum(annotation$peak=="b"& !is.na(annotation$feature)), 6)
    expect_equal(sum(annotation$peak=="c"& !is.na(annotation$feature)), 1)
    expect_equal(sum(annotation$peak=="d"& !is.na(annotation$feature)), 0)
    #check upstream2downstream
    #          aa      bb
    #    12345678901234567890
    #    AAAAAAAAAAAAAA
    #       BBBBBBBB
    #       CC    DD
    #
    myPeak <- GRanges("1", 
                      IRanges(start=c(7, 15), end=c(8, 16), names=c("a","b")), 
                      strand="*")
    feature <- GRanges("1", 
                       IRanges(start=c(1, 4, 4, 10), 
                               end=c(14, 11, 5, 11), 
                               names=c("A", "B", "C", "D")), 
                       strand="+")
    suppressWarnings(annotation <- 
                         annotatePeakInBatch(myPeak, 
                                             AnnotationData=feature, 
                                             maxgap=1,
                                             output="upstreamORdownstream"))
    suppressWarnings(annotation1 <- 
                         annotatePeakInBatch(myPeak, 
                                             AnnotationData=feature, 
                                             maxgap=2,
                                             output="upstreamORdownstream"))
    expect_equal(length(annotation), 2)
    expect_equal(length(annotation1), 3)
    
    ## examples from Julie
    test.GR = GRanges(seqnames = 4, IRanges(start = 100,
                                            end = 1000, 
                                            name = "peak1"))
    
    testAnno.GR <- GRanges(seqnames = c(4, 4, 4),
                           IRanges(start=c(400, 1005, 80),
                                   end = c(450, 1010, 90 ),
                                   names = c("Plus", "Minus1", "Minus2")),
                           strand=c("+", "-", "-"))
    
    test.anno <- annotatePeakInBatch(test.GR,
                                     AnnotationData = testAnno.GR,
                                     PeakLocForDistance = "start")
    expect_equal(test.anno$feature, "Minus2")
    
    test.anno <- annotatePeakInBatch(test.GR,
                                     AnnotationData = testAnno.GR,
                                     PeakLocForDistance = "end")
    expect_equal(test.anno$feature, "Minus1")
    
    test.anno <- annotatePeakInBatch(test.GR,
                                     AnnotationData = testAnno.GR,
                                     PeakLocForDistance = "middle")
    expect_equal(test.anno$feature, "Plus")
    
    test.anno <- annotatePeakInBatch(test.GR,
                                     AnnotationData = testAnno.GR,
                                     PeakLocForDistance = "endMinusStart")
    expect_equal(test.anno$feature, "Minus2")
    
    test.GR = GRanges(seqnames = 4,
                      IRanges(start = 300, end = 600,
                              name = "peak1"))
    
    testAnno.GR <- GRanges(seqnames = c(4, 4, 4),
                           IRanges(start=c(265, 200, 80),
                                   end = c(270, 700, 260 ),
                                   names = c("Plus", "Minus1", "Minus2")),
                           strand=c("+", "-", "-"))
    
    test.anno <- annotatePeakInBatch(test.GR,
                                     AnnotationData = testAnno.GR,
                                     PeakLocForDistance = "start")
    expect_equal(test.anno$feature, "Plus")
    
    test.anno <- annotatePeakInBatch(test.GR,
                                     AnnotationData = testAnno.GR,
                                     PeakLocForDistance = "end")
    expect_equal(test.anno$feature, "Minus1")
    
    test.anno <- annotatePeakInBatch(test.GR,
                                     AnnotationData = testAnno.GR,
                                     PeakLocForDistance = "middle")
    expect_equal(test.anno$feature, "Plus")
    
    test.anno <- annotatePeakInBatch(test.GR,
                                     AnnotationData = testAnno.GR,
                                     PeakLocForDistance = "endMinusStart")
    expect_equal(test.anno$feature, "Minus2")
    
    #check distance is correct. real data
    testPeaks <- GRanges("chr6", 
                         IRanges(c(114643757, 114644908, 114706674, 114790153, 
                                   114859230, 114860358, 114860615, 114862060, 
                                   114888901, 114910896), width=1), 
                         strand="+")
    data(TSS.mouse.GRCm38)
    suppressWarnings(annotation.step13 <- 
                         annotatePeakInBatch(testPeaks , 
                                             AnnotationData = TSS.mouse.GRCm38,
                                             FeatureLocForDistance = "geneEnd",
                                             output="both"))
    ##   identical(annotation.step13,annotation.s13) Faild in 2.10.0
    data(TSS.human.GRCh37)
    suppressWarnings(peakList <- 
                         toGRanges(system.file("extdata", "peaks_hg19.bed", 
                                               package="ChIPpeakAnno"),
                                   header=F))
    suppressWarnings(annotation.step14 <- 
                         annotatePeakInBatch(peakList, 
                                             AnnotationData=TSS.human.GRCh37, 
                                             FeatureLocForDistance="TSS", 
                                             PeakLocForDistance="middle", 
                                             maxgap=5000, select="first", 
                                             output="overlapping"))
    #checkRes(annotation.step14,annotation.s14) , 
    #difference: old 34 ENSG00000246463, new 34 ENSG00000181894
    
#    data(myPeakList)
#    data(TSS.human.NCBI36)
#    annotation.step15 = annotatePeakInBatch(myPeakList, 
#                                           AnnotationData=TSS.human.NCBI36)
#    checkRes(annotation.step15,annotation.s15)
##old
# RangedData with 3 rows and 9 value columns across 24 spaces
# space                 ranges |           peak      strand         feature start_position end_position insideFeature distancetoFeature
# <factor>              <IRanges> |    <character> <character>     <character>      <numeric>    <numeric>   <character>         <numeric>
#     1_19_116634269 ENSG00000221040        1 [116634634, 116634734] | 1_19_116634269           + ENSG00000221040      116622751    116622965    downstream             11883
# 11_11_71974217 ENSG00000222241        3 [ 71974527,  71974627] | 11_11_71974217           + ENSG00000222241       71959018     71959304    downstream             15509
# 11_13_43336708 ENSG00000222330        3 [ 43337016,  43337116] | 11_13_43336708           + ENSG00000222330       43331447     43331749    downstream              5569
# shortestDistance fromOverlappingOrNearest
# <numeric>              <character>
#     1_19_116634269 ENSG00000221040            11669             NearestStart
# 11_11_71974217 ENSG00000222241            15223             NearestStart
# 11_13_43336708 ENSG00000222330             5267             NearestStart
##new    
#     RangedData with 3 rows and 10 value columns across 24 spaces
#     space                 ranges | strand           peak         feature start_position end_position feature_strand insideFeature distancetoFeature
#     <factor>              <IRanges> |  <Rle>    <character>     <character>      <integer>    <integer>    <character>      <factor>         <numeric>
#         1_19_116634269 ENSG00000209170     chr1 [116634634, 116634734] |      * 1_19_116634269 ENSG00000209170      116622751    116622966              +    downstream             11883
#     11_13_43336708 ENSG00000210484     chr3 [ 43337016,  43337116] |      * 11_13_43336708 ENSG00000210484       43331447     43331751              +    downstream              5569
#     11_11_71974217 ENSG00000210995     chr3 [ 71974527,  71974627] |      * 11_11_71974217 ENSG00000210995       71959018     71959311              +    downstream             15509
#     shortestDistance fromOverlappingOrNearest
#     <integer>              <character>
#         1_19_116634269 ENSG00000209170            11668          NearestLocation
#     11_13_43336708 ENSG00000210484             5265          NearestLocation
#     11_11_71974217 ENSG00000210995            15216          NearestLocation
    
    peak <- GRanges(c("chr1","chr1","chr1"),
                    IRanges(start=c(1650,2806,8361), 
                            end=c(1860,3006,8591),
                            names=c("peak1","peak2","peak3")),
                    strand=as.integer(1))

    GENOME <- GRanges("chr1", 
                      IRanges(start=c(1660, 2906, 8391),
                              end=c(2502, 6646, 8860),
                              names=c("Potri.001G000100",
                                      "Potri.001G000200",
                                      "Potri.001G000300")),
                      strand=c("-", "-", "+"))
    suppressWarnings(annotation.step16 <- 
                         annotatePeakInBatch(peak, 
                                             AnnotationData=GENOME, 
                                             PeakLocForDistance ="middle",
                                             output="both"))
##    identical(annotation.step16,annotation.s16)
## there is a bug for 2.10.0 when calculating the distancetoFeature for negative strand.
    
    if(interactive()){
        PeakLocForDistance <- c("start","middle","end")
        FeatureLocForDistance <- c("TSS","middle","start","end", "geneEnd")
        select <- c("all", "first", "last", "arbitrary")
        output <- c("nearestLocation", "overlapping", "both", 
                    "shortestDistance", "upstream&inside", 
                    "inside&downstream", "upstream", "downstream", 
                    "upstreamORdownstream", "inside") 
        ##, "shortestDistance" is not in version 2.10.0
        comb <- do.call(expand.grid, 
                        list(PeakLocForDistance, 
                             FeatureLocForDistance, 
                             select, 
                             output))
        annotation.step17 <- apply(comb, 1, function(.ele) 
            annotatePeakInBatch(peak, AnnotationData=GENOME, 
                                PeakLocForDistance=.ele[1],
                                FeatureLocForDistance=.ele[2],
                                select=.ele[3],
                                output=.ele[4])) 
        ## CPU time long. maybe we can omit select option. 
    }
    
#annotation.s17 <- lapply(annotation.s17, function(.ele) {.ele$distancetoFeature <- abs(.ele$distancetoFeature); .ele})
#annotation.step17 <- lapply(annotation.step17, function(.ele) {.ele$distancetoFeature <- abs(.ele$distancetoFeature); .ele})
#checkRes(annotation.step17,annotation.s17)
    
    #check annotation by txdb
    txdb_file <- system.file("extdata", "Biomart_Ensembl_sample.sqlite",
                             package="GenomicFeatures")
    TxDb <- loadDb(txdb_file)
    exons <- unique(exons(TxDb, columns="exon_name"))
    names(exons) <- exons$exon_name
    fiveUTRs <- unique(unlist(fiveUTRsByTranscript(TxDb)))
    names(fiveUTRs) <- fiveUTRs$exon_name
    threeUTRs <- unique(unlist(threeUTRsByTranscript(TxDb)))
    names(threeUTRs) <- threeUTRs$exon_name
    gaps <- gaps(exons)
    gaps <- gaps[strand(gaps)!="*"]
    gaps.anno <- annotatePeakInBatch(gaps, 
                                     AnnotationData=exons, 
                                     output="inside")
    expect_true(all(is.na(gaps.anno$feature)))
    start(gaps) <- start(gaps)+2
    end(gaps) <- end(gaps)-2
    gaps.anno <- annotatePeakInBatch(exons, 
                                     AnnotationData=gaps, 
                                     output="overlapping", 
                                     maxgap=0,
                                     ignore.strand = FALSE)
    gaps.anno.1 <- gaps.anno[!is.na(gaps.anno$feature)]
    expect_equal(length(gaps.anno.1), 0)
    gaps.anno <- annotatePeakInBatch(exons, 
                                     AnnotationData=gaps, 
                                     output="overlapping", 
                                     maxgap=3,
                                     ignore.strand = FALSE)
    gaps.anno.2 <- gaps.anno[!is.na(gaps.anno$feature)]
    expect_equal(length(gaps.anno.2), 2*length(exons))
    exons.anno <- annotatePeakInBatch(exons,
                                      AnnotationData=exons, 
                                      output="inside")
    expect_equal(exons.anno$peak, exons.anno$feature)
    ##### test 1
    # exons.anno <- annotatePeakInBatch(exons,
    #                                   AnnotationData=exons,
    #                                   ignore.strand = FALSE,
    #                                   output="nearestLocation")
    # expect_equal(exons.anno$peak, exons.anno$feature)
    exons.anno <- annotatePeakInBatch(exons,
                                      AnnotationData=exons,
                                      PeakLocForDistance = "start", 
                                      FeatureLocForDistance = "start",
                                      output="nearestLocation")
    expect_equal(exons.anno$peak, exons.anno$feature)
    exons.anno <- annotatePeakInBatch(exons,
                                      AnnotationData=exons,
                                      PeakLocForDistance = "start", 
                                      FeatureLocForDistance = "start",
                                      ignore.strand = FALSE,
                                      output="nearestLocation")
    expect_equal(exons.anno$peak, exons.anno$feature)
    #### test 2
    exons.anno <- annotatePeakInBatch(exons,
                                      AnnotationData=exons,
                                      ignore.strand = FALSE, 
                                      PeakLocForDistance = "end",
                                      FeatureLocForDistance = "end",
                                      output="nearestLocation")
    expect_equal(exons.anno$peak, exons.anno$feature)
    #### test 3
    exons.anno <- annotatePeakInBatch(exons,
                                      AnnotationData=exons,
                                      ignore.strand = FALSE, 
                                      PeakLocForDistance = "middle",
                                      FeatureLocForDistance = "middle",
                                      output="nearestLocation")
    expect_equal(exons.anno$peak, exons.anno$feature)
    #### test 4
    exons.anno <- annotatePeakInBatch(exons,
                                      AnnotationData=exons, 
                                      PeakLocForDistance="endMinusStart",
                                      FeatureLocForDistance="geneEnd",
                                      output="nearestLocation")
    expect_equal(exons.anno$peak, exons.anno$feature)
    ######## test 5
    exons.anno <- annotatePeakInBatch(exons[strand(exons) =="-"],
                                      AnnotationData=exons[strand(exons) == "-"],
                                      PeakLocForDistance="endMinusStart",
                                      FeatureLocForDistance="geneEnd",
                                      output="nearestLocation")
    expect_equal(exons.anno$peak, exons.anno$feature)
    ######## test 6
    exons.anno <- annotatePeakInBatch(exons[strand(exons) =="+"],
                                      AnnotationData=exons[strand(exons) == "+"],
                                      PeakLocForDistance="endMinusStart",
                                      FeatureLocForDistance="geneEnd",
                                      output="nearestLocation")
    expect_equal(exons.anno$peak, exons.anno$feature)
    threeUTRs.anno <- annotatePeakInBatch(threeUTRs, 
                                          AnnotationData=exons, 
                                          output="downstream", maxgap=1000)
    fiveUTRs.anno <- annotatePeakInBatch(fiveUTRs, 
                                         AnnotationData=exons, 
                                         output="upstream", maxgap=1000)
    threeUTRs.anno <- annotatePeakInBatch(threeUTRs, 
                                          AnnotationData=exons, 
                                          output="inside&downstream")
    fiveUTRs.anno <- annotatePeakInBatch(fiveUTRs, 
                                         AnnotationData=exons, 
                                         output="upstream&inside")
    expect_equal(threeUTRs.anno$peak, threeUTRs.anno$feature)
    expect_equal(fiveUTRs.anno$peak, fiveUTRs.anno$feature)
})

test_that("toGRanges works not correct", {
    ##test format=c("BED", "GFF", "others")
    ##BED
    bed <- data.frame(cbind(space = c("1", "2"), start=c("100", "1000"),
                end=c("200", "1100"), name=c("peak1", "peak2")))
    gr <- toGRanges(bed, format="BED")
    expect_equal(start(gr), c(101, 1001))
    
    ##trim space
    bed$space <- paste(" ", 1:2)
    gr <- toGRanges(bed, format="BED")
    expect_equal(seqlevels(gr), c("1", "2"))
    bed$space <- paste(1:2, " ")
    gr <- toGRanges(bed, format="BED")
    expect_equal(seqlevels(gr), c("1", "2"))
    
    ## csv
    gr <- toGRanges(system.file("extdata", "peaks.csv",
                                package="ChIPpeakAnno"),
                    format="CSV")
    
    ##data.frame
    gr <- toGRanges(bed)
    expect_equal(start(gr), c(100, 1000))
    
    ##GFF
    GFF <- data.frame(cbind(space  = c("chr1", "chr2"), 
                            source=rep("Macs", 2),
                            feature=rep("peak", 2), 
                            start=c("100", "1000"), 
                            end=c("200", "1100"), 
                            score=c(60, 26),
                            strand=c(1, -1), 
                            frame=c(".", 2), 
                            group=c("peak1", "peak2")))
    gr <- toGRanges(GFF, format="GFF")
    
    ## EnsDb
    gr <- toGRanges(EnsDb.Hsapiens.v79, feature="gene")
    ## TxDb
    gr <- toGRanges(TxDb.Hsapiens.UCSC.hg38.knownGene, feature="gene")
})

---
title: "ChIPpeakAnno: annotate, visualize, and compare peak data"
author:
- name: Jianhong Ou
  affiliation: Duke Univeristy, Durham, USA
- name: Kai Hu
  affiliation: UMass Chan Medical School, Worcester, USA
- name: Haibo Liu
  affiliation: UMass Chan Medical School, Worcester, USA
- name: Junhui Li
  affiliation: UMass Chan Medical School, Worcester, USA
- name: Jun Yu
  affiliation: Novo Nordisk Dicerna TRU, Boston, USA
- name: Lihua Julie Zhu
  affiliation: UMass Chan Medical School, Worcester, USA
output:
  BiocStyle::html_document:
    toc_float: true
  BiocStyle::pdf_document: default
package: ChIPpeakAnno
link-citations: yes
bibliography: bibliography.bib
abstract: |
  A guide to utilizing `r Biocpkg("ChIPpeakAnno")` [@zhu2010; @zhu2013] for common analysis of any genmoic interval data such as [peak data](https://en.wikipedia.org/wiki/Peak_calling) collected with the classic [ChIP-seq](https://en.wikipedia.org/wiki/ChIP_sequencing) or the cutting-edge [CUT&RUN](https://en.wikipedia.org/wiki/CUT%26Tag_sequencing) experiments, [ATAC-seq](https://en.wikipedia.org/wiki/ATAC-seq), and their variants. `r Biocpkg("ChIPpeakAnno")` offers a range of functions for peak annotaion, visualization, and peak profile comparison.
vignette: |
  %\VignetteIndexEntry{ChIPpeakAnno: annotate, visualize, and compare peak data}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
```{r setup, include = FALSE}
knitr::opts_chunk$set(message = FALSE, 
                      warning = FALSE,
          					  tidy = FALSE, 
          					  fig.width = 6, 
          					  fig.height = 6,
          					  fig.align = "center")
# Handle the biofilecache error
library(BiocFileCache)
bfc <- BiocFileCache()
res <- bfcquery(bfc, 
                "annotationhub.index.rds", 
                field = "rname", 
                exact = TRUE) 
bfcremove(bfc, rids = res$rid)
```

# Introduction
Several experimental techniques including ChIP-ChIP [@blat1999], ChIP-seq [@barski2007; @johnson2007], and CUT&RUN [@skene2017] have gained widespread use in molecular biology. These techniques enable the study of protein-DNA interactions by identifying the genomic regions that are associated with specific proteins, such as transcription factor binding sites, or epigenetic markers like histone modification. Through these approaches, researchers gain valuable insights into the regulation of genes and the structure of chromatin.

The analysis involves several key procedures as outlined below, you can also integrate other omics data to gain a more comprehensive view of the gene regulation mechanisms. The steps where `r Biocpkg("ChIPpeakAnno")` package can be utilized are displayed in pink boxes.

```{r, fig.cap = "A workflow for ChIP-seq data analysis", echo = FALSE, out.width = "100%", out.height = "100%"}
png <- system.file("extdata", "dataFlow.png", package = "ChIPpeakAnno")

knitr::include_graphics(png)
```

Explanations of selected terms:

+ Peak calling: identify the genomic regions of significant read enrichment (peaks), which represent the binding sites of the protein or epigenetic marker of interest
+ Peak annotation: associate peaks with nearby genomic features, usually gene transcripts, to understand their functional implications
+ Enrichment analysis: identify the gene ontology (GO) terms or biological pathways that are associated with the annotated genes
+ Motif analysis: identify the enriched DNA patterns within peaks to understand the binding preference of the target protein

Various algorithms have been developed to identify peaks from experimental data [@thomas2017]. Once the peak files are obtained, they are commonly converted into formats like [_BED_](https://en.wikipedia.org/wiki/BED_(file_format)) and its variants. These formats allow the data to be easily loaded into genome browsers, such as the UCSC Genome Browser, as custom tracks. This enables investigators to examine the proximity of the peaks to different genomic features like promoters, enhancers, or other regulatory elements. However manually navigating through the genome browser can be a daunting task due to the typically large number of peaks that are spread across the genome.

The _Bioconductor_ package `r Biocpkg("ChIPpeakAnno")` is a pioneering tool that facilitates the batch annotation of peaks obtained from various technologies. One notable feature of `r Biocpkg("ChIPpeakAnno")` is its ability to dynamically retrieve up-to-date annotations by leveraging the `r Biocpkg("biomaRt")` package. This enables users to access the most current annotation files. Additionally, users can supply their own annotation data or utilize existing annotation packages. Furthermore, `r Biocpkg("ChIPpeakAnno")` provides functions to retrieve sequences surrounding the peaks, which can be utilized for peak validation via PCR and motif discovery [@Durinck2005]. The package also facilitates the identification of enriched GO or pathway terms. In addition, `r Biocpkg("ChIPpeakAnno")` includes several helper functions that aid in visualizing binding patterns and comparing peak profiles across multiple samples or experimental conditions.

`r Biocpkg("ChIPpeakAnno")` has been continuously enhanced since its initial release in 2010, as evident from its active development^[https://github.com/jianhong/ChIPpeakAnno/blob/devel/NEWS]. New features are being regularly added based on user requests. If you have any usage related questions, please search for solutions or post new questions on the [Bioconductor Support Site](https://support.bioconductor.org/new/post/), which is actively monitored by many seasoned users and developers. For feature request, bug report, or any other concerns, raise an issue on the [ChIPpeakAnno](https://github.com/jianhong/ChIPpeakAnno) GitHub repository. Your input and contributions will be greatly appreciated and carefully considered.

# Quick demo
This section provides a quick example on utilizing `r Biocpkg("ChIPpeakAnno")` to annotate peaks identified with _MACS_ or _MACS2_ [@zhang2008]. Several steps are typically involved and are discussed in more details in the following sections:

+ Convert peaks to _GRanges_ (Section \@ref(readinpeak))
+ Handle replicates (Section \@ref(handlereplicates))
+ Prepare annotation file (Section \@ref(prepanno))
+ Annotate peaks (Section \@ref(annopeaks))
+ Add other feature IDs (Section \@ref(addids))

From Section \@ref(readinpeak) to \@ref(profilecompare), we delve into detailed use cases, showcasing the versatility of `r Biocpkg("ChIPpeakAnno")` in various scenarios. Section \@ref(workflow1) to \@ref(workflow2) present several commonly employed analytical pipelines, offering step-by-step illustrations for different settings.

## Convert peaks to _GRanges_ {#readinpeakdemo}
The `r Biocpkg("ChIPpeakAnno")` package provides an example peak file in _narrowPeak_ format, which is generated by _MACS_. To work with this example file, we need to locate it with `system.file` and convert it into a _GRanges_ object using `toGRanges` function.
```{r}
library(ChIPpeakAnno)

macs_peak <- system.file("extdata", "MACS_peaks.xls", 
                         package = "ChIPpeakAnno")
macs_peak_gr <- toGRanges(macs_peak, format = "MACS")
head(macs_peak_gr, n = 2)
```

## Prepare annotations {#prepannos}
This section demonstrates how to prepare annotation file from [Ensembl](https://useast.ensembl.org/index.html) package. The Ensembl package is generally favored, as it offers more comprehensive and superior annotation. For more information, please refer to Section \@ref(prepanno).

```{r}
# Use Ensembl annotation package:
library(EnsDb.Hsapiens.v86)

ensembl.hs86.transcript <- transcripts(EnsDb.Hsapiens.v86)
```

## Annotate peaks
```{r}
# Use Ensembl annotation package:
macs_peak_ensembl <- annotatePeakInBatch(macs_peak_gr, 
										 AnnotationData = ensembl.hs86.transcript)
head(macs_peak_ensembl, n = 2)
```

For more regarding the metadata columns, please refer to the Section \@ref(findnearest). Of note, the metadata does not come with "gene symbol" column. We can add it using the `addGeneIDs` function as below.

## Add gene symbols
To add _gene symbols_, we can leverage either the organism annotation package, namely `r Biocpkg("org.Hs.eg.db")`, or the `r Biocpkg("bioRmart")` package. The latter offers the most current information but may have a slower performance as it requires querying the [BioMart](https://useast.ensembl.org/info/data/biomart/index.html) databases in real time. Once the required package is loaded, you can use the `addGeneIDs` function to add _gene symbols_. The following example utilizes the `r Biocpkg("EnsDb")` method.

```{r}
# Use Ensembl annotation package:
macs_peak_ensembl <- addGeneIDs(annotatedPeak = macs_peak_ensembl, 
                                orgAnn = EnsDb.Hsapiens.v86,
                                feature_id_type = "ensembl_transcript_id",
                                IDs2Add = "SYMBOL")
head(macs_peak_ensembl, n = 2)
```

Now, a _hgnc_symbol_ metadata column has been successfully inserted to the resulting _GRanges_ object. It is crucial to specify the correct `feature_id_type` and `IDs2Add` for the function to work properly. By default, `feature_id_type = "ensembl_gene_id"`. 

The following sections demonstration each topic in more details.

# Convert peaks to _GRanges_ {#readinpeak}
Peak files are represented as _GRanges_ objects in `r Biocpkg("ChIPpeakAnno")`. To facilitate the conversion of commonly used peak formats including _BED_ (and its variants), _GFF_, and _CSV_, we have implemented a helper function called `toGRanges`.

```{r}
# Convert GFF to GRanges:
macs_peak_gff <- system.file("extdata", "GFF_peaks_hg38.gff", 
                             package = "ChIPpeakAnno")
macs_peak_gr1 <- toGRanges(macs_peak_gff, format = "GFF", header = FALSE)
head(macs_peak_gr1, n = 2)

# Convert BED to GRanges:
macs_peak_bed <- system.file("extdata", "MACS_output_hg38.bed", 
                             package = "ChIPpeakAnno")
macs_peak_gr2 <- toGRanges(macs_peak_bed, format = "BED", header = FALSE)
head(macs_peak_gr2, n = 2)
```

# Handle replicates {#handlereplicates}

## Obtain final peak set from replicates
For experiments with two or more biological replicates, there are several strategies^[https://ro-che.info/articles/2018-07-11-chip-seq-consensus] to retrieve a final peak set:

+ Take the intersection of peaks: 
  + Most conservative, reduces noise by considering the most robust and consistently enriched peaks
  + May result in small number of peaks with narrower widths
+ Take the union of all peaks: may lead to large number of peaks
  + Least conservative, provides a more comprehensive view of the binding landscape
  + Useful for identifying condition-specific or rare binding events
+ Merge the overlapping peaks: may lead to peaks with broader widths
  + Can be achieved with `ChIPpeakAnno::findOverlapsOfPeaks`
+ Use peak coverage voting to determine a final set:
  + Can be achieved with `r Biocpkg("consensusSeekeR")`
+ Statistical model based approaches that leverage peak coverage and/or read depth information

Investigators may choose one of these strategies based on their research questions and the quality of their data.

## Assess the concordance of peak replicates
Concordant peaks refer to the peaks that come from different biological replicates and exhibit a high degree of overlap in their genomic coordinates and signal intensity. The presence of concordant peaks indicates that the observed signal is likely to be true positive rather than arising from random noise or technical artifacts. You can evaluate the concordance of replicates by visualizing the peak overlappings.

### Find overlapping peaks
Here are examples demonstrating how to identify overlapping peaks using the sample peaks provided in the `r Biocpkg("ChIPpeapAnno")` package. By default, two peaks are considered "overlapping" if "one range has its start or end strictly inside the other (`maxgap = -1L`)". If you set `maxgap = 1000`, two peaks will be classified as "overlapping" if the number of positions that separate them is less than 1000. Additionally, specifying `minoverlap = 100` ensures that only peaks with a minimum of 100 overlapping positions are treated as "overlapping". When `0 < minoverlap < 1`, the function will identify overlaps based on the percentage covered of peak interval.
```{r}
# For two samples:
data(peaks1)
data(peaks2)
head(peaks1, n = 2)
head(peaks2, n = 2)
ol <- findOverlapsOfPeaks(peaks1, peaks2)
names(ol)

# For three samples:
data(peaks3)
ol2 <- findOverlapsOfPeaks(peaks1, peaks2, peaks3,
                           connectedPeaks = "min")

# Find peaks with at least 90% overlap:
ol3 <- findOverlapsOfPeaks(peaks1, peaks2, minoverlap = 0.9)
```

The results are an object of _overlappingPeaks_. This object provides comprehensive information about the overlappings, allowing for further visualization and interpretation:

+ _venn_cnt_: an object of _VennCounts_, which can be used to draw a Venn diagram
+ _peaklist_: a list of _GRanges_ objects that contains all merged overlapping peaks or unique peaks
+ _uniquePeaks_: an object of _GRanges_ that consists of all unique peaks
+ _mergedPeaks_: an object of _GRanges_ that consists of all merged overlapping peaks
+ _peaksInMergedPeaks_: an object of _GRanges_ that consists of all peaks in each samples involved in the overlapping peaks
+ _overlappingPeaks_: a list of data frames that consists of the annotation of all overlapping peaks
+ _all.peaks_: a list of _GRanges_ objects that consists the input peaks with formatted rownames

To determine the number of peaks that are unique to each peak set (i.e., not overlapping with any peaks in other set), you can use the following code:
```{r}
# For peaks1:
length(ol$peaklist[["peaks1"]])

# For peaks2:
length(ol$peaklist[["peaks2"]])
```

To obtain the merged overlapping peaks, you have two options:

+ You can use `ol$mergedPeaks` to obtain all the merged overlapping peaks from all peak sets in `ol`. This means that if you have multiple peak sets, this command will output all the peaks that overlap with peaks from any other peak sets
+ Alternatively, you can use `ol$peaklist[["peaks1///peaks2"]]`, where `"peaks1///peaks2"` represents a _GRanges_ object that contains all the merged overlapping peaks from _peaks1_ and _peaks2_. When you only have two peak sets, `ol$mergedPeaks` is equivalent to `ol$peaklist[["peaks1///peaks2"]]`. However, if more peak sets are involved, e.g. three peak sets, `ol$peaklist[["peaks1///peaks2///peaks3"]]` would represent merged overlapping peaks that consist of peaks from all three sets. In other words, `ol$mergedPeaks` is equivalent to `ol$peaklist[["peaks1///peaks2"]]` plus `ol$peaklist[["peaks2///peaks3"]]` and `ol$peaklist[["peaks1///peaks2///peaks3"]]`

### Visualize the overlaps using Venn diagram {#venn}
The output from `findOverlapsOfPeaks` can be directly fed to `makeVennDiagram` to draw a Venn diagram and evaluate the degree of overlap between peak sets. Additionally, the `makeVennDiagram` function also calculates a P-value, which indicates whether the observed overlap is statistically significant or not. 
```{r, results = "hide", fig.cap = "Venn diagram showing the number of overlapping peaks for two samples", fig.small = TRUE}
# For two samples:
venn <- makeVennDiagram(ol, totalTest = 100,
                        fill = c("#009E73", "#F0E442"),
                        col = c("#D55E00", "#0072B2"),
                        cat.col = c("#D55E00", "#0072B2"))

# For three samples:
venn2 <- makeVennDiagram(ol2, totalTest = 100,
                         fill = c("#CC79A7", "#56B4E9", "#F0E442"),
                         col = c("#D55E00", "#0072B2", "#E69F00"),
                         cat.col = c("#D55E00", "#0072B2", "#E69F00"))

# For peaks overlap at least 90%:
venn3 <- makeVennDiagram(ol3, totalTest = 100,
                         fill = c("#009E73", "#F0E442"),
                         col = c("#D55E00", "#0072B2"),
                         cat.col = c("#D55E00", "#0072B2"))
```

The parameter `totalTest` refers to the total number of potential peaks that are considered in the [hypergeometric test](https://en.wikipedia.org/wiki/Hypergeometric_distribution). It should be set to a value larger than the largest number of peaks in the replicates. Refer to Section \@ref(hypertest) on how to choose `totalTest`. Since P-value is sensitive to the choice of `totalTest`, we recommend using permutation test, implemented as `peakPermTest` in `Biocpkg("ChIPpeakAnno")`. For details, go to Section \@ref(permtest).

### Use other tools to plot Venn diagram
Users can leverage the `ol$venn_cnt` object and choose other tools to draw Venn diagram. Below illustrates how to use `r CRANpkg("Vennerable")` library for plotting.
```{r, eval = FALSE}
if (!library(Vennerable)) {
  install.packages("Vennerable", repos="http://R-Forge.R-project.org")
  library(Vennerable)
}

n <- which(colnames(ol$vennCounts) == "Counts") - 1
set_names <- colnames(ol$vennCounts)[1:n]
weight <- ol$vennCounts[, "Counts"]
names(weight) <- apply(ol$vennCounts[, 1:n], 1, base::paste, collapse = "")
v <- Venn(SetNames = set_names, Weight = weight)
plot(v)
```

### Visualize the distribution of relative positions for overlapping peaks
As mentioned earlier, two peaks are considered as "overlapping" if their distances are within `maxgap`. To visualize the distribution of the relative positions of _peaks1_ to _peaks2_, we can create a pie chart using the `ol$overlappingPeaks` object. This object contains detailed information about the relative positions of peaks for each pair of peak sets. For instance, `ol$overlappingPeaks[["peaks1\\\peaks2"]]` represents the relative positions of overlapping peaks between _peaks1_ and _peaks2_.
```{r}
names(ol$overlappingPeaks)
dim(ol$overlappingPeaks[["peaks1///peaks2"]])
ol$overlappingPeaks[["peaks1///peaks2"]][1:2, ]
unique(ol$overlappingPeaks[["peaks1///peaks2"]][["overlapFeature"]])
pie1(table(ol$overlappingPeaks[["peaks1///peaks2"]]$overlapFeature))
```

The column _overlapFeature_ describes the relative positions of peaks between _peaks1_ and _peaks2_:

+ _upstream_: the peak from _peaks1_ is located upstream of the peak from _peaks2_ and is within a distance of `maxgap`
+ _downstream_: the peak from _peaks1_ is located downstream of the peak from _peaks2_ and is within a distance of `maxgap`
+ _overlapStart_: the peak from _peaks1_ overlaps with the _start_ of peak from _peaks2_
+ _overlapEnd_: the peak from _peaks1_ overlaps with the _end_ of peak from _peaks2_
+ _inside_: the peak from _peaks1_ is completely contained within the peak from _peaks2_
+ _includeFeature_: the peak from _peaks1_ contains the entire range of the peak from _peaks2_. Note that the term _Feature_ here refers to the peak in _peaks2_ rather than a _genomic feature_ as used in peak annotation context

The utilization of a Venn diagram, in conjunction with a pie chart, enables a more comprehensive evaluation of peak concordance among biological replicates. 

# Prepare annotation file {#prepanno}
An annotation file contains genomic coordinates and other relevant information for various genomic features, such as genes, transcripts, promoters, enhancers, and more. By comparing the peaks with these coordinates, researchers can determine which features are most enriched or associated with the peaks, which can help them understand the functional relevance of the peaks and provide insights into the potential regulatory elements or genes involved. 

## Commonly used annotations
Popular annotation files come from two sources and are typically stored in tab-delimited formats, such as _GTF_ or _BED_.
```{r, echo = FALSE}
library(knitr)

Resource <- c("Ensembl", "NCBI RefSeq")
Generated_by <- c("EMBL-EBI", "NCBI")
Annotation_criteria <- c("Comprehensive (most transcripts)", "Conservative (fewer transcripts)")
Gene_id_name <- c("Ensembl gene ID", "NCBI Gene ID, or entrezGene ID, or entrez ID")
URL <- c("https://ftp.Ensembl.org/pub/", "https://ftp.ncbi.nlm.nih.gov/refseq/")
df <- data.frame(Resource, Generated_by, Annotation_criteria, URL)

kable(df, caption = 'Commonly used annotation resources')
```

In addition, the [UCSC Genome Browser](https://hgdownload.soe.ucsc.edu/downloads.html) team provides processed annotations based on the above resources that can be visualized easily with the browser. For human and mouse, there are four `GTF` files provided respectively. 
```{r, echo = FALSE}
library(knitr)

Human <- c("[hg38.refGene.gtf.gz](https://hgdownload.soe.ucsc.edu/goldenPath/hg38/bigZips/genes/hg38.refGene.gtf.gz)",
           "[hg38.ncbiRefSeq.gtf.gz](https://hgdownload.soe.ucsc.edu/goldenPath/hg38/bigZips/genes/hg38.ncbiRefSeq.gtf.gz)",
           "[hg38.knownGene.gtf.gz](https://hgdownload.soe.ucsc.edu/goldenPath/hg38/bigZips/genes/hg38.knownGene.gtf.gz)")
Mouse <- c("[mm10.refGene.gtf.gz](https://hgdownload.soe.ucsc.edu/goldenPath/mm10/bigZips/genes/mm10.refGene.gtf.gz)",
           "[mm10.ncbiRefSeq.gtf.gz](https://hgdownload.soe.ucsc.edu/goldenPath/mm10/bigZips/genes/mm10.ncbiRefSeq.gtf.gz)",
           "[mm10.knownGene.gtf.gz](https://hgdownload.soe.ucsc.edu/goldenPath/mm10/bigZips/genes/mm10.knownGene.gtf.gz)")
Remark <- c("Based on RefSeq transcripts aligned by UCSC followed by manual curation",
            "Based on RefSeq transcripts as aligned by NCBI",
            "Based on Ensembl gene models")
df <- data.frame(Human, Mouse, Remark)

kable(df, caption = "UCSC Genome Browser hosted annotation files")
```

We would recommend using _EnsDb_ annotations because they are usually more comprehensive and consistent.

## Bioconductor supported _TxDb_ and _EnsDb_ {#txdbensdb}
In _Bioconductor_, the tab-delimited files are often converted into _TxDb_ or _EnsDb_ object. Both can be created with the tab delimited files mentioned above. While _EnsDb_ is tailored to _Ensembl_ annotations and contains additional information such as _gene_name_, _symbol_, and _gene_biotype_, the _TxDb_ counterpart is typically created from RefSeq or UCSC Genome Browser hosted annotations. 

There is a comprehensive list of pre-built _Bioconductor_ maintained _TxDb_ and _EnsDb_ packages such as `r Biocpkg("TxDb.Hsapiens.UCSC.hg38.knownGene")` and `r Biocpkg("EnsDb.Hsapiens.v86")`. The list is regularly updated and can be found [here](https://www.bioconductor.org/packages/release/data/annotation/). 

## Obtain _EnsDb_ and _TxDb_ from `AnnotationHub`
Users can also retrieve annotations using the `r Biocpkg("AnnotationHub")` package. By default, `r Biocpkg("AnnotationHub")` uses a snapshot that matches the version of _Bioconductor_ being used, so it may be slightly more up-to-date compared to the pre-built packages. Additionally, users have the option to switch to an earlier version^[https://bioconductor.org/packages/release/bioc/vignettes/AnnotationHub/inst/doc/AnnotationHub.html#configuring-annotationhub-objects]. Below are examples of how to obtain annotations using `r Biocpkg("AnnotationHub")`.

```{r}
library(AnnotationHub)

ah <- AnnotationHub()

# Obtain EnsDb:
EnsDb_Mmusculus_all <- query(ah, pattern = c("Mus musculus", "EnsDb"))
head(EnsDb_Mmusculus_all, n = 2)
EnsDb_Mmusculus <- EnsDb_Mmusculus_all[["AH53222"]]
class(EnsDb_Mmusculus)

# Obtain TxDb:
TxDb_Mmusculus_all <- query(ah, pattern = c("Mus musculus", "TxDb"))
head(TxDb_Mmusculus_all, n = 2)
TxDb_Mmusculus <- TxDb_Mmusculus_all[["AH52264"]]
class(TxDb_Mmusculus)
```

## Build custom _EnsDb_ and _TxDb_
To create the most up-to-date or custom _TxDb_ and _EnsDb_ objects, you can utilize functions such as `makeTxDbFromUCSC`, `makeTxDbFromEnsembl`, and `ensDbFromGRanges` from the `r Biocpkg("GenomicFeatures")`^[https://bioconductor.org/packages/devel/bioc/vignettes/GenomicFeatures/inst/doc/GenomicFeatures.html] package and the `r Biocpkg("Ensembldb")`^[https://www.bioconductor.org/packages/devel/bioc/vignettes/Ensembldb/inst/doc/Ensembldb.html#102_Building_annotation_packages] package.

## Use `biomaRt` {#usebiomart}
The `r Biocpkg("biomaRt")` package offers a convenient interface to the [BioMart](https://useast.Ensembl.org/info/data/biomart/index.html) databases that are prominently maintained by _Ensembl_. By querying `r Biocpkg("biomaRt")`, you can access the latest available annotations from _Ensembl_. Check [this vignette](https://bioconductor.org/packages/release/bioc/vignettes/biomaRt/inst/doc/accessing_Ensembl.html) for details.

`r Biocpkg("ChIPpeakAnno")` provides a helper function called `getAnnotation`, which simplifies the retrieval of desired annotations by leveraging `r Biocpkg("biomaRt")`. Here is an example:
```{r, eval = FALSE}
library(biomaRt)

listMarts()
head(listDatasets(useMart("ENSEMBL_MART_ENSEMBL")), n = 2)
mart <- useMart(biomart = "ENSEMBL_MART_ENSEMBL",
                dataset = "mmusculus_gene_ensembl")
anno_from_biomart <- getAnnotation(mart, 
                                   featureType = "transcript")
head(anno_from_biomart, n = 2)
```

### Convert annotations into _GRanges_
To annotate peaks, the chosen annotation file needs to be converted into _GRanges_ class first. This can be achieved with `toGRanges` function, accessor functions, or `getAnnotation` function.

## Use `toGRanges` function
`r Biocpkg("ChIPpeakAnno")` offers a helper function called `toGRanges`, which can convert annotations from various formats including _GFF_, _BED_, _CSV_, _TxDb_, and _EnsDb_ into _GRanges_. Below is an example.

```{r}
library(EnsDb.Hsapiens.v86)

anno_ensdb_transcript <- toGRanges(EnsDb.Hsapiens.v86, 
                                   feature = "transcript")
head(anno_ensdb_transcript, n = 2)
```

Similarly, set `feature = "gene"` to retrieve gene annotations in _GRanges_ format.

### Use accessor functions
If you are working with _TxDb_ or _EnsDb_ objects, you can obtain annotations in _GRanges_ format with various accessor functions such as `genes` and `transcripts`, which are designed for easy fetching of the desired information.
```{r}
anno_ensdb_transcript <- transcripts(EnsDb.Hsapiens.v86)

head(anno_ensdb_transcript, n = 2)
```

### Use `getAnnotation` function
The output from `getAnnotation` function is in _GRanges_ format, refer to Section \@ref(usebiomart) for details.

# Visualize peak distributions
Plotting peak distributions is a valuable quality control measure as it provides an overview of the localization of peaks across the genome. Unexpected distributions can indicate potential issues with the data. In addition, you can select appropriate annotation file depending on the distribution of your peaks. For instance, if peaks are enriched near promoters, you may focus on annotating them with nearby transcripts.

## Plot peak distributions relative to genomic features
The `binOverFeature` function can be used to plot the distribution of peak counts relative to a specific genomic feature. The following example shows the distribution of peaks in the `macs_peak_gr2` dataset relative to the `gene` feature (transcription start site (TSS)).  
```{r, fig.cap = "Peak count distribution around TSSs", warning = FALSE}
library(TxDb.Hsapiens.UCSC.hg38.knownGene)

annotation_data <- transcripts(TxDb.Hsapiens.UCSC.hg38.knownGene)
binOverFeature(macs_peak_gr2, 
               featureSite = "FeatureStart",
               nbins = 20,
               annotationData = annotation_data,
               xlab = "peak distance from TSS (bp)", 
               ylab = "peak count", 
               main = "Distribution of aggregated peak numbers around TSS")
```

By default, `featureSite = "FeatureStart"` meaning that distance is calculated as peak to feature start (i.e. TSS for transcript). The plot above, describing the distribution of peaks around TSS, exhibits a signal summit around TSS, a characteristic pattern observed in peaks obtained from transcription factor binding experiments.

You can also plot peak distribution over multiple genomic features including exon, intron, enhancer, proximal promoter, 5' UTR and 3' UTR in a single bar graph using `assignChromosomeRegion`.
```{r, fig.cap = "Bar graph showing peak distributions over different genomic features"}
chromosome_region <- assignChromosomeRegion(macs_peak_gr2,
                                            TxDb = TxDb.Hsapiens.UCSC.hg38.knownGene,
                                            nucleotideLevel = FALSE,
                                            precedence=c("Promoters",
                                                         "immediateDownstream", 
                                                         "fiveUTRs", 
                                                         "threeUTRs",
                                                         "Exons", 
                                                         "Introns"))

# optional helper function to rotate x-axis labels for barplot(): 
# ref: https://stackoverflow.com/questions/10286473/rotating-x-axis-labels-in-r-for-barplot
rotate_x <- function(data, rot_angle) {
  plt <- barplot(data, xaxt = "n")
  text(plt, par("usr")[3], 
       labels = names(data), 
       srt = rot_angle, adj = c(1.1,1.1), 
       xpd = TRUE, cex = 0.6)
}

rotate_x(chromosome_region[["percentage"]], 45)
```

By default, `nucleotideLevel = FALSE` meaning that peaks are treated as ranges when determining overlaps with genomic features. If a peak intersects with multiple features, the feature assignment is determined by the order specified in the `precedence` argument. If `precedence` is not set, counts for each overlapping feature will be incremented. Otherwise, if `nucleotideLevel = TRUE`, the summit of the peak (a single position, not suitable for broad peaks) will be used when determining overlaps.

## Plot peak distributions over different feature levels
In addition to inspecting the peak enrichment pattern by plotting the distribution against genomic features, users can plot distributions over different feature levels, each containing multiple categories, using the  `genomicElementDistribution` function. 

+ _Transcript Level_: "geneLevel"
    + "Promoter"
    + "Gene body"
    + "Downstream"
    + "Distal Intergenic"
    
+ _Exon Level_: "Exons"
    + "5' UTR"
    + "CDS"
    + "3' URT"
    + "Other exon"
    
+ _Exon/Intron/Intergenic_: "ExonIntron"
    + "Exon"
    + "Intron"
    + "Intergenic"

Please note that peaks can be classified into multiple categories from different levels, leading to the total percentage of annotated features being greater than 100%. At each level, since a peak spans a genomic range, it may overlap with multiple categories of features. In such cases, by default `nucleotideLevel = FALSE`, which means that the precedence is determined by the order listed in the `labels` argument.

The `genomicElementDistribution` function accepts either a single peak object or a list of peak objects as input. If a single peak object if provided, a pie chart will be created; if a list of peak objects is provided, a bar graph will be created.

### Pie graph with one peak set
```{r, fig.cap = "Pie graph showing peak distributions over features at different levels"}
genomicElementDistribution(macs_peak_gr1, 
                           TxDb = TxDb.Hsapiens.UCSC.hg38.knownGene)
```

As can be seen, a significant number of peaks originate from promoter regions.

### Bar graph with a list of peak sets
```{r, fig.cap = "Bar graph showing peak distributions over features at different levels"}
macs_peaks <- GRangesList(rep1 = macs_peak_gr1,
                          rep2 = macs_peak_gr2)
genomicElementDistribution(macs_peaks, 
                           TxDb = TxDb.Hsapiens.UCSC.hg38.knownGene)
```

The consistent patterns from "rep1" and "rep2" indicate a high correlation between them.

## Plot peak overlaps for multiple features {#upset}
We can create an [UpSet](https://en.wikipedia.org/wiki/UpSet_Plot) plot to view peak overlaps across multiple genomic features.
```{r, fig.cap = "UpSet plot showing the overlappings of peak distributions among different genomic features"}
library(UpSetR)

res <- genomicElementUpSetR(macs_peak_gr1,
                            TxDb.Hsapiens.UCSC.hg38.knownGene)
upset(res[["plotData"]], 
      nsets = length(colnames(res$plotData)), 
      nintersects = NA)
```

UpSet plot can be considered as a "high dimensional Venn diagram" that allows for the visualization of overlaps for multiple sets. For example, in the above plot, it is evident that the feature set "gene body" (from the "Transcript Level") and the feature set "intron" (from the "Exon/Intron/Intergenic") share the highest number of common peaks. Type `?genomicElementUpSetR` for the definition of `distal_promoter`.

# Annotate peaks {#annopeaks}
With the annotation data, you can assign the peaks identified in your experiments to nearby features of your choice such as genes and transcripts. This process is known as peak annotation. The `annotatePeakInBatch` function offers a highly flexible approach to perform peak annotation with various `output` option. 

For example, you can annotate peaks based on their nearest (`output = "nearestLocation"`) or overlapping (`output = "overlapping"`) features using the peak-centric method. Alternatively, you can annotate peaks based on their relative locations to features using the feature-centric method. For example, if a peak is located upstream of a gene within a certain distance (e.g. promoter region), you can assign that gene to the peak (`output = "upstream"`). The `bindingRegion` option allows for even more flexibility in specifying teh relative locations. Detailed explanations see below.

The choice between the peak-centric and feature-centric methods depends on your research question, although most users initially opt for the peak-centric approach as it is easier to interpret.

## Peak-centric method {#peakcentric}
You can assign the nearest or overlapping features to your peaks by setting the `output` option to the following values:

+ _output_: criteria for assigning features
    + "nearestLocation": (default) output the features that are nearest to the peaks based on the absolute value of the difference between the peak location and the feature location, as calculated by `abs(PeakLocForDistance - FeatureLocForDistance)`
    + "overlapping": output features that overlap with the peaks within the maximum distance specified by the `maxgap` parameter
    + "both": output both the nearest feature and overlapping features that are not the nearest
    + "shortestDistance": output the features that have the shortest distance to the peaks; the "shortest distance" is determined from either end of the feature to either end of the peak
    
Other relevant parameters:

+ _PeakLocForDistance_: location of the peak for distance calculation
    + "middle": (recommended) use the center of the peak
    + "start": (default) use the peak edge that is smaller in coordinate
    + "end": use the peak edge that is larger in coordinate
    + "endMinusStart": use "end" defined above if feature is on the plus strand, and "start" if minus strand
    
+ _FeatureLocForDistance_: location of the feature for distance calculation
    + "middle": use the center of the feature 
    + "start": use the feature edge that is smaller in coordinate
    + "end": use the feature edge that is large in coordinate
    + "TSS": (default) use "start" defined above if feature is on the plus strand and "end" if on the minus strand
    + "geneEnd": use "end" defined above if feature is on the plus strand and "start" if on the minus strand
    
+ _maxgap_: the maximum _gap_ that is allowed between the peak and the feature ranges for them to be considered as overlapping; it is defined as the number of bases that separates the two ranges, the _gap_ between two adjacent ranges is 0

The following diagram illustrates how to annotate peaks using the peak-centric method. When `output = "nearestLocation"`, the distance between the peak and the feature is calculated as `abs(PeakLocForDistance - FeatureLocForDistance)`; for demonstration, `PeakLocForDistance = "start"` and `FeatureLocForDistance = "TSS"`.
```{r, fig.cap = "How does peak-centric annotation method work", echo = FALSE, out.width = "100%", out.height = "100%"}
png <- system.file("extdata", "annoPeakCentric.png", package = "ChIPpeakAnno")

knitr::include_graphics(png)
```

## Feature-centric method {#featurecentric}
Peaks can also be annotated based on their relative locations to nearby features. For example, by setting `output = "upstream"`, peaks will be annotated to features that they are located upstream of.

### Relative peak-to-feature location 
You can use the following options to specify the desired relative locations of the peaks to the features.

+ _output_: criteria for assigning features
    + "upstream": output the feature if the peak resides upstream of it
    + "upstrem&inside": output the feature if the peak resides upstream of it or contained within it
    + "inside": output the feature if the peak is completely contained within it
    + "inside&downstream": output the feature if the peak resides within it or downstream of it
    + "downstream": output the feature if the peak resides downstream of it
    + "upstreamORdownstream": output the feature if the peak resides upstream or downstream of it

Other relevant parameter:

+ _maxgap_: allowed _gap_ when determining overlap between two ranges; will be ignored if `output = "inside"`

The following diagram illustrates how peaks are annotated using the feature-centric method.

```{r, fig.cap = "How does feature-centric annotation method work", echo = FALSE, out.width = "100%", out.height = "100%"}
png <- system.file("extdata", "annoFeatureCentric1.png", package = "ChIPpeakAnno")

knitr::include_graphics(png)
```

When using the feature-centric method, the `annotatePeakInBatch` function will output the feature as long as the peak range overlaps with the target region, except when `output = "inside"`. In this case, the entire peak range must be completely contained within the feature range to output it.

### More customization with `bindingRegion`
The `bindingRegion` parameter, which refers to the regions that the target TF binds to, adds further flexibility to the feature-centric method when defining the target region. For example, if you would like to annotate peaks to features where the peaks are located within specific regions relative to them, such as from 2000bp upstream to 500bp downstream of TSS (where most promoters are found), you can set `output = "overlapping"`, `FeatureLocForDistance = "TSS"`, and `bindingRegion = c(-2000, 500)`. Once `bindingRegion` is specified, the `maxgap` will be ignored. 

The following diagram demonstrates several examples of how to use `bindingRegion` to define target regions.

```{r, fig.cap = "How to define target region with bindingRegion", echo = FALSE, out.width = "100%", out.height = "100%"}
png <- system.file("extdata", "annoFeatureCentric2.png", package = "ChIPpeakAnno")

knitr::include_graphics(png)
```

Bi-directional promoters are genomic regions that are located upstream of the TSS of two adjacent genes that are transcribed in opposite directions [@adachi2002]. Those promoters typically regulate the expression of both genes. To annotate peaks located in such regions, you can use `output = "overlapping", FeatureLocForDistance = "TSS"`, and `bindingRegion = c(-5000, 3000)`. By default, `select = "all"`, meaning that all overlapping features will be outputted. If you want to annotate peaks to features with the nearest bi-directional promoters, you can use `output = "nearestBiDirectionalPromoters"` along with `bindingRegion`. In this setting, at most one feature will be reported from each direction. When using `output = "nearestBiDirectionalPromoters"`, both `maxgap` and `FeatureLocForDistance` will be ignored.

To illustrate, we can use the `myPeakList` provided by `r Biocpkg("ChIPpeakAnno")`. As different major genome releases (e.g. _hg19_ vs _hg38_) may have variations in feature coordinates, it is highly recommended to use an annotation file that matches the genome version used when generating your peak file. In the case of `myPeakList`, the peaks were originally called against _hg18_, so it is necessary to use a matching annotation file created with _hg18_. Alternatively, you can use the `rtracklayer::liftOver()` function to convert `myPeakList` to _hg38_ coordinates. For step-by-step instructions, refer to "Step3" in Section \@ref(custompool).

## Example 1: find the nearest features {#findnearest}
We can annotate the peaks by assigning the nearby features to them. This can be achieved by setting `output = "nearestLocation"`. When this option is used, the results may include "overlapping" features as long as they are the nearest ones to the peaks.
```{r}
library(TxDb.Hsapiens.UCSC.hg18.knownGene)

data(myPeakList)
peak_to_anno <- myPeakList[1:100]
anno_data <- transcripts(TxDb.Hsapiens.UCSC.hg18.knownGene)

annotated_peak <- annotatePeakInBatch(peak_to_anno, 
                                      output = "nearestLocation",
                                      PeakLocForDistance = "start",
                                      FeatureLocForDistance = "TSS",
                                      AnnotationData = anno_data)
head(annotated_peak, n = 2)
```

Here is a breakdown of the options:

+ `output = "nearestLocation"`: (default) 
    + output the nearest features calculated as `abs(PeakLocForDistance - FeatureLocForDistance)`. The output can consist of both "strictly nearest features (non-overlapping)" and "overlapping features" as long as it is the nearest
+ `PeakLocForDistance = "start"` (default): 
    + "start" means using the 5' end (relative to plus strand) of the peak to calculate the distance to features
+ `FeatureLocForDistance = "TSS"` (default): 
    + "TSS" means using the 5' end (relative to plus strand) for features on the plus strand and use the 3' end (also relative to plus strand) for features on the minus strand to calculate the distance to features

Here is a breakdown of the resulting metadata columns:

+ _peak_: id of the peak
+ _feature_: id of the feature such as Ensembl gene ID
+ _start_position_, _end_position_, _feature_strand_: feature coordinates 
+ _insideFeature_: relative location of the peak to the feature
    + "upstream": peak resides upstream of the feature
    + "downstream": peak resides downstream of the feature
    + "inside": peak resides inside the feature
    + "overlapStart": peak overlaps with the start of the feature
    + "overlapEnd": peak overlaps with the end of the feature
    + "includeFeature": peak includes the feature entirely
+ _distancetoFeature_: peak-to-feature distance as calculated with `abs(PeakLocForDistance - FeatureLocForDistance)`
+ _shortestDistance_: the shortest distance from either end of the peak to either end the feature
+ _fromOverlappingOrNearest_: relevant only when `output = "both"`; "nearestLocation" indicates that the feature is the closest to the peak, can overlap with the peak; "Overlapping" means that the feature overlaps with the peak and it is not the nearest; when `output = "nearestLocation"`, this column should consist of only "NearestLocation"

## Example 2: find the nearest and overlapping features {#findboth}
In addition, `annotatePeakInBatch` can also report both the nearest features and overlapping features by setting `output = "both"` and the `maxgap` parameter. For example, the following command outputs the nearest features plus all overlapping features that are within 100bp away.
```{r}
annotated_peak <- annotatePeakInBatch(peak_to_anno, 
                                      AnnotationData = anno_data,
                                      output = "both",
                                      maxgap = 100)
head(annotated_peak, n = 4)
```

Now, the `fromOverlappingOrNearest` column consists of both "NearestLocation" and "Overlapping" categories.

## Visualize peak-to-feature distances
The relative location distribution of peak-to-feature can be visualized using the information stored in the _insideFeature_ metadata column.
```{r, fig.cap = "Peak distribution around features"}
pie1(table(annotated_peak$insideFeature))
```

## Use custom annotation data
You also have the option to create and pass user-defined feature coordinates in _GRanges_ format as `annotationData`. For example, if you have a list of transcript factor binding sites obtained by literature mining and would like to use it to annotate your peaks. you can convert the TF binding site coordinates into a _GRanges_ object and then pass that object into `annotatePeakInBatch`.
```{r}
TF_binding_sites <- GRanges(seqnames = c("1", "2", "3", "4", "5", "6", "1", 
                                         "2", "3", "4", "5", "6", "6", "6", 
                                         "6", "6", "5"),
                            ranges = IRanges(start = c(967659, 2010898, 2496700, 
                                                       3075866, 3123260, 3857500,
                                                       96765, 201089, 249670, 
                                                       307586, 312326, 385750, 
                                                       1549800, 1554400, 1565000, 
                                                       1569400, 167888600),
                                             end = c(967869, 2011108, 2496920, 
                                                     3076166,3123470, 3857780,
                                                     96985, 201299, 249890, 307796, 
                                                     312586, 385960, 1550599, 
                                                     1560799, 1565399, 1571199, 
                                                     167888999),
                                             names = paste("t", 1:17, sep = "")),
                            strand = c("*", "*", "*", "*", "*", "*", "*", "*", "*", 
                                       "*", "*", "*", "*", "*", "*", "*", "*"))

annotated_peak2 <- annotatePeakInBatch(peaks1, AnnotationData = TF_binding_sites)
head(annotated_peak2, n = 2)
```

Another example of using user-defined `AnnotationData` is to annotate peaks by promoters. A promoter is typically defined as the DNA sequence located immediately upstream of the TSS of a gene. The specific size of a promoter can vary depending on the gene, its regulatory complexity, and the species being studied. In practice, the promoter region can be defined as 2000bp upstream and 500bp downstream from the TSS. To prepare a custom annotation file containing only promoters, users can leverage the accessor function `promoters`. Similar results can be obtained using the feature-centric approach mentioned in Section \@ref(featurecentric).
```{r}
promoter_regions <- promoters(TxDb.Hsapiens.UCSC.hg18.knownGene, 
                              upstream = 2000, downstream = 500)
head(promoter_regions, n = 2)

annotated_peak3 <- annotatePeakInBatch(peak_to_anno, 
                                       AnnotationData = promoter_regions)
head(annotated_peak3, n = 2)
```

# Add other feature IDs {#addids}
Depending on the annotation file you use, the feature assigned to your peaks may have different feature IDs. For example, if you annotate your peaks with genes using the `TxDb.Hsapiens.UCSC.hg38.knownGene` annotation file, the feature id provided in the annotation file will be "entrez ID". On the other hand, if you annotate your peaks using the `EnsDb.Hsapiens.v86` annotation file, the feature id in the annotation will be "Ensembl gene ID". 
```{r}
anno_txdb <- genes(TxDb.Hsapiens.UCSC.hg38.knownGene)
head(anno_txdb$gene_id, n = 5)

anno_ensdb <- genes(EnsDb.Hsapiens.v86)
head(anno_ensdb$gene_id, n = 5)
```

The feature id in the annotation file will be listed under the "feature" metadata column in your annotated peak _GRanges_ object. To link these feature IDs to other IDs such as "symbol", you can use the `addGeneIDs` function.

The `addGeneIDs` function can accept either a vector of feature IDs or an annotated peak _GRanges_ object as input. It works by creating a mapping between the input feature IDs and the IDs to be linked, using either an organism annotation dataset (`OrgDb` object, such as `org.Hs.eg.db`) or a _BioMart_ dataset (`Mart` object, such as `useMart(biomart = "Ensembl", dataset = "hsapiens_gene_Ensembl")`). 

To use the function correctly, you need to provide the input feature ID type using the `feature_id_type` argument, and specify the feature ID types that need to be linked via the `IDs2Add` argument. The supported `feature_id_type` and `IDs2Add` differ between `OrgDb` and `Mart`. Below summarizes the commonly used ID types.

+ Use _OrgDb_
    + _feature_id_type_: input feature ID type
        + "ensembl_gene_id"
        + "entrez_id"
        + "gene_symbol"
        + "gene_alias"
        + "refseq_id"
    + _IDs2Add_: features ID types to be linked
        + "ensembl"
        + "ensembltrans"
        + "ensemblprot"
        + "entrez_id"
        + "refseq"
        + "symbol"
        
+ Use _Mart_
    + _feature_id_type_: input feature ID type, use `listFilters(mart)` to see the full list
        + "ensembl_gene_id"
        + "ensembl_transcript_id"
        + "ensembl_exon_id"
        + "external_gene_name"
        + "entrezgene_id"
    + _IDs2Add_: feature ID types to be linked, use `listAttributes(mart)` to see the full list
        + "ensembl_gene_id"
        + "ensembl_transcript_id"
        + "ensembl_exon_id"
        + "gene_biotype"
        + "transcript_biotype"
        + "entrezgene_id"
        + "hgnc_symbol"
        + "entrezgene_trans_name"

## Example1: find gene symbols for a vector of entrez IDs
The following example demonstrates how to use the `addGeneIDs` function to find gene symbols for a vector of entrez IDs using `OrgDb`. Note that the `"org.Hs.eg.db"` package name must be quoted.
```{r}
library(org.Hs.eg.db)
library(TxDb.Hsapiens.UCSC.hg38.knownGene)

ucsc.hg38.knownGene <- genes(TxDb.Hsapiens.UCSC.hg38.knownGene)
entrez_ids <- head(ucsc.hg38.knownGene$gene_id, n = 10)
print(entrez_ids)

res <- addGeneIDs(entrez_ids, 
                  orgAnn = "org.Hs.eg.db", 
                  feature_id_type = "entrez_id",
                  IDs2Add = "symbol")
head(res, n = 3)
```

## Example2: add gene symbols to annotated peaks
For this example, we annotate the `macs_peak_gr2` (obtained in Section \@ref(readinpeak)) using transcript information from _TxDb_, and add gene symbols to them.
```{r}
txdb.hg38.transcript <- transcripts(TxDb.Hsapiens.UCSC.hg38.knownGene)
head(txdb.hg38.transcript, n = 4)
```

It appears that the `txdb.hg38.transcript` contains a metadata column called _tx_name_, which holds the Ensembl transcript IDs. However, the `annotatePeakInBatch` function requires this information to be stored as the names of the `txdb.hg38.trancsript` object (`names(txdb.hg38.transcript)`). This is necessary to generate annotated peaks that are compatible with the `addGeneIDs` function. To achieve this, we need to extract the transcript IDs and assign them as names. Below is how.
```{r}
names(txdb.hg38.transcript) <- txdb.hg38.transcript$tx_name
```

Now, we can annotate `macs_peak_gr2` with `annotatePeakInBatch`.
```{r}
res <- annotatePeakInBatch(macs_peak_gr2, 
                           AnnotationData = txdb.hg38.transcript)
head(res, n = 2)
```

As anticipated, the resulting `feature` column contains Ensembl transcript IDs. Next, we utilize the `mart` option to add gene symbols.
```{r}
tryCatch({
  # we will first try biomaRt
  library(biomaRt)

  mart <- useMart(biomart = "ensembl",
                  dataset = "hsapiens_gene_ensembl")
  res <- addGeneIDs(res, 
                    mart = mart,
                    feature_id_type = "ensembl_transcript_id",
                    IDs2Add = "hgnc_symbol")
  head(res, n = 2)
}, error=function(e){
  message(e)
  library(org.Hs.eg.db)
  res <- addGeneIDs(res, 
                    orgAnn = TxDb.Hsapiens.UCSC.hg38.knownGene,
                    feature_id_type = "ensembl_transcript_id",
                    IDs2Add = "GENEID")
  res$symbol[!is.na(res$GENEID)] <- 
    xget(res$GENEID[!is.na(res$GENEID)], org.Hs.egSYMBOL, output = 'first')
  tail(res, n = 2)
})
```

Use `listMarts` to show available `biomart` and use `listDatasets` to show available `dataset`. Be aware that, unlike using `OrgDb` option, we must supply `hgnc_symbol` instead of `symbol` for the `IDs2Add` argument.

# Enrichment analysis
Enrichment analysis is a crucial step in determining whether specific biological processes, pathways, or functional categories are over-represented among the genes associated with the peaks. This analysis provides functional implications for the annotated peaks. Two commonly used method for enrichment analysis are gene ontology (GO) and pathway enrichment.

The GO is a structured vocabulary that categorizes genes and their products into three main categories: _Molecular Function_ (what it does), _Biological Process_ (how it does it), and _Cellular Component_ (where it does it). A pathway, on the other hand, refers to a set of predefined genes involved in a coordinated sequence of molecular events or cellular processes that collectively perform a specific biological function. Examples of biological pathways include the "Glycolysis pathway", which breaks down glucose into pyruvate; and the "MAPK signaling pathway", which is involved in cell proliferation, differentiation, and response to external stimuli. While GO enrichment analysis provides more general insights, pathway analysis focuses specifically on predefined pathways. Both methods are commonly practiced and can be achieved with the `getEnrichedGO` and `getEnrichedPATH` function in `r Biocpkg("ChIPpeakAnno")`.

In the following demonstration, we first annotate `macs_peak_gr2` (obtained in Section \@ref(readinpeakdemo)) using genes from _EnsDb_, and perform GO and pathway enrichment analysis.
```{r, fig.cap = "Histogram showing enriched GO terms"}
anno_data <- genes(EnsDb.Hsapiens.v86)
annotated_peak4 <- annotatePeakInBatch(macs_peak_gr2,
                                       AnnotationData = anno_data,
                                       output = "both")

enriched_go <- getEnrichedGO(annotated_peak4, 
                             orgAnn = "org.Hs.eg.db", 
                             feature_id_type = "ensembl_gene_id")
enrichmentPlot(enriched_go, label_wrap = 60)
```

Please ensure to enclose the `"org.Hs.eg.db"` in quotes, and that the `feature_id_type` matches the ID type stored in the `feature` metadata column of your annotated peak object. If you are using genes from _TxDb_ for peak annotation, the `feature` is likely `entrez_id`. If you are using genes from _EnsDb_ for annotation, the `feature` should be `ensembl_gene_id`. The code snippet below shows the number of enriched GO terms in each category, "bp" for "biological process", "cc" for "cellular component", and "mf" for "molecular function". By default, `multiAdjMethod = NULL` meaning that no multiple testing correction is performed.
```{r}
length(enriched_go[["bp"]][["go.id"]])
length(enriched_go[["cc"]][["go.id"]])
length(enriched_go[["mf"]][["go.id"]])
```

It turns out that if using the subset of annotated `macs_peak_gr2` leads to zero enriched GO terms under the "bp" and "cc" categories, and 6 hits under the "mf" category. It suggests taht there are no significantly enriched "bp" or "cc" terms associated with the subset of peaks. However, there are 6 significantly enriched "mf" terms.
```{r}
head(enriched_go[["mf"]], n = 2)
```

Pathway enrichment analysis can be performed using popular databases such as _Reactome_ and _KEGG (Kyoto Encyclopedia of Genes and Genomes)_. _Reactome_ is renowned for its detailed and expert-curated information, while _KEGG_ offers a broader scope of information, including pathways, diseases, drugs, and more organisms. The `getEnrichedPATH` function can use either database by specifying the `pathAnn` parameter. 

For demonstration, we will use the built-in dataset `annotatedPeaks` with _Reactome_ database. Be aware that the `feature_id_type` for this dataset is `ensembl_gene_id`. To switch to the _KEGG_ database, simply set `pathAnn = "KEGGREST"`.
```{r, fig.cap = "Bar graph showing enriched pathways"}
library(reactome.db)

data(annotatedPeak)
enriched_path <- getEnrichedPATH(annotatedPeak,
                                 orgAnn = "org.Hs.eg.db",
                                 feature_id_type = "ensembl_gene_id",
                                 pathAnn = "reactome.db")
```

To visualize the enriched pathways, we can use the `enrichmentPlot` function.
```{r, fig.cap = "Histogram showing enriched pathways"}
enrichmentPlot(enriched_path)
```

To use `getEnrichedGO` and `getEnrichedPATH`, an `OrgDb` annotation package is necessary. For species that are less common and do not have a valid `OrgDb` available, users can find alternative methods in [this post](https://support.bioconductor.org/p/9153901/#9153953).

# Motif analysis
Sequence motif refer to a recurring pattern in DNA that is believed to have a biological function. These motifs often indicate binding sites for proteins like TFs, some other motifs play a role at the RNA level such as ribosome binding and transcription termination. For peaks obtained through experiments like TF ChIP-seq, motif analysis aids in validating expected binding factors or discovering the TFBSs, while unanticipated motifs suggest the presence of co-binding factors. 

`r Biocpkg("ChIPpeakAnno")` provides several functions that are related to motif analysis, details see below.
    + `getAllPeakSequence`: obtain genomic sequences around peaks
        + Obtained sequences can be used for motif discovery or PCR validation
    + `oligoSummary`: find consensus sequences (motifs) in peak sequences
    + `summarizePatternInPeaks`: check if given motifs appear in peak sequences

## Obtain sequences surrounding the peaks
Here is an example of how to retrieve the peak sequences, including 20bp upstream and 20bp downstream, for the `macs_peak_gr2` peaks obtained in Section \@ref(readinpeak).
```{r}
library(BSgenome.Hsapiens.UCSC.hg38)

sequence_around_peak <- getAllPeakSequence(macs_peak_gr2, 
                                           upstream = 20,
                                           downstream = 20, 
                                           genome = BSgenome.Hsapiens.UCSC.hg38)
head(sequence_around_peak, n = 2)
```

The `genome` argument can accept either a _BSgenome_ object or a _Mart_ object. It is important to ensure that the genome version used matches the one used for creating the peak file. You can find a full list of available _BSgenome_ objects on this [site](https://www.bioconductor.org/packages/release/data/annotation/). 

The following example demonstrates on how to use the `mart` option. It is slower compared to using a _BSgenome_ because it queries the _BioMart_ for annotations on the fly if `AnnotationData` is not set. Refer to Section \@ref(usebiomart) for more on _Mart_.
```{r, eval = FALSE}
library(biomaRt)

mart <- useMart(biomart="ENSEMBL_MART_ENSEMBL",
                dataset="hsapiens_gene_ensembl")

sequence_around_peak <- getAllPeakSequence(macs_peak_gr2[1], 
                                           upstream = 20,
                                           downstream = 20, 
                                           genome = mart)
```

To save the sequences into _fasta_, use the `write2FASTA` function.
```{r, eval = FALSE}
write2FASTA(sequence_around_peak, file = "macs_peak_gr2.fa")
```

## Discover consensus sequences (motifs) in the peaks 
The `oligoSummary` function utilizes Markov models to ascertain if a motif is enriched in a set of sequences relative to the background. As a prerequisite, we must first calculate the frequencies of all combinations of short oligonucleotides of a specified length in the background [@leung1996over]. This can be accomplished using the `oligoFrequency` function. In the example below, we aim to identify consensus sequences of length 6.
```{r}
freqs <- oligoFrequency(BSgenome.Hsapiens.UCSC.hg38$chr1)
motif_summary <- oligoSummary(sequence_around_peak, 
                              oligoLength = 6,
                              MarkovOrder = 3,
                              freqs = freqs,
                              quickMotif = TRUE)
```

Here is a breakdown of the arguments:

+ _oligoLength_: the length of the motifs to search for
+ _MarkovOrder_: the order of a Markov chain, which determines how much the current state in the chain depends on previous states; simply put, a zero-order Markov chain does not consider any context or dependencies between adjacent elements, while higher-order Markov chains capture longer-range dependencies in sequences, making them more suitable for modeling complex sequence patterns
+ _freqs_: the background motif frequencies used for the Markov model
+ _quickMotif_: whether or not to generate the motif matrices

The resulting `motif_summary` is a list containing three elements:

+ _zscore_: the Z-score of each oligonucleotide, which quantifies how many standard deviations away the observed count is from the expected count; a high positive score suggests that the motif is significantly over-represented in the peaks
+ _counts_: the count numbe of each oligonucleotide
+ _motifs_: a list of motif matrices when `quickMotif = TRUE`

We can use histogram (`hist`) to visualize the resulting Z-scores and labels top hits with the `text` function. Below, we label the name of the motif that has the highest Z-score.
```{r, fig.cap = "Histogram showing Z-score distribution"}
zscore <- sort(motif_summary$zscore)
h <- hist(zscore, breaks = 100, main = "Histogram of Z-score")
text(x = zscore[length(zscore)], 
     y = h$counts[length(h$counts)] + 1, 
     labels = names(zscore[length(zscore)]), 
     adj = 0, 
     srt = 90)
```

To illustrate how the Z-score can be influenced by the enrichment level of various motifs, the following code utilizes simulated data. We first generate 5000 sequences with lengths ranging between 100 and 2000 nucleotides. Subsequently,we randomly introduce motif 1 into 10% of the sequences and motif 2 into 15% of the sequences.
```{r, fig.cap = "Histogram showing Z-score distribution for simulation data"}
set.seed(1)

# motifs to simulate
simulate_motif_1 <- "AATTTA"
simulate_motif_2 <- "TGCATG"

# sample 5000 sequences with lengths ranging from 100 to 2000 nucleotides
# randomly insert motif_1 to 10% of the sequences, and motif_2 to 15% of the sequences
simulation_seqs <- sapply(sample(c(1, 2, 0), 
                                 5000,
                                 prob = c(0.1, 0.15, 0.75),
                                 replace = TRUE), 
                           function(x) {
                             seq <- sample(c("A", "T", "C", "G"),
                                           sample.int(1900, 1) + 100, 
                                           replace = TRUE)
                             insert_pos <- sample.int(length(seq) - 6, 1)
                             if (x == 1) {
                               seq[insert_pos:(insert_pos + 5)] <- strsplit(simulate_motif_1, "")[[1]]
                             } else if (x == 2) {
                               seq[insert_pos:(insert_pos + 5)] <- strsplit(simulate_motif_2, "")[[1]]
                             }
                             paste(seq, collapse = "")
                           }
)

motif_summary_simu <- oligoSummary(simulation_seqs, 
                                   oligoLength = 6, 
                                   MarkovOrder = 3, 
                                   quickMotif = TRUE)
zscore_simu <- sort(motif_summary_simu$zscore, 
                    decreasing = TRUE)
h_simu <- hist(x = zscore_simu, 
               breaks = 100, 
               main = "Histogram of Z-score for simulation data")
text(x = zscore_simu[1:2],  
     y = rep(5, 2), 
     labels = names(zscore_simu[1:2]), 
     adj = 0, 
     srt = 90)
```

As evident from the simulation results, the higher the probability of the motif, the larger the resulting Z-score. In addition, you can visualize the motif using the `r Biocpkg("motifStack")` package.
```{r, fig.small = TRUE}
library(motifStack)

pfm <- new("pfm", mat = motif_summary_simu$motifs[[1]],
           name = "sample motif 1")
motifStack(pfm)
```

To loop through each element in `motif_summary$motifs`, we can use the `mapply` function.
```{r, fig.cap = "Plot showing the first motif detected", fig.small = TRUE}
pfms <- mapply(function(motif, id) { new("pfm", mat = motif, name = as.character(id)) },
               motif_summary$motifs,
               seq_along(motif_summary$motifs))

motifStack(pfms[[1]])
```

## Scan pre-defined sequence patterns in the peaks
If you have a list of motifs (sequence patterns), the `summarizePatternInPeaks` function can be utilized to determine whether they are present in the peaks.
```{r}
example_pattern_file <- system.file("extdata/examplePattern.fa",
                                    package = "ChIPpeakAnno")
readLines(example_pattern_file)
pattern_in_peak <- summarizePatternInPeaks(patternFilePath = example_pattern_file,
                                           BSgenomeName = BSgenome.Hsapiens.UCSC.hg38,
                                           peaks = macs_peak_gr2[1:200],
                                           bgdForPerm = "chromosome",
                                           nperm = 100, 
                                           method = "permutation.test")

pattern_in_peak$motif_enrichment
head(pattern_in_peak$motif_occurrence, n = 2)
```

The `summarziePatternInPeaks` function provides two distinct methods (`method = c("binom.test", "permutation.test")`) for evaluating the significance of given motif enrichment within target peaks. When utilizing the "binom.test" method, the expected frequencies for each motif must be determined first, which can be achieved via `expectFrequencyMethod = c("Markov", "Naive")`. When employing the "permutation.test" method, users need to provide parameters such as the number of permutation ("nperm"), the significance level ("alpha"), and methods how background sequences are determined (`bgdForPerm = c("shuffle", "chromosome"), chromosome = c("asPeak", "random")`).

The outcome from `summarizePatternInPeaks` comprises two tables. The "motif_enrichment" table succinctly summarizes the enrichment statistics for each motif. Specifically, when `method = "binom.test"`, the last column "pValueBinomTest" represents the P-values resulting from the binomial test. Conversely, when `method = "permutation.test"`, the last column "cutOffPermutationTest" denotes the threshold value derived from the permutation test, determined by the specified signifiance level. The "motif_occurrence" table contains detailed information regarding the occurrences of each motif within every peak.

## Alternative tools
Besides using `r Biocpkg("ChIPpeakAnno")`, users can extract the sequences with the `getAllPeakSequence` function and employ other tools such as [MEME Suite](https://meme-suite.org/meme/doc/streme.html) for motif-related analysis.

# Peak profile comparison {#profilecompare}
When analyzing two or more peak sets from different experiments (e.g. two TFs), it can be insightful to examine whether the peak profiles correlate, and if they do, how do they compare to each other. `r Biocpkg("ChIPpeakAnno")` not only offers functions to assess if there is a significant overlap among multiple peak sets, but it also provides visualization functions for easy comparison of peak patterns side-by-side.

The significance of overlap can be determined with hypergeometric test or permutation test, both of which are available in `r Biocpkg("ChIPpeakAnno")`. Please be advised that, due to the inherent challenges in estimating the `totalTest` parameter for the hypergeometric test, we strongly discourage the use of this approach.

## Use hypergeometric test to determine overlap among peak sets {#hypertest}
The hypergeometric test is grounded in the principle of the hypergeometric distribution, which is a probability distribution that describes the likelihood of drawing a specific number of successes (k) from a sample size of n, given a finite population (N) that contains K successes when sampling is done without replacement. The null hypothesis posits that the sample is drawn randomly from the population, implying that the there is no overlap between the two sets of peaks. A small P-value indicates that the null should be rejected, indicating a significant overlap between the two sets of peaks.

In `r Biocpkg("ChIPpeakAnno")`, the hypergeometric test is incorporated into the `makeVennDiagram` function, as detailed in Section \@ref(venn). The following example illustrates how to compute the hypergeometric test P-values for peak sets from three TF ChIP-seq experiments.
```{r}
tf1 <- toGRanges(system.file("extdata/TAF.broadPeak", package = "ChIPpeakAnno"),
                 format = "broadPeak")
tf2 <- toGRanges(system.file("extdata/Tead4.broadPeak", package = "ChIPpeakAnno"),
                 format = "broadPeak")
tf3 <- toGRanges(system.file("extdata/YY1.broadPeak", package = "ChIPpeakAnno"),
                 format = "broadPeak")
```

To effectively apply the hypergeometric test, we first need to estimate the total number of binding sites, i.e. `totalTest`. The selection of `totalTest` affects the stringency of the test, with smaller values resulting in a more conservative outcome (larger P-values). For practical guidance on how to choose an appropriate value for `totalTest`, you can refer to this [post](https://stat.ethz.ch/pipermail/bioconductor/2010-November/036540.html). 

In our example, we assume that potential binding regions (which include coding regions and promoter regions) constitute 3% (fairly rough estimation) of the entire genome. Since the example data is derived from chromosome 2, we can estimate the number of total binding sites as `(length of chr2) * 3% / (mean peak length)`.
```{r, results = "hide", fig.cap = "Venn diagram1 showing overlapping peaks", fig.small = TRUE}
overlapping_peaks <- findOverlapsOfPeaks(tf1, 
                                         tf2, 
                                         tf3, 
                                         connectedPeaks = "keepAll")
mean_peak_width <- mean(width(unlist(GRangesList(overlapping_peaks[["all.peaks"]]))))

total_binding_sites <- length(BSgenome.Hsapiens.UCSC.hg38[["chr2"]]) * 0.03 / mean_peak_width
venn1 <- makeVennDiagram(overlapping_peaks, 
                         totalTest = total_binding_sites, 
                         connectedPeaks = "keepAll", 
                         fill = c("#CC79A7", "#56B4E9", "#F0E442"),
                         col = c("#D55E00", "#0072B2", "#E69F00"),
                         cat.col = c("#D55E00", "#0072B2", "#E69F00"))
```

For the P-values of each peak pair:
```{r}
venn1[["p.value"]]
```

For the overlapping peak counts:
```{r}
venn1[["vennCounts"]]
```

The parameter `connectedPeaks` denotes how to calculate peak counts when multiple peaks from different groups overlap. If `connectedPeaks = "keepFirstListConsistent"`, the counts from the first group will be consistently displayed in the plot. If `connectedPeaks = "keepAll"`, you will see multiple numbers: all original peak counts for each group will be displayed in parentheses, while the count of the minimally involved peaks will be displayed outside the parentheses. 
```{r, results = "hide", fig.cap = "Venn diagram2 showing overlapping peaks", fig.small = TRUE}
venn2 <- makeVennDiagram(overlapping_peaks, 
                         totalTest = total_binding_sites, 
                         connectedPeaks = "keepFirstListConsistent", 
                         fill = c("#CC79A7", "#56B4E9", "#F0E442"),
                         col = c("#D55E00", "#0072B2", "#E69F00"),
                         cat.col = c("#D55E00", "#0072B2", "#E69F00"))
```

Given that all the P-values are extremely small, we must reject the null hypothesis. This indicates that each pair of peak sets significantly overlaps with each other. A major drawback of this approach is the necessity to estimate a `totalTest`, which could dramatically affect the test results. For instance, if we choose "2%" instead of "3%" in the above example, the P-value for `tf1` vs. `tf2` increases to 0.49, meaning we can no longer reject the null. To circumvent the requirement of `totalTest`, we have integrated a permutation test in the `peakPermTest` function.

## Use permutation test to determine overlap among peak sets {#permtest}
The permutation test is a non-parametric test, which means it does not require the data to adhere to any specific distribution. The test statistic is determined according to the observed data, and the null distribution of the test statistic is estimated using a permutation (re-sampling) procedure. 

In our scenario, the number of overlapping peaks is treated as the test statistic. Its null distribution is estimated by first re-sampling peaks from a random peak list (the _peak pool_, which represents all potential binding sites) followed by counting the number of overlapping peaks. The random peak list is generated using the distributions found from the input peaks, ensuring that the peak widths and relative binding positions to the features (such as _TSS_ and _geneEnd_) follow the same distributions as the input peaks. When the null hypothesis is valid, the number of overlapping peaks is not significantly different from what would be expected by chance. Here are some sample codes using `peakPermTest`.

Example1 demonstrates a permutation test for non-relevant peak sets.
```{r, eval = FALSE}
library(TxDb.Hsapiens.UCSC.hg38.knownGene)

txdb <- TxDb.Hsapiens.UCSC.hg38.knownGene
set.seed(123)

# Example1: non-relevant peak sets
utr5 <- unique(unlist(fiveUTRsByTranscript(txdb)))
utr3 <- unique(unlist(threeUTRsByTranscript(txdb)))

utr5 <- utr5[sample.int(length(utr5), 1000)]
utr3 <- utr3[sample.int(length(utr3), 1000)]

pt1 <- peakPermTest(peaks1 = utr3, 
                    peaks2 = utr5,
                    TxDb = txdb, 
                    maxgap = 500,
                    seed = 1)
plot(pt1)
```

```{r, fig.cap = "Permutation test for non-relevant peak sets", echo = FALSE, out.width = "100%", out.height = "100%"}
png <- system.file("extdata", "permTest1.png", package = "ChIPpeakAnno")

knitr::include_graphics(png)
```

Example2 demonstrates a permutation test for highly relevant peak sets.
```{r, eval = FALSE}
# Example2: highly relevant peak sets
cds <- unique(unlist(cdsBy(txdb)))
ol <- findOverlaps(cds, utr3, maxgap = 1)
peaks2 <- c(cds[sample.int(length(cds), 500)],
            cds[queryHits(ol)][sample.int(length(ol), 500)])
pt2 <- peakPermTest(peaks1 = utr3,
                    peaks2 = peaks2,
                    TxDb = txdb,
                    maxgap = 500,
                    seed = 1)
plot(pt2)
```

```{r, fig.cap = "Permutation test for highly relevant peak sets", echo = FALSE, out.width = "100%", out.height = "100%"}
png <- system.file("extdata", "permTest2.png", package = "ChIPpeakAnno")

knitr::include_graphics(png)
```

As observed, for highly relevant peak sets, the P-value is very small. 

### Use custom _peak pool_ {#custompool}
The `peakPermTest` function can automatically generate a _peak pool_ given the peak binding type (`bindingType = c("TSS", "geneEnd")`), annotation type (`featureType = c("transcript", "exon")`), and annotation data (_TxDb_). Additionally, users have the option to construct the _peak pool_ from actual binding sites derived from experimental data, with hot spots removed. Hot spots refer to genomic regions that have a high likelihood of being bound by many TFs in ChIP-seq experiments [@yip2012]. We recommend removing hot spots prior to the permutation test to prevent overestimation of the association between two input peak sets. Users are also advised to remove [ENCODE blacklist](https://github.com/Boyle-Lab/Blacklist/tree/master/lists) regions. The blacklists were constructed by identifying consistently problematic regions across independent cell lines and types of experiments for each species in the _ENCODE_ and _modENCODE_ datasets [@encode2012]. 

Below is an example of creating a _peak pool_ for the human genome using the TF binding site clusters downloaded from [ENCODE](https://hgdownload.cse.ucsc.edu/goldenpath/hg38/encRegTfbsClustered/). The following steps are involved:

+ Step1: download TF binding sites
+ Step2: download hot spots
+ Step3: liftover hot spots to hg38 (if necessary)
+ Step4: select peak sets to test
+ Step5: remove hot spots from binding pool
+ Step6: perform permutation test

```{r, eval = FALSE}
# Step1: download TF binding sites
temp <- tempfile()
download.file(file.path("https://hgdownload.cse.ucsc.edu/",
                        "goldenpath/",
                        "hg38/",
                        "encRegTfbsClustered/",
                        "encRegTfbsClusteredWithCells.hg38.bed.gz"), 
              temp)
df_tfbs <- read.delim(gzfile(temp, "r"), header = FALSE)
unlink(temp)

colnames(df_tfbs)[1:4] <- c("seqnames", "start", "end", "TF")
tfbs_hg38 <- GRanges(as.character(df_tfbs$seqnames),
                     IRanges(df_tfbs$start, df_tfbs$end),
                     TF = df_tfbs$TF)

# Step2: download hot spots
base_url <- "http://metatracks.encodenets.gersteinlab.org/metatracks/"

temp1 <- tempfile()
temp2 <- tempfile()
download.file(file.path(base_url, 
                        "HOT_All_merged.tar.gz"), 
              temp1)
download.file(file.path(base_url, 
                        "HOT_intergenic_All_merged.tar.gz"),
              temp2)
untar(temp1, exdir = dirname(temp1))
untar(temp2, exdir = dirname(temp1))
bedfiles <- dir(dirname(temp1), "bed$")
hot_spots_hg19 <- sapply(file.path(dirname(temp1), bedfiles), toGRanges, format = "BED")
unlink(temp1)
unlink(temp2)

names(hot_spots_hg19) <- gsub("_merged.bed", "", bedfiles)
hot_spots_hg19 <- sapply(hot_spots_hg19, unname)
hot_spots_hg19 <- GRangesList(hot_spots_hg19)

# Step3: liftover hot spots to hg38
library(R.utils)

temp_chain_gz <- tempfile()
temp_chain <- tempfile()
base_url_chain <- "http://hgdownload.cse.ucsc.edu/goldenpath/"
download.file(file.path(base_url_chain, 
                        "hg19/liftOver/",
                        "hg19ToHg38.over.chain.gz"),
              temp_chain_gz)
gunzip(filename = temp_chain_gz, destname = temp_chain)
chain_file <- import.chain(hg19_to_hg38)
unlink(temp_chain_gz)
unlink(temp_chain)

hot_spots_hg38 <- liftOver(hot_spots_hg19, chain_file)

# Step4: select peak sets to test
tfbs_hg38_by_TF <- split(tfbs_hg38, tfbs_hg38$TF)
TAF1 <- tfbs_hg38_by_TF[["TAF1"]]
TEAD4 <- tfbs_hg38_by_TF[["TEAD4"]]

# Step5: remove hot spots from binding pool
tfbs_hg38 <- subsetByOverlaps(tfbs_hg38, hot_spots_hg38, invert=TRUE)
tfbs_hg38 <- reduce(tfbs_hg38)

# Step6: perform permutation test
pool <- new("permPool", 
            grs = GRangesList(tfbs_hg38), 
            N = length(TAF1))
pt3 <- peakPermTest(TAF1, TEAD4, pool = pool, ntimes = 500)
plot(pt3)
```

```{r, fig.cap = "Permutation test using custom peak pool", echo = FALSE, out.width = "100%", out.height = "100%"}
png <- system.file("extdata", "permTest3.png", package = "ChIPpeakAnno")

knitr::include_graphics(png)
```

## Visualize TSS enrichment signal of multiple experiments {#multiexp}
If you have peak files obtained from multiple TF ChIP-seq experiments and would like to compare their enriched signals around TSS using raw signals such as read coverage. `r Biocpkg("ChIPpeakAnno")` provides two functions, `featureAlignedHeatmap` and `featureAlignedDistribution`, to visualize their binding patterns side-by-side.

To illustrate this, we first need to prepare both the peak data and coverage information (_bigWig_). This involves four steps:

+ Step1: read in example peak files
+ Step2: find peaks that are shared by all
+ Step3: read in example coverage files
+ Step4: visualize binding patterns

```{r, fig.cap = "Heatmap of coverage densities for selected TFs"}
# Step1: read in example peak files
extdata_path <- system.file("extdata", package = "ChIPpeakAnno")
broadPeaks <- dir(extdata_path, "broadPeak")
gr_TFs <- sapply(file.path(extdata_path, broadPeaks), toGRanges, format = "broadPeak")
names(gr_TFs) <- gsub(".broadPeak", "", broadPeaks)
names(gr_TFs)
```

Now, we have imported peak files for three TFs ("TAF", "Tead", and "YY1") into the `gr_TFs` object. The next step is to identify overlapping peaks to ensure that we are comparing binding patterns over the same genomic regions.
```{r}
# Step2: find peaks that are shared by all
ol <- findOverlapsOfPeaks(gr_TFs)
gr_TFs_ol <- ol$peaklist$`TAF///Tead4///YY1`

# Step3: read in example coverage files
# here we read in coverage data from -2000bp to -2000bp of each shared peak center
gr_TFs_ol_center <- reCenterPeaks(gr_TFs_ol, width = 4000) # use the center of the peaks and extend 2000bp upstream and downstream to obtain peaks with uniform length of 4000bp

bigWigs <- dir(extdata_path, "bigWig")
coverage_list <- sapply(file.path(extdata_path, bigWigs), 
                        import, # rtracklayer::import
                        format = "BigWig",
                        which = gr_TFs_ol_center,
                        as = "RleList")

names(coverage_list) <- gsub(".bigWig", "", bigWigs)
names(coverage_list)
```

### Heatmap
```{r, fig.cap = "Heatmap of coverages for selected TFs", fig.height = 6, message = FALSE}
# Step4: visualize binding patterns
sig <- featureAlignedSignal(coverage_list, gr_TFs_ol_center)

# since the bigWig files are only a subset of the original files,
# filter to keep peaks that are with coverage data for all peak sets
keep <- rowSums(sig[[1]]) > 0 & rowSums(sig[[2]]) > 0 & rowSums(sig[[3]]) > 0
sig <- sapply(sig, function(x) x[keep, ], simplify = FALSE)
gr_TFs_ol_center <- gr_TFs_ol_center[keep]

featureAlignedHeatmap(sig, gr_TFs_ol_center,
                      upper.extreme=c(3, 0.5, 4))
```

By default, the rows in the heatmap are ordered by the total coverage per row from the first sample ("TAF" in this example). We can reorder the rows by tuning the `sortBy` option. For example, setting `sortBy = "YY1"` will order the rows by the "YY1" sample in the dataset. You can also sort the rows based on hierarchical clustering results. Here is a demonstration:
```{r, fig.cap = "Heatmap of coverages for selected TFs sorted by hierarchical clustering", fig.height = 6, message = FALSE}
# perform hierarchical clustering on rows
sig_rowsums <- sapply(sig, rowSums, na.rm = TRUE)
row_distance <- dist(sig_rowsums)
hc <- hclust(row_distance)

# use hierarchical clustering order to sort
gr_TFs_ol_center$sort_by <- hc$order
featureAlignedHeatmap(sig, gr_TFs_ol_center, 
                      upper.extreme = c(3, 0.5, 4),
                      sortBy = "sort_by")
```

### Density plot
Additionally, we can create a density plot using the `featureAlignedDistribution` function.
```{r, fig.cap = "Distribution of coverage densities for selected TFs", message = FALSE}
featureAlignedDistribution(sig, gr_TFs_ol_center,
                           type = "l")
```

# Common workflow 1: single TF with replicates {#workflow1}
For experiments targeting a single TF with replicates, a common analytic strategy is outlined below.

+ Step1: import data
  + Convert `BED/GFF` files into _GRanges_
  + Find overlapping peaks among replicates
  + Add metadata (optional)
  + Visualize replicate concordance using a Venn diagram
+ Step2: prepare annotation file
+ Step3: visualize peak distribution
+ Step4: annotate peaks
  + Find possible enhancers
  + Find potential bi-directional promoters
+ Step5: perform enrichment analysis
+ Step6: conduct motif analysis

## Step1: import data
Common peak formats such as _BED_, _GFF_, and _MACS_ can be converted into _GRanges_ format using the `toGRanges` function. After importing the data, concordance across peak replicates will be evaluated with `findOverlapsOfPeaks` and `makeVennDiagram`. Be aware that the metadata columns will be dropped for the merged overlapping peaks. To add them back, we can use the `addMetadata` function. For example, `addMetadata(ol, colNames = "score", FUN = mean)` will add a "score" column to each merged overlapping peak by taking the mean score of individual peaks involved.
```{r, message = FALSE, warning = FALSE}
library(ChIPpeakAnno)

# Convert BED/GFF into GRanges
bed1 <- system.file("extdata", "MACS_output_hg38.bed", 
                    package = "ChIPpeakAnno")
gr1 <- toGRanges(bed1, format = "BED", header = FALSE)
gff1 <- system.file("extdata", "GFF_peaks_hg38.gff", 
                    package = "ChIPpeakAnno")
gr2 <- toGRanges(gff1, format = "GFF", header = FALSE)

# Find overlapping peaks
ol <- findOverlapsOfPeaks(gr1, gr2)

# Add "score" metadata column to overlapping peaks
ol <- addMetadata(ol, colNames = "score", FUN = mean) 
head(ol$mergedPeaks, n = 2)
```

```{r, results = "hide", fig.cap = "Venn diagram showing the number of overlapping peaks for gr1 and gr2", fig.small = TRUE}
venn <- makeVennDiagram(ol,
                        fill = c("#009E73", "#F0E442"),
                        col = c("#D55E00", "#0072B2"),
                        cat.col = c("#D55E00", "#0072B2"))
```

For the P-value of hypergeometric test:
```{r}
venn[["p.value"]]
```

For overlapping peak counts:
```{r}
venn[["vennCounts"]]
```

As observed, the extremely small P-value suggests a high relevance between the two peak sets, reflecting good consistency among experimental replicates.

## Step2: prepare annotation file
Similar to the peak files, the annotation file must also be converted into a _GRanges_ object. Annotation _GRanges_ can be constructed from not only _BED_, _GFF_, and user-defined text files, but also from _EnsDb_ and _TxDb_ objects using the `toGRanges` function. For _EnsDb_ and _TxDb_ objects, annotation can also be prepared with accessor functions, as detailed in Section \@ref(txdbensdb). Note that the version of genome used to create the annotation file must match the genome used for peak calling, as feature positions may vary across different genome releases. As an example, if you are using `Mus_musculus.v103` for read mapping, it's best to use `EnsDb.Mmusculus.v103` for annotation. 

```{r, warning = FALSE}
library(EnsDb.Hsapiens.v86)

ensembl.hs86.gene <- toGRanges(EnsDb.Hsapiens.v86, feature = "gene")
head(ensembl.hs86.gene, n = 2)
```

## Step3: visualize peak distribution
### Peak distribution relative to features
Now, given the merged overlapping peaks and annotation data, we can visualize the distribution of the distance from the merged overlapping peaks to the nearest features, such as _genes_ (_TSSs_), using the `binOverFeature` function.
```{r, fig.cap = "Peak count distribution around transcription start sites", warning = FALSE}
binOverFeature(ol$mergedPeaks, 
               nbins = 20,
               annotationData = ensembl.hs86.gene,
               xlab = "peak distance from TSSs (bp)", 
               ylab = "peak count", 
               main = "Distribution of aggregated peak numbers around TSS")
```

### Peak distribution over multiple feature levels
We can use the `genomicElementDistribution` to summarize the distribution of peaks over different types of genomic features such exon, intron, enhancer, UTR. When inputting a single peak file, a pie graph will be generated.
```{r, fig.cap = "Pie graph showing peak distributions over different genomic features"}
library(TxDb.Hsapiens.UCSC.hg38.knownGene)

genomicElementDistribution(ol$mergedPeaks, 
                           TxDb = TxDb.Hsapiens.UCSC.hg38.knownGene)
```

As can be seen, a significant number of peaks originate from promoter regions, which is consistent with the signature of peaks obtained from Tf binding experiments. When inputting a list of peak sets (e.g. replicates), a bar graph will be generated.
```{r, fig.cap = "Bar graph showing peak distributions over different genomic features for two replicates"}
macs_peaks <- GRangesList(rep1 = gr1,
                          rep2 = gr2)
genomicElementDistribution(macs_peaks, 
                           TxDb = TxDb.Hsapiens.UCSC.hg38.knownGene)
```

According to the bar graph, the two peak replicates are consistent. 

### Peak overlappings for multiple features 
To visualize peak overlap for multiple feature sets, we can utilize the _UpSet_ plot (for details, see Section \@ref(upset)).

```{r, fig.cap = "UpSet plot showing peak overlappings for multiple features"}
library(UpSetR)

res <- genomicElementUpSetR(ol$mergedPeak,
                            TxDb.Hsapiens.UCSC.hg38.knownGene)
upset(res[["plotData"]], 
      nsets = length(colnames(res$plotData)), 
      nintersects = NA)
```

## Step4: annotate peaks
Based on the above distribution of aggregated peak numbers around the TSS and the distribution of peaks in different chromosomal regions, most of the peaks locate near the TSS. Therefore, it is reasonable to adopt the feature-centric method to annotate the peaks residing in the promoter regions. Promoters can be specified with the `bindingRegion` parameter. In the following example, the promoter region is defined as 2000bp upstream and 500bp downstream of the TSS (`bindingRegion = c(-2000, 500)`).
```{r}
ol_anno <- annotatePeakInBatch(ol$mergedPeak, 
                               AnnotationData = ensembl.hs86.gene, 
                               output = "nearestBiDirectionalPromoters",
                               bindingRegion = c(-2000, 500))
head(ol_anno, n = 2)
```

You can export the annotation to a CSV file:
```{r, eval = FALSE}
ol_anno <- unname(ol_anno) # remove names to avoid duplicate row.names error
ol_anno$peakNames <- NULL # remove peakNames to avoid unimplemented type 'list' error
write.csv(as.data.frame(ol_anno), "ol_anno.csv")
```

To visualize the distribution of peaks around features:
```{r, fig.cap = "Pie chart showing peak distribution around features"}
pie1(table(ol_anno$insideFeature))
```

### Find peaks located in bi-directional promoters
In addition to using the `output = "nearestBiDirectionalPromoters"` option, `r Biocpkg("ChIPpeakAnno")` provides another helper function called `peaksNearBDP` to fetch statistics for peaks situated in bi-directional promoters. 
```{r}
peaks_near_BDP <- peaksNearBDP(ol$mergedPeaks, 
                    AnnotationData = ensembl.hs86.gene, 
                    MaxDistance = 5000) 
# MaxDistance will be translated into "bindingRegion = 
# c(-MaxDistance, MaxDistance)" internally

peaks_near_BDP$n.peaks
peaks_near_BDP$n.peaksWithBDP
peaks_near_BDP$percentPeaksWithBDP

head(peaks_near_BDP$peaksWithBDP, n = 2)
```

### Find peaks located in enhancers
Enhancers are DNA sequences that can amplify gene expression and are frequently used as biomarkers for cancer diagnosis and treatment. They can be identified using a variety of experimental methods such as 3C, 5C, and HiC [@lieberman2009]. With enhancers obtained through these experimental techniques, we can locate peaks that locate to potential enhancer regions. The following example uses 5C data derived with the _hg19_ genome assembly, hence, it's necessary to use a matching annotation file.
```{r}
library(EnsDb.Hsapiens.v75)

ensembl.hs75.gene <- toGRanges(EnsDb.Hsapiens.v75, feature = "gene")

DNA5C <- system.file("extdata", 
                     "wgEncodeUmassDekker5CGm12878PkV2.bed.gz",
                     package="ChIPpeakAnno")
DNAinteractiveData <- toGRanges(gzfile(DNA5C))
# the example bed.gz file can also be downloaded from:
# https://hgdownload.cse.ucsc.edu/goldenpath/hg19/encodeDCC/wgEncodeUmassDekker5C/wgEncodeUmassDekker5CGm12878PkV2.bed.gz

peaks_near_enhancer <-  findEnhancers(peaks = ol$mergedPeaks,
                                      annoData = ensembl.hs75.gene, 
                                      DNAinteractiveData = DNAinteractiveData)
head(peaks_near_enhancer, n = 2)
```

## Step5: perform enrichment analysis
With annotated peaks, we can use the `getEnrichedGO` and `getEnrichedPATH` functions to respectively retrieve a list of enriched GO or pathway terms.
```{r, fig.cap = "Histogram showing enriched GO terms"}
library(org.Hs.eg.db)

enriched_go <- getEnrichedGO(annotatedPeak = ol_anno, 
                             orgAnn = "org.Hs.eg.db", 
                             feature_id_type = "ensembl_gene_id",
                             condense = TRUE)
enrichmentPlot(enriched_go)
```

Likewise, the following pertains to pathway enrichment analysis.
```{r, fig.cap = "Histogram showing enriched pathways"}
library(reactome.db)

enriched_pathway <- getEnrichedPATH(annotatedPeak = ol_anno,
                                    orgAnn = "org.Hs.eg.db", 
                                    pathAnn = "KEGGREST",
                                    maxP = 0.05)
enrichmentPlot(enriched_pathway)

# To remove the common suffix " - Homo sapiens (human)":
enrichmentPlot(enriched_pathway, label_substring_to_remove = " - Homo sapiens \\(human\\)")
```

## Step6: conduct motif analysis
To perform motif analysis, we first need to extract sequences surrounding the peaks, then acquire the consensus sequences. We can also visualize the top motifs discovered.
```{r}
library(BSgenome.Hsapiens.UCSC.hg38)

seq_around_peak <- getAllPeakSequence(ol$mergedPeaks, 
                                      upstream = 20,
                                      downstream = 20, 
                                      genome = BSgenome.Hsapiens.UCSC.hg38)
head(seq_around_peak, n = 2)
```

We can use the `write2FASTA` function to store the result in a FASTA file. The following code snippet generates Z-scores for short oligos of length 6.
```{r, fig.cap = "Histogram showing Z-score distribution for oligos of length 6"}
freqs <- oligoFrequency(BSgenome.Hsapiens.UCSC.hg38$chr1)
motif_summary <- oligoSummary(seq_around_peak, 
                              oligoLength = 6,
                              MarkovOrder = 3,
                              freqs = freqs,
                              quickMotif = TRUE)
zscore <- sort(motif_summary$zscore)
h <- hist(zscore, 
          breaks = 100, 
          main = "Histogram of Z-score")
text(x = zscore[length(zscore)], 
     y = h$counts[length(h$counts)] + 1, 
     labels = names(zscore[length(zscore)]), 
     adj = 0, 
     srt = 90)
```

We can use `motifStack` to visualize the top discovered motifs.
```{r, fig.cap = "Sequence log of detected motif 1", fig.small = TRUE}
library(motifStack)

pfm <- new("pfm", mat = motif_summary$motifs[[1]],
           name = "sample motif 1")
motifStack(pfm)
```

# Common workflow 2: comparing binding profiles for multiple TFs {#workflow2}
Given two or more peak sets from different TFs, it might be intriguing to examine if the peak profiles are correlated, and if so, how does the peak patterns compare to each other. The workflow presented here demonstrates how to compare the binding profiles of three TFs. The steps are outlined below.

+ Step1: import data
+ Step2: determine if there is significant overlap among peak sets
+ Step3: visualize and compare the binding patterns
  + Heatmap
  + Density plot

## Step1: import data
```{r, warning = FALSE}
tf1 <- toGRanges(system.file("extdata/TAF.broadPeak", package = "ChIPpeakAnno"),
                 format = "broadPeak")
tf2 <- toGRanges(system.file("extdata/Tead4.broadPeak", package = "ChIPpeakAnno"),
                 format = "broadPeak")
tf3 <- toGRanges(system.file("extdata/YY1.broadPeak", package = "ChIPpeakAnno"),
                 format = "broadPeak")
```

## Step2: determine if there is significant overlap among peak sets
To examine the associations across different peak sets, `r Biocpkg("ChIPpeakAnno")` implements both hypergeometric test (`makeVennDiagram`, for details see Section \@ref(hypertest)) and permutation test (`peakPermTest`, for details see Section \@ref(permtest)). For demonstration, here we use hypergeometric test.

```{r, results = "hide", fig.cap = "Venn diagram showing overlapping peaks for three TFs", fig.small = TRUE}
library(BSgenome.Hsapiens.UCSC.hg38)

overlapping_peaks <- findOverlapsOfPeaks(tf1, 
                                         tf2, 
                                         tf3, 
                                         connectedPeaks = "keepAll")
mean_peak_width <- mean(width(unlist(GRangesList(overlapping_peaks[["all.peaks"]]))))

total_binding_sites <- length(BSgenome.Hsapiens.UCSC.hg38[["chr2"]]) * 0.03 / mean_peak_width
venn1 <- makeVennDiagram(overlapping_peaks, 
                         totalTest = total_binding_sites, 
                         connectedPeaks = "keepAll", 
                         fill = c("#CC79A7", "#56B4E9", "#F0E442"),
                         col = c("#D55E00", "#0072B2", "#E69F00"),
                         cat.col = c("#D55E00", "#0072B2", "#E69F00"))
```

For the P-values of each peak pair:
```{r}
venn1[["p.value"]]
```

Given that the P-values are all extremely low, there is a significant overlap between each pair of peak sets.

## Step3: visualize and compare the binding patterns
We can leverage heatmap and density plot to effectively visualize and compare the binding patterns of multiple TFs. For detailed instructions, refer to \@ref(multiexp).
```{r, fig.cap = "Heatmap of coverages for selected TFs", fig.height = 6, message = FALSE}
ol_tfs <- findOverlapsOfPeaks(tf1, tf2, tf3, 
                              connectedPeaks = "keepAll")
gr_ol_tfs <- ol_tfs$peaklist$`tf1///tf2///tf3`

TF_width <- width(gr_ol_tfs)
gr_ol_tfs_center <- reCenterPeaks(gr_ol_tfs, width = 4000)

extdata_path <- system.file("extdata", package = "ChIPpeakAnno")
bigWigs <- dir(extdata_path, "bigWig")
coverage_list <- sapply(file.path(extdata_path, bigWigs), 
                        import, # rtracklayer::import
                        format = "BigWig",
                        which = gr_ol_tfs_center,
                        as = "RleList")

names(coverage_list) <- gsub(".bigWig", "", bigWigs)

sig <- featureAlignedSignal(coverage_list, gr_ol_tfs_center)
# since the bigWig files are only a subset of the original files,
# filter to keep peaks that are with coverage data for all peak sets
keep <- rowSums(sig[[1]]) > 0 & rowSums(sig[[2]]) > 0 & rowSums(sig[[3]]) > 0
sig <- sapply(sig, function(x) x[keep, ], simplify = FALSE)
gr_ol_tfs_center <- gr_ol_tfs_center[keep]

featureAlignedHeatmap(sig, gr_ol_tfs_center,
                      upper.extreme=c(3, 0.5, 4))
```

By default, the rows are arranged according to the total coverage per row from the first sample. Below is an example of how to sort by the third sample ("YY1") in the dataset through tuning the `sortBy` option.
```{r, fig.cap = "Heatmap of coverages for selected TFs sorted by YY1 sample", fig.height = 6, message = FALSE}
featureAlignedHeatmap(sig, gr_ol_tfs_center,
                      upper.extreme=c(3, 0.5, 4),
                      sortBy = "YY1")
```

To generate a density plot, use the `featureAlignedDistribution` function.
```{r, fig.cap = "Distribution of coverage densities for selected TFs", message = FALSE}
featureAlignedDistribution(sig, gr_ol_tfs_center, 
                           type="l")
```

As observed, the binding of "YY1" is significantly stronger, while the binding of "Tead" is considerably weaker.

# Have questions?
For questions related to usage, please post your queries on the [Bioconductor Support Site](https://support.bioconductor.org/new/post/). If you wish to report a bug or request a new feature, kindly raise an issue on the [ChIPpeakAnno](https://github.com/jianhong/ChIPpeakAnno) GitHub repository.

# Selected Q & A
## How to import peaks?
`r Biocpkg("ChIPpeakAnno")` provides a helper function, `toGRanges`, specifically designed for importing files. Users also have the option to use other tools, such as `rtracklayer::import`.

## How to properly annotate peaks from ChIP-seq data?
`r Biocpkg("ChIPpeakAnno")` offers a variety of options for annotating peaks, which can be specified with the `output` argument in the `annotatePeakInBatch` function. 

+ If you are interested in the nearest features surrounding the peaks, set `output = "nearestLocation"`, `output = "shortestDistance"`, or `output = "overlapping"`. This is a peak-centric method, for details see Section \@ref(peakcentric).
+ If you are interested in the peaks binding to the promoter regions, you can set `output = "upstream"`. For more flexibility, you can adjust the `bindingRegion` option. This is a feature-centric method, for details see Section \@ref(featurecentric)

## Should I use `annotatePeakInBatch` or `annoPeaks`?
You should use `annotatePeakInBatch` as it serves as the primary wrapper function that internally calls `annoPeaks`. Historically, `annotatePeakInBatch` was primarily composed of peak-centric methods. Over time, feature-centric methods, initially implemented in the `annoPeaks` function, were integrated into `annotatePeakInBatch`.

## How to prepare annotation data for `annotatePeakInBatch`?
Ensure that the annotation data is in _GRanges_ format for `annotatePeakInBatch` to work. You can convert _TxDb_, _EnsDb_, or even _GFF_ and _BED_, etc. into _GRanges_ using the `toGRanges` function. Additionally, you can leverage the `getAnnotation` function to fetch annotation data from _BioMart_. If needed, you can even create a personalized annotation file. For detailed instructions, see Section \@ref(prepanno).

## Can I output either the nearest or overlapping features?
This question pertains to this [post](https://support.bioconductor.org/p/9154859/#9154869).

When you set `output = "both"`, both the "nearest" and "overlapping" features will be output. If your preference is to assign only one type of feature to each peak (either "nearest" or "overlapping", with a preference for "overlapping" in cases where the "nearest" feature is not "overlapping"), you can use the following strategy: first, annotate peaks with overlapping features; second, annotate peaks lacking overlapping features with the nearest features; last, concatenate the two sets of results. The example codes are provided below:
```{r, warning = FALSE}
library(ensembldb)
library(EnsDb.Hsapiens.v75)
data(myPeakList)
annoData <- annoGR(EnsDb.Hsapiens.v75)

# Step1: annotate peaks to the overlapping features, if "select = 'all'", multiple features can be assigned to a single peak.
anno_overlapping <- annotatePeakInBatch(myPeakList, 
                                        AnnotationData = annoData, 
                                        output = "overlapping", 
                                        select = "first")
anno_overlapping_non_na <- anno_overlapping[!is.na(anno_overlapping$feature)]

# Step2: annotate peaks that are without overlapping features to nearest features
myPeakList_non_overlapping <- myPeakList[!(names(myPeakList) %in% anno_overlapping_non_na$peak)]  
anno_nearest <- annotatePeakInBatch(myPeakList_non_overlapping,
                                    AnnotationData = annoData, 
                                    output = "nearestLocation", 
                                    select = "first")

# Step3: concatenate the two
anno_final <- c(anno_overlapping_non_na, anno_nearest)
```

The provided code allocates either the "overlapping" or "nearest" feature to each peak. If the "overlapping" feature is not the "nearest", only the "overlapping" one will be reported.

## Why is the sum of peak numbers in the Venn diagram NOT equal to the sum of the peaks in the original peak lists?
This question is a common scenario in calculating the intersection of peaks. Peaks, being a range of continuous points rather than single points, present a challenge in determining the overlapping regions. Consider the intersection of two lists of range objects: list A (1~3, 4~5, 7~9) and list B (2~8), the number of overlapping ranges depends on the reference chosen, if we use list B as the reference, the output would be one range; however, if we use list A as the reference, the output would be three ranges.

## How does `findOverlapsOfPeaks` count the number of overlapping peaks?
This question is in response to this [post](https://support.bioconductor.org/p/133486/#133603).

When counting the number of overlapping peaks using `findOverlapsOfPeaks`, the `connectedPeaks` option comes into play. If multiple peaks involve in any group of connected or overlapping peaks in any input peak list, setting  `connectedPeaks = "merge"` will increment the overlapping counts by one. On the other hand, setting `connectedPeaks = "min"` will add the minimal number of involved peaks in each group of connected or overlapped peaks to the overlapping counts. If `connectedPeaks = "keepAll"`, it will add the number of involved peaks for each peak list to the corresponding overlapping counts. In addition, it will output counts as if `connectedPeaks` was set to "min". 

For examples, if 5 peaks in group1 overlap with 2 peaks in group 2:

+ Setting `connectedPeaks = "merge"` will add 1 to the overlapping counts
+ Setting `connectedPeaks = "min"` will add 2 to the overlapping counts
+ Setting `connectedPeaks = "keepAll"` will add 5 peaks to "count.group1", 2 to "count.group2", and 2 to the overlapping counts

## Is there a way to show the number of peaks in original peak lists?
You have the option to configure `connectedPeaks = "keepAll"` in both the `findOverlapsOfPeaks` and `makeVennDiagram` functions.

## How to extract the original peak IDs of the overlapping peaks?
In the output of `findOverlapsOfPeaks`, each element in the peak list contains a metadata column names _peakNames_, which is a CharacterList. This CharacterList is a list of the contributing peak IDs with prefixes, e.g. "peaks1_peakname1", "peaksi_peaknamej", where "i" denotes the peak group i and "j" denotes the specific peak j within that group. Users can retrieve the original peak name by splitting these strings. Here are the sample codes:
```{r, warning = FALSE}
library(ChIPpeakAnno)
library(reshape2)

# Step1: read in two peak files
bed <- system.file("extdata", 
                   "MACS_output.bed",
                   package = "ChIPpeakAnno")
gff <- system.file("extdata", 
                   "GFF_peaks.gff", 
                   package = "ChIPpeakAnno")
gr1 <- toGRanges(bed, format = "BED", 
                 header = FALSE)
gr2 <- toGRanges(gff, format = "GFF", 
                 header = FALSE, skip = 3)
names(gr2) <- seq(length(gr2)) # add names to gr2 for Step4

# Step2: find overlapping peaks
ol <- findOverlapsOfPeaks(gr1, gr2)
peakNames <- ol$peaklist[['gr1///gr2']]$peakNames

# Step3: extract original peak names
peakNames <- melt(peakNames, 
                  value.name = "merged_peak_id") # reshape df
head(peakNames, n = 2)

peakNames <- cbind(peakNames[, 1], 
                   do.call(rbind, 
                           strsplit(as.character(peakNames[, 3]), "__")))

colnames(peakNames) <- c("merged_peak_id", "group", "peakName")
head(peakNames, n = 2)

# Step4: split by peak group
gr1_subset <- gr1[peakNames[peakNames[, "group"] %in% "gr1", "peakName"]]
gr2_subset <- gr2[peakNames[peakNames[, "group"] %in% "gr2", "peakName"]]
head(gr1_subset, n = 2)
head(gr2_subset, n = 2)
```

Alternatively, the following snippet should also work.
```{r}
gr1_renamed <- ol$all.peaks$gr1
gr2_renamed <- ol$all.peaks$gr2
head(gr1_renamed, n = 2)
head(gr2_renamed, n = 2)

peakNames <- melt(ol$peaklist[['gr1///gr2']]$peakNames, 
                  value.name = "merged_peak_id")
gr1_subset <- gr1_renamed[peakNames[grepl("^gr1", peakNames[, 3]), 3]]
gr2_subset <- gr2_renamed[peakNames[grepl("^gr2", peakNames[, 3]), 3]]
head(gr1_subset, n = 2)
head(gr2_subset, n = 2)
```

## How to select the proper number for `totalTest` when using `makeVennDiagram`?
During the evaluation of the association between two sets of peak data using the hypergeometric distribution, it is essential to determine the total number of potential binding sites, the `totalTest` parameter in the `makeVennDiagram`. This parameter should have a value larger than the largest number of peaks in the peak list. The choice of `totalTest` influences teh stringency of the test, with smaller values yielding more stringent tests and larger P-values. The computation time for calculating P-values remains independent of the `totalTest` value. For practical guidance on selecting an appropriate `totalTest` value, please refer to this [post](https://stat.ethz.ch/pipermail/bioconductor/2010-November/036540.html).

# How to cite ChIPpeakAnno
If you use `r Biocpkg("ChIPpeakAnno")` in your work, please cite it as follows:
```{r citation, echo = FALSE}
citation(package = "ChIPpeakAnno")
```

# Session info
Here is the output of `sessionInfo()` on the system on which this document was compiled running pandoc `r rmarkdown::pandoc_version()`:
```{r sessionInfo, echo = FALSE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/addGeneIDs.R
\name{addGeneIDs}
\alias{addGeneIDs}
\title{Add common IDs to annotated peaks such as gene symbol, entrez ID, 
ensemble gene id and refseq id.}
\usage{
addGeneIDs(
  annotatedPeak,
  orgAnn,
  IDs2Add = c("symbol"),
  feature_id_type = "ensembl_gene_id",
  silence = TRUE,
  mart
)
}
\arguments{
\item{annotatedPeak}{GRanges or a vector of feature IDs.}

\item{orgAnn}{organism annotation dataset such as org.Hs.eg.db.}

\item{IDs2Add}{a vector of annotation identifiers to be added}

\item{feature_id_type}{type of ID to be annotated, default is 
ensembl_gene_id}

\item{silence}{TRUE or FALSE. If TRUE, will not show unmapped entrez id
for feature ids.}

\item{mart}{mart object, see \link[biomaRt:useMart]{useMart} of biomaRt
package for details}
}
\value{
GRanges if the input is a GRanges or dataframe if input is a vector.
}
\description{
Add common IDs to annotated peaks such as gene symbol, 
entrez ID, ensemble gene id and refseq id leveraging organism annotation 
dataset. For example, org.Hs.eg.db is the dataset from orgs.Hs.eg.db 
package for human, while org.Mm.eg.db is the dataset from the org.Mm.eg.db
package for mouse.
}
\details{
One of orgAnn and mart should be assigned. 
\itemize{    
  \item If orgAnn is given, parameter feature_id_type should be 
  ensemble_gene_id, entrez_id, gene_symbol, gene_alias or refseq_id.
  And parameter IDs2Add can be set to any combination of identifiers 
  such as "accnum", "ensembl", "ensemblprot", "ensembltrans", "entrez_id",
  "enzyme", "genename", "pfam", "pmid", "prosite", "refseq", "symbol", 
  "unigene" and "uniprot". Some IDs are unique to an organism, 
  such as "omim" for org.Hs.eg.db and "mgi" for org.Mm.eg.db.
  
  Here is the definition of different IDs : 
    \itemize{
      \item accnum: GenBank accession numbers
      \item ensembl: Ensembl gene accession numbers
      \item ensemblprot: Ensembl protein accession numbers
      \item ensembltrans: Ensembl transcript accession numbers
      \item entrez_id: entrez gene identifiers
      \item enzyme: EC numbers
      \item genename: gene name
      \item pfam: Pfam identifiers
      \item pmid: PubMed identifiers
      \item prosite: PROSITE identifiers
      \item refseq: RefSeq identifiers
      \item symbol: gene abbreviations
      \item unigene: UniGene cluster identifiers
      \item uniprot: Uniprot accession numbers
      \item omim: OMIM(Mendelian Inheritance in Man) identifiers
      \item mgi: Jackson Laboratory MGI gene accession numbers
    }
  
  \item If mart is used instead of orgAnn, for valid parameter 
  feature_id_type and IDs2Add parameters, please refer to 
  \link[biomaRt:getBM]{getBM} in bioMart package. 
  Parameter feature_id_type should be one valid filter name listed by 
  \link[biomaRt:listFilters]{listFilters(mart)} such as ensemble_gene_id.
  And parameter IDs2Add should be one or more valid attributes name listed 
  by \link[biomaRt:listAttributes]{listAttributes(mart)} such as 
  external_gene_id, entrezgene, wikigene_name, or mirbase_transcript_name.
  
}
}
\examples{
data(annotatedPeak)
library(org.Hs.eg.db)
addGeneIDs(annotatedPeak[1:6,],orgAnn="org.Hs.eg.db",
           IDs2Add=c("symbol","omim"))
##addGeneIDs(annotatedPeak$feature[1:6],orgAnn="org.Hs.eg.db",
##           IDs2Add=c("symbol","genename"))
if(interactive()){
  mart <- useMart("ENSEMBL_MART_ENSEMBL",host="www.ensembl.org",
                  dataset="hsapiens_gene_ensembl")
  ##mart <- useMart(biomart="ensembl",dataset="hsapiens_gene_ensembl")
  addGeneIDs(annotatedPeak[1:6,], mart=mart,
             IDs2Add=c("hgnc_symbol","entrezgene"))
}
}
\references{
http://www.bioconductor.org/packages/release/data/annotation/
}
\seealso{
\link[biomaRt:getBM]{getBM}, AnnotationDb
}
\author{
Jianhong Ou, Lihua Julie Zhu
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bindist.R
\docType{class}
\name{bindist-class}
\alias{bindist-class}
\alias{bindist}
\alias{bindist-method}
\alias{$,bindist-method}
\alias{$<-,bindist-method}
\title{Class \code{"bindist"}}
\description{
An object of class \code{"bindist"} represents the relevant fixed-width
range of binding site from the feature and number of possible binding site
in each range.
}
\section{Objects from the Class}{
 Objects can be created by calls of the form
\code{new("bindist", counts="integer", mids="integer",
halfBinSize="integer", bindingType="character", featureType="character")}.
}

\seealso{
\link{preparePool}, \link{peakPermTest}
}
\keyword{classes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/peaksNearBDP.R
\name{peaksNearBDP}
\alias{peaksNearBDP}
\title{obtain the peaks near bi-directional promoters}
\usage{
peaksNearBDP(myPeakList, AnnotationData, MaxDistance = 5000L, ...)
}
\arguments{
\item{myPeakList}{\link[GenomicRanges:GRanges-class]{GRanges}: See example
below}

\item{AnnotationData}{annotation data obtained from getAnnotation or
customized annotation of class \link[GenomicRanges:GRanges-class]{GRanges}
containing additional variable: strand (1 or + for plus strand and -1 or -
for minus strand). For example, data(TSS.human.NCBI36),
data(TSS.mouse.NCBIM37), data(TSS.rat.RGSC3.4) and data(TSS.zebrafish.Zv8).}

\item{MaxDistance}{Specify the maximum gap allowed between the peak and
nearest gene}

\item{...}{Not used}
}
\value{
A list of 4 \item{list("peaksWithBDP")}{annotated Peaks containing
bi-directional promoters.

GRangesList with slot start holding the start position of the peak, slot end
holding the end position of the peak, slot space holding the chromosome
location where the peak is located, slot rownames holding the id of the
peak.  In addition, the following variables are included.

feature: id of the feature such as ensembl gene ID

insideFeature: upstream: peak resides upstream of the feature; downstream:
peak resides downstream of the feature; inside: peak resides inside the
feature; overlapStart: peak overlaps with the start of the feature;
overlapEnd: peak overlaps with the end of the feature; includeFeature: peak
include the feature entirely.

distancetoFeature: distance to the nearest feature such as transcription
start site.  By default, the distance is calculated as the distance between
the start of the binding site and the TSS that is the gene start for genes
located on the forward strand and the gene end for genes located on the
reverse strand. The user can specify the location of peak and location of
feature for calculating this

feature_range: start and end position of the feature such as gene

feature_strand: 1 or + for positive strand and -1 or - for negative strand
where the feature is located } \item{list("percentPeaksWithBDP")}{The
percent of input peaks containing bi-directional promoters}
\item{list("n.peaks")}{The total number of input peaks}
\item{list("n.peaksWithBDP")}{The # of input peaks containing bi-directional
promoters}
}
\description{
Obtain the peaks near bi-directional promoters. Also output percent of peaks
near bi-directional promoters.
}
\examples{


if (interactive() || Sys.getenv("USER")=="jou")
{
    library(GenomeInfoDb)
    data(myPeakList)
    data(TSS.human.NCBI36)
    seqlevelsStyle(TSS.human.NCBI36) <- seqlevelsStyle(myPeakList)
    annotatedBDP = peaksNearBDP(myPeakList[1:6,], 
                                AnnotationData=TSS.human.NCBI36,
                                MaxDistance=5000,
                                PeakLocForDistance =  "middle", 
                                FeatureLocForDistance = "TSS")
    c(annotatedBDP$percentPeaksWithBDP, annotatedBDP$n.peaks, 
      annotatedBDP$n.peaksWithBDP)
}

}
\references{
Zhu L.J. et al. (2010) ChIPpeakAnno: a Bioconductor package to
annotate ChIP-seq and ChIP-chip data. BMC Bioinformatics 2010,
11:237doi:10.1186/1471-2105-11-237
}
\seealso{
annotatePeakInBatch, findOverlappingPeaks, makeVennDiagram
}
\author{
Lihua Julie Zhu, Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HOT.spots.R
\docType{data}
\name{HOT.spots}
\alias{HOT.spots}
\title{High Occupancy of Transcription Related Factors regions}
\format{
An object of GRangesList
}
\source{
http://metatracks.encodenets.gersteinlab.org/
}
\usage{
HOT.spots
}
\description{
High Occupancy of Transcription Related Factors regions of human (hg19)
}
\details{
How to generated the data:

temp <- tempfile()

url <- "http://metatracks.encodenets.gersteinlab.org"

download.file(file.path(url, "HOT_All_merged.tar.gz"), temp)

temp2 <- tempfile()

download.file(file.path(url, "HOT_intergenic_All_merged.tar.gz"), temp2)

untar(temp, exdir=dirname(temp))

untar(temp2, exdir=dirname(temp))

f <- dir(dirname(temp), "bed$")

HOT.spots <- sapply(file.path(dirname(temp), f), toGRanges, format="BED")

names(HOT.spots) <- gsub("_merged.bed", "", f)

HOT.spots <- sapply(HOT.spots, unname)

HOT.spots <- GRangesList(HOT.spots)

save(list="HOT.spots",

file="data/HOT.spots.rda",

compress="xz", compression_level=9)
}
\examples{

 data(HOT.spots)
 elementNROWS(HOT.spots)

}
\references{
Yip KY, Cheng C, Bhardwaj N, Brown JB, Leng J, Kundaje A,
Rozowsky J, Birney E, Bickel P, Snyder M, Gerstein M. Classification of
human genomic regions based on experimentally determined binding sites of
more than 100 transcription-related factors. Genome Biol. 2012 Sep
26;13(9):R48.  doi: 10.1186/gb-2012-13-9-r48. PubMed PMID: 22950945; PubMed
Central PMCID: PMC3491392.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mergePlusMinusPeaks.R
\name{mergePlusMinusPeaks}
\alias{mergePlusMinusPeaks}
\title{Merge peaks from plus strand and minus strand}
\usage{
mergePlusMinusPeaks(
  peaks.file,
  columns = c("name", "chromosome", "start", "end", "strand", "count", "count", "count",
    "count"),
  sep = "\\t",
  header = TRUE,
  distance.threshold = 100,
  plus.strand.start.gt.minus.strand.end = TRUE,
  output.bedfile
)
}
\arguments{
\item{peaks.file}{Specify the peak file. The peak file should contain peaks
from both plus and minus strand}

\item{columns}{Specify the column names in the peak file}

\item{sep}{Specify column delimiter, default tab-delimited}

\item{header}{Specify whether the file has a header row, default TRUE}

\item{distance.threshold}{Specify the maximum gap allowed between the plus
stranded and the nagative stranded peak}

\item{plus.strand.start.gt.minus.strand.end}{Specify whether plus strand
peak start greater than the paired negative strand peak end. Default to TRUE}

\item{output.bedfile}{Specify the bed output file name}
}
\value{
output the merged peaks in bed file and a data frame of the bed
format
}
\description{
Merge peaks from plus strand and minus strand within certain distance apart,
and output merged peaks as bed format.
}
\examples{


if (interactive())
{
    data(myPeakList)
    data(TSS.human.NCBI36)
    library(matrixStats)
        peaks <- system.file("extdata", "guide-seq-peaks.txt", 
                              package = "ChIPpeakAnno")
        merged.bed <- mergePlusMinusPeaks(peaks.file = peaks, 
                                          columns=c("name", "chromosome", 
                                                    "start", "end", "strand", 
                                                    "count", "count"), 
                                          sep = "\t", header = TRUE,  
                                          distance.threshold = 100,  
                                plus.strand.start.gt.minus.strand.end = TRUE, 
                                          output.bedfile = "T2test100bp.bed")
}

}
\references{
Zhu L.J. et al. (2010) ChIPpeakAnno: a Bioconductor package to
annotate ChIP-seq and ChIP-chip data. BMC Bioinformatics 2010,
11:237doi:10.1186/1471-2105-11-237
}
\seealso{
annotatePeakInBatch, findOverlappingPeaks, makeVennDiagram
}
\author{
Lihua Julie Zhu
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/xget.R
\name{xget}
\alias{xget}
\title{Return the value from a Bimap objects}
\usage{
xget(
  x,
  envir,
  mode,
  ifnotfound = NA,
  inherits,
  output = c("all", "first", "last")
)
}
\arguments{
\item{x, envir, mode, ifnotfound, inherits}{see
\link[AnnotationDbi:Bimap-envirAPI]{mget}}

\item{output}{return the all or first item for each query}
}
\value{
a character vector
}
\description{
Search by name for an Bimap object.
}
\examples{

    library(org.Hs.eg.db)
    xget(as.character(1:10), org.Hs.egSYMBOL)

}
\seealso{
See Also as \code{\link[base:get]{mget}},
\code{\link[AnnotationDbi:Bimap-envirAPI]{mget}}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/addAncestors.R
\name{addAncestors}
\alias{addAncestors}
\title{Add GO IDs of the ancestors for a given vector of GO ids}
\usage{
addAncestors(go.ids, ontology = c("bp", "cc", "mf"))
}
\arguments{
\item{go.ids}{A matrix with 4 columns: first column is GO IDs and 4th 
column is entrez IDs.}

\item{ontology}{bp for biological process, cc for cellular component and 
mf for molecular function.}
}
\value{
A vector of GO IDs containing the input GO IDs with the GO IDs of 
their ancestors added.
}
\description{
Add GO IDs of the ancestors for a given vector of GO IDs 
leveraging GO.db
}
\examples{
go.ids = cbind(c("GO:0008150", "GO:0005576", "GO:0003674"),
               c("ND", "IDA", "ND"), 
               c("BP", "BP", "BP"), 
               c("1", "1", "1"))
library(GO.db)
addAncestors(go.ids, ontology="bp")
}
\author{
Lihua Julie Zhu
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/estLibSize.R
\name{estLibSize}
\alias{estLibSize}
\title{estimate the library size}
\usage{
estLibSize(bamfiles, index = bamfiles, ...)
}
\arguments{
\item{bamfiles}{The file names of the 'BAM' ('SAM' for asBam) files to be
processed.}

\item{index}{The names of the index file of the 'BAM' file being processed;
this is given without the '.bai' extension.}

\item{\dots}{Not used.}
}
\value{
numberic vector
}
\description{
estimate the library size of bam files
}
\examples{

    if(interactive() || Sys.getenv("USER")=="jou"){
        path <- system.file("extdata", "reads", package="MMDiffBamSubset")
        if(file.exists(path)){
            WT.AB2 <- file.path(path, "WT_2.bam")
            Null.AB2 <- file.path(path, "Null_2.bam")
            Resc.AB2 <- file.path(path, "Resc_2.bam")
            estLibSize(c(WT.AB2, Null.AB2, Resc.AB2))
        }
    }

}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cntOverlaps.R
\name{cntOverlaps}
\alias{cntOverlaps}
\title{count overlaps}
\usage{
cntOverlaps(A, B, maxgap = 0L, ...)
}
\arguments{
\item{A, B}{A GRanges object.}

\item{maxgap}{A single integer >= 0.}

\item{...}{parameters passed to \link[regioneR]{numOverlaps}#'}
}
\description{
Count overlaps with max gap.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tileCount.R
\name{tileCount}
\alias{tileCount}
\title{Perform overlap queries between reads and genome by windows}
\usage{
tileCount(
  reads,
  genome,
  windowSize = 1e+06,
  step = 1e+06,
  keepPartialWindow = FALSE,
  mode = countByOverlaps,
  ...
)
}
\arguments{
\item{reads}{A \link[GenomicRanges:GRanges-class]{GRanges},
\link[GenomicRanges:GRangesList-class]{GRangesList}
\link[GenomicAlignments:GAlignments-class]{GAlignments},
\link[GenomicAlignments:GAlignmentsList-class]{GAlignmentsList},
\link[GenomicAlignments:GAlignmentPairs-class]{GAlignmentPairs} or
\link[Rsamtools:BamFile-class]{BamFileList} object that represents the data
to be counted by
\code{\link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps}}.}

\item{genome}{The object from/on which to get/set the sequence information.}

\item{windowSize}{Size of windows}

\item{step}{Step of windows}

\item{keepPartialWindow}{Keep last partial window or not.}

\item{mode}{mode can be one of the pre-defined count methods. see
\link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps}.
default is countByOverlaps, alia of countOverlaps(features, reads,
ignore.strand=ignore.strand)}

\item{...}{Additional arguments passed to
\code{\link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps}}.}
}
\value{
A
\link[SummarizedExperiment:RangedSummarizedExperiment-class]{RangedSummarizedExperiment}
object. The assays slot holds the counts, rowRanges holds the annotation
from genome.
}
\description{
tileCount extends
\link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps} by
providing fixed window size and step to split whole genome into windows and
then do queries. It will return counts in each windows.
}
\examples{

    fls <- list.files(system.file("extdata", package="GenomicAlignments"),
                  recursive=TRUE, pattern="*bam$", full=TRUE)
    names(fls) <- basename(fls)
    genes <- GRanges(seqlengths = c(chr2L=7000, chr2R=10000))
    se <- tileCount(fls, genes, windowSize=1000, step=500)

}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/featureAlignedExtendSignal.R
\name{featureAlignedExtendSignal}
\alias{featureAlignedExtendSignal}
\title{extract signals in given ranges from bam files}
\usage{
featureAlignedExtendSignal(
  bamfiles,
  index = bamfiles,
  feature.gr,
  upstream,
  downstream,
  n.tile = 100,
  fragmentLength,
  librarySize,
  pe = c("auto", "PE", "SE"),
  adjustFragmentLength,
  gal,
  ...
)
}
\arguments{
\item{bamfiles}{The file names of the 'BAM' ('SAM' for asBam) files to be
processed.}

\item{index}{The names of the index file of the 'BAM' file being processed;
this is given without the '.bai' extension.}

\item{feature.gr}{An object of \link[GenomicRanges:GRanges-class]{GRanges}
with identical width.}

\item{upstream, downstream}{upstream or dwonstream from the feature.gr.}

\item{n.tile}{The number of tiles to generate for each element of
feature.gr, default is 100}

\item{fragmentLength}{Estimated fragment length.}

\item{librarySize}{Estimated library size.}

\item{pe}{Pair-end or not. Default auto.}

\item{adjustFragmentLength}{A numberic vector with length 1. Adjust the
fragments/reads length to.}

\item{gal}{A GAlignmentsList object or a list of GAlignmentPairs. If
bamfiles is missing, gal is required.}

\item{\dots}{Not used.}
}
\value{
A list of matrix. In each matrix, each row record the signals for
corresponding feature.
}
\description{
extract signals in the given feature ranges from bam files (DNAseq only).
The reads will be extended to estimated fragement length.
}
\examples{

 if(interactive() || Sys.getenv("USER")=="jou"){
    path <- system.file("extdata", package="MMDiffBamSubset")
    if(file.exists(path)){
        WT.AB2 <- file.path(path, "reads", "WT_2.bam")
        Null.AB2 <- file.path(path, "reads", "Null_2.bam")
        Resc.AB2 <- file.path(path, "reads", "Resc_2.bam")
        peaks <- file.path(path, "peaks", "WT_2_Macs_peaks.xls")
        estLibSize(c(WT.AB2, Null.AB2, Resc.AB2))
        feature.gr <- toGRanges(peaks, format="MACS")
        feature.gr <- feature.gr[seqnames(feature.gr)=="chr1" & 
                             start(feature.gr)>3000000 & 
                             end(feature.gr)<75000000]
        sig <- featureAlignedExtendSignal(c(WT.AB2, Null.AB2, Resc.AB2), 
                               feature.gr=reCenterPeaks(feature.gr, width=1), 
                               upstream = 505,
                               downstream = 505,
                               n.tile=101, 
                               fragmentLength=250,
                               librarySize=1e9)
        featureAlignedHeatmap(sig, reCenterPeaks(feature.gr, width=1010), 
                          zeroAt=.5, n.tile=101)
    }
 }

}
\seealso{
See Also as \code{\link{featureAlignedSignal}},
\code{\link{estLibSize}}, \code{\link{estFragmentLength}}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TSS.human.GRCh38.R
\docType{data}
\name{TSS.human.GRCh38}
\alias{TSS.human.GRCh38}
\title{TSS annotation for human sapiens (GRCh38) obtained from biomaRt}
\format{
A 'GRanges' [package "GenomicRanges"] object with ensembl id as
names.
}
\usage{
TSS.human.GRCh38
}
\description{
TSS annotation for human sapiens (GRCh38) obtained from biomaRt
}
\details{
used in the examples Annotation data obtained by:

mart = useMart(biomart = "ensembl", dataset = "hsapiens_gene_ensembl")

getAnnotation(mart, featureType = "TSS")
}
\examples{

data(TSS.human.GRCh38)
slotNames(TSS.human.GRCh38)

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getVennCounts.R
\name{getVennCounts}
\alias{getVennCounts}
\title{Obtain Venn Counts for Venn Diagram, internal function for makeVennDigram}
\usage{
getVennCounts(
  ...,
  maxgap = -1L,
  minoverlap = 0L,
  by = c("region", "feature", "base"),
  ignore.strand = TRUE,
  connectedPeaks = c("min", "merge", "keepAll")
)
}
\arguments{
\item{\dots}{Objects of \link[GenomicRanges:GRanges-class]{GRanges}. See
example below.}

\item{maxgap, minoverlap}{Used in the internal call to \code{findOverlaps()}
to detect overlaps. See
\code{?\link[IRanges:findOverlaps-methods]{findOverlaps}} in the
\pkg{IRanges} package for a description of these arguments.}

\item{by}{region, feature or base, default region. feature means using
feature field in the GRanges for calculating overlap, region means using
chromosome range for calculating overlap, and base means using calculating
overlap in nucleotide level.}

\item{ignore.strand}{When set to TRUE, the strand information is ignored in
the overlap calculations.}

\item{connectedPeaks}{If multiple peaks involved in overlapping in several
groups, set it to "merge" will count it as only 1, while set it to "min"
will count it as the minimal involved peaks in any concered groups}
}
\value{
\item{vennCounts}{vennCounts objects containing counts for Venn
Diagram generation, see details in limma package vennCounts}
}
\description{
Obtain Venn Counts for peak ranges using chromosome ranges or feature field,
internal function for makeVennDigram
}
\examples{

if(interactive() || Sys.getenv("USER")=="jou"){
peaks1 = GRanges(seqnames=c("1", "2", "3"), 
                 IRanges(start = c(967654, 2010897, 2496704), 
                            end = c(967754, 2010997, 2496804), 
                            names = c("Site1", "Site2", "Site3")),  
                   strand=as.integer(1), 
                   feature=c("a","b", "c"))
  peaks2 = 
      GRanges(seqnames= c("1", "2", "3", "1", "2"), 
                    IRanges(start=c(967659, 2010898, 2496700, 3075866, 3123260), 
                         end=c(967869, 2011108, 2496920, 3076166, 3123470), 
                         names = c("t1", "t2", "t3", "t4", "t5")), 
                    strand = c(1L, 1L, -1L,-1L,1L), 
                    feature=c("a","c","d","e", "a"))
    getVennCounts(peaks1,peaks2)
    getVennCounts(peaks1,peaks2, by="feature")
    getVennCounts(peaks1, peaks2, by="base")
}

}
\seealso{
\link{makeVennDiagram}, \link{findOverlappingPeaks}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getAllPeakSequence.R
\name{getAllPeakSequence}
\alias{getAllPeakSequence}
\title{Obtain genomic sequences around the peaks}
\usage{
getAllPeakSequence(
  myPeakList,
  upstream = 200L,
  downstream = upstream,
  genome,
  AnnotationData
)
}
\arguments{
\item{myPeakList}{An object of \link[GenomicRanges:GRanges-class]{GRanges}:
See example below}

\item{upstream}{upstream offset from the peak start, e.g., 200}

\item{downstream}{downstream offset from the peak end, e.g., 200}

\item{genome}{BSgenome object or mart object. Please refer to
available.genomes in BSgenome package and useMart in bioMaRt package for
details}

\item{AnnotationData}{GRanges object with annotation information.}
}
\value{
\link[GenomicRanges:GRanges-class]{GRanges} with slot start holding
the start position of the peak, slot end holding the end position of the
peak, slot rownames holding the id of the peak and slot seqnames holding the
chromosome where the peak is located. In addition, the following variables
are included: \item{upstream}{upstream offset from the peak start}
\item{downstream}{downstream offset from the peak end} \item{sequence}{the
sequence obtained}
}
\description{
Obtain genomic sequences around the peaks leveraging the BSgenome and
biomaRt package
}
\examples{

#### use Annotation data from BSgenome
peaks <- GRanges(seqnames=c("NC_008253", "NC_010468"),
                 IRanges(start=c(100, 500), end=c(300, 600), 
                         names=c("peak1", "peak2")))
library(BSgenome.Ecoli.NCBI.20080805)
seq <- getAllPeakSequence(peaks, upstream=20, downstream=20, genome=Ecoli)
write2FASTA(seq, file="test.fa")

}
\references{
Durinck S. et al. (2005) BioMart and Bioconductor: a powerful
link between biological biomarts and microarray data analysis.
Bioinformatics, 21, 3439-3440.
}
\author{
Lihua Julie Zhu, Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/condenseMatrixByColnames.R
\name{condenseMatrixByColnames}
\alias{condenseMatrixByColnames}
\title{Condense matrix by colnames}
\usage{
condenseMatrixByColnames(mx, iname, sep = ";", cnt = FALSE)
}
\arguments{
\item{mx}{a matrix to be condensed}

\item{iname}{the name of the column to be condensed}

\item{sep}{separator for condensed values,default ;}

\item{cnt}{TRUE/FALSE specifying whether adding count column or not?}
}
\value{
dataframe of condensed matrix
}
\description{
Condense matrix by colnames
}
\examples{

a<-matrix(c(rep(rep(1:5,2),2),rep(1:10,2)),ncol=4)
colnames(a)<-c("con.1","con.2","index.1","index.2")
condenseMatrixByColnames(a,"con.1")
condenseMatrixByColnames(a,2)

}
\author{
Jianhong Ou, Lihua Julie Zhu
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/findEnhancers.R
\name{findEnhancers}
\alias{findEnhancers}
\title{Find possible enhancers depend on DNA interaction data}
\usage{
findEnhancers(
  peaks,
  annoData,
  DNAinteractiveData,
  bindingType = c("nearestBiDirectionalPromoters", "startSite", "endSite"),
  bindingRegion = c(-5000, 5000),
  ignore.peak.strand = TRUE,
  ...
)
}
\arguments{
\item{peaks}{peak list, \link[GenomicRanges:GRanges-class]{GRanges} object}

\item{annoData}{annotation data, \link[GenomicRanges:GRanges-class]{GRanges}
object}

\item{DNAinteractiveData}{DNA interaction data,
\link[GenomicRanges:GRanges-class]{GRanges} object with interaction blocks
informations, \link[InteractionSet:InteractionSet]{GInteractions} object, 
or BEDPE file which could be imported by 
\link[trackViewer:importGInteractions]{importGInteractions} or 
BiocIO::\link[BiocIO:export]{import} or assembly in following list:
hg38, hg19, mm10, danRer10, danRer11.}

\item{bindingType}{Specifying the criteria to associate peaks with
annotation. Here is how to use it together with the parameter bindingRegion.
The annotation will be shift to a new position depend on the DNA interaction
region.  \itemize{ \item To obtain peaks within 5kb upstream and up to 3kb
downstream of shift TSS within the gene body, set bindingType = "startSite"
and bindingRegion = c(-5000, 3000) \item To obtain peaks up to 5kb upstream
within the gene body and 3kb downstream of shift gene/Exon End, set
bindingType = "endSite" and bindingRegion = c(-5000, 3000) \item To obtain
peaks with nearest bi-directional enhancer regions within 5kb upstream and
3kb downstream of shift TSS, set bindingType =
"nearestBiDirectionalPromoters" and bindingRegion = c(-5000, 3000) }
\describe{ \item{startSite}{start position of the feature (strand is
considered)} \item{endSite}{end position of the feature (strand is
considered)} \item{nearestBiDirectionalPromoters}{nearest enhancer regions
from both direction of the peaks (strand is considered). It will report
bidirectional enhancer regions if there are enhancer regions in both
directions in the given region (defined by bindingRegion). Otherwise, it
will report the closest enhancer regions in one direction.} }}

\item{bindingRegion}{Annotation range used together with bindingType, which
is a vector with two integer values, default to c (-5000, 5000). The first
one must be no bigger than 0. And the sec ond one must be no less than 1.
For details, see bindingType.}

\item{ignore.peak.strand}{ignore the peaks strand or not.}

\item{...}{Not used.}
}
\value{
Output is a GRanges object of the annotated peaks.
}
\description{
Find possible enhancers by data from chromosome conformation capture
techniques such as 3C, 5C or HiC.
}
\examples{

  bed <- system.file("extdata", 
                     "wgEncodeUmassDekker5CGm12878PkV2.bed.gz",
                     package="ChIPpeakAnno")
  DNAinteractiveData <- toGRanges(gzfile(bed))
  library(EnsDb.Hsapiens.v75)
  annoData <- toGRanges(EnsDb.Hsapiens.v75, feature="gene")
  data("myPeakList")
  findEnhancers(myPeakList[500:1000], annoData, DNAinteractiveData)
  
}
\seealso{
See Also as \code{\link{annotatePeakInBatch}}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/privateUtil.R
\name{EnsDb2GR}
\alias{EnsDb2GR}
\title{EnsDb object to GRanges}
\usage{
EnsDb2GR(ranges, feature)
}
\arguments{
\item{ranges}{an EnsDb object}

\item{feature}{feature type, could be disjointExons, gene, exon and 
transcript}
}
\description{
convert EnsDb object to GRanges
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getUniqueGOidCount.R
\name{getUniqueGOidCount}
\alias{getUniqueGOidCount}
\title{get the count for each unique GO ID}
\usage{
getUniqueGOidCount(goList)
}
\arguments{
\item{goList}{a set of GO terms as character vector}
}
\value{
a list with 2 variables \item{GOterm}{a vector of GO terms as
character vector} \item{GOcount}{counts corresponding to the above GOterm as
numeric vector}
}
\description{
get the count for each unique GO ID
}
\note{
internal function not intended to be called directly by users
}
\examples{

goList= c("GO:0000075", "GO:0000082","GO:0000082","GO:0000122","GO:0000122",
           "GO:0000075","GO:0000082","GO:0000082","GO:0000122","GO:0000122",
           "GO:0000122","GO:0000122","GO:0000075", "GO:0000082","GO:000012")
 
getUniqueGOidCount(goList)

}
\seealso{
getEnrichedGO
}
\author{
Lihua Julie Zhu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/toGRanges.R
\name{toGRanges}
\alias{toGRanges}
\alias{toGRanges,data.frame-method}
\alias{toGRanges,connection-method}
\alias{toGRanges,TxDb-method}
\alias{toGRanges,EnsDb-method}
\alias{toGRanges,character-method}
\title{Convert dataset to GRanges}
\usage{
toGRanges(data, ...)

\S4method{toGRanges}{connection}(
  data,
  format = c("BED", "GFF", "GTF", "MACS", "MACS2", "MACS2.broad", "narrowPeak",
    "broadPeak", "CSV", "others"),
  header = FALSE,
  comment.char = "#",
  colNames = NULL,
  ...
)

\S4method{toGRanges}{TxDb}(
  data,
  feature = c("gene", "transcript", "exon", "CDS", "fiveUTR", "threeUTR", "tRNAs",
    "geneModel"),
  OrganismDb,
  ...
)

\S4method{toGRanges}{EnsDb}(
  data,
  feature = c("gene", "transcript", "exon", "disjointExons"),
  ...
)

\S4method{toGRanges}{character}(
  data,
  format = c("BED", "GFF", "GTF", "MACS", "MACS2", "MACS2.broad", "narrowPeak",
    "broadPeak", "CSV", "others"),
  header = FALSE,
  comment.char = "#",
  colNames = NULL,
  ...
)
}
\arguments{
\item{data}{an object of data.frame, \link[GenomicFeatures:TxDb-class]{TxDb}
or \link[ensembldb]{EnsDb}, or the file name of data to be imported.
Alternatively, data can be a readable txt-mode connection (See ?read.table).}

\item{\dots}{parameters passed to \link{read.table}}

\item{format}{data format.  If the data format is set to BED, GFF,
narrowPeak or broadPeak, please refer to
http://genome.ucsc.edu/FAQ/FAQformat#format1 for column order. "MACS" is for
converting the excel output file from MACS1. "MACS2" is for converting the
output file from MACS2. If set to CSV, must have columns: seqnames, start, end, strand.}

\item{header}{A logical value indicating whether the file contains the names
of the variables as its first line. If missing, the value is determined from
the file format: header is set to TRUE if the first row contains
one fewer field than the number of columns or the format is set to 'CSV'.}

\item{comment.char}{character: a character vector of length one containing a
single character or an empty string. Use "" to turn off the interpretation
of comments altogether.}

\item{colNames}{If the data format is set to "others", colname must be
defined. And the colname must contain space, start and end. The column name
for the chromosome # should be named as space.}

\item{feature}{annotation type}

\item{OrganismDb}{an object of \link[OrganismDbi]{OrganismDb}. It is used
for extracting gene symbol for geneModel group for
\link[GenomicFeatures:TxDb-class]{TxDb}}
}
\value{
An object of \link[GenomicRanges:GRanges-class]{GRanges}
}
\description{
Convert UCSC BED format and its variants, such as GFF, or any user defined
dataset such as MACS output file to GRanges
}
\examples{

  macs <- system.file("extdata", "MACS_peaks.xls", package="ChIPpeakAnno")
  macsOutput <- toGRanges(macs, format="MACS")
  if(interactive() || Sys.getenv("USER")=="jou"){
    ## MACS connection
    macs <- readLines(macs)
    macs <- textConnection(macs)
    macsOutput <- toGRanges(macs, format="MACS")
    close(macs)
    ## bed
    toGRanges(system.file("extdata", "MACS_output.bed", package="ChIPpeakAnno"),
                format="BED")
    ## narrowPeak
    toGRanges(system.file("extdata", "peaks.narrowPeak", package="ChIPpeakAnno"),
                format="narrowPeak")
    ## broadPeak
    toGRanges(system.file("extdata", "TAF.broadPeak", package="ChIPpeakAnno"),
                format="broadPeak")
    ## CSV
    toGRanges(system.file("extdata", "peaks.csv", package="ChIPpeakAnno"),
                format="CSV")
    ## MACS2
    toGRanges(system.file("extdata", "MACS2_peaks.xls", package="ChIPpeakAnno"),
                format="MACS2")
    ## GFF
    toGRanges(system.file("extdata", "GFF_peaks.gff", package="ChIPpeakAnno"),
                format="GFF")
    ## EnsDb
    library(EnsDb.Hsapiens.v75)
    toGRanges(EnsDb.Hsapiens.v75, feature="gene")
    ## TxDb
    library(TxDb.Hsapiens.UCSC.hg19.knownGene)
    toGRanges(TxDb.Hsapiens.UCSC.hg19.knownGene, feature="gene")
    ## data.frame
    macs <- system.file("extdata", "MACS_peaks.xls", package="ChIPpeakAnno")
    macs <- read.delim(macs, comment.char="#")
    toGRanges(macs)
  }

}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrichmentPlot.R
\name{enrichmentPlot}
\alias{enrichmentPlot}
\title{plot enrichment results}
\usage{
enrichmentPlot(
  res,
  n = 20,
  strlength = Inf,
  style = c("v", "h"),
  label_wrap = 40,
  label_substring_to_remove = NULL,
  orderBy = c("pvalue", "termId", "none")
)
}
\arguments{
\item{res}{output of \link{getEnrichedGO}, \link{getEnrichedPATH}.}

\item{n}{number of terms to be plot.}

\item{strlength}{shorten the description of term by the number of char.}

\item{style}{plot vertically or horizontally}

\item{label_wrap}{soft wrap the labels (i.e. descriptions of the GO or PATHWAY terms), default to 40 characters.}

\item{label_substring_to_remove}{remove common substring from label, 
default to NULL. Special characters must be escaped. E.g. if you would like 
to remove "Homo sapiens (human)" from labels, you must use "Homo sapiens \\\(
human\\\)".}

\item{orderBy}{order the data by pvalue, termId or none.}
}
\value{
an object of ggplot
}
\description{
Plot the GO/KEGG/reactome enrichment results
}
\examples{
data(enrichedGO)
enrichmentPlot(enrichedGO)
if (interactive()||Sys.getenv("USER")=="jou") {
     
     library(org.Hs.eg.db)
     library(GO.db)
     bed <- system.file("extdata", "MACS_output.bed", package="ChIPpeakAnno")
     gr1 <- toGRanges(bed, format="BED", header=FALSE) 
     gff <- system.file("extdata", "GFF_peaks.gff", package="ChIPpeakAnno")
     gr2 <- toGRanges(gff, format="GFF", header=FALSE, skip=3)
     library(EnsDb.Hsapiens.v75) ##(hg19)
     annoData <- toGRanges(EnsDb.Hsapiens.v75)
     gr1.anno <- annoPeaks(gr1, annoData)
     gr2.anno <- annoPeaks(gr2, annoData)
     over <- lapply(GRangesList(gr1=gr1.anno, gr2=gr2.anno), 
                    getEnrichedGO, orgAnn="org.Hs.eg.db",
                    maxP=.05, minGOterm=10, condense=TRUE)
     enrichmentPlot(over$gr1)
     enrichmentPlot(over$gr2, style = "h")
 }
}
\author{
Jianhong Ou, Kai Hu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genomicElementUpSetR.R
\name{genomicElementUpSetR}
\alias{genomicElementUpSetR}
\title{Genomic Element data for upset plot}
\usage{
genomicElementUpSetR(
  peaks,
  TxDb,
  seqlev,
  ignore.strand = TRUE,
  breaks = list(distal_upstream = c(-1e+05, -10000, -1, 1), proximal_upstream = c(-10000,
    -5000, -1, 1), distal_promoter = c(-5000, -2000, -1, 1), proximal_promoter = c(-2000,
    200, -1, 0), `5'UTR` = fiveUTRsByTranscript, `3'UTR` = threeUTRsByTranscript, CDS =
    cds, exon = exons, intron = intronsByTranscript, gene_body = genes,
    immediate_downstream = c(0, 2000, 1, 1), proximal_downstream = c(2000, 5000, 1, 1),
    distal_downstream = c(5000, 1e+05, 1, 1))
)
}
\arguments{
\item{peaks}{peak list, \link[GenomicRanges:GRanges-class]{GRanges} object or
a \link[GenomicRanges:GRangesList-class]{GRangesList}.}

\item{TxDb}{an object of \code{\link[GenomicFeatures:TxDb-class]{TxDb}}}

\item{seqlev}{sequence level should be involved. 
Default is all the sequence levels in intersect of peaks and TxDb.}

\item{ignore.strand}{logical. Whether the strand of the input ranges
should be ignored or not. Default=TRUE}

\item{breaks}{list. A list for labels and sets for the genomic elements.
The element could be an S4 method for signature 'TxDb' or a numeric vector
with length of 4. The three numbers are 
c(upstream point, downstream point, promoter (-1) or downstream (1),
 remove gene body or not (1: remove, 0: keep)).}
}
\value{
list of data for plot.
}
\description{
Prepare data for upset plot for genomic element distribution
}
\details{
The data will be calculated by for each breaks. 
No precedence will be considered.
}
\examples{
if (interactive() || Sys.getenv("USER")=="jou"){
  data(myPeakList)
  if(require(TxDb.Hsapiens.UCSC.hg19.knownGene)){
  seqinfo(myPeakList) <- 
  seqinfo(TxDb.Hsapiens.UCSC.hg19.knownGene)[seqlevels(myPeakList)]
  myPeakList <- GenomicRanges::trim(myPeakList)
  myPeakList <- myPeakList[width(myPeakList)>0]
  x <- genomicElementUpSetR(myPeakList, 
    TxDb.Hsapiens.UCSC.hg19.knownGene)
  library(UpSetR)
  upset(x$plotData, nsets=13, nintersects=NA)
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ExonPlusUtr.human.GRCh37.R
\docType{data}
\name{ExonPlusUtr.human.GRCh37}
\alias{ExonPlusUtr.human.GRCh37}
\title{Gene model with exon, 5' UTR and 3' UTR information for human sapiens
(GRCh37) obtained from biomaRt}
\format{
GRanges with slot start holding the start position of the exon, slot
end holding the end position of the exon, slot rownames holding ensembl
transcript id and slot space holding the chromosome location where the gene
is located. In addition, the following variables are included.  \describe{
\item{list("strand")}{1 for positive strand and -1 for negative strand}
\item{list("description")}{description of the transcript}
\item{list("ensembl_gene_id")}{gene id} \item{list("utr5start")}{5' UTR
start} \item{list("utr5end")}{5' UTR end} \item{list("utr3start")}{3' UTR
start} \item{list("utr3end")}{3' UTR end}}
}
\usage{
ExonPlusUtr.human.GRCh37
}
\description{
Gene model with exon, 5' UTR and 3' UTR information for human sapiens
(GRCh37) obtained from biomaRt
}
\details{
used in the examples Annotation data obtained by: mart = useMart(biomart =
"ensembl", dataset = "hsapiens_gene_ensembl") ExonPlusUtr.human.GRCh37 =
getAnnotation(mart=human, featureType="ExonPlusUtr")
}
\examples{

data(ExonPlusUtr.human.GRCh37)
slotNames(ExonPlusUtr.human.GRCh37)

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binOverRegions.R
\name{plotBinOverRegions}
\alias{plotBinOverRegions}
\title{plot the coverage of regions}
\usage{
plotBinOverRegions(dat, ...)
}
\arguments{
\item{dat}{A list of matrix which indicate the coverage of regions per bin}

\item{...}{Parameters could be used by \link[graphics]{matplot}}
}
\description{
plot the output of \link{binOverRegions} or \link{binOverGene}
}
\examples{

if(interactive()){
path <- system.file("extdata", package="ChIPpeakAnno")
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(rtracklayer)
files <- dir(path, "bigWig")
if(.Platform$OS.type != "windows"){
cvglists <- lapply(file.path(path, files), import,
                   format="BigWig", as="RleList")
names(cvglists) <- sub(".bigWig", "", files)
d <- binOverGene(cvglists, TxDb.Hsapiens.UCSC.hg19.knownGene)
plotBinOverRegions(d)
}
}

}
\seealso{
\link{binOverRegions}, \link{binOverGene}
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/assignChromosomeRegion.R
\name{assignChromosomeRegion}
\alias{assignChromosomeRegion}
\title{Summarize peak distribution over exon, intron, enhancer, proximal promoter,
5 prime UTR and 3 prime UTR}
\usage{
assignChromosomeRegion(
  peaks.RD,
  exon,
  TSS,
  utr5,
  utr3,
  proximal.promoter.cutoff = c(upstream = 2000, downstream = 100),
  immediate.downstream.cutoff = c(upstream = 0, downstream = 1000),
  nucleotideLevel = FALSE,
  precedence = NULL,
  TxDb = NULL
)
}
\arguments{
\item{peaks.RD}{peaks in GRanges: See example below}

\item{exon}{exon data obtained from getAnnotation or customized annotation
of class GRanges containing additional variable: strand (1 or + for plus
strand and -1 or - for minus strand). This parameter is for backward
compatibility only.  \code{\link[GenomicFeatures:TxDb-class]{TxDb}} should
be used instead.}

\item{TSS}{TSS data obtained from getAnnotation or customized annotation of
class GRanges containing additional variable: strand (1 or + for plus strand
and -1 or - for minus strand). For example,
data(TSS.human.NCBI36),data(TSS.mouse.NCBIM37), data(TSS.rat.RGSC3.4) and
data(TSS.zebrafish.Zv8). This parameter is for backward compatibility only.
\code{\link[GenomicFeatures:TxDb-class]{TxDb}} should be used instead.}

\item{utr5}{5 prime UTR data obtained from getAnnotation or customized
annotation of class GRanges containing additional variable: strand (1 or +
for plus strand and -1 or - for minus strand). This parameter is for
backward compatibility only.  \code{\link[GenomicFeatures:TxDb-class]{TxDb}}
should be used instead.}

\item{utr3}{3 prime UTR data obtained from getAnnotation or customized
annotation of class GRanges containing additional variable: strand (1 or +
for plus strand and -1 or - for minus strand). This parameter is for
backward compatibility only.  \code{\link[GenomicFeatures:TxDb-class]{TxDb}}
should be used instead.}

\item{proximal.promoter.cutoff}{Specify the cutoff in bases to classify
proximal promoter or enhencer. Peaks that reside within
proximal.promoter.cutoff upstream from or overlap with transcription start
site are classified as proximal promoters. Peaks that reside upstream of the
proximal.promoter.cutoff from gene start are classified as enhancers. The
default is upstream 2000 bases and downstream 100 bases.}

\item{immediate.downstream.cutoff}{Specify the cutoff in bases to classify
immediate downstream region or enhancer region. Peaks that reside within
immediate.downstream.cutoff downstream of gene end but not overlap 3 prime
UTR are classified as immediate downstream.  Peaks that reside downstream
over immediate.downstreatm.cutoff from gene end are classified as enhancers.
The default is upstream 0 bases and downstream 1000 bases.}

\item{nucleotideLevel}{Logical. Choose between peak centric and nucleotide
centric view. Default=FALSE}

\item{precedence}{If no precedence specified, double count will be enabled,
which means that if a peak overlap with both promoter and 5'UTR, both
promoter and 5'UTR will be incremented. If a precedence order is specified,
for example, if promoter is specified before 5'UTR, then only promoter will
be incremented for the same example.  The values could be any conbinations
of "Promoters", "immediateDownstream", "fiveUTRs", "threeUTRs", "Exons" and
"Introns", Default=NULL}

\item{TxDb}{an object of \code{\link[GenomicFeatures:TxDb-class]{TxDb}} or
similar including \code{\link[ensembldb:EnsDb-class]{EnsDb}}}
}
\value{
A list of two named vectors: percentage and jaccard (Jaccard Index).
The information in the vectors: \item{list("Exons")}{Percent or the picard
index of the peaks resided in exon regions.} \item{list("Introns")}{Percent
or the picard index of the peaks resided in intron regions.}
\item{list("fiveUTRs")}{Percent or the picard index of the peaks resided in
5 prime UTR regions.} \item{list("threeUTRs")}{Percent or the picard index
of the peaks resided in 3 prime UTR regions.}
\item{list("Promoter")}{Percent or the picard index of the peaks resided in
proximal promoter regions.} \item{list("ImmediateDownstream")}{Percent or
the picard index of the peaks resided in immediate downstream regions.}
\item{list("Intergenic.Region")}{Percent or the picard index of the peaks
resided in intergenic regions.}

The Jaccard index, also known as Intersection over Union.  The Jaccard index
is between 0 and 1. The higher the index, the more significant the overlap
between the peak region and the genomic features in consideration.
}
\description{
Summarize peak distribution over exon, intron, enhancer, proximal promoter,
5 prime UTR and 3 prime UTR
}
\examples{

if (interactive() || Sys.getenv("USER")=="jou"){
    ##Display the list of genomes available at UCSC:
    #library(rtracklayer)
    #ucscGenomes()[, "db"]
    ## Display the list of Tracks supported by makeTxDbFromUCSC()
    #supportedUCSCtables()
    ##Retrieving a full transcript dataset for Human from UCSC
    ##TranscriptDb <- 
    ##     makeTxDbFromUCSC(genome="hg19", tablename="ensGene")
    if(require(TxDb.Hsapiens.UCSC.hg19.knownGene)){
      TxDb <- TxDb.Hsapiens.UCSC.hg19.knownGene
      exons <- exons(TxDb, columns=NULL)
      fiveUTRs <- unique(unlist(fiveUTRsByTranscript(TxDb)))
      Feature.distribution <- 
          assignChromosomeRegion(exons, nucleotideLevel=TRUE, TxDb=TxDb)
      barplot(Feature.distribution$percentage)
      assignChromosomeRegion(fiveUTRs, nucleotideLevel=FALSE, TxDb=TxDb)
      data(myPeakList)
      assignChromosomeRegion(myPeakList, nucleotideLevel=TRUE, 
                             precedence=c("Promoters", "immediateDownstream", 
                                          "fiveUTRs", "threeUTRs", 
                                          "Exons", "Introns"), 
                             TxDb=TxDb)
    }
}

}
\references{
1. Zhu L.J. et al. (2010) ChIPpeakAnno: a Bioconductor package
to annotate ChIP-seq and ChIP-chip data. BMC Bioinformatics 2010,
11:237doi:10.1186/1471-2105-11-237

2. Zhu L.J. (2013) Integrative analysis of ChIP-chip and ChIP-seq dataset.
Methods Mol Biol. 2013;1067:105-24. doi: 10.1007/978-1-62703-607-8_8.
}
\seealso{
\link{genomicElementDistribution}, \link{genomicElementUpSetR},
\link{binOverFeature}, \link{binOverGene}, \link{binOverRegions}
}
\author{
Jianhong Ou, Lihua Julie Zhu
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annoPeaks.R
\name{annoPeaks}
\alias{annoPeaks}
\title{Annotate peaks}
\usage{
annoPeaks(
  peaks,
  annoData,
  bindingType = c("nearestBiDirectionalPromoters", "startSite", "endSite", "fullRange"),
  bindingRegion = c(-5000, 5000),
  ignore.peak.strand = TRUE,
  select = c("all", "bestOne"),
  ...
)
}
\arguments{
\item{peaks}{peak list, \link[GenomicRanges:GRanges-class]{GRanges} object}

\item{annoData}{annotation data, \link[GenomicRanges:GRanges-class]{GRanges}
object}

\item{bindingType}{Specifying the criteria to associate peaks with
annotation. Here is how to use it together with the parameter bindingRegion
\itemize{ \item To obtain peaks within 5kb upstream and up to 3kb downstream
of TSS within the gene body, set bindingType = "startSite" and bindingRegion
= c(-5000, 3000) \item To obtain peaks up to 5kb upstream within the gene
body and 3kb downstream of gene/Exon End, set bindingType = "endSite" and
bindingRegion = c(-5000, 3000) \item To obtain peaks from 5kb upstream to
3kb downstream of genes/Exons , set bindingType = "fullRange" and
bindingRegion = c(-5000, 3000) \item To obtain peaks with nearest
bi-directional promoters within 5kb upstream and 3kb downstream of TSS, set
bindingType = "nearestBiDirectionalPromoters" and bindingRegion = c(-5000,
3000) } \describe{ \item{startSite}{start position of the feature (strand is
considered)} \item{endSite}{end position of the feature (strand is
considered)} \item{fullRange}{whole range of the feature}
\item{nearestBiDirectionalPromoters}{nearest promoters from both direction
of the peaks (strand is considered). It will report bidirectional promoters
if there are promoters in both directions in the given region (defined by
bindingRegion). Otherwise, it will report the closest promoter in one
direction.} }}

\item{bindingRegion}{Annotation range used together with bindingType, which
is a vector with two integer values, default to c (-5000, 5000). The first
one must be no bigger than 0, which means upstream. And the sec ond one must
be no less than 1, which means downstream (1 is the site position, 2 is the
next base of the site position). For details, see bindingType.}

\item{ignore.peak.strand}{ignore the peaks strand or not.}

\item{select}{"all" or "bestOne". Return the annotation containing all or
the best one.  The "bestOne" is selected by the shortest distance to the
sites and then similarity between peak and annotations.  Ignored if
bindingType is nearestBiDirectionalPromoters.}

\item{...}{Not used.}
}
\value{
Output is a GRanges object of the annotated peaks.
}
\description{
Annotate peaks by annoGR object in the given range.
}
\examples{
    library(ensembldb)
    library(EnsDb.Hsapiens.v75)
    data("myPeakList")
    annoGR <- toGRanges(EnsDb.Hsapiens.v75)
    seqlevelsStyle(myPeakList) <- seqlevelsStyle(annoGR)
    annoPeaks(myPeakList, annoGR)

}
\seealso{
See Also as \code{\link{annotatePeakInBatch}}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cumulativePercentage.R
\name{cumulativePercentage}
\alias{cumulativePercentage}
\title{Plot the cumulative percentage tag allocation in sample}
\usage{
cumulativePercentage(bamfiles, gr, input = 1, binWidth = 1000, ...)
}
\arguments{
\item{bamfiles}{Bam file names.}

\item{gr}{An object of \link[GenomicRanges:GRanges-class]{GRanges}}

\item{input}{Which file name is input. default 1.}

\item{binWidth}{The width of each bin.}

\item{...}{parameter for
\link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps}.}
}
\value{
A list of data.frame with the cumulative percentages.
}
\description{
Plot the difference between the cumulative percentage tag allocation in
paired samples.
}
\examples{

\dontrun{
path <- system.file("extdata", "reads", package="MMDiffBamSubset")
files <- dir(path, "bam$", full.names = TRUE)
library(BSgenome.Hsapiens.UCSC.hg19)
gr <- as(seqinfo(Hsapiens)["chr1"], "GRanges")
cumulativePercentage(files, gr)
} 
 

}
\references{
Normalization, bias correction, and peak calling for ChIP-seq
Aaron Diaz, Kiyoub Park, Daniel A. Lim, Jun S. Song Stat Appl Genet Mol
Biol. Author manuscript; available in PMC 2012 May 3.Published in final
edited form as: Stat Appl Genet Mol Biol. 2012 Mar 31; 11(3):
10.1515/1544-6115.1750
/j/sagmb.2012.11.issue-3/1544-6115.1750/1544-6115.1750.xml.  Published
online 2012 Mar 31.  doi: 10.1515/1544-6115.1750 PMCID: PMC3342857
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/downstreams.R
\name{downstreams}
\alias{downstreams}
\title{Get downstream coordinates}
\usage{
downstreams(gr, upstream, downstream)
}
\arguments{
\item{gr}{A GenomicRanges object}

\item{upstream, downstream}{non-negative interges.}
}
\value{
A GenomicRanges object
}
\description{
Returns an object of the same type and length as x containing downstream 
ranges. The output range is defined as
}
\details{
(end(x) - upstream) to (end(x) + downstream -1) 

for ranges on the + and * 
strand, and as 

(start(x) - downstream + 1) to (start(x) + downstream)

for ranges on the - strand.

Note that the returned object might contain out-of-bound ranges.
}
\examples{
gr <- GRanges("chr1", IRanges(rep(10, 3), width=6), c("+", "-", "*"))
downstreams(gr, 2, 2)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeVennDiagram.R
\name{makeVennDiagram}
\alias{makeVennDiagram}
\title{Make Venn Diagram from a list of peaks}
\usage{
makeVennDiagram(
  Peaks,
  NameOfPeaks,
  maxgap = -1L,
  minoverlap = 0L,
  totalTest,
  by = c("region", "feature", "base"),
  ignore.strand = TRUE,
  connectedPeaks = c("min", "merge", "keepAll", "keepFirstListConsistent"),
  method = c("hyperG", "permutation"),
  TxDb,
  plot = TRUE,
  ...
)
}
\arguments{
\item{Peaks}{A list of peaks in \link[GenomicRanges:GRanges-class]{GRanges}
format: See example below.}

\item{NameOfPeaks}{Character vector to specify the name of Peaks, 
e.g., c("TF1", "TF2"). This will be used as label in the Venn Diagram.}

\item{maxgap, minoverlap}{Used in the internal call to 
\code{findOverlaps()} to detect overlaps.
See \code{?\link[IRanges:findOverlaps-methods]{findOverlaps}} 
in the \pkg{IRanges} package for a description of these arguments.}

\item{totalTest}{Numeric value to specify the total number of tests 
performed to obtain the list of peaks. It should be much larger than 
the number of peaks in the largest peak set.}

\item{by}{"region", "feature" or "base", default = "region". 
"feature" means using feature field in the GRanges for calculating overlap, 
"region" means using chromosome range for calculating overlap, 
and "base" means calculating overlap in nucleotide level.}

\item{ignore.strand}{Logical: when set to TRUE, the strand information is
ignored in the overlap calculations.}

\item{connectedPeaks}{If multiple peaks involved in overlapping in 
several groups, set it to "merge" will count it as only 1, 
while set it to "min" will count it as the minimal involved peaks in 
any connected peak group. "keepAll" will show all the orginal counts 
for each list while the final counts will be same as "min". 
"keepFirstListConsistent" will keep the counts consistent with first list.}

\item{method}{method to be used for p value calculation. 
hyperG means hypergeometric test and permutation means \link{peakPermTest}.}

\item{TxDb}{An object of \link[GenomicFeatures:TxDb-class]{TxDb}.}

\item{plot}{logical. If TRUE (default), a venn diagram is plotted.}

\item{\dots}{Additional arguments to be passed to 
\link[VennDiagram:venn.diagram]{venn.diagram}.}
}
\value{
A p.value is calculated by
hypergeometric test or permutation test to determine whether the overlaps of 
peaks or features are significant.
}
\description{
Make Venn Diagram from two or more peak ranges, 
Also calculate p-value to  determine whether those peaks 
overlap significantly.
}
\details{
For customized graph options, 
please see venn.diagram in VennDiagram package.
}
\examples{
if (interactive()){
peaks1 <- GRanges(seqnames=c("1", "2", "3"),
                  IRanges(start=c(967654, 2010897, 2496704),
                          end=c(967754, 2010997, 2496804), 
                          names=c("Site1", "Site2", "Site3")),
                  strand="+",
                  feature=c("a","b","f"))
peaks2 = GRanges(seqnames=c("1", "2", "3", "1", "2"), 
                 IRanges(start = c(967659, 2010898,2496700,
                                   3075866,3123260),
                         end = c(967869, 2011108, 2496920, 
                                 3076166, 3123470),
                         names = c("t1", "t2", "t3", "t4", "t5")), 
                 strand = c("+", "+", "-", "-", "+"), 
                 feature=c("a","b","c","d","a"))
makeVennDiagram(list(peaks1, peaks2), NameOfPeaks=c("TF1", "TF2"),
                totalTest=100,scaled=FALSE, euler.d=FALSE, 
                fill=c("#009E73", "#F0E442"), # circle fill color
                col=c("#D55E00", "#0072B2"), #circle border color
                cat.col=c("#D55E00", "#0072B2"))

makeVennDiagram(list(peaks1, peaks2), NameOfPeaks=c("TF1", "TF2"),
                totalTest=100, 
                fill=c("#009E73", "#F0E442"), # circle fill color
                col=c("#D55E00", "#0072B2"), #circle border color
                cat.col=c("#D55E00", "#0072B2"))

###### 4-way diagram using annotated feature instead of chromosome ranges

makeVennDiagram(list(peaks1, peaks2, peaks1, peaks2), 
                NameOfPeaks=c("TF1", "TF2","TF3", "TF4"), 
                totalTest=100, by="feature",
                main = "Venn Diagram for 4 peak lists",
                fill=c(1,2,3,4))
}
}
\seealso{
\link{findOverlapsOfPeaks}, 
\link[VennDiagram:venn.diagram]{venn.diagram}, \link{peakPermTest}
}
\author{
Lihua Julie Zhu, Jianhong Ou
}
\keyword{graph}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/privateUtil.R
\name{TxDb2GR}
\alias{TxDb2GR}
\title{TxDb object to GRanges}
\usage{
TxDb2GR(ranges, feature, OrganismDb)
}
\arguments{
\item{ranges}{an Txdb object}

\item{feature}{feature type, could be geneModel, gene, exon, 
transcript, CDS, fiveUTR, threeUTR, microRNA, and tRNA}

\item{OrganismDb}{org db object}
}
\description{
convert TxDb object to GRanges
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/findMotifsInPromoterSeqs.R
\name{findMotifsInPromoterSeqs}
\alias{findMotifsInPromoterSeqs}
\title{Find occurence of input motifs in the promoter regions of the input gene
list}
\usage{
findMotifsInPromoterSeqs(
  patternFilePath1,
  patternFilePath2,
  findPairedMotif = FALSE,
  BSgenomeName,
  txdb,
  geneIDs,
  upstream = 5000L,
  downstream = 5000L,
  name.motif1 = "motif1",
  name.motif2 = "motif2",
  max.distance = 100L,
  min.distance = 1L,
  motif.orientation = c("both", "motif1UpstreamOfMotif2", "motif2UpstreamOfMoif1"),
  ignore.strand = FALSE,
  format = "fasta",
  skip = 0L,
  motif1LocForDistance = "end",
  motif2LocForDistance = "start",
  outfile,
  append = FALSE
)
}
\arguments{
\item{patternFilePath1}{File path containing a list of known motifs.
Required}

\item{patternFilePath2}{File path containing a motif requried to be in the
flanking regions of the motif(s) in the first file, i.e, patternFilePath1.
Requried if findPairedMotif is set to TRUE}

\item{findPairedMotif}{Find motifs in paired configuration only or not.
Default FALSE}

\item{BSgenomeName}{A BSgenome object. For a list of existing Bsgenomes,
please refer use the function available.genomes in BSgenome package. For
example,BSgenome.Hsapiens.UCSC.hg38 is for hg38, BSgenome.Hsapiens.UCSC.hg19
is for hg19, BSgenome.Mmusculus.UCSC.mm10 is for mm10,
BSgenome.Celegans.UCSC.ce6 is for ce6 BSgenome.Rnorvegicus.UCSC.rn5 is for
rn5, BSgenome.Drerio.UCSC.danRer7 is for Zv9, and
BSgenome.Dmelanogaster.UCSC.dm3 is for dm3. Required}

\item{txdb}{A TxDb object. For creating and using TxDb object, please refer
to GenomicFeatures package. For a list of existing TxDb object, please
search for annotation package starting with Txdb at
http://www.bioconductor.org/packages/release/BiocViews.html#___AnnotationData,
such as TxDb.Rnorvegicus.UCSC.rn5.refGene for rat,
TxDb.Mmusculus.UCSC.mm10.knownGene for mouse,
TxDb.Hsapiens.UCSC.hg19.knownGene and TxDb.Hsapiens.UCSC.hg38.knownGene for
human, TxDb.Dmelanogaster.UCSC.dm3.ensGene for Drosophila and
TxDb.Celegans.UCSC.ce6.ensGene for C.elegans}

\item{geneIDs}{One or more gene entrez IDs. For example the entrez ID for
EWSIR is 2130 https://www.genecards.org/cgi-bin/carddisp.pl?gene=EWSR1 You
can use the addGeneIDs function in ChIPpeakAnno to convert other types of
Gene IDs to entrez ID}

\item{upstream}{Number of bases upstream of the TSS to search for the
motifs. Default 5000L}

\item{downstream}{Number of bases downstream of the TSS to search for the
motifs. Default 5000L}

\item{name.motif1}{Name of the motif in inputfilePath2 for labeling the
output file column. Default motif1. used only when searching for motifs in
paired configuration}

\item{name.motif2}{Name of the motif in inputfilePath2 for labeling the
output file column. Default motif2 used only when searching for motifs in
paired configuration}

\item{max.distance}{maximum required gap between a paired motifs to be
included in the output file. Default 100L}

\item{min.distance}{Minimum required gap between a paired motifs to be
included in the output file. Default 1L}

\item{motif.orientation}{Required relative oriention between paired motifs:
both means any orientation, motif1UpstreamOfMotif2 means motif1 needs to be
located on the upstream of motif2, and motif2UpstreamOfMoif1 means motif2
needs to be located on the upstream of motif1. Default both}

\item{ignore.strand}{Specify whether paired motifs should be located on the
same strand. Default FALSE}

\item{format}{The format of the files specified in inputFilePath1 and
inputFilePath2. Default fasta}

\item{skip}{Specify number of lines to skip at the beginning of the input
file. Default 0L}

\item{motif1LocForDistance}{Specify whether to use the start or end of the
motif1 location to calculate distance between paired motifs. Only applicable
when findPairedMotif is set to TRUE. Default end}

\item{motif2LocForDistance}{Specify whether to use the start or end of the
motif2 location to calculate distance between paired motifs. Only applicable
when findPairedMotif is set to TRUE. Default start}

\item{outfile}{File path to save the search results}

\item{append}{Specify whether to append the results to the specified output
file, i.e., outfile. Default FALSE}
}
\value{
A vector of numeric. It is the background corrected log2-transformed
ratios, CPMRatios or OddRatios.

An object of GRanges with metadata "tx_start", "tx_end tx_strand", "tx_id",
"tx_name", "Gene ID", and motif specific information such as motif name,
motif found, motif strand etc.
}
\description{
Find occurence of input motifs in the promoter regions of the input gene
list
}
\details{
This function outputs the motif occuring locations in the promoter regions
of input gene list and input motifs. It also can find paired motifs within
specificed gap threshold
}
\examples{


library("BSgenome.Hsapiens.UCSC.hg38")
library("TxDb.Hsapiens.UCSC.hg38.knownGene")

patternFilePath1 =system.file("extdata", "motifIRF4.fa", package="ChIPpeakAnno")
patternFilePath2 =system.file("extdata", "motifAP1.fa", package="ChIPpeakAnno")
pairedMotifs <- findMotifsInPromoterSeqs(patternFilePath1 = patternFilePath1,
   patternFilePath2 = patternFilePath2,
   findPairedMotif = TRUE,
   name.motif1 = "IRF4", name.motif2 = "AP1",
   BSgenomeName = BSgenome.Hsapiens.UCSC.hg38,
   geneIDs = 7486, txdb = TxDb.Hsapiens.UCSC.hg38.knownGene,
   outfile = "testPaired.xls")

unPairedMotifs <- findMotifsInPromoterSeqs(patternFilePath1 = patternFilePath1,
    BSgenomeName = BSgenome.Hsapiens.UCSC.hg38,
   geneIDs = 7486, txdb = TxDb.Hsapiens.UCSC.hg38.knownGene,
   outfile = "testUnPaired.xls")

}
\author{
Lihua Julie Zhu, Kai Hu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/metagene.R
\name{metagenePlot}
\alias{metagenePlot}
\title{peak distance to features}
\usage{
metagenePlot(
  peaks,
  AnnotationData,
  PeakLocForDistance = c("middle", "start", "end"),
  FeatureLocForDistance = c("TSS", "middle", "geneEnd"),
  upstream = 1e+05,
  downstream = 1e+05
)
}
\arguments{
\item{peaks}{peak list, \link[GenomicRanges:GRanges-class]{GRanges} object or
a \link[GenomicRanges:GRangesList-class]{GRangesList}.}

\item{AnnotationData}{A \link[GenomicRanges:GRanges-class]{GRanges} object 
or a \link[GenomicFeatures:TxDb-class]{TxDb} object.}

\item{PeakLocForDistance}{Specify the location of peak for calculating
distance,i.e., middle means using middle of the peak to calculate distance
to feature, start means using start of the peak to calculate the distance to
feature. To be compatible with previous version, by default using start}

\item{FeatureLocForDistance}{Specify the location of feature for calculating
distance,i.e., middle means using middle of the feature to calculate
distance of peak to feature, TSS means using start of feature when
feature is on plus strand and using end of feature when feature is on minus
strand, geneEnd means using end of feature when feature is on plus strand
and using start of feature when feature is on minus strand.}

\item{upstream, downstream}{numeric(1). Upstream or downstream region of
features to plot.}
}
\description{
Bar plot for distance to features
}
\details{
the bar heatmap is indicates the peaks around features.
}
\examples{
path <- system.file("extdata", package="ChIPpeakAnno")
files <- dir(path, "broadPeak")
peaks <- sapply(file.path(path, files), toGRanges, format="broadPeak")
peaks <- GRangesList(peaks)
names(peaks) <- sub(".broadPeak", "", basename(names(peaks)))
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
metagenePlot(peaks, TxDb.Hsapiens.UCSC.hg19.knownGene)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hyperGtest.R
\name{hyperGtest}
\alias{hyperGtest}
\title{hypergeometric test}
\usage{
hyperGtest(alltermcount, thistermcount, totaltermInGenome, totaltermInPeakList)
}
\arguments{
\item{alltermcount}{a list with two variables: GOterm and GOcount which is
GO terms and corresponding counts in the whole genome}

\item{thistermcount}{a list with two variables: GOterm and GOcount which is
GO terms and corresponding counts in the peak list}

\item{totaltermInGenome}{number of total GO terms in the whole genome}

\item{totaltermInPeakList}{number of total GO terms in the peak list}
}
\value{
a list with 6 variables \item{thisterm}{GO term}
\item{thistermcount}{count of this GO term in the peak list}
\item{thistermtotal}{count of this GO term in the whole genome}
\item{pvalue}{pvalue of the hypergeometric test}
\item{totaltermInPeakList}{number of total GO terms in the peak list}
\item{totaltermInGenome}{number of total GO terms in the whole genome}
}
\description{
hypergeometric test with lower.tail = FALSE used by getEnrichedGO
}
\details{
see phyper for details
}
\note{
internal function not intended to be used directly by users
}
\examples{

goList= c("GO:0000075", "GO:0000082","GO:0000082","GO:0000122",
          "GO:0000122","GO:0000075","GO:0000082","GO:0000082",
          "GO:0000122","GO:0000122","GO:0000122","GO:0000122",
          "GO:0000075", "GO:0000082","GO:000012")
  
alltermcount = list(GOterm=c("GO:0000075", "GO:0000082", "GO:000012", 
                             "GO:0000122"), 
                    GOcount=c(100, 200, 10, 10))
thistermcount = getUniqueGOidCount(goList)
totaltermInPeakList = 15
totaltermInGenome = 1000
hyperGtest(alltermcount,thistermcount, totaltermInGenome, totaltermInPeakList)

}
\references{
Johnson, N. L., Kotz, S., and Kemp, A. W. (1992) Univariate
Discrete Distributions, Second Edition. New York: Wiley
}
\seealso{
phyper, getEnrichedGO
}
\author{
Lihua Julie ZHu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annotatePeakInBatch.R
\name{annotatePeakInBatch}
\alias{annotatePeakInBatch}
\title{Obtain the distance to the nearest TSS, miRNA, and/or exon for a list of 
peaks}
\usage{
annotatePeakInBatch(
  myPeakList,
  mart,
  featureType = c("TSS", "miRNA", "Exon"),
  AnnotationData,
  output = c("nearestLocation", "overlapping", "both", "shortestDistance", "inside",
    "upstream&inside", "inside&downstream", "upstream", "downstream",
    "upstreamORdownstream", "nearestBiDirectionalPromoters"),
  multiple = c(TRUE, FALSE),
  maxgap = -1L,
  PeakLocForDistance = c("start", "middle", "end", "endMinusStart"),
  FeatureLocForDistance = c("TSS", "middle", "start", "end", "geneEnd"),
  select = c("all", "first", "last", "arbitrary"),
  ignore.strand = TRUE,
  bindingRegion = NULL,
  ...
)
}
\arguments{
\item{myPeakList}{A \link[GenomicRanges:GRanges-class]{GRanges} object}

\item{mart}{A mart object, used if AnnotationData is not supplied, see
useMart of bioMaRt package for details}

\item{featureType}{A charcter vector used with mart argument if
AnnotationData is not supplied; choose from "TSS", "miRNA" or "Exon"}

\item{AnnotationData}{A \link[GenomicRanges:GRanges-class]{GRanges} or
\link{annoGR} object. It can be obtained from the function getAnnotation or
customized annotation of class GRanges containing additional variable:
strand (1 or + for plus strand and -1 or - for minus strand). Pre-compliled
annotations, such as TSS.human.NCBI36, TSS.mouse.NCBIM37, TSS.rat.RGSC3.4
and TSS.zebrafish.Zv8, are provided by this package (attach them with data()
function). Another method to provide annotation data is to obtain through
biomaRt in real time by using the mart and featureType option}

\item{output}{\describe{ 
\item{nearestLocation (default)}{will output the nearest features calculated 
as PeakLoc - FeatureLocForDistance; when selected, the output can consist of 
both "strictly nearest features (non-overlapping)" and "overlapping features"
as long as they are the nearest}
\item{overlapping}{will output overlapping features with maximum gap
specified as maxgap between peak range and feature range; it is possible for 
a peak to be annotated with zero ("NA" will be returned) or multiple 
overlapping features if exist}
\item{both}{will output all the nearest features as well as any features
that overlap with the peak that is not the nearest}
\item{shortestDistance}{will output the features with the shortest distance;
the "shortest distance" is determined from either ends of the feature to 
either ends of the peak} 
\item{upstream&inside}{will output all upstream and overlapping features with 
maximum gap} 
\item{inside&downstream}{will output all downstream and overlapping features 
with maximum gap}
\item{upstream}{will output all upstream features with maximum gap} 
\item{downstream}{will output all downstream features with maximum gap} 
\item{upstreamORdownstream}{will output all upstream features with maximum 
gap or downstream with maximum gap} 
\item{nearestBiDirectionalPromoters}{will use \link{annoPeaks} to
annotate peaks. Nearest promoters from both direction of the peaks (strand
is considered). It will report bidirectional promoters if there are
promoters in both directions in the given region (defined by bindingRegion).
Otherwise, it will report the closest promoter in one direction.} }}

\item{multiple}{Not applicable when output is nearest. TRUE: output multiple
overlapping features for each peak. FALSE: output at most one overlapping
feature for each peak. This parameter is kept for backward compatibility,
please use select.}

\item{maxgap}{The maximum \emph{gap} that is allowed between 2 ranges for
the ranges to be considered as overlapping. The \emph{gap} between 2 ranges
is the number of positions that separate them. The \emph{gap} between 2
adjacent ranges is 0. By convention when one range has its start or end
strictly inside the other (i.e. non-disjoint ranges), the \emph{gap} is
considered to be -1.}

\item{PeakLocForDistance}{Specify the location of peak for calculating
distance,i.e., middle means using middle of the peak to calculate distance
to feature, start means using start of the peak to calculate the distance to
feature, endMinusStart means using the end of the peak to calculate the 
distance to features on plus strand and the start of the peak to calculate 
the distance to features on minus strand. To be compatible with previous 
version, by default using start}

\item{FeatureLocForDistance}{Specify the location of feature for calculating
distance,i.e., middle means using middle of the feature to calculate
distance of peak to feature, start means using start of the feature to
calculate the distance to feature, TSS means using start of feature when
feature is on plus strand and using end of feature when feature is on minus
strand, geneEnd means using end of feature when feature is on plus strand
and using start of feature when feature is on minus strand. To be compatible
with previous version, by default using TSS}

\item{select}{"all" may return multiple overlapping peaks, "first" will
return the first overlapping peak, "last" will return the last overlapping
peak and "arbitrary" will return one of the overlapping peaks.}

\item{ignore.strand}{When set to TRUE, the strand information is ignored in
the annotation. Unless you have stranded peaks and you are interested in 
annotating peaks to the features in the same strand only, you should just 
use the default setting ignore.strand = TRUE.}

\item{bindingRegion}{Annotation range used for \link{annoPeaks}, which is a
vector with two integer values, default to c (-5000, 5000). The first one
must be no bigger than 0. And the sec ond one must be no less than 1. Once
bindingRegion is defined, annotation will based on \link{annoPeaks}. Here is
how to use it together with the parameter output and FeatureLocForDistance.
\itemize{ \item To obtain peaks with nearest bi-directional promoters within
5kb upstream and 3kb downstream of TSS, set output =
"nearestBiDirectionalPromoters" and bindingRegion = c(-5000, 3000) \item To
obtain peaks within 5kb upstream and up to 3kb downstream of TSS within the
gene body, set output="overlapping", FeatureLocForDistance="TSS" and
bindingRegion = c(-5000, 3000) \item To obtain peaks up to 5kb upstream
within the gene body and 3kb downstream of gene/Exon End, set
output="overlapping", FeatureLocForDistance="geneEnd" and bindingRegion =
c(-5000, 3000) \item To obtain peaks from 5kb upstream to 3kb downstream of
genes/Exons, set output="overlapping", bindingType = "fullRange" and
bindingRegion = c(-5000, 3000) } For details, see \link{annoPeaks}.}

\item{...}{Parameters could be passed to \link{annoPeaks}}
}
\value{
An object of \link[GenomicRanges:GRanges-class]{GRanges} with slot
start holding the start position of the peak, slot end holding the end
position of the peak, slot space holding the chromosome location where the
peak is located, slot rownames holding the id of the peak. In addition, the
following variables are included.  \item{list("feature")}{id of the feature
such as ensembl gene ID} \item{list("insideFeature")}{upstream: peak resides
upstream of the feature; downstream: peak resides downstream of the feature;
inside: peak resides inside the feature; overlapStart: peak overlaps with
the start of the feature; overlapEnd: peak overlaps with the end of the
feature; includeFeature: peak include the feature entirely}
\item{list("distancetoFeature")}{distance to the nearest feature such as
transcription start site.  By default, the distance is calculated as the
distance between the start of the binding site and the TSS that is the gene
start for genes located on the forward strand and the gene end for genes
located on the reverse strand. The user can specify the location of peak and
location of feature for calculating this}
\item{list("start_position")}{start position of the feature such as gene}
\item{list("end_position")}{end position of the feature such as the gene}
\item{list("strand")}{1 or + for positive strand and -1 or - for negative
strand where the feature is located} \item{list("shortestDistance")}{The
shortest distance from either end of peak to either end the feature.  }
\item{list("fromOverlappingOrNearest")}{Relevant only when output is set to 
"both". If "nearestLocation": indicates this feature's start (feature's end 
for features from minus strand) is the closest to the peak start ("strictly 
nearest" or "nearest overlapping"); if "Overlapping": indicates this feature 
overlaps with this peak although it is not the nearest (non-nearest 
overlapping) }
}
\description{
Obtain the distance to the nearest TSS, miRNA, exon et al for a list of peak 
locations leveraging IRanges and biomaRt package
}
\examples{


    ## example 1: annotate myPeakList by TxDb or EnsDb.
    data(myPeakList)
    library(ensembldb)
    library(EnsDb.Hsapiens.v75)
    annoData <- annoGR(EnsDb.Hsapiens.v75)
    annotatePeak = annotatePeakInBatch(myPeakList[1:6], AnnotationData=annoData)
    annotatePeak
    
    ## example 2: annotate myPeakList (GRanges) 
    ## with TSS.human.NCBI36 (Granges)
    data(TSS.human.NCBI36)
    annotatedPeak = annotatePeakInBatch(myPeakList[1:6], 
                                        AnnotationData=TSS.human.NCBI36)
    annotatedPeak
    
    ## example 3: you have a list of transcription factor biding sites from 
    ## literature and are interested in determining the extent of the overlap 
    ## to the list of peaks from your experiment. Prior calling the function 
    ## annotatePeakInBatch, need to represent both dataset as GRanges 
    ## where start is the start of the binding site, end is the end of the 
    ## binding site, names is the name of the binding site, space and strand 
    ## are the chromosome name and strand where the binding site is located.
    
    myexp <- GRanges(seqnames=c(6,6,6,6,5,4,4), 
                     IRanges(start=c(1543200,1557200,1563000,1569800,
                                     167889600,100,1000),
                             end=c(1555199,1560599,1565199,1573799,
                                   167893599,200,1200),
                             names=c("p1","p2","p3","p4","p5","p6", "p7")), 
                     strand="+")
    literature <- GRanges(seqnames=c(6,6,6,6,5,4,4), 
                          IRanges(start=c(1549800,1554400,1565000,1569400,
                                          167888600,120,800),
                                  end=c(1550599,1560799,1565399,1571199,
                                        167888999,140,1400),
                                  names=c("f1","f2","f3","f4","f5","f6","f7")),
                          strand=rep(c("+", "-"), c(5, 2)))
    annotatedPeak1 <- annotatePeakInBatch(myexp, 
                                          AnnotationData=literature)
    pie(table(annotatedPeak1$insideFeature))
    annotatedPeak1
    ### use toGRanges or rtracklayer::import to convert BED or GFF format
    ###  to GRanges before calling annotatePeakInBatch
    test.bed <- data.frame(space=c("4", "6"), 
                           start=c("100", "1000"),
                           end=c("200", "1100"), 
                           name=c("peak1", "peak2"))
    test.GR = toGRanges(test.bed)
    annotatePeakInBatch(test.GR, AnnotationData = literature)
 
 library(testthat)
  peak <- GRanges(seqnames = "chr1", 
                  IRanges(start = 24736757, end=24737528,
                          names = "testPeak"))
  data(TSS.human.GRCh37)
  TSS.human.GRCh37[names(TSS.human.GRCh37)== "ENSG00000001461"]
  # GRanges object with 1 range and 1 metadata column:
  # seqnames            ranges strand |            description
  #<Rle>         <IRanges>  <Rle> |            <character>
  # ENSG00000001461        1 24742285-24799466      + | NIPA-like domain con..
  peak
  #GRanges object with 1 range and 0 metadata columns:
  #   seqnames            ranges strand
  #<Rle>         <IRanges>  <Rle>
  #  testPeak     chr1 24736757-24737528      *
  TSS.human.GRCh37[names(TSS.human.GRCh37)== "ENSG00000001460"]
  #GRanges object with 1 range and 1 metadata column:
  #   seqnames            ranges strand |            description
  #<Rle>         <IRanges>  <Rle> |            <character>
  #   ENSG00000001460        1 24683490-24743424      - | UPF0490 protein C1or..
  ap <- annotatePeakInBatch(peak, Annotation=TSS.human.GRCh37, 
                            PeakLocForDistance = "start")
  stopifnot(ap$feature=="ENSG00000001461")
  ap <- annotatePeakInBatch(peak, Annotation=TSS.human.GRCh37,
                            PeakLocForDistance = "end")
  stopifnot(ap$feature=="ENSG00000001461")
  ap <- annotatePeakInBatch(peak, Annotation=TSS.human.GRCh37,
                            PeakLocForDistance = "middle")
  stopifnot(ap$feature=="ENSG00000001461")
  ap <- annotatePeakInBatch(peak, Annotation=TSS.human.GRCh37,
                            PeakLocForDistance = "endMinusStart")
  stopifnot(ap$feature=="ENSG00000001461")
  ## Let's calculate the distances between the peak and the TSS of the genes
  ## in the annotation file used for annotating the peaks.
  ## Please note that we need to compute the distance using the annotation
  ## file TSS.human.GRCh37.
  ## If you would like to use  TxDb.Hsapiens.UCSC.hg19.knownGene, 
  ## then you will need to annotate the peaks
  ## using TxDb.Hsapiens.UCSC.hg19.knownGene as well.
  ### using start
  start(peak) -start(TSS.human.GRCh37[names(TSS.human.GRCh37)== 
                                      "ENSG00000001461"]) #picked
  #[1] -5528
  start(peak) -end(TSS.human.GRCh37[names(TSS.human.GRCh37)==
                                   "ENSG00000001460"])
  #[1] -6667
  #### using middle
  (start(peak) + end(peak))/2 -
      start(TSS.human.GRCh37[names(TSS.human.GRCh37)== "ENSG00000001461"])
  #[1] -5142.5
  (start(peak) + end(peak))/2 -
      end(TSS.human.GRCh37[names(TSS.human.GRCh37)== "ENSG00000001460"])
  # [1] 49480566
  end(peak) -start(TSS.human.GRCh37[names(TSS.human.GRCh37)==
                                   "ENSG00000001461"]) #picked
  # [1] -4757
  end(peak) -end(TSS.human.GRCh37[names(TSS.human.GRCh37)==
                                 "ENSG00000001460"])
  # [1] -5896
  #### using endMinusStart
  end(peak) - start(TSS.human.GRCh37[names(TSS.human.GRCh37)==
                                    "ENSG00000001461"]) ## picked
  # [1] -4575
  start(peak) -end(TSS.human.GRCh37[names(TSS.human.GRCh37)==
                                    "ENSG00000001460"])
  #[1] -6667
  ###### using txdb object to annotate the peaks
  library(org.Hs.eg.db)
  select(org.Hs.eg.db, key="STPG1", keytype="SYMBOL",
         columns=c("ENSEMBL", "ENTREZID", "SYMBOL"))
  #  SYMBOL         ENSEMBL ENTREZID
  #  STPG1 ENSG00000001460    90529
  select(org.Hs.eg.db, key= "ENSG00000001461", keytype="ENSEMBL",
         columns=c("ENSEMBL", "ENTREZID", "SYMBOL"))
  #ENSEMBL ENTREZID SYMBOL
  # ENSG00000001461    57185 NIPAL3
  require(TxDb.Hsapiens.UCSC.hg19.knownGene)
  txdb.ann.current <- genes(TxDb.Hsapiens.UCSC.hg19.knownGene)
  # note: the annotation of STPG1 shifted from old version
  # here we set the old one for the test
  txdb.ann <- GRanges('chr1', IRanges(start=c(24683489, 24742245),
                      end=c(24741587, 24799473)), 
                      strand=c('-', '+'), gene_id=c('90529', '57185'))
  names(txdb.ann) <- txdb.ann$gene_id
  STPG1 <- select(org.Hs.eg.db, key="STPG1", keytype="SYMBOL",
                  columns=c( "SYMBOL", "ENSEMBL", "ENTREZID"))[1,3]
  NIPAL3 <- select(org.Hs.eg.db, key="NIPAL3", keytype="SYMBOL",
                   columns=c( "SYMBOL", "ENSEMBL", "ENTREZID"))[1,3]
  ap <- annotatePeakInBatch(peak, Annotation=txdb.ann,
                            PeakLocForDistance = "start")
  expect_equal(ap$feature, STPG1)
  ap <- annotatePeakInBatch(peak, Annotation=txdb.ann,
                            PeakLocForDistance = "end")
  expect_equal(ap$feature, STPG1)
  ap <- annotatePeakInBatch(peak, Annotation=txdb.ann,
                            PeakLocForDistance = "middle")
  expect_equal(ap$feature, STPG1)
  ap <- annotatePeakInBatch(peak, Annotation=txdb.ann,
                            PeakLocForDistance = "endMinusStart")
  expect_equal(ap$feature, NIPAL3)
  txdb.ann.current[NIPAL3]
  txdb.ann[txdb.ann$gene_id == NIPAL3]
  #  GRanges object with 1 range and 1 metadata column:
  #    seqnames            ranges strand |     gene_id
  #  <Rle>         <IRanges>  <Rle> | <character>
  #   57185     chr1 24742245-24799473      + |       57185
  #-------
  txdb.ann.current[STPG1]
  txdb.ann[txdb.ann$gene_id == STPG1]
  #   GRanges object with 1 range and 1 metadata column:
  #     seqnames            ranges strand |     gene_id
  #  <Rle>         <IRanges>  <Rle> | <character>
  #     90529     chr1 24683489-24741587      - |       90529

}
\references{
1. Zhu L.J. et al. (2010) ChIPpeakAnno: a Bioconductor package
to annotate ChIP-seq and ChIP-chip data. BMC Bioinformatics 2010,
11:237doi:10.1186/1471-2105-11-237

2. Zhu L (2013). "Integrative analysis of ChIP-chip and ChIP-seq dataset."
In Lee T and Luk ACS (eds.), Tilling Arrays, volume 1067, chapter 4, pp.
-19.  Humana Press. http://dx.doi.org/10.1007/978-1-62703-607-8_8
}
\seealso{
\link{getAnnotation}, \link{findOverlappingPeaks},
\link{makeVennDiagram}, \link{addGeneIDs}, \link{peaksNearBDP},
\link{summarizePatternInPeaks}, \link{annoGR}, \link{annoPeaks}
}
\author{
Lihua Julie Zhu, Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TSS.mouse.NCBIM37.R
\docType{data}
\name{TSS.mouse.NCBIM37}
\alias{TSS.mouse.NCBIM37}
\title{TSS annotation data for mouse (NCBIM37) obtained from biomaRt}
\format{
GRanges with slot start holding the start position of the gene, slot
end holding the end position of the gene, slot names holding ensembl gene
id, slot seqnames holding the chromosome location where the gene is located
and slot strand holding the strinad information. In addition, the following
variables are included.  \describe{ \item{list("description")}{description
of the gene}}
}
\usage{
TSS.mouse.NCBIM37
}
\description{
TSS annotation data for mouse (NCBIM37) obtained from biomaRt
}
\details{
Annotation data obtained by:

mart = useMart(biomart = "ensembl", dataset = "mmusculus_gene_ensembl")

getAnnotation(mart, featureType = "TSS")
}
\examples{

data(TSS.mouse.NCBIM37)
slotNames(TSS.mouse.NCBIM37)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ChIPpeakAnno-deprecated.R
\name{ChIPpeakAnno-deprecated}
\alias{ChIPpeakAnno-deprecated}
\title{Deprecated Functions in Package ChIPpeakAnno}
\arguments{
\item{Peaks1}{GRanges: See example below.}

\item{Peaks2}{GRanges: See example below.}

\item{maxgap, minoverlap}{Used in the internal call to \code{findOverlaps()}
to detect overlaps. See
\code{?\link[IRanges:findOverlaps-methods]{findOverlaps}} in the
\pkg{IRanges} package for a description of these arguments.}

\item{multiple}{TRUE or FALSE: TRUE may return multiple overlapping peaks in
Peaks2 for one peak in Peaks1; FALSE will return at most one overlapping
peaks in Peaks2 for one peak in Peaks1. This parameter is kept for backward
compatibility, please use select.}

\item{NameOfPeaks1}{Name of the Peaks1, used for generating column name.}

\item{NameOfPeaks2}{Name of the Peaks2, used for generating column name.}

\item{select}{all may return multiple overlapping peaks, first will return
the first overlapping peak, last will return the last overlapping peak and
arbitrary will return one of the overlapping peaks.}

\item{annotate}{Include overlapFeature and shortestDistance in the
OverlappingPeaks or not.  1 means yes and 0 means no. Default to 0.}

\item{ignore.strand}{When set to TRUE, the strand information is ignored in
the overlap calculations.}

\item{connectedPeaks}{If multiple peaks involved in overlapping in several
groups, set it to "merge" will count it as only 1, while set it to "min"
will count it as the minimal involved peaks in any concered groups}

\item{\dots}{Objects of \link[GenomicRanges:GRanges-class]{GRanges}: See
also \code{\link{findOverlapsOfPeaks}}.}
}
\description{
These functions are provided for compatibility with older versions of R
only, and may be defunct as soon as the next release.
}
\details{
findOverlappingPeaks is now deprecated wrappers for
\code{\link{findOverlapsOfPeaks}}
}
\seealso{
\code{\link{Deprecated}}, \link{findOverlapsOfPeaks},
\link{toGRanges}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TSS.human.GRCh37.R
\docType{data}
\name{TSS.human.GRCh37}
\alias{TSS.human.GRCh37}
\title{TSS annotation for human sapiens (GRCh37) obtained from biomaRt}
\format{
A GRanges object with slot start holding the start position of the
gene, slot end holding the end position of the gene, slot names holding
ensembl gene id, slot seqnames holding the chromosome location where the
gene is located and slot strand holding the strinad information. In
addition, the following variables are included.  \describe{
\item{list("description")}{description of the gene}}
}
\usage{
TSS.human.GRCh37
}
\description{
TSS annotation for human sapiens (GRCh37) obtained from biomaRt
}
\details{
The dataset TSS.human.GRCh37 was obtained by:

mart = useMart(biomart = "ENSEMBL_MART_ENSEMBL", host="grch37.ensembl.org",
path="/biomart/martservice", dataset = "hsapiens_gene_ensembl")

getAnnotation(mart, featureType = "TSS")
}
\examples{

data(TSS.human.GRCh37)
slotNames(TSS.human.GRCh37)

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/write2FASTA.R
\name{write2FASTA}
\alias{write2FASTA}
\title{Write sequences to a file in fasta format}
\usage{
write2FASTA(mySeq, file = "", width = 80)
}
\arguments{
\item{mySeq}{GRanges with varibles name and sequence ,e.g., results obtained
from getAllPeakSequence}

\item{file}{Either a character string naming a file or a connection open for
reading or writing. If "" (the default for write2FASTA), then the function
writes to the standard output connection (the console) unless redirected by
sink}

\item{width}{The maximum number of letters per line of sequence}
}
\value{
Output as FASTA file format to the naming file or the console.
}
\description{
Write the sequences obtained from getAllPeakSequence to a file in fasta
format leveraging writeFASTA in Biostrings package. FASTA is a simple file
format for biological sequence data. A FASTA format file contains one or
more sequences and there is a header line which begins with a > proceeding
each sequence.
}
\examples{

peaksWithSequences = GRanges(seqnames=c("1", "2"),
IRanges(start=c(1000, 2000), 
end=c(1010, 2010), 
names=c("id1", "id2")), 
sequence= c("CCCCCCCCGGGGG", "TTTTTTTAAAAAA"))

write2FASTA(peaksWithSequences, file="testseq.fasta", width=50)

}
\author{
Lihua Julie Zhu
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/oligoSummary.R
\name{oligoFrequency}
\alias{oligoFrequency}
\title{get the oligonucleotide frequency}
\usage{
oligoFrequency(sequence, MarkovOrder = 3L)
}
\arguments{
\item{sequence}{The sequences packaged in DNAStringSet, DNAString object or
output of function \link{getAllPeakSequence}.}

\item{MarkovOrder}{Markov order.}
}
\value{
A numeric vector.
}
\description{
Prepare the oligonucleotide frequency for given Markov order.
}
\examples{
    library(seqinr)
    library(Biostrings)
    oligoFrequency(DNAString("AATTCGACGTACAGATGACTAGACT"))

}
\seealso{
See Also as \code{\link{oligoSummary}}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/translatePattern.R
\name{translatePattern}
\alias{translatePattern}
\title{translate pattern from IUPAC Extended Genetic Alphabet to regular expression}
\usage{
translatePattern(pattern)
}
\arguments{
\item{pattern}{a character vector with the IUPAC nucleotide ambiguity codes}
}
\value{
a character vector with the pattern represented as regular
expression
}
\description{
translate pattern containing the IUPAC nucleotide ambiguity codes to regular
expression.  For example,Y->[C|T], R-> [A|G], S-> [G|C], W-> [A|T], K->
[T|U|G], M-> [A|C], B-> [C|G|T], D-> [A|G|T], H-> [A|C|T], V-> [A|C|G] and
N-> [A|C|T|G].
}
\examples{

    pattern1 = "AACCNWMK"
    translatePattern(pattern1)

}
\seealso{
countPatternInSeqs, summarizePatternInPeaks
}
\author{
Lihua Julie Zhu
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/featureAlignedSignal.R
\name{featureAlignedSignal}
\alias{featureAlignedSignal}
\title{extract signals in given ranges}
\usage{
featureAlignedSignal(
  cvglists,
  feature.gr,
  upstream,
  downstream,
  n.tile = 100,
  ...
)
}
\arguments{
\item{cvglists}{List of \link[IRanges:AtomicList-class]{SimpleRleList} or
\link[IRanges:AtomicList-class]{RleList}}

\item{feature.gr}{An object of \link[GenomicRanges:GRanges-class]{GRanges}
with identical width.}

\item{upstream, downstream}{Set the feature.gr to upstream and dwonstream
from the center of the feature.gr if they are set.}

\item{n.tile}{The number of tiles to generate for each element of
feature.gr, default is 100}

\item{...}{Not used.}
}
\value{
A list of matrix. In each matrix, each row record the signals for
corresponding feature. rownames of the matrix show the seqnames and
coordinates.
}
\description{
extract signals in the given feature ranges
}
\examples{

  cvglists <- list(A=RleList(chr1=Rle(sample.int(5000, 100), 
                                      sample.int(300, 100))), 
                   B=RleList(chr1=Rle(sample.int(5000, 100), 
                                      sample.int(300, 100))))
  feature.gr <- GRanges("chr1", IRanges(seq(1, 4900, 100), width=100))
  featureAlignedSignal(cvglists, feature.gr)

}
\seealso{
See Also as \link{featureAlignedHeatmap},
\link{featureAlignedDistribution}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/peaks2.R
\docType{data}
\name{peaks2}
\alias{peaks2}
\title{An example GRanges object representing a ChIP-seq peak dataset}
\format{
GRanges
}
\usage{
peaks2
}
\description{
An example GRanges object representing a ChIP-seq peak dataset
}
\examples{

data(peaks2)
head(peaks2, n = 2)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binOverFeature.R
\name{binOverFeature}
\alias{binOverFeature}
\title{Aggregate peaks over bins from the TSS}
\usage{
binOverFeature(
  ...,
  annotationData = GRanges(),
  select = c("all", "nearest"),
  radius = 5000L,
  nbins = 50L,
  minGeneLen = 1L,
  aroundGene = FALSE,
  mbins = nbins,
  featureSite = c("FeatureStart", "FeatureEnd", "bothEnd"),
  PeakLocForDistance = c("all", "end", "start", "middle"),
  FUN = sum,
  errFun = sd,
  xlab,
  ylab,
  main
)
}
\arguments{
\item{\dots}{Objects of GRanges to be analyzed}

\item{annotationData}{An object of
\link[GenomicRanges:GRanges-class]{GRanges} or \link{annoGR} for annotation}

\item{select}{Logical: annotate the peaks to all features or the nearest one}

\item{radius}{The radius of the longest distance to feature site}

\item{nbins}{The number of bins}

\item{minGeneLen}{The minimal gene length}

\item{aroundGene}{Logical: count peaks around features or a given site of
the features.  Default = FALSE}

\item{mbins}{if aroundGene set as TRUE, the number of bins intra-feature.
The value will be normalized by value * (radius/genelen) * (mbins/nbins)}

\item{featureSite}{which site of features should be used for distance
calculation}

\item{PeakLocForDistance}{which site of peaks should be used for distance
calculation}

\item{FUN}{the function to be used for score calculation}

\item{errFun}{the function to be used for errorbar calculation or values for
the errorbar.}

\item{xlab}{titles for each x axis}

\item{ylab}{titles for each y axis}

\item{main}{overall titles for each plot}
}
\value{
A data.frame with bin values.
}
\description{
Aggregate peaks over bins from the feature sites.
}
\examples{

bed <- system.file("extdata", "MACS_output.bed", package="ChIPpeakAnno")
gr1 <- toGRanges(bed, format="BED", header=FALSE)
data(TSS.human.GRCh37)
binOverFeature(gr1, annotationData=TSS.human.GRCh37,
               radius=5000, nbins=10, FUN=length, errFun=0)

}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrichedGO.R
\docType{data}
\name{enrichedGO}
\alias{enrichedGO}
\title{Enriched Gene Ontology terms used as example}
\format{
A list of 3 dataframes. \describe{ \item{list("bp")}{ dataframe
described the enriched biological process with 9 columns

go.id:GO biological process id

go.term:GO biological process term

go.Definition:GO biological process description

Ontology: Ontology branch, i.e. BP for biological process

count.InDataset: count of this GO term in this dataset

count.InGenome: count of this GO term in the genome

pvalue: pvalue from the hypergeometric test

totaltermInDataset: count of all GO terms in this dataset

totaltermInGenome: count of all GO terms in the genome

} \item{list("mf")}{ dataframe described the enriched molecular function
with the following 9 columns

go.id:GO molecular function id

go.term:GO molecular function term

go.Definition:GO molecular function description

Ontology: Ontology branch, i.e. MF for molecular function

count.InDataset: count of this GO term in this dataset

count.InGenome: count of this GO term in the genome

pvalue: pvalue from the hypergeometric test

totaltermInDataset: count of all GO terms in this dataset

totaltermInGenome: count of all GO terms in the genome

} \item{list("cc")}{ dataframe described the enriched cellular component the
following 9 columns

go.id:GO cellular component id

go.term:GO cellular component term

go.Definition:GO cellular component description

Ontology: Ontology type, i.e. CC for cellular component

count.InDataset: count of this GO term in this dataset

count.InGenome: count of this GO term in the genome

pvalue: pvalue from the hypergeometric test

totaltermInDataset: count of all GO terms in this dataset

totaltermInGenome: count of all GO terms in the genome

} }
}
\usage{
enrichedGO
}
\description{
Enriched Gene Ontology terms used as example
}
\examples{

data(enrichedGO)
dim(enrichedGO$mf)
dim(enrichedGO$cc)
dim(enrichedGO$bp)

}
\author{
Lihua Julie Zhu
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getGO.R
\name{getGO}
\alias{getGO}
\title{Obtain gene ontology (GO) terms for given genes}
\usage{
getGO(all.genes, orgAnn = "org.Hs.eg.db", writeTo, ID_type = "gene_symbol")
}
\arguments{
\item{all.genes}{A character vector of feature IDs}

\item{orgAnn}{Organism annotation package such as org.Hs.eg.db for human and
org.Mm.eg.db for mouse, org.Dm.eg.db for fly, org.Rn.eg.db for rat,
org.Sc.eg.db for yeast and org.Dr.eg.db for zebrafish}

\item{writeTo}{File path for output table}

\item{ID_type}{The feature type in annotatedPeak such as ensembl_gene_id,
refseq_id, gene_symbol}
}
\value{
An invisible table with genes and GO terms.
}
\description{
Obtain gene ontology (GO) terms useing GO gene mapping package such as
org.Hs.db.eg to obtain the GO annotation.
}
\examples{

  if (interactive()) {
     data(annotatedPeak)
     library(org.Hs.eg.db)
     getGO(annotatedPeak[1:6]$feature, 
          orgAnn="org.Hs.eg.db", 
          ID_type="ensembl_gene_id")
}

}
\seealso{
getEnrichedGO
}
\author{
Lihua Julie Zhu
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wgEncodeTfbsV3.R
\docType{data}
\name{wgEncodeTfbsV3}
\alias{wgEncodeTfbsV3}
\title{transcription factor binding site clusters (V3) from ENCODE}
\format{
An object of GRanges.
}
\source{
http://hgdownload.cse.ucsc.edu/goldenPath/hg19/encodeDCC/
wgEncodeRegTfbsClustered/wgEncodeRegTfbsClusteredV3.bed.gz
}
\usage{
wgEncodeTfbsV3
}
\description{
possible binding pool for human (hg19) from transcription factor binding
site clusters (V3) from ENCODE data and removed the HOT spots
}
\details{
How to generate the data:

temp <- tempfile()

download.file(file.path("http://hgdownload.cse.ucsc.edu", "goldenPath",

"hg19", "encodeDCC",

"wgEncodeRegTfbsClustered",

"wgEncodeRegTfbsClusteredV3.bed.gz"), temp)

data <- read.delim(gzfile(temp, "r"), header=FALSE)

unlink(temp)

colnames(data)[1:4] <- c("seqnames", "start", "end", "TF")

wgEncodeRegTfbsClusteredV3 <- GRanges(as.character(data$seqnames),

IRanges(data$start, data$end),

TF=data$TF)

data(HOT.spots)

hot <- reduce(unlist(HOT.spots))

ol <- findOverlaps(wgEncodeRegTfbsClusteredV3, hot)

wgEncodeTfbsV3 <- wgEncodeRegTfbsClusteredV3[-unique(queryHits(ol))]

wgEncodeTfbsV3 <- reduce(wgEncodeTfbsV3)

save(list="wgEncodeTfbsV3",

file="data/wgEncodeTfbsV3.rda",

compress="xz", compression_level=9)
}
\examples{

data(wgEncodeTfbsV3)
head(wgEncodeTfbsV3)

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getEnrichedPATH.R
\name{getEnrichedPATH}
\alias{getEnrichedPATH}
\title{Obtain enriched PATH that near the peaks}
\usage{
getEnrichedPATH(
  annotatedPeak,
  orgAnn,
  pathAnn,
  feature_id_type = "ensembl_gene_id",
  maxP = 0.01,
  minPATHterm = 10,
  multiAdjMethod = NULL,
  subGroupComparison = NULL
)
}
\arguments{
\item{annotatedPeak}{GRanges such as data(annotatedPeak) or a vector of
feature IDs}

\item{orgAnn}{organism annotation package such as org.Hs.eg.db for human and
org.Mm.eg.db for mouse, org.Dm.eg.db for fly, org.Rn.eg.db for rat,
org.Sc.eg.db for yeast and org.Dr.eg.db for zebrafish}

\item{pathAnn}{pathway annotation package such as KEGG.db (deprecated), reactome.db, KEGGREST}

\item{feature_id_type}{the feature type in annotatedPeakRanges such as
ensembl_gene_id, refseq_id, gene_symbol or entrez_id}

\item{maxP}{maximum p-value to be considered to be significant}

\item{minPATHterm}{minimum count in a genome for a path to be included}

\item{multiAdjMethod}{multiple testing procedures, for details, see
mt.rawp2adjp in multtest package}

\item{subGroupComparison}{A logical vector to split the peaks into two
groups. The enrichment analysis will compare the over-present GO terms
in TRUE group and FALSE group separately. The analysis will split into
two steps: 1. enrichment analysis for TRUE group by hypergeometric
test; 2. enrichment analysis for TRUE over FALSE group
by Fisher's Exact test for the enriched GO terms.
To keep the output same format, if you want to compare FALSE vs TRUE,
please repeat the analysis by inverting the parameter.
Default is NULL.}
}
\value{
A dataframe of enriched path with the following variables.
\item{path.id}{KEGG PATH ID} \item{EntrezID}{Entrez ID}
\item{count.InDataset}{count of this PATH in this dataset}
\item{count.InGenome}{count of this PATH in the genome} \item{pvalue}{pvalue
from the hypergeometric test} \item{totaltermInDataset}{count of all PATH in
this dataset} \item{totaltermInGenome}{count of all PATH in the genome}
\item{PATH}{PATH name}
}
\description{
Obtain enriched PATH that are near the peaks using path package such as
reactome.db and path mapping package such as org.Hs.db.eg to obtain the path
annotation and using hypergeometric test (phyper) and multtest package for
adjusting p-values
}
\examples{

if (interactive()||Sys.getenv("USER")=="jou") {
data(annotatedPeak)
library(org.Hs.eg.db)
library(reactome.db)
enriched.PATH = getEnrichedPATH(annotatedPeak, orgAnn="org.Hs.eg.db",
                 feature_id_type="ensembl_gene_id",
                 pathAnn="reactome.db", maxP=0.01,
                 minPATHterm=10, multiAdjMethod=NULL)
 head(enriched.PATH)
 enrichedKEGG = getEnrichedPATH(annotatedPeak, orgAnn="org.Hs.eg.db",
                 feature_id_type="ensembl_gene_id",
                 pathAnn="KEGGREST", maxP=0.01,
                 minPATHterm=10, multiAdjMethod=NULL)
 enrichmentPlot(enrichedKEGG)
}

}
\references{
Johnson, N. L., Kotz, S., and Kemp, A. W. (1992) Univariate
Discrete Distributions, Second Edition. New York: Wiley
}
\seealso{
phyper, hyperGtest
}
\author{
Jianhong Ou, Kai Hu
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/myPeakList.R
\docType{data}
\name{myPeakList}
\alias{myPeakList}
\title{An example GRanges object representing a ChIP-seq peak dataset}
\format{
GRanges with slot rownames containing the ID of peak as character,
slot start containing the start position of the peak, slot end containing
the end position of the peak and seqnames containing the chromosome where
the peak is located.
}
\source{
Robertson G, Hirst M, Bainbridge M, Bilenky M, Zhao Y, et al. (2007)
Genome-wide profiles of STAT1 DNA association using chromatin
immunoprecipitation and massively parallel sequencing. Nat Methods 4:651-7
}
\usage{
myPeakList
}
\description{
the putative STAT1-binding regions identified in un-stimulated cells using
ChIP-seq technology (Robertson et al., 2007)
}
\examples{

data(myPeakList)
slotNames(myPeakList)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/featureAlignedDistribution.R
\name{featureAlignedDistribution}
\alias{featureAlignedDistribution}
\title{plot distribution in given ranges}
\usage{
featureAlignedDistribution(
  cvglists,
  feature.gr,
  upstream,
  downstream,
  n.tile = 100,
  zeroAt,
  ...
)
}
\arguments{
\item{cvglists}{Output of \link{featureAlignedSignal} or a list of
\link[IRanges:AtomicList-class]{SimpleRleList} or
\link[IRanges:AtomicList-class]{RleList}}

\item{feature.gr}{An object of \link[GenomicRanges:GRanges-class]{GRanges}
with identical width.  If the width equal to 1, you can use upstream and
downstream to set the range for plot.  If the width not equal to 1, you can
use zeroAt to set the zero point of the heatmap.}

\item{upstream, downstream}{upstream or dwonstream from the feature.gr.}

\item{n.tile}{The number of tiles to generate for each element of
feature.gr, default is 100}

\item{zeroAt}{zero point position of feature.gr}

\item{...}{any paramters could be used by \link[graphics]{matplot}}
}
\value{
invisible matrix of the plot.
}
\description{
plot distribution in the given feature ranges
}
\examples{

  cvglists <- list(A=RleList(chr1=Rle(sample.int(5000, 100), 
                                      sample.int(300, 100))), 
                   B=RleList(chr1=Rle(sample.int(5000, 100), 
                                      sample.int(300, 100))))
  feature.gr <- GRanges("chr1", IRanges(seq(1, 4900, 100), width=100))
  featureAlignedDistribution(cvglists, feature.gr, zeroAt=50, type="l")

}
\seealso{
See Also as \link{featureAlignedSignal},
\link{featureAlignedHeatmap}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preparePool.R
\name{preparePool}
\alias{preparePool}
\title{prepare data for permutation test}
\usage{
preparePool(
  TxDb,
  template,
  bindingDistribution,
  bindingType = c("TSS", "geneEnd"),
  featureType = c("transcript", "exon"),
  seqn = NA
)
}
\arguments{
\item{TxDb}{an object of \link[GenomicFeatures:TxDb-class]{TxDb}}

\item{template}{an object of \link[GenomicRanges:GRanges-class]{GRanges}}

\item{bindingDistribution}{an object of \link{bindist}}

\item{bindingType}{the relevant position to features}

\item{featureType}{feature type, transcript or exon.}

\item{seqn}{seqnames. If given, the pool for permutation will be restrict in
the given chromosomes.}
}
\value{
a list with two elements, grs, a list of
\link[GenomicRanges:GRanges-class]{GRanges}.  N, the numbers of elements
should be drawn from in each GRanges.
}
\description{
prepare data for permutation test \link{peakPermTest}
}
\examples{

    if(interactive() || Sys.getenv("USER")=="jou"){
        path <- system.file("extdata", package="ChIPpeakAnno")
        peaksA <- toGRanges(file.path(path, "peaks.narrowPeak"), 
                            format="narrowPeak")
        peaksB <- toGRanges(file.path(path, "MACS2_peaks.xls"), format="MACS2")
        library(TxDb.Hsapiens.UCSC.hg19.knownGene)
        ppp <- preparePool(TxDb.Hsapiens.UCSC.hg19.knownGene, 
                           peaksA, bindingType="TSS",
                           featureType="transcript")
    }

}
\seealso{
\link{peakPermTest}, \link{bindist}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getGeneSeq.R
\name{getGeneSeq}
\alias{getGeneSeq}
\title{Get gene sequence using the biomaRt package}
\usage{
getGeneSeq(LocationParameters, mart)
}
\arguments{
\item{LocationParameters}{c(ensembl_gene_id, distance from the peak to the
transcription start site of the gene with the above ensemblID, upstream
offset from the peak, downstream offset from the peak, Gene Start, Gene End)}

\item{mart}{see useMart of bioMaRt package for details}
}
\value{
a list with the following items \item{feature_id}{ensemble gene ID}
\item{distancetoFeature}{distance from the peak to the transcriptionstart
site of the gene with the above ensembl gene ID} \item{upstream}{upstream
offset from the peakStart} \item{downstream}{downstream offset from the
peakEnd} \item{seq}{sequence obtained around the peak with above upstream
and downstream offset}
}
\description{
Get gene sequence using the biomaRt package
}
\note{
internal function not intended to be called directly by users
}
\examples{



if (interactive())
{
mart <- useMart(biomart="ensembl", dataset="drerio_gene_ensembl")
LocationParameters =c("ENSDARG00000054562",400, 750, 750,40454140,40454935)
getGeneSeq(LocationParameters, mart)

LocationParameters =c("ENSDARG00000054562",752, 750, 750,40454140,40454935)
getGeneSeq(LocationParameters, mart)
 
LocationParameters =c("ENSDARG00000054562",750, 750, 750,40454140,40454935)
getGeneSeq(LocationParameters, mart)
 
 LocationParameters =c("ENSDARG00000054562",-2, 750, 750,40454140,40454935)
 getGeneSeq(LocationParameters, mart)

 LocationParameters =c("ENSDARG00000054562",0, 750, 750,40454140,40454935)
 getGeneSeq(LocationParameters, mart)
 
 LocationParameters =c("ENSDARG00000054562",2, 750, 750,40454140,40454935)
 getGeneSeq(LocationParameters, mart) 
 
 LocationParameters =c("ENSDARG00000054562",1000, 750, 750,40454140,40454935)
 getGeneSeq(LocationParameters, mart)
}


}
\author{
Lihua Julie Zhu
}
\keyword{internal}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binOverRegions.R
\name{binOverRegions}
\alias{binOverRegions}
\title{coverage of chromosome regions}
\usage{
binOverRegions(
  cvglists,
  TxDb,
  upstream.cutoff = 1000L,
  downstream.cutoff = upstream.cutoff,
  nbinsCDS = 100L,
  nbinsUTR = 20L,
  nbinsUpstream = 20L,
  nbinsDownstream = nbinsUpstream,
  includeIntron = FALSE,
  minCDSLen = nbinsCDS,
  minUTRLen = nbinsUTR,
  maxCDSLen = Inf,
  maxUTRLen = Inf
)
}
\arguments{
\item{cvglists}{A list of \link[IRanges:AtomicList-class]{SimpleRleList} or
\link[IRanges:AtomicList-class]{RleList}. It represents the coverage for
samples.}

\item{TxDb}{An object of \code{\link[GenomicFeatures:TxDb-class]{TxDb}}.  It
is used for extracting the annotations.}

\item{upstream.cutoff, downstream.cutoff}{cutoff length for upstream or
downstream of transcript.}

\item{nbinsCDS, nbinsUTR, nbinsUpstream, nbinsDownstream}{The number of bins
for CDS, UTR, upstream and downstream.}

\item{includeIntron}{A logical value which indicates including intron or
not.}

\item{minCDSLen, minUTRLen}{minimal length of CDS or UTR of transcript.}

\item{maxCDSLen, maxUTRLen}{maximal length of CDS or UTR of transctipt.}
}
\description{
calculate the coverage of 5'UTR, CDS and 3'UTR per transcript per bin.
}
\examples{

if(Sys.getenv("USER")=="jou"){
path <- system.file("extdata", package="ChIPpeakAnno")
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(rtracklayer)
files <- dir(path, "bigWig")
if(.Platform$OS.type != "windows"){
cvglists <- lapply(file.path(path, files), import,
                   format="BigWig", as="RleList")
names(cvglists) <- sub(".bigWig", "", files)
d <- binOverRegions(cvglists, TxDb.Hsapiens.UCSC.hg19.knownGene)
plotBinOverRegions(d)
}
}

}
\seealso{
\link{binOverGene}, \link{plotBinOverRegions}
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/permPool.R
\docType{class}
\name{permPool-class}
\alias{permPool-class}
\alias{permPool}
\alias{permPool-method}
\alias{$,permPool-method}
\alias{$<-,permPool-method}
\title{Class \code{"permPool"}}
\description{
An object of class \code{"permPool"} represents the possible locations to do
permutation test.
}
\section{Slots}{

\describe{
\item{\code{grs}}{object of \code{"GRangesList"} The list of binding ranges}

\item{\code{N}}{vector of \code{"integer"}, permutation number for each ranges}
}}

\section{Objects from the Class}{
 Objects can be created by calls of the form
\code{new("permPool", grs="GRangesList", N="integer")}.
}

\seealso{
\link{preparePool}, \link{peakPermTest}
}
\keyword{classes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/addMetadata.R
\name{addMetadata}
\alias{addMetadata}
\title{Add metadata of the GRanges objects used for findOverlapsOfPeaks}
\usage{
addMetadata(ol, colNames = NULL, FUN = c, ...)
}
\arguments{
\item{ol}{An object of overlappingPeaks, which is output of
\link{findOverlapsOfPeaks}.}

\item{colNames}{Names of metadata column to be added. If it is NULL,
addMetadata will guess what to add.}

\item{FUN}{A function to be called}

\item{...}{Arguments to the function call.}
}
\value{
return value is An object of \link{overlappingPeaks}.
}
\description{
Add metadata to to overlapping peaks after calling findOverlapsOfPeaks.
}
\examples{

peaks1 <- GRanges(seqnames=c(6,6,6,6,5),
                 IRanges(start=c(1543200,1557200,1563000,1569800,167889600),
                         end=c(1555199,1560599,1565199,1573799,167893599),
                         names=c("p1","p2","p3","p4","p5")),
                 strand="+",
                 score=1:5, id=letters[1:5])
peaks2 <- GRanges(seqnames=c(6,6,6,6,5),
                  IRanges(start=c(1549800,1554400,1565000,1569400,167888600),
                          end=c(1550599,1560799,1565399,1571199,167888999),
                          names=c("f1","f2","f3","f4","f5")),
                  strand="+",
                  score=6:10, id=LETTERS[1:5])
ol <- findOverlapsOfPeaks(peaks1, peaks2)
addMetadata(ol)

}
\seealso{
See Also as \code{\link{findOverlapsOfPeaks}}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ChIPpeakAnno.R
\docType{package}
\name{ChIPpeakAnno-package}
\alias{ChIPpeakAnno-package}
\alias{ChIPpeakAnno}
\title{Batch annotation of the peaks identified from either ChIP-seq or ChIP-chip
experiments.}
\description{
The package includes functions to retrieve the sequences around the peak,
obtain enriched Gene Ontology (GO) terms, find the nearest gene, exon, miRNA
or custom features such as most conserved elements and other transcription
factor binding sites leveraging biomaRt, IRanges, Biostrings, BSgenome,
GO.db, hypergeometric test phyper and multtest package.
}
\details{
\tabular{ll}{ Package: \tab ChIPpeakAnno\cr Type: \tab Package\cr Version:
\tab 3.0.0\cr Date: \tab 2014-10-24\cr License: \tab LGPL\cr LazyLoad: \tab
yes\cr }
}
\examples{

 if(interactive()){
  data(myPeakList)
  library(ensembldb)
  library(EnsDb.Hsapiens.v75)
  anno <- annoGR(EnsDb.Hsapiens.v75)
  annotatedPeak <-
    annotatePeakInBatch(myPeakList[1:6], AnnotationData=anno)
 }

}
\references{
1. Y. Benjamini and Y. Hochberg (1995). Controlling the false
discovery rate: a practical and powerful approach to multiple testing. J. R.
Statist. Soc. B. Vol. 57: 289-300. \cr 2. Y. Benjamini and D. Yekutieli
(2001). The control of the false discovery rate in multiple hypothesis
testing under dependency. Annals of Statistics. Accepted. \cr 3.  S. Durinck
et al. (2005) BioMart and Bioconductor: a powerful link between biological
biomarts and microarray data analysis. Bioinformatics, 21, 3439-3440. \cr 4.
S. Dudoit, J. P. Shaffer, and J. C. Boldrick (Submitted). Multiple
hypothesis testing in microarray experiments. \cr 5. Y. Ge, S. Dudoit, and
T. P. Speed. Resampling-based multiple testing for microarray data
hypothesis, Technical Report #633 of UCB Stat.
http://www.stat.berkeley.edu/~gyc \cr 6. Y. Hochberg (1988). A sharper
Bonferroni procedure for multiple tests of significance, Biometrika. Vol.
75: 800-802. \cr 7. S. Holm (1979). A simple sequentially rejective multiple
test procedure. Scand. J. Statist.. Vol. 6: 65-70. \cr 8. N. L. Johnson,S.
Kotz and A. W. Kemp (1992) Univariate Discrete Distributions, Second
Edition. New York: Wiley \cr 9. Zhu L.J. et al. (2010) ChIPpeakAnno: a
Bioconductor package to annotate ChIP-seq and ChIP-chip data. BMC
Bioinformatics 2010, 11:237doi:10.1186/1471-2105-11-237.\cr
}
\author{
Lihua Julie Zhu, Jianhong Ou, Hervé Pagès, Claude Gazin, Nathan
Lawson, Simon Lin, David Lapointe and Michael Green

Maintainer: Jianhong Ou <jianhong.ou@umassmed.edu>, Lihua Julie Zhu
<julie.zhu@umassmed.edu>
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/peaks3.R
\docType{data}
\name{peaks3}
\alias{peaks3}
\title{An example GRanges object representing a ChIP-seq peak dataset}
\format{
GRanges
}
\usage{
peaks3
}
\description{
An example GRanges object representing a ChIP-seq peak dataset
}
\examples{

data(peaks3)
head(peaks3, n = 2)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summarizePatternInPeaks.R
\name{summarizePatternInPeaks}
\alias{summarizePatternInPeaks}
\title{Output a summary of the occurrence and enrichment of each pattern in the 
sequences.}
\usage{
summarizePatternInPeaks(
  patternFilePath,
  format = "fasta",
  BSgenomeName,
  peaks,
  revcomp = TRUE,
  method = c("binom.test", "permutation.test"),
  expectFrequencyMethod = c("Markov", "Naive"),
  MarkovOrder = 3L,
  bgdForPerm = c("shuffle", "chromosome"),
  chromosome = c("asPeak", "random"),
  nperm = 1000,
  alpha = 0.05,
  ...
)
}
\arguments{
\item{patternFilePath}{Character value. The path to the file that contains 
the pattern.}

\item{format}{Character value. The format of file containing the 
oligonucleotide pattern, either "fasta" (default) or "fastq".}

\item{BSgenomeName}{Character value. BSgenome object. Please refer to 
available.genomes in BSgenome package for details.}

\item{peaks}{Character value. \link[GenomicRanges:GRanges-class]{GRanges} 
containing the peaks.}

\item{revcomp}{Boolean value, if TURE, also search the reverse compliment of 
pattern. Default is TRUE.}

\item{method}{Character value. Method for pattern enrichment test, 
'binom.test' (default) or 'permutation.test'.}

\item{expectFrequencyMethod}{Character value. Method for calculating the 
expected probability of pattern occurrence, 'Markov' (default) or 'Naive'.}

\item{MarkovOrder}{Integer value. The order of Markov chain. Default is 3.}

\item{bgdForPerm}{Character value. The method for obtaining the background 
sequence. 'chromosome' (default) selects background chromosome 
from chromosomes, refer to 'chromosome' parameter; 'shuffle' will obtain the
backgroud sequence by shufflubg any k-mers in peak sequences, refer to '...'.}

\item{chromosome}{Character value. Relevant if "bgdForPerm='chromosome'".
'asPeak' means to use the same chromosomes in peaks; 'random' means to use 
all chromosomes randomly. Default is 'asPeak'.}

\item{nperm}{Integer value. The number of permutation test, default is 1000.}

\item{alpha}{Numeric value. The significant level for permutation test, 
default is 0.05.}

\item{...}{Aditional parameter passed to function
\link[universalmotif]{shuffle_sequences}}
}
\value{
A list including two data frames named 'motif_enrichment' and 
'motif_occurrence'. The 'motif_enrichment' has four columns: 
\itemize{
 \item "patternNum": number of matched pattern
 \item "totalNumPatternWithSameLen":  total number of pattern with the 
 same length
 \item "expectedRate":  expected rate of pattern for 'binom.test' method
 \item "patternRate":  real rate of pattern for 'permutation.test' method
 \item "pValueBinomTest":  p value of bimom test for 'binom.test' method
 \item "cutOffPermutationTest":  cut off of permutation test for 
 'permutation.test' method
}

The 'motif_occurrence' has 14 columns:

\itemize{
 \item "motifChr":    Chromosome of motif
 \item "motifStartInChr":    motif start position in chromosome
 \item "motifEndInChr":    motif end position in chromosome
 \item "motifName":    motif name
 \item "motifPattern":    motif pattern
 \item "motifStartInPeak":    motif start position in peak
 \item "motifEndInPeak":    motif end position in peak
 \item "motifFound":    specific motif Found in peak
 \item "motifFoundStrand":    strand of specific motif Found in peak, "-" 
 means reverse complement of motif found in peaks
 \item "peakChr":    Chromosome of peak
 \item "peakStart":    peak start position
 \item "peakEnd":    peak end position
 \item "peakWidth":    peak width
 \item "peakStrand":    peak strand
}
}
\description{
Output a summary of the occurrence and enrichment of each pattern in the 
sequences.
}
\details{
Please see \link[universalmotif]{shuffle_sequences} for the more 
information bout 'shuffle' method.
}
\examples{
                            
library(BSgenome.Hsapiens.UCSC.hg19)
filepath <- system.file("extdata", "examplePattern.fa", 
                        package = "ChIPpeakAnno")
peaks <- GRanges(seqnames = c("chr17", "chr3", "chr12", "chr8"),
                 IRanges(start = c(41275784, 10076141, 4654135, 31024288),
                         end = c(41276382, 10076732, 4654728, 31024996),
                         names = paste0("peak", 1:4)))
result <- summarizePatternInPeaks(patternFilePath = filepath, peaks = peaks,
                                  BSgenomeName = Hsapiens)

}
\author{
Lihua Julie Zhu, Junhui Li, Kai Hu
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/peakPermTest.R
\name{peakPermTest}
\alias{peakPermTest}
\title{Permutation Test for two given peak lists}
\usage{
peakPermTest(
  peaks1,
  peaks2,
  ntimes = 100,
  seed = as.integer(Sys.time()),
  mc.cores = getOption("mc.cores", 2L),
  maxgap = -1L,
  pool,
  TxDb,
  bindingDistribution,
  bindingType = c("TSS", "geneEnd"),
  featureType = c("transcript", "exon"),
  seqn = NA,
  ...
)
}
\arguments{
\item{peaks1, peaks2}{an object of
\link[GenomicRanges:GRanges-class]{GRanges}}

\item{ntimes}{number of permutations}

\item{seed}{random seed}

\item{mc.cores}{The number of cores to use. see mclapply.}

\item{maxgap}{See \link[IRanges:findOverlaps-methods]{findOverlaps} in the
IRanges package for a description of these arguments.}

\item{pool}{an object of \link{permPool}}

\item{TxDb}{an object of \link[GenomicFeatures:TxDb-class]{TxDb}}

\item{bindingDistribution}{an object of \link{bindist}}

\item{bindingType}{where the peaks should bind, TSS or geneEnd}

\item{featureType}{what annotation type should be used for detecting the
binding distribution.}

\item{seqn}{default is NA, which means not filter the universe pool for
sampling.  Otherwise the universe pool will be filtered by the seqnames in
seqn.}

\item{\dots}{further arguments to be passed to \link[regioneR]{numOverlaps}.}
}
\value{
A list of class permTestResults. See \link[regioneR]{permTest}
}
\description{
Performs a permutation test to seee if there is an association between two
given peak lists.
}
\examples{

    path <- system.file("extdata", package="ChIPpeakAnno")
    #files <- dir(path, pattern="[12]_WS170.bed", full.names=TRUE)
    #peaks1 <- toGRanges(files[1], skip=5)
    #peaks2 <- toGRanges(files[2], skip=5)
    #peakPermTest(peaks1, peaks2, TxDb=TxDb.Celegans.UCSC.ce6.ensGene)
    if(interactive()){
        peaks1 <- toGRanges(file.path(path, "MACS2_peaks.xls"), 
                            format="MACS2")
        peaks2 <- toGRanges(file.path(path, "peaks.narrowPeak"), 
                            format="narrowPeak")
        library(TxDb.Hsapiens.UCSC.hg19.knownGene)
        peakPermTest(peaks1, peaks2, 
               TxDb=TxDb.Hsapiens.UCSC.hg19.knownGene, min.pctA=10)
    }

}
\references{
Davison, A. C. and Hinkley, D. V. (1997) Bootstrap methods and
their application, Cambridge University Press, United Kingdom, 156-160
}
\seealso{
\link{preparePool}, \link{bindist}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/findOverlapsOfPeaks.R
\name{findOverlapsOfPeaks}
\alias{findOverlapsOfPeaks}
\alias{overlappingPeaks}
\alias{overlappingPeaks-class}
\title{Find the overlapped peaks among two or more set of peaks.}
\usage{
findOverlapsOfPeaks(
  ...,
  maxgap = -1L,
  minoverlap = 0L,
  ignore.strand = TRUE,
  connectedPeaks = c("keepAll", "min", "merge")
)
}
\arguments{
\item{\dots}{Objects of \link[GenomicRanges:GRanges-class]{GRanges}: See
example below.}

\item{maxgap, minoverlap}{Used in the internal call to \code{findOverlaps()}
to detect overlaps. See
\code{?\link[IRanges:findOverlaps-methods]{findOverlaps}} in the
\pkg{IRanges} package for a description of these arguments. 
If 0 < minoverlap < 1, the function will find overlaps by percentage
covered of interval and the filter condition will be set to max covered 
percentage of overlapping peaks.}

\item{ignore.strand}{When set to TRUE, the strand information is ignored in
the overlap calculations.}

\item{connectedPeaks}{If multiple peaks are involved in any group of 
connected/overlapping peaks in any input peak list, set it to "merge" will
add 1 to the overlapping counts, while set it to "min" will add the minimal 
involved peaks in each group of connected/overlapped peaks to the 
overlapping counts. Set it to "keepAll" will add the number of involved 
peaks for each peak list to the corresponding overlapping counts. 
In addition, it will output counts as if connectedPeaks were set to "min".
For examples (https://support.bioconductor.org/p/133486/#133603), 
if 5 peaks in group1 overlap with 2 peaks in group 2, setting connectedPeaks
 to "merge" will add 1 to the overlapping counts; setting it to "keepAll" 
 will add 5 peaks to count.group1, 2 to count.group2, and 2 to counts; 
 setting it to “min” will add 2 to the overlapping counts.}
}
\value{
return value is An object of overlappingPeaks.  \item{venn_cnt}{an
object of VennCounts} \item{peaklist}{a list consists of all overlapping
peaks or unique peaks} \item{uniquePeaks}{an object of
\link[GenomicRanges:GRanges-class]{GRanges} consists of all unique peaks}
\item{mergedPeaks}{an object of \link[GenomicRanges:GRanges-class]{GRanges}
consists of all merged overlapping peaks} \item{peaksInMergedPeaks}{an
object of \link[GenomicRanges:GRanges-class]{GRanges} consists of all peaks
in each samples involved in the overlapping peaks} \item{overlappingPeaks}{a
list of data frame consists of the annotation of all the overlapped peaks}
\item{all.peaks}{a list of GRanges object which contain the input peaks with
formated rownames.}
}
\description{
Find the overlapping peaks for two or more (less than five) set of peak
ranges.
}
\details{
Efficiently perform overlap queries with an interval tree implemented with
GRanges.
}
\examples{

peaks1 <- GRanges(seqnames=c(6,6,6,6,5),
                 IRanges(start=c(1543200,1557200,1563000,1569800,167889600),
                         end=c(1555199,1560599,1565199,1573799,167893599),
                         names=c("p1","p2","p3","p4","p5")),
                 strand="+")
peaks2 <- GRanges(seqnames=c(6,6,6,6,5),
                  IRanges(start=c(1549800,1554400,1565000,1569400,167888600),
                          end=c(1550599,1560799,1565399,1571199,167888999),
                          names=c("f1","f2","f3","f4","f5")),
                  strand="+")
t1 <- findOverlapsOfPeaks(peaks1, peaks2, maxgap=1000)
makeVennDiagram(t1)
t1$venn_cnt
t1$peaklist
t2 <- findOverlapsOfPeaks(peaks1, peaks2, minoverlap = .5)
makeVennDiagram(t2)

t3 <- findOverlapsOfPeaks(peaks1, peaks2, minoverlap = .90)
makeVennDiagram(t3)

}
\references{
1.Interval tree algorithm from: Cormen, Thomas H.; Leiserson,
Charles E.; Rivest, Ronald L.; Stein, Clifford. Introduction to Algorithms,
second edition, MIT Press and McGraw-Hill. ISBN 0-262-53196-8

2.Zhu L.J. et al. (2010) ChIPpeakAnno: a Bioconductor package to annotate
ChIP-seq and ChIP-chip data. BMC Bioinformatics 2010,
11:237doi:10.1186/1471-2105-11-237

3. Zhu L (2013). "Integrative analysis of ChIP-chip and ChIP-seq dataset."
In Lee T and Luk ACS (eds.), Tilling Arrays, volume 1067, chapter 4, pp.
-19. Humana Press. http://dx.doi.org/10.1007/978-1-62703-607-8_8,
http://link.springer.com/protocol/10.1007\%2F978-1-62703-607-8_8
}
\seealso{
\link{annotatePeakInBatch}, \link{makeVennDiagram},
\link{getVennCounts}, \link{findOverlappingPeaks}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binOverGene.R
\name{binOverGene}
\alias{binOverGene}
\title{coverage of gene body}
\usage{
binOverGene(
  cvglists,
  TxDb,
  upstream.cutoff = 0L,
  downstream.cutoff = upstream.cutoff,
  nbinsGene = 100L,
  nbinsUpstream = 20L,
  nbinsDownstream = nbinsUpstream,
  includeIntron = FALSE,
  minGeneLen = nbinsGene,
  maxGeneLen = Inf
)
}
\arguments{
\item{cvglists}{A list of \link[IRanges:AtomicList-class]{SimpleRleList} or
\link[IRanges:AtomicList-class]{RleList}. It represents the coverage for
samples.}

\item{TxDb}{An object of \code{\link[GenomicFeatures:TxDb-class]{TxDb}}.  It
is used for extracting the annotations.}

\item{upstream.cutoff, downstream.cutoff}{cutoff length for upstream or
downstream of transcript.}

\item{nbinsGene, nbinsUpstream, nbinsDownstream}{The number of bins for gene,
upstream and downstream.}

\item{includeIntron}{A logical value which indicates including intron or
not.}

\item{minGeneLen, maxGeneLen}{minimal or maximal length of gene.}
}
\description{
calculate the coverage of gene body per gene per bin.
}
\examples{

if(Sys.getenv("USER")=="jou"){
path <- system.file("extdata", package="ChIPpeakAnno")
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(rtracklayer)
files <- dir(path, "bigWig")
if(.Platform$OS.type != "windows"){
cvglists <- lapply(file.path(path, files), import,
                   format="BigWig", as="RleList")
names(cvglists) <- sub(".bigWig", "", files)
d <- binOverGene(cvglists, TxDb.Hsapiens.UCSC.hg19.knownGene)
plotBinOverRegions(d)
}
}

}
\seealso{
\link{binOverRegions}, \link{plotBinOverRegions}
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/estFragmentLength.R
\name{estFragmentLength}
\alias{estFragmentLength}
\title{estimate the fragment length}
\usage{
estFragmentLength(
  bamfiles,
  index = bamfiles,
  plot = TRUE,
  lag.max = 1000,
  minFragmentSize = 100,
  ...
)
}
\arguments{
\item{bamfiles}{The file names of the 'BAM' ('SAM' for asBam) files to be
processed.}

\item{index}{The names of the index file of the 'BAM' file being processed;
this is given without the '.bai' extension.}

\item{plot}{logical. If TRUE (the default) the acf is plotted.}

\item{lag.max}{maximum lag at which to calculate the acf. See
\code{\link[stats]{acf}}}

\item{minFragmentSize}{minimal fragment size to avoid the phantom peak.}

\item{\dots}{Not used.}
}
\value{
numberic vector
}
\description{
estimate the fragment length for bam files
}
\examples{

    if(interactive() || Sys.getenv("USER")=="jou"){
        path <- system.file("extdata", "reads", package="MMDiffBamSubset")
        if(file.exists(path)){
            WT.AB2 <- file.path(path, "WT_2.bam")
            Null.AB2 <- file.path(path, "Null_2.bam")
            Resc.AB2 <- file.path(path, "Resc_2.bam")
            estFragmentLength(c(WT.AB2, Null.AB2, Resc.AB2))
        }
    }
    

}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getAnnotation.R
\name{getAnnotation}
\alias{getAnnotation}
\title{Obtain the TSS, exon or miRNA annotation for the specified species}
\usage{
getAnnotation(
  mart,
  featureType = c("TSS", "miRNA", "Exon", "5utr", "3utr", "ExonPlusUtr", "transcript")
)
}
\arguments{
\item{mart}{A mart object, see useMart of biomaRt package for details.}

\item{featureType}{TSS, miRNA, Exon, 5'UTR, 3'UTR, transcript or Exon plus
UTR. The default is TSS.}
}
\value{
\link[GenomicRanges:GRanges-class]{GRanges} with slot start holding
the start position of the feature, slot end holding the end position of the
feature, slot names holding the id of the feature, slot space holding the
chromosome location where the feature is located. In addition, the following
variables are included.  \item{list("strand")}{1 for positive strand and -1
for negative strand where the feature is located}
\item{list("description")}{description of the feeature such as gene}
}
\description{
Obtain the TSS, exon or miRNA annotation for the specified species using the
biomaRt package
}
\note{
For featureType of TSS, start is the transcription start site if
strand is 1 (plus strand), otherwise, end is the transcription start site.
\cr\cr
Note that the version of the annotation db must match with the genome used
for mapping because the coordinates may differ for different genome releases.
 For example, if you are using Mus_musculus.v103 for mapping, 
 you'd best also use EnsDb.Mmusculus.v103 for annotation. 
 See Examples for more info.
}
\examples{

if (interactive() || Sys.getenv("USER")=="jou" )
{
  library(biomaRt)
  mart <- useMart(biomart="ensembl", dataset="hsapiens_gene_ensembl")
  Annotation <- getAnnotation(mart, featureType="TSS")
}

##########################################################
#  Below are 3 options to fetch the annotation file.     #
##########################################################
if (interactive() || Sys.getenv("USER")=="jou" ){
## Option1: with the AnnotationHub package
library(AnnotationHub)
ah <- AnnotationHub()
EnsDb.Mmusculus <- query(ah, pattern = c("Mus musculus", "EnsDb"))
EnsDb.Mmusculus.v101 <- EnsDb.Mmusculus[[length(EnsDb.Mmusculus)]]
class(EnsDb.Mmusculus.v101)

## Option2: with the getAnnotation() function
library(ChIPpeakAnno)
library(biomaRt)
listMarts()
mart <- useMart(biomart="ENSEMBL_MART_ENSEMBL", 
                dataset="mmusculus_gene_ensembl")
Annotation <- getAnnotation(mart)
# Note that getAnnotation() queries biomart, which is always up-to-date.

## Option3: build your own EnsDb package
## This may need extra effort, and the ?makeEnsembldbPackage 
## is a good starting point.
}
}
\references{
Durinck S. et al. (2005) BioMart and Bioconductor: a powerful
link between biological biomarts and microarray data analysis.
Bioinformatics, 21, 3439-3440.
}
\author{
Lihua Julie Zhu, Jianhong Ou, Kai Hu
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tileGRanges.R
\name{tileGRanges}
\alias{tileGRanges}
\title{Slide windows on a given \link[GenomicRanges:GRanges-class]{GRanges} object}
\usage{
tileGRanges(targetRegions, windowSize, step, keepPartialWindow = FALSE, ...)
}
\arguments{
\item{targetRegions}{A \link[GenomicRanges:GRanges-class]{GRanges} object of
genomic regions of interest.}

\item{windowSize}{Size of windows}

\item{step}{Step of windows}

\item{keepPartialWindow}{Keep last partial window or not.}

\item{...}{Not used.}
}
\value{
A \link[GenomicRanges:GRanges-class]{GRanges} object.
}
\description{
tileGRanges returns a set of genomic regions by sliding the windows in a
given step. Each window is called a "tile".
}
\examples{

    genes <- GRanges(
        seqnames = c(rep("chr2L", 4), rep("chr2R", 5), rep("chr3L", 2)),
        ranges = IRanges(c(1000, 3000, 4000, 7000, 2000, 3000, 3600, 
                           4000, 7500, 5000, 5400), 
                         width=c(rep(500, 3), 600, 900, 500, 300, 900, 
                                 300, 500, 500),
                         names=letters[1:11])) 
    se <- tileGRanges(genes, windowSize=50, step=10)

}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Peaks.Ste12.R
\docType{data}
\name{Peaks.Ste12.Replicate3}
\alias{Peaks.Ste12.Replicate3}
\title{Ste12-binding sites from biological replicate 3 in yeast (see reference)}
\format{
GRanges with slot names containing the ID of peak as character, slot
start containing the start position of the peak, slot end containing the end
position of the peak and space containing the chromosome where the peak is
located.
}
\source{
http://www.biomedcentral.com/1471-2164/10/37
}
\usage{
Peaks.Ste12.Replicate3
}
\description{
Ste12-binding sites from biological replicate 3 in yeast (see reference)
}
\examples{

data(Peaks.Ste12.Replicate3)
Peaks.Ste12.Replicate3

}
\references{
Philippe Lefranois, Ghia M Euskirchen, Raymond K Auerbach, Joel
Rozowsky, Theodore Gibson, Christopher M Yellman, Mark Gerstein and Michael
Snyder (2009) Efficient yeast ChIP-Seq using multiplex short-read DNA
sequencing BMC Genomics 10:37doi:10.1186/1471-2164-10-37
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/convert2EntrezID.R
\name{convert2EntrezID}
\alias{convert2EntrezID}
\title{Convert other common IDs to entrez gene ID.}
\usage{
convert2EntrezID(IDs, orgAnn, ID_type = "ensembl_gene_id")
}
\arguments{
\item{IDs}{a vector of IDs such as ensembl gene ids}

\item{orgAnn}{organism annotation dataset such as org.Hs.eg.db}

\item{ID_type}{type of ID: can be ensemble_gene_id, gene_symbol or refseq_id}
}
\value{
vector of entrez ids
}
\description{
Convert other common IDs such as ensemble gene id, gene symbol, refseq id to
entrez gene ID leveraging organism annotation dataset.  For example,
org.Hs.eg.db is the dataset from orgs.Hs.eg.db package for human, while
org.Mm.eg.db is the dataset from the org.Mm.eg.db package for mouse.
}
\examples{

ensemblIDs = c("ENSG00000115956", "ENSG00000071082", "ENSG00000071054",
 "ENSG00000115594", "ENSG00000115594", "ENSG00000115598", "ENSG00000170417")
library(org.Hs.eg.db)
entrezIDs = convert2EntrezID(IDs=ensemblIDs, orgAnn="org.Hs.eg.db",
 ID_type="ensembl_gene_id")

}
\author{
Lihua Julie Zhu
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/IDRfilter.R
\name{IDRfilter}
\alias{IDRfilter}
\title{Filter peaks by IDR (irreproducible discovery rate)}
\usage{
IDRfilter(
  peaksA,
  peaksB,
  bamfileA,
  bamfileB,
  maxgap = -1L,
  minoverlap = 0L,
  singleEnd = TRUE,
  IDRcutoff = 0.01,
  ...
)
}
\arguments{
\item{peaksA, peaksB}{peaklist, \link[GenomicRanges:GRanges-class]{GRanges}
object.}

\item{bamfileA, bamfileB}{file path of bam files.}

\item{maxgap, minoverlap}{Used in the internal call to \code{findOverlaps()}
to detect overlaps. See
\code{?\link[IRanges:findOverlaps-methods]{findOverlaps}} in the
\pkg{IRanges} package for a description of these arguments.}

\item{singleEnd}{(Default TRUE) A logical indicating if reads are single or
paired-end.}

\item{IDRcutoff}{If the IDR no less than IDRcutoff, the peak will be
removed.}

\item{...}{Not used.}
}
\value{
An object GRanges
}
\description{
Using IDR to assess the consistency of replicate experiments and obtain a
high-confidence single set of peaks
}
\examples{

  if(interactive()){
    path <- system.file("extdata", "reads", package="MMDiffBamSubset")
    if(file.exists(path)){
            bamfileA <- file.path(path, "reads", "WT_2.bam")
            bamfileB <- file.path(path, "reads", "Resc_2.bam")
            WT.AB2.Peaks <- file.path(path, "peaks", "WT_2_Macs_peaks.xls")
            Resc.AB2.Peaks <- file.path(path, "peaks",
                                       "Resc_2_Macs_peaks.xls")
            peaksA=toGRanges(WT.AB2.Peaks, format="MACS")
            peaksB=toGRanges(Resc.AB2.Peaks, format="MACS")
            library(idr)
            library(DelayedArray)
            IDRfilter(peaksA, peaksB,
                        bamfileA, bamfileB)
    }
  }

}
\references{
Li, Qunhua, et al. "Measuring reproducibility of high-throughput
experiments." The annals of applied statistics (2011): 1752-1779.
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bdp.R
\name{bdp}
\alias{bdp}
\title{obtain the peaks near bi-directional promoters}
\usage{
bdp(peaks, annoData, maxgap = 2000L, ...)
}
\arguments{
\item{peaks}{peak list, \link[GenomicRanges:GRanges-class]{GRanges} object}

\item{annoData}{annotation data, \link{annoGR} object}

\item{maxgap}{maxgap between peak and TSS}

\item{...}{Not used.}
}
\value{
Output is a list of GRanges object of the peaks near bi-directional
promoters.
}
\description{
Obtain the peaks near bi-directional promoters. Also output percent of peaks
near bi-directional promoters.
}
\examples{

  if(interactive() || Sys.getenv("USER")=="jou"){
    library(ensembldb)
    library(EnsDb.Hsapiens.v75)
    data("myPeakList")
    annoGR <- annoGR(EnsDb.Hsapiens.v75)
    seqlevelsStyle(myPeakList) <- seqlevelsStyle(annoGR)
    ChIPpeakAnno:::bdp(myPeakList, annoGR)
  }

}
\seealso{
See Also as \code{\link{annoPeaks}}, \code{\link{annoGR}}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genomicElementDistribution.R
\name{genomicElementDistribution}
\alias{genomicElementDistribution}
\title{Genomic Element distribution}
\usage{
genomicElementDistribution(
  peaks,
  TxDb,
  seqlev,
  nucleotideLevel = FALSE,
  ignore.strand = TRUE,
  promoterRegion = c(upstream = 2000, downstream = 100),
  geneDownstream = c(upstream = 0, downstream = 1000),
  labels = list(geneLevel = c(promoter = "Promoter", geneDownstream = "Downstream",
    geneBody = "Gene body", distalIntergenic = "Distal Intergenic"), ExonIntron = c(exon
    = "Exon", intron = "Intron", intergenic = "Intergenic"), Exons = c(utr5 = "5' UTR",
    utr3 = "3' UTR", CDS = "CDS", otherExon = "Other exon"), group = c(geneLevel =
    "Transcript Level", promoterLevel = "Promoter Level", Exons = "Exon level",
    ExonIntron = "Exon/Intron/Intergenic")),
  labelColors = c(promoter = "#E1F114", geneBody = "#9EFF00", geneDownstream = "#57CB1B",
    distalIntergenic = "#066A4B", exon = "#6600FF", intron = "#8F00FF", intergenic =
    "#DA00FF", utr5 = "#00FFDB", utr3 = "#00DFFF", CDS = "#00A0FF", otherExon =
    "#006FFF"),
  plot = TRUE,
  keepExonsInGenesOnly = TRUE,
  promoterLevel
)
}
\arguments{
\item{peaks}{peak list, \link[GenomicRanges:GRanges-class]{GRanges} object or
a \link[GenomicRanges:GRangesList-class]{GRangesList}.}

\item{TxDb}{an object of \code{\link[GenomicFeatures:TxDb-class]{TxDb}}}

\item{seqlev}{sequence level should be involved. 
Default is all the sequence levels in intersect of peaks and TxDb.}

\item{nucleotideLevel}{Logical. Choose between peak centric and nucleotide
centric view. Default=FALSE}

\item{ignore.strand}{logical. Whether the strand of the input ranges
should be ignored or not. Default=TRUE}

\item{promoterRegion}{numeric. The upstream and downstream of genes to define
promoter region.}

\item{geneDownstream}{numeric. The upstream and downstream of genes to define
gene downstream region.}

\item{labels}{list. A list for labels for the genomic elements.}

\item{labelColors}{named character vector. The colors for each labels.}

\item{plot}{logic. Plot the pie chart for the genomic elements or not.}

\item{keepExonsInGenesOnly}{logic. Keep the exons within annotated gene only.}

\item{promoterLevel}{list. The breaks, labels, and colors for divided range 
of promoters. The breaks must be from 5' -> 3' and the percentage will use
the fixed precedence 3' -> 5'}
}
\value{
Invisible list of data for plot.
}
\description{
Plot pie chart for genomic element distribution
}
\details{
The distribution will be calculated by geneLevel,
ExonIntron, and Exons The geneLevel will be categorized as
promoter region, gene body, gene downstream and distal intergenic region.
The ExonIntron will be categorized as exon, intron and intergenic.
The Exons will be categorized as 5' UTR, 3'UTR and CDS.
The precedence will follow the order of labels defination.
For example, for ExonIntron, if a peak overlap with both exon and intron, 
and exon is specified before intron, then only exon will
be incremented for the same example.
}
\examples{
if (interactive() || Sys.getenv("USER")=="jou"){
  data(myPeakList)
  if(require(TxDb.Hsapiens.UCSC.hg19.knownGene)){
  seqinfo(myPeakList) <- 
  seqinfo(TxDb.Hsapiens.UCSC.hg19.knownGene)[seqlevels(myPeakList)]
  myPeakList <- GenomicRanges::trim(myPeakList)
  myPeakList <- myPeakList[width(myPeakList)>0]
    genomicElementDistribution(myPeakList, 
        TxDb.Hsapiens.UCSC.hg19.knownGene)
    genomicElementDistribution(myPeakList, 
        TxDb.Hsapiens.UCSC.hg19.knownGene,
        nucleotideLevel = TRUE)
    genomicElementDistribution(myPeakList, 
        TxDb.Hsapiens.UCSC.hg19.knownGene,
        promoterLevel=list(
        #from 5' -> 3', fixed precedence 3' -> 5'
        breaks = c(-2000, -1000, -500, 0, 100),
        labels = c("upstream 1-2Kb", "upstream 0.5-1Kb", 
                   "upstream <500b", "TSS - 100b"),
        colors = c("#FFE5CC", "#FFCA99", 
                   "#FFAD65", "#FF8E32")))
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pie1.R
\name{pie1}
\alias{pie1}
\title{Pie Charts}
\usage{
pie1(
  x,
  labels = names(x),
  edges = 200,
  radius = 0.8,
  clockwise = FALSE,
  init.angle = if (clockwise) 90 else 0,
  density = NULL,
  angle = 45,
  col = NULL,
  border = NULL,
  lty = NULL,
  main = NULL,
  percentage = TRUE,
  rawNumber = FALSE,
  digits = 3,
  cutoff = 0.01,
  legend = FALSE,
  legendpos = "topright",
  legendcol = 2,
  radius.innerlabel = radius,
  ...
)
}
\arguments{
\item{x}{a vector of non-negative numerical quantities.  The values in x are
displayed as the areas of pie slices.}

\item{labels}{one or more expressions or character strings giving names for
the slices.  Other objects are coerced by as.graphicsAnnot. For empty or NA
(after coercion to character) labels, no label nor pointing line is drawn.}

\item{edges}{the circular outline of the pie is approximated by a polygon
with this many edges.}

\item{radius}{the pie is drawn centered in a square box whose sides range
from -1 to 1.  If the character strings labeling the slices are long it may
be necessary to use a smaller radius.}

\item{clockwise}{logical indicating if slices are drawn clockwise or counter
clockwise (i.e., mathematically positive direction), the latter is default.}

\item{init.angle}{number specifying the starting angle (in degrees) for the
slices. Defaults to 0 (i.e., "3 o'clock") unless clockwise is true where
init.angle defaults to 90 (degrees), (i.e., "12 o'clock").}

\item{density}{the density of shading lines, in lines per inch. The default
value of NULL means that no shading lines are drawn. Non-positive values of
density also inhibit the drawing of shading lines.}

\item{angle}{the slope of shading lines, given as an angle in degrees
(counter-clockwise).}

\item{col}{a vector of colors to be used in filling or shading the slices.
If missing a set of 6 pastel colours is used, unless density is specified
when par("fg") is used.}

\item{border, lty}{(possibly vectors) arguments passed to polygon which draws
each slice.}

\item{main}{an overall title for the plot.}

\item{percentage}{logical. Add percentage in the figure or not. default
TRUE.}

\item{rawNumber}{logical. Instead percentage, add raw number in the figure
or not. default FALSE.}

\item{digits}{When set percentage as TRUE, how many significant digits are
to be used for percentage. see \link[base]{format}. default 3.}

\item{cutoff}{When percentage is TRUE, if the percentage is lower than
cutoff, it will NOT be shown. default 0.01.}

\item{legend}{logical. Instead of lable, draw legend for the pie. default,
FALSE.}

\item{legendpos, legendcol}{legend position and legend columns. see
\link[graphics]{legend}}

\item{radius.innerlabel}{position of percentage or raw number label relative
to the circle.}

\item{...}{graphical parameters can be given as arguments to pie. They will
affect the main title and labels only.}
}
\description{
Draw a pie chart with percentage
}
\examples{

pie1(1:5)

}
\seealso{
\code{\link[graphics]{pie}}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getEnrichedGO.R
\name{getEnrichedGO}
\alias{getEnrichedGO}
\title{Obtain enriched gene ontology (GO) terms that near the peaks}
\usage{
getEnrichedGO(
  annotatedPeak,
  orgAnn,
  feature_id_type = "ensembl_gene_id",
  maxP = 0.01,
  minGOterm = 10,
  multiAdjMethod = NULL,
  condense = FALSE,
  removeAncestorByPval = NULL,
  keepByLevel = NULL,
  subGroupComparison = NULL
)
}
\arguments{
\item{annotatedPeak}{A GRanges object or a vector of feature IDs}

\item{orgAnn}{Organism annotation package such as org.Hs.eg.db for human and
org.Mm.eg.db for mouse, org.Dm.eg.db for fly, org.Rn.eg.db for rat,
org.Sc.eg.db for yeast and org.Dr.eg.db for zebrafish}

\item{feature_id_type}{The feature type in annotatedPeak such as
ensembl_gene_id, refseq_id, gene_symbol or entrez_id}

\item{maxP}{The maximum p-value to be considered to be significant}

\item{minGOterm}{The minimum count in a genome for a GO term to be included}

\item{multiAdjMethod}{The multiple testing procedures, for details, see
mt.rawp2adjp in multtest package}

\item{condense}{Condense the results or not.}

\item{removeAncestorByPval}{Remove ancestor by p-value. P-value is
calculated by fisher exact test. If gene number in all of the children is
significant greater than it in parent term, the parent term will be removed
from the list.}

\item{keepByLevel}{If the shortest path from the go term to 'all' is greater
than the given level, the term will be removed.}

\item{subGroupComparison}{A logical vector to split the peaks into two 
groups. The enrichment analysis will compare the over-present GO terms
in TRUE group and FALSE group separately. The analysis will split into 
two steps: 1. enrichment analysis for TRUE group by hypergeometric
test; 2. enrichment analysis for TRUE over FALSE group
by Fisher's Exact test for the enriched GO terms.
To keep the output same format, if you want to compare FALSE vs TRUE,
please repeat the analysis by inverting the parameter.
Default is NULL.}
}
\value{
A list with 3 elements \item{list("bp")}{ enriched biological
process with the following 9 variables

go.id:GO biological process id

go.term:GO biological process term

go.Definition:GO biological process description

Ontology: Ontology branch, i.e. BP for biological process

count.InDataset: count of this GO term in this dataset

count.InGenome: count of this GO term in the genome

pvalue: pvalue from the hypergeometric test

totaltermInDataset: count of all GO terms in this dataset

totaltermInGenome: count of all GO terms in the genome

} \item{list("mf")}{enriched molecular function with the following 9
variables

go.id:GO molecular function id

go.term:GO molecular function term

go.Definition:GO molecular function description

Ontology: Ontology branch, i.e. MF for molecular function

count.InDataset: count of this GO term in this dataset

count.InGenome: count of this GO term in the genome

pvalue: pvalue from the hypergeometric test

totaltermInDataset: count of all GO terms in this dataset

totaltermInGenome: count of all GO terms in the genome

} \item{list("cc")}{enriched cellular component the following 9 variables

go.id:GO cellular component id

go.term:GO cellular component term

go.Definition:GO cellular component description

Ontology: Ontology type, i.e. CC for cellular component

count.InDataset: count of this GO term in this dataset

count.InGenome: count of this GO term in the genome

pvalue: pvalue from the hypergeometric test

totaltermInDataset: count of all GO terms in this dataset

totaltermInGenome: count of all GO terms in the genome

}
}
\description{
Obtain enriched gene ontology (GO) terms based on the features near the
enriched peaks using GO.db package and GO gene mapping package such as
org.Hs.db.eg to obtain the GO annotation and using hypergeometric test
(phyper) and multtest package for adjusting p-values
}
\examples{

  data(enrichedGO)
  enrichedGO$mf[1:10,]
  enrichedGO$bp[1:10,]
  enrichedGO$cc
  if (interactive()) {
     data(annotatedPeak)
     library(org.Hs.eg.db)
     library(GO.db)
     enriched.GO = getEnrichedGO(annotatedPeak[1:6,], 
                                 orgAnn="org.Hs.eg.db", 
                                 maxP=0.01,
                                 minGOterm=10,
                                 multiAdjMethod= NULL)
     dim(enriched.GO$mf)
     colnames(enriched.GO$mf)
     dim(enriched.GO$bp)
     enriched.GO$cc
}

}
\references{
Johnson, N. L., Kotz, S., and Kemp, A. W. (1992) Univariate
Discrete Distributions, Second Edition. New York: Wiley
}
\seealso{
phyper, hyperGtest
}
\author{
Lihua Julie Zhu. Jianhong Ou for subGroupComparison
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/findOverlappingPeaks.R
\name{findOverlappingPeaks}
\alias{findOverlappingPeaks}
\alias{findOverlappingPeaks-deprecated}
\title{Find the overlapping peaks for two peak ranges.}
\usage{
findOverlappingPeaks(
  Peaks1,
  Peaks2,
  maxgap = -1L,
  minoverlap = 0L,
  multiple = c(TRUE, FALSE),
  NameOfPeaks1 = "TF1",
  NameOfPeaks2 = "TF2",
  select = c("all", "first", "last", "arbitrary"),
  annotate = 0,
  ignore.strand = TRUE,
  connectedPeaks = c("min", "merge"),
  ...
)
}
\arguments{
\item{Peaks1}{GRanges: See example below.}

\item{Peaks2}{GRanges: See example below.}

\item{maxgap, minoverlap}{Used in the internal call to \code{findOverlaps()}
to detect overlaps. See
\code{?\link[IRanges:findOverlaps-methods]{findOverlaps}} in the
\pkg{IRanges} package for a description of these arguments.}

\item{multiple}{TRUE or FALSE: TRUE may return multiple overlapping peaks in
Peaks2 for one peak in Peaks1; FALSE will return at most one overlapping
peaks in Peaks2 for one peak in Peaks1. This parameter is kept for backward
compatibility, please use select.}

\item{NameOfPeaks1}{Name of the Peaks1, used for generating column name.}

\item{NameOfPeaks2}{Name of the Peaks2, used for generating column name.}

\item{select}{all may return multiple overlapping peaks, first will return
the first overlapping peak, last will return the last overlapping peak and
arbitrary will return one of the overlapping peaks.}

\item{annotate}{Include overlapFeature and shortestDistance in the
OverlappingPeaks or not.  1 means yes and 0 means no. Default to 0.}

\item{ignore.strand}{When set to TRUE, the strand information is ignored in
the overlap calculations.}

\item{connectedPeaks}{If multiple peaks involved in overlapping in several
groups, set it to "merge" will count it as only 1, while set it to "min"
will count it as the minimal involved peaks in any concered groups}

\item{\dots}{Objects of \link[GenomicRanges:GRanges-class]{GRanges}: See
also \code{\link{findOverlapsOfPeaks}}.}
}
\value{
\item{OverlappingPeaks}{a data frame consists of input peaks
information with added information: overlapFeature (upstream: peak1 resides
upstream of the peak2; downstream: peak1 resides downstream of the peak2;
inside: peak1 resides inside the peak2 entirely; overlapStart: peak1
overlaps with the start of the peak2; overlapEnd: peak1 overlaps with the
end of the peak2; includeFeature: peak1 include the peak2 entirely) and
shortestDistance (shortest distance between the overlapping peaks)}
\item{MergedPeaks}{GRanges contains merged overlapping peaks}
}
\description{
Find the overlapping peaks for two input peak ranges.
}
\details{
The new function findOverlapsOfPeaks is recommended.

Efficiently perform overlap queries with an interval tree implemented in
IRanges.
}
\examples{

    if (interactive())
    {    
    peaks1 = 
        GRanges(seqnames=c(6,6,6,6,5), 
                IRanges(start=c(1543200,1557200,1563000,1569800,167889600),
                        end=c(1555199,1560599,1565199,1573799,167893599),
                        names=c("p1","p2","p3","p4","p5")),
                strand=as.integer(1))
    peaks2 = 
        GRanges(seqnames=c(6,6,6,6,5), 
                IRanges(start=c(1549800,1554400,1565000,1569400,167888600),
                        end=c(1550599,1560799,1565399,1571199,167888999),
                        names=c("f1","f2","f3","f4","f5")),
                strand=as.integer(1))
    t1 =findOverlappingPeaks(peaks1, peaks2, maxgap=1000, 
          NameOfPeaks1="TF1", NameOfPeaks2="TF2", select="all", annotate=1) 
    r = t1$OverlappingPeaks
    pie(table(r$overlapFeature))
    as.data.frame(t1$MergedPeaks)
    }

}
\references{
1.Interval tree algorithm from: Cormen, Thomas H.; Leiserson,
Charles E.; Rivest, Ronald L.; Stein, Clifford. Introduction to Algorithms,
second edition, MIT Press and McGraw-Hill. ISBN 0-262-53196-8

2.Zhu L.J. et al. (2010) ChIPpeakAnno: a Bioconductor package to annotate
ChIP-seq and ChIP-chip data. BMC Bioinformatics 2010, 11:237
doi:10.1186/1471-2105-11-237

3. Zhu L (2013). Integrative analysis of ChIP-chip and ChIP-seq dataset.  In
Lee T and Luk ACS (eds.), Tilling Arrays, volume 1067, chapter 4, pp. -19.
Humana Press. http://dx.doi.org/10.1007/978-1-62703-607-8_8
}
\seealso{
findOverlapsOfPeaks, annotatePeakInBatch, makeVennDiagram
}
\author{
Lihua Julie Zhu
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annoGR.R
\docType{class}
\name{annoGR-class}
\alias{annoGR-class}
\alias{annoGR}
\alias{coerce}
\alias{coerce,GRanges,annoGR-method}
\alias{coerce,annoGR,GRanges-method}
\alias{info,annoGR-method}
\alias{info}
\alias{annoGR,GRanges-method}
\alias{annoGR,TxDb-method}
\alias{annoGR,EnsDb-method}
\title{Class \code{annoGR}}
\usage{
\S4method{info}{annoGR}(object)

\S4method{annoGR}{GRanges}(ranges, feature = "group", date, ...)

\S4method{annoGR}{TxDb}(
  ranges,
  feature = c("gene", "transcript", "exon", "CDS", "fiveUTR", "threeUTR", "tRNAs",
    "geneModel"),
  date,
  source,
  mdata,
  OrganismDb
)

\S4method{annoGR}{EnsDb}(
  ranges,
  feature = c("gene", "transcript", "exon", "disjointExons"),
  date,
  source,
  mdata
)
}
\arguments{
\item{object}{annoGR object.}

\item{ranges}{an object of \link[GenomicRanges:GRanges-class]{GRanges},
\link[GenomicFeatures:TxDb-class]{TxDb} or \link[ensembldb]{EnsDb}}

\item{feature}{annotation type}

\item{date}{a \link{Date} object}

\item{...}{could be following parameters}

\item{source}{character, where the annotation comes from}

\item{mdata}{data frame, metadata from annotation}

\item{OrganismDb}{an object of OrganismDb. It is used for extracting gene
symbol for geneModel group for \link[GenomicFeatures:TxDb-class]{TxDb}}
}
\description{
An object of class \code{annoGR} represents the annotation data could be
used by annotationPeakInBatch.
}
\section{Slots}{

\describe{
\item{\code{seqnames,ranges,strand,elementMetadata,seqinfo}}{slots inherit from 
\link[GenomicRanges:GRanges-class]{GRanges}. 
The ranges must have unique names.}

\item{\code{source}}{character, where the annotation comes from}

\item{\code{date}}{a \link{Date} object}

\item{\code{feature}}{annotation type, could be "gene", "exon", "transcript", "CDS",
"fiveUTR", "threeUTR", "microRNA", "tRNAs", "geneModel" for 
\link[GenomicFeatures:TxDb-class]{TxDb} object, or "gene", "exon",
"transcript" for \link[ensembldb]{EnsDb} object}

\item{\code{mdata}}{data frame, metadata from annotation}
}}

\section{Objects from the Class}{
 Objects can be created by calls of the form
\code{new("annoGR", date, elementMetadata, feature, mdata, ranges, seqinfo,
seqnames, source, strand)}
}

\examples{

    if(interactive() || Sys.getenv("USER")=="jou"){
        library(EnsDb.Hsapiens.v79)
        anno <- annoGR(EnsDb.Hsapiens.v79)
    }

}
\author{
Jianhong Ou
}
\keyword{classes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/countPatternInSeqs.R
\name{countPatternInSeqs}
\alias{countPatternInSeqs}
\title{Output total number of patterns found in the input sequences}
\usage{
countPatternInSeqs(pattern, sequences)
}
\arguments{
\item{pattern}{DNAstringSet object}

\item{sequences}{a vector of sequences}
}
\value{
Total number of occurrence of the pattern in the sequences
}
\description{
Output total number of patterns found in the input sequences
}
\examples{
  library(Biostrings)
  filepath = 
    system.file("extdata", "examplePattern.fa", package="ChIPpeakAnno")
  dict = readDNAStringSet(filepath = filepath, format="fasta", 
                          use.names=TRUE)
  sequences = c("ACTGGGGGGGGCCTGGGCCCCCAAAT", 
                "AAAAAACCCCTTTTGGCCATCCCGGGACGGGCCCAT", 
                "ATCGAAAATTTCC")
  countPatternInSeqs(pattern=dict[1], sequences=sequences)
  countPatternInSeqs(pattern=dict[2], sequences=sequences)
  pattern = DNAStringSet("ATNGMAA")
  countPatternInSeqs(pattern=pattern, sequences=sequences)

}
\seealso{
summarizePatternInPeaks, translatePattern
}
\author{
Lihua Julie Zhu
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reCenterPeaks.R
\name{reCenterPeaks}
\alias{reCenterPeaks}
\title{re-center the peaks}
\usage{
reCenterPeaks(peaks, width = 2000L, ...)
}
\arguments{
\item{peaks}{An object of \link[GenomicRanges:GRanges-class]{GRanges} or
\link{annoGR}.}

\item{width}{The width of new peaks}

\item{...}{Not used.}
}
\value{
An object of GRanges.
}
\description{
Create a new list of peaks based on the peak centers of given list.
}
\examples{

    reCenterPeaks(GRanges("chr1", IRanges(1, 10)), width=2)

}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annotatedPeak.R
\docType{data}
\name{annotatedPeak}
\alias{annotatedPeak}
\title{Annotated Peaks}
\format{
GRanges with slot start holding the start position of the peak, slot
end holding the end position of the peak, slot names holding the id of the
peak, slot strand holding the strands and slot space holding the chromosome
location where the peak is located. In addition, the following variables are
included.  \describe{ \item{list("feature")}{id of the feature such as
ensembl gene ID} \item{list("insideFeature")}{upstream: peak resides
upstream of the feature; downstream: peak resides downstream of the feature;
inside: peak resides inside the feature; overlapStart: peak overlaps with
the start of the feature; overlapEnd: peak overlaps with the end of the
feature; includeFeature: peak include the feature entirely}
\item{list("distancetoFeature")}{distance to the nearest feature such as
transcription start site} \item{list("start_position")}{start position of
the feature such as gene} \item{list("end_position")}{end position of the
feature such as the gene} }
}
\usage{
annotatedPeak
}
\description{
TSS annotated putative STAT1-binding regions that are identified in
un-stimulated cells using ChIP-seq technology (Robertson et al., 2007)
}
\details{
obtained by data(TSS.human.GRCh37)

data(myPeakList)

annotatePeakInBatch(myPeakList, AnnotationData = TSS.human.GRCh37,
output="b", multiple=F)
}
\examples{

data(annotatedPeak)
head(annotatedPeak, 4)  # show first 4 ranges
if (interactive() || Sys.getenv("USER")=="jou") {
y = annotatedPeak$distancetoFeature[!is.na(annotatedPeak$distancetoFeature)]
hist(as.numeric(as.character(y)), 
     xlab="Distance To Nearest TSS", main="", breaks=1000, 
ylim=c(0, 50), xlim=c(min(as.numeric(as.character(y)))-100, 
max(as.numeric(as.character(y)))+100))
}

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/oligoSummary.R
\name{oligoSummary}
\alias{oligoSummary}
\title{Output a summary of consensus in the peaks}
\usage{
oligoSummary(
  sequence,
  oligoLength = 6L,
  freqs = NULL,
  MarkovOrder = 3L,
  quickMotif = FALSE,
  revcomp = FALSE,
  maxsize = 1e+05
)
}
\arguments{
\item{sequence}{The sequences packaged in DNAStringSet, DNAString object or
output of function \link{getAllPeakSequence}.}

\item{oligoLength}{The length of oligonucleotide.}

\item{freqs}{Output of function \link{frequency}.}

\item{MarkovOrder}{The order of Markov chain.}

\item{quickMotif}{Generate the motif by z-score of not.}

\item{revcomp}{Consider both the given strand and the reverse complement
strand when searching for motifs in a complementable alphabet (ie DNA).
Default, FALSE.}

\item{maxsize}{Maximum allowed dataset size (in length of sequences).}
}
\value{
A list is returned. \item{zscore}{A numeric vector. The z-scores of
each oligonucleotide.} \item{counts}{A numeric vector. The counts number of
each oligonucleotide.} \item{motifs}{a list of motif matrix.}
}
\description{
Calculate the z-scores of all combinations of oligonucleotide in a given
length by Markove chain.
}
\examples{

    if(interactive() || Sys.getenv("USER")=="jou"){
        data(annotatedPeak)
        library(BSgenome.Hsapiens.UCSC.hg19)
        library(seqinr)
        seq <- getAllPeakSequence(annotatedPeak[1:100], 
                     upstream=20, 
                     downstream=20, 
                     genome=Hsapiens)
        oligoSummary(seq)
    }

}
\references{
van Helden, Jacques, Marcel li del Olmo, and Jose E.
Perez-Ortin. "Statistical analysis of yeast genomic downstream sequences
reveals putative polyadenylation signals." Nucleic Acids Research 28.4
(2000): 1000-1010.
}
\seealso{
See Also as \code{\link{frequency}}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summarizeOverlapsByBins.R
\name{summarizeOverlapsByBins}
\alias{summarizeOverlapsByBins}
\title{Perform overlap queries between reads and genomic features by bins}
\usage{
summarizeOverlapsByBins(
  targetRegions,
  reads,
  windowSize = 50,
  step = 10,
  signalSummaryFUN = max,
  mode = countByOverlaps,
  ...
)
}
\arguments{
\item{targetRegions}{A \link[GenomicRanges:GRanges-class]{GRanges} object of
genomic regions of interest.}

\item{reads}{A \link[GenomicRanges:GRanges-class]{GRanges},
\link[GenomicRanges:GRangesList-class]{GRangesList}
\link[GenomicAlignments:GAlignments-class]{GAlignments},
\link[GenomicAlignments:GAlignmentsList-class]{GAlignmentsList},
\link[GenomicAlignments:GAlignmentPairs-class]{GAlignmentPairs} or
\link[Rsamtools:BamFile-class]{BamFileList} object that represents the data
to be counted by
\code{\link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps}}.}

\item{windowSize}{Size of windows}

\item{step}{Step of windows}

\item{signalSummaryFUN}{function, which will be applied to the bins in each
feature.}

\item{mode}{mode can be one of the pre-defined count methods. see
\link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps}.
default is countByOverlaps, alia of countOverlaps(features, reads,
ignore.strand=ignore.strand)}

\item{...}{Additional arguments passed to
\code{\link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps}}.}
}
\value{
A
\link[SummarizedExperiment:RangedSummarizedExperiment-class]{RangedSummarizedExperiment}
object. The assays slot holds the counts, rowRanges holds the annotation
from features.
}
\description{
summarizeOverlapsByBins extends
\link[GenomicAlignments:summarizeOverlaps-methods]{summarizeOverlaps} by
providing fixed window size and step to split each feature into bins and
then do queries. It will return counts by signalSummaryFUN, which applied to
bins in one feature, for each feature.
}
\examples{

    fls <- list.files(system.file("extdata", package="GenomicAlignments"),
                  recursive=TRUE, pattern="*bam$", full=TRUE)
    names(fls) <- basename(fls)
    genes <- GRanges(
        seqnames = c(rep("chr2L", 4), rep("chr2R", 5), rep("chr3L", 2)),
        ranges = IRanges(c(1000, 3000, 4000, 7000, 2000, 3000, 3600, 
                           4000, 7500, 5000, 5400), 
                         width=c(rep(500, 3), 600, 900, 500, 300, 900, 
                                 300, 500, 500),
                         names=letters[1:11])) 
    se <- summarizeOverlapsByBins(genes, fls, windowSize=50, step=10)

}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/featureAlignedHeatmap.R
\name{featureAlignedHeatmap}
\alias{featureAlignedHeatmap}
\title{Heatmap representing signals in given ranges}
\usage{
featureAlignedHeatmap(
  cvglists,
  feature.gr,
  upstream,
  downstream,
  zeroAt,
  n.tile = 100,
  annoMcols = c(),
  sortBy = names(cvglists)[1],
  color = colorRampPalette(c("yellow", "red"))(50),
  lower.extreme,
  upper.extreme,
  margin = c(0.1, 0.01, 0.15, 0.1),
  gap = 0.01,
  newpage = TRUE,
  gp = gpar(fontsize = 10),
  ...
)
}
\arguments{
\item{cvglists}{Output of \link{featureAlignedSignal} or a list of
\link[IRanges:AtomicList-class]{SimpleRleList} or
\link[IRanges:AtomicList-class]{RleList}}

\item{feature.gr}{An object of \link[GenomicRanges:GRanges-class]{GRanges}
with identical width.  If the width equal to 1, you can use upstream and
downstream to set the range for plot.  If the width not equal to 1, you can
use zeroAt to set the zero point of the heatmap.}

\item{upstream, downstream}{upstream or dwonstream from the feature.gr.  It
must keep same as \link{featureAlignedSignal}. It is used for x-axis label.}

\item{zeroAt}{zero point position of feature.gr}

\item{n.tile}{The number of tiles to generate for each element of
feature.gr, default is 100}

\item{annoMcols}{The columns of metadata of feature.gr that specifies the
annotations shown of the right side of the heatmap.}

\item{sortBy}{Sort the feature.gr by columns by annoMcols and then the
signals of the given samples. Default is the first sample. Set to NULL to
disable sort.}

\item{color}{vector of colors used in heatmap}

\item{lower.extreme, upper.extreme}{The lower and upper boundary value of
each samples}

\item{margin}{Margin for of the plot region.}

\item{gap}{Gap between each heatmap columns.}

\item{newpage}{Call grid.newpage or not. Default, TRUE}

\item{gp}{A gpar object can be used for text.}

\item{...}{Not used.}
}
\value{
invisible gList object.
}
\description{
plot heatmap in the given feature ranges
}
\examples{

  cvglists <- list(A=RleList(chr1=Rle(sample.int(5000, 100), 
                                      sample.int(300, 100))), 
                   B=RleList(chr1=Rle(sample.int(5000, 100), 
                                      sample.int(300, 100))))
  feature.gr <- GRanges("chr1", IRanges(seq(1, 4900, 100), width=100))
  feature.gr$anno <- rep(c("type1", "type2"), c(25, 24))
  featureAlignedHeatmap(cvglists, feature.gr, zeroAt=50, annoMcols="anno")

}
\seealso{
See Also as \link{featureAlignedSignal},
\link{featureAlignedDistribution}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/egOrgMap.R
\name{egOrgMap}
\alias{egOrgMap}
\title{Convert between the name of the organism annotation package ("OrgDb") and
the name of the organism.}
\usage{
egOrgMap(name)
}
\arguments{
\item{name}{The name of the organism annotation package or the species.}
}
\value{
A object of character
}
\description{
Give a species name and return the organism annotation package name or give
an organism annotation package name then return the species name.
}
\examples{

  egOrgMap("org.Hs.eg.db")
  egOrgMap("Mus musculus")

}
\author{
Jianhong Ou
}
\keyword{misc}
